# ----------------------------------------------------------
# CMAKE file.
# It generates the signal[.bat] command. 
# This command is the access to the Signal batch compiler.
# ----------------------------------------------------------

MK_CONFIG_NAME(${pK_Examples}/mk_test_demos FILENAME_CMD)
GEN_HEADER_SCRIPT(${FILENAME_CMD})

GEN_REQUIRE_SHELL_VAR_LOADENV(${FILENAME_CMD} pK_ROOT)
GEN_REQUIRE_SHELL_VAR_LOADENV(${FILENAME_CMD} pK_bin)
GEN_REQUIRE_SHELL_VAR(${FILENAME_CMD} pK_Examples)
ADD_EXECUTE_RIGHT(${FILENAME_CMD})

IF(UNIX)
  FILE(APPEND ${FILENAME_CMD} "cd $pK_Examples/TEST_DEMOS\n")
  FILE(APPEND ${FILENAME_CMD} "rm -f -R CMakeFiles CMakeCache.txt\n")
  # this line must be deleted (add an option to the compiler to provide a path of libraries (similar to -L for c compiler))
  FILE(APPEND ${FILENAME_CMD} "setenv SIGNAL_LIBRARY_PATH  \${SIGNAL_LIBRARY_PATH}:\${SignalLib_Graphical}:\${ex_watch}/lib\n")
  FILE(APPEND ${FILENAME_CMD} "cmake .\n")
  FILE(APPEND ${FILENAME_CMD} "make -i | tee testDemo.lis \n")
  FILE(APPEND ${FILENAME_CMD} "echo \" >->->->  searching fo errors \"\n")
  FILE(APPEND ${FILENAME_CMD} "grep FAILED testDemo.lis\n")
  FILE(APPEND ${FILENAME_CMD} "grep Error testDemo.lis\n")
  FILE(APPEND ${FILENAME_CMD} "grep error testDemo.lis\n")
  FILE(APPEND ${FILENAME_CMD} "\n")
  FILE(APPEND ${FILENAME_CMD} "\n")
  FILE(APPEND ${FILENAME_CMD} "echo \"To test, run ctest in $pK_Examples/TEST_DEMOS\"\n")
  FILE(APPEND ${FILENAME_CMD} "\n")
  FILE(APPEND ${FILENAME_CMD} "cd $pK_Examples\n")
ELSE(UNIX)
  
ENDIF(UNIX)



MK_CONFIG_NAME(${pK_Examples}/mk_test_systematic_options FILENAME_CMD)
GEN_HEADER_SCRIPT(${FILENAME_CMD})

GEN_REQUIRE_SHELL_VAR_LOADENV(${FILENAME_CMD} pK_ROOT)
GEN_REQUIRE_SHELL_VAR_LOADENV(${FILENAME_CMD} pK_bin)
GEN_REQUIRE_SHELL_VAR(${FILENAME_CMD} pK_Examples)
ADD_EXECUTE_RIGHT(${FILENAME_CMD})

IF(UNIX)
  FILE(APPEND ${FILENAME_CMD} "cd $pK_Examples/TEST_SYSTEMATIC_OPTIONS\n")
  FILE(APPEND ${FILENAME_CMD} "rm -f -R CMakeFiles CMakeCache.txt\n")
  # this line must be deleted (add an option to the compiler to provide a path of libraries (similar to -L for c compiler))
  FILE(APPEND ${FILENAME_CMD} "setenv SIGNAL_LIBRARY_PATH  \${SIGNAL_LIBRARY_PATH}:\${SignalLib_Graphical}:\${ex_watch}/lib\n")
  FILE(APPEND ${FILENAME_CMD} "cmake .\n")
  FILE(APPEND ${FILENAME_CMD} "setenv name TEST_SYSTEMATIC_OPTIONS\n")
  # FILE(APPEND ${FILENAME_CMD} "ctest -Q -O \${name}.log --timeout 10 \$*\n")
  FILE(APPEND ${FILENAME_CMD} "ctest -Q  --timeout 10 \$* | tee \${name}.log \n")
  FILE(APPEND ${FILENAME_CMD} "echo \" >->->->  searching fo errors \"\n")
  FILE(APPEND ${FILENAME_CMD} "rm -f Failure_\${name}.log\n")
  FILE(APPEND ${FILENAME_CMD} "grep \"Timeout)\" \${name}.log > Failure_\${name}.log\n")
  FILE(APPEND ${FILENAME_CMD} "grep \"Failed)\"  \${name}.log >> Failure_\${name}.log\n")
  FILE(APPEND ${FILENAME_CMD} "echo \"diff Failure_\${name}.log ReferenceTest/.\"\n")
  FILE(APPEND ${FILENAME_CMD} "diff Failure_\${name}.log ReferenceTest/.\n")
  FILE(APPEND ${FILENAME_CMD} "\n")
  FILE(APPEND ${FILENAME_CMD} "cd $pK_Examples\n")
ELSE(UNIX)
  
ENDIF(UNIX)

