module P_statechart =

type P_states = enum (Q, R, S);
type Q1_states = enum (U, V);
type Q2_states = enum (X, Y, Z);

process P_chart =
   ( ? event Tick;
       event a, b, i, j, m, n;
     ! P_states P_currentState;
       Q1_states Q1_currentState;
       Q2_states Q2_currentState;
   )
   (| (| case P_currentState in
           {#Q}: (| P_nextState ::= (#R when a) default (#S when b) |)
           {#R}: (| P_nextState ::= #S when b |)
           {#S}: (| P_nextState ::= #Q when a |)
         end
       | P_nextState ::= defaultvalue P_currentState
       | P_currentState := P_nextState $ init #Q
       | P_currentState ^= Tick
       |)
    | clk_Q_chart := when (P_currentState = #Q)
    | start_Q_chart := when (P_nextState = #Q) when (P_currentState /= #Q)
    | Q1_State ^= Q2_State ^= clk_Q_chart ^+ start_Q_chart
    | (| case Q1_State in
           {#U}: (| Q1_newState ::= #V when i |)
           {#V}: (| Q1_newState ::= #U when j |)
         end
       | Q1_newState ::= defaultvalue Q1_State
       | Q1_newState ^= Q1_State
       | Q1_nextState := (#U when start_Q_chart) default Q1_newState
       | Q1_State := Q1_nextState $ init #U
       | Q1_currentState := Q1_State when clk_Q_chart
       |)
    | (| case Q2_State in
           {#X}: (| Q2_newState ::= #Y when m |)
           {#Y}: (| Q2_newState ::= #Z when n |)
           {#Z}: (| Q2_newState ::= #X when j |)
         end
       | Q2_newState ::= defaultvalue Q2_State
       | Q2_newState ^= Q2_State
       | Q2_nextState := (#X when start_Q_chart) default Q2_newState
       | Q2_State := Q2_nextState $ init #X
       | Q2_currentState := Q2_State when clk_Q_chart
       |)
    |)
   where
     P_states P_nextState;
     event clk_Q_chart, start_Q_chart;
     Q1_states Q1_State, Q1_newState, Q1_nextState;
     Q2_states Q2_State, Q2_newState, Q2_nextState;
   end;
end;


