#!/usr/bin/tcsh


setenv GTKWAVE "N"
setenv AppliName equationSolving

setenv HERE $PWD
setenv DataDir ${HERE}/${AppliName}/data
set prefix=${HERE}/equationSolving/equationSolving

mkdir -p ${prefix}_1
mkdir -p ${prefix}_2

\cp ${DataDir}/R*.dat ${prefix}_1/.
\cp ${DataDir}/R*.dat ${prefix}_2/.
\rm ${prefix}_1/W*.dat ${prefix}_2/W*.dat

$pK_bin/signal ${AppliName}.SIG "-dist -TRA -c"
$pK_Examples/run_appli_mpi.sh ${AppliName}

cd $HERE

if (! -efr "${prefix}_1/Woc.dat") then
   echo " >>>>>>>>ERROR: The file ${prefix}_1/Woc.dat not generated"
    goto endlab
endif

if (! -efr "${prefix}_1/Wx1.dat") then
   echo " >>>>>>>>ERROR: The file ${prefix}_1/Wx1.dat not generated."
    goto endlab
endif

if (! -efr "${prefix}_1/Wx2.dat") then
   echo " >>>>>>>>ERROR: The file ${prefix}_1/Wx2.dat not generated."
    goto endlab
endif


if ( "$GTKWAVE" == "Y" ) then
echo " (gtkwave) Continue[Y/N]?"
setenv X $<
if ( "$X" == "N" ) then
     exit
endif

gtkwave ${prefix}_1/W_DUMPFILE_VCD_.dat
endif

endlab:
    cd $HERE

