
#include "powders_nb.h"

static Widget simulator_title_widget, time_label_widget, canvas_widget, drink_button_widget;

/*=========================================================*/
/*        BITMAP of Icons                                  */
/*=========================================================*/

#include "glass.xbm"
#include "left_arm.xbm"
#include "right_arm.xbm"
#include "powder1.xbm"
#include "powder2.xbm"
#include "water1.xbm"
#include "water2.xbm"

/*=========================================================*/
/*        VARIABLES for drawing                            */
/*=========================================================*/

typedef struct
{
  int w;
  int h;
  Pixmap pm;
} icon;

static Display *canvas_display;
static Window canvas_window;
static int screen_nb;
static GC canvas_gc, canvas_gc_eff;
static icon glass_icon, left_arm_icon, right_arm_icon, powder1_icon, powder2_icon, water1_icon, water2_icon;

/* Link an integer to an icon */
icon
choose_icon (n)
     int n;
{
  switch (n)
    {
    case 1:
      return glass_icon;
    case 2:
      return left_arm_icon;
    case 3:
      return right_arm_icon;
    case 4:
      return powder1_icon;
    case 5:
      return powder2_icon;
    case 6:
      return water1_icon;
    case 7:
      return water2_icon;
    default:
      break;
    };
}

void
DISPLAY_ICON (int n, int x, int y, double seq)
{
  icon i;

  i = choose_icon (n);
  XCopyPlane (canvas_display, i.pm, canvas_window, canvas_gc, 0, 0, i.w, i.h, x, y, 1);
}

double
UNDISPLAY_ICON (int n, int x, int y)
{
  icon i;

  i = choose_icon (n);
  XCopyPlane (canvas_display, i.pm, canvas_window, canvas_gc_eff, 0, 0, i.w, i.h, x, y, 1);
  return 0.0;
}

void
DISPLAY_STRING (int n, int x, int y)
{
  char *text;

  text = SIMUL_STRINGS[n];
  XDrawString (canvas_display, canvas_window, canvas_gc, x, y, text, strlen (text));
}

void
UNDISPLAY_STRING (int n, int x, int y)
{
  char *text;
  text = SIMUL_STRINGS[n];
  XDrawString (canvas_display, canvas_window, canvas_gc_eff, x, y, text, strlen (text));
}

void
CLEAR_SCREEN (boolean h)
{
  XClearWindow (canvas_display, canvas_window);
}


/*=========================================================*/
/*       Saving WIDGETS                                    */
/*=========================================================*/

void
create_simulator_title (Widget widget)
{
  simulator_title_widget = widget;
}

void
create_drink (Widget widget)
{
  drink_button_widget = widget;
}

void
create_canvas (Widget widget)
{
  canvas_widget = widget;
}

void
create_time_label (Widget widget)
{
  time_label_widget = widget;
}

/*=========================================================*/
/*        READING INPUTS                                   */
/*=========================================================*/

boolean vdrink;

void
init_drink ()
{
  vdrink = FALSE;
}

int
SCAN_DRINK ()
{
  boolean drink;
  drink = vdrink;
  init_drink ();
  return drink;
}

void
push_drink ()
{
  vdrink = TRUE;
}

void
INIT_SIMULATOR_INPUTS (boolean h)
{
  init_drink ();
}

/*=========================================================*/
/*        PRINTING                                         */
/*=========================================================*/

void
PRINT_USUAL_TIME (int s, int m, int h)
{
  /*
     char str[128];
     sprintf(str,"%.2d:%.2d:%.2d",h,m,s);
     putlabel(time_label_widget,str);
   */
}

void
SIMULATOR_INIT_LABELS ()
{
  // putlabel(drink_button_widget,DRINK_STRING);
  // putlabel(simulator_title_widget,SIMULATOR_TITLE);
}

/*=========================================================*/
/*        Graphical initialisation                         */
/*=========================================================*/

static icon
creer_icon (char *bits, int width, int height)
{
  icon i;
  i.pm = XCreateBitmapFromData (canvas_display, canvas_window, bits, width, height);
  i.w = width;
  i.h = height;
  return i;
}

extern void
creer_contexte_graphique ()
{
  XGCValues values;

  canvas_display = XtDisplay (canvas_widget);
  canvas_window = XtWindow (canvas_widget);
  screen_nb = XDefaultScreen (canvas_display);
  XtVaGetValues (canvas_widget, XmNforeground, &values.foreground, XmNbackground, &values.background, NULL);
  canvas_gc = XtGetGC (canvas_widget, GCForeground | GCBackground, &values);
  values.function = GXxor;
  values.foreground = values.foreground ^ values.background;
  values.background = 0;
  canvas_gc_eff = XtGetGC (canvas_widget, GCForeground | GCBackground | GCFunction, &values);
  glass_icon = creer_icon (glass_bits, glass_width, glass_height);
  left_arm_icon = creer_icon (left_arm_bits, left_arm_width, left_arm_height);
  right_arm_icon = creer_icon (right_arm_bits, right_arm_width, right_arm_height);
  powder1_icon = creer_icon (powder1_bits, powder1_width, powder1_height);
  powder2_icon = creer_icon (powder2_bits, powder2_width, powder2_height);
  water1_icon = creer_icon (water1_bits, water1_width, water1_height);
  water2_icon = creer_icon (water2_bits, water2_width, water2_height);
}
