module regulateur =
   process Regulator_chart =
        ( ? event Tick; 
            event time; 
            event evt_consigne;
        )
      (| case RegulatorCurrentState in
         {#regulating}: (| valeurConsigne := getConsigne(evt_consigne)
                         | fixerConsigne(evt_consigne, valeurConsigne)
                         | (counter, call_regule) := topmod{1}()
                         | counter ^= time
                         | reguler(call_regule)
                         |)
         end 
       | RegulatorCurrentState ^= Tick
       | RegulatorCurrentState := #regulating
       |)
      where 
      type RegulatorState = enum (regulating); 
      RegulatorState RegulatorCurrentState init (RegulatorState#regulating); 
      event call_regule; 
      dreal valeurConsigne; 
      integer counter;
      end
   ; 
   process fixerConsigne =
        ( ? event evt_consigne; 
            dreal valeurConsigne;
        )
        spec (| evt_consigne ^= valeurConsigne |)
      (| consigneNiveau ::= valeurConsigne |)
   ; 
   process reguler =
        ( ? event clk_reguler;
        )
      (| valeurDebit := donnerDebit(clk_reguler)
       | valeurNiveau := donnerNiveau(clk_reguler)
       | QEA := calculerCommande{6.0, 150.0, 29.6, 17.0, 10.0}(clk_reguler, valeurDebit, valeurNiveau)
       | fixerDebitEau(clk_reguler, QEA)
       |)
      where 
      dreal valeurDebit, valeurNiveau; 
      dreal QEA;
      end
   ; 
   use general;
end %regulateur%; 
