process coSimClu =
     ( ? real a;
         real b;
         real c;
       ! real x1;
         real x2;
         boolean error;
         integer lat;
         integer MaxLat;
         )
 pragmas 
    main
    Defined_clock_hierarchy 
  end pragmas
   (| (| DateGenerator{}
       | (| d_deb := d_c
          | Latency{}
          |) where HomoType d_deb; end
       | MaxLatency{}
       | P_COSTP{}
       |)/ d_error, d_x1, d_x2, stable, dEnd, d_c, d_b, d_a |)
   where 
   use Cost_Context, STD, COSTBIB, M_P_COST; 
   process DateGenerator =
        ( ? dEnd;
          ! d_a;
            HomoType d_b;
            HomoType d_c;
        )
      (| d := ((dEnd$ init NilHomoTypeValue) when (^d_a))+(d$ init NilHomoTypeValue)
       | d_a := d
       | d_b := d
       | d_c := d
       |)
      where 
      HomoType d;
      end
   ; 
   process MaxLatency =
        ( ? HomoType lat;
          ! HomoType MaxLat;
        )
      (| MaxLat := (lat when (lat>ZMaxLat)) default ZMaxLat
       | ZMaxLat := MaxLat$1 init NilHomoTypeValue
       | ZMaxLat ^= lat
       |)
      where 
      HomoType ZMaxLat;
      end
   ; 
   process Latency =
        ( ? d_deb;
            boolean stable;
            HomoType d_x1;
            HomoType d_x2;
            HomoType d_error;
          ! HomoType dEnd;
            HomoType lat;
        )
      (| d_end := MAX(MAX(d_x1,d_x2),d_error)
       | dEnd := d_end cell (^stable)
       | l := dEnd-(d_deb cell (^stable))
       | lat := l when (^d_end)
       |)
      where 
      HomoType l, d_end;
      process MAX =
           ( ? HomoType IN1;
               HomoType IN2;
             ! HomoType MAX_VAL;
           )
         (| HCOMMON := (when (^IN1)) when (^IN2)
          | c1 := IN1 when HCOMMON
          | c2 := IN2 when HCOMMON
          | MAX_VAL := (IN1 when (c1>c2)) default IN2 default IN1
          |)
         where 
         event HCOMMON;
         HomoType c1, c2;
         end
      ; 
      end
   ; 
   process P_COSTP =
        ( ? real a;
            real b;
            real c;
            HomoType d_a;
            HomoType d_b;
            HomoType d_c;
          ! real x2;
            real x1;
            boolean error;
            boolean stable init true;
            HomoType d_x2;
            HomoType d_x1;
            HomoType d_error;
        )
      (| (| P{}
          | P_COST{}
          |)/ C_error, C_cc_384, C_373, C_, C_d, C_331, OK, C_328, err2, next_stable |)
      where 
        boolean err2, next_stable, OK, C_d, C_, C_328, C_331, C_373, C_cc_384, C_error;
        process P =
     ( ? real a, b, c;
       ! real x2, x1;
         boolean error, OK, stable init true, next_stable, err2, C_328, C_331, C_d, C_, C_373, C_cc_384, C_error;
     )
   pragmas 
      main
   end pragmas
   (| (| Tick := true
       | when Tick ^= stable ^= yy ^= mx ^= next_stable ^= s ^= XZX_147 ^= C_328 ^= C_331 ^= C_d_357 ^= C__368
       | when Tick ^= next_yy ^= biterate ^= pre_next_yy ^= C ^= C_y ^= OK_344 ^= C_cc_390 ^= C__416 ^= C_x ^= C_x1 ^= C_444 ^= C_448 ^= C_451
       |)
    | (| when stable ^= C_err
       | when stable ^= a ^= b ^= c ^= OK ^= C_cc ^= C_376 ^= C_error_398
       |)
    | (| when OK ^= bb ^= cc ^= dd ^= aa ^= XZX_80 ^= XZX_84 ^= C_d ^= C_ ^= C_373 |)
    | (| when C_d ^= d |)
    | (| when C_ ^= x_1 ^= XZX_91 |)
    | (| when C_cc ^= bb_1 ^= cc_2 ^= C_cc_384 ^= C_error |)
    | (| when C_cc_384 ^= x ^= bb_212 ^= cc_213 |)
    | (| when C_error ^= err2 |)
    | (| when C_err ^= error ^= err_235 |)
    | (| nlabel_456 :: equationSolving_Cluster_4{}
       | nlabel_456 ^= when stable
       |)
    | (| when C_y ^= x2 ^= y ^= bb_110 ^= x_168 ^= x_177 |)
    | (| when C__416 ^= XZX_164 |)
    | (| when C_x ^= x21 |)
    | (| when C_x1 ^= x1 |)
    | (| nlabel :: equationSolving_Cluster_1{}
       | nlabel ^= when Tick
       |)
    | (| nlabel_454 :: equationSolving_Cluster_2{}
       | nlabel_454 ^= when Tick
       |)
    | (| nlabel_455 :: equationSolving_Cluster_3{}
       | nlabel_455 ^= when Tick
       |)
    | (| nlabel_470 :: equationSolving_Cluster_delays{}
       | nlabel_470 ^= when Tick
       |)
    | (| c --> nlabel_456
       | b --> nlabel_455
       | a --> nlabel_454
       | nlabel_456 --> nlabel
       | nlabel_455 --> nlabel
       | nlabel_454 --> nlabel
       | nlabel_454 --> nlabel_455
       | nlabel_454 --> nlabel_456
       |)
    |)
   where 
   constant real cst_epsilon = 0.00001;
   label nlabel, nlabel_454, nlabel_455, nlabel_470; 
   label nlabel_456; 
   process equationSolving_Cluster_4 =
        ( ? real c;
            boolean OK, stable;
            real aa;
            boolean C_cc;
        )
      pragmas 
         Cluster
      end pragmas
      (| (| (| cc := XZX_84/aa
             | XZX_84 := c when OK
             | cc_2 := c when C_cc
             |) |) |)
   %equationSolving_Cluster_4%; 
   process equationSolving_Cluster_1 =
        ( ? boolean OK;
            real bb, cc;
            boolean stable;
            real pre_next_yy, bb_212, cc_2;
            boolean OK_344, C_cc, C_cc_384, C_cc_390, C_error, C_error_398;
          ! real x2, x1;
            boolean error;
        )
      pragmas 
         Cluster
      end pragmas
      (| (| (| error := err_235
             | biterate := (true when C_d) default ((not stable) when C_451)
             | next_stable := s<cst_epsilon
             | err2 := (cc_2/=0.0) when C_error
             | err_235 := (true when C_373) default (err2 when C_error)
             | C := not biterate
             | C_328 := XZX_147>=0.0
             | C_331 := not (XZX_147>=0.0)
             | C_y := next_stable and biterate
             | C_d := dd>0.0
             | C_d_357 := left_tt ( C_d,stable )
             | C_ := dd=0.0
             | C__368 := left_tt ( C_,stable )
             | C_373 := dd<0.0
             | C_376 := left_tt ( C_373,OK )
             | C__416 := C_y or OK_344
             | C_x := C_y or C__368
             | C_err := C_376 or C_error_398
             | C_x1 := C_x or C_cc_390
             | C_444 := (not C_y) and C__368
             | C_448 := (not C_x) and C_cc_390
             | C_451 := not C_d_357
             |)
          | (| x2 := x_168
             | x1 := (x21 when C_x) default (x when C_448)
             | x := -(cc_213/bb_212)
             | d := dd when C_d
             | dd := (bb*bb)-(4.0*cc)
             | x_1 := (-XZX_91)/2.0
             | XZX_91 := bb when C_
             | y := yy when C_y
             | bb_110 := XZX_164 when C_y
             | yy := ((d/2.0) when C_d) default (pre_next_yy when C_451)
             | next_yy := (((yy+(mx/yy))/2.0) when biterate) default (yy when C)
             | mx := (d when C_d) cell Tick init 0.0e0
             | s := (XZX_147 when C_328) default ((-XZX_147) when C_331)
             | XZX_147 := next_yy-yy
             | XZX_164 := (bb when OK) cell C__416 init 0.0e0
             | x_168 := -((bb_110-y)/2.0)
             | x_177 := -((bb_110+y)/2.0)
             | x21 := (x_177 when C_y) default (x_1 when C_444)
             | cc_213 := cc_2 when C_cc_384
             |)
          |) |)
   %equationSolving_Cluster_1%; 
   process equationSolving_Cluster_2 =
        ( ? real a;
            boolean stable;
        )
      pragmas 
         Cluster
      end pragmas
      (| (| (| OK := a/=0.0
             | OK_344 := left_tt ( OK,stable )
             | C_cc := not OK
             |)
          | (| aa := a when OK |)
          |) |)
   %equationSolving_Cluster_2%; 
   process equationSolving_Cluster_3 =
        ( ? real b;
            boolean OK, stable;
            real aa;
            boolean C_cc;
        )
      pragmas 
         Cluster
      end pragmas
      (| (| (| C_cc_384 := bb_1/=0.0
             | C_cc_390 := left_tt ( C_cc_384,stable )
             | C_error := bb_1=0.0
             | C_error_398 := left_tt ( C_error,C_cc )
             |)
          | (| bb := XZX_80/aa
             | XZX_80 := b when OK
             | bb_212 := bb_1 when C_cc_384
             | bb_1 := b when C_cc
             |)
          |) |)
   %equationSolving_Cluster_3%; 
   process equationSolving_Cluster_delays =
        ( ? real next_yy;
            boolean next_stable;
        )
      pragmas 
         DelayCluster
         Cluster
      end pragmas
      (| (| (| stable := next_stable$1 init true |)
          | (| pre_next_yy := next_yy$1 init 1.0 |)
          |) |)
   %equationSolving_Cluster_delays%; 
   real x, d, bb, cc, dd, aa, XZX_80, XZX_84, x_1, XZX_91, y, bb_110, yy, next_yy;
   boolean biterate;
   real mx, pre_next_yy, s, XZX_147, XZX_164, x_168, x_177, x21, bb_212, cc_213, bb_1, cc_2;
   boolean err_235, Tick, C, C_y, OK_344, C_cc, C_d_357, C__368, C_376, C_cc_390, C_error_398, C__416, C_x, C_err, C_x1, C_444, C_448, C_451;
   end
%equationSolving_Simu_sbDC_TRA%; %(| C_336 := not (next_stable and biterate)
                                   | C_338 := not stable
                                   | C_341 := C_y or stable
                                   | C_cc_349 := left_tt ( C_cc,stable )
                                   | C_d_354 := left_tt ( C_d,OK )
                                   | C_360 := not (dd>0.0)
                                   | C__365 := left_tt ( C_,OK )
                                   | C_371 := not (dd=0.0)
                                   | C_379 := left_tt ( C_373,stable )
                                   | C_382 := not (dd<0.0)
                                   | C_cc_387 := left_tt ( C_cc_384,C_cc )
                                   | C_393 := not (bb_1/=0.0)
                                   | C_401 := not (bb_1=0.0)
                                   | C_404 := C_cc_384 or C_error
                                   | C_407 := C_ or C_373
                                   | C_410 := C_d or C_407
                                   | C_413 := C_d or C_373
                                   | C_425 := C_err or C_cc_387
                                   | C_428 := left_tt ( C_425,stable )
                                   | C_431 := C_x or C_428
                                   | C_434 := C_x or C_379
                                   | C_440 := C_431 or C_cc_349
                                   |)***war: unused signals 
*
%

      end
   ; 
   HomoType d_a, d_b, d_c, dEnd, d_x2, d_x1, d_error;
   boolean stable init true;
   end
; 
