process equationSolving =
     ( ? real a;
         real b;
         real c;
       ! real x2;
         real x1;
         boolean oc;
     )
   (| (| OK := a/=0.0
       | (| SecondDegree_ABS(a,b,c) |)/ C_bb
                                      / stable
                                      / C_err
                                      / C_y
                                      / C_x
       | (| FirstDegree_ABS(not OK,b,c) |)/ C_bb
                                          / C_error
       | (| a2 := x
          | err1 := err
          | a1 := x21
          | (| u := a1 default a2
             | oc := (when err1) default err2
             |)
          | x1 := u
          |) where real u, a1, a2;
                   boolean err1; end
       | a ^= b ^= c
       |)/ err2, x, err, x21, OK |)
   where 
   boolean err2, err, C_x, C_y, C_err, stable, OK, C_bb, C_error;
     
process SecondDegree_ABS =
     ( ? real a, b, c;
       ! boolean err;
         real x21, x2;
         boolean stable, C_y, C_bb, C_err, C_x;
     )
     spec (| (| {a,b,c} --> {err,x21,x2}
              | {{a,b,c} --> C_y} when C_y
              | {a --> C_bb} when C_bb
              | {{a,b,c} --> C_err} when C_err
              | {{a,b,c} --> C_x} when C_x
              |)
           | (| stable ^= C_y ^= C_x
              | when stable ^= a ^= b ^= c ^= C_bb
              | when C_y ^= x2
              | when C_bb ^= C_err
              | when C_err ^= err
              | when C_x ^= x21
              |)
           |)
   pragmas 
      BlackBox "SecondDegree"
   end pragmas
   external "C"
%SecondDegree_ABSTRACT%; 

     process FirstDegree_ABS =
     ( ? boolean Compute;
         real b, c;
       ! real x;
         boolean err2, C_error, C_bb;
     )
     spec (| (| {Compute,b,c} --> {x,err2}
              | {{Compute,b} --> C_error} when C_error
              | {{Compute,b} --> C_bb} when C_bb
              |)
           | (| Compute ^= b ^= c
              | when Compute ^= C_error ^= C_bb
              | when C_error ^= err2
              | when C_bb ^= x
              |)
           |)
   pragmas 
      BlackBox "FirstDegree"
   end pragmas
   external "C"
%FirstDegree_ABSTRACT%; 

   real x21, x;
   end
; 
