process safe_FIFO =
  { type message_type;
    integer fifo_size;
    message_type default_mess; }
  ( ? message_type mess_in;
      event get_mess;
    ! message_type mess_out;
      boolean OK_write, OK_read; )
  (| access_clock := mess_in ^+ get_mess
   | new_mess_in := mess_in when OK_write 
   | mess_out ^= get_mess when OK_read 
   | (mess_out, nbmess, OK_write, OK_read) := basic_FIFO{message_type, fifo_size, default_mess} (new_mess_in, access_clock)   
   |)
  where
    integer nbmess; 
    message_type new_mess_in;
    event access_clock;
    
    process basic_FIFO =
      { type message_type;
        integer fifo_size;
        message_type default_mess; }
      ( ? message_type mess_in;
          event access_clock;
        ! message_type mess_out;
          integer nbmess;
          boolean OK_write, OK_read;
          )
      (| prev_nbmess := nbmess$1 init 0
       | OK_write := prev_nbmess<fifo_size
       | OK_read := prev_nbmess>0
       | nbmess := ((prev_nbmess+1) when (^mess_in) when OK_write) default ((prev_nbmess-1) when (^mess_out) when OK_read) default prev_nbmess
       | nbmess ^= access_clock
       | queue := (mess_in window fifo_size) cell (^access_clock)
       | mess_out := (prev_mess_out when (not OK_read) when (^mess_out)) default (queue[fifo_size-prev_nbmess] when (^mess_out))
       | prev_mess_out := mess_out$1 init default_mess
       |)
      where 
        integer prev_nbmess;
        [fifo_size]message_type queue;
        message_type prev_mess_out;
      end%basic_FIFO%; 
    
  end;%safe_FIFO% 
