process LTTA = {type RWtype} ( ? RWtype XW ! RWtype XR)
   (| % WRITER % 
      (| ALTERNATE ( XW, Y_W )
       | Y_W := MEMORYCELL ( XW )
       | Y := Y_W cell ^Y
       | C_W := (true when ^Y_W) default (false when ^Y)
       | B := COMMUTATOR (C_W)
       |) where RWtype Y_W; boolean C_W; end
    | % BUS % 
      (| ALTERNATE ( Y, Y_B )
       | Y_B := MEMORYCELL ( Y )
       | B_B := B cell ^Y_B when ^Y_B
       |)

    | % ACTUAL READER % 
      (| B_R := B_B cell ^B_R when ^B_R % Reader rate adjustement % 
       | Y_R := Y_B cell ^B_R when ^B_R % Reader rate adjustement % 
       | C_R := TRIGGER(B_R)  % Reader triggering% 
       | XR := SAMPLE(Y_R,C_R)  % Reader sampling% 
       |)

    | % READER ABSTRACT SPECIFICATION preserving flow equivalence% 
      (| C_RS := TRIGGER(B_B)
       | X_RS := SAMPLE(Y_B,C_RS)
       | ALTERNATE ( X_RS, XRS )
       | XRS := MEMORYCELL (X_RS)
       |) 

    | B_R ^> XRS % HYPOTHESIS 12 %   
    |)  
  where
    RWtype Y, Y_B, Y_R, X_RS, XRS;
    boolean B, B_B, B_R, C_R, C_RS;
    process COMMUTATOR = ( ? boolean C ! boolean B)
       (| B := (not ZB when C) default ZB
        | ZB := B$1 init false
        | C^=B
        |) 
      where boolean ZB;
    end ; 
    process TRIGGER = ( ? boolean B ! boolean C)
       (| C := true when (B and (not ZB)) default (true when ((not B) and ZB)) default (false when ^ZB)
        | ZB := B$1 init false
        |)
      where boolean ZB;
    end ; 
    process ALTERNATE = ( ? first, second; ! )
       (| first ^= when firstAllowed
        | second ^= when not firstAllowed
        | firstAllowed := not (firstAllowed $1 init false)
        |)
       where boolean firstAllowed;
    end ; 
    process MEMORYCELL = ( ? written ! read )
       (| read := written cell ^read when ^read |) ; 
    process SAMPLE = ( ? written; boolean C ! read)
       (| read := written when C
        | C ^= written
        |) ; 
end;