process LTTA3 = {type RWtype} ( ? RWtype XW ! RWtype XRS)
   (| % WRITER desynchronization wrt XW rate%  
      (| ALTERNATE ( XW, Y_W ) % from Y_W := TWOSTEP(XW) % 
       | Y_W := MEMORYCELL ( XW ) % from Y_W := TWOSTEP(XW) %
       |)
    | % WRITER time acceleration % 
      (| Y := Y_W cell ^Y % from (Y, C_W) := ACCELERATE(Y_W)%
       | C_W := (true when ^Y_W) default (false when ^Y) % from (Y, C_W) := ACCELERATE(Y_W)%
       |)
    | % WRITER boolean commutation %  
      (| B := COMMUTATOR (C_W)
       |)
    | % BUS desynchronization wrt bus rate% 
      (| ALTERNATE ( Y, Y_B ) % from (Y_B, B_B) := TWOSTEP2(Y) % 
       | Y_B := MEMORYCELL ( Y ) % from (Y_B, B_B) := TWOSTEP2(Y) %
       | B_B := B cell ^Y_B when ^Y_B % from (Y_B, B_B) := TWOSTEP2(Y)% 
       |)

    | % BUS to READER: WRITER boolean commutation reversing % 
      (| C_RS := TRIGGER(B_B)
       |)
    | % BUS to READER: WRITER time acceleration reversing % 
      (| X_BS := SAMPLE(Y_B,C_RS)
       |)  
    | % final READER  desynchronization wrt XR rate%  
      (| ALTERNATE ( X_BS, XRS ) % from XRS := TWOSTEP(X_BS) % 
       | XRS := MEMORYCELL ( X_BS ) % from XRS := TWOSTEP(X_BS) %
       |)
    |)
   where
    RWtype Y, Y_W, Y_B, X_BS;
    boolean B, C_W, B_B, C_RS;
    process COMMUTATOR = ( ? boolean C ! boolean B)
       (| B := (not ZB when C) default ZB
        | ZB := B$1 init false
        | C^=B
        |) 
      where boolean ZB;
    end ; 
    process TRIGGER = ( ? boolean B ! boolean C)
       (| C := true when (B and (not ZB)) default (true when ((not B) and ZB)) default (false when ^ZB)
        | ZB := B$1 init false
        |)
      where boolean ZB;
    end ; 
    process SAMPLE = ( ? written; boolean C ! read)
       (| read := written when C
        | C ^= written
        |) ; 
    process ALTERNATE = ( ? first, second; ! )
       (| first ^= when firstAllowed
        | second ^= when not firstAllowed
        | firstAllowed := not (firstAllowed $1 init false)
        |)
       where boolean firstAllowed;
    end ; 
    process MEMORYCELL = ( ? written ! read )
       (| read := written cell ^read when ^read |) ; 
end;