
% From the paper on 
   "A Protocol for Loosely Time-Triggered Architectures"
 by Benveniste at al. 
%
process lttaFifo3C1 = 
  (? boolean xw; 
     event cw, cb, cr;
   ! boolean xr, inv; )
  (| (xb,bb,sbw) := bus(xw,writer(xw,cw),cb)        %writer + bus%
   | (xr,br,sbb) := reader(xb,bb,cr)                %reader%
   
    | cb ^= sbw default cb                          % condition (16)%
%     | cr ^= (when switched(sbb)) default cr        condition (17)%

   | xok := fifo(xw)                                %fifo satisfies (4)%
   | inv := equal(xok,xr)                           %tests whether xok=xr?%
   | Sigali(Always(B_True(inv)))
   |)
  where
   use SIGALI;
   boolean xb, bb, sbw, sbb, br, xok;
   process writer = 
     (? boolean xw;
        event cw;
      ! boolean bw; )
     (| bw ^= xw ^= cw
      | bw := not (bw$1 init true)
      |)
   ;                                           %bw: boolean flag%
   
   process bus =
     (? boolean xw, bw; 
        event cb;
      ! boolean xb, bb, sbw; )
     (| (xb,bb,sbw) := buffer(xw,bw,cb) |)
   ;
   
   process reader =
     (? boolean xb, bb; 
        event cr;
      ! boolean xr, br, sbb; )
     (| (yr,br,sbb) := buffer(xb,bb,cr)
      | xr := yr when switched(br)
      |)
     where 
       boolean yr; 
     end;                            %switched(br) validates xr%
  
   process switched =
     (? boolean b;
      ! boolean c; )
     (| zb := b$1 init true
      | c := (b and (not zb)) or ((not b) and zb) 
      |)
     where
       boolean zb; 
     end;                            %c=true when b alternates%
  
   process buffer =
     (? boolean x, b;
        event c;
      ! boolean bx, bb, sb; )
     (| (sx,sb) := shift_2(x,b)
      | (bx,bb) := current_2(sx,sb,c)
      |)
     where 
       boolean sx;
     end;
  
   process shift_2 =                              %see shift_1%
     (? boolean x, b;
      ! boolean sx, sb; )
     (| (sx,sb) := current_2(x,b,^sb)
      | interleave(x,sx)
      |)
   ;
   process current_2 =
     (? boolean wx, wb; 
        event c;
      ! boolean rx, rb; )
     (| rx := (wx cell c init false) when c
      | rb := (wb cell c init true) when c
      |)
   ;  %see current_1%
   process interleave =
     (? boolean x, sx;
      ! )
     (| x ^= when b
      | sx ^= when (not b)
      | b := not(b$1 init false)
      |)
     where
       boolean b;
     end;
   process equal =
     (? boolean y, z;
      ! boolean inv; )
     (| inv := (y and z) or (not y and not z) default i
       % inv := ((y when z) default (not y when not z)) default i % 
      | i := inv $1 init true
      |)
     where
       boolean i;
     end;                            %tests whether y=z%
   process fifo =
     (? boolean x;
      ! boolean xok; )
     %  Fifo 3 %
     (| xok := shift_1(shift_1(shift_1(x))) |) 
   ;
   process shift_1 =
     (? boolean x;
      ! boolean sx; )
     (| sx := current_1(x,^sx)
      | interleave(x,sx)
      |)
   ;
   process current_1 =
     (? boolean wx;
        event c;
      ! boolean rx; )
     (| rx := (wx cell c init false) when c |)
   ;
end;
  
