
%  See the descritpion section 3.5 %
process DISTRIBUTOR =
( ? integer A;
    event Demand;
  ! integer S;)
pragmas
  Comments " We want to program a fresh goods distributor. It contains at every moment at most only"
           " one item, denoted by an integer input signal A. A user wanting an item pushes a button,"
           " giving an input event Demand. To give the item A, the distributor produces its integer value on output S."
           " Example of scenario :"
           "                       1    2    3                  4        5    6     "
           "   A    : ------------ * -- * -- * ---------------- * ------ * -- * --- "
           " Demand : -- * -- * ---------------- * -- * -- * ------ * -- * -------- "
           "                       1             3              4        5          "
           "   S    : ------------ * ----------- * ------------ * ------ * -------- "
end pragmas       

  (| S := A when Demand
          default A when WAIT$ init false
          default MEM_A when AVAIL_A$ init false when Demand
   | AVAIL_A ^= A ^+ Demand ^= WAIT ^= MEM_A
   | AVAIL_A := not ^S default ^A default AVAIL_A$ init false
   | WAIT := not ^S default Demand default WAIT$ init false
   | MEM_A := A default MEM_A$
   | )
where
  boolean AVAIL_A, WAIT;
  integer MEM_A;
end % DISTRIBUTOR %;
  
