process DISTRIBUTOR_EXTENDED_SPECIFICATION_TRA =
     ( ? integer A;
         event Demand;
         boolean C_A, C_Demand;
       ! integer S;
     )
   pragmas 
      Main
      Comments " We want to program a fresh goods distributor. It contains at every moment at most only"
               " one item, denoted by an integer input signal A. A user wanting an item pushes a button,"
               " giving an input event Demand. To give the item A, the distributor produces its integer value on output S."
               " Example of scenario :"
               "                       1    2    3                  4        5    6     "
               "   A    : ------------ * -- * -- * ---------------- * ------ * -- * --- "
               " Demand : -- * -- * ---------------- * -- * -- * ------ * -- * -------- "
               "                       1             3              4        5          "
               "   S    : ------------ * ----------- * ------------ * ------ * -------- "
   end pragmas
   (| (| CLK_C_A := ^C_A
       | CLK_C_A ^= C_A ^= C_Demand
       | ACT_CLK_C_A{}
       |) |)
   where 
   event CLK_50, CLK_40, CLK_38, CLK_37, CLK_35, CLK_32, CLK_AVAIL_A, CLK_29, CLK_S, CLK_25, CLK_20, CLK_18, CLK_16, CLK_15, CLK_13, CLK_10, CLK_8, CLK_A;
   integer MEM_A;
   process ACT_CLK_C_A =
        ( )
      (| (| CLK_A_0 := when C_A
          | CLK_A_0 ^= A
          | CLK_54 := when (not C_A)
          |)
       | (| when C_Demand ^= Demand
          | Demand ^= Demand
          | CLK_56 := when (not C_Demand)
          |)
       | (| CLK_58 := CLK_A_0 ^* Demand |)
       | (| CLK_AVAIL_A_0 := CLK_A_0 ^+ Demand
          | CLK_AVAIL_A_0 ^= AVAIL_A ^= WAIT ^= MEM_A ^= pre_WAIT ^= pre_AVAIL_A ^= pre_AVAIL_A_40 ^= pre_WAIT_45 ^= pre_MEM_A
          | ACT_CLK_AVAIL_A_0{}
          |)
       | (| CLK_62 := Demand ^* CLK_18 |)
       | (| CLK_64 := CLK_A_0 ^* CLK_10 |)
       | (| CLK_66 := CLK_64 ^+ CLK_58 |)
       | (| CLK_68 := CLK_64 ^+ Demand |)
       | (| CLK_S_0 := CLK_62 ^+ CLK_66
          | CLK_S_0 ^= S
          | (| S := (A when CLK_58) default (A when CLK_76) default (MEM_A when CLK_74) |)
          |)
       | (| CLK_72 := CLK_62 ^+ CLK_A_0 |)
       | (| CLK_74 := CLK_62 ^- CLK_66 |)
       | (| CLK_76 := CLK_64 ^- CLK_58 |)
       | (| CLK_78 := CLK_AVAIL_A_0 ^- CLK_68 |)
       | (| CLK_80 := CLK_AVAIL_A_0 ^- CLK_72 |)
       | (| CLK_82 := Demand ^- CLK_A_0 |)
       |)
      where 
      process ACT_CLK_AVAIL_A_0 =
           ( )
         (| (| CLK_10 := when pre_WAIT
             | CLK_11 := when (not pre_WAIT)
             |)
          | (| CLK_18 := when pre_AVAIL_A
             | CLK_19 := when (not pre_AVAIL_A)
             |)
          | (| AVAIL_A := (not CLK_S_0) default CLK_78 default (pre_AVAIL_A_40 when CLK_80)
             | WAIT := (not CLK_S_0) default (Demand when CLK_80) default (pre_WAIT_45 when CLK_78)
             | MEM_A := (A when CLK_A_0) default (pre_MEM_A when CLK_82)
             | pre_WAIT := WAIT$1 init false
             | pre_AVAIL_A := AVAIL_A$1 init false
             | pre_AVAIL_A_40 := AVAIL_A$1 init false
             | pre_WAIT_45 := WAIT$1 init false
             | pre_MEM_A := MEM_A$1 init 0
             |)
          |)
      %ACT_CLK_AVAIL_A_0%; 
      end
   %ACT_CLK_C_A%; 
   end
%DISTRIBUTOR_EXTENDED_SPECIFICATION_TRA%; 
