process DISTRIBUTOR_SEQ_TRA =
     ( ? integer A;
         boolean C_A, Demand;
       ! integer S;
     )
   pragmas 
      Main
      Comments " We want to program a fresh goods distributor. It contains at every moment at most only"
               " one item, denoted by an integer input signal A. A user wanting an item pushes a button,"
               " giving an input event Demand. To give the item A, the distributor produces its integer value on output S."
               " Example of scenario :"
               "                       1    2    3                  4        5    6     "
               "   A    : ------------ * -- * -- * ---------------- * ------ * -- * --- "
               " Demand : -- * -- * ---------------- * -- * -- * ------ * -- * -------- "
               "                       1             3              4        5          "
               "   S    : ------------ * ----------- * ------------ * ------ * -------- "
      DefinedClockHierarchy
   end pragmas
   (| (| Tick := true
       | when Tick ^= C_A ^= Demand
       | ACT_Tick{}
       |) |)
   where 
   boolean Tick;
   process ACT_Tick =
        ( )
      (| when Tick ^= C_CLK_58 ^= C_ ^= C_CLK_82 ^= XZX_82 ^= XZX_88 ^= C_CLK_62 ^= C_CLK_64 ^= C_CLK_66 ^= C_CLK_68 ^= C_S ^= C_CLK_72 ^= C_CLK_74 ^= C_CLK_76 ^= C_CLK_78 ^= C_CLK_80
       | (| when C_A ^= A |)
       | (| when C_ ^= MEM_A ^= pre_WAIT ^= pre_AVAIL_A
          | ACT_C_{}
          |)
       | (| when C_S ^= S
          | (| S := (A when C_CLK_58) default (A when C_CLK_76) default (MEM_A when C_CLK_74) |)
          |)
       | (| C_CLK_58 := C_A and Demand
          | C_ := C_A or Demand
          | C_CLK_82 := (not C_A) and Demand
          | XZX_82 := left_tt ( pre_WAIT,C_ )
          | XZX_88 := left_tt ( pre_AVAIL_A,C_ )
          | C_CLK_62 := Demand and XZX_88
          | C_CLK_64 := C_A and XZX_82
          | C_CLK_66 := C_CLK_64 or C_CLK_58
          | C_CLK_68 := C_CLK_64 or Demand
          | C_S := C_CLK_62 or C_CLK_66
          | C_CLK_72 := C_CLK_62 or C_A
          | C_CLK_74 := (not C_CLK_66) and C_CLK_62
          | C_CLK_76 := (not C_CLK_58) and C_CLK_64
          | C_CLK_78 := (not C_CLK_68) and C_
          | C_CLK_80 := (not C_CLK_72) and C_
          |)
       |)
      where 
      integer MEM_A;
      boolean Demand, pre_WAIT, pre_AVAIL_A, C_CLK_58, C_, C_CLK_82, XZX_82, XZX_88, C_CLK_62, C_CLK_64, C_CLK_66, C_CLK_68, C_S, C_CLK_72, C_CLK_74, C_CLK_76, C_CLK_78, C_CLK_80;
      process ACT_C_ =
           ( )
         (| when C_ ^= AVAIL_A ^= WAIT ^= pre_AVAIL_A_40 ^= pre_WAIT_45 ^= pre_MEM_A
          | (| AVAIL_A := (false when C_S) default (true when C_CLK_78) default (pre_AVAIL_A_40 when C_CLK_80)
             | WAIT := (false when C_S) default (true when C_CLK_80) default (pre_WAIT_45 when C_CLK_78)
             | MEM_A := (A when C_A) default (pre_MEM_A when C_CLK_82)
             | pre_WAIT := WAIT$1 init false
             | pre_AVAIL_A := AVAIL_A$1 init false
             | pre_AVAIL_A_40 := AVAIL_A$1 init false
             | pre_WAIT_45 := WAIT$1 init false
             | pre_MEM_A := MEM_A$1 init 0
             |)
          |)
         where 
         integer pre_MEM_A;
         boolean AVAIL_A, WAIT, pre_AVAIL_A_40, pre_WAIT_45;
         end
      %ACT_C_%; 
      end
   %ACT_Tick%; 
   end
%DISTRIBUTOR_SEQ_TRA%; %(| Tick := true when Tick
                         | C_CLK_54 := not C_A
                         | C_CLK_56 := not Demand
                         | C_CLK_11 := not pre_WAIT
                         | C_CLK_19 := not pre_AVAIL_A
                         |)**WARNING: unused signals 

%
