process DISTRIBUTOR_TRA =
     ( ? integer A;
         event Demand;
       ! integer S;
     )
   pragmas 
      Main
      Comments " We want to program a fresh goods distributor. It contains at every moment at most only"
               " one item, denoted by an integer input signal A. A user wanting an item pushes a button,"
               " giving an input event Demand. To give the item A, the distributor produces its integer value on output S."
               " Example of scenario :"
               "                       1    2    3                  4        5    6     "
               "   A    : ------------ * -- * -- * ---------------- * ------ * -- * --- "
               " Demand : -- * -- * ---------------- * -- * -- * ------ * -- * -------- "
               "                       1             3              4        5          "
               "   S    : ------------ * ----------- * ------------ * ------ * -------- "
   end pragmas
   (| (| CLK_A := ^A
       | CLK_A ^= A
       |)
    | (| ^Demand ^= Demand
       | Demand ^= Demand
       |)
    | (| CLK_8 := CLK_A ^* Demand |)
    | (| CLK_13 := CLK_A ^* CLK_10 |)
    | (| CLK_15 := CLK_13 ^- CLK_8 |)
    | (| CLK_16 := CLK_8 ^+ CLK_13 |)
    | (| CLK_20 := Demand ^* CLK_18 |)
    | (| CLK_25 := CLK_20 ^- CLK_16 |)
    | (| CLK_S := CLK_16 ^+ CLK_20
       | CLK_S ^= S
       | (| S := (A when CLK_8) default (A when CLK_15) default (MEM_A when CLK_25) |)
       |)
    | (| CLK_29 := Demand ^- CLK_A |)
    | (| CLK_AVAIL_A := CLK_A ^+ Demand
       | CLK_AVAIL_A ^= MEM_A
       | ACT_CLK_AVAIL_A{}
       |)
    | (| CLK_32 := CLK_A ^- CLK_S |)
    | (| CLK_35 := CLK_AVAIL_A ^- CLK_50 |)
    | (| CLK_37 := Demand ^- CLK_S |)
    | (| CLK_38 := Demand ^+ CLK_13 |)
    | (| CLK_40 := CLK_AVAIL_A ^- CLK_38 |)
    | (| CLK_50 := CLK_A ^+ CLK_20 |)
    |)
   where 
   event CLK_50, CLK_40, CLK_38, CLK_37, CLK_35, CLK_32, CLK_AVAIL_A, CLK_29, CLK_S, CLK_25, CLK_20, CLK_18, CLK_16, CLK_15, CLK_13, CLK_10, CLK_8, CLK_A;
   integer MEM_A;
   process ACT_CLK_AVAIL_A =
        ( )
      (| CLK_AVAIL_A ^= AVAIL_A ^= WAIT ^= pre_WAIT ^= pre_AVAIL_A ^= pre_AVAIL_A_40 ^= pre_WAIT_45 ^= pre_MEM_A
       | (| CLK_10 := when pre_WAIT
          | CLK_11 := when (not pre_WAIT)
          |)
       | (| CLK_18 := when pre_AVAIL_A
          | CLK_19 := when (not pre_AVAIL_A)
          |)
       | (| AVAIL_A := (not CLK_S) default CLK_32 default (pre_AVAIL_A_40 when CLK_35)
          | WAIT := (not CLK_S) default (Demand when CLK_37) default (pre_WAIT_45 when CLK_40)
          | MEM_A := (A when CLK_A) default (pre_MEM_A when CLK_29)
          | pre_WAIT := WAIT$1 init false
          | pre_AVAIL_A := AVAIL_A$1 init false
          | pre_AVAIL_A_40 := AVAIL_A$1 init false
          | pre_WAIT_45 := WAIT$1 init false
          | pre_MEM_A := MEM_A$1 init 0
          |)
       |)
      where 
      event CLK_19, CLK_11;
      integer pre_MEM_A;
      boolean AVAIL_A, WAIT, pre_WAIT, pre_AVAIL_A, pre_AVAIL_A_40, pre_WAIT_45;
      end
   %ACT_CLK_AVAIL_A%; 
   end
%DISTRIBUTOR_TRA%; 
