process SUMMIT_TRA =
     ( ? integer A;
       ! event SUMMIT;
     )
   pragmas 
      Main
      Comments "2. Produce a TOP event signal each time a summit for A values has been passed. "
               "   This is possible only on the first decreasing value !"
               " 3. Suppose now that some consecutive values of A may be equal. There is a summit on"
               "    decreasing A only if A was increasing before it became flat !"
               "    Use a boolean signal  to remember the up/down status of A."
   end pragmas
   (| (| CLK_A := ^A
       | CLK_A ^= A
       | ACT_CLK_A{}
       |) |)
   where 
   event CLK_A;
   process ACT_CLK_A =
        ( )
      (| CLK_A ^= ZA ^= UP ^= ZUP
       | (| SUMMIT := when (ZUP and (not UP))
          | SUMMIT ^= SUMMIT
          |)
       | (| ZA := A$1 init 0
          | UP := (A>ZA) or ((A=ZA) and ZUP)
          | ZUP := UP$1 init true
          |)
       |)
      where 
      boolean UP, ZUP;
      integer ZA;
      end
   %ACT_CLK_A%; 
   end
%SUMMIT_TRA%; 
