process PICTURE_EXTENDED_SPECIFICATION_TRA =
     { integer NL, NC; }
     ( ? boolean PIXEL, C_PIXEL, C_LINE, C_COLUMN;
       ! integer LINE, COLUMN;
     )
   pragmas 
      Main
      Comments " 1. Pixels from a sequence of pictures are given as boolean input, line after line, and for"
               " each line, by column. A picture has NL lines and NC columns (constant parameters)."
               " The last pixel of a picture is followed by the first one of the next picture. Produce for each pixel its LINE and COLUMN number."
               " In a separate compiling, effective values of NL and NC, for instance 4 and 8, are given in a file picture.par, containing 4,8"
   end pragmas
   (| (| CLK_C_PIXEL := ^C_PIXEL
       | CLK_C_PIXEL ^= C_PIXEL ^= C_LINE ^= C_COLUMN
       | ACT_CLK_C_PIXEL{}
       |) |)
   where 
   event CLK_COLUMN, CLK_LINE, CLK_PIXEL;
   process ACT_CLK_C_PIXEL =
        ( )
      (| (| CLK_PIXEL_0 := when C_PIXEL
          | CLK_PIXEL_0 ^= PIXEL
          | CLK := when (not C_PIXEL)
          |)
       | (| CLK_LINE_0 := when C_LINE
          | CLK_LINE_0 ^= LINE
          | CLK_11 := when (not C_LINE)
          |)
       | (| CLK_COLUMN_0 := when C_COLUMN
          | CLK_COLUMN_0 ^= COLUMN
          | CLK_13 := when (not C_COLUMN)
          |)
       |)
   %ACT_CLK_C_PIXEL%; 
   end
%PICTURE_EXTENDED_SPECIFICATION_TRA%; 
