process PICTURE_SEQ_TRA =
     ( ? boolean PIXEL;
       ! integer LINE, COLUMN;
     )
   pragmas 
      Main
      Comments " 1. Pixels from a sequence of pictures are given as boolean input, line after line, and for"
               " each line, by column. A picture has NL lines and NC columns (constant parameters)."
               " The last pixel of a picture is followed by the first one of the next picture. Produce for each pixel its LINE and COLUMN number."
      DefinedClockHierarchy
   end pragmas
   (| (| Tick := true
       | when Tick ^= PIXEL ^= LINE ^= COLUMN
       | ACT_Tick{}
       |) |)
   where 
   constant integer NL = 2;
   constant integer NC = 3;
   boolean Tick;
   process ACT_Tick =
        ( )
      (| when Tick ^= pre_COLUMN ^= pre_LINE ^= C_CLK
       | (| LINE := (((pre_LINE modulo 2)+1) when C_CLK) cell Tick init 0
          | COLUMN := (pre_COLUMN modulo 3)+1
          | pre_COLUMN := COLUMN$1 init 0
          | pre_LINE := LINE$1 init 0
          | C_CLK := COLUMN=1
          |)
       |)
      where 
      boolean C_CLK;
      integer pre_COLUMN, pre_LINE;
      end
   %ACT_Tick%; 
   end
%PICTURE_SEQ_TRA%; %(| Tick := true when Tick
                     | C_CLK_8 := not (COLUMN=1)
                     |)**WARNING: unused signals 

%
