process PICTURE_TRA =
     ( ? boolean PIXEL;
       ! integer LINE, COLUMN;
     )
   pragmas 
      Main
      Comments " 1. Pixels from a sequence of pictures are given as boolean input, line after line, and for"
               " each line, by column. A picture has NL lines and NC columns (constant parameters)."
               " The last pixel of a picture is followed by the first one of the next picture. Produce for each pixel its LINE and COLUMN number."
   end pragmas
   (| (| CLK_PIXEL := ^PIXEL
       | CLK_PIXEL ^= PIXEL ^= LINE ^= COLUMN
       | ACT_CLK_PIXEL{}
       |) |)
   where 
   constant integer NL = 2;
   constant integer NC = 3;
   event CLK_PIXEL;
   process ACT_CLK_PIXEL =
        ( )
      (| CLK_PIXEL ^= pre_COLUMN ^= pre_LINE
       | (| CLK := when (COLUMN=1) |)
       | (| LINE := (((pre_LINE modulo 2)+1) when CLK) cell CLK_PIXEL init 0
          | COLUMN := (pre_COLUMN modulo 3)+1
          | pre_COLUMN := COLUMN$1 init 0
          | pre_LINE := LINE$1 init 0
          |)
       |)
      where 
      event CLK;
      integer pre_COLUMN, pre_LINE;
      end
   %ACT_CLK_PIXEL%; 
   end
%PICTURE_TRA%; 
