process BIG_BEN =
  ( ? event TICK;
    ! integer DAY, HOUR, MINUTE, SECOND; )

  pragmas
    Comments " A classical example of modularity is the counting of time, using some instances of a Counter modulo N."
              " An input signal TICK is supposed to occur each second. The process produces at these"
              " instants the day, hour, minute and second numbers."
              " The CNT MOD process has two events as input : one to increase counter, an other "
              " to obtain (on output CNT) the current value of the counter. The process also emits an"
              " event when the counter becomes RESET to zero."
  end pragmas

  (| (SECOND, NEW_MINUTE) := CNT_MOD {60} (TICK, TICK)
   | (MINUTE, NEW_HOUR ) := CNT_MOD {60} (TICK, NEW_MINUTE)
   | (HOUR , NEW_DAY ) := CNT_MOD {24} (TICK, NEW_HOUR)
   | DAY ^= TICK
   | DAY := DAY$ + 1 when NEW_DAY default DAY$ init 1
   |)
  where
    event NEW_MINUTE, NEW_HOUR, NEW_DAY;
    process CNT_MOD = % Counter modulo N %
      { integer N;}
      ( ? event EV_OUT, % when Counter must be output %
          EV_INC; % when Counter must be increased %
        ! integer CNT;
          event RESET; )
      (| CNT ^= EV_OUT ^+ EV_INC
       | CNT := (ZCNT+1) modulo N when EV_INC
       default ZCNT
       | ZCNT := CNT$ init 0
       | RESET := when CNT = 0 when EV_INC
       |)
      where
        integer ZCNT;
      end % CNT_MOD %;
  end % BIG_BEN %;
    
