process BIG_BEN_BOOL_TRA =
     ( ? boolean TICK;
       ! integer DAY, HOUR, MINUTE, SECOND;
     )
   pragmas 
      Main
      Comments " A classical example of modularity is the counting of time, using some instances of a Counter modulo N."
               " An input signal TICK is supposed to occur each second. The process produces at these"
               " instants the day, hour, minute and second numbers."
               " The CNT MOD process has two events as input : one to increase counter, an other "
               " to obtain (on output CNT) the current value of the counter. The process also emits an"
               " event when the counter becomes RESET to zero."
      DefinedClockHierarchy
   end pragmas
   (| (| Tick := true
       | when Tick ^= TICK ^= DAY ^= HOUR ^= MINUTE ^= SECOND
       | ACT_Tick{}
       |) |)
   where 
   constant integer N = 60;
   constant integer N_49 = 60;
   constant integer N_73 = 24;
   boolean Tick;
   process ACT_Tick =
        ( )
      (| when Tick ^= ZCNT ^= ZCNT_54 ^= ZCNT_80 ^= pre_DAY ^= pre_DAY_100 ^= C_NEW_MINUTE ^= C_CLK ^= C_CLK_34 ^= C_CLK_54 ^= C_NEW_HOUR ^= C_NEW_DAY ^= C_CLK_74 ^= C_CLK_76
       | (| DAY := ((pre_DAY+1) when C_NEW_DAY) default (pre_DAY_100 when C_CLK_76)
          | HOUR := (((ZCNT_80+1) modulo 24) when C_NEW_HOUR) default (ZCNT_80 when C_CLK_74)
          | MINUTE := (((ZCNT_54+1) modulo 60) when C_NEW_MINUTE) default (ZCNT_54 when C_CLK)
          | SECOND := (ZCNT+1) modulo 60
          | ZCNT := SECOND$1 init 0
          | ZCNT_54 := MINUTE$1 init 0
          | ZCNT_80 := HOUR$1 init 0
          | pre_DAY := DAY$1 init 0
          | pre_DAY_100 := DAY$1 init 1
          | C_NEW_MINUTE := SECOND=0
          | C_CLK := not (SECOND=0)
          | C_CLK_34 := MINUTE=0
          | C_CLK_54 := HOUR=0
          | C_NEW_HOUR := C_NEW_MINUTE and C_CLK_34
          | C_NEW_DAY := C_NEW_HOUR and C_CLK_54
          | C_CLK_74 := not C_NEW_HOUR
          | C_CLK_76 := not C_NEW_DAY
          |)
       |)
      where 
      boolean C_NEW_MINUTE, C_CLK, C_CLK_34, C_CLK_54, C_NEW_HOUR, C_NEW_DAY, C_CLK_74, C_CLK_76;
      integer ZCNT, ZCNT_54, ZCNT_80, pre_DAY, pre_DAY_100;
      end
   %ACT_Tick%; 
   end
%BIG_BEN_BOOL_TRA%; %(| Tick := true when Tick
                      | C_CLK_35 := not (MINUTE=0)
                      | C_CLK_55 := not (HOUR=0)
                      |)**WARNING: unused signals 

%
