process BIG_BEN_TRA =
     ( ? event TICK;
       ! integer DAY, HOUR, MINUTE, SECOND;
     )
   pragmas 
      Main
      Comments " A classical example of modularity is the counting of time, using some instances of a Counter modulo N."
               " An input signal TICK is supposed to occur each second. The process produces at these"
               " instants the day, hour, minute and second numbers."
               " The CNT MOD process has two events as input : one to increase counter, an other "
               " to obtain (on output CNT) the current value of the counter. The process also emits an"
               " event when the counter becomes RESET to zero."
   end pragmas
   (| (| ^TICK ^= TICK
       | TICK ^= TICK ^= DAY ^= HOUR ^= MINUTE ^= SECOND
       | ACT_TICK{}
       |) |)
   where 
   constant integer N = 60;
   constant integer N_49 = 60;
   constant integer N_73 = 24;
   process ACT_TICK =
        ( )
      (| TICK ^= ZCNT ^= ZCNT_54 ^= ZCNT_80 ^= pre_DAY ^= pre_DAY_100
       | (| NEW_MINUTE := when (SECOND=0)
          | CLK := when (not (SECOND=0))
          |)
       | (| CLK_34 := when (MINUTE=0) |)
       | (| CLK_54 := when (HOUR=0) |)
       | (| NEW_HOUR := NEW_MINUTE ^* CLK_34 |)
       | (| NEW_DAY := NEW_HOUR ^* CLK_54 |)
       | (| CLK_74 := TICK ^- NEW_HOUR |)
       | (| CLK_76 := TICK ^- NEW_DAY |)
       | (| DAY := ((pre_DAY+1) when NEW_DAY) default (pre_DAY_100 when CLK_76)
          | HOUR := (((ZCNT_80+1) modulo 24) when NEW_HOUR) default (ZCNT_80 when CLK_74)
          | MINUTE := (((ZCNT_54+1) modulo 60) when NEW_MINUTE) default (ZCNT_54 when CLK)
          | SECOND := (ZCNT+1) modulo 60
          | ZCNT := SECOND$1 init 0
          | ZCNT_54 := MINUTE$1 init 0
          | ZCNT_80 := HOUR$1 init 0
          | pre_DAY := DAY$1 init 0
          | pre_DAY_100 := DAY$1 init 1
          |)
       |)
      where 
      event CLK_76, CLK_74, NEW_DAY, NEW_HOUR, CLK_54, CLK_34, CLK, NEW_MINUTE;
      integer ZCNT, ZCNT_54, ZCNT_80, pre_DAY, pre_DAY_100;
      end
   %ACT_TICK%; 
   end
%BIG_BEN_TRA%; 
