process N_INTER_SEQ_TRA =
     ( ? integer N;
       ! boolean I;
     )
   pragmas 
      Main
      Comments "Let N be a positive or null integer signal. Produce after each N, and before the next"
               "N, a sequence of N events. Use a decreasing counter, and synchronizes input N on"
               "some value of the delayed counter (to avoid circularities)."
               "N   : - 4 --------------- 1 ------ 0 --- 2 ----------"
               "CNT : --4--3--2--1--0-----1--0-----0-----2--1--0-----"
               "CNT$: --0--4--3--2--1-----0--1-----0-----0--2--1-----"
               "S   : -----*--*--*--*--------*--------------*--*-----"
      DefinedClockHierarchy
   end pragmas
   (| (| Tick := true
       | ACT_Tick{}
       |) |)
   where 
   boolean Tick;
   process ACT_Tick =
        ( )
      (| when Tick ^= CNT ^= ZCNT ^= C_N ^= C_CLK ^= C_I
       | (| when C_N ^= N |)
       | (| when C_I ^= I
          | (| I := true when C_I |)
          |)
       | (| CNT := (N when C_N) default ((ZCNT-1) when C_CLK)
          | ZCNT := CNT$1 init 0
          | C_N := ZCNT=0
          | C_CLK := not (ZCNT=0)
          | C_I := ZCNT>0
          |)
       |)
      where 
      boolean C_N, C_CLK, C_I;
      integer CNT, ZCNT;
      end
   %ACT_Tick%; 
   end
%N_INTER_SEQ_TRA%; %(| Tick := true when Tick
                     | C_CLK_15 := not (ZCNT>0)
                     |)**WARNING: unused signals 

%
