process N_INTER_TRA =
     ( ? integer N;
       ! event I;
     )
   pragmas 
      Main
      Comments "Let N be a positive or null integer signal. Produce after each N, and before the next"
               "N, a sequence of N events. Use a decreasing counter, and synchronizes input N on"
               "some value of the delayed counter (to avoid circularities)."
               "N   : - 4 --------------- 1 ------ 0 --- 2 ----------"
               "CNT : --4--3--2--1--0-----1--0-----0-----2--1--0-----"
               "CNT$: --0--4--3--2--1-----0--1-----0-----0--2--1-----"
               "S   : -----*--*--*--*--------*--------------*--*-----"
   end pragmas
   (| (| CLK_CNT := ^CLK_CNT
       | ACT_CLK_CNT{}
       |) |)
   where 
   event CLK_CNT;
   process ACT_CLK_CNT =
        ( )
      (| CLK_CNT ^= CNT ^= ZCNT
       | (| CLK_N := when (ZCNT=0)
          | CLK_N ^= N
          | CLK := when (not (ZCNT=0))
          |)
       | (| I := when (ZCNT>0)
          | I ^= I
          |)
       | (| CNT := (N when CLK_N) default ((ZCNT-1) when CLK)
          | ZCNT := CNT$1 init 0
          |)
       |)
      where 
      event CLK, CLK_N;
      integer CNT, ZCNT;
      end
   %ACT_CLK_CNT%; 
   end
%N_INTER_TRA%; 
