%  5.2 Automata %
%  Modifiction for the simulation: the light is put off automatically after 6 seconds and not after 1 minute.%
process LIGHT =
  ( ? event SWITCH, H; % H every 1 seconds %
    ! event PUT_ON, PUT_OFF;
      )
  pragmas
    Comments " A passage may be lightened by pushing a switch. Light is put off by the"
    "same switch, or automatically after 1 minute. The process doing that may be written as"
    "a two-state automaton : S = 1 when light is OFF, S = 2 when ON."
  end pragmas
  
% State changes %
  (| S ^= SWITCH ^+ H ^= CNT
   | S := (3 - ZS when SWITCH) default (1 when ZS = 2 when ZCNT = 1) default ZS % loop on current state %
   | ZS := S $ init 1
% Actions on transitions %
   | CNT := (6 %  60 %  when ZS = 1 default ZCNT - 1) when S = 2 default ZCNT
   | ZCNT := CNT $ init 0
   | PUT_ON := when S = 2 when ZS = 1
   | PUT_OFF := when S = 1 when ZS = 2
   |)
  where
    integer S, ZS, CNT, ZCNT;
  end % LIGHT %;
    
