
%  Chapter 5, section 5.3, exercices 1,2,3 %
process PICTURE_ANALYSIS =
  {integer NL, NC;} % size of the picture %
  ( ? boolean PIXEL;
    ! integer LINE, COLUMN;
      integer L_INTO, C_INTO;
      event MOVED;
      integer L_LAST, C_LAST;
      integer L_OBJECT, C_OBJECT;
      integer NUM_OBJECT;
 )
  (|
    (| PIXEL ^= COLUMN
     | COLUMN := (COLUMN$ init 0) modulo NC + 1
     | LINE := (((LINE$ init 0) modulo NL + 1) when COLUMN=1) cell ^PIXEL
     |)
  |
   (| INTO := LINE>2 and COLUMN>1 and COLUMN<NC and PIXEL and PIXEL$(NC-1) and PIXEL$NC and PIXEL$(NC+1) and PIXEL$(2*NC)
    | L_INTO := LINE$NC when INTO
    | C_INTO := COLUMN$NC when INTO
     % The INTO boolean for a given pixel can only be set NC pixels after. In INTO definition,
       and operators are sufficient, because all operands have the same clock. We assume the
       evaluation stops as soon as an operand is false, so the initial values in delays have not to be set.
       Movements are detected by :%
    | MOVED := when (INTO /= INTO $(NL*NC))
    |)
 | %In a picture containing convex objects, FIRST and LAST are pixels where a line enters and leaves an object%
   (| FIRST := PIXEL and (COLUMN=1 or not PIXEL$)
    | LAST := (PIXEL$ init false) and (COLUMN=1 or not PIXEL)
    | L_LAST := LINE$ when LAST
    | C_LAST := COLUMN$ when LAST
    |)
  % In fact, LAST is the first pixel following the object crossing.
    We are crossing an object for the first time if we are in an object (PIXEL true), and if there is no true pixel just above. %
 | NEW := PIXEL and (LINE=1 or (not PIXEL$NC) and (FIRST or NEW$))
   % Inside each object, NEW remains true on first line. Otherwise, it becomes (and remains)
     false in case of true pixel above; else, it is true on first pixel, and may keep this value until last pixel.%
 | (| NEW_OBJECT := when LAST and NEW$
    | L_OBJECT := LINE$ when NEW_OBJECT
    | C_OBJECT := COLUMN$ when NEW_OBJECT
    | NUM_OBJECT := 1 + NUM_OBJECT$ init 0
    | NUM_OBJECT ^= NEW_OBJECT
    |)
 |)
  where
    boolean INTO;
%     integer L_INTO, C_INTO; %
    boolean NEW, FIRST, LAST;
    event NEW_OBJECT;
end;
