%  Chapter 5.2 automata, exercice 2 %
process STOPWATCH =
  ( ? event SS, LAP, H;
    ! integer DISPLAY;)
  pragmas
    Comments "A STOPWATCH is a classical example of system modelized by an automaton."
    "It has two buttons : SS to Start or Stop counting of time, and LAP (intermediate"
    "time) which stops Display without stopping the time counter. A new push on LAP"
    "makes current counter be displayed. Even when displaying is stopped, time counting"
    "may be started/stopped by SS."
    "When time counting is stopped, and display is free, LAP resets the stopwatch."
    "Add a source of time, which is supposed to have a sufficient accuracy. Displayed"
    "values are numbers of pulses of this input signal."
  end pragmas
  (| CNT ^= RUNNING ^= DISPLAY_ON ^= DISPLAY ^= SS ^+ LAP ^+ H
   | RUNNING := not ZRUNNING when SS default ZRUNNING
   | DISPLAY_ON := not ZDISPLAY_ON when LAP when RUNNING
                default LAP when not RUNNING % always set true if not running %
                default ZDISPLAY_ON
   | CNT := 0 when LAP when ZDISPLAY_ON and not RUNNING 
         default ZCNT + 1 when H when RUNNING 
         default ZCNT
   | DISPLAY := CNT when DISPLAY_ON default DISPLAY$ init 0
   | ZCNT := CNT$ init 0
   | ZRUNNING := RUNNING$ init false
   | ZDISPLAY_ON := DISPLAY_ON$ init true
   |)
  where
    boolean RUNNING, ZRUNNING, DISPLAY_ON, ZDISPLAY_ON;
    integer CNT, ZCNT;
  end % STOPWATCH %;
    
