process STOPWATCH_EXTENDED_SPECIFICATION_TRA =
     ( ? event SS, LAP, H;
         boolean C_SS, C_LAP, C_H;
       ! integer DISPLAY;
     )
   pragmas 
      Main
      Comments "A STOPWATCH is a classical example of system modelized by an automaton."
               "It has two buttons : SS to Start or Stop counting of time, and LAP (intermediate"
               "time) which stops Display without stopping the time counter. A new push on LAP"
               "makes current counter be displayed. Even when displaying is stopped, time counting"
               "may be started/stopped by SS."
               "When time counting is stopped, and display is free, LAP resets the stopwatch."
               "Add a source of time, which is supposed to have a sucient accuracy. Displayed"
               "values are numbers of pulses of this input signal."
   end pragmas
   (| (| CLK_C_SS := ^C_SS
       | CLK_C_SS ^= C_SS ^= C_LAP ^= C_H
       | ACT_CLK_C_SS{}
       |) |)
   where 
   event CLK_66, CLK_51, CLK_49, CLK_48, CLK_43, CLK_42, CLK_39, CLK_35, CLK_33, CLK_32, CLK_30, CLK_25, CLK_23, CLK_22, CLK_20, CLK_DISPLAY, CLK;
   process ACT_CLK_C_SS =
        ( )
      (| (| when C_SS ^= SS
          | SS ^= SS
          | CLK_69 := when (not C_SS)
          |)
       | (| when C_LAP ^= LAP
          | LAP ^= LAP
          | CLK_71 := when (not C_LAP)
          |)
       | (| CLK_73 := SS ^+ LAP |)
       | (| when C_H ^= H
          | H ^= H
          | CLK_75 := when (not C_H)
          |)
       | (| CLK_77 := LAP ^+ H |)
       | (| CLK_DISPLAY_0 := CLK_73 ^+ H
          | CLK_DISPLAY_0 ^= DISPLAY ^= RUNNING ^= ZRUNNING ^= DISPLAY_ON ^= ZDISPLAY_ON ^= CNT ^= ZCNT ^= pre_DISPLAY
          | ACT_CLK_DISPLAY_0{}
          |)
       | (| CLK_81 := H ^* CLK_22 |)
       | (| CLK_83 := LAP ^* CLK_39 |)
       | (| CLK_85 := LAP ^* CLK_23 |)
       | (| CLK_87 := LAP ^* CLK_22 |)
       | (| CLK_90 := CLK_81 ^+ CLK_83 |)
       | (| CLK_92 := CLK_81 ^- CLK_83 |)
       | (| CLK_95 := CLK_77 ^- SS |)
       | (| CLK_97 := CLK_DISPLAY_0 ^- CLK_90 |)
       | (| CLK_99 := CLK_DISPLAY_0 ^- LAP |)
       |)
      where 
      process ACT_CLK_DISPLAY_0 =
           ( )
         (| (| CLK_22 := when RUNNING
             | CLK_23 := when (not RUNNING)
             |)
          | (| CLK_39 := when (ZDISPLAY_ON and (not RUNNING))
             | CLK_40 := when (not (ZDISPLAY_ON and (not RUNNING)))
             |)
          | (| CLK_54 := when DISPLAY_ON
             | CLK_55 := when (not DISPLAY_ON)
             |)
          | (| DISPLAY := (CNT when CLK_54) default (pre_DISPLAY when CLK_55)
             | RUNNING := ((not ZRUNNING) when SS) default (ZRUNNING when CLK_95)
             | ZRUNNING := RUNNING$1 init false
             | DISPLAY_ON := ((not ZDISPLAY_ON) when CLK_87) default (LAP when CLK_85) default (ZDISPLAY_ON when CLK_99)
             | ZDISPLAY_ON := DISPLAY_ON$1 init true
             | CNT := (0 when CLK_83) default ((ZCNT+1) when CLK_92) default (ZCNT when CLK_97)
             | ZCNT := CNT$1 init 0
             | pre_DISPLAY := DISPLAY$1 init 0
             |)
          |)
      %ACT_CLK_DISPLAY_0%; 
      end
   %ACT_CLK_C_SS%; 
   end
%STOPWATCH_EXTENDED_SPECIFICATION_TRA%; 
