process STOPWATCH_SEQ_TRA =
     ( ? boolean SS, LAP, H;
       ! integer DISPLAY;
     )
   pragmas 
      Main
      Comments "A STOPWATCH is a classical example of system modelized by an automaton."
               "It has two buttons : SS to Start or Stop counting of time, and LAP (intermediate"
               "time) which stops Display without stopping the time counter. A new push on LAP"
               "makes current counter be displayed. Even when displaying is stopped, time counting"
               "may be started/stopped by SS."
               "When time counting is stopped, and display is free, LAP resets the stopwatch."
               "Add a source of time, which is supposed to have a sufficient accuracy. Displayed"
               "values are numbers of pulses of this input signal."
      DefinedClockHierarchy
   end pragmas
   (| (| Tick := true
       | when Tick ^= SS ^= LAP ^= H
       | ACT_Tick{}
       |) |)
   where 
   boolean Tick;
   process ACT_Tick =
        ( )
      (| when Tick ^= C_CLK_73 ^= C_CLK_77 ^= C_RUNNING ^= C_CLK_95 ^= C_CLK_99 ^= RUNNING_103 ^= C_CLK_23_108 ^= C_CLK_39_113 ^= C_CLK_81 ^= C_CLK_83 ^= C_CLK_85 ^= C_CLK_87 ^= C_CLK_90 ^= C_CLK_92 ^= C_CLK_97
       | (| when C_RUNNING ^= DISPLAY ^= RUNNING ^= C_CLK_23 ^= C_CLK_39
          | ACT_C_RUNNING{}
          |)
       | (| C_CLK_73 := SS or LAP
          | C_CLK_77 := LAP or H
          | C_RUNNING := C_CLK_73 or H
          | C_CLK_95 := (not SS) and C_CLK_77
          | C_CLK_99 := (not LAP) and C_RUNNING
          | RUNNING_103 := left_tt ( RUNNING,C_RUNNING )
          | C_CLK_23_108 := left_tt ( C_CLK_23,C_RUNNING )
          | C_CLK_39_113 := left_tt ( C_CLK_39,C_RUNNING )
          | C_CLK_81 := H and RUNNING_103
          | C_CLK_83 := LAP and C_CLK_39_113
          | C_CLK_85 := LAP and C_CLK_23_108
          | C_CLK_87 := LAP and RUNNING_103
          | C_CLK_90 := C_CLK_81 or C_CLK_83
          | C_CLK_92 := (not C_CLK_83) and C_CLK_81
          | C_CLK_97 := (not C_CLK_90) and C_RUNNING
          |)
       |)
      where 
      boolean LAP, RUNNING, C_CLK_73, C_CLK_77, C_RUNNING, C_CLK_95, C_CLK_99, RUNNING_103, C_CLK_23, C_CLK_23_108, C_CLK_39, C_CLK_39_113, C_CLK_81, C_CLK_83, C_CLK_85, C_CLK_87, C_CLK_90, C_CLK_92, C_CLK_97;
      process ACT_C_RUNNING =
           ( )
         (| when C_RUNNING ^= ZRUNNING ^= DISPLAY_ON ^= ZDISPLAY_ON ^= CNT ^= ZCNT ^= pre_DISPLAY ^= C_CLK_55
          | (| DISPLAY := (CNT when DISPLAY_ON) default (pre_DISPLAY when C_CLK_55)
             | RUNNING := ((not ZRUNNING) when SS) default (ZRUNNING when C_CLK_95)
             | ZRUNNING := RUNNING$1 init false
             | DISPLAY_ON := ((not ZDISPLAY_ON) when C_CLK_87) default (true when C_CLK_85) default (ZDISPLAY_ON when C_CLK_99)
             | ZDISPLAY_ON := DISPLAY_ON$1 init true
             | CNT := (0 when C_CLK_83) default ((ZCNT+1) when C_CLK_92) default (ZCNT when C_CLK_97)
             | ZCNT := CNT$1 init 0
             | pre_DISPLAY := DISPLAY$1 init 0
             | C_CLK_23 := not RUNNING
             | C_CLK_39 := ZDISPLAY_ON and (not RUNNING)
             | C_CLK_55 := not DISPLAY_ON
             |)
          |)
         where 
         integer CNT, ZCNT, pre_DISPLAY;
         boolean ZRUNNING, DISPLAY_ON, ZDISPLAY_ON, C_CLK_55;
         end
      %ACT_C_RUNNING%; 
      end
   %ACT_Tick%; 
   end
%STOPWATCH_SEQ_TRA%; %(| Tick := true when Tick
                       | C_CLK_69 := not SS
                       | C_CLK_71 := not LAP
                       | C_CLK_75 := not H
                       | C_CLK_40 := not (ZDISPLAY_ON and (not RUNNING))
                       |)**WARNING: unused signals 

%
