process STOPWATCH_TRA =
     ( ? event SS, LAP, H;
       ! integer DISPLAY;
     )
   pragmas 
      Main
      Comments "A STOPWATCH is a classical example of system modelized by an automaton."
               "It has two buttons : SS to Start or Stop counting of time, and LAP (intermediate"
               "time) which stops Display without stopping the time counter. A new push on LAP"
               "makes current counter be displayed. Even when displaying is stopped, time counting"
               "may be started/stopped by SS."
               "When time counting is stopped, and display is free, LAP resets the stopwatch."
               "Add a source of time, which is supposed to have a sufficient accuracy. Displayed"
               "values are numbers of pulses of this input signal."
   end pragmas
   (| (| ^SS ^= SS
       | SS ^= SS
       |)
    | (| ^LAP ^= LAP
       | LAP ^= LAP
       |)
    | (| ^H ^= H
       | H ^= H
       |)
    | (| CLK := SS ^+ LAP |)
    | (| CLK_DISPLAY := H ^+ CLK
       | CLK_DISPLAY ^= DISPLAY
       | ACT_CLK_DISPLAY{}
       |)
    | (| CLK_20 := CLK_66 ^- SS |)
    | (| CLK_25 := LAP ^* CLK_22 |)
    | (| CLK_30 := LAP ^* CLK_23 |)
    | (| CLK_32 := CLK_30 ^- CLK_25 |)
    | (| CLK_33 := CLK_25 ^+ CLK_30 |)
    | (| CLK_35 := CLK_DISPLAY ^- CLK_33 |)
    | (| CLK_42 := LAP ^* CLK_39 |)
    | (| CLK_43 := H ^* CLK_22 |)
    | (| CLK_48 := CLK_43 ^- CLK_42 |)
    | (| CLK_49 := CLK_42 ^+ CLK_43 |)
    | (| CLK_51 := CLK_DISPLAY ^- CLK_49 |)
    | (| CLK_66 := LAP ^+ H |)
    |)
   where 
   event CLK_66, CLK_51, CLK_49, CLK_48, CLK_43, CLK_42, CLK_39, CLK_35, CLK_33, CLK_32, CLK_30, CLK_25, CLK_23, CLK_22, CLK_20, CLK_DISPLAY, CLK;
   process ACT_CLK_DISPLAY =
        ( )
      (| CLK_DISPLAY ^= RUNNING ^= ZRUNNING ^= DISPLAY_ON ^= ZDISPLAY_ON ^= CNT ^= ZCNT ^= pre_DISPLAY
       | (| CLK_22 := when RUNNING
          | CLK_23 := when (not RUNNING)
          |)
       | (| CLK_39 := when (ZDISPLAY_ON and (not RUNNING))
          | CLK_40 := when (not (ZDISPLAY_ON and (not RUNNING)))
          |)
       | (| CLK_54 := when DISPLAY_ON
          | CLK_55 := when (not DISPLAY_ON)
          |)
       | (| DISPLAY := (CNT when CLK_54) default (pre_DISPLAY when CLK_55)
          | RUNNING := ((not ZRUNNING) when SS) default (ZRUNNING when CLK_20)
          | ZRUNNING := RUNNING$1 init false
          | DISPLAY_ON := ((not ZDISPLAY_ON) when CLK_25) default (LAP when CLK_32) default (ZDISPLAY_ON when CLK_35)
          | ZDISPLAY_ON := DISPLAY_ON$1 init true
          | CNT := (0 when CLK_42) default ((ZCNT+1) when CLK_48) default (ZCNT when CLK_51)
          | ZCNT := CNT$1 init 0
          | pre_DISPLAY := DISPLAY$1 init 0
          |)
       |)
      where 
      event CLK_55, CLK_54, CLK_40;
      integer CNT, ZCNT, pre_DISPLAY;
      boolean RUNNING, ZRUNNING, DISPLAY_ON, ZDISPLAY_ON;
      end
   %ACT_CLK_DISPLAY%; 
   end
%STOPWATCH_TRA%; 
