

ENABLE_TESTING()

FUNCTION(ADD_MEMORY_TEST DIR)

  SET(COMMAND_TEST java -classpath .:$ENV{SignalLibJava_graphical}/SignalGraphicalJavaStd.jar mainSimu)
  SET(NAME_TEST ${CMAKE_CURRENT_SOURCE_DIR}_TEST_${EXAMPLE_NAME})

  ADD_TEST(NAME ${NAME_TEST}
      WORKING_DIRECTORY "${DIR}" 
      COMMAND ${COMMAND_TEST}
      )
ENDFUNCTION(ADD_MEMORY_TEST)

FUNCTION(COMPILE EXAMPLE_NAME)

IF(NOT EXISTS "$ENV{Signal_bin}")
  MESSAGE("============================================================================")
  MESSAGE("        The variable Signal_bin is not defined...exiting")
  MESSAGE("============================================================================")
  RETURN()
ENDIF(NOT EXISTS "$ENV{Signal_bin}")

SET(SIGNAL_COMPILER $ENV{Signal_bin}/signal)

SET(REF_DIR ${EXAMPLE_NAME})
SET(DIR_TEST  XTEST)

SET(SRC ${EXAMPLE_NAME}.SIG)
SET(PAR ${EXAMPLE_NAME}.PAR)
SET(MOD ${DIR_TEST}/${EXAMPLE_NAME}_body.c)

SET_SOURCE_FILES_PROPERTIES(${MOD} 
  PROPERTIES OBJECT_DEPENDS "${SRC}"
  GENERATED TRUE
  )

ADD_CUSTOM_COMMAND(
    OUTPUT ${MOD}
    COMMAND ${CMAKE_COMMAND} -E echo "Compiling ${EXAMPLE_NAME}.SIG"
    COMMAND ${SIGNAL_COMPILER} ARGS ${SRC} -TRA -c -force -par=${PAR} -D=${DIR_TEST}
    COMMAND ${CMAKE_COMMAND} -E copy ${REF_DIR}/CMakeLists.txt ${DIR_TEST}/CMakeLists.txt
    COMMAND ${CMAKE_COMMAND} -E copy ${REF_DIR}/${EXAMPLE_NAME}_javaC.c ${DIR_TEST}/${EXAMPLE_NAME}_javaC.c
    COMMAND ${CMAKE_COMMAND} -E copy ${REF_DIR}/interfaceCppJava.c ${DIR_TEST}/interfaceCppJava.c
    COMMAND ${CMAKE_COMMAND} -E copy ${REF_DIR}/e${EXAMPLE_NAME}.c ${DIR_TEST}/e${EXAMPLE_NAME}.c
    COMMAND ${CMAKE_COMMAND} -E copy ${REF_DIR}/Simu${EXAMPLE_NAME}.java ${DIR_TEST}/Simu${EXAMPLE_NAME}.java
    COMMAND ${CMAKE_COMMAND} -E copy ${REF_DIR}/mainSimu.java ${DIR_TEST}/mainSimu.java
    COMMAND ${CMAKE_COMMAND} -E copy ${REF_DIR}/frame.txt ${DIR_TEST}/frame.txt
    COMMAND ${CMAKE_COMMAND} -E copy ${REF_DIR}/panel.txt ${DIR_TEST}/panel.txt
    COMMAND ${CMAKE_COMMAND} -E copy ${REF_DIR}/button.txt ${DIR_TEST}/button.txt
    COMMAND ${CMAKE_COMMAND} -E copy ${REF_DIR}/label.txt ${DIR_TEST}/label.txt
    COMMAND ${CMAKE_COMMAND} -E chdir ${DIR_TEST} cmake .
    COMMAND ${CMAKE_COMMAND} -E chdir ${DIR_TEST} make
    COMMAND ${CMAKE_COMMAND} -E echo "Done."
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS ${SRC}
    )

MESSAGE("Target Name= T_${EXAMPLE_NAME}")
ADD_CUSTOM_TARGET(T_${EXAMPLE_NAME} ALL DEPENDS "${MOD}")

ADD_MEMORY_TEST(${CMAKE_CURRENT_SOURCE_DIR}/${DIR_TEST})

ENDFUNCTION(COMPILE EXAMPLE_NAME)

