process PETERSON =
     ( ? event R1, R2, L1, L2;
       ! event A1, A2;
         boolean CS1, CS2;
     )
   (| CLIENT(R1,L1)
    | CLIENT(R2,L2)
    | (A1,A2) := CONTROLEUR(R1,L1,R2,L2)
    | (CS1,CS2) := SECTION_CRITIQUE(A1,L1,A2,L2)
    |)
   where 
   process CONTROLEUR =
        ( ? event R1, L1, R2, L2;
          ! event A1, A2;
        )
      (| D1 := R1 default (not L1) default ZD1
       | ZD1 := D1$1
       | D2 := R2 default (not L2) default ZD2
       | ZD2 := D2$1
       | P := (not A1) default A2 default ZP
       | ZP := P$1
       | H := R1 default L1 default R2 default L2
       | D1 ^= D2 ^= P ^= H
       | C := R1 when R2 when ((not ZD1) and (not ZD2))
       | A1 := (R1 when (not D2)) default (C when ZP) default (L2 when D1)
       | A2 := (R2 when (not D1)) default (C when (not ZP)) default (L1 when D2)
       |)
      where 
      boolean D1, ZD1 init false, D2, ZD2 init false, P, ZP;
      event C, H;
      end
   %CONTROLEUR%; 
   process CLIENT =
        ( ? event R, L;
        )
      (| X := not ZX
       | ZX := X$1
       | R ^= _XMI_Id_4
       | L ^= _XMI_Id_3
       | _XMI_Id_3 := true when ZX
       | _XMI_Id_4 := true when X
       |)
      where 
      _XMI_Id_3, _XMI_Id_4;
      boolean X, ZX init false;
      end
   %CLIENT%; 
   process SECTION_CRITIQUE =
        ( ? event A1, L1, A2, L2;
          ! boolean CS1, CS2;
        )
      (| CS1 := A1 default (not L1) default ZCS1
       | ZCS1 := CS1$1
       | CS2 := A2 default (not L2) default ZCS2
       | ZCS2 := CS2$1
       | CS1 ^= CS2 ^= _XMI_Id_5
       | _XMI_Id_5 := A1 default A2 default L1 default L2
       |)
      where 
      _XMI_Id_5;
      boolean ZCS1 init false, ZCS2 init false;
      end
   %SECTION_CRITIQUE%; 
   end
%PETERSON%; 
