# SynDEx-6.7.5 (C) INRIA 2002-2005, 4/4/2005 09:19:39

# Makefile for application example6

# $(M4) must be the GNU macroprocessor m4
# $(Macros_Path) must be the path to the generic *.m4? macro-files
# $(VPATH) is searched by make for dependent files not found in $(PWD)
VPATH = $(Macros_Path)

.PHONY: example6.all example6.run clean
example6.run : example6.all # load and run example6:
       # (command args = processors in loading order)
	./$(example6.root)



# processor root type=U:
example6.all : root
example6.root += root
example6.root += =langis.irisa.fr
root : root.root.o $(root.libs)
	S=`$(Macros_Path)/rshcd langis.irisa.fr "uname -sr"` ;\
	case $$S in *SunOS*5.*) L='-lsocket -lnsl' ;; esac ;\
	$(Macros_Path)/rshcd langis.irisa.fr $(CC) $(CFLAGS) $^ $$L -lm -o $@
root.%.o : %.c
	$(Macros_Path)/rshcd langis.irisa.fr \
	$(CC) $(CFLAGS) -c $< -o $@ -- $^
root.c : root.m4 syndex.m4x U.m4x C.m4x example6.m4x TCP.m4x 
	$(M4) $< >$@
clean ::
	test -x langis.irisa.fr.mnt && ./langis.irisa.fr.mnt ||\
	$(Macros_Path)/rshcd langis.irisa.fr "\
	$(RM) root root.c root.root.o langis.irisa.fr.mnt"
	$(RM) root root.c root.root.o langis.irisa.fr.mnt


# processor pc1 type=U:
example6.all : pc1
example6.root += pc1
example6.root += =kawa
pc1 : pc1.pc1.o $(pc1.libs)
	S=`$(Macros_Path)/rshcd kawa "uname -sr"` ;\
	case $$S in *SunOS*5.*) L='-lsocket -lnsl' ;; esac ;\
	$(Macros_Path)/rshcd kawa $(CC) $(CFLAGS) $^ $$L -lm -o $@
pc1.%.o : %.c
	$(Macros_Path)/rshcd kawa \
	$(CC) $(CFLAGS) -c $< -o $@ -- $^
pc1.c : pc1.m4 syndex.m4x U.m4x C.m4x example6.m4x TCP.m4x 
	$(M4) $< >$@
clean ::
	test -x kawa.mnt && ./kawa.mnt ||\
	$(Macros_Path)/rshcd kawa "\
	$(RM) pc1 pc1.c pc1.pc1.o kawa.mnt"
	$(RM) pc1 pc1.c pc1.pc1.o kawa.mnt




