/*
   Authors: Loïc Besnard, François Fabre, Thierry Gautier.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - EPL License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony SSME Platform (website: http://www.irisa.fr/espresso/polychrony).

   Polychrony SSME Platform is free software; you can redistribute it and/or modify it under
   the terms of the EPL as published by the Eclipse Foundation.

   Polychrony SSME Platform are distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the Eclipse Public License - v 1.0 for more details.

   You should have received a copy of the Eclipse Public License - v 1.0
   along with Polychrony SSME Platform; see the file COPYING. If not, consult the url
   http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse Foundation, Inc.
   102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
*/

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreePrinter
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreePrinter_init(JNIEnv * env, jobject obj)
{
	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreePrinter
 * Method:    printTree
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreePrinter_printTree(JNIEnv * env, jobject obj, jlong t)
{
  return (jboolean) SignalUnparse((ntrees)t,  SignalExport_announce);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreePrinter
 * Method:    printTreeFile
 * Signature: (ILjava/lang/String;)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreePrinter_printTreeFile(JNIEnv * env, jobject obj, jlong t, jstring filename)
{
  return (jboolean) SignalUnparseFile((ntrees)t, jstring2str(filename, env), undefinedMessage);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreePrinter
 * Method:    setOutputDirectory
 * Signature: (Ljava/lang/String;)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreePrinter_setOutputDirectory(JNIEnv * env, jobject obj, jstring directory)
{
	return (jboolean) sys_set_userOutputDir(jstring2str(directory, env)); 	
}
