/*
   Authors: Loïc Besnard, François Fabre, Thierry Gautier.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - EPL License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony SSME Platform (website: http://www.irisa.fr/espresso/polychrony).

   Polychrony SSME Platform is free software; you can redistribute it and/or modify it under
   the terms of the EPL as published by the Eclipse Foundation.

   Polychrony SSME Platform are distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the Eclipse Public License - v 1.0 for more details.

   You should have received a copy of the Eclipse Public License - v 1.0
   along with Polychrony SSME Platform; see the file COPYING. If not, consult the url
   http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse Foundation, Inc.
   102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
*/

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isAction
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isAction(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isAction((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isBodyTree
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isBodyTree(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isBodyTree((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isConstantDecl
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isConstantDecl(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isConstantDecl((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isEffectiveParameter
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isEffectiveParameter(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isEffectiveParameter((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isExprProc
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isExprProc(JNIEnv * env, jobject obj, jint codeOp)
{
	return (jboolean)STree_isExprProc((int) codeOp);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isExternModel
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isExternModel(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isExternModel((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isFunction
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isFunction(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isFunction((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isIdentEqual
 * Signature: (II)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isIdentEqual(JNIEnv * env, jobject obj, jlong node1, jlong node2)
{
	return (jboolean)STree_isIdentEq((ntrees)node1, (ntrees)node2);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isImplicitTypeTree
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isImplicitTypeTree(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isImplicitTypeTree((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isInDeclList
 * Signature: (II)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isInDeclList(JNIEnv * env, jobject obj, jlong decListNode, jlong idNode)
{
	return (jboolean)STree_isInDeclList((ntrees)decListNode, (ntrees)idNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isInputOutput
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isInputOutput(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isInputOutput((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isInterface
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isInterface(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isInterface((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isList
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isList(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isList((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isLocalDeclList
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isLocalDeclList(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isLocalDeclList((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isModel
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isModel(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isModel((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isModelInList
 * Signature: (II)I
 */
JNIEXPORT jlong JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isModelInList(JNIEnv * env, jobject obj, jlong name, jlong declList)
{
	ntrees *res = NULL;
	if(STree_isModelInList((ntrees) name, (ntrees) declList, res) ) return (jlong) *res;
	return (jlong) ERROR_NODE;
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isModelWithoutParameters
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isModelWithoutParameters(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isModelWithoutParameters((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isModule
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isModule(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isModule((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isModulesList
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isModulesList(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isModulesList((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isNameOfModel
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isNameOfModel(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isNameOfModel((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isNode
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isNode(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isNode((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isOperatorModel
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isOperatorModel(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isOperatorModel((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isParamAtype
 * Signature: (II)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isParamAtype(JNIEnv * env, jobject obj, jlong param, jint rank)
{
	return (jboolean)STree_isParamAtype((ntrees)param, (int)rank);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isParametersOfModel
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isParametersOfModel(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isParametersOfModel((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isPragmas
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isPragmas(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isPragmas((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isPrivateDeclaration
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isPrivateDeclaration(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isPrivateDeclaration((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isProcess
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isProcess(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isProcess((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isSignalDecl
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isSignalDecl(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isSignalDecl((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isSpec
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isSpec(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isSpec((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isTypeDecl
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isTypeDecl(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isTypeDecl((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isUnaryExprProc
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isUnaryExprProc(JNIEnv * env, jobject obj, jint codeOp)
{
	return (jboolean)STree_isUnaryExprProc((int) codeOp);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isUndefinedTree
 * Signature: (I)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isUndefinedTree(JNIEnv * env, jobject obj, jlong node)
{
	return (jboolean)STree_isUndefinedTree((ntrees)node);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeTesting
 * Method:    isTreeEq
 * Signature: (II)Z
 */
JNIEXPORT jboolean JNICALL Java_org_eclipse_pop_ssme_polychrony_SignalTreeTesting_isTreeEq(JNIEnv * env, jobject obj, jlong node1, jlong node2)
{
	return (jboolean)STree_isTreeEq((ntrees)node1, (ntrees)node2);
}
