/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/


GraphManager *pK_GraphManager = new GraphManager ();	///< Predefined graph manager object.


_PRIVATE_
/**
   @return "true" if it exists a triplet (info) with g as graph in the database, "false" otherwise. 
 */
  boolean GraphManager::getEntry (ptDCG g, ptInfoGraph * info)
{
  ptlPointer
    li;
  pointer
    elem;

  li = database;
  while (pk_true)
    {
      if (!ptlPointer_get_elemNext (&li, &elem))
	return pk_false;
      (*info) = (ptInfoGraph) elem;
      if ((*info)->getGraph () == g)
	return pk_true;
    }
  return pk_false;
}

/**
   @return "true" if it exists a triplet (info) with vtree as abstract tree in the database, "false" otherwise. 
 */
boolean
GraphManager::getEntry (pointer vtree, ptInfoGraph * info)
{
  ptlPointer li;
  pointer elem;

  li = database;
  while (pk_true)
    {
      if (!ptlPointer_get_elemNext (&li, &elem))
	return pk_false;
      (*info) = (ptInfoGraph) elem;
      if ((*info)->getProduceFrom () == vtree)
	return pk_true;
    }
  return pk_false;
}
