/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

typedef class booleans2events  *ptbooleans2events ;

class booleans2events
{
#include "booleans2events_g.h"
#include "booleans2events_m.h"

protected:
    ptDCG AGRAPH;    ///< operand graph: the functionality is applied to this graph.
    ptExprManager EM;   ///< operand graph info: expression manager.
    ptClockManager CKM; ///< operand graph info: clock manager.
    ptNodeManager NM;   ///< operand graph info: node manager.

    typeMark vmark;                      ///< local mark.
    boolean rewcond, rewexprel, rewmele; ///< control options
    ptlinstances lsigrew;                ///< list of rewritten signals (to avoid cycles)
    ptlINode metNodes;                   ///< list of visited nodes (to avoid cycles)
    ptinsth the_nullClock_B2E_copy;                       ///< predefined null clock.
};


