/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/**
   @return "true" is x1 and x2 are the same clock (formula in the the same class), "false" otherwise.
 */
virtual boolean /*booleans2events::*/satisfiesClockEq( ptinsth x1 ,ptinsth x2 );

/** @return the clock [vexpcond] ^* vhexpcond
    @param vexpcond: a Signal expression.
    @param vhexpcond: the clock of  the expression vexpcond.
    @param vhns (out): the clock [not vexpcond] ^* vhexpcond.
 */
ptinsth /*booleans2events::*/mksubnosub( ptexpcal vexpcond ,ptinsth vhexpcond ,ptinsth* vhns );

/**
  @return the result of the rewritting of when (vexpcond).
  @param vexpcond  (in) : a default expression (E1 default E2... default En)
  @param vhns (out):  result of the rewritting of when (not vexpcond).
 */
ptinsth /*booleans2events::*/mksubnosubmele( ptexpcal vexpcond ,ptinsth* vhns );

/** @return "true" if the operand expression exp is a recursive one.
   @param exp  (in): assumed to be a synchronous expression.
 */
boolean /*booleans2events::*/isexpsyncrec( ptexpcal exp );

/** @return "true" if the operand expression exp is a recursive one.
   @param exp  (in): assumed to be a DEFAULT expression.
 */
boolean /*booleans2events::*/isexpmelerec( ptexpcal exp );

/** @return "true" if the signal vsig is a recursive one.
   @param vsig  (in): assumed to be a variable expression (signal).
 */
boolean /*booleans2events::*/is_equationrec( ptexpcal vsig );

/** @return "true" if the operand expression vsig is a default expression (direct or it is 
   a signal defined by a default expression).
   @param vsig (in): a signal expression.
 */
boolean /*booleans2events::*/isSignalDefault( ptexpcal vsig );

/** Rewriting.
   It replaces the extraction vhsub by vhsubn and 
   the extraction vhnosub by vhnosubn in the clock system.
   It assumes that vhsub and vhnosubn are build on the same expression (one is positive, the other negative extraction).
 */
void /*booleans2events::*/replaceSubs( ptinsth vhsub ,ptinsth vhsubn ,ptinsth vhnosub ,ptinsth vhnosubn );

/**
  @return 
   - pk_true if the expression EXP with VHEXP as clock is a relationnal expression in normal form
   ( <= or = operator and an order on expressions are used for the normal form).
   - false othewise, the rewritting of the expression is done (in E) and 
      - vhsub is set to the clock [E];
      - vhnosub is set to the clock [not E].
 */
boolean /*booleans2events::*/isRelationalExprNormalForm( ptexpcal exp ,ptinsth vhexp ,ptinsth* vhsub ,ptinsth* vhnosub );

/** Rewriting OR expression. 
    It applies the rules:
      - [e1 or e2] --> [e1] ^+ [e2]
      - [not(e1 or e2)]  --> [not e1] ^* [not e2]

   @param exp  (in) an OR  expression (e1 or e2).
   @param vhexp  (in) the clock of exp.
   @param vhn  (out) the clock [e1] ^+ [e2]
   @param vhnosubn  (out) the clock  [not e1] ^* [not e2]
 */
void /*booleans2events::*/rewor( ptexpcal exp ,ptinsth vhexp ,ptinsth* vhn ,ptinsth* vhnosubn );

/** Rewriting EXCLUSIVE-OR expression.
   It applies the rules:
     - [e1 eor e2] --> ([e1] ^*[not e2]) ^+ ([e2] ^* [not e1])
     - [not(e1 or e2)]  --> ([not e1] ^* [not e2]) ^+ ( [e1] ^* [e2])

   @param exp  (in) an EXCLUSIVE-OR  expression (e1 eor e2). (assumed)
   @param vhexp  (in) the clock of exp.
   @param vhn  (out) the clock ([e1] ^*[not e2]) ^+ ([e2] ^* [not e1]).
   @param vhnosubn  (out) the clock ([not e1] ^* [not e2]) ^+ ( [e1] ^* [e2]). 
 */
void /*booleans2events::*/rewexclusiveor( ptexpcal exp ,ptinsth vhexp ,ptinsth* vhn ,ptinsth* vhnosubn );

/** Rewriting AND expression.
   It applies the rules:
    - [e1 and e2] -->[e1] ^* [e2] 
    - [not(e1 and e2)]  -->[not e1] ^+ [not e2]

   @param exp  (in) an AND  expression (e1 and e2). (assumed)
   @param vhexp  (in) the clock of exp.
   @param vhn  (out) the clock [e1] ^* [e2]
   @param vhnosubn  (out) the clock [not e1] ^+ [not e2]
 */
void /*booleans2events::*/rewand( ptexpcal exp ,ptinsth vhexp ,ptinsth* vhn ,ptinsth* vhnosubn );

/** Rewriting NOT expression. Applying the rule:
       - [not(not e)]  --> [e]

   @param exp  (in) an (assumed) NOT  expression (not e). (assumed)
   @param  vhexp  (in) the clock of exp.
   @param vhsubn the clock when (e).
   @param vhnosubn  (out) the clock when (not e). 
 */
void /*booleans2events::*/rewnot( ptexpcal exp ,ptinsth vhexp ,ptinsth* vhsubn ,ptinsth* vhnosubn );

/**
  Conditionnal rewriting boolean signal.
  @return
  - pk_true if a signal (vsig with vhsig as clock) is "free" (input, delay, produced by an external call), or rewritings are not allowed.
  - false otherwise, in this case (where E denotes the expression of the definition of the signal vsig)
        - vhsubn is the clock "when E"
	- vhnosubn the clock "when (not E)". 
 */
boolean /*booleans2events::*/isFreeSignal( ptexpcal vsig ,ptinsth vhsig ,ptinsth* vhsubn ,ptinsth* vhnosubn );

/** @return 
   - pk_true if the expression exp is an event expression, 
   then vhsub and vhnsub are respectivly set to vhexp and the_hnullClock_B2E_copy.
   false otherwise.
 */
boolean /*booleans2events::*/isConstantExtract( ptexpcal exp ,ptinsth vhexp ,ptinsth* vhsub ,ptinsth* vhnsub );

/**
  Conditionnal rewriting of an expression.
  @return "true" if an expression (exp) with vhexp as clock is free.
  "false" otherwise, in this case the rewriting of the expression is done (depending on some global parameters)
    - nvhsub is the clock that replaces [exp] 
    - nvhnosub the clock that repalces [not exp]

 */
boolean /*booleans2events::*/isFreeCondition( ptexpcal exp ,ptinsth vhexp ,ptinsth* nvhsub ,ptinsth* nvhnosub );

/**
  @return 
    - pk_true if the expression (e) assigned to an (assumed) positive extraction clock (vhsub) is not a free condition.
      In this case, the clock [e] and [not e] are replaced in the system;
    - false otherwise, e is a free condition or rewritings are not allowed.
 */
boolean /*booleans2events::*/applyPositiveExtraction( ptinsth vhsub );

/**
  Initializing rewrittings.
  @param logicalOp  (in) when it is pk_true, logical expressions  are rewritten;
  @param relatOp  (in) when it is pk_true, relational expressions are rewritten;
  @param defaultOp  (in) when it is pk_true, default expressions are rewritten;
 */
void /*booleans2events::*/initrew( boolean logicalOp ,boolean relatOp ,boolean defaultOp );


