/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PUBLIC_
/**
   Constructor.
   The functionality is applied for a graph (g).
*/
assertions2events::assertions2events (ptDCG g):booleans2events (g)
{
}

/**
     Destructor.
*/
_VIRTUAL_
assertions2events::~
assertions2events ()
{
}

/**
   It normalizes boolean expressions declared as assumptions.
   An assumption is a boolean assumed always "true" when it is available.
   @return "true" if such an expression is rewritten, "false" otherwise.
*/
boolean
assertions2events::rewAssertions ()
{
  boolean bresult, somecondrewrite;
  ptinsth vh;
  ptlinsth list;

  initrew (pk_true, pk_true, pk_true);
  makeSynchrosNotImplicatedInAssertions ();
  CKM->setModeSynchroSolving (pk_false);

  lass1 = NILLINSTH;
  lass2 = NILLINSTH;
  bresult = pk_false;

  if (pk_false)
    {
      somecondrewrite = pk_true;
      while (somecondrewrite)
	{
	  somecondrewrite = pk_false;
	  list = CKM->getFormulaList (sub);
	  while (ptlinsth_get_next (&list, &vh))
	    if (rewAssertion (vh))
	      {
		CKM->hclmklequiv (0);
		somecondrewrite = pk_true;
		bresult = pk_true;
	      }
	}
    }
  finalize ();

  return bresult;
}
