/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/**
   It adds to the list of \b cycles, the entry point of the cycle is the top element of the global \b stack.
 */
void /*CircuitCalculus::*/cycleDetected( void );

/**
   @return "false" if a cycle is detected (the node is already in the stack), "true" otherwise.
   If a node (node) is already in the stack, a cycle is detected. It calls the cycleDetected() method
   to produce and add the cycle in the global list (cycles).

   Otherwise, the node is pushed and marked (vmarkpushed).
 */
boolean /*CircuitCalculus::*/push( ptINode node );

/**
   It pops a node (node), assumed to be the top element of the stack, from the stack.
 */
void /*CircuitCalculus::*/pop( ptINode node );

/**
   If a node (node) has not been explored, 
   - it is pushed (push() method): if it is in the stack, a cycle is detected.
   - its successors are visited (recursively)
   - then, it is popped, but it is marked as explored (markexplored mark).       
 */
virtual void /*CircuitCalculus::*/visitNode( ptINode node );

/**
   @return "false" if a cycle is detected (the clock is already in the stack), "true" otherwise.
   If a clock (clk) is already in the stack, a cycle is detected. It calls the cycleDetected() method
   to produce and add the cycle in the global list (cycles).

   Otherwise, the clock is pushed and marked (vmarkpushed).
 */
boolean /*CircuitCalculus::*/push( ptinsth clk );

/**
   It pops a clock (clk), assumed to be the top element of the stack, from the stack.
 */
void /*CircuitCalculus::*/pop( ptinsth clk );

/**
   It applies visitNode() for each element of a list of nodes (lnode).
 */
void /*CircuitCalculus::*/visitNodes( ptlINode lnode );

/**
   For a dependence X->Y of a list of dependences (ld), it applies visitNode() on Y.
 */
void /*CircuitCalculus::*/visitDependences( ptldependence ld );

/**
   It applies visitClock() for each element of a list of clocks (lh).
 */
void /*CircuitCalculus::*/visitClocks( ptlinsth lh );

/**
   If the clock (clk) has not been explored, 
   - it is pushed (push() method): if it is in the stack, a cycle is detected.
   - its successors are visited (recursively)
   - then, it is popped but it is marked as explored (markexplored mark).       
 */
virtual void /*CircuitCalculus::*/visitClock( ptinsth clk );

/**
   When the graph contains cycles, at least one of the list  \b lireached,  \b lhreached is not empty.
   These lists give the entry points of the cycles. A node/clock is in the previous list if 
   it has been reached by at least one of its predecessor but not by all of them.

   This method produces the cycles in a list called \b cycles.
   For the computing, it uses a stack (\b stack) and some marks (\b vmarkpushed, \b vmarkexplored).\n
   It is called by the getCycles() method.

   <b> lireached, lhreached, cycles, stack,vmarkpushed, vmarkexplored </b>  are attribute members of the class.
 */
virtual void /*CircuitCalculus::*/visitReached( void );


