/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/**
   A clock (h) is added to the list of nodes referenced during the greedy algorithm
   but not selected (some of its predecessors are not selected).
 */
void /*CircuitCalculus::*/incrnbEntryPoint( ptinsth h );

/**
  A clock/node  has been selected by the greedy algorithm.
  The associative lptent is updated for a clock (h). The counter is decreased and if the number of treferences
  becomes equal to 0 the entry is removed from the table.
 */
void /*CircuitCalculus::*/decrnbEntryPoint( ptinsth h );

/** It applies incrnbEntryPoint for each clock of a list of clocks (lh)
  */
void /*CircuitCalculus::*/addlinsthfront( ptlinsth lh );

/** It applies incrnbEntryPoint for a node, if it verifies the criteria.
  */
void /*CircuitCalculus::*/addinstrfront( ptINode i );

/** It applies addinstrfront for each node of a list of nodes (li)
  */
void /*CircuitCalculus::*/addlinstrfront( ptlINode li );

/**
   It applies, for each dependence from -> to of a list (ld) the addinstrfront method with "to" as parameter.
 */
void /*CircuitCalculus::*/addlinstrfront( ptldependence ld );

/**
   For a clock (h) 
   - it adds as entry points (referenced node) all successors of the clock,
   - it removes the clock(h) from this set of entry points (it has been visited).
 */
void /*CircuitCalculus::*/clockAction( ptinsth h );

/**
   For a node (i)
   - it adds as entry points (referenced node) all successors of the node,
   - it removes the node from this set of entry points (it has been visited).
 */
void /*CircuitCalculus::*/nodeAction( ptINode i );

/**
   It adds a node (i) in a list (lireached) if the node has not been visited 
   during the greedy algorithm.
 */
void /*CircuitCalculus::*/searchLockedNode( ptINode i ,ptlINode* lireached );

/**
   It applies searchLockedNode() for each node of a list of nodes (li).
 */
void /*CircuitCalculus::*/searchLockedNodes( ptlINode li ,ptlINode* lireached );

/**
   It adds a clock (h) in a list (lhreached) if the clock has not been visited 
   during the greedy algorithm.
 */
void /*CircuitCalculus::*/searchLockedClock( ptinsth h ,ptlinsth* lhreached );

/**
   It applies searchLockedClock() for each clock of a list of clocks (lh).
 */
void /*CircuitCalculus::*/searchLockedClocks( ptlinsth lh ,ptlinsth* lhreached );

/**
   @return "true" if there are some nodes/clocks not visited during the travel of the graph (ie graph contains cycles), 
   "false" otherwise.
   It classifies the list of entry points of cycles (lpent) in two lists: one for the signals (lireached),
   another for clocks (lhreached). \n
   lpent, lireached and lhreached are attribute members of the class.
 */
boolean /*CircuitCalculus::*/existLockedNodes( void );

/**
   @return true if all the nodes of a subgraph (sg) are already visited, "false" otherwise.
 */
boolean /*CircuitCalculus::*/isVisitedSubGraph( ptINode sg );

/** Initial travel of the nodes assigned to the "initial clock".  */
void /*CircuitCalculus::*/graphTravellingInitialClock( void );

/**
  @return "true" if the graph contains cycles, "false" otherwise.
  It initializes the functionality by creating a "traveller of graph" (PARC attribute member of the class) and 
  computes nodes assigned to the "initial clock" (graphTravellingInitialClock() method).
  This traveller object allows to apply to the graph a greedy algorithm that takes into account the dependences of the graph.
  When cycles are detected, the "locked" nodes (resp. clocks) are available in the list lireached (resp. lhreached).\n
  lireached and lhreached are attribute members of the class.
 */
boolean /*CircuitCalculus::*/circuitDetection( void );

/**
   Travelling the nodes/clocks of the current graph in the composed node context (composedNode).
   It calls for each selected element the adequate method nodeProcessing() for a node,  and clockProcessing()
   for a clock.
 */
void /*CircuitCalculus::*/graphTravelling( ptINode composedNode );

/**
   For a node (node):
    - it signals to its successors that it has been selected by the greedy algorithm
    - it applies the specific calculus (nodeAction() method)

    Note that it recalls (recursively) the graphTravelling() method for composed nodes (array of processes, sub-graphs).
 */
virtual void /*CircuitCalculus::*/nodeProcessing( ptINode node );

/**
   For a clock (vclock):
    - it signals to its successors that it has been selected by the greedy algorithm
    - it applies the specific calculus (clockAction method)
 */
virtual void /*CircuitCalculus::*/clockProcessing( ptinsth vclock );


