/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

typedef class ClosureCalculus * ptClosureCalculus;
typedef class CircuitCalculus * ptCircuitCalculus;

#include <map>
class CircuitCalculus 
{
#include "CircuitCalculus_m.h"
#include "CircuitCalculusCycles_i.h"
#include "CircuitCalculus_g.h"
private:
  typedef std::map< ptinsth, integer > entrypointType;
  entrypointType lptent;  ///< Associative table: number of nodes by clock reached by the algorithm but not yet selected.
  ptlINode lireached;        ///< When the greedy algorithm stops: list of nodes referenced  but not selected.
  ptlinsth lhreached;        ///< When the greedy algorithm stops: list of clocks referenced  but not selected.
  ptlPointer cycles;         ///< list of cycles. (step 2 of the algorithm)
  ptlPointer fcycles;         ///< list of false cycles. (step 2 of the algorithm)
  ptStack stack;             ///< stack used to build the  list of cycles (step 2)
  typeMark vmarkexplored;     ///< mark used to build the  list of cycles (step 2)
 protected:
  typeMark vmarkpushed;       ///< mark used to build the  list of cycles (step 2)

protected:
  ptDCG AGRAPH;    ///< the functionality is applied to this graph.
  ptExprManager EM;   ///< operand graph info: expression manager.
  ptClockManager CKM; ///< operand graph info: clock manager.
  ptNodeManager NM;   ///< operand graph info: node manager.

  ptTravelDepManager PARC; ///< graph traveller (greedy algorithm)
  boolean DEBUG_MODE; ///< no comment
};

class ClosureCalculus:public CircuitCalculus
{
#include "ClosureCalculus_m.h"
#include "ClosureCalculusCycles_i.h"
#include "ClosureCalculus_g.h"
private:
  ptlinsth lhclos;
  ptlinstances lexpclos;
};
