/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/**
   It manages the nbMaxIndex attribute member that defines the max number of indices
   used at the same time in the program: nbMaxIndex=max(n,nbMaxIndex).
 */
void /*cGenerator::*/setMaxIndex( int n );

/**
   @return "true" if a node has a list of associated indexes (ls), "false" otherwise.
   The list is synthetized from operators provided for spatial processing.
 */
boolean /*cGenerator::*/getNodeTravelIndex( ptINode node ,ptlinstances* ls );

/**
   @return the term of a type for a named type (t) or t otherwise.
 */
virtual TypeType /*cGenerator::*/GetUnamedType( TypeType t );

/**
   It generates the language key-word for static accessibility.
   Whithout effect when SEPARATE mode is activated or INTERNAL_BLOCK is activated.   
 */
virtual void /*cGenerator::*/genAccessibility( void );

/** 
    It signals that the generator begins a set of declarations.
  */
virtual void /*cGenerator::*/cdebdecl( void );

/** 
    It signals that the generator finalizes a set of declarations. 
 */
virtual void /*cGenerator::*/cfindecl( void );

/**  
     It generates
     - the "local" scope key-word (cGenerator::genAccessibility())
     - the type t without dimensions (cGenerator::genTypeBase())
     - store t as the current type (tprec attribute member)
  */
virtual void /*cGenerator::*/genTypeBeginDeclaration( TypeType t );

/** 
    Generation of the type t without its dimensions.
    - genTypeBase() when functionDeclaration mode is active.
    - genTypeBeginDeclaration() when the generator is initialized for a new declaration or the current type (tprec) is not t
    - the separator of elements for a list of declaration otherwise.
 */
virtual void /*cGenerator::*/gentype( TypeType t );

/**
   It generates the expression (aDim).
   Isolated to allow the specialisation of the generation of dimensions in the declarations.
   Some languages (C) uses the syntax such <em> int x[3] </em>, other ones (Java) uses <em> [3]int x </em>.
 */
virtual void /*cGenerator::*/genDimensionInDeclaration( ptexpcal aDim );

/** 
   Generation of the dimensions of a type (t).
   It calls 
   - genDimensionInDeclaration() for the generation of a dimension.
   - setMaxIndex() to produce the max-number of internal indices useful for array manipulations.
 */
virtual void /*cGenerator::*/genDclDimensions( TypeType TT );

/** 
   Generation of the declaration of the signal exp when it is a node mn of a delay tree.
 */
virtual void /*cGenerator::*/genDclSignalDelayTree( ptexpcal exp ,ptmemnode mn );

/**
  Generation of the declaration of the signal when it is a node NM of a delay tree.
  In this case, the signal is seen as an index on an area.
 */
virtual void /*cGenerator::*/genDclSignalAsIndex( ptmemnode mn );

/**
  Generation of the declaration of the identifier id whose type is t.
 */
virtual void /*cGenerator::*/genIdentDeclaration( ptident id ,TypeType t );

/**
  Generation of the declaration of the signal exp when it is not a node of a delay tree.
 */
virtual void /*cGenerator::*/genSignalDeclaration( ptexpcal exp );

/**
   @return "true" if a signal (exp) is a node of a delay tree, "false" otherwise.
   This method declares an index for the signal (genDclSignalAsIndex()) and declares also the array when it is
   the root of a delay tree (genDclSignalDelayTree()).
   
   \note  when a signal is a node of a delay tree, it will be replaced for the code generation by an access to 
   a global area (array that allows to represent all the signals of the same tree of delays) using a 
   indice to this array.
 */
virtual boolean /*cGenerator::*/genDclTreeDelaySignal( ptexpcal exp );

/**
   Generation of the declaration of a signal (exp) when it is useful.
   It calls genDclTreeDelaySignal() method for a node of a delay tree, genSignalDeclaration() otherwise.
 */
virtual void /*cGenerator::*/genDclSignal( ptexpcal exp );

/**
   Generation of the declarations of the signals of a list of signals (lsig).
 */
virtual void /*cGenerator::*/genDclSignals( ptlinstances lsig );

/**
   Generation of the declaration of a constant (exp) when it is useful 
   and when its type is not a predefined one 
   (for a constant  with a predefined type, a constant is replaced by its value).
 */
virtual void /*cGenerator::*/genConstantDeclaration( ptexpcal exp );

/** 
    Parameters are not generated here for C generator, but in an external file (cGeneratorExtern_* file).
    This method  must be kept for specialisation.
 */
virtual void /*cGenerator::*/genParameters( void );

/** 
    Generation of nb elements of a list of declarations of signals (lst).
    When nb is negative value, all the elements of the list are declared.
  */
virtual void /*cGenerator::*/genIndexLstDeclaration( ptlinstances lst ,int nb );

/**
   Generation of the declarations of the non-substituted parameters and indexes of the graph. 
 */
virtual void /*cGenerator::*/genDclParametersAndIndexes( void );

/** 
    Generation of identifiers for previous value of state variables. 
 */
virtual void /*cGenerator::*/genStateVariables( void );

/**
   It declares a Signal external object (ie separated compiling) taking into account the implementation language (vlang).
   externalObj gives the type of the declared object and vdata the name of the object.
 */
virtual void /*cGenerator::*/genExternalSignalObjectDeclaration( ptrepstr externalObj ,ptrepstr vdata ,ntrees vlang );

/** 
    Generation of identifiers for external Signal objects (Black boxes, Grey Boxes).
    For a reference (node) to an external model, the compiler has associated to it a pragma 
    specifying the name of the entry point and a number to have multi references to the same model in an application.
    These informations are given by getClassAndObjectExternalCall().

    It calls genExternalSignalObjectDeclaration().
    
 */
virtual void /*cGenerator::*/genExternalSignalObjects( ptINode node ,ptlrepstr* lstr );

/** 
    This method generates the declaration of external Signal objects of the graph. 
    These declarations are induced by the use of models (Black boxes, Grey Boxes) that have been 
    separated compiled.
 */
virtual void /*cGenerator::*/genExternalSignalObjects( void );

/**
   It generates the declaration of the "micro step" clock (reserved name) if 
   the graph is an endochronous with an internal clock root.
 */
virtual void /*cGenerator::*/genMicrostepDecl( void );

/**
   Generation of the declarations of the signals and non-substituted parameters of the graph
   (body file).
 */
virtual void /*cGenerator::*/gendeclarationsBody( void );

/**
   Generation of the identifier _id_ where id denotes the identifier of the signal (sig). 
   When star is "true", the indirection operator is generated before the identifier.
   When id cannot be fixed from sig, a name is created with n (sig is the n-th formal paramater).
 */
virtual void /*cGenerator::*/genFormalParameterIdent( ptexpcal sig ,boolean star ,int n );

/**
   Generation of the declaration of a signal (sig) as a formal parameter. 
   @param sig (in) a signal.
   @param isoutput (in) must be "true" for an output parameter, "false" otherwise.
   @param bprintIdent (in) when it is "true", a name is printed.
 */
virtual void /*cGenerator::*/genDclFormalParameter( ptexpcal sig ,boolean isoutput ,boolean bprintIdent ,int n );

/**
   Generation of the declaration of the signals of a list (lsig) as formal parameters.
   It calls genDclFormalParameter() for each of element.
   @param lsig (in) a list of signals.
   @param isoutput (in) must be "true" for an output parameter, "false" otherwise.
   @param bprintIdent (in) when it is "true", a name is printed.
   @param bvirg (in) if "true" the last declaration is completed by the separator of a parameter list.
   @param n (in) the current number of parameters. It is used for creating identifiers (if needed).
   @return n + the size of the list.
 */
virtual int /*cGenerator::*/genDclFormalParameters( ptexpcal lsig ,boolean bvirg ,boolean isoutput ,boolean bprintIdent ,int n );

/** 
   Generation of the hearder of the global/external procedure (or function if asFunc) name with inputs and outputs as formal parameters.
   When ClusterEntry is "false", the name of the formal parameters are the names of the signals of the inputs/outputs lists, otherwise 
   for a signal X of inputs/outputs, the name of the formal parameter is _X_.
 */
virtual boolean /*cGenerator::*/genExternalFunction( ptident nom ,ptexpcal linputs ,ptexpcal loutputs ,boolean asFunc ,boolean ClusterEntry );

/** Generation of the hearder of the global/external procedure or function.
   @return true if the header is generated (false for cast function)
   @param name (in) name of the procedure/function
   @param asFunc (in) at pk_true for a function, pk_false for a procedure.
   @param inputs (in) input formal parameters.
   @param outputs (in) output formal parameters.
   @param ClusterEntry (in) at pk_false, the name of formal parameters are the names of the signals of the inputs/outputs lists,
           otherwise for a signal X of inputs/outputs, the name of the formal parameter is _X_.
   @param declaration (in) at pk_true, the header is completed by the separator of declarations.
 */
virtual boolean /*cGenerator::*/genEntryPoint( ptident name ,ptexpcal inputs ,ptexpcal outputs ,boolean asFunc ,boolean ClusterEntry ,boolean declaration );

/** Generation of the hearder of the procedure name with inputs and outputs as parameters.
   This procedure is an external one if bExternal is "true" or a static one othewise. 
   The header is completed by the separator of declarations if declaration.
 */
virtual void /*cGenerator::*/genEntryPointDeclaration( ptident name ,ptexpcal inputs ,ptexpcal outputs ,boolean declaration ,boolean bExternal );

/**
   It generates the list of internal indices. 
   The number of indices (nbMaxIndex) has been produced by the calls to setMaxIndex().
   - It produces a list of identifiers ( newIndex()) 
   - and calls genIndexLstDeclaration() for the generation of this list.
 */
virtual void /*cGenerator::*/genInternalIndexes( void );

/** 
    Generation of n elements of a list of declarations of signals (l) using genIndexLstDeclaration() 
    as a local declaration in a specific context:
    - INTERNAL_BLOCK is set to "true" to inhibit the generation  of the accessibility attribute (push)
    - genIndexLstDeclaration() is called to generate the n elements of l
    - INTERNAL_BLOCK is reset to its previous value (pop).
 */
virtual void /*cGenerator::*/genLocalIndexLstDeclaration( ptlinstances l ,int n );

/** 
    It assigns a counter for each affine_sample undersampling.
    The identifier is assigned as an attribute of the output signal of the node 
    B := affine_sample{pahse, d} (C).
 */
virtual void /*cGenerator::*/genAffineSampleCounterDeclaration( void );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
virtual void /*cGenerator::*/genUserPragma( ptlpragmas lpragmas ,ptrepstr selectedPragma );

/**
   It generates the user imports using the PRAGMA_CODEGEN_<LANGUAGE>_IMPORT pragma.
 */
virtual void /*cGenerator::*/genUserImports( void );

/**
   It generates the user imports using the PRAGMA_CODEGEN_<LANGUAGE>_DECLARATION pragma.
 */
virtual void /*cGenerator::*/genUserDeclarations( void );


