/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/** @return "true" if a external call must be declared, false otherwise. */
virtual boolean /*cGenerator::*/mustBeDeclared( ptINode aNode );

/**
   @return "true" if the node call node is annotated by the "grey box" pragma, "false" otherwise.
   @param node (in) a node call node.
   @param valPragma (out) the associated grey box pragma.
 */
virtual boolean /*cGenerator::*/isAnnotatedGreyBox( ptINode node ,ptpragma* valPragma );

/**
   @param node (in) a node call node.
   @param valPragma (out) the associated "black box" pragma.
   @return "true" if the Graph of the node call node is annotated by the "black box" pragma, "false" otherwise.
 */
virtual boolean /*cGenerator::*/isAnnotatedBlackBoxGraph( ptINode node ,ptpragma* valPragma );

/**
   @return "true" if it exists some external constants, "false" otherwise.
 */
virtual boolean /*cGenerator::*/TestExternalConstants( void );

/** @return "true" if it exists some external types, "false" otherwise.  */
virtual boolean /*cGenerator::*/TestExternalTypes( void );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*cGenerator::*/getName( ptINode node ,ptident* id );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
ptlINode /*cGenerator::*/UnicityDeclProc( ptlINode l );

/** 
   Generation of  declarations of external functions/procedures of the program.
   It generates a declaration for the node calls annotated by the NOTGREYBOXBLACKBOXREFERENCE attribute. This
   attribute is set in mkListOfBlackGreyBoxesDeclarations() method.
 */
virtual void /*cGenerator::*/genExternalProcedures( void );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
ptlinstances /*cGenerator::*/UnicityDeclFunc( ptlinstances l );

/** 
   Generation of  declarations of external functions/procedures of the program.
 */
virtual void /*cGenerator::*/genExternalFunctions( void );

/**
   Generation of the headers of reading operations.
 */
virtual void /*cGenerator::*/genInputReadFunctions( void );

/**  Generation of  headers of writing operations.
 */
virtual void /*cGenerator::*/genOutputWriteFunctions( void );

/** 
    Generation of  declarations of external constants referenced in the program. 
  */
virtual boolean /*cGenerator::*/genExternalConstants( void );

/**
   It generates the declaration of an (assumed) external type (TT).
 */
virtual void /*cGenerator::*/genExternalType( TypeType TT );

/** 
    Generation of  declarations of external types referenced in the program.
  */
virtual boolean /*cGenerator::*/genExternalTypes( void );

/** Generation of  the declarations of external objects referenced in the program.
    It generates a declaration for the node calls annotated by the NOTGREYBOXBLACKBOXREFERENCE attribute. This
    attribute is set in mkListOfBlackGreyBoxesDeclarations() method.
 */
virtual void /*cGenerator::*/genExternalNodeDeclarations( void );

/** 
   Generation of declarations of external objects (constants, types, function, nodes, i/o operations) 
   Note that some of externals can be undefined; a message is send to the user in this case.
 */
virtual boolean /*cGenerator::*/genExternalDeclarations( void );

/**
   It generates (printincludeBodyheaderFileSeparate()) 
   the import of the header file for each element of the internal list lBlackGreyBoxesDeclarations.
   This list is assumed previously filled by the mkListOfBlackGreyBoxesDeclarations() method.

   For a name <em> foo </em> of lBlackGreyBoxesDeclarations, it generates (C language) the following line:\n
   <em> \#include foo_separate.h </em> \n
   This file <em> foo_separate.h </em> is automaticaly generated when a model (<em>foo </em>) is compiled in separated mode.
 */
virtual void /*cGenerator::*/genGreyBlackBoxesExternalDeclarations( void );

/**
   added to llow the specific declaration of a devired generator( distribution, tasks,...)
 */
virtual void /*cGenerator::*/genSpecifics( void );

/**
   It generates the declaration of external calls in foo_externalsProc.h (foo is the name of the current graph).
   It calls:
   - printdclexternfileProc()  opening file
   - genExternalFunctions()  functions
   - genExternalProcedures() procedures
   - genExternalNodeDeclarations() node calls
   - genGreyBlackBoxesExternalDeclarations() black/grey boxes references (separated compiling of models)
   - genInputReadFunctions() readings
   - genOutputWriteFunctions() writings
   -  closefile() closing file
 */
virtual void /*cGenerator::*/genExternalProcs( void );

/**
   @return "true" if it exists external constants or external types in the graph, "false" otherwise.

   It generates the external constants (genExternalConstants()) and the external types (genExternalTypes())
   of the graph. It is done when TestExternalConstants() or TestExternalTypes(), in the file 
   <em> foo_externalsUNDEF_LIS.h  </em> where foo is the name of the current graph).

   Such a file will contain lines such that:\n
   typedef UNDEF() pointer;
   
   The user must define these externals in <em>  foo_externalsUNDEF.h </em> for compiling the generated code.
 */
virtual boolean /*cGenerator::*/genExternalConstantsTypes( void );

/**
   For each node (n) of lNodes:
   - if the node is a "black box" reference or a "grey box" reference (Signal separated compiling), a pragma is 
   associated with it. This pragma gives the name of the external call to use. This name is added to the attribute member
   (lBlackGreyBoxesDeclarations). This list is explored  by the genGreyBlackBoxesExternalDeclarations() method to generate the
   declaration of such objects.
   - otherwise, n is marked by NOTGREYBOXBLACKBOXREFERENCE (internal attribute). This attribute is referenced in 
   genExternalProcedures() method.
 */
void /*cGenerator::*/mkListOfBlackGreyBoxesDeclarations( ptlINode lNodes );

/**
   It calls mkListOfBlackGreyBoxesDeclarations(ptlINode) for
   - the node calls of the program,
   - the procedure call nodes of the program.

   At the end, the list lBlackGreyBoxesDeclarations contains all the names of the external references to "black boxes" or 
   "grey boxes" models. This list will be explored  by the genGreyBlackBoxesExternalDeclarations() method to generate the
   declaration of such objects.
   
 */
virtual void /*cGenerator::*/mkListOfBlackGreyBoxesDeclarations( void );

/** 
   Entry point of the generation of the external object declarations(constants, types, ...) 
   in the file foo_externals.h
   (where foo is the name of the current graph).
   It calls:
   - mkListOfBlackGreyBoxesDeclarations()
   - genExternalProcs()
   - genExternalConstantsTypes()
   - printdclexternfile()
   - printRefExternalInclude()
   - printRefExternalIncludeProc()
   - closefile()  closing file
 */
virtual void /*cGenerator::*/genExternalDeclarationsFile( void );


