/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/** 
    Generation of the declaration of a signal as a parameter of a read/write function.
    @param InOutSignal (in) a signal
    @param anInput (in) at "true" for a input signal, "false" for an output.
 */
virtual void /*cGenerator::*/genInputOutputParameter( ptexpcal InOutSignal ,boolean anInput );

/**
  Generation of  header declaration or header definition of a read operation.
  @param bdef (in)  when it is pk_true, it implies the generation of the header definition, 
  the generation of the header declaration otherwise.
  @param sig (in) a signal from which one the following text is generated :
  - "extern logical r_foo_SIGNAME(SIGTYPE *SIGNAME);" when not bdef
  - "extern logical r_foo_SIGNAME(SIGTYPE *SIGNAME)" when bdef

  where SIGNAME denotes the name of SIG, and SIGTYPE the type of SIG
 */
virtual void /*cGenerator::*/genReadHeaderExterncall( ptexpcal sig ,boolean bdef );

/**
  Generation of  header declaration or header definition of a write operation.
  @param bdef (in)   when it is pk_true, it implies the generation of the header definition, 
  the generation of the header declaration otherwise.
  @param sig (in) a signal from which one the following text is generated :

  - "extern void w_foo_SIGNAME(SIGTYPE SIGNAME);" when not bdef
  - "extern void w_foo_SIGNAME(SIGTYPE SIGNAME)" when bdef

  where SIGNAME denotes the name of SIG, and SIGTYPE the type of SIG
 */
virtual void /*cGenerator::*/genWriteHeaderExterncall( ptexpcal sig ,boolean bdef );

/**
  It generates the body of the reading function of a signal.
  @param aSig (in) an input signal. 
  \see genReadType
 */
virtual void /*cGenerator::*/genDefReadingSignal( ptexpcal aSig );

/**
  Generation of  the body of the writing function of a signal.
  @param aSig (in) an output signal. 
  \see genWriteType
 */
virtual void /*cGenerator::*/genDefWritingSignal( ptexpcal aSig );

/** Generation of  the "reading function" entry point of a signal. 
   @param aSig (in) a input signal.
 */
virtual void /*cGenerator::*/genDeclAndDefReadingSignal( ptexpcal aSig );

/** Generation of  the "writing function" entry point of a signal. 
   @param aSig (in) a output signal.
 */
virtual void /*cGenerator::*/genDeclAndDefWritingSignal( ptexpcal aSig );

/** 
    It generates the definition of a read instruction for an identifier (ids), taking
    into account a set of fields (fields) and an array context (isArray).

    examples:
    - foo
    - &(*foo).f1.f2 for two fields (f1, f2) and isArray=false.
    - &(*foo).f1.f2 for two fields (f1, f2) and isArray=false.
 */
virtual void /*cGenerator::*/genbodyread( ptident ids ,ptexpcal fields ,boolean isArray );

/** 
    It generates the definition of a write instruction for an identifier (ids), taking
    into account a set of fields (fields).
 */
virtual void /*cGenerator::*/genbodywrite( ptident ids ,ptexpcal addedExp );

/**
   It generates the expansion of the lpart:= rpart in lpart.e1....eN = rpart.f1.....fm  for each field of lpart 
   for a signal of structure type, where
   - e1....eN are given by lfields (optional) 
   - f1.....fm are given by lfieldsdef (optional).
   - t is the the type of lpart.e1....eN.
   It calls genAssignString() for the string type.
 */
virtual void /*cGenerator::*/genReadWriteType( ptexpcal vsig ,ptexpcal addedExp ,TypeType t ,boolean bread );

/** 
   Generation of  reading/writing operations for input/output signals of the program.
   @param ins (in) list of the input nodes.
   @param outs (in) list of the output nodes.
 */
virtual void /*cGenerator::*/genIOReadingWriting( ptlINode ins ,ptlINode outs );

/** 
    Generation of  file descriptor declarations.
    One by input/output node of the program.
 */
virtual void /*cGenerator::*/genIONodesFileDeclarations( ptlINode ln ,boolean InOrOut ,boolean* bfirst );

/**
   Generation of  file descriptor declarations.
   One by input/output signals of the program using the following conventions : 
   for an input X (resp. output), the file descriptor is called "frX" (resp. "fwX")
   @param ins (in) list of the input nodes.
   @param outs (in) list of the output nodes.
 */
virtual void /*cGenerator::*/genIOFileDeclarations( ptlINode ins ,ptlINode outs );

/**
   It generates the closing of the files for input/outputs operations (ln).
   It is a set of reading node, when InOrOut, or writing nodes otherwise.
 */
virtual void /*cGenerator::*/genIONodesClosing( ptlINode ln ,boolean InOrOut );

/**
  Generation of  the entry point Foo_endio().c of the file foo_io.c, where Foo denotes the name
  of the current graph. The definition of this entry is a set of file closing (genIONodesClosing()).
  @param ins (in) list of the input nodes.
  @param outs (in) list of the output nodes.
 */
virtual void /*cGenerator::*/genIOClosing( ptlINode ins ,ptlINode outs );

/**
   It generates the opening of the files for input/outputs operations (ln).
   It is a set of reading node, when InOrOut, or writing nodes otherwise.
 */
virtual int /*cGenerator::*/genIONodesOpeningFiles( ptlINode ln ,boolean InOrOut ,int cpt ,ptident idvcd );

/** 
   Generation of the entry point foo_begio().c of the file foo_io.c. 
   The definition of this entry is a set of file openings (genIONodesOpeningFiles()).
   @param ins (in) list of the input nodes.
   @param outs (in) list of the output nodes.
 */
virtual void /*cGenerator::*/genIOOpening( ptlINode ins ,ptlINode outs );

/**
   It opens the file (foo_io.c) for the code generation of the io module, where foo is the name of the current graph.
 */
virtual void /*cGenerator::*/geniomoduleInit( void );

/**
   It closes the file (foo_io.c), previously opened in geniomoduleInit().
 */
virtual void /*cGenerator::*/geniomoduleFinalize( void );

/**
   It generates the I/O function (where foo is the name of the application):
   - foo_stepIO_begin(); 
   - foo_stepIO_end();
   These functions are called before (resp. after) the foo_iterate().
   It allows to connect the result of a simuilation with a VCD viewer (gtkwave,...)
 */
virtual void /*cGenerator::*/genIOVCDFunctions( void );

/** 
   Entry point of the generating of the i/o module. 
   Code (file declarations, file opening, file closing, i/o operations) is generated  in the file foo_io.c, 
   where foo is the name of the current graph.

   It initializes the io code generation 
   then it genrates 
     - the declaration of the io-files: genIOFileDeclarations()
     - the opening of the io-files for read/write operations : genIOOpening()
     - the closing of the io-files for read/write operations : genIOClosing()
     - the code for each read (input)/write (=output) of the interface of the Signal program: genIOReadingWriting()

   Then it closes the file (foo_io.c).

   \note Conventions: for an input x (resp. output), the attached file is "Rx.dat" (resp. "Wx.dat").

 */
virtual void /*cGenerator::*/geniomodule( void );


