/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

private:

/**
   Specific to the management of the nodes of delay tree.
   It generates the initial value for each indexes assigned to the node MN.
   if i>0, the definition of the index assigned with mn is already generated. This value can be different of the initial value index.
 */
virtual void /*cGenerator::*/genDelayIndexesInit( ptmemnode mn ,int i );

/** 
    It generates the assignment to the bottom value (pk_false) for each signals of a list (lsig) of signals.
    Some particular cases are filtered ( signal marked by BELONG_MEMORY mark is not initialized,
    When a signal is initialized, it is marked by an internal mark (INIT_DONE). 
 */
virtual void /*cGenerator::*/genInitBooleanClocks( ptlinstances lsig );

/**
   It generates the calling to the initialisation of an external object (externalObj), 
   using a data area (vdata), implemented in a specified language (vl).

   Example: for \em foo  value of externalObj, \em myData  value of vdata, it generates:
   - For C language as implementation language, <em>  foo_initialize (&myData); </em>
   - For C++ language as implementation language, <em>  myData.foo_initialize(); </em>
   
   \note
   - If vl is nilstr, C language is used.
   - Such a code is is produced by Polychrony for separated compiling.
   - currently, only C and C++ are allowed as implementation language.
 */
virtual void /*cGenerator::*/genInitSignalNodeCall( ptrepstr externalObj ,ptrepstr vdata ,ptrepstr vl );

/**
   For node (node) referencing a "GreyBox" or "BlackBox" model, it generates (genInitSignalNodeCall()) 
   if it not already done (using lstr list) the calling to the entry point defining of the initialisation of the model.
   It uses the pragma associated with node and the getClassAndObjectExternalCall() for extracting informations of this pragma.

   lstr (out) lstr + the name of the object associated with the node.
 */
virtual void /*cGenerator::*/genInitNodeCall( ptINode node ,ptlrepstr* lstr );

/** 
    It generates the call of the initializing of external referenced graphs.
    The considered nodes are annotated by "GreyBox" or "BlackBox" informations (this code is produced 
    by Polychrony for separated compiling).

    It calls genInitNodeCall() for each node call node and each procedure node call.
 */
virtual void /*cGenerator::*/geninitNodeCall( void );

/**
   This method generates the code of constant signals.
 */
virtual void /*cGenerator::*/genConstantSignals( void );

/**
   @return "true" if a signal (exp) is a node of a delay tree, "false" otherwise.
   For a node of a delay tree, it generates the initialisation (when it is initiliazed) of the signal (exp).
   
   For that, it calls 
   - genAssignDelay()
   - genAssignSynchronous()

   and always calls  genDelayIndexesInit()

   Moreover, the signal (node of a delay tree) exp is added to the list lexp if this node is a Signal delay node. This list
   will be used to generate (genAssignEquivalence()) the equivalences (see note below).

   
   \note When a signal is a node of a delay tree, it will be replaced for the code generation by an access to 
   a global area (array that allows to represent all the signals of the same tree of delays) using a 
   indice to this array.
 */
virtual boolean /*cGenerator::*/genInitTreeDelaySignal( ptexpcal exp ,ptlinstances* lexp );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*cGenerator::*/mustBeInitialized( ptexpcal exp );

/** 
    It generates the initializing of a signal (exp) filtering optimisation attributes.
    It calls genInitTreeDelaySignal() method when exp is a node of a delay tree.
 */
virtual void /*cGenerator::*/genSignalInit( ptexpcal exp );

/** 
    It generates the initializing of the list of signals (lsig).
    It calls genSignalInit() for each of them.
 */
virtual void /*cGenerator::*/genSignalsInit( ptlinstances lsig );

/** 
    This method generates the initializing of the non-substitued parameters.
 */
virtual void /*cGenerator::*/genParameterInit( void );

/** 
    It generates initialisations for the state variables. 
    The initial value of a state variable X is reported to 
    the "X" identifier that denotes the previous value of X (available by AttributeNameGencode attribute).
 */
void /*cGenerator::*/genStatesInit( void );

/**
   It generates the initialisation of each affine_sample undersampling. 
   For such an element (B := affine_sample{pahse, d} (C)), 
   a counter has been assigned, and declared, previously in the genAffineSampleCounterDeclaration() method.
   This counter is initialized here to the phase value. 
 */
virtual void /*cGenerator::*/geninitAffineSample( void );

protected:

/**
   It initialises the generation of the foo_initialize entry point.
   It is isolated to allow specialisations.
 */
virtual void /*cGenerator::*/genInitialisationsInitialise( void );

/**
   It finalizes the generation of the foo_initialize entry point.
   It is isolated to allow specialisations.
 */
virtual void /*cGenerator::*/genInitialisationsFinalyze( void );

/** 
    This method is the entry point of the generation of the initialisations.
    An entry point Foo_initialize(), where Foo denotes the name of the current graph, is generated which contains these initializings
    (parameters, memories, constant signals) and aslo the calls to the initial entry point of node calls.
    
    It calls:
    - genInitialisationsInitialise()
    - genParameterInit()
    - genSignalsInit()
    - genStatesInit()
    - genConstantSignals()
    - geninitNodeCall()
    - geninitAffineSample()
    - genInitBooleanClocks()
    - printcallentrypointstepinitialize()
    - genInitialisationsFinalyze()
 */
virtual void /*cGenerator::*/genInitialisations( void );


