/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#include <vector> ///< from STL
typedef class cGeneratorTasks  *ptcGeneratorTasks; ///< Pointer to a C generator, with tasks, objet.
typedef std::map<ptINode, ptident> TaskNamesTableType;
typedef std::map<ptINode, int> TaskNumberTableType;
class cGeneratorTasks: public cGenerator
{
#include "cGeneratorTasks_m.h"
#include "cGeneratorTasks_g.h"
 protected:
  integer numberOfTasks; ///< number of tasks of the applications (built from the number of clusters+i/o)
  integer SemSynchroEndClusters; ///<  Synchronisation between the last cluster(delay cluster) and the iterate task.
  integer SemTerminationTask; ///<  Synchronisation between the tasks (reads) and the termination task.
  integer SemSynchroMainTask; ///<  Synchronisation between the termination task and the main task.
  integer numberSemaphores; ///<  the number of semaphores used in the generated code.
  integer nbPredIterateTask; //< number of predecessors of the iterate task.
  ptlINode lTasks;  ///< list of the nodes, a task is associated with each of them.
  ptINode delayCluster; ///< the cluster of the memories.
  ptident idScheduler;  ///< the name of the scheduler task.
  ptident idTerminate;  ///< the name of the termination task.
  boolean bTermTaskGen; ///< at true if the termination task must be generated (application has some read).
  std::vector <int> semIniTable; ///< initial value of the semaphores.
  std::vector <ptrepstr> kwOsPrimitives;
  TaskNamesTableType TaskNamesTable;
  TaskNumberTableType TaskNumTable;
};
