/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/**
   It returns the name of a task(node).
   It is assumed that this method is called after calling mkTaskName() that fixes the names of the task.
  */
ptident /*cGeneratorTasks::*/getTaskName( ptINode node );

/**
   it sets a name to a task (n). The unicity of the name is guaranteed.
   Assumed : n is a cluster or an io operation.
 */
void /*cGeneratorTasks::*/mkTaskName( ptINode n );

/**
   It generates the code that signals, to the successors of a task (aTask), the end of its execution.
 */
virtual void /*cGeneratorTasks::*/genEndTask( ptINode aTask );

/**
   It generates the code of a thread. This code has the following form:
   \code
   while(pk_true)
      {
      Wait(); // waiting for the start order.
      specific code of the task;
      Signal(); // signaling to my successors the end of my step.
      }
   \endcode
   \see genEndTask
 */
virtual void /*cGeneratorTasks::*/genCodeTask( ptINode aTask );

/**
   It generates the code for the tasks of the application.
   \see genCodeTask().
 */
virtual void /*cGeneratorTasks::*/genCodeTasks( void );

/**
   It generates the wait of the end of the step for the iterate task.
   If a "delay cluster" exists, the "iterate task" wait for the end of the execution of the
   "delay cluster", otherwise it waits for all the tasks without successors.
 */
virtual void /*cGeneratorTasks::*/genWaitEndOfstep( void );

/**
   Do nothing for the thread generation.
   It is redefined in cGeneratorDist.h class.
 */
virtual void /*cGeneratorTasks::*/genPrintInfosStep( void );

/**
   It generates the foo_iterate() entry point. 
   It is a task. The code has the following form:
   \code
   while(pk_true)
      {
      signals to the clusters without predecessor that they can start their execution
      wait the signal of the "delay cluster" (end of an iterate).
      }
   \endcode  It is a task that
 */
virtual void /*cGeneratorTasks::*/genEntryPointIterate( void );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
virtual void /*cGeneratorTasks::*/genMainTask( void );

/**
   It generates the code of the suspending of the tasks of the application.
 */
virtual void /*cGeneratorTasks::*/genEntryPointSuspend( void );

/**
   It generates the code of the resuming of the tasks of the application.
 */
virtual void /*cGeneratorTasks::*/genEntryPointResume( void );

/** 
    Generation of the entry point FOO_iterate_Task() dynamic scheduler of the program.
 */
virtual void /*cGeneratorTasks::*/genScheduler( void );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
virtual ptlINode /*cGeneratorTasks::*/getTasksToBeGenerated( ptlINode ln );

/**
   Fixing a number to each task, a name to each task.
  */
virtual void /*cGeneratorTasks::*/fixingTaskAttributes( void );

/**
   It defines the number of tasks (\ref cGeneratorTasks#numberOfTasks "numberOfTasks") of the application 
   and it identifies the delay cluster (\ref cGeneratorTasks#delayCluster "delayCluster").

   A number, available by the \ref cGeneratorTasks#taskAttribute "taskAttribute" attribute, is assigned to each cluster.
   - the indexes 0 to numberOfTasks-1 are the clusters of the applications
   - the value numberOfTasks will be associated with the scheduller (iterate).
   \see getTaskNumber().
 */
virtual void /*cGeneratorTasks::*/defineNumberOfTasks( void );

/**
   It defines the number of semaphores useful to define the synchronisations between the tasks of the application.
   There are one semaphore by task (the foo_iterate is a task).

   \note 
   - this method must be called after the defineNumberOfTasks().
   - Currently, the number of semaphores = number of tasks.
 */
virtual void /*cGeneratorTasks::*/defineNumberOfSemaphores( void );

/**
   @returns the number associated with a node (node), the value -1 when it is unknown.
   This number is available after the call to the defineNumberOfTasks() method.
 */
int /*cGeneratorTasks::*/getTaskNumber( ptINode node );

/**
   @return the number of predecessors of a task (node), taking into account the cluster of delays
   (Recall: the dependencies are inverted for the delays).
  */
virtual int /*cGeneratorTasks::*/getNbPredecessorsCluster( ptINode node );

/**
   It computes the initialisations of the semaphores.
   A table semIniTable[numberOfTasks] is used to keep this value.
   
   if semIniTable[i]=m, it specifies that the i-th task has m predecessors.
   For a task without predecessor, the value is set to 1 : it is the scheduller that signals to 
   such a task it can start.

   \note this method must be called after defineNumberOfSemaphores().
 */
virtual void /*cGeneratorTasks::*/initsemaphores( void );

/**
   It prepares the generation of the code of the tasks by
   - defining the number of tasks of the application: defineNumberOfTasks()
   - defining the number of semaphores of the application:defineNumberOfSemaphores()
   - computing the initialisation of each semaphore: initsemaphores()
 */
virtual void /*cGeneratorTasks::*/initGenCodeTasks( void );

/** 
    It generates in the file FOO_Tasks.h the declarations of
    - the number of tasks
    - the tasks
    - the semaphores
    - the headers of the tasks (genTasksHeader()).
 */
virtual void /*cGeneratorTasks::*/genTasksDeclarations( void );

/**
   It generates the code of the application with threads.
   The communications of the application (for distributed code), are generated by the geniomodule() method.
   
   \see {genExternalDeclarationsFile(), dclTypes(), genTasksDeclarations(), genBody(), geniomodule()}
 */
virtual void /*cGeneratorTasks::*/gencode( void );

/**
   It generates the initialisations of the semaphores.
   All the semaphores are initialized to the value 0.
 */
virtual void /*cGeneratorTasks::*/genSemaphoresIni( void );

/**
   It generates the headers of the tasks of the application.
   \see printTaskHeaderDcl()
 */
virtual void /*cGeneratorTasks::*/genTasksHeader( void );

/**
   It generates the code of the creating of the tasks of the application.
   \see printTaskCreate()
 */
virtual void /*cGeneratorTasks::*/genTasksCreate( void );

/**
   It finalizes the generation of the foo_initialize entry point.
 */
virtual void /*cGeneratorTasks::*/genInitialisationsFinalyze( void );

/**
   @copydoc cGenerator::gendeclarationsBody()
   Moreover, it adds the declarations associated with the tasks.
   \see printIncludeTaskDeclarations().
 */
virtual void /*cGeneratorTasks::*/gendeclarationsBody( void );

/**
   It generates the code of a read environment. The thread terminates when the read function returns a "false" value.
   The form of the call is :
   \code
   if (!r_<processName>_<ident1)> (ident2)) pK_Task_exit();
   \endcode
   where ident1(resp. ident2) denotes the identifier of the signal exp (resp. expEff).
   @param exp (in) a signal.
   @param expEff (in) a signal.
   @param processName (in) an identifier.
 */
virtual void /*cGeneratorTasks::*/genCodeReadEnv( ptexpcal exp ,ptident processName ,ptexpcal expEff );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
virtual void /*cGeneratorTasks::*/genCallOsPrimitive( ptrepstr kw );

/**
   It generates the code of the end of the application (termination task). 
   The thread is first waiting until a read function returns a "false" value, in this case the read task send a signal() to
   free this termintion task.
   Then this task cancels the other tasks, before sending a signal() to the main task.
 */
virtual void /*cGeneratorTasks::*/genTerminationTask( void );

/**
   It generates the start entrypoint of the application.
   It assumes the threads/semaphores are created and initialized.
 */
virtual void /*cGeneratorTasks::*/genStart( void );


