/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PUBLIC_
/** Constructor.  */
  cGeneratorTasks::cGeneratorTasks ()
{
  numberOfTasks = 0;		// and nb semaphores
  lTasks = NILLINODE;
  delayCluster = NILINODE;
  nbPredIterateTask = 0;
}

/** Destructor */
_VIRTUAL_ cGeneratorTasks::~cGeneratorTasks ()
{
}


/**
   It generates POSIX threads using semaphores (if the clusters are available).
   A thread is associated with
   - each cluster of the application 
   - each input/output signal of the application,
   - the "iterate" entry point (scheduler).
   
   The code is generated in the same file than the classical code generation. 
   A new file is generared, FOO_tasks.h that contains the headers of the tasks.

   @return "true" if the operation succeeds, "false" otherwise: graph without clusters,...

   \note Keep in mind that the dependences are inverted for the delays.
   \see initGenCodeTasks()
*/
_VIRTUAL_
  boolean
cGeneratorTasks::generate (ptDCG_sch vGraph)
{
  if (nbSets == 1)
    return pk_false;		/*  Without train clusters */
  TextForm = new inteprintc ();
  initialize (vGraph, pk_false, nilstr);
  initGenCodeTasks ();
  gencode ();
  return finalize ();
}
