/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PROTECTED_
/** 
    It generates the definition of a read instruction for an identifier (ids), taking
    into account a set of fields (fields) and an array context (isArray).
*/
  _VIRTUAL_ void
cppGenerator::genbodyread (ptident ids, ptexpcal fields, boolean isArray)
{
  if (fields != NILEXPCAL)
    {
      TextForm->printkwref ();
      TextForm->printLP ();
      if (isArray)
	TextForm->printident (ids);
      else
	{
	  TextForm->printLP ();
	  TextForm->printstar ();
	  TextForm->printident (ids);
	  TextForm->printRP ();
	}
    }
  else
    {
      TextForm->printstar ();
      TextForm->printident (ids);
    }
  if (fields != NILEXPCAL)
    {
      genFieldsList (fields);
      TextForm->printRP ();
    }
}
