/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/** 
    Generation of code for each cluster. Each cluster is a Java thread.
    In separated mode, entry points are generated with parameters, otherwise without parameters ; in this case, 
    the i/o variables are updated by side effect
 */
virtual void /*threadsJavaGenerator::*/genSubGraphs( void );

/** 
    Code generation of the file foo.java, with foo the name of the current graph.
    It generates a part of the declaration of the class foo.

    It calls genBodyClassBegin(), genDclParametersAndIndexes(), 
    genDclrArea(), generateConstructor(), printJavaAreaConstructor(), genBodyClassEnd().
    \code
    The code looks like 
    class foo
    {
         private foo_io _io_;
	 private  KeyboardReader KR = new KeyboardReader();
	 public foo_Area XArea =new foo_Area();
	 
	public foo(){
	     _io_=new foo_io ();
        }

	public foo(foo_Area Xa){
         XArea = Xa;}

	 public void openIO(){
        _io_.foo_OpenIO();
	}

	public void closeIO(){
        _io_.foo_CloseIO();
	}
    \endcode
 */
virtual void /*threadsJavaGenerator::*/genBodyClass( void );

/** 
    Code generation of the file foo.java
    - the entries: foo_initialize(), foo_STEP_initialize(), (genInitialisations())
    - the scheduler (genScheduler())
    - an entry point for each cluster (genSubGraphs()), one thread by cluster.
    - the shared object of the threads are genrated in genClassArea().
 */
virtual void /*threadsJavaGenerator::*/genBodyCode( void );

/** 
    Generation of the Area class that contains the signals of the program shared by the threads.
    \code
    Such a code looks like (foo is the name of the graph)
    class foo_Area{
          public  KeyboardReader KR = new KeyboardReader();
          //  ==> parameters and indexes
          //  ==> input signals     
          public float a, b, c;
          //  ==> output signals
	  public float x2, x1;
	  public boolean error;
	  //  ==> local signals
	  public boolean OK;
	  public float bb, cc, dd, yy, next_yy;
	  public boolean biterate;
	  ...
	  }
     \endcode
 */
virtual void /*threadsJavaGenerator::*/genClassArea( void );

/** 
    Generation of the header of a procedure characterized by its name (name) its inputs (inputs)  and its outputs (outputs).
    This procedure is an external one when bExternal or a static one othewise. 
    It is the declaration when declaration, its definition otherwise.. 
 */
virtual void /*threadsJavaGenerator::*/genEntryPointDeclaration( ptident name ,ptexpcal inputs ,ptexpcal outputs ,boolean declaration ,boolean bExternal );

/** 
    This method generates code for a reference to the subgraph (aSubGraph) when it is a cluster one. 
    Such a reference is a procedure call with or without parameters according to the context 
    given by the parameters blackBox and schedulerTrain: when blackBox="false" or schedulerTrain="true", 
    the procedure is called without parameters. 
 */
virtual void /*threadsJavaGenerator::*/genRefSubGraphNode( ptINode aSubGraph ,boolean blackBox ,boolean schedulerTrain );


