/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PROTECTED_
/**
   It generates the join operator.
   \code
   for name=foo, it generates
   foo.join();
   \endcode   
*/
  _VIRTUAL_ void
inteprintjavathread::printjoin (ptrepstr name)
{
  printstr (name);
  printstr (string2repstr (".join();"));
}

/** 
    It generates the catch operator.
    \code 
    It generates
    catch(InterruptedException ie) {}
    \endcode
*/
_VIRTUAL_ void
inteprintjavathread::printcatchIException ()
{
  printstr (string2repstr ("catch(InterruptedException ie) {} "));
  printLine ();
}

/**
   It generates the try operator (" try { ").
*/
_VIRTUAL_ void
inteprintjavathread::printtry ()
{
  printstr (string2repstr (" try { "));
  printLine ();
}


/** 
    It generates the declaration of the shared memory of the threads (predefined name).
    \code
    public foo_Area XArea ;
    \endcode
 */
_VIRTUAL_ void
inteprintjavathread::genHeaderArea ()
{
  printkwpublic ();
  genAreaName ();
  printstr (string2repstr (" XArea "));
}

/** 
    Generation of the name of the Area class foo_Area (foo is the name of the graph).
    This name is built in t he construtor (inteprintjavathread()).
*/
_VIRTUAL_ void
inteprintjavathread::genAreaName ()
{
  printstr (areaName);
}


/**
   \code
   It generates for name=foo
        try { foo.join();}
	catch(InterruptedException ie) {}
   \endcode
*/
_VIRTUAL_ void
inteprintjavathread::genJoinFunction (ptrepstr name)
{
  printtry ();
  printjoin (name);
  printRBracket ();
  printLine ();
  printcatchIException ();
  printLine ();
}
