/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PROTECTED_

_VIRTUAL_ boolean
ColouringHierarchy::filteredNode (ptINode node)
{
  ptinsth hp, h;
  h = NM->get_nodeClock (node);
  while ( h != rootClock)
    {
      hp = CKM->getFather(h);
      if (hp == h) return pk_true;
      h = hp;
    }
  return pk_false;
}

boolean ColouringHierarchy::filteredClock(ptinsth vh)
{

  ptinsth hp;
  while ( vh != rootClock)
    {
      hp = CKM->getFather(vh);
      if (hp == vh) return pk_true;
      vh = hp;
    }
  return pk_false;
}


/**
   It marks the constraints, assertions and proved equivalent formula  associated with a clock (vh)
*/
  _VIRTUAL_ void
ColouringHierarchy::markConstraintsAndProvedEquiv (ptinsth vh)
{
  // markClass (vh, pk_false);
}


/**
   It marks the  hierarchy with vh as root.
 */
_VIRTUAL_ void
ColouringHierarchy::colouring (ptinsth vh)
{
  ptlinsth lh;
  ptinsth h;

  markClock(vh);
  marklNodes (CKM->getNodesAssignedTo (vh));
  lh = CKM->getChildren (vh);
  while (ptlinsth_get_next (&lh, &h))
    colouring (h);
}

