/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef __CommManager_h__
#define __CommManager_h__

typedef class CommManager *ptCommManager;

class CommManager
{
#include "CommManager_m.h"
#include "CommManager_g.h"

protected:
  ptDCG AGRAPH;    ///< the functionality is applied to this graph.
  ptExprManager EM;   ///< operand graph info: expression manager.
  ptClockManager CKM; ///< operand graph info: clock manager
  ptNodeManager NM;   ///< operand graph info: node manager.
  ptlinstances inputs, outputs;

  ptrepstr vtrEnv, vtrInput, vtrOutput;
 
  boolean error;         ///< error management, set to "true" when an error occured, "false" by default.
  boolean BDEBUG;          ///< internal debugging.
};
		 
#endif
