/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#include "DCG_Fiacre.h"
#include <vector>
#include <set>
#include <map>

typedef class FiacreService *ptFiacreService;

class FiacreService
{
#include "FiacreService_m.h"
#include "FiacreService_g.h"

private:
 ptDCG_poly vDCG;    ///< The DCG Graph
 ptDCG_Fiacre vDCGFiacre; ///< The Fiacre DCG Graph associated with vDCG
 

 ptClockManager CKM; ///< Clock manager of the Graph
 ptExprManager EM;   ///< Expression manager of the Graph
 ptNodeManager NM;   ///< Node Manager of the Graph
 ptNameManager Names; ///> Name manager of the graph.

   ptlinstances inputs, outputs; ///< Resp. the inputs (outputs) of the graph.
 ptrepstr ProcessNameStr; ///< name of the graph.

 ptlINode unNodes; ///< Unused Nodes
 ptlinsth unClocks; ///< Unused Clocks

   boolean bErrCode, bFirstEquation, requireNullClock ;
 ptrepstr codeOp;
 std::map<noperators, ptrepstr> opExprTable;
 std::map<ptinsth, ptlinstances> TableSynchro;
 ntrees vtDefOperators;  /// Fiacre Definition of the Signal operators (expressions).
 ptrepstr vpragmaFiacre;
 ptFiacreShaper shaper;

 ptrepstr clock_operators[6], suffcste, suffcsteFirst, suffcsteSecond, suffcstAll, 
          identityId, preRefInstance, eqClockPrefix;
 ptrepstr operatorTable[SIG_NB_OPERATORS+1];
 ptident idEndOfReaction, idNullClock, idPrefix;
 typeMark FiacreAttr;
};

