/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PUBLIC_ LustrePrinter::LustrePrinter ()
{
  idWhen = string2ident (ID_WHEN_LUSTRE);
  idCurrent = string2ident (ID_CURRENT_LUSTRE);
  idPre = string2ident (ID_PRE_LUSTRE);
  setPrintOptionUnaryWhen (pk_true);	// unary when expression.
}


LustrePrinter::~LustrePrinter ()
{
}


/**
   @copydoc SignalPrinter::fileUnparse
*/
_VIRTUAL_ boolean
LustrePrinter::fileUnparse (ntrees p, ptrepbuf cbuf, ptrepstr unsuffixedFilePathName)
{
  ptrepstr x;

  initPrinter ();
  if (!this_intePrinter->open_bufferMakePathName (cbuf, unsuffixedFilePathName, "lus", &x))
    return pk_false;
  unparse_tree (p, 999999);
  intpriclose ();
  return pk_true;
}
