/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#include "DCG_Sigali.h"

typedef class SigaliService *ptSigaliService;

class SigaliService
{
#include "SigaliService_m.h"
#include "SigaliServiceProperty_i.h"
#include "SigaliServiceParametrizedCode_i.h"
#include "SigaliService_g.h"

private:
 ptDCG_poly vDCG;    ///< The DCG Graph
 ptDCG_Sigali vDCGSigali; ///< The Sigali DCG Graph associated with vDCG

 ptClockManager CKM; ///< Clock manager of the Graph
 ptExprManager EM;   ///< Expression manager of the Graph
 ptNodeManager NM;   ///< Node Manager of the Graph

 boolean notStandard; ///< initialized to false, it becomes "true" when a memory if not specified as waited.
 boolean GdelayOne; ///< initialized to true, it becomes "false" when a delay is not 1 (Restriction).

 ptlINode unNodes; ///< Unused Nodes
 ptlinsth unClocks; ///< Unused Clocks
 ptlINode lproperties; ///< List of the reference to the SIGALI commands (properties to be proved).
 typeMark attributeNumber, refInSigaliCmd ; ///< internal attributes.
 typeMark freeConditionAttr; ///< internal attribute link from free condition, polynomial variable
 ptrepstr ProcessNameStr; ///< name of the graph.
 ptlrepDelay listDelays;/**< List of delays: to each Signal delay, b:= a$1 init b0, is assigned a quadruplets (x, a, ^a, b0). 
			   It is used to produced the equations: x' = a + (1-a²) x, x0= b0, b = a² x. */
 ptlpolynomial listconditions;     ///< list of the conditions.
 ptlpolynomial listconstraints;    ///< list of the constranits
 ptlpolynomial listcontrolables;   ///< list of the controlable variables
 ptlpolynomial listfreeconditions; ///< list of the free conditions
 ptlpolynomial liststatevar;       ///< list of the state variables.
 ptlpolynomial listevolutions;     ///< list of the evolutions
 ptlpolynomial listinit;           ///< list of the initialisations
 ptlpolynomial listvar;            ///< list of the variables
 ptldefpoly listdef;               ///< list of the definitions (identifier, polynomial).

 int numcond;      ///< the translator creates "free conditions"(booleens built on non-boolean expressions): counter of created.
 ptident prefixecond;  ///< the translator creates "free conditions" (booleens built on non-boolean expressions): identifier.
 int numetat;     ///< the translator creates state variables: counter of created.
 ptident prefixeetat;  ///< the translator creates state variables: identifier.

 ptrepstr vstrletat, vstrlcond, vstrlevol, vstrlcont;
 ptrepstr vstrlcondlibres, vstrlinit, vstrlcontr, vstrlvar, vstrdecl;
 boolean  BERROR; ///< error code 

 ptz3zShaper shaper;     ///< Text form shaper for the translator.
 ptrepstr SigaliPragma; ///< name of the SIGALI Pragma in the Signal Library (predefined name).
   
 ptident  vstrsigali, ///<  SIGALI intrinsic function
   vstrcontrollable;   ///<  controllable SIGALI intrinsic function.
};

