/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

typedef class z3zShaper *ptz3zShaper;
#define Z3ZSUFF "z3z"

class z3zShaper
{
#include "z3zShaper_m.h"
#include "z3zShaper_g.h"

private:
 boolean over;        ///< buffer overflow managing.
 ptrepbuf bufferOut; ///< internal buffer.
 int priorityTable[(int) (polySquare) + 1]; ///< Table of the priority of the z3z operators.
 ptrepstr vstrcommand,  ///< string "foo_CMD.z3z", where foo is the name of the compiled process.
   vstrpredefs,   ///< string "Bibli.lib"
   vstrmkp,       ///< string "Creat_SDP.lib"
   vreadstr;      ///< string "read"
 ptrepstr opolydef, ///< string Sigali \e default operator
   opolywhen,       ///< string Sigali \e when operator
   opolyand,        ///< string Sigali \e and operator
   opolyor,         ///< string Sigali \e or operator
   opolynot;        ///< string Sigali \e not operator
};

