/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

/** @return a new list of empty polynomials.  */
extern ptlpolynomial
makePolyList (void)
{
  ptlpolynomial list;

  list = new lpolynomial ();
  list->blist = NILELEMLIST;
  list->elist = NILELEMLIST;
  list->current = NILELEMLIST;
  return list;
}



/** It appends a polynomial (p) at the end of a list (list).*/
extern void
addpolynomial (ptlpolynomial list, ptpolynomial p)
{
  ptelemlist e;

  e = new elemlist ();
  e->elem = p;
  e->next = NILELEMLIST;
  if (list->elist == NILELEMLIST)
    list->blist = e;
  else
    list->elist->next = e;
  list->elist = e;
}

/** It initialises the iterator of the list (list) to the first element. */
extern void
initIteratorListPoly (ptlpolynomial list)
{
  list->current = list->blist;
}

/**
   @return "true" if the travel is finished, "false" otherwise.
   An iterator is previously initialised by initIteratorListPoly().
*/
extern boolean
isEndlistPoly (ptlpolynomial list)
{
  return (boolean) (list->current == NILELEMLIST);
}

/** 
    @return the current element of a list (list), and the iterator is set to the next element.
    An iterator is previously initialised by initIteratorListPoly().
 */
extern ptpolynomial
nextpolynomial (ptlpolynomial list)
{
  ptpolynomial p;

  p = list->current->elem;
  list->current = list->current->next;
  return p;
}
