/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PUBLIC_
/**
   Constructor of an attribute for SigaliGenerator.
   It is initialized by "z3z_undefined" for the mark and undefined (nil) for the polynomial.
*/
  z3zAttribute::z3zAttribute ()
{
  z3marque = z3z_undefined;
  z3poly = NILPOLYNOMIAL;
}

/**
   Destructor.
*/
z3zAttribute::~z3zAttribute ()
{
}

/**
   @return the mark of the current attribute.
*/
z3zMarkType z3zAttribute::getMark ()
{
  return z3marque;
}

/**
   It sets \e m to the mark of the current attribute.
*/
void
z3zAttribute::setMark (z3zMarkType m)
{
  z3marque = m;
}

/**
    @return the polynomial of the current attribute.
*/
ptpolynomial z3zAttribute::getPolynomial ()
{
  return z3poly;
}

/**
   It assigns \e p to the polynomial of the current attribute.
*/
void
z3zAttribute::setPolynomial (ptpolynomial p)
{
  z3poly = p;
}
