/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

/** \todo{ MISSING GLOBAL FILE OR FIRST FUNCTION, API DOCUMENTATION } */

private:

/**
   It assigns an attribute to an expression.
   This attribute is a triplet (the name of the Syndex operator associated with a signal operator, ".o", 
   the index of the current subgraph).
   \see getLanguageOperator(ptexpcal), mkSyndexAttribute() .
 */
virtual void /*DCG2Syndex::*/setReferenceToForOperatorOf( ptexpcal e );

/** 
    Giving the Nth usage of a Signal operator (op).
    @param op (in) the operator of signal.
    @param  Nth (out) the Nth usage of signal operator if the operator is known (declare in the global table OperatorNamesTable).
    @param name (out) the name of the op operator if it exists.
    @return "true" if the operator op is kwnown, "false" otherwise.
 */
virtual boolean /*DCG2Syndex::*/getNewOperatorReference( noperators op ,ptrepstr* name ,int* Nth );

/** 
    @return the number associated with a new usage of an identifier (name).
    It manages the \c ReferenceCountersTable attribute member of the class.
 */
virtual int /*DCG2Syndex::*/getNewNameReference( ptrepstr name );

/**
   @return "true" if a Signal operator is implemented in Syndex for vectors.
   The table is built in TablesInitialize() method.
 */
virtual boolean /*DCG2Syndex::*/isDefinedForVector( noperators op );

/**
   @return "true" if a type (t) is a vector type with size vectorSize, "false" otherwise.
 */
virtual boolean /*DCG2Syndex::*/isVectorType( TypeType t ,ptexpcal* vectorSize );

/**
   @return the Syndex type associated with a Signal type (t). 
   The returned type is different from t 
   - for enumeration; it is replaced by an int type,
   - for an array type; the type of the element is returned.
   
   @param t (in) a signal type of an expression with op as operator.
   @param op (in) a signal operator used only to fix the dim expression. 
   @param dim (out) defined by the size of the vector when it is a vectorial type.
   or by 1 when the type t not a vector one, and an operator (op) is defined for vector.
   @param bLibrary (out) set to pk_true for predefined type, "false" otherwise. For predefined type, it exists a predefined Syndex library
   associated with.   
 */
virtual TypeType /*DCG2Syndex::*/getInfosType( noperators op ,TypeType t ,ntrees* dim ,boolean* bLibrary );

/**
   @return the name of a type. It looks at the table DCG2Syndex::TypeTable initialized in initTypeTable() method.
   For type not defined in the table (user type), it returns the associated name.
 */
virtual ptrepstr /*DCG2Syndex::*/getTypeName( TypeType t );

/** Giving the operator name in syndex.
   @param op (in) the operator name of signal.
   @param t (in) the operator type of signal.
   @param i (out) the Nth operator of signal.
   @param vtype (out) the operator type of syndex (base type when vector)
   @param dim (out) the vector dimension when t is a vector type.
   @param bLibrary (out) at "true" when it exists a "Signal_t" predefined library for the type t, false otherwise.
   @return syndex name.
 */
virtual ptrepstr /*DCG2Syndex::*/getInfosForReferenceDeclaration( noperators op ,TypeType t ,int* i ,ptrepstr* vtype ,ntrees* dim ,boolean* bLibrary );

/** 
    Giving the operator name in syndex.
    @param op (in) the operator name of signal.
    @param ty (in) the operator type of signal.
    @return syndex name+Nth. eg:plus234
 */
virtual ptrepstr /*DCG2Syndex::*/getLanguageOperator( noperators op ,TypeType ty );

/**
   @return the name of the operator associated with the Signal operator (op) for a particular type (ty).
   For a Signal operator (op) of an expression with ty as type, it adds the declaration of the Syndex operator in
   the syndex algorithm. It takes into account the predefined library (signal_TT, for TT a predefined type), and the possible initial values.
   For example, it produces the following declarations:
   - Signal_float/cst<{2.0}> cst_13;
   - Signal_float/Log_ne Log_ne_3;
 */
virtual ptrepstr /*DCG2Syndex::*/getLanguageOperator( noperators op ,TypeType ty ,ntrees initialvalue );

/**
   @return the type (for Syndex) of an expression (vexp)
   (enum type is implemented as int).
 */
virtual TypeType /*DCG2Syndex::*/getTypeOperator( ptexpcal vexp );

/** Giving the operator name in syndex.
   @param vexp (in) the expression of signal.
   @return syndex name+Nth. eg:plus234
 */
virtual ptrepstr /*DCG2Syndex::*/getLanguageOperator( ptexpcal vexp );

/**
   Cell translation:
   It solves the references for each operand of the expression (e) 
   Then it declares and assigns (attribute) a new Cell Syndex operator to the expression (e). 

 */
virtual void /*DCG2Syndex::*/referenceForCell( ptexpcal e ,ptexpcal init ,TypeType type );

/** When translation:
    For Syndex, the translation of a subgraph produces an algorithm 
    that takes into account the condition (condition: c=1).
    So, for E When C expression, the reference is solved for E.
  */
virtual void /*DCG2Syndex::*/referenceForWhen( ptexpcal e );

/** Default translation:
    It solves the references for each operand of the expression (e).
    Then it declares and assigns (attribute) a new default Syndex operator to the expression (e).
 */
virtual void /*DCG2Syndex::*/referenceForDefault( ptexpcal e );

/**
   Constant value expression:
   It declares and assigns (attribute) a new constant Syndex operator to the expression (vexp). 
   The value associated with the constant Syndex operator is produced by the translation of  the constant 
   expression (translateConstantExpression()).

   For enum type, it applied referenceForEnumerate().
 */
void /*DCG2Syndex::*/referenceForConstantExpression( ptexpcal vexp );

/**
   Assumed : vexp is a reference to an enum value (i.e. Type#enumVal).
   It is replaced in Syndex by a int constant, the ordinal of the value in the type.
 */
void /*DCG2Syndex::*/referenceForEnumerate( ptexpcal vexp );

/** Unary expression translation:
    It solves the references for each operand of the expression (vexp).
    Then it declares and assigns (attribute) a new Syndex operator to the expression.
    \note the references to state variable (x?) are filtered. (why?)
 */
void /*DCG2Syndex::*/referenceForUnaryExpression( ptexpcal vexp );

/** Binary expression translation:
    It solves the references for each operand of the expression (vexp).
    Then it declares and assigns (attribute) a new Syndex operator to the expression.

    For enum type, it applied referenceForEnumerate().
 */
void /*DCG2Syndex::*/referenceForBinaryExpression( ptexpcal vexp );

/** Ternary expression translation:
    It solves the references for each operand of the expression (vexp).
    Then it declares and assigns (attribute) a new Syndex operator to the expression.
 */
void /*DCG2Syndex::*/referenceForTernaryExpression( ptexpcal vexp );

/**
   @return a new instance (id_N) of a syndex operator typeSyn/id (or Signal_typeSyn/id).
   This instance is delared in the Syndex program.
 */
ptrepstr /*DCG2Syndex::*/mkDeclarationOperator( ptident id ,ptrepstr typeSyn );

/** function call expression translation:
    It solves the references for each operand of the expression (vexp).
    Then it declares and assigns (attribute) a new Syndex operator to the expression.

    Here, we assume that the "user" will provide the definition of the associated Syndex algorithm of the function.
   \see mkDeclarationOperator
 */
void /*DCG2Syndex::*/referenceForFunctionCallExpression( ptexpcal vexp );

/**
   It declares an external Signal constant (vexp) in the Syndex program.
   The created Syndex operator is assigned (attribute) to the expression.
   
   Here, we assume that the "user" will provide the definition of the associated Syndex algorithm.
   Example: for a undefined parameter n, it declares
   - Signal_int/n n_1;
   \see mkDeclarationOperator
 */
void /*DCG2Syndex::*/declareExternalConstant( ptexpcal vexp );

/**
   For an identifier, constant or parameter, it applied declareExternalConstant() for external one 
   or referenceForEqu() otherwise (i.e. as a signal definition).
   
   For other identifiers (Signals), nothing is done: their references will be replaced by connections 
   from the node where they are produced.
 */
void /*DCG2Syndex::*/referenceForVariable( ptexpcal vexp );

/** List expression translation:
    It solves the references for each operand of the list (vexp).
 */
void /*DCG2Syndex::*/referenceForListExpression( ptexpcal vexp );

/** Expression translation:
    
    It solves the references for each operand of the expression (vexp).
    It declares and assigns (attribute) a new Syndex operator to the expression. Recall that the connection between theses
    operators will be done in a second step.

    Here, we assume that there are Syndex libraries that defines the algorithms of the Signal operators.
    \note enum type available in Signal is translated as int in Syndex.

    It realises a switch according to the operator of an expression (vexp).
    - referenceForVariable()                identifier
    - referenceForConstantExpression()      constant
    - referenceForUnaryExpression()         unary expression
    - referenceForListExpression()          list expression
    - referenceForBinaryExpression()        binary expression 
    - referenceForTernaryExpression()       ternary expression
    - referenceForFunctionCallExpression()  function call 
    - referenceForWhen()       when operator
    - referenceForDefault()   default operator
 */
void /*DCG2Syndex::*/referenceForExpression( ptexpcal vexp );


