/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/**
   Declaration of the references for an equation (vnode), first step of the translation.
   It calls referenceForCell() for a cell. It applies referenceForExpression() on the definition expression.
   An attribute, see mkSyndexAttribute() method, is associated with each visited expression.

   Example:
   \verbatim
   references: 
       Signal_float/Arit_div<1> Arit_div_9;
       Signal_float/Arit_minus<1> Arit_minus_5;
   \endverbatim
    are the references declared for the float expression -(x/y).
 */
virtual void /*DCG2Syndex::*/referenceForEqu( ptINode vnode );

/**
   Declaration of the references for an delay (aNode), first step of the translation.
   An attribute, see mkSyndexAttribute() method, is associated with each visited expression.
  Example:
   \verbatim
   references: 
      Signal_bool/delay<{1};1> delay_1;
   \endverbatim
   are the references declared for a boolean delay <tt> x $ 1 init pk_true </tt>.
 */
virtual void /*DCG2Syndex::*/referenceForDelay( ptINode aNode );

/**
   Specific processing for the outputs (attribute member: \c lwrites) of the current graph defined in the current sub-graph
   and the outputs of the subgraph (attribute member: \c ouputs):
   - For an node of lwrites, it declares a reference to an actuator, 
   and adds the connection from the node that produced the signal to the actuator.

   \verbatim
   references:
      Signal_bool/output<1> output_3;
   dependences:
      strong_precedence_data default_12.o -> output_3.i;
   \endverbatim

   - For an output of the subgraph, it adds the connection from the node that produced the signal to the declared output in the interface.
     \verbatim
       ...
      ! float  x21;

      conditions: C_x_511 = 1;
      references: 
          Signal_float/default<1> default_10;
      dependences:
          strong_precedence_data default_10.o -> x21;
   \endverbatim

   \remarks 
   - The list \c lwrites is updated in referenceSpecialExternalCall().
   - here, some connections are managed.
 */
virtual void /*DCG2Syndex::*/referenceForOutputs( void );

/**
   Declaration of the references for some particular external calls (aNode), first step of the translation. 
   The following intrinsics are treated: \c writeS, \c readS, \c Status (Signal state variable are replaced by such an external).
   For the \c writeS external call, the node is added to the lwrite list (attribute member), 
   and will be treated later (see declareReferences()).
   @return "true" if the external call is treated, "false" otherwise.
   An attribute, see mkSyndexAttribute() method, is associated with each visited expression.
 */
virtual boolean /*DCG2Syndex::*/referenceSpecialExternalCall( ptINode aNode );

/**
   It applies referenceForExpression() for each element of inputs.
   It delares a new Syndex operator built with vLib and name, as UserLibrary/name name_60, or IntrinsicLibrary/name name_60.
   It links (attribute) each signal output, element of outputs, to an output of the model (Syndex node).
 */
virtual void /*DCG2Syndex::*/setCallreference( ptINode n ,ptident name ,ptexpcal lpars ,ptexpcal inputs ,ptexpcal outputs ,ptrepstr vLib );

/**
   Declaration of the references for an external call (aNode), first step of the translation.
   An attribute, see mkSyndexAttribute() method, is associated with each visited expression.
   It calls  referenceSpecialExternalCall() for some particular cases.
   \see setCallreference()
 */
virtual void /*DCG2Syndex::*/referenceForExternalCall( ptINode aNode );

/**
   Internal to referenceForNodeCall().
   Declaration of the references for a reference to a model (aGraph), first step of the translation, 
   with some effective parameters (par),  with some effective inputs (inputs),  with some effective outputs (outputs).
   An attribute, see mkSyndexAttribute() method, is associated with each visited expression.

   For a graph with foo as name, it declares \n
   foo foo1 \n
   in the main Syndex program.
   
 */
virtual ptrepstr /*DCG2Syndex::*/setNodeCallreference( ptDCG aGraph ,ptexpcal par ,ptexpcal inputs ,ptexpcal outputs );

/**
   Declaration of the references for a node call (aNode), first step of the translation.
   An attribute, see mkSyndexAttribute() method, is associated with each visited expression.
   \see setCallreference()
 */
virtual void /*DCG2Syndex::*/referenceForNodeCall( ptINode aNode );

/**
   Declaration of the references for a reference to a subgraph node (aNode), first step of the translation.
   An attribute, see mkSyndexAttribute() method, is associated with each visited expression.
   \see setCallreference()
 */
virtual void /*DCG2Syndex::*/referenceForRefSubGraph( ptINode aNode );

/**
   Declaration of the references for an array node (aNode), first step of the translation.
   An attribute, see mkSyndexAttribute() method, is associated with each visited expression.
   \note Not yet implemented.
 */
virtual void /*DCG2Syndex::*/referenceForArray( ptINode aNode );

/**
   Declaration of the references for a node (aNode), first step of the translation.
   An attribute, see mkSyndexAttribute() method, is associated with each visited expression.

   It switches according to the operator of the node:
   - referenceForEqu()  equation
   - referenceForDelay() delay 
   - referenceForRefSubGraph() subgraph
   - referenceForNodeCall() node call
   - referenceForExternalCall() external call
   - referenceForArray() (array, not implemented)   
 */
void /*DCG2Syndex::*/referenceForNode( ptINode aNode );

/**
   It declares, first step of the translaion, the Syndex operators for a list of nodes (lnodes).
   It calls referenceForNode() for each nodeof the list.
   Then, it calls referenceForOutputs() 
   for a specific processing of the outputs (lwrite attribute member) of the current graph defined in the current sub-graph
   and the outputs of the subgraph (ouputs attribute member).
   \see referenceSpecialExternalCall, referenceForNode.
 */
void /*DCG2Syndex::*/declareReferences( ptlINode lnodes );


