/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#include <map>
#include <vector>

typedef class SyndexTreeInterface *ptinteTreeBuilder;
typedef std::map<ptrepstr, ntrees> SyndexTableType1;
typedef std::map<ptrepstr, ptrepstr> SyndexTableType2;
class SyndexTreeInterface
{
#include "SyndexTreeInterface_m.h"
#include "SyndexTreeInterface_g.h"
#include "SyndexTreeManage_g.h"

protected:
  ntrees tSyndex,tlInclude,tlAlgo,tlBody, tlGroup, tlConstraint, tArchi, tlIncludeDurations, tDefProcessors, tDefMedia;
  ntrees tCurrentInclude,tCurrentAlgo,tCurrentBody;
  ntrees tMainAlgorithm;//the algo for main clock
  ptrepstr StrUndefRunOnGroup, currentAlgoName, mainAlgorithm,stdInputName, stdOutputName, archiName, vstrNoBroadcast, vstrDefaultMediaCommType, vstrDefaultCodePhase;
  SyndexTableType1 PartitionTable;  ///< Associative table for the export of the RunOn partitionning.
  SyndexTableType1 ProcessorTable, MediaTable;///< Table of processors, medias.(definitions of the models)
  SyndexTableType2 ProcessorInstanceTable, MediaInstanceTable;  ///< Table of processors, medias (link models-instances)

};
