/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
   It initializes the current object for the attribute members
   - tCurrentInclude=nil, current include
   - tCurrentAlgo=nil, current algorithm
   - tlInclude=empty list, list of includes
   - tlAlgo = empty list, list of algorithms
   - tSyndex =  the main tree
   - stdInputName="i"
   - stdOutputName= "o"

   It is necessary to call finalize () after the translation and call getresult() to have the result abstract tree.
 */
void /*SyndexTreeInterface::*/initialize( void );

/**
   It finalizes the resulting Syndex program.
   To have the Syndex abtract tree, call getresult() method.
 */
void /*SyndexTreeInterface::*/finalize( ntrees undefGroupConstraint );

/**
   @return the representation of a Syndex identifier named vstr.
 */
ntrees /*SyndexTreeInterface::*/mkSyndexIdent( ptrepstr vstr );

/**
   @return the n-th input/output when binput/not binput.
 */
ptrepstr /*SyndexTreeInterface::*/mkOName( int n );

/**
   @return the n-th input/output when binput/not binput.
 */
ptrepstr /*SyndexTreeInterface::*/mkIName( int n );

/**
   It adds the condition, clockName = value, to the current algorithm.
   \see setCondition
 */
void /*SyndexTreeInterface::*/addCondition( ptrepstr clockName ,int value );

/**
   It adds the pk_true condition to the current algorithm.
   \see setCondition
 */
void /*SyndexTreeInterface::*/addTrueCondition( void );

/**
   It adds the connection, <b> FromNode.outputname -> ToNode.n </b>, to the current alogorithm.
   \see addConnectionSimple
 */
void /*SyndexTreeInterface::*/addConnectionFromToAt( ptrepstr FromNode ,ptrepstr outputname ,ptrepstr ToNode ,int n );

/**
   It adds the connection, <b> FromNode.outputname -> ToNode.inputname </b>, to the current alogorithm.
   \see addConnectionSimple
 */
void /*SyndexTreeInterface::*/addConnectionFromToAt2( ptrepstr FromNode ,ptrepstr outputname ,ptrepstr ToNode ,ptrepstr inputname );

/**
   It adds the connection, <b> FromNode.outputname1 -> ToNode.outputname2 </b>, to the current alogorithm.
   \see addConnectionInMain
 */
void /*SyndexTreeInterface::*/addConnectionFromToAtInMain( ptrepstr FromNode ,ptrepstr outputname1 ,ptrepstr ToNode ,ptrepstr outputname2 );

/**
   It adds the current algorithm (tCurrentAlgo: attribute memebr) to the list of aglorithms (tlAlgo: attribute member).
   It is added at the tail if addPostClock, at the head otherwise.
 */
void /*SyndexTreeInterface::*/addCurrentClock( boolean addPostClock );

/**
   It adds, at the tail, an algorithm (mainAlgoTree) to the list of aglorithms (tlAlgo: attribute member).
 */
void /*SyndexTreeInterface::*/addCurrentAlgoTree( ntrees mainAlgoTree );

/**
   @return the predefined libbrary name, given by the concatenation of 
   SignalIdentPrefix_string name and type.
 */
ptrepstr /*SyndexTreeInterface::*/getPredefinedLibraryName( ptrepstr type );

/**
   It adds a library (type) to the list of includes (tlInclude). Unicity is guaranteed.
 */
void /*SyndexTreeInterface::*/addInclude( ptrepstr type );

/**  
     It declares an input signal characterized by its base type (type) with some possible dimensions (vdim) and its name (name).
 */
void /*SyndexTreeInterface::*/addInput( ptrepstr type ,ntrees vdim ,ptrepstr name );

/**  
   It declares an output signal characterized by its base type (type) with some possible dimensions (vdim) and its name (name).
 */
void /*SyndexTreeInterface::*/addOutput( ptrepstr type ,ntrees vdim ,ptrepstr name );

/**
   @return a new reference of an algorithm (addAlgoName), this reference is declared in the current algorithm.
   \see makeInstSubGraphName, makeTreeReference.
 */
ptrepstr /*SyndexTreeInterface::*/declareAlgorithmInMain( ptrepstr addAlgoName );

/**
   @return the name of a reference (t) defined when the operator of t is opSyndexref, opinport, opoutport.
   Otherwise it returns a predefined error name.
   \verbatim
   Example: for the following reference declaration (t)
      Signal_float/delay<{1.0};1> delay_2;
      it returns delay_2
   \endverbatim
 */
ptrepstr /*SyndexTreeInterface::*/getReferenceName( ntrees t );

/**
   @return the name of the instance associated with a modelName (modelName).
 */
ptrepstr /*SyndexTreeInterface::*/makeInstSubGraphName( ptrepstr modelName );

/**
   It declares a constant in the current algorithm, characterized by its type (treeType), 
   its name (nameCst) and its definition (vtdef).
 */
void /*SyndexTreeInterface::*/mkCstDlc( ntrees treeType ,ptrepstr nameCst ,ntrees vtdef );

/**
   @return a \ref mkSkeletonAlgo() "skeleton abstract tree",  characterized by its name (name) and some parameters (lparam).
 */
ntrees /*SyndexTreeInterface::*/mkSubGraphSkeletonAlgorithm( ptrepstr name ,ntrees lparam );

/** It sets the main algorithm declaration with params as parameters  */
void /*SyndexTreeInterface::*/mkMainAlgorithmDeclaration( ntrees params );

/** create and return an empty list of SynDEx expressions  */
ntrees /*SyndexTreeInterface::*/make_Syndexlexpr_emptyList( void );

/** create and return an empty list of SynDEx parameters  */
ntrees /*SyndexTreeInterface::*/make_lparameters_emptyList( void );

/**
   @return an argument value (sub-term of a declaration of a reference), composed of 
   a initial value (initvaltree), the number of delays (nbdelay), the size for a window (vwindow)
   and a size (vsize) associated with the declared reference.
   The built argument ignores the NILTREE parameters.

   \verbatim
   Example: <{1.0};1> is an argument value in the following reference declaration.
      Signal_float/delay<{1.0};1> delay_2;
   \endverbatim
 */
ntrees /*SyndexTreeInterface::*/mkArgsValues( ntrees initvaltree ,ntrees nbdelay ,ntrees vwindow ,ntrees vsize );

/**
   @return a new reference to a Syndex algorithm. The reference is the abstract tree of the 
   theNthOperation-th reference of a model characterized by its name (name), 
   its type (type), possibly predefined (predefined), and some specific arguments (argsname).
   
   This new reference is added to the current algorithhm (tCurrentBody, attribute member of the class).
   \see makeReferenceType, nameAndNumber.

    \verbatim
    Example: With predefined=true, type = float, name=delay, theNthOperation=2, argsname=<{1.0};1>
    This method declares in the following reference
      Signal_float/delay<{1.0};1> delay_2;
    in the current algorithm.
   \endverbatim
 */
ntrees /*SyndexTreeInterface::*/addReference( boolean predefined ,ptrepstr type ,ptrepstr name ,ptrepstr nameOperation ,ntrees argsname );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
ntrees /*SyndexTreeInterface::*/addReference( boolean predefined ,ptrepstr type ,ptrepstr name ,int theNthOperation ,ntrees argsname );

/**
   It adds a reference without any specific argument.

   @copydoc addReference().
 */
ntrees /*SyndexTreeInterface::*/addReference( boolean predefinedType ,ptrepstr type ,ptrepstr name ,int theNthOperation );

/**
   @return the predefined name for the intrinsic library when  bintrinsic,
   or the predefined name for the User library otherwise.
 */
ptrepstr /*SyndexTreeInterface::*/getLibraryName( boolean bintrinsic );

/** 
    @return the tree that represents an identifier with vname as name.
  */
ntrees /*SyndexTreeInterface::*/makeIdentifier( ptrepstr vname );

/** 
    @return the tree that represents a constant with v as value.
  */
ntrees /*SyndexTreeInterface::*/makeConstant( ptrepstr v );

/** 
    @return the tree that represents a constant with v as value.
  */
ntrees /*SyndexTreeInterface::*/makeConstantInt( int anInt );

/** @return the abstract Syndex atomic tree with op as operator.  */
ntrees /*SyndexTreeInterface::*/mkNullaryTree( noperators op );

/**
   @return the abstract Syndex binary tree op(t1,t2).
 */
ntrees /*SyndexTreeInterface::*/make_SyndexUminus_tree( ntrees t );

/**
   @return the abstract Syndex binary tree op(t1,t2).
 */
ntrees /*SyndexTreeInterface::*/make_SyndexElevec_tree( ntrees t );

/**
   @return the abstract Syndex binary tree op(t1,t2).
 */
ntrees /*SyndexTreeInterface::*/makeBinary( noperators op ,ntrees t1 ,ntrees t2 );

/**
   @return the abstract Syndex list tree p in which elem is added at the tail.
 */
ntrees /*SyndexTreeInterface::*/AddList( ntrees p ,ntrees elem );

/**
   @return the abstract Syndex tree that repretents an int value (val).
 */
ntrees /*SyndexTreeInterface::*/makeAtomInteger( long int val );

/**
   It adds a new element in a group.
   @param grpname (in) the name of the group.
   @param elemGroup (in) the elem group to insert.
 */
void /*SyndexTreeInterface::*/addElemGroup( ptrepstr grpname ,ntrees elemGroup );

/**
   It adds a new element in the undefined group (object without any binding).
   @param grpname (in) the name of the group.
   @param elemGroup (in) the elem group to insert.
 */
void /*SyndexTreeInterface::*/addElemUndefinedGroup( ntrees elemGroup );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
ntrees /*SyndexTreeInterface::*/mkHierarchyreference( ptrepstr operationName ,boolean isInMainClock );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*SyndexTreeInterface::*/addArchiOperator( ptrepstr procModel ,ptrepstr nameProc );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*SyndexTreeInterface::*/addMediaOperator( ptrepstr mediaModel ,ptrepstr nameMedia );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*SyndexTreeInterface::*/addArchiConnection( ptrepstr vproc ,ptrepstr vmedium );


