/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef __OPERSYN__
#define  __OPERSYN__


// If the number of operators is modified, you must update the file $Signal_environment/polychronyLangOperators.h
#include "polychronyLangOperators.h"

#define BaseSyndexOperator LastSMEOperator

// LEAF
#define opSyndexnullary   1

// unused #define opSyndextype    1+BaseSyndexOperator
#define opincltype      2+BaseSyndexOperator
#define opleftdpd       3+BaseSyndexOperator 
#define oprightdpd      4+BaseSyndexOperator
#define opintype        5+BaseSyndexOperator
#define opoutype        6+BaseSyndexOperator
#define opinterfacename 7+BaseSyndexOperator
#define opcdsname       8+BaseSyndexOperator
#define opalgotype      9+BaseSyndexOperator
#define opreftype       10+BaseSyndexOperator
#define oprefname       11+BaseSyndexOperator
#define opalgoname      12+BaseSyndexOperator
// unused #define opnullstring    13+BaseSyndexOperator
#define opdpdtype       14+BaseSyndexOperator
#define opvalue         15+BaseSyndexOperator
#define opSyndexId      16+BaseSyndexOperator
#define opSyndexConstant 17+BaseSyndexOperator

// UNARY
#define opSyndexUnary   101+BaseSyndexOperator

#define opinclude       101+BaseSyndexOperator
#define opparameter	102+BaseSyndexOperator
#define oppararef       103+BaseSyndexOperator
#define opinitvalue     104+BaseSyndexOperator
#define opSyndexUminus  105+BaseSyndexOperator
#define opSyndexElevec  106+BaseSyndexOperator
#define opimportduration 107+BaseSyndexOperator

// BINARY
#define opSyndexBinary  201+BaseSyndexOperator

#define opinport	201+BaseSyndexOperator
#define opoutport	202+BaseSyndexOperator
#define opconds		203+BaseSyndexOperator
#define opinterface	204+BaseSyndexOperator
#define opMainDeclaration 205+BaseSyndexOperator
#define opSyndexPlus      206+BaseSyndexOperator
#define opSyndexMinus     207+BaseSyndexOperator
#define opSyndexMult      208+BaseSyndexOperator
#define opSyndexDivi      209+BaseSyndexOperator
#define opTypeAndDimension 210+BaseSyndexOperator
#define opSyndexGroup      211+BaseSyndexOperator
#define opSyndexConstraint 212+BaseSyndexOperator
#define opRefArchiNode   213+BaseSyndexOperator
#define opArchitecture   214+BaseSyndexOperator
#define opSyndexDefMedia 215+BaseSyndexOperator

// LIST
#define opSyndexList	301+BaseSyndexOperator

#define oplinclude	301+BaseSyndexOperator
#define oplalgo		302+BaseSyndexOperator
#define oplparameters	303+BaseSyndexOperator
#define oplimports	304+BaseSyndexOperator
#define oploutports	305+BaseSyndexOperator
#define oplbody         306+BaseSyndexOperator
#define oplrefs  	307+BaseSyndexOperator
#define opldpds 	308+BaseSyndexOperator
#define opSyndexlexpr 	309+BaseSyndexOperator
#define oplargval       310+BaseSyndexOperator
#define oplgroup        311+BaseSyndexOperator
#define opSyndexProgram 312+BaseSyndexOperator
#define opSyndexElemGroup 313+BaseSyndexOperator
#define oplSyndexConstraint 314+BaseSyndexOperator
#define opSyndexOperators 315+BaseSyndexOperator
#define opSyndexMedias 316+BaseSyndexOperator
#define opSyndexArchiConnections 317+BaseSyndexOperator
#define opSyndexlAttrOperator 318+BaseSyndexOperator
#define opSyndexGates  319+BaseSyndexOperator
#define opldefoperator  320+BaseSyndexOperator
#define opldefmedia  321+BaseSyndexOperator

// TERNARY
#define opSyndexTernary	401+BaseSyndexOperator

#define opalgo		402+BaseSyndexOperator
#define optypename	403+BaseSyndexOperator
#define opbody		404+BaseSyndexOperator
#define opSyndexref	405+BaseSyndexOperator
#define opdpd		406+BaseSyndexOperator
#define opSyndexHierarchy 407+BaseSyndexOperator
#define opDefArchitecture 408+BaseSyndexOperator
#define opSyndexOperator 409+BaseSyndexOperator
#define opSyndexDefOperator 410+BaseSyndexOperator
#define opsynend        411+BaseSyndexOperator

#define SYN_NB_OPERATORS opsynend

#define nmakenullatom_syndex(OPER) natomstring(OPER,nilstr)

#define LL_make_incltype_atom(ARG)       natomstring (opincltype,ARG)
#define LL_make_leftdpd_atom(ARG)        natomstring (opleftdpd,ARG)
#define LL_make_rightdpd_atom(ARG)       natomstring (oprightdpd,ARG)
#define LL_make_intype_atom(ARG)         natomstring (opintype,ARG)
#define LL_make_outype_atom(ARG)         natomstring (opoutype,ARG)
#define LL_make_interfacename_atom(ARG)  natomstring (opinterfacename,ARG)
#define LL_make_cdsname_atom(ARG)        natomstring (opcdsname,ARG)
#define LL_make_algotype_atom(ARG)       natomint (opalgotype,ARG)
#define LL_make_reftype_atom(ARG)        natomstring (opreftype,ARG)
#define LL_make_refname_atom(ARG)        natomstring (oprefname,ARG)
#define LL_make_algoname_atom(ARG)       natomstring (opalgoname,ARG)
#define LL_make_dpdtype_atom(ARG)        natomint (opdpdtype,ARG)
#define LL_make_value_atom(ARG)          natomint (opvalue,ARG)
#define LL_make_SyndexId_atom(ARG)       natomstring (opSyndexId,ARG)
#define LL_make_SyndexConstant_atom(ARG) natomstring (opSyndexConstant,ARG)

// UNARY

#define LL_make_include_tree(ARG)        nmakeunary( opinclude, ARG)
#define LL_make_parameter_tree(ARG)      nmakeunary( opparameter, ARG)
#define LL_make_pararef_tree(ARG)        nmakeunary( oppararef, ARG)
#define LL_make_initvalue_tree(ARG)      nmakeunary( opinitvalue, ARG)
#define LL_make_SyndexUminus_tree(ARG)   nmakeunary( opSyndexUminus, ARG)
#define LL_make_SyndexElevec_tree(ARG)   nmakeunary( opSyndexElevec, ARG)
#define LL_make_importduration_tree(ARG) nmakeunary( opimportduration, ARG)

// BINARY 

#define LL_make_inport_tree(ARG1,ARG2) nmakebinary(opinport,ARG1,ARG2)
#define LL_make_outport_tree(ARG1,ARG2) nmakebinary(opoutport,ARG1,ARG2)
#define LL_make_conds_tree(ARG1,ARG2) nmakebinary(opconds,ARG1,ARG2)
#define LL_make_interface_tree(ARG1,ARG2) nmakebinary(opinterface,ARG1,ARG2)
#define LL_make_MainDeclaration_tree(ARG1,ARG2) nmakebinary(opMainDeclaration,ARG1,ARG2)
#define LL_make_SyndexPlus_tree(ARG1,ARG2) nmakebinary(opSyndexPlus,ARG1,ARG2)
#define LL_make_SyndexMinus_tree(ARG1,ARG2) nmakebinary(opSyndexMinus,ARG1,ARG2)
#define LL_make_SyndexMult_tree(ARG1,ARG2) nmakebinary(opSyndexMult,ARG1,ARG2)
#define LL_make_SyndexDivi_tree(ARG1,ARG2) nmakebinary(opSyndexDivi,ARG1,ARG2)
#define LL_make_TypeAndDimension_tree(ARG1,ARG2) nmakebinary(opTypeAndDimension,ARG1,ARG2)
#define LL_make_SyndexGroup_tree(ARG1,ARG2) nmakebinary(opSyndexGroup,ARG1,ARG2)
#define LL_make_SyndexConstraint_tree(ARG1,ARG2) nmakebinary(opSyndexConstraint,ARG1,ARG2)
#define LL_make_RefArchiNode_tree(ARG1,ARG2) nmakebinary(opRefArchiNode,ARG1,ARG2)
#define LL_make_Architecture_tree(ARG1,ARG2) nmakebinary(opArchitecture,ARG1,ARG2)
#define LL_make_SyndexDefMedia_tree(ARG1,ARG2) nmakebinary(opSyndexDefMedia,ARG1,ARG2)

// LIST

#define LL_make_linclude_emptyList() nmakemptylist(oplinclude)
#define LL_make_lalgo_emptyList() nmakemptylist(oplalgo)
#define LL_make_lparameters_emptyList() nmakemptylist(oplparameters)
#define LL_make_limports_emptyList() nmakemptylist(oplimports)
#define LL_make_loutports_emptyList() nmakemptylist(oploutports)
#define LL_make_lbody_emptyList() nmakemptylist(oplbody)
#define LL_make_lrefs_emptyList() nmakemptylist(oplrefs)
#define LL_make_ldpds_emptyList() nmakemptylist(opldpds)
#define LL_make_Syndexlexpr_emptyList() nmakemptylist(opSyndexlexpr)
#define LL_make_largval_emptyList() nmakemptylist(oplargval)
#define LL_make_lgroup_emptyList() nmakemptylist(oplgroup)
#define LL_make_SyndexProgram_emptyList() nmakemptylist(opSyndexProgram)
#define LL_make_SyndexElemGroup_emptyList() nmakemptylist(opSyndexElemGroup)
#define LL_make_lSyndexConstraint_emptyList() nmakemptylist(oplSyndexConstraint)
#define LL_make_SyndexOperators_emptyList() nmakemptylist(opSyndexOperators)
#define LL_make_SyndexMedias_emptyList() nmakemptylist(opSyndexMedias)
#define LL_make_SyndexArchiConnections_emptyList() nmakemptylist(opSyndexArchiConnections)
#define LL_make_SyndexlAttrOperator_emptyList() nmakemptylist(opSyndexlAttrOperator)
#define LL_make_SyndexGates_emptyList() nmakemptylist(opSyndexGates)
#define LL_make_ldefoperator_emptyList() nmakemptylist(opldefoperator)
#define LL_make_ldefmedia_emptyList() nmakemptylist(opldefmedia)
 
#define LL_make_lbody_list(ARG1) nmakelist(oplbody, ARG1)
#define LL_make_SyndexProgram_list(ARG1) nmakelist(opSyndexProgram, ARG1)
#define LL_make_SyndexlAttrOperator_list(ARG1) nmakelist(opSyndexlAttrOperator, ARG1)

// TERNARY
#define LL_make_algo_tree(ARG1,ARG2,ARG3)              nmaketernary(opalgo,ARG1,ARG2,ARG3)
#define LL_make_typename_tree(ARG1,ARG2,ARG3)          nmaketernary(optypename,ARG1,ARG2,ARG3)
#define LL_make_body_tree(ARG1,ARG2,ARG3)              nmaketernary(opbody,ARG1,ARG2,ARG3)
#define LL_make_Syndexref_tree(ARG1,ARG2,ARG3)         nmaketernary(opSyndexref,ARG1,ARG2,ARG3)
#define LL_make_dpd_tree(ARG1,ARG2,ARG3)               nmaketernary(opdpd,ARG1,ARG2,ARG3)
#define LL_make_SyndexHierarchy_tree(ARG1,ARG2,ARG3)   nmaketernary(opSyndexHierarchy,ARG1,ARG2,ARG3)
#define LL_make_DefArchitecture_tree(ARG1,ARG2,ARG3)   nmaketernary(opDefArchitecture,ARG1,ARG2,ARG3)
#define LL_make_SyndexOperator_tree(ARG1,ARG2,ARG3)    nmaketernary(opSyndexOperator,ARG1,ARG2,ARG3)
#define LL_make_SyndexDefOperator_tree(ARG1,ARG2,ARG3) nmaketernary(opSyndexDefOperator,ARG1,ARG2,ARG3)

/* 
#define opsynend
*/

// The followings are used for reference step, but unused in tree.
#define opretN (LastSyndexOperator+1)
#define opretfen (LastSyndexOperator+2)
#define opcstn (LastSyndexOperator+3)
#endif



