/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PROTECTED_
/**
   This method translates the \Signal description of the architecture to the \Syndex tool.
   Currently, the predefined pragmas Processor, Connexions, Bus are used for the translation.
*/
  void
DCG2Syndex::translateArchitecture ()
{
  ptlpragmas l, lprag;
  ptpragma vpragma;
  ptrepstr first, second;
  ntrees stmts;

  lprag = AGRAPH->getPragmas ();
  l = lprag;
  while (ptlpragmas_get_next (&lprag, &vpragma))
    if (isPragmaKeyword (vpragma, PRAGMA_PROCESSOR_NAME))
      {
	stmts = getPragmaStatement (vpragma);
	first = getPragmaTerm (stmts, 1);
	second = getPragmaTerm (stmts, 2);
	TBI->addArchiOperator (second, first);
      }
    else if (isPragmaKeyword (vpragma, PRAGMA_BUS))
      {
	stmts = getPragmaStatement (vpragma);
	first = getPragmaTerm (stmts, 1);
	second = getPragmaTerm (stmts, 2);
	TBI->addMediaOperator (second, first);
      }
  lprag = l;
  while (ptlpragmas_get_next (&lprag, &vpragma))
    if (isPragmaKeyword (vpragma, PRAGMA_CONNECTION))
      {
	stmts = getPragmaStatement (vpragma);
	first = getPragmaTerm (stmts, 1);
	second = getPragmaTerm (stmts, 2);
	TBI->addArchiConnection (first, second);
      }
}
