/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/


/**
   Constructor of a new Syndex printer.
   By default addArchitecture is set to pk_true(code for architecture will be added).
*/
_PUBLIC_
SyndexPrinter::SyndexPrinter ()
{
}


/**
   Destructor.
*/
SyndexPrinter::~SyndexPrinter ()
{
}


/**
   It prints the textual form of a Syndex tree(trees) in a file (openfilename).
   It calls:
   - openFile() opening the file for printing
   - printPolychronyVersion()  It prints the Polychrony Version
   - printSyndexVersion()      It prints the Syndex Version
   - printTree() the pretty printing of the tree.
   - closeFile() closing the file

   \note The Syndex operators are declared in opersyndex.h file.
*/
void
SyndexPrinter::fileUnparse (ntrees trees, ptrepstr processName)
{
  openFile (processName);
  init ();
  printPolychronyVersion ();
  printSyndexVersion ();
  unparse_subtree (trees);
  finalize ();
  closeFile ();
}
