/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

typedef class DCG2KernelTranslator  *ptDCG2KernelTranslator;

class DCG2KernelTranslator
{
#include "DCG2KernelTranslator_m.h"
#include "DCG2KernelTranslator_g.h"

protected:
  ptDCG_basic AGRAPH;    ///< operand graph: the functionality is applied to this graph.
  ptExprManager EM;   ///< operand graph info: expression manager.
  ptClockManager CKM; ///< operand graph info: clock manager.
  ptNodeManager NM;   ///< operand graph info: node manager.

  ptinsth hinit;       ///< predefined "initial" clock.
  ptident idContext;  ///< Context identifier used as model for auxillary signals.
  ptINode currentNode; ///< the current node during the analyse.
  boolean bachieved; ///< the current status of the transforamtion: "true" when the program is in kernel node, "false" otherwise (restictions).
};


