/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#include <map>
typedef class intemkIGraph *ptintemkIGraph;

class intemkIGraph
{
#include "intemkIGraph_m.h"
#include "intemkIGraph_g.h"
#include "intemkIGraphAffineClock_g.h"

private:
  ptDCG AGRAPH;    ///< operand graph: the functionality is applied to this graph.
  ptExprManager EM;   ///< operand graph info: expression manager.
  ptClockManager CKM; ///< operand graph info: clock manager.
  ptNodeManager NM;   ///< operand graph info: node manager.
  ptNameManager NAMEM; ///< operand graph info: name manager.

  ptinsth hinit, ///< predefined initial clock (for constants)
    the_nullClock_GB_copy,       ///< prefereined null clock
    hundef,       ///< predefined undefined clock
    caseContextClock; ///< the case context clock: used to fix the clock of the constants in the case expressions.

  ptStack labelsStack, ///< Stack of blocks
    clkLabelsStack; ///< Stack of context clock
  ptpragma vRunOn, vGreyBox, vBlackBox; ///< particular pragmas useful for the graph production.
 
  boolean WaitConstantExpr,///< context for expression analysis: must be set to "true" when a constant expression is waited, "false" otherwise.
    AcceptStateVar, ///<  context for expression analysis: must be set to "true" when the references to state variables are allowed, "false" otherwise.
    bodyGraph; ///< array context: "true" for body array compiling, "false" otherwise.

  TypeType UndefinedType; ///< predefined undefined type 

  integer CounterOfExternalProcessReference;///< internal counter giving the number of external call. It is used to repair the "black boxes" of a same "grey box" reference.
  typeMark myMark; ///< internal mark.
  ptsplitting splittingObject; ///< object that offers splitting of the struture/bundle types methods.

  std::map<ptrepstr, ptStack> StackPragmaTables; /// stacks for the management of the pragmas.
    
  boolean automaton_is_clocked; ///< Automaton management. Set to true when the clock of an automaton is fixed (using the intrinsic Automaton_clock()).
  ptinsth automatonClock; ///<  Automaton management. The clock of an automaton, already used as context clock for the constants (trigger of transitions).
  ptexpcal automaton_current_state; ///<  Automaton management. It is the state variable of the current state of the automaton.
  boolean InAutomatonIntrinsicContext; ///< used to no assign a clock to a label used as a name of a state of an automaton.
};
