/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
   Constructor. It is linked with a graph (g).
  */
/*intemkIGraph::*/intemkIGraph( ptDCG g );

/**
   Destructor.
 */
/*intemkIGraph::*/~intemkIGraph( void );

/** @ingroup exprGroup
   It links an expression (assumed to be of the form x[?]),
   to the current index of an array of processes (See getStackArrayNode()). No effect, if there is no array block.

   Note: It is done by an attribute called \e LinkToArrayIndexAttribute.
 */
void /*intemkIGraph::*/linkToCurrentIndexArray( ptexpcal e );

/** @ingroup exprGroup
   @return "true" if a signal (aSig) respects the single assignment, "false" otherwise.
   (Several partial defitions are allowed).
   When an error is detected, the operand tree (vtree) is annotated.
 */
boolean /*intemkIGraph::*/verifyDefSig( ptexpcal aSig ,BackAnnotationType vtree );

/** @ingroup exprGroup
   @return the initial value for a signal (vsig).
   If vinit is 
   - defined, it is the initial value of the signal (ie if there is yet an initial expression associated with the signbal it is replaced by vinit),
   - otherwise, the initial returned value is the current initial value associated with it.
 */
ptexpcal /*intemkIGraph::*/verifAssignInit( ptexpcal vsig ,ptexpcal vinit );

/** @ingroup exprGroup
  @return a new signal with undefined (free) type.
  @param annotTree (in) back attribute to parser abtract tree for error annotations. It can be undefined.
  @param instent (in/out) the created signal is inserted into this list.
 */
ptexpcal /*intemkIGraph::*/mkVariable( BackAnnotationType annotTree ,ptlinstances* instent );

/** @ingroup exprGroup
  @return a new signal with TT as type.
  @param TT (in) the type of the created signal. It can be undefined, in this case, a free type is associated with the created signal.
  @param annotTree (in) back annotation to parser information for error managing.
  @param instent (in/out) the created signal is inserted into this list.
 */
ptexpcal /*intemkIGraph::*/mkVariable( BackAnnotationType annotTree ,TypeType TT ,ptlinstances* instent );

/** @ingroup exprGroup. Structure/bundle managing.
    @return the operand expression (exp).
    If the expression (exp) is
      - an access of a field of a structure (x.Field), it associates (see getSetField() method), if it is not done, a "composed node" associated 
       with the referenced signal (x): the nodes associated with the fields { x.f1, ...,x.fn} are the elements of the "composed node".

      - a list of expressions, this method is applied for each element of the list
    A back attribute to parser abstract tree (vt) can be provided for error annotations.
 */
ptexpcal /*intemkIGraph::*/mkFieldAccess( ptexpcal exp ,BackAnnotationType vt );

/** @ingroup nodeGroup
   @return "true" if the operand signal (vinst) is a "bundle" one, "false" otherwise.
   - for a bundle an input node is created for each field without modification of the interface (see fieldsInputs() method) of the graph.
   in this case this method is called for each element and nRef parameter if the node associated with the "bundle".
   - Otherwise, nRef must be undefined.
   In all the cases, 
    - the returned node (m) is the "input node" associated with the operand signal.
    - it takes into account the differents contexts (see takeIntoAccountContexts()).
 */
boolean /*intemkIGraph::*/addInNode( ptexpcal vinst ,ptINode nRef ,ptINode* m );

/** @ingroup nodeGroup
   It adds a "write" node in the graph for the signal (vinst).
   For a bundle/structured type, it must be called for each sub-signal (see fieldsOutputs()).
   The parameter nRef unused currenly.
 */
ptINode /*intemkIGraph::*/addOutNode( ptexpcal vinst ,ptINode nRef );

/** @ingroup nodeGroup 
    Construction of the input nodes for the signals of the list (list). 
    Assumes these signals are inputs signals of the graph.
    This operation can induce splitting up for bundles.
    Note that the interface of the program is not modified.
    @return none.
 */
void /*intemkIGraph::*/addInNodes( ptlinstances list );

/** @ingroup nodeGroup 
    Construction of the output nodes for the signals of the list (list).
    This operation can induce splitting up for bundles.
    Note that the interface of the program is not modified.
    @return none
 */
void /*intemkIGraph::*/addOutNodes( ptlinstances list );

/** @ingroup nodeGroup 
   It associates to a node (node) the current pragmas (see pragmasContext() method)
   and when the current label node is 
   - a sub graph, it is inserted in the subgraph.
   - an array, it is inserted in the body  sub-graph  or the inital  sub-graph of the array (depends on the bodyGraph boolean context).
   The delay are not inserted in the array node (see addInputArrayNodes()).
 */
void /*intemkIGraph::*/takeIntoAccountContexts( ptINode node );

/** @ingroup nodeGroup
   It creates the definition of a constant (vexpcal) by the expression Edef.
   The associated clock is the predefined "initial" clock.
   A back attribute to parser abstract tree (refTree) for error annotations can be provided.
 */
void /*intemkIGraph::*/createConstantDefinition( ptexpcal vexpcal ,ptexpcal Edef ,BackAnnotationType refTree );

/** @ingroup nodeGroup
   It associates with the node that defined an identifier (expcal1) an element composed of: 
  - expcal2 as expression of definition.
  - vhcal as clock at which the expression expcal2 is used to define the signal expcal1.

  The list of signals (instent) are assumed to be the signals referenced in expcal2: it is used to install dependences.
  A back attribute to parser abstract tree (vtree) for error annotations can be provided.\n
 
  After some verifications about the clock of assigment it calls mkEquation() method.\n
  Some particular cases:
     - the constant definitions are filtered (see createConstantDefinition() method). 
     - the cartesian product operation is processed in mkCartesianProductEquation() method.

  @return the synchronized clock of expcal1 with vhvar.
 */
ptinsth /*intemkIGraph::*/createEquation( ptexpcal expcal1 ,ptexpcal expcal2 ,ptinsth vhcal ,ptinsth vhvar ,ptlinstances instent ,BackAnnotationType vtree );

/** @ingroup nodeGroup
    Add a partial equation. Similar to createEquation().
  */
ptinsth /*intemkIGraph::*/createPartialEquation( ptexpcal expcal1 ,ptexpcal expcal2 ,ptinsth vhcal ,ptinsth vhvar ,ptlinstances instent ,BackAnnotationType vtree );

/** @ingroup nodeGroup
   It associates with the node that defined an identifier (expcal1) an element composed of: 
   - expcal2 as expression of definition.
   - vhcal as clock at which the expression expcal2 is used to define the signal expcal1.

   The list of signals (instent) are assumed to be the signals referenced in expcal2: it is used to install dependences.
   A back attribute to parser abstract tree (vt) for error annotations can be provided.\n
   Here, nothing is said about the clock of the defined signal. 

   The node is not inserted in the graph: it can be used when a signal is defined by a default-like expression (see mkEquation()).
   Then, createEquation() method must be called for the last expression to insert the node in the graph. 
 */
void /*intemkIGraph::*/addSubEquation( ptexpcal expcal1 ,ptexpcal expcal2 ,ptinsth vhcal ,ptlinstances instent ,BackAnnotationType vt );

/** 
    @ingroup nodeGroup
    It creates a delay node (\e zexp := \e exp $ \e delayExp window \e winExp  init \e vinit)
    with vh as clock.
    Note : when the value (d) of the delay and the value of the window (w) are available, and, d=0 and w=1
    an equation node is created.
 */
void /*intemkIGraph::*/mkDelayWindowNode( ptexpcal zexp ,ptexpcal exp ,ptexpcal delayExp ,ptexpcal winExp ,ptexpcal vinit ,ptinsth vh ,BackAnnotationType vtree );

/** @ingroup nodeGroup
   @return "false" if the model (modelName) is the "assert" predefined model, "true" otherwise.
   For the assertion, see AssertionCallNode().
   
   It adds a procedure call node in the graph \e louts := \e modelName { \e lparam } ( \e lins ).
   @param modelName (in)  name of the model,
   @param lparam (in) sets of parameters,
   @param  lins (in)   sets of referenced signals,
   @param louts  (in) sets of produced signals,
   @param vh (in) clock of the node,
   @param code  (in) safety property tag,
   @param vtree  (in)  back annotation to the reference of the model,
   @param modelDecl  (in)  back annotation to the declaration of the model,
   @param  bintrinsic (in) intrinsic model when bintrinsic, 
   @param vn (out) the inserted node (available only when it returns "true").
 */
boolean /*intemkIGraph::*/mkProcCallNode( ptident modelName ,ptexpcal lparam ,ptexpcal lins ,ptexpcal louts ,ptinsth vh ,safetyPropertyType code ,BackAnnotationType vtree ,BackAnnotationType modelDecl ,boolean bintrinsic ,ptINode* vn );

/**
   It sets vr as the current "Run On" pragma.
 */
void /*intemkIGraph::*/setRunOnPragma( ptpragma vr );

/** @ingroup pragmaGroup
   @return the current "Run On" pragma.
 */
ptpragma /*intemkIGraph::*/getRunOnPragma( void );

/** @ingroup pragmaGroup
    It pushes a pragma (vr) in the StackPragmaTables[pragma name of (vr)].
 */
void /*intemkIGraph::*/pushPragma( ptpragma vr );

/** @ingroup pragmaGroup
    It pops a pragma(vr) in the StackPragmaTables[pragma name of (vr)].
 */
void /*intemkIGraph::*/popPragma( ptpragma vr );

/**@ingroup pragmaGroup
   vgb becomes the current "Grey box" pragma, and the 
   counter of external processes (CounterOfExternalProcessReference attribute) is increadsed.
 */
void /*intemkIGraph::*/newGreyBoxPragma( ptpragma vgb );

/** @ingroup pragmaGroup
   vgb becomes the current "Grey box" pragma.
 */
void /*intemkIGraph::*/setGreyBoxPragma( ptpragma vgb );

/** *
    @ingroup pragmaGroup
    @return the current "Grey box" pragma.
 */
ptpragma /*intemkIGraph::*/getGreyBoxPragma( void );

/**
   @ingroup pragmaGroup
   vgb becomes the current "Black box" pragma.
 */
void /*intemkIGraph::*/setBlackBoxPragma( ptpragma vgb );

/**
   @ingroup pragmaGroup
   @return the current "Black box" pragma.
 */
ptpragma /*intemkIGraph::*/getBlackBoxPragma( void );

/**
   vls becomes the current label stack (labelsStack attribute).
  */
void /*intemkIGraph::*/setLabelStack( ptStack vls );

/** @ingroup labelGroup
   @return the current label stack (labelsStack attribute).
  */
ptStack /*intemkIGraph::*/getLabelStack( void );

/**
   @ingroup labelGroup
   It pushes the element (vClk) to  the top of the clock label stack (clkLabelsStack attribute).
 */
void /*intemkIGraph::*/pushContextClock( ptElemStack vClk );

/**
   @ingroup labelGroup
   It pops the clock label stack (clkLabelsStack attribute).
 */
void /*intemkIGraph::*/popContextClock( void );

/**
   @ingroup labelGroup
   @return "true" if the clock label stack is not empty, "false" otherwise.
   @param el (out) the top of the stack.
 */
boolean /*intemkIGraph::*/topContextClock( ptinsth* el );

/**
   @ingroup labelGroup
   @return the clock, if it exists, that is at the top of the clock label stack, or a new one otherwise.
 */
ptinsth /*intemkIGraph::*/getLabelClock( ntrees absTree );

/**
   @ingroup labelGroup
   It pushes 
   - the node (el) associated to a label to the top of the label stack. el is NILINODE for a state of an automaton.
   - and the clock (vClk) to the top of the clock label stack.
 */
void /*intemkIGraph::*/pushLabel( ptINode el ,ptinsth vClk );

/**
   @ingroup labelGroup
   It pops the label stack (labelsStack attribute) and the clock label stack (clkLabelsStack attribute).
 */
void /*intemkIGraph::*/popLabel( void );

/**
   @ingroup labelGroup
   @return the top of the label stack.
 */
boolean /*intemkIGraph::*/topLabel( ptElemStack* el );

/** @ingroup labelGroup
    It pushes an array node (arrayNode) in the "label stack" context.
    and sets the bodyGraph to "false": here, we suppose that the compiler begins to 
    compile the "initial" part of an array of processes.
  */
void /*intemkIGraph::*/pushArray( ptINode arrayNode );

/** @ingroup labelGroup
    Array managing.
    vbody must be at "true" value for the compiling of the body of the array; "false" for the with part.  */
void /*intemkIGraph::*/setCurrentSubgraph( boolean vbody );

/** @ingroup labelGroup
    Pop array/label stack.
 */
void /*intemkIGraph::*/popArray( void );

/** @ingroup pragmaGroup
    It associates the current pragmas (RunOn, Black Box, Grey Box,...) to a node (node).
 */
void /*intemkIGraph::*/pragmasContext( ptINode node );

/** @ingroup pragmaGroup
    @return a new pragma built from another one (aPragma) and with a new "value" given by the current 
    value (or increased if bincr) of the internal counter (CounterOfExternalProcessReference).
    It is used to mark the set of clusters (balck boxes) of a same reference to an external process (seen as a grey box).
 */
ptpragma /*intemkIGraph::*/addIndexForPragma( ptpragma aPragma ,boolean bincr );

/**
   @ingroup labelGroup
   clk becomes the case context clock. It is used to fix the clock of the constants in the case expressions.
 */
ptinsth /*intemkIGraph::*/pushCaseContextClock( ptinsth clk );

/**
   @ingroup labelGroup
   clk becomes the case context clock. It is used to fix the clock of the constants in the case expressions.
 */
ptinsth /*intemkIGraph::*/getCaseContextClock( void );

/**
   @ingroup clockGroup
   @return the clock obtained by the synchronisation of
   - the clock with a free part vh1
   - the clock vh2 with a free part if locfree is pk_true.
 */
ptinsth /*intemkIGraph::*/instop2syncfree( ptinsth vhcste ,ptinsth vh1 ,ptinsth vh2 ,boolean locfree );

/** @ingroup clockGroup
    @return the clock of a signal (vsig). This clock is created if it does not exist.
  */
ptinsth /*intemkIGraph::*/mkClockInstance( ptexpcal vsig );

/** @ingroup clockGroup
   If the clock of the signal (vinstance) is undefined, a new clock is associated with it, otherwise it is unchanged.
   The clock of a index, parameter, constant is undefined.
   @return the clock of the operand identifier.
 */
ptinsth /*intemkIGraph::*/setClockVariable( ptexpcal vinstance );

/** 
    @ingroup clockGroup
    It associates to a clock (vh) the current pragmas.
 */
void /*intemkIGraph::*/takeIntoAccountContexts( ptinsth vh );

/**
   @ingroup clockGroup
   @return the clock of an identifier (vexpcal) assumed to be 
       - a signal, parameter, index, label, state variable
       - or a reference to a field of a structure,
       - or a reference to an element of an array.
  using a context clock (vhcste) combined with context mode (isfree) for fixing this clock for state variable and index.
  The list of signals (l) is completed with the identifier when it is a signal or a label.
 */
ptinsth /*intemkIGraph::*/getSetIdClock( ptexpcal vexpcal ,boolean* isfree ,ptinsth vhcste ,BackAnnotationType vt ,ptlinstances* l );

/** 
    @ingroup clockGroup
    It associates a clock (vh) to a signal (vinstance).
    @return the clock of the signal.
    If the identifier (vinstance) is
    - a constant, the clock is the predefined "initial" clock.
    - a state variable, the clock is the predefined fictitious root.
    - otherwise, if the clock (vh) is 
       - undefined, or the signal (vinstance) is currently defined by a partial expression (isPartialDefinitionOf() method), 
       it is defined by setClockVariable() method.
       - otherwise, a synchronisation is added between the clock of the signal and the operand clock (vh).
 */
ptinsth /*intemkIGraph::*/getSignalClockSynchronizedWith( ptexpcal vinstance ,ptinsth vh );

/**  @ingroup clockGroup
     @return the clock of the synchronisation of a list (l) of signals.  */
ptinsth /*intemkIGraph::*/synchronizeIdentifiers( ptlinstances l );

/**  @ingroup clockGroup
     @return the upper bound of the clocks of the signals of a list (l).  */
ptinsth /*intemkIGraph::*/upperBoundClockOfIdentifiers( ptlinstances l );

/** @ingroup globalProcessinGroup
   For each node, element of the list of partial definitions (ie set of x::=E1,..., x::=En), it finalyzes 
   by fixing its clock and inserting it in the graph.
   Two cases are considered: the state variable (see statepartialDefinitionFinalize() method), and the signals (see signalpartialDefinitionFinalize()).
 */
void /*intemkIGraph::*/partialDefinitionFinalize( void );

/** @ingroup globalProcessinGroup
    @return "true" if all the fields of structure/bundle signal are defined, "false" otherwise. 
    For each "structure/bundle" node defining a signal (x),
      - it adds a dependence x.a_i --> x for each field of a structure (not for a bundle).
      - it inserts the node associated with the "structure/bundle" into the graph at the clock
            - the synchronized clock of the field x.a_1, ..., x.a_n.
            - upper bound of the signals x.a_1, ..., x.a_n for a bundle
 */
boolean /*intemkIGraph::*/verifyStructBundleDefinitions( void );

/**
   @ingroup globalProcessinGroup
   It finalyzes the construction  of the associated graph by:
    - \ref graphClassSpecificity "applying graph Class specificity",
    - \ref propagateTypes "propagating types",
    - \ref DCG::setInitialValues "verifying the initialisations",
    - \ref addDefinitionForUndefinedSignals "adding definitions (x:=x) for undefined signals that are not declared as inputs,
    - \ref enumNameConflicts "solving conflicts for enumerated type",
    - \ref verifyStructBundleDefinitions "finalyzing the structure/bundle definitions"
    - \ref partialDefinitionFinalize "finalyzing the partial definitions definitions"
    - adding the pragma PRAGMA_DEFINED_CLOCK_HIERARCHY to the clock systems when it is present in the graph (it specified that the hierarchy is available).
    @return "true" if the construction succeeds, "false" otherwise.
 */
boolean /*intemkIGraph::*/graphFinalyze( void );

/** @ingroup particularContextGroup
   Context Clock for constant expression.\n
   @return vhcste if it is not undefined, a new clock variable otherwise and the tree (vtree) is annotated with an error. 
 */
ptinsth /*intemkIGraph::*/instContextClock( ptinsth vhcste ,BackAnnotationType vtree );

/** @ingroup particularContextGroup
   Context Clock for constant expression.\n
   @return vhcste if context mode (isfree) is "true", otherwise it calls instContextClock() method.
   note: isfree is not modified.
 */
ptinsth /*intemkIGraph::*/instsiginvhcste( boolean* isfree ,ptinsth vhcste ,BackAnnotationType vtree );

/**
   @ingroup particularContextGroup
   @return the current context for constant expression, before fixing it (WaitConstantExpr attribute) to b.
   when b, the expressions must be expressions on constants (constant value, parameters, constant identifiers,...)
   otherwise errors are signaled.
 */
boolean /*intemkIGraph::*/getSetConstantContext( boolean b );

/**
  @ingroup particularContextGroup
  @return "true" if the expressions must be expressions on constants (constant value, parameters, constant identifiers,...), "false" otherwise.
 */
boolean /*intemkIGraph::*/isInConstantContext( void );

/**
   @ingroup particularContextGroup
   @return the current context for "state variable" in expression, before fixing it (AcceptStateVar attribute) to b.
   when b, the expressions can contain references to state variables otherwise errors are signaled.
 */
boolean /*intemkIGraph::*/getSetStateVarContext( boolean b );

/**
   @ingroup particularContextGroup
   @return "true" if expressions can contain references to some state variables, "false" otherwise.
 */
boolean /*intemkIGraph::*/isInStateVarContext( void );

/**
   @ingroup globalProcessinGroup
   It updates the names of the signals by 
     - building the list of the undefined and non referenced signals.
     - removing these signals from the graph,
     - modifying the signals with the same prefix than the removed ones.
   @return "true" if some updates are done, "false" otherwise.
 */
boolean /*intemkIGraph::*/updateSignalsNames( void );

/**
   \copydoc  splitting::mkFieldsDescription().
 */
ptlinstances /*intemkIGraph::*/mkFieldsDescription( ptexpcal exp );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*intemkIGraph::*/setAuxiliarySignalName( ptexpcal aSig ,ptexpcal exp ,noperators vop );

/**
   @ingroup automatonContextGroup
   clk becomes the automaton context clock. 
   It is used to fix the clock of the conditions built on the current state variable associated with an automaton.
   @return the previous one. The user must managed the stack.
 */
ptinsth /*intemkIGraph::*/setClockAutomaton( ptinsth clk );

/**
   @ingroup automatonContextGroup

   @return the current automaton context clock.
   It is used to fix the clock of the conditions built on the current state variable associated with an automaton.
 */
ptinsth /*intemkIGraph::*/getClockAutomaton( void );

/**
   @ingroup automatonContextGroup
   Sets the current state variable (of an automaton) to vstatevar
 */
void /*intemkIGraph::*/setAutomatonCurrentStateVar( ptexpcal vstatevar );

/**
   @ingroup automatonContextGroup
   @return the current state variable (associated with an automaton) previously set by setAutomatonCurrentStateVar().
 */
ptexpcal /*intemkIGraph::*/getAutomatonCurrentStateVar( void );

/**
   @ingroup automatonContextGroup
   @return true i the clock automaton has been fixed using the Automaton_clock () intrinsic, "false" otherwise.
 */
boolean /*intemkIGraph::*/isClockedAutomaton( void );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*intemkIGraph::*/setClockedAutomaton( boolean b );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*intemkIGraph::*/setInAutomatonIntrinsicContext( boolean b );


