/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
   Constructor. The object is linked with a graph (g).
   The provided methods work on this graph.
   It provides methods to split the structure/bundle type of the linked graph.
 */
/*splitting::*/splitting( ptDCG g );

/**
   Destructor.
 */
/*splitting::*/~splitting( void );

/** @ingroup exprSplitGroup
    Getting the i-th field of a synchronous expression.
    @param exp (in) : an (assumed) synchronous expression.
    @param i (in) : the wanted field number.
    @return the i-th field of a synchronous expression.
  */
ptexpcal /*splitting::*/mkFieldOfSynchronousExpression( ptexpcal exp ,integer i );

/**
   @ingroup exprSplitGroup
   @return the list of the fields associated with an expression (exp) with structrue/bundle as type or an array type built on structured type,
   an empty list for a non structure/bundle type.
   Assumed: the expression (exp) must be an identifier (example: for a signal x with struct t1 y; t2 z; end, it produces {x.y, x.z})
   For more details, see 
     - mkFieldsDescription(TypeType, ptexpcal , ptexpcal , boolean ).
     - isStructureBundleType(TypeType , TypeType , ptexpcal , boolean)
 */
ptlinstances /*splitting::*/mkFieldsDescription( ptexpcal exp );

/** @ingroup nodeSplitGroup
    Splitting structured type definition for a delay (n).
 */
boolean /*splitting::*/splitDelay( ptINode n );

/** @ingroup nodeSplitGroup 
    Splitting structured type definition for an equation (n)
  */
boolean /*splitting::*/splitEqu( ptINode n );

/**@ingroup nodeSplitGroup
   Splitting structured type definition for a partial definition (n).
 */
boolean /*splitting::*/splitPartialDefinition( ptINode n );

/**
   @ingroup nodeSplitGroup
   Splitting structured type definition for all the delays of the graph.
 */
void /*splitting::*/splitStructuresDelays( void );

/**
   @ingroup nodeSplitGroup
   Splitting structured type definition for all the equations of the graph.
 */
void /*splitting::*/splitStructuresEquations( void );

/**
   @ingroup nodeSplitGroup
   Splitting structured type definition for all the partial definitions of the graph.
 */
void /*splitting::*/splitStructuresPartialDefinitions( void );

/**
   @ingroup nodeSplitGroup
   Splitting structured type definition for all the external calls of the graph.
   \warning Not applied for node calls.
 */
void /*splitting::*/splitStructuresCalls( void );

/**
   @ingroup nodeSplitGroup
   Splitting structured type definition for all the nodes of the graph and the definitions of constants.
   Then
      - the field references are replaced by standart signals (see replaceFieldBySignal()), 
      - the structured nodes are removed (see removeGlobalStructureNode()).
      - the interface of the graph is updated (can be modified).
   \warning Not applied for node calls. For arrays and sub-graph it is without effect : the effect is in the inner nodes.
 */
void /*splitting::*/splitStructures( void );


