/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

private:

/**
   @return "true" if a type (t) is a structure, a bundle type or an array type built on structure/bundle type, "false" otherwise.
 */
boolean /*splitting::*/isStructureBundleType( TypeType t );

/** 
    @return "true" if a type (t) is a structure or bundle type or a array type built on a structure/bundle type, "false" otherwise.
    @param t (in) a type.
    @param TT (out) different from t if it is an array type, in this case it is the structured type.
    @param vdim (out) dimensions of the operand type (t)
    @param bstruct (out) "true" when TT it is a structured type, "false" for a bundle.
 */
boolean /*splitting::*/isStructureBundleType( TypeType t ,TypeType* TT ,ptexpcal* vdim ,boolean* bstruct );

/**
   @return the created node (equation) for the definition of a signal (vField) by the i-th field of an expression (definition).
   The i-th expression defines the signal at a given clock (hc).
 */
ptINode /*splitting::*/mkNodeIthFieldWhen( ptexpcal vField ,ptexpcal definition ,integer i ,ptinsth hc );

/**
   @return the created node (delay node) for the definition of a signal (vField) by the i-th field of an expression (definition).
 */
ptINode /*splitting::*/mkNodeIthFieldDelay( ptexpcal vField ,ptexpcal definition ,integer i );

/**
   @return the created node for the definition of a signal (vField) by the i-th field of an expression (definition).
   It creates a delay node(mkNodeIthFieldDelay()) or an equation node (mkNodeIthFieldWhen()).
 */
ptINode /*splitting::*/splitExpression( ptexpcal vField ,ptexpcal definition ,integer i );

/**
   @return the i-th element of a list (exp), undefined element it does not exist.
 */
ptexpcal /*splitting::*/getIthElementOfList( ptexpcal exp ,integer i );

/**
   @return the i-th field of a signal (exp) or exp if it does not exist.
 */
ptexpcal /*splitting::*/getIthFieldForVariable( ptexpcal exp ,integer i );

/**
   @return a new signal with vstr as prefix for its name, with TT (an array type) as type, and h as clock.
   A link is kept for removing the field access.
 */
ptexpcal /*splitting::*/mkSignalForArrayOfField( ptexpcal exp ,ptrepstr vstr ,TypeType TT ,ptinsth h );

/**
   @return a new signal (tfield) with vstr as prefix for its name, with TT as type, and h as clock.
   This signal is a renaning of the field access (exp.str).
   A link is kept for removing the field access.
   For example, \e foo5 can be the signal that represents the field access \e x.foo.
   \warning exp is assumed to be an identifier.
 */
ptexpcal /*splitting::*/mkSignalForField( ptexpcal exp ,ptrepstr vstr ,TypeType TT ,ptinsth h );

/**
   @return a list of signals that represent the fields of a signal (exp).
   @param t (in) a structured type (structure or bundle)
   @param exp (in) a signal with t as base type (completed by the dimensions vdim)
   @param vdim (in) the dimension associated with  the base type (t)  -- for an array type --.
   @param bstructure (in) when it is "true", t is a structure type, otherwise a bundle one.
   
    For an X of an array of structured type such that
     [N] structure
            T1 x1;
	    ...
	    Tn xn; 
          end structure
     It is splitted into several signals: Y1 declared [N] T1 X_x1, ...; Yn declared [N] Tn X_xn.
 */
ptlinstances /*splitting::*/mkFieldsDescription( TypeType t ,ptexpcal exp ,ptexpcal vdim ,boolean bstructure );

/**
   It initialises each node of a list signals (ls) for splitting operation.
   (referenced in initSplitNode()).
 */
void /*splitting::*/initSplitNodes( ptlinstances ls ,ptINode n );

/**
   @return the list of the signals associated with the different fields of a signal.
   For a node (n) defining  a signal (s), it initializes the splitting operation:
     - n becomes an undefined node
     - it creates the signals associated with the different fields (mkFieldsDescription() method)
     - it initializes each created signal
     - n becomes a "composed node" that groups the nodes of the different fields (mk_node_lfields()).
 */
ptlinstances /*splitting::*/initSplitNode( ptINode n ,ptexpcal s );

/**
   It finalizes the splitting operation for a node (n) replaced by a set of nodes (ln):
     - the pragmas associated with n are propagated to ln.
 */
void /*splitting::*/finalyzeSplitNode( ptINode n ,ptlINode ln );

/** 
    Splitting structured type definition for Delays, equation, and partial definition.
 */
boolean /*splitting::*/splitCommon( ptINode n );

/**
   It defines the i-th element of l by the acces to the i-th element of a definition (definition). All the created nodes, have h as clock.
   Some additionnal information are used:
      - partialDef when it is "true", it specify that it is a partial definition.
      - bpartdefault when it is "true", it specify that it is the default value of a partial definition.
  @return the create nodes.
  \see splitExpression
 */
ptlINode /*splitting::*/mkDefinitionFields( ptlinstances l ,ptexpcal definition ,ptinsth h ,boolean partialDef ,boolean bpartdefault );

/**
   Splitting structured type definition for a "write" node (associated with an output signal).
 */
boolean /*splitting::*/splitOuput( ptINode node );

/**
   Splitting structured type definition for a "read" node (associated with an input signal).
 */
boolean /*splitting::*/splitInput( ptINode node );

/**
   @return "true" if the type of a signal (e) is structure/bundle one, "false" otherwise.
   When it returns "true", l is the list of the signals that represent the fields of the operand signal.
 */
boolean /*splitting::*/getListOfFields( ptexpcal e ,ptlinstances* l );

/**
   @return  the expanded form of e (a signal or a list of signal) when structure type, bundle type or array type built on structure/bundle type are
   splitted (in this case, a signal is replaced by N signals, N is the number of attribute of the structured type.)
 */
ptexpcal /*splitting::*/expandStructureToFields( ptexpcal e );

/**
   Splitting structured type definition for an external procedure call node.
 */
boolean /*splitting::*/splitProcCall( ptINode node );

/**
   For a "composed node" (node) that groups the nodes of the different fields
   It removes the node (node) from the graph after propagating its dependences to its components.
 */
void /*splitting::*/removeGlobalStructureNode( ptINode node );

/**
   It applies removeGlobalStructureNode(ptINode) for each "composed node" of the 
   graph that groups the nodes of the different fields.
   Then, it removes the structured type constant.
 */
void /*splitting::*/removeGlobalStructureNode( void );

/**
   Splitting structured type definition for the constants of the graph.
   (similar to splitEqu() method).
 */
void /*splitting::*/splitStructuresConstants( void );


