/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

/* Il faudrait supprimer ces fonctions (loic.Besnard) */

extern ptinsth
mygetracine (ptinsth vh)
{
  int dummy;

  return myClockSystem->getRoot (vh, &dummy);
}

extern ptinsth
mygetpere (ptinsth vh)
{
  return myClockSystem->getFather (vh);
}

extern boolean
myishsub (ptinsth vh)
{
  return (myClockSystem->getOperator (vh) == sub);
}


extern boolean
myishnosub (ptinsth vh)
{
  return (myClockSystem->getOperator (vh) == nosub);
}


extern ptinsth
mygetrepr (ptinsth vh)
{
  return myClockSystem->getRepresentativeFormula (vh);
}


extern ptinsth
mygethnosub (ptinsth hsub)
{
  ptinsth vh;
  myClockSystem->getComplInFather (hsub, &vh);
  return vh;
}


extern ptinsth
mygethsub (ptinsth hnosub)
{
  ptinsth vh;
  myClockSystem->getComplInFather (hnosub, &vh);
  return vh;
}

extern int
mygetop (ptinsth h)
{
  ptinsth h1, h2;
  pkClockType vop;

  vop = myClockSystem->getOperator (h);
  if (vop == vari)
    return 0;
  if (vop == predef)
    return 1;
  if (vop == sub)
    return 2;
  if (vop == nosub)
    return 3;
  if (vop == hcomp)
    return 6;
  if (vop == super)
    return 5;
  if (vop == infer)
    {
      if (myClockSystem->getMinusArgs (h, &h1, &h2))
	return 6;
      return 4;
    }
  return -1;			// error
}

extern void
mygetargs (ptinsth h, ptinsth * h1, ptinsth * h2)
{
  if (!myClockSystem->getMinusArgs (h, h2, h1))
    if (!myClockSystem->getInfArgs (h, h1, h2))
      if (!myClockSystem->getSupArgs (h, h1, h2))
	if (myClockSystem->getOperator (h) == hcomp)
	  {
	    myClockSystem->getUnaryArg (h, h2);
	    *h1 = mygetpere (h);
	  }
}

/** BDD2ClockHierarchy is initialized from BDDhierarchy
    @param aClockSystem is assumed to be initialized with the null clock defined
    @return a copy of the null clock provided by aClockSystem
 */
extern ptinsth
BDD2ClockHierarchy_init (ptClockSystem aClockSystem)
{
  myClockSystem = aClockSystem;
  return myClockSystem->getNullClock ();
}
