/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
/*ClockHierarchy::*/ClockHierarchy( void );

/** Clock hierarchy.
    It initializes the hierarchy. clkroot is the predefined "fictitious" root of a system.
 */
void /*ClockHierarchy::*/initHierarchy( ptinsth clkroot );

/**
   Clock Hierarchy.
   @return the "tick" of the program.
   For a endochronous program "tick" is the synthetized master clock,
   otherwise it is the fictitious root (predefined) of the system.
 */
ptinsth /*ClockHierarchy::*/getTickClock( void );

/** Clock Hierarchy.
    Set the tick clock of the program.
 */
void /*ClockHierarchy::*/setTickClock( ptinsth h );

/** Clock Hierarchy.
    @return true if h is the tick clock of the program, false otherwise.
 */
boolean /*ClockHierarchy::*/satisfiesTickClock( ptinsth h );

/** Clock hierarchy.
    @return true if h is the fictitious root of a system, false otherwise.
 */
boolean /*ClockHierarchy::*/satisfiesFictitiousRoot( ptinsth h );

/** Clock hierarchy.
    @return the predefined "fictitious" root of a system.
 */
ptinsth /*ClockHierarchy::*/getFictitiousRoot( void );

/** 
    @return "true" if a clock (pt) is a fictitious root one
    (ie its children are the real roots of the hierarchy), "false" otherwise.
 */
boolean /*ClockHierarchy::*/isFictitiousRootFormula( ptinsth pt );

/** Clock Hierarchy.
    @return the root of a clock (vh) and its depth (depth)
  */
ptinsth /*ClockHierarchy::*/getRoot( ptinsth vh ,int* depth );

/** Clock Hierarchy.
    It assigns the root clock (vhr) to a clock (vh).
  */
void /*ClockHierarchy::*/setRoot( ptinsth vh ,ptinsth vhr );

/** Clock Hierarchy.
    @return the set of children of a clock (vh).
  */
ptlinsth /*ClockHierarchy::*/getChildren( ptinsth vh );

/** Clock Hierarchy.
    @return the set of children of a clock (vh).
  */
void /*ClockHierarchy::*/setChildren( ptinsth vh ,ptlinsth lh );

/** Clock Hierarchy.
    @return true if the clock vh is a root of the hiecharchy, false otherwise.
 */
boolean /*ClockHierarchy::*/satisfiesRoot( ptinsth vh );

/** Clock Hierarchy.
    It adds a clock (child) as a child of another clock (vh) in the hierarchy.
  */
void /*ClockHierarchy::*/addChild( ptinsth vh ,ptinsth child );

/** Clock Hierarchy.
    It removes a clock (child) of the children of another clock (vh) in the hierarchy.
  */
void /*ClockHierarchy::*/removeChild( ptinsth vh ,ptinsth child );

/** Clock  Hierachy.
    @return the depth of a clock in the hierarchy.
  */
int /*ClockHierarchy::*/getDepth( ptinsth vh );

/** Clock  Hierachy.
    Set the depth of a clock in the hierarchy.
  */
void /*ClockHierarchy::*/setDepth( ptinsth vh ,int d );

/** Clock  Hierachy.
    @return true if the depth of a clock is null, false otherwise.
  */
boolean /*ClockHierarchy::*/satisfiesNullDepth( ptinsth vh );

/** Clock  Hierachy.
    @return the clock father of a clock (vh). 
    For a root, vh = getFather(vh).
 */
ptinsth /*ClockHierarchy::*/getFather( ptinsth vh );

/** Clock  Hierachy.
    It assigns the father clock (vhfather) to a clock (vh).
 */
void /*ClockHierarchy::*/setFather( ptinsth vh ,ptinsth vhfather );

/** Hierachy.
    @return the complementary clock of a clock (vh) in the hierarchy if is available, or undefined otherwise.
    This information is available for placed clock and for extractions.
  */
boolean /*ClockHierarchy::*/getComplInFather( ptinsth vh ,ptinsth* r );

/**
   @return the root and the depth (vdepth) of the clock vh. 
   When the root if the fictitious root, the depth is re-computed.
 */
ptinsth /*ClockHierarchy::*/getRootAndDepth( ptinsth vh ,int* vdepth );

/**
   It updates the depth of the subtree with vh as root. The depth of vh is vdepth.
   It sets the root of the clocks of the subtree to vhroot.
 */
void /*ClockHierarchy::*/updateDepthSubTree( ptinsth vh ,ptinsth vhroot ,int vdepth );

/** @return the list of the clocks on the branch from a clock (vh) until another one (vhemb).
    Assumed : vhemb and vh are in the same branch and vhemb is an ascendant of vh. 
 */
ptlinsth /*ClockHierarchy::*/getClocksUntil( ptinsth vh ,ptinsth vhemb );

/** 
    It places a clock (vh) in the clock hierarchy.
    The root of vh is vhrac, its father clock (vhfather) and its depth (vdepth).
 */
void /*ClockHierarchy::*/placeInClockHierarchy( ptinsth vh ,ptinsth vhrac ,ptinsth vhfather ,int vdepth );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
int /*ClockHierarchy::*/getClockCounter( void );

/**
   @return 
    - pk_true  if vharg1 and vharg2 have the same root (but not the fictitious root)  and are on different branches. Then :
           - vhemb (out) : is the class of the smaller placed upper bound (branching);
	   - vharg1 (out): the nearest of vhemb;
	   - vharg2 (out): the other;
           - vhson1 (out): child of vhemb on the branch of vharg1
           - vhson2 (out): child of vhemb on the branch of vharg2
    - false if vharg1 and vharg2 have not the same root or the root is  the fictitious clock. Then,
           - vhemb (out) : is the undefined clock.
 */
boolean /*ClockHierarchy::*/getCompleteBranching( ptinsth* vharg1 ,ptinsth* vharg2 ,ptinsth* vhson1 ,ptinsth* vhson2 ,ptinsth* vhemb );

/** @return
     - the branching of two clocks (vharg1 and vharg2), if these clocks are in the same clock tree, 
     - the undefined clock otherwise. 
 */
ptinsth /*ClockHierarchy::*/getBranching( ptinsth vharg1 ,ptinsth vharg2 );

/** Formula.
   @return "true" it the formula ?vh is the canonical form of its class.
   (ie. It is the representative formula and placed in the hierarchy)  */
boolean /*ClockHierarchy::*/satisfiesIsCanonicalRepr( ptinsth vh );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*ClockHierarchy::*/cloneClocks( ptinsth vh1 ,ptinsth vh2 );


