/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
/* requires <stddef> */
#ifndef __ClockManagerExportType__
#define __ClockManagerExportType__

typedef class ClockManager *ptClockManager;
typedef class ClockSystem *ptClockSystem;

typedef struct insth     *ptinsth; ///< Pointer to a clock/formula.
#define NILINSTH    (ptinsth)  NULL
typedef ptinsth   insthFormula; ///< Pointer to a formula.
typedef ptinsth   insthClock; ///< Pointer to a clock (a header formula).
typedef class condition  *ptcondition; // representation of a condition in the clock calculus (C, ^C, [C],[not C])
typedef struct linsth  *ptlinsth; ///< List of clocks.
#define NILLINSTH     (ptlinsth)NULL


typedef struct GraphInfos  *ptGraphInfos; ///< Used to link each clock to a graph (set of nodes computed at this clock).
#define NILGRAPHINFOS (ptGraphInfos)NULL

/// Operator of a clock formula
typedef enum 
{
  sub, ///< when C
  nosub, ///< when not C
  hnot, ///< not operator, always used as operand of a lower bound (to express x ^- y)
  hcomp,///< complement in its father clock (used only in a internal hierarchy)
  infer, ///< lower bound x ^* y
  super, ///< lower bound x ^+ y
  vari,  ///< free variable
  predef, ///< predefined clock (initial, null, undefined)
  troot  ///< Fictitious root of a hierarchy
} pkClockType;

#endif
