/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/** @return the clock composed of a new variable.  */
insthClock /*ClockSystem::*/new_variFormulaRootClock( void );

/** 
   @return a new condition with c as undersampling expression. 
   It creates the undersampling clock [c] by this expression and its negation [not c].
   The expression (c) 
      - is reduced to a signal if isasignal is "true";
      - its clock is vhorl, 
      - references the signals of the list linst.

   Moreover, it is declared an equivalent formula if isAnequivalent is pk_true (used for bDC+ sub-format).
 */
ptcondition /*ClockSystem::*/new_conditionExtractions( insthClock vhorl ,ptexpcal c ,ptlinstances linst ,boolean isasignal ,boolean isAnequivalent );

/** - misc -
    @return the clock composed of the h ^- h1 formula where h denotes the mother clock of h1 in
    the hierarchy. It assumes that such a clock exists: h1 is placed in a tree.
 */
insthClock /*ClockSystem::*/new_compClockInTree( insthClock vharg );

/** @return the clock composed of the lower-bound vh1 ^* vh2 formula.  */
ptinsth /*ClockSystem::*/makeInf( insthFormula vh1 ,insthFormula vh2 );

/**
   Rewriting the clock of the expression of the sub-formula vfsub in vhfrom.
   vfsub is assumed to be a sub-formula.
 */
void /*ClockSystem::*/rewriteSub( ptinsth vfsub ,ptinsth vhfrom );

/** 
    For an assumed sub-formula vfsub [e], e is replaced by nexp. Nexp references the signals of the list l.
 */
void /*ClockSystem::*/rewriteCondSub( ptinsth vfsub ,ptexpcal nexp ,ptlinstances l );

/** 
    Rewriting in vhfrom of the clock of the negate-formula vfnot.
 */
void /*ClockSystem::*/rewriteNot( ptinsth vfnot ,ptinsth vhfrom );

/**
   @return the class of the formula (vharg1 ^* vharg2) build if vfinf=hundef
   rebuild otherwise, and vfinf is removed from its class and the equivalence are announced.
   vfinf is assumed to be a inf-formula.
 */
ptinsth /*ClockSystem::*/rewriteInf( ptinsth vfinf ,ptinsth vharg1 ,ptinsth vharg2 );

/**
   @return the class of the formula (vharg1 ^+ vharg2) build if vfsup=hundef
   rebuild otherwise, and vfsup is removed from its class and the equivalence are announced.
   vfsup is assumed to be a sup-formula.
 */
ptinsth /*ClockSystem::*/rewriteSup( ptinsth vfsup ,ptinsth vharg1 ,ptinsth vharg2 );

/** 
    It replaces the clock vhsub by vhnew in the system and the equivalences are announced.
    When keep is pk_true, the formula are kept.
 */
void /*ClockSystem::*/replaceSub( ptinsth vhsub ,ptinsth vhnew ,boolean keep );

/** 
    It replaces the clock vhsub by vhnew in the system and the equivalences are announced.
    When keep is pk_true, the formula are kept.
 */
void /*ClockSystem::*/replaceSub_null( ptinsth vhsub );

/**
   @return the class vhnew.
   If vfsup,  an assumed sup-formula, is not the "undefined clock", 
   this formula is removed from its class and the equivalence with vhnew is announced.
 */
ptinsth /*ClockSystem::*/replaceSup( ptinsth vfsup ,ptinsth vhnew );

/**

   @return the class vhnew.
   If vfinf, an assumed inf-formula, is not the "undefined clock", 
   this formula is removed from its class and the equivalence with vhnew is announced.
 */
ptinsth /*ClockSystem::*/replaceInf( ptinsth vfinf ,ptinsth vhnew );

/** It merges a clock (vh1) with the null clock and realizes induced merges.
  */
void /*ClockSystem::*/hclunionwithhnull( ptinsth vh1 );

/**
   @return 
     - false if it does not exists some equivalences to do, 
     - true otherwise, in this case it builds this equivalences and the induced equivalences.
 */
boolean /*ClockSystem::*/hclmklequiv0( void );

/** Formula.
    The representative formula of the class {clk, bclk, ...} becomes bclk.
    This clock is a child of father clock.
 */
void /*ClockSystem::*/switchFormula( ptinsth clk ,ptinsth bclk ,ptinsth father );

/**
   It replaces a formula (vh1) by another (vh2) for each formula of a list (luse).
 */
void /*ClockSystem::*/replaceForm( ptinsth vh1 ,ptinsth vh2 ,ptlinsth luse );

/**
   It realizes the synchronisations that are not marked by m.
   (Currently used for assertions managing).
 */
void /*ClockSystem::*/makeSynchrosUnmarked( typeMark m );

/**
   It returns the synchrozisations not yet solved (when ModeSynchroSolving is "false" for example) in lh1, lh2.
   We have lh1 = { h1,...., hN,...,hv}, lh2 = { k1,...., kN,...kv}, and hi is equivalent to ki.
   (Currently used for assertions managing).
 */
void /*ClockSystem::*/getSuspendedSynchros( ptlinsth* lh1 ,ptlinsth* lh2 );

/**
   It removes a clock (clk) from the system by :
     - updating root clocks or placed clocks sub-set,
     - updating the formula sub-set.
     Informations are kept for tracability.
 */
void /*ClockSystem::*/removeClock( ptinsth clk );

/** Removing an EXTRACTION formula.
   It cleans the use of its arguments and the internal lists.
   @param vform an assumed sub-formula to remove.
   @param killFormula (in) the formula vform is removed of the class, otherwise it is 
   kept as an equivalent.
   @param becomesvari (out) at pk_true when the clock becomes an empty set of formula.
   @return the class of vform.
 */
ptinsth /*ClockSystem::*/removeSub( ptinsth vform ,boolean killFormula ,boolean* becomesvari );

/** 
    @return
    - false if the clock (vh) of a signal (sig) is the null clock. In this case, the link signal/clock is preserved.
    - true otherwise and the link is destroyed : the signal is removed from the set of the signals assigned to vh.
      If there is no references to this clock, it is removed from the system.
      
      if bk, the signal (sig) is kept in a specific set; its name could be used for the name of the clock (vh).
 */
boolean /*ClockSystem::*/removeFromClock( ptinsth vh ,ptexpcal sig ,boolean bk );

/** @return true if a clock (vh) is a free clock (i.e a variable without any constraints)
    false otherwise. */
boolean /*ClockSystem::*/isFreeClock( ptinsth vh );

/**
  Undersampling by a positive condition.
  @return the clock in which the sub-formula that represents the set of the value "true" of the 
  condition c with c ^= vh, is an element. It assumes that c is a positive expression which references the signals given in the list pred.
  This sub-formula is noted [c] and the following properties hold:
    - [c] ^+ [not c] = ^c
    - [c] ^* [not c] = ^0
    \see makeNoSub
 */
ptinsth /*ClockSystem::*/makeSub( insthFormula vh ,ptexpcal c ,ptlinstances pred );

/**
  Undersampling by a negative condition.
  @return the clock in which the sub-formula, that represents the set of the value "false" of the 
  condition c with c ^= vh, is an element. It assumes that c is a positive expression.
  This sub-formula is noted [not c].
  \see makeSub
 */
ptinsth /*ClockSystem::*/makeNoSub( ptexpcal c );

/** @return the clock composed of the upper-bound vh1 ^+ vh2 formula.  */
ptinsth /*ClockSystem::*/makeSup( ptinsth vh1 ,ptinsth vh2 );

/** @return the class of -(vh).  */
ptinsth /*ClockSystem::*/getForce_notClock( insthFormula vh );

/** @return the clock composed of the vh1 ^- vh2 formula.
    Applied elementary reduction:
       - vh1 ^- vh1 -> ^0
 */
ptinsth /*ClockSystem::*/makeMinus( ptinsth vh1 ,ptinsth vh2 );

/** @return the clock obtained by the merge of vh1 and vh2.
    a representative formula is chosen.
  */
ptinsth /*ClockSystem::*/makeSynchro( ptinsth vh1 ,ptinsth vh2 );

/** @return the clock obtained by the merge of vh1 and vh2.
    This constraint is assumed satisfied (assertion).
 */
ptinsth /*ClockSystem::*/makeAssumption( ptinsth vh1 ,ptinsth vh2 );

/**
   Adds in the clock system the assertions:
   - (| when vcond ^= vh | when not vcond ^=0 |) when bpos, 
   - (| when not vcond ^= vh | when vcond ^=0 |) when not bpos.

   vh is assumed to be the clock of the condition (vcond).
 */
void /*ClockSystem::*/makeAssert( ptinsth vh ,ptexpcal vcond ,boolean bpos ,ptinsth* vhsub ,ptinsth* vhnosub );

/** @return the class obtained by the merge of vh1 and vh2.
    vh1 is a proved equivalent formula of vh2.
 */
ptinsth /*ClockSystem::*/makeEquivForm( ptinsth vh1 ,ptinsth vh2 );

/** @return the class obtained by the merge of vh1 and [c], with 
      - c a positive condition.
      - hc ^= c
      - [c] is a proved equivalent formula of vh1.
      - vlist list of  the signals referenced in the condition c.
    \note these kept formula are used for interformat translations.
 */
ptinsth /*ClockSystem::*/makeEquivForm( ptinsth vh1 ,ptexpcal c ,ptlinstances vlist ,ptinsth hc );

/**
   It places as roots the set of unplaced clocks.
  */
void /*ClockSystem::*/setClocksAsRoots( void );

/**
   It realizes the fusion of two clocks vhold and vhnew. This induces the fusion of:
   the formula, the lists of synchronous signals, the sub-graphs of nodes assigned to each clock.
 */
void /*ClockSystem::*/hclfusion( ptinsth vhold ,ptinsth vhnew );

/**
  @return true if the formula VH2 has not the priority on vh1 for the choice of a representative element.
  remark : a placed formula has always the priority on a non-placed one.
 */
boolean /*ClockSystem::*/isFormulaBeforeFormula( ptinsth vh1 ,ptinsth vh2 );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*ClockSystem::*/free_formula( ptinsth vh );


