/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
   It adds a placed clock (vh) as a constraint to be the null clock.
 */
void /*ClockSystem::*/addPlacedNullClocks( ptinsth vh );

/** 
    Adding (vh1, vh2) in 
    - the set of placed formula to be proved equivalent
    - or in the set of assertions when one of the formula is tagged as an assumption.
 */
void /*ClockSystem::*/addConstraintPlacedClocks( ptinsth vh1 ,ptinsth vh2 );

protected:

/** Removing a variable.
    Remove a clock (vh) from the list of the clocks without definition(empty class).
 */
void /*ClockSystem::*/removeVari( ptinsth vh );

/** Removing NOT formula.
  @return the class vform, in which the formula vform has been removed.
  References and lists of formula are uptdated.
  @param becomesvari (out) at pk_true when the resulting clock is whitout definition, false otherwise.
  @param vform an assumed not-formula to remove.
 */
ptinsth /*ClockSystem::*/removeNot( ptinsth vform ,boolean* becomesvari );

/** Removing a LOWER BOUND formula.
   @return the class vform, in which the formula vform has been removed.
   References and lists of formula are uptdated.
   @param becomesvari (out) at pk_true when the resulting clock is whitout definition, false otherwise.
   @param vform (in) : an assumed inf-formula to remove.
 */
ptinsth /*ClockSystem::*/removeInf( ptinsth vform ,boolean* becomesvari );

/** Removing UPPER BOUND formula.
    @return the class vform, in which the formula vform has been removed.
    References and lists of formula are uptdated.
    @param vform (in) : an assumed sup-formula to remove.
    @param becomesvari (out) at pk_true when the resulting clock is whitout definition, false otherwise.
 */
ptinsth /*ClockSystem::*/removeSup( ptinsth vform ,boolean* becomesvari );

/** Adding equivalence.
   It adds the equivalence VH1 = VH2 to do.
 */
void /*ClockSystem::*/hcladdsynchro( ptinsth vh1 ,ptinsth vh2 );

/** Getting equivalence.
    @return true if it exists some equivalence to do in the system, 
    in this case vh1 and vh2 must be unified.
 */
boolean /*ClockSystem::*/hclsomesynchro( ptinsth* vh1 ,ptinsth* vh2 );

/** Adding clock to the modified set.
   @param vh  (in) the clock for which the reference must be rewritten.
   @return none.
 */
void /*ClockSystem::*/hcladdmodified( ptinsth vh );

/** Getting clock from modified set.
   @return true if the set of modified formula is not empty, false otherwise.
   @param vh (out) clock for which the reference to must be rewritten.
 */
boolean /*ClockSystem::*/hclsomehmodified( ptinsth* vh );

/**
   Adding a clock in the set of roots.
 */
void /*ClockSystem::*/insertlhroots( ptinsth vh );

/**
   @return true if the removing of a clock (vh) from the set of roots succeeds, false otherwise.
 */
boolean /*ClockSystem::*/removelhroots( ptinsth vh );

/**
   Adding a clock in the set of placed clocks.
 */
void /*ClockSystem::*/insertlhplaced( ptinsth vh );

/**
   @return true if the removing of a clock (vh) from the set of placed clocks succeeds, false otherwise.
   When b is pk_true, the clock is also removed from the placed sub-set of formula (one by clock formula operator).
 */
boolean /*ClockSystem::*/removelhplaced( ptinsth vh ,boolean b );

/** Adds vh as a new clock to be merge with the ^0 clock.  */
void /*ClockSystem::*/setClockToNullClock( ptinsth vh );

/** 
    If a clock (vh) is not already placed, it is inserted as a root in the hierarchy.
 */
void /*ClockSystem::*/addClockAsRoot( ptinsth vh );

/** 
    @return the class of the formula op(vharg) where op denotes the "hnot" operator or the "hcomp" operator.
    This formula is added to the vhcl(in) class. A new class is created if vhcl (in) is the undefined clock.
 */
insthFormula /*ClockSystem::*/mkUnaFormula( insthClock* vhresult ,insthClock vharg ,pkClockType op );

/** 
    @return the class of the formula op(vharg1, vharg2) where op denotes a binary operator (^+, ^*).
    This formula is added to the vhcl(in) class. A new class is created if vhcl (in) is the undefined clock.
 */
insthClock /*ClockSystem::*/new_binaryFormulaClock( insthClock vharg1 ,insthClock vharg2 ,pkClockType op );

/** 
    @return the class of the formula ^+(vharg1, vharg2)
    ^+(vharg1, vharg2) is added to the vhcl(in) class. A new class is created if vhcl (in) is the undefined clock.
    ^+(vharg1, vharg2) is added in the list of super fromula and as a root
 */
insthFormula /*ClockSystem::*/new_superFormulaRootClock( insthClock* vhresult ,insthClock vharg1 ,insthClock vharg2 );

/** 
    @return the class of the formula ^*(vharg1, vharg2)
    ^*(vharg1, vharg2) is added to the vhcl(in) class. A new class is created if vhcl (in) is the undefined clock.
    ^*(vharg1, vharg2) is added in the list of infer fromula and as a root
 */
insthFormula /*ClockSystem::*/new_inferFormulaRootClock( insthClock* vhresult ,insthClock vharg1 ,insthClock vharg2 );

/** 
    It updates the list of the clock system: The clock vh is added to the unplaced clock.
    A "hcomp" formula hcomp(H) is replaced by a complementary formula *(HC, not(H)) where HC is the father clock of H.
 */
void /*ClockSystem::*/addFormulaToListRoot( ptinsth vh );

/**
   Removing an extraction (vh) from the system.
   It assumes that vh is an extraction.
 */
void /*ClockSystem::*/removelssub( ptinsth vh );

/**
   @return true if  the output parameter vwhichnull is assigned to a value (-1, 0, 1). The coding is 
   - vwhichnull=-1 if vharg1=^0
   - vwhichnull=0  if vharg1=vharg2
   - vwhichnull=1  if vharg2=^0
   false otherwise.
 */
boolean /*ClockSystem::*/hredinfsup( ptinsth vharg1 ,ptinsth vharg2 ,int* vwhichnull );

/** 
    @return "true" if (vother ^- vharg) can be rewriten in vother, "false" otherwise.
 */
boolean /*ClockSystem::*/hredhnot( ptinsth vharg ,ptinsth vother );

/** 
    @return "true" if some simplification on tick clock can be applied, in this case vh is the result, "false" otherwise.
  */
boolean /*ClockSystem::*/hredupb( ptinsth vharg1 ,ptinsth vharg2 ,ptinsth* vh );

/**
   @return true if it exists a null clock (vh) , not yet merge to the null clock.
   The references to this clock must be visited for rewritting.
 */
boolean /*ClockSystem::*/hclsomehnull( ptinsth* vh );

/**
  It adds a not placed clock (vh) as a clock to be merge with the null clock.
  If toinsert is pk_true, it is added in the set of the clocks without definition.
 */
void /*ClockSystem::*/hcladdhnull( ptinsth vh ,boolean toinsert );

/** 
    @return true if it exists not solved constrainsts on placed clocks, false otherwise. 
 */
boolean /*ClockSystem::*/existsynchropl( void );

/**
   Adding (vh1, vh2) in the set of assumptions.
 */
void /*ClockSystem::*/hcladdassertion( ptinsth vh1 ,ptinsth vh2 );

/**
   @return true if the formula -(VHARG) exists in the system, false if it is created.
   vhresult (out) contains, all the cases, the class of the formula.
 */
boolean /*ClockSystem::*/findForce_notFormula( ptinsth* vhresult ,ptinsth vharg );

/**
   @return true if the formula (vharg1 ^* vharg2) exists in the system, false if it is created and not placed.
   @param vharg1, vharg2 (in) : arguments of  the ^* formula.
   @param vhresult (out) : the class of the formula (vharg1 ^* vharg2).
   @param vfinf (out) : the formula (vharg1 ^* vharg2).
 */
boolean /*ClockSystem::*/findForce_inferFormula( ptinsth* vhresult ,ptinsth vharg1 ,ptinsth vharg2 ,ptinsth* vfinf );

/**
   @return true if the formula (vharg1 ^+ vharg2) exists in the system, false if it is created and not placed.
   @param vharg1, vharg2 (in) : arguments of  the ^+ formula.
   @param vhresult (out) : the class of the formula (vharg1 ^+ vharg2).
   @param vfsup (out) : the formula (vharg1 ^+ vharg2).
 */
boolean /*ClockSystem::*/findForce_superFormula( ptinsth* vhresult ,ptinsth vharg1 ,ptinsth vharg2 ,ptinsth* vfsup );

/**
  @return true if the condition with cond as expression exists in the system, false otherwise.
  When it exists in the system, when valvrai :
   - is pk_true, vhresult (out) is the  class of [cond] (undersampling by the condition),
   - is pk_false, vhresult (out) is the classe of [not cond] (undersampling by the negation of the condition).
 */
boolean /*ClockSystem::*/rchlsub( boolean valvrai ,ptexpcal cond ,ptinsth* vhresult );

/**
   It changes the representative formula of a class.
   The representative formula of the class of vhold becomes vhnew.
 */
void /*ClockSystem::*/hclchangform( ptinsth vhold ,ptinsth vhnew );


