/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

private:

/**
   Sets to a clock (clk) its hierarchy informations: its father clock (hfather), its root (hroot) and its depth (depth).
 */
void /*ClockSystem::*/setHierarchy( ptinsth clk ,ptinsth hfather ,ptinsth hroot ,int depth );

/**
   Ordering formulas (vh1, vh2) by increasing number.
  */
void /*ClockSystem::*/setorder_from_num( ptinsth* vh1 ,ptinsth* vh2 );

/** @return 
    - pk_true if the clocks vh1 and vh2 are placed.
    - pk_false, not placed and they are re-ordered (null clock first)
 */
boolean /*ClockSystem::*/sortFormula( ptinsth* vh1 ,ptinsth* vh2 );

/**
   It removes a condition from the system.
   @return true if the condition of the clock (assumed to be an extraction) is in the list vlcond, false otherwise.
   When it is present, the condition is removed from the list and returned in output vcondition parameter.
 */
boolean /*ClockSystem::*/dlcond( ptlinsth* vlcond ,ptinsth velem ,ptcondition* vcondition );

/**
   List managing when the beginning of the list and the end of the list are known (added for optimizing clock calculus).
   It adds a formula (vh) in such a list (lbegin, lend).
 */
void /*ClockSystem::*/insertSortedList( ptinsth vh ,ptlinsth* lbegin ,ptlinsth* lend );

/**
   List managing when the beginning of the list and the end of the list are known (added for optimizing clock calculus).
   It removes a formula (vh) from such a list (lbegin, lend).
 */
boolean /*ClockSystem::*/removeSortedList( ptinsth vh ,ptlinsth* lbegin ,ptlinsth* lend );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*ClockSystem::*/clean_variableClockList( void );

/**
   System management.
   @return 
   - pk_true if the formula -vharg is yet registerd. Then, vhresult (out) is the class of the found formula.
   - false otherwise.
 */
boolean /*ClockSystem::*/find_notClockFormula( ptinsth* vhresult ,ptinsth vharg );

/**
   System management.
   @return 
   - pk_true if the formula op(vh1, vh2) is in the list VLHINFSUP. Then, vhresult (out) is the class of the found formula.
   - false otherwise.
 */
boolean /*ClockSystem::*/find_binaryClockFormula( ptlinsth vlhinfsup ,ptinsth vh1 ,ptinsth vh2 ,ptinsth* vhresult );

/**
   System management.
   @return true if the formula op(vh1, vh2) exists using the references to vh1.
   @return false if the formula op(vh1, vh2) does not exist using the references to vh1.
   @param(vhresult) is assigned the existing formula if any; it remains unchanged otherwise
 */
boolean /*ClockSystem::*/rchFormula( pkClockType op ,ptinsth vh1 ,ptinsth vh2 ,ptinsth* vhresult );

/** 
    System management.

    @return true if an expression (cond) is argument of an extraction clock on condition (velem), 
    of a list of extraction clocks (list).
    Assumed: list is an extraction clocks list.
 */
boolean /*ClockSystem::*/recherche( ptlinsth list ,ptexpcal cond ,ptcondition* velem );

/**
   It inserts an extraction  clock (vhsub) in the list vlsub.
   Assumed : vhsub is an extraction clock.
 */
void /*ClockSystem::*/register_variClockRoot( ptinsth vh );

/**
   It inserts an extraction  clock (vhsub) in the list vlsub.
   Assumed : vhsub is an extraction clock.
   @return the modified list.
 */
ptlinsth /*ClockSystem::*/insertlcond( ptlinsth vlsub ,ptinsth vhsub );

/**
   It inserts an extraction  clock (vhsub) at the end of the list (vlsub) if isasignal or at the beginning of the list otherwise.
   Assumed : vhsub is an extraction clock.
   @return the modified list.
 */
ptlinsth /*ClockSystem::*/insertlcond( ptlinsth vlsub ,ptinsth vhsub ,boolean isasignal );

/**
   It removes a condition from the system.
   @return true if the condition vcondition is in the list vlsub, 
   in this case it is removed from it, false otherwise.
 */
boolean /*ClockSystem::*/ptlinsth_remove_condition( ptlinsth* vlsub ,ptcondition vcondition );

/** creates a new formula of type (operator) vop; 
                   this formula is unstable since arguments are not set
    if the formula of (* vhcl) is undefined the newly created formula is made a clock returned in (* vhcl)
    otherwise if the formula of (* vhcl) is a vari, it is replaced by the new formula
            provided that (* vhcl) is a root and is not the meta root
    @return the unstable  created formula.
 */
insthFormula /*ClockSystem::*/insert_newFormula( insthClock* vhcl ,pkClockType vop );

/**
   @return true if the couple (vh1, vh2) is an element of the list l1, l2. 
   One element by list and at the same rank.
 */
boolean /*ClockSystem::*/search( ptinsth vh1 ,ptinsth vh2 ,ptlinsth l1 ,ptlinsth l2 );

/** @return True if vh is a recursive form in vform, false otherwise.
    Local to \ref ishodefrec.  */
boolean /*ClockSystem::*/ishodefrecin( ptinsth vh ,ptinsth vform );

/** @return True if vh is a recursive form in vform, false otherwise.
  */
boolean /*ClockSystem::*/ishodefrec( ptinsth vh ,ptinsth vform );

/** 
   It rewrites the formula of the list (luse) by replacing the references to vh1 by the null clock.
 */
void /*ClockSystem::*/setlusetohnull( ptinsth vh1 ,ptlinsth luse );

/**
   @return the class result of the merge of two classes (x1 and x2).
   It realizes recursively the induced merging.
   Warning: the boolean reductions are not applied. It is used during the creation of the clock system (only elementary reductions are appled).
   \see {hclmkunion(), mergingClasses0(), hclunionwithhnull()}
 */
ptinsth /*ClockSystem::*/hclmkunion0( ptinsth x1 ,ptinsth x2 );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
ptinsth /*ClockSystem::*/rewriteInf0( ptinsth use ,ptinsth vh1 ,ptinsth vh2 );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
ptinsth /*ClockSystem::*/rewriteSup0( ptinsth use ,ptinsth vh1 ,ptinsth vh2 );

/**
   @return the result of the merge of two clocks (classes of formula), vh1 andf vh2.
   It realizes recursively the induced merges.
   \see hclmkunion0.
 */
void /*ClockSystem::*/mergingClasses0( ptinsth vh1 ,ptinsth vh2 );

/**
   The pragmas associated with a clock (vhold) are inserted to those of an another one (vhnew).
 */
void /*ClockSystem::*/fusion_pragmas( ptinsth vhold ,ptinsth vhnew );

/** 
    Assumed : the formula vh and vform have the same clock father.
    It substitutes the current representative formula (vh) by another one (vform).
  */
void /*ClockSystem::*/substitute_clhead( ptinsth vh ,ptinsth vform );

/** It substitutes the current representative formula (vh) by another one (vform).  */
void /*ClockSystem::*/modify_clhead( ptinsth vh ,ptinsth vform );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*ClockSystem::*/hclexclusiverules( ptinsth vh );

/** It merges a clock (vh1) with the null clock and realizes induced merges.
  */
void /*ClockSystem::*/unionwithhnull( ptinsth vh1 );

/**
   It merges a clock (vh) with the null clock and realizes induced merges, for vh a upper bound.
  */
ptlinsth /*ClockSystem::*/getTermsUpperBound( ptinsth vh ,ptlinsth lh );

protected:

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*ClockSystem::*/TestExclusiveConditions( ptinsth vharg1 ,ptinsth vharg2 );


