/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

/** \todo{ MISSING GLOBAL FILE OR FIRST FUNCTION, API DOCUMENTATION } */

/**
  @return a new affine relation (period_n, phasis, period_d)
 */
EXTERN ptAffineRelation mkAffineRelation( long int period_n ,long int phasis ,long int period_d );

/**
   @return a copy of an affine relation (pt).
 */
EXTERN ptAffineRelation ptAffineRelation_duplicate( ptAffineRelation pt );

/**
   Copies an affine relation (pt1) into another one (pt2).
 */
EXTERN void ptAffineRelation_copy( ptAffineRelation pt1 ,ptAffineRelation pt2 );

/**
   Getting the arguments (period_n, phasis, period_d) of an affine relation (pt).
 */
EXTERN void ptAffineRelation_get_elems( ptAffineRelation pt ,AffineParam* period_n ,AffineParam* phasis ,AffineParam* period_d );

/**
   Setting the arguments (period_n, phasis, period_d) of an affine relation (pt).
 */
EXTERN void ptAffineRelation_set_elems( ptAffineRelation pt ,AffineParam period_n ,AffineParam phasis ,AffineParam period_d );

/**
  @return 
  - "true" if the parameters of affine relations (pt1, pt2) are equal: for pt1 = (n1, phi1, d1)
  and pt2 = (n2, phi2, d2), n1 = n2, phi1 = phi2, d1 = d2.
  - "false" otherwise.
 */
EXTERN boolean ptAffineRelation_compare( ptAffineRelation pt1 ,ptAffineRelation pt2 );

/**
   @return "true" if an affine relation pt=(period1, phasis, period2) satisfies period1= 1, phasis= 0 and period2= 1, "false" otherwise.
 */
EXTERN boolean ptAffineRelation_isOneZeroOne( ptAffineRelation pt );

/**
   It builts the canonical form of an affine relation (pt).
   (see AffineParam_gcd_quotient(), AffineParam_div_and_mod()).
   For pt=(n, phi, d):
   - AffineParam_gcd_quotient() produces v_gcd = gcd(n,d), n1= n/v_gcd and d1= d/v_gcd.
   - AffineParam_div_and_mod() produces q, r such that phi = q* v_gcd + r, applied on phi, gcd
   - then the canocical form is: (n1, q, d1) if r=0, (2*n1, 2*q+1, 2*d1) otherwise
 */
EXTERN void ptAffineRelation_canonical_form( ptAffineRelation pt );

/**
   @return "true" if pt1=(n1, phi1, d1), and pt2=(n2, phi2, d2) are equivalent, "false" otherwise.
   - Particular cases:
    - n1=n2=1, phi1=phi2,d1=d2
    - d1=d2=1, phi1=phi2,n1=n2
   - Otherwise the canonical form of the affine relations (ptAffineRelation_canonical_form()) are built and compared (ptAffineRelation_compare()).
 */
EXTERN boolean ptAffineRelation_isEquivalent( ptAffineRelation pt1 ,ptAffineRelation pt2 );

/**
   The affine relation ptin = (n, phi, d) is divided in ptout1 = (1, max(0, -phi), n) and ptout2 = (1, max(0, phi), d).
   \note Side effect on ptin (=ptout1) and a new object is created for ptout2.
 */
EXTERN void ptAffineRelation_divide( ptAffineRelation ptin ,ptAffineRelation* ptout1 ,ptAffineRelation* ptout2 );

/**
   It produces (ptout) the (simple) composition of the relations ptin1 = (1, phi1, d1) and ptin2 = (1, phi2, d2).
   It is defined by ptout = (1, phi1 + d1*phi2, d1*d2).
 */
EXTERN void ptAffineRelation_simple_composition( ptAffineRelation ptin1 ,ptAffineRelation ptin2 ,ptAffineRelation ptout );

/**
   It produces (ptout) the composition of the relations ptin1 = (1, phi1, d1) and ptin2 = (1, phi2, d2).
   Definition: for ptin1 = (n1, phi1, d1) and ptin2 = (n2, phi2, d2), ptout = (n1*n2, phi1*n2 + d1*phi2, d1*d2).

   \note We can composed (only?) the affine relations 
   - (n, phi, d) with (1, phi', d'), result = (n, phi + d*phi', d*d') with phi integer, (phi' >= 0)
   - (1, phi, d) with (1, phi', d') is (1, phi + d phi', d d') phi, phi' >= 0.
   - (n, phi, 1) with (1, phi', d') is (n, phi + phi', d').
 */
EXTERN void ptAffineRelation_general_composition( ptAffineRelation ptin1 ,ptAffineRelation ptin2 ,ptAffineRelation ptout );

/**
  @return "true" if the complementary of ptin exists (ptout), "false" otherwise.

  For ptin = (1, phi, d), it exists if d = 2, phi=0 or phi=1, then ptout = (1, 1-phi, d).
 */
EXTERN boolean ptAffineRelation_complementary( ptAffineRelation ptin ,ptAffineRelation ptout );

/**
   It defines the inverse (ptout) of an affine relation (ptin). With ptin = (n, phi, d), ptout = (d, -phi, n).
 */
EXTERN void ptAffineRelation_inverse( ptAffineRelation ptin ,ptAffineRelation ptout );

/**
   @return "true" if  inverse(ptin1) composed with ptin2 is an affine relation whose 
   the UNION of the affine operand clocks is in affine relation with each operand, "false" otherwise.
   \see ptAffineRelation_sup_is_affine
 */
EXTERN boolean ptAffineRelation_comp_sup_is_affine( ptAffineRelation ptin1 ,ptAffineRelation ptin2 ,ptAffineRelation* ptout );

/**
   @return "true" if  inverse(ptin1) composed with ptin2 is an affine relation whose 
   the INTERSECTION of the affine operand clocks is in affine relation with each operand, "false" otherwise.
   Currently, it returns always "false".
   
   \see  ptAffineRelation_inf_is_affine
 */
EXTERN boolean ptAffineRelation_comp_inf_is_affine( ptAffineRelation ptin1 ,ptAffineRelation ptin2 ,ptAffineRelation* ptout );


