/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
  @return 
  - the placed formula (vharg1 ^*vharg2) if the clocks vharg1 and  vharg2 are in the same tree 
  - normalized formula (sum of products of extractions/variables) of vharg1 ^*vharg2, otherwise.
 */
ptinsth /*ClockManager::*/normalizeInf( ptinsth vharg1 ,ptinsth vharg2 );

/**
  @return 
  - the placed formula (vharg1 ^+ vharg2) if the clocks vharg1 and  vharg2 are in the same tree 
  - normalized formula (sum of products of extractions/variables) of vharg1 ^+ vharg2, otherwise.
 */
ptinsth /*ClockManager::*/normalizeSup( ptinsth vharg1 ,ptinsth vharg2 );

/**
  It holoph-simplifies a complementary formula.
  @param vharg1 is the term of a not-formula (assumed),
  @param vharg2 a formula;
  @param  newterm result of the simplification
  @return 
  - "true" if the not(vharg1) ^* vharg2 is holoph-simplified in newterm,
  - "false" otherwise (newterm is not assigned).
 */
boolean /*ClockManager::*/infReducehnot( int holoph ,ptinsth vharg1 ,ptinsth vharg2 ,ptinsth* newterm );

/**
   It holoph-simplifies vterm2 by removing the terms T of vterm2 such that T*vharg1 = ^0.

   @param vharg1 (in) is an extraction (assumed),
   @param vterm2 (in/out) a formula, vterm2 (out) the holoph-simplification of vterm2 (in) by vharg1.

   @return 
   - "true" if the vharg1 ^* vharg2 is holoph-simplified in null clock,
   - "false" otherwise (vterm2 can be modified).
 */
boolean /*ClockManager::*/infReduceNullClockExtract( int holoph ,ptinsth vharg1 ,ptinsth* vterm2 );

/**
   It holoph-simplifies vterm2 by removing the terms T of vterm2 such that T*vharg1 = ^0.

   @param vharg1 (in) is an extraction (assumed),
   @param vterm2 (in/out) a formula, vterm2 (out) the holoph-simplification of vterm2 (in) by vharg1.

   It calls infReduceNullClockExtract() for vharg1 an extraction.
   
   @return 
   - "true" if the vharg1 ^* vharg2 is holoph-simplified in null clock,
   - "false" otherwise (vterm2 can be modified).
 */
boolean /*ClockManager::*/infReduceNullClock( int holoph ,ptinsth vharg1 ,ptinsth* vharg2 );

/**
   It holoph-simplifies a term (T) vharg1 ^* vharg2 without decomposition of the term vharg2.
   @return "true" if the term T is holoph-simplified in vharg2, false otherwise.
   if breduce, vharg1 (out) is vharg1 (in) - the elements greater than vharg2 (in).
 */
boolean /*ClockManager::*/infRemainder( int holoph ,boolean breduce ,ptinsth* vharg1 ,ptinsth* vharg2 );

/**
   @return "true" if the term vharg1 ^*vharg2 is holoph-simplified in vharg2, false otherwise.
 */
boolean /*ClockManager::*/infWithoutRemainder( int holoph ,ptinsth* vharg1 ,ptinsth* vharg2 );

/**
   It holoph-simplifies a term vharg1 ^+ vharg2 without decomposition of the term vharg2.
   @return 
   - "true" if the term vharg1 ^+ vharg2 is holoph-simplified in vharg2 (out) 
   - "false" otherwise.
   vharg1(out) and vharg2 (out) are reduced if breduce.
 */
boolean /*ClockManager::*/supRemainder( int holoph ,boolean breduce ,ptinsth* vharg1 ,ptinsth* vharg2 );

/**
  It holoph-simplifies a term (T) of the form (x ^* y) ^+ vharg2.
  @param vharg1 a complementary formula (assumed),
  @param vharg2 a formula;
  @param newterm result of the simplification
  @return 
  - "true" if T is simplified in newterm,
  - "false" otherwise (newterm is not assigned).
 */
boolean /*ClockManager::*/supReducehnot( int holoph ,ptinsth vharg1 ,ptinsth vharg2 ,ptinsth* newterm );

/**
   It holoph-simplifies a term (T) vharg1 ^+ vharg2 without decomposition of the term vharg2.
   vharg1 and vharg2 can be modified.
   @return "true" if the result of the simpliciation is vharg2 (out), "false" otherwise.
 */
boolean /*ClockManager::*/supWithoutRemainder( int holoph ,ptinsth* vharg1 ,ptinsth* vharg2 );

/**
   It holoph-simplifies the term (T) vharg1 ^*vharg2 using 
    - (A) classical boolean rules if the operands are not in the same tree of clocks;
    - (B) tree reduction technique otherwise.
   @return the result of the simplification of T.
   @param vcommu (in) at pk_true for applying commutativity, otherwise vharg2 is not decomposed in (A).
   @param vfinf  (in) : original formula (vharg1 ^*vharg2) or undefined clock. When it is undefined, formula are
   created in the system, otherwise the original formula is replaced or rewritten.
   @param holoph (in) : depth of solving used to limit the rewritings in (A).
 */
ptinsth /*ClockManager::*/booleanReducedInf( int holoph ,ptinsth vfinf ,ptinsth vharg1 ,ptinsth vharg2 ,boolean vcommu );

/**
   It holoph-simplifies the term (T) vharg1 ^+ vharg2 using 
    - (A) classical boolean rules if the operands are not in the same tree of clocks;
    - (B) tree reduction technique otherwise.
   @return the result of the simplification of T.
   @param vcommu (in) at pk_true for applying commutativity, otherwise vharg2 is not decomposed in (A).
   @param vfsup (in) : original formula (vharg1 ^*vharg2) or undefined clock. When it is undefined, formula are
   created in the system, otherwise the original formula is replaced or rewritten in the system.
   @param holoph (in) : depth of solving used to limit the rewritings in (A).
 */
ptinsth /*ClockManager::*/booleanReducedSup( int holoph ,ptinsth vfsup ,ptinsth vharg1 ,ptinsth vharg2 ,boolean vcommu );

/**
   It applies the rule : ( F ^+ [c] ) ^+ [not(c)]  -> F ^+  ^c
   If vharg1 (in) is a term of the form (F ^+ [c]), and if vharg2 a term of the form [not(c)] 
   it returns 
    - "true", and vharg1 (out) becomes F, vharg2 (out) becomes ^c
    - "false" otherwise.
 */
boolean /*ClockManager::*/supConditionCompl( ptinsth* vharg1 ,ptinsth* vharg2 );

/**
   @return 
     - false if it does not exists some equivalences to do, 
     - true otherwise, in this case it builds this equivalences and the induced equivalences.
 */
boolean /*ClockManager::*/hclmklequiv( int holoph );

/** 
    @return "true" if vharg1 < vharg2 using the hierarchy, "false" otherwise.
    \remarks The inclusion test depends on the global variable strongInclusionTest.
  */
boolean /*ClockManager::*/isIncluded( ptinsth vharg1 ,ptinsth vharg2 );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*ClockManager::*/hredhnotNullClock( ptinsth vharg1 ,ptinsth vharg2 );


