/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
   @return 
   - pk_true if the clock is not a placed one and if a formula (vh), not representative formula of its class, 
   is a syntactic formula equivalent to the representative element.
   - false otherwise (in particular when the class is a singleton, or the clock is place placed).
 */
boolean /*ClockManager::*/isOtherSyntacticFormOfRepresentativeFormula( ptinsth vh );

/** Building elementary tree.
    @param vh1 (in) : an positive extraction formula ([C]),
    @param vh2 (in) : an negative extraction formula on the same condition than vh1 ([not C]),
    @param vh (in) the clock of C (assumed);
    @return "true" the elementary tree (vh1 and vh2 added as children of vh) is build,
    false when the clocks (in which vh1, or vh2 are elements) are already placed, or must be reduce to null clock.
 */
boolean /*ClockManager::*/buildElementaryTreeFromSub( ptinsth vh ,ptinsth vh1 ,ptinsth vh2 );

/**
   @return 
   - pk_true if the formula (vharg1 ^* vharg2) is placed in a tree, \b otherterm contains the placed formula.
   - false if vharg1 and vharg2 are not placed in the same tree, \b otherterm is not available.
 */
boolean /*ClockManager::*/treeReduceInf( ptinsth vharg1 ,ptinsth vharg2 ,ptinsth* otherterm );

/**
   @return 
   - pk_true if the formula (vharg1 ^+ vharg2) is placed in a tree, \b otherterm contains the placed formula.
   - false if vharg1 and vharg2 are not placed in the same tree, \b otherterm is not available.
 */
boolean /*ClockManager::*/treeReduceSup( ptinsth vharg1 ,ptinsth vharg2 ,ptinsth* otherterm );

/**
   @return 
   - pk_true if the formula vfinf = vharginf ^- vharghnot is placed in a tree, \b otherterm contains the placed formula.
   - false if vharginf and vharghnot are not placed in the same tree, \b otherterm is not available.
 */
boolean /*ClockManager::*/treeReduceInfhnot( ptinsth vfinf ,ptinsth vharghnot ,ptinsth vharginf ,ptinsth* newterm );

/** 
    It finalizes the hierarchy by setting the access to the children of each clock (during the clock calculus, 
    trees are build using the "father" fonction).
    @return the clock tick (master clock) for endochonous system, "fictitious" root otherwise.
 */
ptinsth /*ClockManager::*/finalizeClockHierarchy( void );

/** Clock  Hierachy.
    The tree assigned to a clock (vh) is placed under (as a child) the tree assigned to another clock (f).
    @return the placed clock.
 */
ptinsth /*ClockManager::*/addPlaced( ptinsth vh ,ptinsth f );

/** Clock  Hierachy.
    It calls ClockManager::addPlaced() and assocites to vh the same bdd than vo.
    vh is a clone of vo (other clock System, but they have the same associated bdd).
    @return the placed clock.
 */
ptinsth /*ClockManager::*/addPlacedClone( ptinsth vh ,ptinsth f ,ptinsth vo );

/** 
   It resets a clock (vh) as a root in the hierarchy and recursively 
   the clocks with a formula that references it.
   @return true if the clock is initialy placed (and it re-becomes a root), false otherwise.
 */
boolean /*ClockManager::*/resetClockAsRoot( ptinsth vh );

/**
   It resets the clocks of a list (lh) as roots of the hierarchy.
   \see resetClockAsRoot
 */
void /*ClockManager::*/resetClocksAsRoot( ptlinsth lh );

/** clocktreefront is initialized from systemSolving
    It initializes the BDD system solving: ClockHierarchy2BDD, BDDHierarchy, BDD2ClockHierarchy
    The null clock is assumed to be defined
   \see treeEndSolving
 */
void /*ClockManager::*/clocktreefront_init( void );

/**
   It stops the tree placing mechanism.
   \see clocktreefront_init
 */
void /*ClockManager::*/treeEndSolving( void );

/**
   It prepares the system for new modifations.
   It must be called when the hierarchy is build (\ref finalizeClockHierarchy  has been applied).
   Then the system can be completed and the \ref clockCalculus "clock calculus" re-applied.
   @return the list of the clocks, children, before the call, of the fictitious root.
  */
ptlinsth /*ClockManager::*/initSystemForModification( void );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*ClockManager::*/removeBDDClock( ptinsth vh );


