/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PROTECTED_
/** For Debugging.
    It prints the list of the signals of the operand list  (l).
*/
  void
ClockSystem::PRINTCLASS (ptlinstances l)
{
  ptexpcal e;
  boolean first;

  pK_messenger->printStringDebug (string2repstr ("<"));
  first = pk_true;
  while (ptlinstances_get_next (&l, &e))
    {
      if (!first)
	pK_messenger->printStringDebug (string2repstr (","));
      else
	first = pk_false;
      //      pK_messenger->printStringDebug(EM->getName(e));
    }
  pK_messenger->printStringDebug (string2repstr ("<"));
}

/** For Debugging ; used for tracing the synchronization of two clocks.
    It prints, if DEBUG global attribute is "true" and if vh1 is different from vh2, 
    the list of the signals associated to each operand clocks (vh1 and vh2).
    The parameter bconstraint at "true" specifies that the two (different) clocks are not root of a hierarchy.
*/
void
ClockSystem::PRINTCLOCKSYNCHRO (ptinsth vh1, ptinsth vh2, ptinsth vhres, boolean bconstraint)
{
  ptlinstances l1, l2;
  ptrepstr mess;

  if (DEBUG)
    if (vh1 != vh2)
      {
	l1 = getSynchronousSignals (vh1);
	l2 = getSynchronousSignals (vh2);
	if (bconstraint)
	  mess = string2repstr ("Fusion : ...CONSTRAINT...");
	else
	  mess = string2repstr ("Fusion : ");
	pK_messenger->printStringDebug (mess);
	PRINTCLASS (l1);
	PRINTCLASS (l2);
	pK_messenger->printStringDebug (string2repstr ("---------"));
      }
}
