
_PROTECTED_
/** Ordre sur les formules. */
  boolean ClockSystem::satisfies_order_extracts (ptinsth vharg1, ptinsth vharg2)
{
  ptinsth vh;
  pkClockType op1, op2;

  op1 = getOperator (vharg1);
  op2 = getOperator (vharg2);
  if (op1 == sub)
    {
      if (op2 == sub)
	return satisfies_order_num (vharg1, vharg2);
      getComplExtraction (vharg2, &vh);
      return (boolean) (!satisfies_order_num (vh, vharg1));
      // return (boolean) (!satisfies_order_num(vharg2->Operand.opsub1 ->get_clksub(), vharg1));
    }
  else
    {
      // vharg1 = vharg1->Operand.opsub1->get_clksub();
      getComplExtraction (vharg1, &vharg1);
      if (op2 == sub)
	return satisfies_order_num (vharg1, vharg2);
      getComplExtraction (vharg2, &vh);
      // return satisfies_order_num(vharg1, vharg2->Operand.opsub1->get_clksub());
      return satisfies_order_num (vharg1, vh);
    }
}

/**
   Order on formula.
   @return num(?vharg1) < num(?vharg2).
*/
boolean ClockSystem::satisfies_order_num (ptinsth vharg1, ptinsth vharg2)
{
  return (getNum (vharg1) <= getNum (vharg2));
}

/**  Order on formula.
     Assumed : the operand formula, vh1 and vh2, are placed in the same tree.
     Used order:
             - extraction < others (lower bound, upper bound,...),
             - vh1, vh2 extractions, num(positive extraction(vh1)) < num(positive extraction(vh2)),
             - num(vh1) < num(vh2) otherwise.
      @return true if vh1 is less than vh2 (vh1 < vh2) with the defined order, false otherwise.

*/
boolean ClockSystem::satisfies_order_sametree (ptinsth vh1, ptinsth vh2)
{
  pkClockType
    vop2;

  switch (getOperator (vh1))
    {
    case sub:
    case nosub:
      vop2 = getOperator (vh2);
      if ((vop2 == sub) || (vop2 == nosub))
	return satisfies_order_extracts (vh1, vh2);
      return pk_true;
      break;

    case infer:
    case super:
      vop2 = getOperator (vh2);
      if ((vop2 == sub) || (vop2 == nosub))
	return pk_false;
      return satisfies_order_num (vh1, vh2);
      break;

    case vari:
      return satisfies_order_num (vh1, vh2);
      break;

    case hnot:
      break;
    default:;
    }
  return pk_false;
}

/**  Order on formula.
     Assumed : the operand formula, vh1 and vh2, are not placed in the same tree.
     Used order:
             - vari < others (extractions, lower bound, upper bound, ...)
             - num(vh1) < num(vh2)
	     @return true if vh1 is less than vh2 (vh1 < vh2) with the defined order, false otherwise.	     
*/
boolean ClockSystem::is_order_difftrees (ptinsth vh1, ptinsth vh2)
{
  pkClockType
    op1,
    op2;
  op1 = getOperator (vh1);
  op2 = getOperator (vh2);
  if (op1 == vari)
    {
      if (op2 == vari)
	return satisfies_order_num (vh1, vh2);
      return pk_true;
    }
  if (op2 == vari)
    return pk_false;
  return satisfies_order_num (vh1, vh2);
}
