/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

/*
   -----------------------------------------------------------------------
   Managing of the link between a clock and its associated sub-graph. 
   -----------------------------------------------------------------------*/

/**
   Initializing the operand descriptor (vig)
*/
static void
GraphInfos_init (ptGraphInfos vig)
{
  vig->gfd = ptgfd_create ();
  vig->lsucci = NIL_lINode;
  vig->lsig = NIL_linstances;
  vig->interface = NILINTERFACE;
  vig->ptINodebc = NIL_INode;
  vig->lsigkept = NIL_linstances;
}

/**
  It merges the nodes of graphs of the two operand cloks (vhold, vhnew) with result in vhnew (side effects).
*/
static void
ptinsth_fusion_gfd (ptinsth vhold, ptinsth vhnew)
{
  ptGraphInfos vigvhold, vigvhnew;

  vigvhold = ptinsth_get_GraphInfos (vhold);
  vigvhnew = ptinsth_get_GraphInfos (vhnew);
  vigvhnew->gfd = ptgfd_fusion (vigvhold->gfd, vigvhnew->gfd);
  ptgfd_init (vigvhold->gfd);	// added Apr 2012 LBesnard.
}
