/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
/**
   @return the root of the hierarchy of a clock (vh).
*/
static ptinsth
ptinsth_get_xroot (ptinsth vh)
{
  vh = ptinsth_get_clhead (vh);
  if (vh->root == NILINSTH)
    return vh;
  return ptinsth_get_clhead (vh->root);
}

/**
   @return the root of the hierarchy of a clock (vh).
   The depth of the operand clock (vh) is updated using the previous value (p) and returned (effect_depth).
*/
static ptinsth
recroot (ptinsth vh, int p, int *effect_depth)
{
  ptinsth vhrac;

  vhrac = ptinsth_get_xroot (vh);
  *effect_depth = ptinsth_get_depth (vhrac);
  if ((*effect_depth) > 0)
    {
      vhrac = recroot (vhrac, *effect_depth, effect_depth);
      *effect_depth = (*effect_depth) + p;
      ptinsth_set_root (vh, vhrac, *effect_depth);
    }
  else
    *effect_depth = p;
  return vhrac;
}
