/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#ifndef __ObjectCommonInfos_H__
#define __ObjectCommonInfos_H__

typedef class ObjectCommonInfos * ptObjectCommonInfos; ///< pointer to a ObjectCommonInfos object.

typedef enum {undefObject, ///< Undefined object type (default)
	      exprObject, ///< For an expression (expcal type)
	      nodeObject, ///< For a node (INode type)
	      clockObject,///< For a clock (insth type)
	      // dependenceObject, ///<  For a dependence (dependence type)
	      graphObject, ///< For a Graph (IGraph type)
	      automatonObject  ///< For an automaton (Automaton type)
} objectType;

class ObjectCommonInfos
{
#include "ObjectCommonInfos_m.h"
#include "ObjectCommonInfos_g.h"
  
private:
  objectType whoami; ///< Who am I
  ptlMark lmark; ///< list of marks
  ptlAttributes userData; ///< List of attributes
  ptlpragmas vpragmas ; ///< List of pragmas
  int num; ///< number of the object.
};

#include <map>
typedef std::map<pointer, pointer> TablePointerPointerType;
typedef TablePointerPointerType *ptTablePointerPointer;


typedef std::map<pointer, int> TablePointerInteger;
typedef TablePointerInteger *ptTablePointerInteger;

#endif // __ObjectCommonInfos_H__
