/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/


/**
   Representation of an interface composed of 
    - input clocks, output clocks, local clocks
    - input signals, output signals, local signals
    - parameters
    - constants
*/

typedef struct interface
{
  ptlinsth inClocks, outClocks, localClocks;
  ptlinstances inSignals, outSignals, localSignals;
  ptlinstances lpar, lconstants;
  ptlinstances inOutSignals;

  ptinterface next;
} tinterface;

/// Garbaging: list of free descriptors.
static ptinterface gcinterface = NILINTERFACE;


/** 
    @return the list l1 \{x, for all x of l2}.
 */
static ptlinstances
connectinstances (ptlinstances l1, ptlinstances l2)
{
  ptexpcal e;
  while (ptlinstances_get_next (&l2, &e))
    ptlinstances_isin_remove_exp (&l1, e);
  return l1;
}

#define isArrayLocalSignal(XXX) (pk_false)
