/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
   Fields of structure management: for a signal of structured type, the compiler assigns a fictitious signal 
   to each field to have the same access (getting clock, getting node,...) than standart signal. 
   This method assigns a signal (s) to a reference of a field of a structure (e):
   for x.y, a signal s is created and associated with it. 
   \note
   - The link (e,s) is managed using an attribute called FIELD_SIGNAL.
   - When s is NILEXPCAL, the association of e with its "fictitious" signal is deleted.
 */
void /*ExprManager::*/setSignalAssignedTo( ptexpcal e ,ptexpcal s );

/**
   Fields of structure management: it assigns a list of signals (ls) to a signal (e) for e a structured signal.
   A signal (u) of ls is the signal associated with a field of e (x.f) \see setSignalAssignedTo().
   \note the list (ls) is associated with e as an attribute called FIELDSLIST.
 */
void /*ExprManager::*/setFieldsOf( ptexpcal e ,ptlinstances ls );

/**
   It associates the definition (node) to a signal (vsig) or an access to an element (x[]) of an array.
   For x[], the node is associated with x and an attribute is set for linking x[] to node (setNodeAccessToArrayElement()). 
   So, the node of x can evolved during the compiling (in array blocks for example).
 */
void /*ExprManager::*/setNode( ptexpcal vsig ,ptINode node );

/**
   It sets to an expression (exp) its type (vtyp).
 */
void /*ExprManager::*/setType( ptexpcal exp ,TypeType vtyp );

/**
   @param exp (in) is a "opereh" expression (when/cell expression).
   @param h  (in) a clock.
   It assigns the clock h as second operand of the expression.
 */
void /*ExprManager::*/setContributionClock( ptexpcal exp ,ptinsth h );

/**
   @param vsig (in) is a "variabl" expression (signal identifier).
   @param id (in) an identifier.
   It assigns the name (id) of a signal (vsig).
 */
void /*ExprManager::*/setName( ptexpcal vsig ,ptident id );

/** 
    @param  exp (in) is a "variabl" expression (signal identifier).
    @param vdecl (in) a tree address (declaration of the signal in the abstract tree produced by the parser).
    It links a signal (exp) to its tree-declaration (vdecl).
 */
void /*ExprManager::*/setTreeOfSignalDeclaration( ptexpcal exp ,ntrees vdecl );

/** 
   It sets  the initial expression of a signal.
   @param  vsig (in) is a signal identifier (assumed).
   @param valini (in) initialization expression.
 */
void /*ExprManager::*/setInitialValue( ptexpcal vsig ,ptexpcal valini );

/** 
   @param vexp (in) any signal expression.
   @param vhsub (in) the extraction (clock) built on vexp.
   It sets  the link clock-expression vhsub = [vexp].
  */
void /*ExprManager::*/setExtractionLink( ptexpcal vexp ,ptinsth vhsub );

/**
   It defines the state variable attribute of an identifier by b.
   When b is pk_true, it specified that exp is a stqte variable. By default a signal IS NOT a state variable.
 */
void /*ExprManager::*/setStateTag( ptexpcal exp ,boolean b );

/**
   It declared exp as a shared signal if b.
   By default a signal IS NOT a shared variable.
 */
void /*ExprManager::*/setSharedSignal( ptexpcal exp ,boolean b );

/**
   It defines a int signal(exp) as a constant signal with val as value.
 */
void /*ExprManager::*/set_integerValueHolder( ptexpcal exp ,long int val );

/**
   It assigns the bounds [lb, up] to an expression (exp).
 */
void /*ExprManager::*/setBounds( ptexpcal exp ,compilerInteger lb ,compilerInteger up );

/**  Indexed signals (array process)
     \DocNotComplete
 */
void /*ExprManager::*/setException( ptexpcal exp ,ptexpcal vexception );

/** 
    @param exp (in) an identifier.
    It specifies that exp is a signal
    \note an identifier can be a signal, a parameter, an index ...
 */
void /*ExprManager::*/belongsSignal( ptexpcal exp );

/** @param exp (in) an identifier.
    It specifies that exp is an input signal. 
 */
void /*ExprManager::*/belongsInFlow( ptexpcal exp );

/** @param exp (in)  an identifier.
    It specifies that exp is an output signal.
 */
void /*ExprManager::*/belongsOutFlow( ptexpcal exp );

/** @param exp (in)  an identifier.
    It specifies that the signal (exp) is a local signal.
 */
void /*ExprManager::*/belongsLocalFlow( ptexpcal exp );

/**
   A signal (pt) belongs a free (not defined, not assigned,...) signal.
 */
void /*ExprManager::*/belongsFreeSignal( ptexpcal pt );

/**
   A signal (pt) belongs defined (but not valued).
 */
void /*ExprManager::*/belongsDefined( ptexpcal exp );

/** 
    It links an expression (n) with the original tree (ba) it comes from.
 */
void /*ExprManager::*/setBackAnnotation( ptexpcal n ,BackAnnotationType ba );

/** 
    Setting travel indexes to an expression.
    @param exp (in) a signal expression.
    @param l (in) a list of indexes.
    \note \DocNotComplete (what is a "travel index"?)
 */
void /*ExprManager::*/setTravelIndexes( ptexpcal exp ,ptlinstances l );

/**
   Setting the list of optimized travel indexes to an expression.
   @param exp (in) a signal expression.
   @param l (in) the list of indexes.
   \note \DocNotComplete (what is a "travel index"?, what is an optimized "travel index"?)
 */
void /*ExprManager::*/setOptimizedTravelIndexes( ptexpcal exp ,ptlinstances l );

/**
   It links a node (node) to an access to an element (s) of an array.
 */
void /*ExprManager::*/setNodeAccessToArrayElement( ptexpcal s ,ptINode node );

/** Array management:
    It links (bidirectionnal) a clone (vClone) to a signal (v). (x[I] is a clone of x, x[I,J] a clone of x[I],...).
    An object (v) not yet cloned is the "clone class head" element.
    Note that it is a circular list with a header element.
    \see setCloneClassHead(), isCloneClassHead(), setClone().
 */
void /*ExprManager::*/setClone( ptexpcal v ,ptexpcal vClone );

/**
   v is declared as the "clone class head" element of its class: 
    - x[I] is a clone of x, 
    - x[I,J] a clone of x[I],...),
    - an object (v) not yet cloned is the "clone class head" element (setCloneClassHead()).
 */
void /*ExprManager::*/setCloneClassHead( ptexpcal v );

/** 
    It assigns a clock (vclk) to a signal (vsig). No effect if vsig is not a signal.
 */
void /*ExprManager::*/setClock( ptexpcal vsig ,ptinsth vclk );

/**
   If the name (id) of vsig is without suffix, and if it exists an another signal (vs) with the same prefix identifier than vsig, 
   then vs is recalled id.
   
   \note the removeIdent methode must be applied before calling this method. It must be used when a signal (vsig) is removed from the graph.

   \see{removeIdent}
 */
void /*ExprManager::*/changeNameSignalSamePrefix( ptexpcal vsig );

/**
   @param vexp (in) any signal expression.
   @param nexp (in) any signal expression.
   It sets an indirection from vexp to nexp.
   \note MISC.
 */
void /*ExprManager::*/setIndirection( ptexpcal vexp ,ptexpcal nexp );

/** 
    It sets the identifier assigned to a signal (aSig).
    If a signal (aSig) is not a declared signal (i.e. it has been added by the compiler),
    and if codeOp is the delay operator (opret), the name of aSig is defined by 
    \e pre_X where \e X denotes the identifier associated with vfrom. The prefix (\e pre) is given by getDelayId(). 

    @return "true" if the operation succeeds, "false" otherwise.
    \note
    - MISC operation.
    - Restriction: implemented only for delay.
 */
boolean /*ExprManager::*/changeUndefinedName( ptexpcal aSig ,ptexpcal vfrom ,noperators codeOp );

/**
   The name of a signal (vsig) is defined by the name of the original identifier on which is is built.
   This name is propagated to its clones.
 */
void /*ExprManager::*/setOriginalName( ptexpcal vsig );

/** 
    The operand identifier (vsig) is a Signal added by the Signal ToolBox.
 */
void /*ExprManager::*/setAuxiliarySignal( ptexpcal vsig );

/**
   It sets that a signal (aSig) is unified with a clock (clk).
   If clk is the predefined undefined clock, the association is removed.
 */
void /*ExprManager::*/setSignalUnifiedWithClock( ptexpcal aSig ,ptinsth clk );

/**
   It assigns to a signal (vsig)  the clock (vh) at which the signal 
   is not defined by  the (assumed) operand constant value (vExpr).
 */
void /*ExprManager::*/setDefaultConstantValueInfos( ptexpcal vsig ,ptinsth vh ,ptexpcal vExpr );

/**
   It defines the assignment clock of a signal (exp) by assClock.
 */
void /*ExprManager::*/setAssignmentClock( ptexpcal exp ,ptinsth assClock );

/**
   It defines the utility clock of a signal (exp) by hu.
 */
void /*ExprManager::*/setUtilityClock( ptexpcal exp ,ptinsth hu );

/**
   It defines the utility clock of a signal (exp) in a subgraph (sg) by hu.
 */
void /*ExprManager::*/setUtilityClockInSubGraph( ptexpcal exp ,ptINode sg ,ptinsth hu );

/**
   A signal (vsig) is marked as a shared signal by several graphs if b, otherwise it is unmarked.
 */
void /*ExprManager::*/setSharedSignalBySeveralGraphs( ptexpcal vsig ,boolean b );


