/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
   It builts and assigns the name of a signal.
   @param vexpcal (in) must be an identifier expression.
   @param r (in) tree-identifier prefix for the name construction.
   @param appendSuffix (in) Tag for ident manipulation.
   @return the tree-identifier obtained :
   - by concatenating r and the number of vexpcal when appendSuffix
   - by substituing the suffix of r by the number of vexpcal when not appendSuffix
 */
ptident /*ExprManager::*/mkSignalName( ptexpcal vexpcal ,ptident r ,boolean appendSuffix );

/** @return the expression of a type reference (effective parameter for a call)  */
ptexpcal /*ExprManager::*/mkExpType( TypeType t );

/** @return the expression of a call reference to an external model 
    characterized by 
    - its name (id),
    - some parameters (lparams),
    - some inputs (ins), 
    - its clock (vh) 
    - and its result type (typeRes).
 */
ptexpcal /*ExprManager::*/mkCallExp( ptident id ,ptexpcal lparams ,ptexpcal ins ,TypeType typeRes ,ptinsth vh );

/**
   @return the expression which denotes a structure/bundle field identifier.
   \see{mkIdentExp} for the description of the parameter.
 */
ptexpcal /*ExprManager::*/mkIdentField( ptident r ,TypeType TT ,ptinsth clk );

/**
   It creates a new expression which denotes an identifier (instance of a flow).
   @param r (in) tree-identifier used as prefix to build the name of the instance.
   @param ti (in) specialisation of the identifier as a signal, constant, ...
   @param TT  (in) type of the signal.
   @param clk clock of the signal (it can be "hundef" value)
   @param node (in) node of the signal (can be "opnil" one)
   @param ar (in) abstract tree of the declaration of the flow(parser information).
   @return the created identifier.
 */
ptexpcal /*ExprManager::*/mkIdentExp( ptident r ,typinst ti ,TypeType TT ,ptINode node ,ptinsth clk ,BackAnnotationType ar );

/** 
    Similar to mkIdentExp(ptident, typinst, TypeType, ptINode, ptinsth, ntrees).
    Moreover, the signal is initialized by vinit expression.
 */
ptexpcal /*ExprManager::*/mkIdentExp( ptident r ,typinst ti ,TypeType TT ,ptexpcal vinit ,ptINode node ,ptinsth clk ,BackAnnotationType ar );

/**  It creates a new expression which denotes an Index identifier.
     @param id (in) tree-identifier used as prefix to build the name of the instance.
     @param uBound (in) the max value of the index (NILEXPCAL if unkown).
     @param node (in) node of the signal (can be "opnil" one)
     @param clock (in) clock of the signal (can be "hundef" value)
     @param vt (in) abstract tree of the declaration of the flow(parser information)
     @return the created identifier.
 */
ptexpcal /*ExprManager::*/mkIndexIdent( ptident id ,ptexpcal uBound ,ptINode node ,ptinsth clock ,BackAnnotationType vt );

/**  It creates a new expression which denotes an Label identifier.
     @param id (in) tree-identifier used as prefix to build the name of the instance.
     @param node (in) node of the signal (can be "opnil" one)
     @param clock (in) clock of the signal (can be "hundef" value)
     @param vt (in) abstract tree of the declaration of the flow(parser information)
     @return the created identifier.
 */
ptexpcal /*ExprManager::*/mkLabelIdent( ptident id ,ptINode node ,ptinsth clock ,BackAnnotationType vt ,boolean badded );

/**
   @return a new signal, copy of a model (vexpcal), characterized by a node (vinstr), and the same name than the model.
   Moreover, the signals (vexpcal and the copy) are chained (see setClone()) to keep the link between clones. It is used for the compiling of arrays
   to keep the link x, x[], x[][],...
 */
ptexpcal /*ExprManager::*/mkIdentClone( ptexpcal vexpcal ,ptINode vinstr );

/**
   @return a new signal, copy of a model (vexpcal), characterized by a node (vinstr) and a clock (vclk). 
   A new name is assigned to the created signal if bkeepname, otherwise the same name is used.
 */
ptexpcal /*ExprManager::*/mkIdentCopy( ptexpcal vexpcal ,ptINode vinstr ,ptinsth vclk ,boolean bkeepname );

/**
   @return a new signal, copy of a model (vexpcal), characterized by a node (vinstr) and a clock (vclk). 
   A new name is assigned to the created signal.
 */
ptexpcal /*ExprManager::*/mkIdentCopy( ptexpcal vexpcal ,ptINode vinstr ,ptinsth vclk );

/**
   Builting a constant nil expression.
   @param cst  (in) value of the constant (string memory value)
   @return the representation of the constant, (constant operator Class).
 */
ptexpcal /*ExprManager::*/mk_nilPtexpcal( ptrepstr cst );

/**
   Builting a constant name expression.
   @param cst  (in) value of the constant (string memory value)
   @return the representation of the constant, (constant operator Class).
 */
ptexpcal /*ExprManager::*/mk_namePtexpcal( ptrepstr cst );

/**
   Builting a constant enum value string.
   @param cst  (in) value of the constant (string memory value)
   @return the representation of the constant, (constant operator Class).
 */
ptexpcal /*ExprManager::*/mk_enumPtexpcal( ptrepstr cst );

/**
   Builting a constant char value string.
   @param cst  (in) value of the constant (string memory value)
   @return the representation of the constant, (constant operator Class).
 */
ptexpcal /*ExprManager::*/mk_charPtexpcal( ptrepstr cst );

/**
   Builting a constant string value string.
   @param cst  (in) value of the constant (string memory value)
   @return the representation of the constant, (constant operator Class).
 */
ptexpcal /*ExprManager::*/mk_stringPtexpcal( ptrepstr cst );

/**
   Builting a Constant integer value string.
   @param op (in) signal constant operator
   @param cst  (in) value of the constant (string memory value)
   @return the representation of the constant, (constant operator Class).
 */
ptexpcal /*ExprManager::*/mk_integerPtexpcal( ptrepstr cst );

/**
   Builting a Constant real value string
   @param op (in) signal constant operator
   @param cst  (in) value of the constant (string memory value)
   @return the representation of the constant, (constant operator Class).
 */
ptexpcal /*ExprManager::*/mk_realPtexpcal( ptrepstr cst );

/**
   Builting a Constant double precision real value string.
   @param op (in) signal constant operator
   @param cst  (in) value of the constant (string memory value)
   @return the representation of the constant, (constant operator Class).
 */
ptexpcal /*ExprManager::*/mk_dprealPtexpcal( ptrepstr cst );

/**
   Builting a Constant expression.
   @param op (in) signal constant operator
   @param cst  (in) value of the constant (string memory value)
   @return the representation of the constant, (constant operator Class).
 */
ptexpcal /*ExprManager::*/mkConstantExp( noperators op ,ptrepstr cst );

/**
   Builting an int Constant expression.
   @param val (in) value of the constant.
   @return the representation of the constant (constant operator Class)
 */
ptexpcal /*ExprManager::*/mkIntegerConstant( compilerInteger val );

/**
   Builting a Synchronous Unary expression.
   @param op (in) Signal Unary operator (assumed).
   @param e1 (in) child of the Unary expression.
   @param vt (in) abstract tree of the declaration of the flow(parser information)
   @return Unary expression op(e1), (oper1 operator Class)
 */
ptexpcal /*ExprManager::*/mkUnaryExp( noperators op ,ptexpcal e1 ,BackAnnotationType vt );

/**
   Builting a Synchronous binary expression.
   @param op (in) Signal binary operator (assumed).
   @param e1,e2 (in) children of the Binary expression.
   @param vt (in) abstract tree of the declaration of the flow(parser information)
   @return Binary expression op(e1, e2), (oper2 operator Class)
 */
ptexpcal /*ExprManager::*/mkBinaryExp( noperators op ,ptexpcal e1 ,ptexpcal e2 ,BackAnnotationType vt );

/**
   Builting a Synchronous Ternary expression. 
   @param op (in) Signal ternary operator (assumed).
   @param e1,e2,e3 (in) children of the ternary expression.
   @param vt (in) abstract tree of the declaration of the flow(parser information)
   @return Ternary expression op(e1, e2, e3) (oper3 operator Class).
 */
ptexpcal /*ExprManager::*/mkTernaryExp( noperators op ,ptexpcal e1 ,ptexpcal e2 ,ptexpcal e3 ,BackAnnotationType vt );

/**
   Builting a Synchronous list expression. Implemented as a combed binary expression.
   @param op (in) Signal list operator (assumed).
   @param e1 (in) first child of the list.
   @param e2 (in) tail of the list.
   @param vt (in) abstract tree of the declaration of the flow(parser information)
   @return list expression op(e1, e2), (oper2 operator Class).
 */
ptexpcal /*ExprManager::*/mkNaryExp( noperators op ,ptexpcal e1 ,ptexpcal e2 ,BackAnnotationType vt );

/**
   Builting a list of expressions reduced to one element (e1).
   @param op (in) Signal list operator (assumed).
   @param e1 (in) first child of the list.
   @param vt (in) abstract tree of the declaration of the flow(parser information)
   @return the list expression.
 */
ptexpcal /*ExprManager::*/mkNaryExp( noperators op ,ptexpcal e1 ,BackAnnotationType vt );

/**
   Concatenating two lists of expressions: the elements of a list (l1) are added before the elements of a second list (l2).
   When l2 is empty, l1 is duplicated !!!.
   @param l1 (in) a list of expressions (assumed)
   @param l2 (in) a list of expressions (assumed)
   @param vt (in) abstract tree of the declaration of the flow(parser information).
 */
ptexpcal /*ExprManager::*/concatenate( ptexpcal l1 ,ptexpcal l2 ,BackAnnotationType vt );

/**
   Builting a temporal binary expression (default). 
   @param op (in) Signal temporal binary operator (in fact default operator).
   @param e1 (in) first operand of the resulting expression
   @param e2 (in) second operand of the resulting expression
   @param vt (in) abstract tree of the declaration of the flow(parser information)
   @return expression op(e1, e2) (oper2tp operator Class), but the contribution clock is not set (see mkClockedDefault()).
   \note {The expressions e1 and e2  MUST be "when" expressions.}
 */
ptexpcal /*ExprManager::*/mkBinaryExpTp( noperators op ,ptexpcal e1 ,ptexpcal e2 ,BackAnnotationType vt );

/** @return the expression denoting vexp1 \b default vexptoadd and the contribution clock is assigned to the expression.
    It is assumed that
    - vexp1 is a normalized default with a contribution clock
    - vexpToadd is a normalized when expression.
 */
ptexpcal /*ExprManager::*/mkClockedDefault( ptexpcal vexp1 ,ptexpcal vexpToadd );

/**
   Builting a temporal Unary expression (event, unary when).
   @param op (in) Signal temporal unary operator (assumed).
   @param vexp1 (in) child of the expression.
   @param vt (in) abstract tree of the declaration of the expression (parser information).
   @return expression op(e1), (oper1tp operator Class)

   \note Currently, unused by the compiler.
 */
ptexpcal /*ExprManager::*/mkUnaryExpTp( noperators op ,ptexpcal vexp1 ,BackAnnotationType vt );

/**
   Builting a temporal binary expression (when, cell).
   @param op (in) a signal operator; assumed to be the "when" operator or the "cell" operator.
   @param e  (in) left expression of the cell/when expression
   @param ck (in) contribution clock assigned to e
   @return op(e1, ck) (opereh operator Class)
 */
ptexpcal /*ExprManager::*/mkWhenOrCellExp( noperators op ,ptexpcal e ,ptinsth ck );

/** 
    @param vsig  (in) a signal identifier expression (assumed)
    @param nbElements (in) is the number of elements expected for the initializing.
    @param vind (out) new index identifier used to defined the initialisation expression. NIL expression can be returned.
    @param vinit (out) initial value defined fot the signal vsig. This expression is the default value 
    of its type (see Signal reference manual).
    @return "true" if the initial value is defined, false otherwise.
 */
boolean /*ExprManager::*/mkDefaultInit( ptexpcal vsig ,long int nbElements ,ptexpcal* vind ,ptexpcal* vinit );

/** 
    It removes an expression (e) of the expression manager.
    @return true if e was in the manager, false otherwise.
 */
boolean /*ExprManager::*/remove( ptexpcal e );

/**
   It applies the distributivity of the when on the default.
   For e default expression ( (e1 when h1) default ... default (en when hn)) when h 
   it returns (e1 when h1 when h) default ... default (en when hn when h)
 */
ptexpcal /*ExprManager::*/distributivityDefaultClock( ptexpcal e ,ptinsth h );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
ptinsth /*ExprManager::*/getSetAssignmentClock( ptexpcal vexp );


