/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
  */
void /*ExprManager::*/DEBUG_TRUE( char* mess );

/** Expression manager constructor.
    The returned object must be initialized \see{initialize}.
    The following expressions are created:
    - "true": to get it, use getTrue()
    - "false" to get it, use getFalse()
    By default,
    - the unicity of the expressions is guaranteed: see setUnifyExpressionMode() to modify this parameter.
    - the type ckecking is applied for each created expression: see setModeTypeChecking() to modify this parameter.
 */
/*ExprManager::*/ExprManager( void );

/** Destructor   */
/*ExprManager::*/~ExprManager( void );

/**
    It links the expression manager to
    - a node manager (nm),
    - a clock  manager (ckm),
    - a name manager (vNameManager)
    - and a traceability manager (tm)
 */
void /*ExprManager::*/initialize( ptNodeManager nm ,ptClockManager ckm ,ptNameManager vNameManager ,ptTraceabilityManager tm );

/**
   In an expression manager, unicity of syntactic expressions can be asked (b with the value "true") or not (b with the value "false").
   By default the property is guaranted.
 */
void /*ExprManager::*/setUnifyExpressionMode( boolean b );

/**
   In an expression manager, the type checking can be asked (b with the value "true") or not (b "false").
   By default, it is applied.
   @return the value of the mode before the calling to the method.
 */
boolean /*ExprManager::*/setModeTypeChecking( boolean b );

/**
   In an expression manager, the type checking for the access to the elements of an array can
   be asked (b with the value "true") or not (b "false"). By default, it is applied.

   Moreover, the result of the last control is returned (vLastOutOfBoundControl),
   using the following encoding:
   - 0 the bounds are not controlable (default),
   - 1 the indexes are all in the bounds,
   - 2 at lest one of the indexes is out of the bounds.

   @return the value of the mode before the calling to the method.
 */
boolean /*ExprManager::*/setTypeCheckingOutOfBounds( boolean b ,int* vLastOutOfBoundControl );

/**
   In an expression manager, the application of some arithmetic rules for reductions can be asked (b with the value "true")
   or not (b "false").
   By default, they are not applied.
   @return the value of the mode before the calling to the method.
 */
boolean /*ExprManager::*/setArithmeticRuleMode( boolean b );

/** Access to a typed-list of expressions of an expression manager.
    @param vop (in) a Signal operator.
    @param list (out) list of expressions with the vop operator.
    @return true if the output list is not empty.
 */
boolean /*ExprManager::*/getExprList( noperators vop ,ptlexpcal* list );

/** Predefined expression in an expression manager.
    @return the representation of the "false" value.
 */
ptexpcal /*ExprManager::*/getFalse( void );

/** Predefined expression in an expression manager.
    @return the representation of the "true" value.
 */
ptexpcal /*ExprManager::*/getTrue( void );

/** Predefined expression in an expression manager.
    @return the representation of the "false" value.
 */
ptexpcal /*ExprManager::*/get0( void );

/** Predefined expression in an expression manager.
    @return the representation of the "true" value.
 */
ptexpcal /*ExprManager::*/get1( void );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*ExprManager::*/get_ptexpcalConstants( ptexpcal* expcalFalse ,ptexpcal* expcalTrue ,ptexpcal* expcal0 ,ptexpcal* expcal1 );

/** Garbaging.
    It adds an expression (e) in the set of unused expressions.
 */
void /*ExprManager::*/free( ptexpcal e );

/** Solving conflict names :
   - for enumeration type value : a name can be in two enumeration type declaration. It is
   allowed in ADA but not for C, C++.
   This method appends a suffix to a name when a conflict is detected.
   @return "true" if a name has been modified, "false" otherwise.
 */
boolean /*ExprManager::*/enumNameConflicts( void );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*ExprManager::*/printTracebilityInfos( ptident graphname );


