/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

private:

/**
   @return the list of travel indexes of an expression (e) assumed to be an index expression or a list of index expressions.
 */
ptlinstances /*ExprManager::*/mkIndexLst( ptexpcal e );

/**
   @return the list with the greater size.
   The elements of the shorter list are assumed to be equal with the elements of the other one: an indirection is 
   currently set (it should be a constraint).
 */
ptlinstances /*ExprManager::*/getMaxTravelIndexes( ptlinstances l1 ,ptlinstances l2 );

/**
   @return the getMaxTravelIndexes(ptlinstances, ptlinstances) on the list of travel indexes of each expression.
 */
ptlinstances /*ExprManager::*/getMaxTravelIndexes( ptexpcal e1 ,ptexpcal e2 );

/**
   It synthetizes the set of travel indexes for a synchronous unary expression res, defined by op(e1).
   It is defined by:
    - if res= << E >> (cartesian product of indexes),  mkIndexLst() of E
    - the the set of travel indexes of e1, otherwise.
 */
void /*ExprManager::*/SpatialUnary( ptexpcal res ,noperators op ,ptexpcal e1 );

/**
   It assigns the set of the travel indexes of an expression (e1) to an another one res=op(e1), for op a temporal unary operator.
   \note Loïc Besnard: never called, I think.
 */
void /*ExprManager::*/SpatialUnaryTp( ptexpcal res ,noperators op ,ptexpcal e1 );

/**
   It synthetizes the set of travel indexes for a synchronous binary expression res, defined by op(e1, e2).
   It is defined by:
    - if res= E1 next E2 next .... En (each component has its own indices), no synthesis
    - if res=x[E] it is the mkIndexLst() of E
    - if res=x:E  it is the mkIndexLst() of x
    - otherwise, the getMaxTravelIndexes(ptexpcal, ptexpcal) of e1, e2.
 */
void /*ExprManager::*/SpatialBinary( ptexpcal res ,noperators op ,ptexpcal e1 ,ptexpcal e2 );

/**
   It synthetizes the set of travel indexes for a temporal-binary  expression (default) res, defined by op(e1, e2).
   It is the getMaxTravelIndexes(ptexpcal, ptexpcal) of set of travel indexes of the operands e1, e2.
 */
void /*ExprManager::*/SpatialBinaryTp( ptexpcal res ,noperators op ,ptexpcal e1 ,ptexpcal e2 );

/**
   It synthetizes the set of travel indexes for a ternary expression res defined by op(e1,e2,e3)
   Currently, no computation.
 */
void /*ExprManager::*/SpatialTernary( ptexpcal res ,noperators op ,ptexpcal e1 ,ptexpcal e2 ,ptexpcal e3 );

/**
   It synthetizes the set of travel indexes for a n-ary combed expression res, defined by op(e1, e2).
   It is the getMaxTravelIndexes(ptexpcal, ptexpcal) of set of travel indexes of the operands e1, e2.
 */
void /*ExprManager::*/SpatialNary( ptexpcal res ,noperators op ,ptexpcal e1 ,ptexpcal e2 );

/**
   It synthetizes the set of travel indexes for an extraction (E when H) or a memory (E cell H) expression.
   It is the set of travel indexes of the first argument (E).
 */
void /*ExprManager::*/SpatialExtractOrMemory( ptexpcal res ,noperators op ,ptexpcal e1 ,ptinsth vclk );

/**
   It synthetizes the set of travel indexes for an function call expression (exp) with ins as inputs.
   It is the getMaxTravelIndexes(ptlinstances, ptlinstances) of set of travel indexes of the inputs.
 */
void /*ExprManager::*/SpatialFuncCall( ptexpcal exp ,ptexpcal ins );

/**
   Assumed: the expressions are evaluated.
   @return 
   - "true" if the expression vexp, with vsize the size of an expression of its dimensions, satisfies
        - codeOp = 1,  0..n step 1  with vsize = n
	- codeOp = 2,  tr (0.. n step 1 |* m)  with vsize = n (i.e. isArithmeticalProgression(getUnaryArg(vexp), 3, vsize))
	- codeOp = 3,  tr (0.. n step 1 |* m)  with vsize = n (i.e. isArithmeticalProgression(getBinaryArgstAt(vexp, 1), 1, vsize))
   - "false" otherwise.
 */
boolean /*ExprManager::*/isArithmeticalProgression( ptexpcal vexp ,int codeOp ,ptexpcal vsize );


