/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
   @return the normalized array type T, [DimLst,...]Term, representing [DimLst] TT.
   In normal form, Term is not an array. [DimLst,...] shall contain all dimensions.
 */
TypeType /*ExprManager::*/mkArrayType( ptexpcal DimLst ,TypeType TT );

/**
   @return "false".
   It associates the error type to an expression (vexp) and a message (imessage) to
   the corresponding tree (where).
 */
boolean /*ExprManager::*/setErrorTypeExp( ptexpcal vexp ,int imessage ,BackAnnotationType where );

/**
   @return "false".
   It associates the error type to an expression (vexp) and an error message, "unexpected type", 
   to the corresponding tree (where).
 */
boolean /*ExprManager::*/errUnexpectedType( ptexpcal vexp ,BackAnnotationType where );

/**
   @return "false".
   It associates the error type to an expression (vexp) and an error message, "error for extension type", 
   to the corresponding tree (where).
 */
boolean /*ExprManager::*/errExtension( ptexpcal vexp ,BackAnnotationType where );

/**
   It verifies the  Numerical/Logical expressions extensions for an expression (vexp).
   The eventual error is hooked to the where.
 */
void /*ExprManager::*/TypeCheckingExpcalNLExtensions( ptexpcal vexp ,BackAnnotationType where );

/**
   @return 
   - "true" if the operation succeeds, t = greatest type of source and target (unifytctype()).
   - "false" otherwise, t is not modified.
 */
boolean /*ExprManager::*/GetGreaterType( TypeType source ,TypeType target ,TypeType* t );

/** 
    @return "true" if the operation succeeds, "false" otherwise.
    It verifies the type of an index expression excluding cartesian product (return pk_true)
    It assumes that the list of travel indexes is available. 
    It verifies that the indexes have the same type.
 */
boolean /*ExprManager::*/TypeCheckingIndexes( ptexpcal vexp );

/**
   It controls the compatibility of the types for the definition 
   @param vexpcal1 (in) left part of the definition
   @param vexpcal2 (in) the expression of definition of the equation/partial definition.
   @param refTree (in) : reference to the syntactic tree of the program ; used for annotations.
   @param partialDef (in) when "true", it specifies that the equation is a partial one (vexpcal1 ::= vexpcal2).
   @param bextension (out) set to "true" if the expressions are well typed using extension rules, "false" otherwise.
   @return "true" if the expressions are well typed, in this case bextension is fixed, "false" otherwise
 */
boolean /*ExprManager::*/TypeCheckingEquation( ptexpcal vexpcal1 ,ptexpcal* vexpcal2 ,BackAnnotationType refTree ,boolean* bextension );

/**
   For an equation lexp := rexp, if rexp is an event, it is propagated to lexp.
 */
void /*ExprManager::*/TypeCheckingEquationFinalize( ptexpcal lexp ,ptexpcal rexp ,BackAnnotationType refTree );

/**
   @return "true" if an expression (vexpcalcul) is a scalar expression, "false" otherwise (in this case it is modified: it is set to scalar).
   @param vexpcalcul (in) an expression
   @param refTree (in) : reference to the syntactic tree of the program ; used for annotations.
   \see controlequadim
 */
boolean /*ExprManager::*/TypeCheckingIsScalar( ptexpcal vexpcalcul ,BackAnnotationType refTree );

/**
   If the type of the expression is not defined, it is fixed to boolean.
   @return 
   - "true" if the operand expression is boolean, 
   - "false" otherwise, an error is hooked to vtree.
 */
boolean /*ExprManager::*/TypeCheckingCondition( ptexpcal vexp ,BackAnnotationType vtree );

/** 
    If the type of the expression is defined, it verifies that it is boolean.
    @return 
    - "true" if the operand expression is boolean or not fixed.
    - "false" otherwise, an error is hooked to vtree.
 */
boolean /*ExprManager::*/TypeCheckingVerifyTypeCondition( ptexpcal vexp ,BackAnnotationType vtree );

/**
   It controls the compatibility of the types of a effective parameter and a formal parameter in a call node.
   @param TT (in) type of the formal element
   @param vexpcal (in) the effectif element
   @param refTree (in) reference to the syntactic tree of the program ; used for annotations.
 */
void /*ExprManager::*/TypeCheckingFormalEffective( TypeType TT ,ptexpcal vexpcal ,boolean enentree ,BackAnnotationType refTree );

/** 
    @return 
    - "true" if the expressions, vexpcal1 and vexpcal2, have the same dimension, 
    - "false" otherwise, an error is hooked to refTree.
 */
boolean /*ExprManager::*/TypeCheckingSameSize( ptexpcal vexpcal1 ,ptexpcal vexpcal2 ,BackAnnotationType refTree );

/**
   @return 
    - "true" if the type of vexpcal1 is the type event (a conversion boolean->event can be applied).
    - "false" otherwise, an error is hooked to declaration of  vexpcal1.
    
    notdefined is set to "true" if vexpcal1 is not valuated, "false" otherwise.
 */
boolean /*ExprManager::*/TypeCheckingIsEvent( ptexpcal vexpcal1 ,boolean* notdefined );

/**
   Type checking for a list expression.
   @param vexp (in) expression defined by vope(vexpcal1, vexpcal2).
   @param vope (in) operator of the expression.
   @param vexpcal1, vexpcal2  (in) operands of the expression.
   @param refTree (in) : reference to the syntactic tree of the program ; used for annotations.
   @return "true" if the expression is well typed, "false" otherwise.
 */
boolean /*ExprManager::*/TypeCheckingList( noperators vope ,ptexpcal vexp ,ptexpcal vexpcal1 ,ptexpcal vexpcal2 ,BackAnnotationType refTree );

/** 
    @return 
    - "true" if a value (val) is an element of an assumed enumerated type (TT); TT must be a enumerated type.
    - "false" otherwise, an error is hooked to refTree.
  */
boolean /*ExprManager::*/TypeCheckingControlValEnum( TypeType TT ,ptrepstr val ,BackAnnotationType refTree );

/**
   Type checking for an expression (vexp ) defined by a temporal binary expression with vexp1, vexp2 as operands.
   On error, a message is hooked to refTree.
 */
void /*ExprManager::*/TypeCheckingBinaryTemporal( noperators op ,ptexpcal vexp ,ptexpcal vexp1 ,ptexpcal vexp2 ,BackAnnotationType refTree );

/**
   Type checking for a when/cell expression (vexp) defined by vexp1.
 */
void /*ExprManager::*/TypeCheckingExtractOrMemory( noperators op ,ptexpcal vexp ,ptexpcal vexp1 ,BackAnnotationType refTree );

/**
   Type checking for delay expression (vexp) defined by "vexpcal1 $ valret window valfen init vinit". On error, a message is hooked to refTree.
   The control on initialisation is realized at the end of the graph production \see{TypeCheckingInit}.
 */
void /*ExprManager::*/TypeCheckingDelay( noperators op ,ptexpcal vexp ,ptexpcal vexpcal1 ,ptexpcal valret ,ptexpcal valfen ,BackAnnotationType refTree );

/**
   Type checking for an initial value (vinit) for a delayed signal (delayedExpr).
   On error, a message is hooked to refTree.

   \attention not implemented for the oplevect operator, only for oplelevec operator (see verifyEachElevec()).
 */
void /*ExprManager::*/TypeCkeckingInitialValue( ptexpcal delayedExpr ,ptexpcal vinit ,BackAnnotationType refTree );

/**
  Type checking for vexp := lb .. up step st. On error, a message is hooked to refTree.
  @return "true" if the expression is well type, "false" otherwise.
 */
boolean /*ExprManager::*/TypeCheckingIndex( ptexpcal vexp ,ptexpcal lb ,ptexpcal ub ,ptexpcal st ,BackAnnotationType refTree );

/**
  Verification on value.
  @param vexp (in) an expression.
  @param refTree (in) reference to the syntactic tree of the program ; used for annotations.
  @param strict (in) the value must be strictly positive if strict is pk_true
  @param bval (out) at pk_true if the value of the expression (val) is known, "false" otherwise.
  @param bmess (in) if pk_true a message if hooked to the tree (refTree) is the value (val) is not positive.
  @return 
      - "true" when the expression is undefined (nil), or is an int expression and its value is unknown or known and positive.
      - "false" otherwise.
 */
boolean /*ExprManager::*/hasPositiveIntegerType( ptexpcal vexp ,BackAnnotationType refTree ,boolean strict ,boolean* bval ,boolean bmess );

/**
  Verification on value.
  @param vexp (in) an expression.
  @param refTree (in) reference to the syntactic tree of the program ; used for annotations.
  @param strict (in) the value must be strictly positive if strict is pk_true
  @param bval (out) at pk_true if the value of the expression (val) is known, "false" otherwise.
  @param bmess (in) if pk_true a message if hooked to the tree (refTree) is the value (val) is not positive.
  @return 
      - "true" when the expression is undefined (nil), or is an int expression and its value is unknown or known and positive.
      - "false" otherwise.
 */
boolean /*ExprManager::*/hasIntegerValueEqualTo1( ptexpcal vexp );

/**
   It updates the type of vexp when TT a enumerated type and vexp is an access to a value of TT (updateEnumValue()).
   It is applied when the type of vexp is no fixed.
 */
void /*ExprManager::*/TypePropagate( TypeType TT ,ptexpcal vexp );

/**
   It sets (forces) TT as the type of an expression (exp) if its type is free. 
   A message (warning) is hooked to refTree ("no type control done for the exp expression").
 */
void /*ExprManager::*/TypeCheckingForceType( ptexpcal exp ,TypeType TT ,BackAnnotationType refTree );

/**
    Type checking for ls:= id{lp}(le), the control is achieved for id an intrinsic function identifier (bounds, dim , size, indices).
    @return 
    - "true" if the expression is well typed, or id is not considered ,
    - "false" otherwise, an error message is hooked to vt.
 */
boolean /*ExprManager::*/TypeCheckingIntrinsic( ptident id ,ptexpcal lp ,ptexpcal le ,ptexpcal ls ,BackAnnotationType vt );

/**  
     Type checking for vexp a synchronous unary expression vope(vexpcal1).
     @return  "true" if the expression is well typed, "false" otherwise, an error message is hooked to refTree.
     It calls TypeCheckingMatrixTr, TypeCheckingnega, TypeCheckingCartesianProduct.
 */
boolean /*ExprManager::*/TypeCheckingUnary( noperators vope ,ptexpcal vexp ,ptexpcal vexpcal1 ,BackAnnotationType refTree );

/**
   @return
   - "true" if the definition vTuple := vDef, where vDef is a cartesian product is well typed
   - "false" otherwise, in this case the tree (refTree) is annotated with the error message.   
 */
boolean /*ExprManager::*/TypeCheckingCartesianProductEquation( ptexpcal vTuple ,ptexpcal vDef ,BackAnnotationType refTree );

/** 
    It validates the type of vexp defined by a synchronous binary expression vope(vexpcal1, vexpcal2).
    On error, messages are hooked to refTree tree.
    @return vexp or the evaluated equivalent expression. 
    It calls : TypeVerifFieldsAccess, TypeVerifCounter, TypeVerifException, TypeVerifComplex, TypeCheckingRelation1, TypeCheckingRelationEqEq
    TypeCheckingRelationIIEQ, TypeCheckingRelation2, TypeCheckingArithmBinary, evalarithBinary, TypeCheckingelem, TypeCheckingparc,
    TypeCheckingconc, TypeCheckingRepeat, TypeCheckingMatrixMult, TypeCheckingNext.
    
  */
ptexpcal /*ExprManager::*/TypeCheckingBinary( noperators vope ,ptexpcal vexp ,ptexpcal vexpcal1 ,ptexpcal vexpcal2 ,BackAnnotationType refTree );

/**
   @return the upper bound of an index (vind).

   On error, messages are hooked to refTree tree.
  */
ptexpcal /*ExprManager::*/TypeCheckingGetUpperBoundIterationIndex( ptexpcal vind ,BackAnnotationType refTree );

/**
   For an equation vl := vr, it assigns to vl the values of vr taking into account the values of the initial value (vinit).
 */
void /*ExprManager::*/setValuesEq( ptexpcal vl ,ptexpcal vr ,noperators op );


