/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
/**
  Module de gestion de la representation des signaux (flots instancies). Les
  attributs sont geres dans le module atfgattr
*/

typedef struct linstid
{
  ptident identorig;		/* Name of the identifier */
  ptident identvar;		/* Name of the identifier with its suffix */
  typinst tinst;		/* Kind of identifier:  signal, parameter, index,... */
  typsignal InOutLocAssert;	/* Sub class for a signal: input, output, local, assertion,... */
  TypeType vType;		/* Its type */
  ptexpcal vali;		/* Its initial value */
  ntrees decl;			/* Its abstract tree declaration (back annotation to the source) */
  ptINode leval;		/* Its Node definition */
  ptinsth vhorl;		/* Its clock */
  ptexpcal expcalass;		/* Its representation as expression */
  ptinstidattr attribut;	/* Its attributes */
  categoryType IdCategory;	/* Its tag declaration (state variable, shared signal, undefined). By default undefined. */
} tlinstid;


///
#define IS_NILLINSTID(LINSTID) ((LINSTID) == (NILLINSTID))
#define GET_LINSTIDLEVAL(LINSTID) ((LINSTID)->leval)
#define GET_LINSTIDATRIBUTE(LINSTID) ((LINSTID)->attribut)
#define SET_LINSTIDATRIBUTE(LINSTID, ATTRIB) ((LINSTID)->attribut = (ATTRIB) )

/**
   @return a new identifier characterized by 
   - its node (vnode) 
   - its clock (vclk).
*/
static ptlinstid
ptlinstid_new (ptINode vnode, ptinsth vclk)
{
  ptlinstid vinstid;

  vinstid = new linstid ();
  vinstid->leval = vnode;
  vinstid->vhorl = vclk;
  return vinstid;
}

extern ptinstidattr
ptlinstid_getAttribute (ptlinstid vinst)
{
  return GET_LINSTIDATRIBUTE (ptlinstid_get_instid_ref (vinst));
}
