/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

/** Representation (unidirectional) of an element of a list of expressions. */
typedef struct linstances
{
  ptexpcal elem;		///< expression associated with the element. 
  ptlinstances next;		///< next element of the list
} tlinstances;

///< internal list used for garbaging.
static ptlinstances gclinstances = NILLINSTANCES;

/**
   For a list v1, it returns
   the expression (e) associated with v1,
   the next element of v1
*/
static void
ptlinstances_gethead_attributs (ptlinstances v1, ptexpcal * e, ptlinstances * suiv)
{
  *e = v1->elem;
  ptexpcal_get_indir (*e, e);
  *suiv = v1->next;
}

/**
   For a input-list vl, 
   @return the expression associated with vl,
   vl is then set to the next element of vl.
*/
static ptexpcal
ptlinstances_gethead (ptlinstances * vl)
{
  ptexpcal vexp;
  vexp = (*vl)->elem;
  *vl = (*vl)->next;
  return vexp;
}


static ptlinstances
ptlinstances_create ()
{
  return new linstances ();
}
