/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/


/**-->Instance d'identificateur designe par l'expression ?PT*/
extern ptlinstid
ptexpcal_get_instance (ptexpcal pt)
{
  noperators op;
  ptlinstid vinstid;

  // printf("DEBUG entering ptexpcal_get_instance pt adr is %li\n", (long int)pt); fflush(stdout);
  if (pt == NILEXPCAL)
    return NILLINSTID;
  // printf("DEBUG      in  ptexpcal_get_instance 1\n"); fflush(stdout);
  if (ptexpcal_getSignalAssignedTo (pt, &pt))
    {
      // printf("DEBUG      in  ptexpcal_get_instance 1-1, signal is %li\n", (long int)pt); fflush(stdout);
      if (pt == NILEXPCAL)
	return NILLINSTID;
      vinstid = ptexpcal_get_signal (pt);
      // printf("DEBUG  exiting ptexpcal_get_instance 1-2 vinstid adr is %li\n",(long int)vinstid); fflush(stdout);
      // printf("DEBUG                                    vinstid name is %s\n", ident2string(ptlinstid_get_originalident(vinstid))); fflush(stdout);
      return vinstid;
    }
  // printf("DEBUG      in  ptexpcal_get_instance 2\n"); fflush(stdout);
  /* modified September 2008 lbesnard. */
  op = GET_OPERATOR (pt);
  // printf("DEBUG      in  ptexpcal_get_instance 3\n"); fflush(stdout);
  if (op == variabl)
    return ptexpcal_get_signal (pt);
  // printf("DEBUG      in  ptexpcal_get_instance 4\n"); fflush(stdout);
  if (op == opelem)
    return ptexpcal_get_instance (pt->U.SBINARY.op1);
  // printf("DEBUG      in  ptexpcal_get_instance 5\n"); fflush(stdout);
  if (op == opcham)
    return ptexpcal_get_instance (pt->U.SBINARY.op1);
  // printf("DEBUG      in  ptexpcal_get_instance 6\n"); fflush(stdout);

  /* unexpected value for ?pt->oper */
  return NILLINSTID;
}

/** retourne le signal non indice denote par ?vexp  */
extern ptexpcal
ptexpcal_getUnindexedSignal (ptexpcal vexp)
{
  ptlinstid vinst;

  vinst = ptexpcal_get_instance (vexp);
  vinst = ptlinstid_get_instid_ref (vinst);
  return ptlinstid_get_expcalass (vinst);
}

/** It returns the node of the delay tree assigned to the signal ?exp. */
extern ptmemnode
ptexpcal_get_node_tree_delay (ptexpcal exp)
{
  if (GET_OPERATOR (exp) == opvvarin)
    return NILMEMNODE;		// ref to a state variable
  return ptlinstid_get_node_tree_delay (ptexpcal_get_instance (exp));
}

/** It assigns the node of the delay tree !mem to the signal ?exp. */
extern void
ptexpcal_set_node_tree_delay (ptexpcal exp, ptmemnode mem)
{
  ptlinstid_set_node_tree_delay (ptexpcal_get_instance (exp), mem);
}


/** It returns pk_true if the signal ?VEXP is an element !MN of a delay tree. */
extern boolean
ptexpcal_satisfies_node_tree_delay (ptexpcal exp, ptmemnode * mn)
{
  if (GET_OPERATOR (exp) == opvvarin)
    return pk_false;		// ref to a state variable
  (*mn) = ptexpcal_get_node_tree_delay (exp);
  return (boolean) ((*mn) != NILMEMNODE);
}
