/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

/**
   Referenced only by the typemanager;
   @return "true" when the expressions (e1,e2) are equivalent, "false" otherwize
*/
extern boolean
ExpcalCstEq (ExpcalCst e1, ExpcalCst e2)
{
  return ptexpcal_isEquivalent (e1, e2, pk_true);
}

/**
   Referenced only by the typemanager;
   @return "true" when the list of expressions (e1,e2) are equivalent, "false" otherwize
*/
extern boolean
ExpcalCstListEq (ExpcalCstList e1, ExpcalCstList e2)
{
  return ptexpcal_isEquivalent (e1, e2, pk_true);
}

/**
   Specific to the typemanager; to concat the dimension of array types.
*/
extern ExpcalCstList
ExpcalListConcat (ExpcalCstList e1, ExpcalCstList e2)
{
  ptexpcal vpred, se1;
  // without effect now, the nornal form for the dimensions is manage before the 
  if (e1 == NILEXPCAL)
    return e2;
  se1 = e1;
  while (e1 != NILEXPCAL)
    {
      vpred = e1;
      e1 = ptexpcal_get_binaryArgstAt (e1, 2);
    }
  ptexpcal_set_binaryArgstAt (vpred, 2, e2);
  return se1;
}
