/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/** It adds vinsth as a successor of vinstr.
    @return "true" if the operation succeeds, "false" otherwise (it already exists in the graph). 
 */
boolean /*NodeManager::*/addDependence( ptINode vinstr ,ptinsth vinsth );

/**  It adds vhto as a successor of vhfrom.
     @return "true" if the operation succeeds, "false" otherwise (it already exists in the graph). 
 */
boolean /*NodeManager::*/addDependence( ptinsth vhfrom ,ptinsth vhto );

/**  It adds vinstr as a successor of vh.
     @return "true" if the operation succeeds, "false" otherwise (it already exists in the graph or vh is the null clock). 
 */
boolean /*NodeManager::*/addDependence( ptinsth vh ,ptINode vinstr );

/**
   It adds the dependence vinstrFrom -> vinstrTo when h with tdep as kind of dependence.
   @return "true" if the operation succeeds, "false" otherwise (it already exists in the graph).
 */
boolean /*NodeManager::*/addDependence( ptINode vinstrFrom ,ptINode vinstrTo ,ptinsth h ,TypeDependenceKind tdep );

/**  
     It adds the data-flow dependence vinstrFrom -> vinstrTo when h.
     @return "true" if the operation succeeds, "false" otherwise (it already exists in the graph). 
 */
boolean /*NodeManager::*/addDependence( ptINode vinstrFrom ,ptINode vinstrTo ,ptinsth h );

/**
   It adds the explicit dependence vinstrFrom -> vinstrTo when h.
   @return "true" if the operation succeeds, "false" otherwise (it already exists in the graph). 
 */
boolean /*NodeManager::*/addExplicitDependence( ptINode vinstrFrom ,ptINode vinstrTo ,ptinsth h );

/**
   It adds the explicit dependence vinstrFrom -> vinstrTo when h if this dependence does not exist.
   @return "true" if the operation succeeds, "false" otherwise (it already exists in the graph). 
 */
boolean /*NodeManager::*/addReinforcingDependence( ptINode vinstrFrom ,ptINode vinstrTo ,ptinsth h );

/** 
    It adds the (data-flow) dependences n -> m when h, for n in lnodesFrom, and m element of lnodeTo.
    It calls addDependence(ptINode, ptINode , ptinsth ).
 */
void /*NodeManager::*/addDependences( ptlINode lnodesFrom ,ptlINode lnodeTo ,ptinsth h );

/**
   It adds the dependence n -> m when (h ^* x1 ^* x2), with
   - n the node of aSig
   - m the node of sigTo
   - x1 he clock of aSig
   - x2 he clock of sigTo

    It is an explicit dependence when bexplicit, a data-flow one otherwise   
 */
boolean /*NodeManager::*/addDependence( ptexpcal aSig ,ptexpcal sigTo ,ptinsth h ,boolean bexplicit );

/** It sets the dependences for downsampling clocks (when Condition) of a list (lh).  */
void /*NodeManager::*/setDependencesINodeToClocks( ptlinsth lh );

/**
   For each clock of the list lh, it adds (addDependence(ptinsth, ptINOde)) a dependence from its clock to each
   node computed at this clock.
 */
void /*NodeManager::*/setDependencesClocksToINodes( ptlinsth lh );

/** 
    It sets a dependence from a node (anode) to a subgraph node (aSubGraph) 
    iff it exists a dependence from anode to one of the node of the subgraph.
 */
boolean /*NodeManager::*/setDependencesToSubGraph( ptINode anode ,ptINode aSubGraph );

/** 
    It adds the dependences n -> m when h, with
    - n the node of one signal of lFrom,
    - m the node of one signal of lTo,
    
    It is an explicit dependence when bexplicit, a data-flow one otherwise
    It calls addDependence(ptexpcal , ptexpcal, ptinsth, boolean).
 */
void /*NodeManager::*/addDependences( ptlinstances lFrom ,ptlinstances lTo ,ptinsth h ,boolean bexplicit );

/**
   It Propagates the dependences associated with a node to its sucesssors/predecessors.
 */
void /*NodeManager::*/dependencesPropagate( ptINode node );

/**
   It propagates the explicit dependences associated with a node (node1) to another one (node2).
 */
void /*NodeManager::*/ExplicitdependencesPasteOn( ptINode node1 ,ptINode node2 );

/**
   It propagates the dependences associated with a node (node1) to another one (node2).
   Only the successors of node1 are considered.
 */
void /*NodeManager::*/dependencesPasteOn( ptINode node1 ,ptINode node2 );

/**
   It propagates the dependences associated with a node (nodeFrom) to another one (nodeTo).
   Predecessors/successors of nodeFrom are considered.
 */
void /*NodeManager::*/dependencesMove( ptINode nodeFrom ,ptINode nodeTo );

/**
   It removes the dependences node -> obj, when obj (a clock, or a node) is marked (mark).
 */
void /*NodeManager::*/removeDependenceMarkedSuccessors( ptINode node ,typeMark mark );

/**
   @return "true" if a node (node) is referenced in the graph.
 */
boolean /*NodeManager::*/isReferenced( ptINode node );

/**
   @return the number of explicit dependence it exists from a node (node).
 */
int /*NodeManager::*/getCardExplicitPredecessors( ptINode node );

/** It removes the dependences reaching a node (node).  */
void /*NodeManager::*/removeDependenceTo( ptINode node );

/** It removes the dependences outgoing from a node (node).  */
void /*NodeManager::*/removeDependenceFrom( ptINode node );

/** It removes the dependences outgoing from a clock (vh).  */
void /*NodeManager::*/removeDependenceFrom( ptinsth vh );

/** It removes the dependences reaching a clock (vh).  */
void /*NodeManager::*/removeDependenceTo( ptinsth vh );

/** It removes the dependences associated with the predefined null clock.  */
void /*NodeManager::*/removeDependenceNullClock( void );

/** It removes a dependence (aDep).  */
void /*NodeManager::*/removeDependence( ptdependence aDep );

/** It removes the dependence vh -> vNodeTo.  */
void /*NodeManager::*/removeDependence( ptinsth vh ,ptINode vNodeTo );

/** It removes the dependence vinstr -> vinsth.  */
void /*NodeManager::*/removeDependence( ptINode vinstr ,ptinsth vinsth );

/** It removes the dependence vNodeFrom -> vNodeTo.  */
void /*NodeManager::*/removeDependence( ptINode vNodeFrom ,ptINode vNodeTo );

/**
   @return
   - "true" if it exists a dependence vFrom -> vTo, returned in aDep
   - "false" otherwise, aDep is not modified.
 */
boolean /*NodeManager::*/getDependence( ptINode vFrom ,ptINode vTo ,ptdependence* aDep );

/**
   It sets the dependences for each node call of the graph.
 */
void /*NodeManager::*/setDependencesNodeCall( void );

/**
   It sets the dependences induced by labelled objects:
   the internal nodes of a subgraph depends on a "fictitious" node (internal to the representation).
 */
void /*NodeManager::*/setDependencesLabels( void );

/** 
    It sets the dependences for array of processes.
    Internal nodes of an array depends on the index of the array.
 */
void /*NodeManager::*/setDependencesArrays( void );

/** 
    Assumes: node is a list of partial defintions node.
    It adds a dependence from each component to node. For
    - N1 defined by x::=E1, 
    - ... 
    - Nn defined by x:=En
    - N the node (node) associated to x
    .
    it adds Ni->N
 */
void /*NodeManager::*/setDependencesPartDefinition( ptINode node );

/** 
    It sets the dependences for nodes defined by a set of partial definitions. 
    The node depends on all part definition nodes. 
 */
void /*NodeManager::*/setDependencesPartDefinitions( void );

/**
   It reenforces the dependences for node calls: it adds a dependence from each input to each output of such a node.
   It is used for sequential code  generators.
   \note it may add cycles in the graph.
   @return "true" if some dependences has been added, "false" otherwise.
 */
boolean /*NodeManager::*/setsbDCplusDependencesForNodeCalls( void );

/**
   Assumed: the operand expression is a normalized default or a when expression.
   It adds a dependence for the signals of the expression (ne) to a node (node).
 */
void /*NodeManager::*/addDependences( ptINode node ,ptexpcal ne );

/**
   Replace the dependence (oNode --> vTo) by the dependence (nNode  --> vTo). The clock of the dependence is kept.
   @return true if the operation succeeds, "false" otherwie (no dependence (oNode  --> vTo))
 */
boolean /*NodeManager::*/replaceDependence( ptINode oNode ,ptINode nTo ,ptINode nNode );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*NodeManager::*/free_dependences( ptldependence ldep );


