/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*NodeManager::*/insertNodeToArray( ptINode aNode ,ptexpcal vexp );

/** It creates the equation vsig := (vexp when vhcal); vsig is synchronized with the clock vh; 
    @param vsig (in) the signal defined by the equation.
    @param vexp (in) expression definition of X;
    @param vh (in) the clock of X;
    @param vhcal (in) the contributon clock of vexp to the definition of X.
    @return the node of the defined signal (i.e vsig).
 */
ptINode /*NodeManager::*/insertEquation( ptexpcal vsig ,ptexpcal vexp ,ptinsth vh ,ptinsth vhcal );

/** It creates a new signal X then the equation X := (vexp when vhcal); X is synchronized with the clock vh; 
   @param id  (in) identifier of the new signal;
   @param TT (in) the type of the new signal;
   @param vexp (in) expression definition of X;
   @param vh (in) the clock of X;
   @param vhcal (in) the contributon clock of vexp to the definition of X.
   @param node (out) the node of X.
   @return the created signal (i.e X)  */
ptexpcal /*NodeManager::*/insertEquation( ptident id ,TypeType TT ,ptexpcal vexp ,ptinsth vh ,ptinsth vhcal ,ptINode* node );

/** It creates an equation C1 = leftt(c,bk) where C1 is a new signal with vh as clock.
   @param c (in) a boolean clock expression.
   @param bk (in) a boolean clock expression such that father(bk) = vh on the branching (vh, ^c) 
   @param vh (in) the clock of the expression "leftt(c, bk)"
   @return the created SIGNAL defined by lefttt expression.
  */
ptexpcal /*NodeManager::*/createLeftt( ptexpcal c ,ptexpcal bk ,ptinsth vh );

/** 
    @return 
     - the expression c, when force is "false" and when clock(c) is equal to the clock vh; 
     - oherwise a new signal, defined by the equation c when vh, and synchronized with the clock vh. 
    @param force (in) at pk_true to add a new signal.
    @param c (in) a monochromous expression.
    @param vh (in) the clock of the new signal
 */
ptexpcal /*NodeManager::*/createWhen( ptexpcal c ,ptinsth vh ,boolean force );

/** @return the input list in which the input node aNode is added if it is an undeclared external model of lExtern.

   @param aNode (in) a  node ; but it works only for external node call;
   @param lExtern (in) : a list of external node call.
   Unicity guaranted using the name of the  external node call.
 */
ptlINode /*NodeManager::*/addExternDecl( ptINode aNode ,ptlINode lExtern );

/** @return "true" if the list lExtern contains a external call with n as name, "false" otherwise
    @param n (in) an ident
    @param lExtern (in) : a list of external node call (assumed)
 */
boolean /*NodeManager::*/isDeclaredExternal( ptident n ,ptlINode lExtern );

/** @return a new untyped node  */
ptINode /*NodeManager::*/mk_node_undefined( void );

/** It adds (vexpdedef when vhcal) as a partial definition of the signal vexpadef 
    @return the node defining the signal vexpadef.
    The node is not inserted into the graph of the clock of this node, use \ref insertNode for that (when the definition is completed).
 */
ptINode /*NodeManager::*/addPartAff( ptexpcal vexpadef ,ptexpcal vexpdedef ,ptinsth vhcal ,ptlinstances instent );

/** It adds (vexpdedef when vhcal) as the default-value part of the signal vexpadef.
    @return the node defining the signal vexpadef.
    The node is not inserted into the graph of the clock of this node, use \ref insertNode for that (when the definition is completed).
 */
ptINode /*NodeManager::*/addDefaultValuePart( ptexpcal vexpadef ,ptexpcal vexpdedef ,ptinsth vhcal ,ptlinstances instent );

/**
  It adds to the node defining the signal expcal1 the expression (expcal2 when vhcal).
  @param expcal1 (in) a signal.
  @param expcal2 (in) a monochronous expression.
  @param vhcal (in) contribution clock of expcal2 to the definition of expcal1.
  @param instent (in) list of referenced signals of the expression expcal2.
  @param treeRef (in) reference to the syntactic tree of the program(tracability).
  @return the node defining the signal vexpcal1.
  The node is not inserted into the graph of the clock of this node, use \ref insertNode for that (when the definition is completed).
 */
ptINode /*NodeManager::*/mk_node_equation( ptexpcal expcal1 ,ptexpcal expcal2 ,ptinsth vhcal ,ptlinstances instent ,BackAnnotationType ba );

/**
  It defines the node of an input signal.
  @param i (in) a input signal of the program when NodeCall is undefined or a signal defined in the 
  NodeCall node.
  @param NodeCall (in) a node call 
  @return the node defining the signal i (node operator is opread)

  The node is not inserted into the graph of the clock of this node, use \ref insertNode for that (when the definition is completed).
 */
ptINode /*NodeManager::*/mk_node_input( ptexpcal i ,ptINode NodeCall ,BackAnnotationType ba );

/**
  It makes the writing node of an output signal.
  @param i (in) a output signal of the program.
  @return the writing node of the signal i (node operator is opwrite).
  The node is not inserted into the graph of the clock of this node, use \ref insertNode for that (when the definition is completed).
 */
ptINode /*NodeManager::*/mk_node_output( ptexpcal i ,BackAnnotationType ba );

/**
  It defines the node of signal as a delay node (node operator is opret).
  @param s (in) a output signal of the equation.
  @param eDelay (in) the delayed signal.
  @param vdelay (in) the delay expression.
  @param vwindow (in) the window expression.
  @param vinit (in) the initial value.
  @param treeRef (in) the reference to the syntactic tree of the program (tracability).

  @return the node of the signal s.
  The node is not inserted into the graph, use \ref insertNode for that (when the definition is completed).
 */
ptINode /*NodeManager::*/mk_node_delay( ptexpcal s ,ptexpcal eDelay ,ptexpcal vdelay ,ptexpcal vwindow ,ptexpcal vinit ,BackAnnotationType ba );

/**
  It defines the node of a set of signals as an external procedure call node (node operator is opappe).
  @param idCall (in) the name of the external procedure;
  @param parameters (in) the set of parameters;
  @param inputs (in) the set of input signals;
  @param outputs (in) the set of output signals.
  @param treeRef (in) the reference to the syntactic tree of the program (tracability).
  @return the procedure node call.
  The node is not inserted into the graph of the clock of this node, use \ref insertNode for that (when the definition is completed).
 */
ptINode /*NodeManager::*/mk_procCall( ptident idCall ,ptexpcal parameters ,ptexpcal inputs ,ptexpcal outputs ,BackAnnotationType ba );

/**
  It defines the node of a set of signals as a "nodecall" node (node operator is opnodecall)
  @param vgraph (in) graph model.
  @param parameters (in) the set of parameters;
  @param inputs (in) the set of signal inputs;
  @param outputs (in) the set of signal outputs;
  @param treeRef (in) the reference to the syntactic tree of the program (tracability).
  @return the procedure node call.
  The node is not inserted into the graph of the clock of this node, use \ref insertNode for that (when the definition is completed).
 */
ptINode /*NodeManager::*/mk_node_call( ptDCG vgraph ,ptexpcal parameters ,ptexpcal inputs ,ptexpcal outputs ,BackAnnotationType ba );

/** @return the sub-graph node assigned to a label 
    @param vlabel (in) a label identifier.
    @param treeRef (in) the reference to the syntactic tree of the program (tracability).
    The node is not inserted into the graph of the clock of this node, use \ref insertNode for that (when the definition is completed).
 */
ptINode /*NodeManager::*/mk_node_subgraph( ptexpcal vlabel ,BackAnnotationType ba );

/**
   It defines the node n as "bundle/structure" one which produces the signal s.
   This node is characterized by a list of signals (lsigFields) that must be the signals  s.y1, ....s.yn where yi are the fieds of 
   the "bundle/structure" type of the signal s.
   @param treeRef (in) the reference to the syntactic tree of the program (tracability).
   @return the node n.
   The node is not inserted into the graph of the clock of this node, use \ref insertNode for that (when the definition is completed).
 */
ptINode /*NodeManager::*/mk_node_lfields( ptexpcal s ,ptINode n ,ptlinstances lsigFields ,BackAnnotationType ba );

/**
   @return a new array node.
   @param indexNode (in) the index of the array, \see {mk_node_index}.
   @param inputs (in) the referenced signals in the array.
   @param outputs (in) the defined signals in the array.
   @param treeRef (in) the reference to the syntactic tree of the program (tracability).
   The node is not inserted into the graph of the clock of this node, use \ref insertNode for that (when the definition is completed).
 */
ptINode /*NodeManager::*/mk_node_array( ptINode indexNode ,ptexpcal inputs ,ptexpcal outputs ,BackAnnotationType ba );

/**
   @return the node assigned to the index i.
   @param i (in) a index identifier (assumed)
   @param e (in) definition of the index
   \see {mk_node_array}
 */
ptINode /*NodeManager::*/mk_node_index( ptexpcal i ,ptexpcal e );

/** It inserts a node (node) into the AllNodes set, and its typed-node set.  */
void /*NodeManager::*/insertinSet( ptINode node );

/** It inserts a node (node) 
    - into the graph at the operand clock (vh).
    - in the internal sets ( insertinSet() method)  */
void /*NodeManager::*/insertNode( ptINode node ,ptinsth vh );

/** It moves a node (node) from its current clock to a new one (h).
  */
void /*NodeManager::*/moveNodeToClock( ptINode node ,ptinsth h );

/**
   It removes a node (node) from the graph assigned to its clock. 
 */
void /*NodeManager::*/removegfd( ptINode node );

/** It resets a node (node) from the node manager (dependences to the node are deleted).  */
void /*NodeManager::*/resetNodeForModification( ptINode node );

/** It removes a node (node) from the node manager (dependences to and from the node are deleted).  */
void /*NodeManager::*/removeNode( ptINode node );

/**
   It removes the write node of a signal (vsig).
   For a signal x := E and x an output of a graph, an internal write-node is added into the graph.
   This method removes this internal node.
 */
void /*NodeManager::*/remove_node_output( ptexpcal vsig );

/** Each node of a sub-graph node or an array node (node) becomes invisible from its clock.
    These nodes are accessible from the sub-graph/array node.
    For an array node, the operation is applied for the body-graph and the init-graph of the array-node.
 */
void /*NodeManager::*/unlinkNodesFromClock( ptINode node );

/** 
    Each node of a sub-graph node or an array node (node) becomes visible from its clock.
  */
void /*NodeManager::*/linkNodesToClock( ptINode node );

/**
   @return teh created node.
   It creates and inserts an intrinsic unsafe procedure call denoting "louts:= name{lparam}(lins)" at the clock vh in the graph.
 */
ptINode /*NodeManager::*/mkIntrinsicUnsafeAt( ptident id ,ptexpcal lparam ,ptexpcal lins ,ptexpcal louts ,ptinsth vh ,BackAnnotationType ba );

/**
   It unifies the nodes assigned to a list of signals (listOfSignals) into only one node (n).
 */
void /*NodeManager::*/nodesMerging( ptlinstances ls ,ptINode n );

/**
   sub-Graph node.
   The internal nodes and the clocks of a sub-graph (SubGraph) are linked with this sub-graph node.
   After this operation the \ref get_inComposedNode (n, &x) will return "true" and SubGraph in x, for each nodes n of the sub-graph node.
   When the parameter brec is "true" the operation is recursively applied to the internal sub-graphs of SubGraph.
   \see {get_inComposedNode}
 */
void /*NodeManager::*/subGraphLinkNodes( ptINode SubGraph ,boolean brec );

/**
   sub-Graph node.
   The internal nodes and the clocks of a sub-graph (SubGraph) are unlinked with this sub-graph node.
   After this operation the get_inComposedNode(n, ) will return "false", for each nodes n of the subgraph node.
   When brec is "true" the operation is recursively applied to the internal sub-graphs of SubGraph.
   \see {get_inComposedNode}
 */
void /*NodeManager::*/subGraphUnlinkNodes( ptINode SubGraph ,boolean brec );

/**
   Each node of ln is inserted in the sub-graph of its clock.
 */
void /*NodeManager::*/linkNodesToClock( ptlINode ln );

/**
   Sub-Graph node.
   It replaces a sub-graph (aSubGraph) by its nodes in the graph. The dependences are propagated to/from the internal
   nodes of the sub-graph. The sub-graph (aSubGraph) is removed from the node manager.
 */
boolean /*NodeManager::*/subGraphFlattenning( ptINode aSubGraph );

/**
   Array node.
   The internal nodes and the clocks of an array-node (arrayNode) are linked with this array node. The method 
   is applied recursively if brec.
   After this operation the get_inComposedNode(n, &x) will return "true" and arrayNode in x, for each nodes n of the array-node.
   This operation is applied for the body graph and the initial graph of an array node.
   \see {get_inComposedNode}
 */
void /*NodeManager::*/arrayLinkNodes( ptINode arrayNode ,boolean brec );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*NodeManager::*/arrayUnlinkNodes( ptINode arrayNode ,boolean brec );

/**
   Array node.
   @return the depth of the array block for a node (node).
 */
int /*NodeManager::*/arrayGetLevelBlock( ptINode node );

/**
   Array node.
   @return true if the ouptut parameter nodeArrayIndex is defined (i.e in a array block), false otherwise.
   @param nodeArrayIndex (out)  the node of the inner index of the array blocks for a set of nodes
   (nodes of the signals of lsig list, and nodes of the indexes of the lindexes list)
   @param lsig (in) list of signals 
   @param lindexes (in) list of indexes
 */
boolean /*NodeManager::*/arrayGetMaxLevelIndex( ptlinstances lsig ,ptlinstances lindexes ,ptINode* nodeArrayIndex );

/**
   Sub-Graph node.
   A node (aNode) is inserted into a sub-graph (sg).
 */
boolean /*NodeManager::*/subGraphInsertNode( ptINode sg ,ptINode aNode );

/**
   Sub-Graph node.
   A node (aNode) is removed from a sub-graph node (node).
 */
boolean /*NodeManager::*/subGraphRemoveNode( ptINode node ,ptINode aNode );

/**
   Sub-Graph node.
   A clock (vh) is inserted into a sub-graph node (node).
 */
boolean /*NodeManager::*/subGraphInsertClock( ptINode node ,ptinsth vh );

/**
   Sub-graph node.
   A clock (vh) is removed from a sub-graph node (node).
 */
boolean /*NodeManager::*/subGraphRemoveClock( ptINode node ,ptinsth vh );

/**
   array node.
   The node (aNode) is inserted into the body sub-graph of an array (node).
 */
void /*NodeManager::*/arrayBodyInsertNode( ptINode node ,ptINode aNode );

/**
   array node.
   The clock (vh) is inserted into the body sub-graph of an array (node).
 */
void /*NodeManager::*/arrayBodyInsertClock( ptINode node ,ptinsth vh );

/**
   array node.
   The clock (vh) is removed from the body sub-graph of an array (node).
 */
void /*NodeManager::*/arrayBodyRemoveClock( ptINode node ,ptinsth vh );

/**
   array node.
   The node (aNode) is inserted into the initial sub-graph of an array (node).
 */
void /*NodeManager::*/arrayInitInsertNode( ptINode node ,ptINode aNode );

/**
   array node.
   The node (aNode) is removed from the initial sub-graph of an array (node).
 */
void /*NodeManager::*/arrayInitRemoveNode( ptINode node ,ptINode aNode );

/**
   array node.
   A clock (vclk) is inserted into the initial sub-graph of an array (node).
 */
void /*NodeManager::*/arrayInitInsertClock( ptINode node ,ptinsth vclk );

/**
   array node.
   A clock (vclk) is removed from the initial sub-graph of an array (node).
 */
void /*NodeManager::*/arrayInitRemoveClock( ptINode node ,ptinsth vclk );

/**
   array node.
   The node (n) is removed from the body sub-graph of an array (node).
 */
boolean /*NodeManager::*/arrayBodyRemoveNode( ptINode node ,ptINode n );

/**
   array node.
   The nodes of the list (ln) and the clocks of the list (lh) are assigned to the 
   body sub-graph of an array (n).
 */
boolean /*NodeManager::*/arrayBodySetDef( ptINode n ,ptlINode ln ,ptlinsth lh );

/**
   array node.
   The nodes of the list (ln) and the clocks of the list (lh) are assigned to the 
   initial sub-graph of an array (n).
 */
boolean /*NodeManager::*/arrayInitSetDef( ptINode n ,ptlINode ln ,ptlinsth lh );

/**
   Partial definition.
   A partial definition (node) is removed from the set of definitions of a signal (vsig).
   @return "true" is the set of partial definition becomes empty, "false" otherwise.
 */
boolean /*NodeManager::*/removeDefPart( ptexpcal vsig ,ptINode node );

/** @return a one-delayed signal of vsig.
    It creates a new signal (zx) defined as the 1-delayed of vsig. The node is inserted in the 
    graph.
 */
ptexpcal /*NodeManager::*/mkDelayOf( ptexpcal vsig );

/**
   The subgraphs are removed from the graph and their dependencies are propagated.
 */
void /*NodeManager::*/removingSubGraphs( void );

/**
   The implicit conversions defined in the Signal Manual reference are explicited.
 */
void /*NodeManager::*/explicitConversions( void );

/**
   @return the undefined clock if vexpr is "vDefinedSig $1", the contribution clock of vexpr otherwise.
 */
boolean /*NodeManager::*/assignmentClockExpr( ptexpcal vDefinedSig ,ptexpcal vexpr ,ptexpcal* vinit ,ptinsth* vhass );

/**
   @return "true" if the assignment clock for the operand node (node) is defined in vhAssignment, "false" otherwise.
   vhAssignment is equal to the undefined clock if the node is x ::= x$1, or  x ::= defaultvalue x$1.
   The assigment clock is assigned to the signal defined in node.
   A node is assumed to be an equation (not a delay).
   \See :setAssignmentClock(), getAssignmentClock().
 */
boolean /*NodeManager::*/assignmentClockEquation( ptINode node ,ptexpcal* vinit ,ptinsth* vhAssignment );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
ptinsth /*NodeManager::*/assignmentClockPartialEquation( ptINode node );

/**
   It computes the assignment clock of an equation ( node ).
   A node is assumed to be an equation (not a delay).
 */
ptinsth /*NodeManager::*/assignmentClockEquation( ptINode node );

/** It compute the assignment clock of a node (node).  */
ptinsth /*NodeManager::*/ComputeAssignmentClock( ptINode node );


