/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/


/** @name Node Manager Class.
   A Node Manager is assigned to each Graph.
*/
class NodeManager
{
#include "NodeManager_m.h"
#include "NodeDependence_m.h"
#include "NodeDependence_g.h"

#include "NodeRewriting_m.h"
#include "NodeRewriting_g.h"
#include "NodeInterface_g.h" 
#include "NodeInterface_m.h" 
#include "NodeAccessGet_g.h" 
#include "NodeAccessSet_g.h" 
#include "NodeMake_g.h"
#include "NodeAttributes_g.h"
#include "NodeManager_g.h"
private:
  ptExprManager  EM;
  ptClockManager CKM;
  ptTraceabilityManager TM;
  ptinsth hundef, the_nullClock_NM_copy;

  ptlINode AllNodes, deletedNodes;
  ptlINode lread, lwrite, ldelay, ldefsig, lArray, ldefpart;
  ptlINode listrefextern, lNodeCall, lSubGraph, lBundStruct;

  ptlINode AllNodesEnd, deletedNodesEnd;
  ptlINode lreadEnd, lwriteEnd, ldelayEnd, ldefsigEnd, lArrayEnd, ldefpartEnd;
  ptlINode listrefexternEnd, lNodeCallEnd, lSubGraphEnd, lBundStructEnd;

  ptldependence GdependencesList;
};

