/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

private:

/**
   It resets the dependences reaching a node (node) and the node belongs an equation node.
   The status is not modified for a partial definition.
 */
void /*NodeManager::*/resetAsEquation( ptINode node );

/**
   @return the node of the defined signal (vexpadef).
   It associates to a signal (vexpadef) the expression (vexpdedef when H) with
   - H=vhcal if vexpadef is not already defined
   - H is the complement of K in vhcal, where K is the clock of the expression already assigned to vexpadef.

   instent: list of the signals referenced in vexpdedef, used to define the dependences.
 */
ptINode /*NodeManager::*/addaff( ptexpcal vexpadef ,ptexpcal vexpdedef ,ptinsth vhcal ,ptlinstances instent );

/**
   It creates a partial definition node in the graph by 
   - "left ::= right when vhcal",  
   - instent: list of the signals referenced in right, used to define the dependences.
   @return the created partial definition node.
 */
ptINode /*NodeManager::*/mkPartEquation( ptexpcal left ,ptexpcal right ,ptinsth vhcal ,ptlinstances instent );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*NodeManager::*/addSynchrosFields( ptlinstances lsig1 ,ptlinstances lsig2 );

/**
   Adding the synchronisation for lexp := rexp, for a bundle type.
 */
void /*NodeManager::*/addSynchrosBundle( ptexpcal lexp ,ptexpcal rexp );

/**
  @param aNode  (in) a node, assumed to be an equation ("opdefsig" operator).
  It simplifies the definition of the signal vexpcal1 when it is a event.
  In this case, the constraint ^vexpca1 ^= when vexpcal is added to the clock system.
  Otherwise, the expression of definition of the signal can be completed as a cell 
  using the clock of the signal and the assignment clock.
  @return none.
 */
void /*NodeManager::*/end_equation( ptINode aNode );

/**
   It inserts (putinstr()) a node (aNode), assumed to be an equation, in the graph associated with a clock (vh).
   It adds the dependences (addDependence(ptinsth, ptINode)) from the contribution clocks of the definition to the node. 
   The dependences from the signals referenced in the expressions are not added here, they have been already added in addaff().
 */
void /*NodeManager::*/graph_add_defsig( ptINode aNode ,ptinsth vh );

/**
   It inserts a node (aNode) in the graph associated with a clock (vh).
   For each element X of lins, a dependence from the node of X to aNode is added.
 */
void /*NodeManager::*/putinstr( ptINode aNode ,ptinsth vh ,ptlinstances lins );

/**
   It inserts a node (aNode) in the graph associated with a clock (vh). This node defines a set of signals (louts).
   For each element X of lins, a dependence from the node of X to aNode is added.
 */
void /*NodeManager::*/addmultinstruction( ptexpcal louts ,ptINode aNode ,ptinsth vh ,ptexpcal lins );

/**
   - aNode is assumed to be a node call with vh as associated clock
   - lout is the signals defined in aNode

   For each element of louts, it adds a node (read node) in the graph with vh as clock.
   The set of created nodes is assigned to the node call.
 */
void /*NodeManager::*/addInputNodesForOutputs( ptexpcal lout ,ptINode aNode ,ptinsth vh );

/**
   It inserts in the graph a node (aNode) assumed to be a node call with vh as associated clock.
 */
void /*NodeManager::*/addNodeCall( ptINode aNode ,ptinsth vh );

/**
   It inserts in the graph a node (aSubGraph) assumed to be a node associtaed with a sub-graph with vh as associated clock.
 */
void /*NodeManager::*/addSubGraph( ptINode aSubGraph ,ptinsth vh );

/**
   For a sub-graph (sg),
    - it returns ln the list of its nodes and clocks the list of the its clocks 
    - otherwise ln is composed of sg, and clocks the empty list.
 */
void /*NodeManager::*/getNodesClocksDefinedIn( ptINode sg ,ptlINode* ln ,ptlinsth* clocks );

/**
   It inserts a node (n) in the sub-graph associated with a clock (h).
 */
void /*NodeManager::*/insertgfd( ptINode n ,ptinsth h );

/**
   It removes a node (aNode) from the internal table of the node manager.
 */
void /*NodeManager::*/removeInSet( ptINode aNode );

/**
   For a "bundle/struct" node (lfields) node (n).
   It merges the nodes of the fields in n.
   It is used  when a structure is globaly assigned.
 */
void /*NodeManager::*/nodesMerging( ptINode n );

/**
   A node (n) of a sub-graph is removed from  its sub-graph.
   (It searches in all the sub-graphs).
 */
void /*NodeManager::*/removeInArraysSubGraphs( ptINode n );

/**
   Each node of ln is removed from the sub-graph of its clock.
 */
void /*NodeManager::*/unlinkNodesToClock( ptlINode ln );

/**
   It inserts a node (node) in a table characterized by its firt element (lbegin) and its last one (lend).
 */
void /*NodeManager::*/insertTable( ptINode node ,ptlINode* lbegin ,ptlINode* lend );

/**
   It removes a node (node) from a table characterized by its firt element (lbegin) and its last one (lend).
 */
boolean /*NodeManager::*/removeTable( ptINode node ,ptlINode* lbegin ,ptlINode* lend );

/**
   It removes a node (node) from the node manager. 
   It calls removeTable() taking into account the class of the node (equation, delay,...).
 */
void /*NodeManager::*/removeInSetCase( ptINode aNode );

/**
   It unifies the nodes assigned to a list of signals (listOfSignals) into only one node (node).
 */
void /*NodeManager::*/unifyNodesForSeveralOutputs( ptlinstances listOfSignals ,ptINode node );

/** 
    Array node.
    Adding dependence form the index of an array to an internal node of the array.
    The internal signals (access to element x[i]) are linked with their definition using a "global" attribute.
 */
void /*NodeManager::*/linkInodeToInodeArray( ptINode aNode ,ptINode ArrayNode );

/**
   sub-Graph node.
   The internal nodes and the clocks of a sub-graph (SubGraph) are linked with composedNode.
   After this operation the \ref get_inComposedNode (n, &x) will return "true" and SubGraph in x, for each nodes n of the sub-graph node.
   When the parameter bflatInternalSubGraph is "true" the operation is recursively applied to the internal sub-graphs of SubGraph.
 */
void /*NodeManager::*/subGraphLinkNodes( ptINode SubGraph ,ptINode composedNode ,boolean bflatInternalSubGraph );

/**
   aNode element of aSubGraph becomes a node of a composed node upBlock.
 */
void /*NodeManager::*/addInBlock( ptINode aNode ,ptINode upBlock ,ptINode aSubGraph );

/**
   The nodes of a subgraph (aSubGraph) becomes nodes of the subgraph of this subgraph.
 */
void /*NodeManager::*/removeBlockSubGraph( ptINode aSubGraph );

/** @return "true" if the output list (list) is not empty, "false" otherwise.
    @param list (out) list of the nodes of the graph  with code as opertor (equation, memorization, ....)
    @param code (in) a SIGNAL operator.
 */
boolean /*NodeManager::*/getNodesList( noperators code ,ptlINode* list );

/**
   The implicit conversions defined in the Signal Manual reference are explicited.
   It calls 
   - ExprManager::ExplicitConversions() followed by
   - ExprManager::EM->rewritingExprEH, then 
 */
void /*NodeManager::*/explicitConversions( ptlINode lNodes );


