/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

/** Representation (bidirectional) of an element of a list of nodes. */
struct linstr {
  ptlINode pred,		///< previous element of the list
   next;			///< next element of the list
  ptINode elem;			///< node associated with the element.
};

ptlINode gclinodes = NILLINODE;	// Garbage

/** It links two elements  of list of nodes (l1, l2): ie  next(l1)=l2, pred(l2)=l1.
*/
static void ptlInode_link(ptlINode l1, ptlINode l2)
{
  ptlINode v;

  l1->next = l2;
  v = l2->pred;
  if (v != NILLINODE)
    {
      l1->pred = v;
      v->next = l1;
    }
  l2->pred = l1;
}
