/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
/**
   Representation of the nodes of a graph.
*/

static int numNode = 0;

/**
   It assigns the global current number (numNode) to a node (vNode). numNode is increased.
*/
void setNumNode(ptINode vNode)
{
  numNode = numNode + 1;
  vNode->setnum(numNode);
}

static void ptINode_clear(ptINode vinstr)
{
  vinstr->horl = NILINSTH;
  vinstr->ptINodebc = NILINODE;
  vinstr->U.instidref = NILLINSTID;
  vinstr->interface = NILINTERFACE;
  vinstr->lsucc = NILLDEPENDENCE;
  vinstr->lpred = NILLDEPENDENCE;
  vinstr->lpredhorl = NILLINSTH;
  vinstr->lsucchorl = NILLINSTH;
  vinstr->label = NILEXPCAL;
  vinstr->inNode = NILEXPCAL;
  vinstr->outNode = NILEXPCAL;
  vinstr->safetyInfo = opsafe;
  vinstr->iterationPrecedenceLst = NILLDEPENDENCE;
  vinstr->setwhoami(nodeObject);
  vinstr->backAnnotation = NILBACKANNOTATION;
}

///
static void ptINode_init_gen(ptINode vinstr)
{
  setNumNode(vinstr);
  ptINode_clear(vinstr);
}
