/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#include "cstdio"
#include <vector>

typedef FILE *RefFILE; // For printing

#define TableInitialSize 4
#define SHELL_TableMaxSize "SHELL_TypeTableMaxSize"
#define TableResizingFactor 2

typedef long int TypeType;  // TypeType is the index in the type table for user defined types
typedef int TypeClass; // Type for DC type Classes
typedef TypeType *ptTypeType; 
typedef std::vector <TypeType> LTypes;

// Predefined types
#define LabelType -1
#define PureType -2
#define BooleanType -3
#define ShortType -4
#define IntegerType -5
#define LongType -6
#define RealType -7
#define DRealType -8
#define ComplexType -9
#define DComplexType -10
#define CharType -11
#define StringType -12
#define ByteType -13
#define WordType -14
#define ErrorType -15

#define nbPredefinedType 16

// Categories
#define LastClassNumber 16
#define SimpleClass -1  
#define ExternClass 0
#define EnumerationClass 1  
#define SubrangeClass 2
#define BitsClass 3
#define ArrayClass 4
#define MatrixClass 5
#define NamedClass 6
#define LambdaClass 7
#define AnyClass 8
#define MetaClass 9
#define TupleClass 10
#define StructureClass 11
#define BundleClass 12
#define NodeClass 13
#define GenericNodeClass 14
#define MetaNodeClass 15
