/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

/* --------------------------------------------------------
   TypeTestArrayClass(TypeType TT)
   ========================================================
   returns:
   True if TT is an array class
   ------------------------------------------------------------*/
extern BoolType
TypeTestArrayClass (TypeType TT)
  /*---------------************------------------------*/
{
  return (TestArrayClass (TT));
}

/* --------------------------------------------------------
   TypeTestMatrixClass(TypeType TT)
   ========================================================
   returns:
   True if TT is a matrix class
   ------------------------------------------------------------*/
extern BoolType
TypeTestMatrixClass (TypeType TT)
  /*---------------************------------------------*/
{
  if (macroTytestpredef (TT))
    return pk_false;
  else
    return (macroCltestMatrixClass (macroTygetclass (TT)));
}

extern TypeType
ArrayTypeCreate (ExpcalCstList DimLst, TypeType Term)
{
  TypeType TT;
  if (ArrayFind (&DimLst, Term, &TT));
  else
    TT = ArrayMatrixCreate (ArrayClass, DimLst, Term);
  return TT;
}

extern TypeType
MatrixTypeCreate (ExpcalCstList DimLst, TypeType Term)
{
  TypeType TT;
  if (MatrixFind (DimLst, Term, &TT));
  else
    TT = ArrayMatrixCreate (MatrixClass, DimLst, Term);
  return TT;
}

extern ExpcalCstList
ArrayMatrixTypeGetDimLst (TypeType TT)
  /*---------------***********---------------------------------------*/
{
  return ArrayMatrixGetDimLst (TT);
}

extern TypeType
ArrayMatrixTypeGetTerm (TypeType TT)
  /*---------------***********---------------------------------------*/
{
  return ArrayMatrixGetTerm (TT);
}

extern TypeType
ArrayMatrixTypeGetCurrent (TypeType TT)
  /*---------------***********---------------------------------------*/
{
  return ArrayMatrixGetCurrent (TT);
}

extern ExpcalCstList
ArrayMatrixCurrentTypeGetDimLst (TypeType TT)
  /*---------------***********---------------------------------------*/
{
  TypeType RTT;
  if (ArrayMatrixRecTestandGetCurrent (TT, &RTT))
    return ArrayMatrixGetDimLst (RTT);
  return ArrayMatrixGetDimLst (TT);
}

extern TypeType
ArrayMatrixCurrentTypeGetTerm (TypeType TT)
  /*---------------***********---------------------------------------*/
{
  TypeType RTT;
  if (ArrayMatrixRecTestandGetCurrent (TT, &RTT))
    return ArrayMatrixGetTerm (RTT);
  return ArrayMatrixGetTerm (TT);
}

extern BoolType
TypeTestArrayMatrix (TypeType TT)
  /*---------------************------------------------*/
{
  return (ClassTestArrayMatrix (TT));
}
