/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/


/* Testing.
   @returns True if TT is an array of bits class
*/
extern BoolType
TypeTestBitsClass (TypeType TT)
  /*---------------************------------------------*/
{
  if (macroTytestpredef (TT))
    return pk_false;
  else
    return (macroCltestBitsClass (macroTygetclass (TT)));
}

/* Creating a Bits type.
   @return a new BitsType with parameters Bounds.
*/
extern TypeType
BitsTypeCreate (ExpcalCst Bounds)
{
  TypeType TT;
  if (BitsFind (Bounds, &TT));
  else
    TT = BitsCreate (Bounds);
  return TT;
}

/* Getting bounds of a Bit type.
   @return the bounds assigned to the Bit type.
*/
extern ExpcalCst
BitsTypeGetDim (TypeType TT)
  /*---------------***********---------------------------------------*/
{
  return (BitsGetDim (TT));
}
