/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
/**
   |**
   |***                                                      File TypeBits_i.c
   |**						       	            **|
   |**						       	            **|
   |**						       	            **|
   |**	      	THIS FILE CONTAINS T Y P E REPRESENTATION           **|
   |**		           LOCAL FUNCTIONS                          **|
   |**		           for Bits types                           **|
   |**								    **|
   |*********|*********|*********|*********|*********|*********|*********/


typedef struct
{
  TypeType WhoamI;
  ExpcalCst Dim;
} BitsTypeRepr;
#define macroBitsgetdim(tyde) (tyde->Dim)
#define macroBitsset(tyde,dim) {\
       (tyde->Dim)=dim;\
    }

#define  macroTyBitsSTree_getDescriptionr(tyty) (macroTySTree_getDescriptionr(BitsTypeRepr,tyty))

static ExpcalCst
BitsGetDim (TypeType TT)
  /*---------------***********---------------------------------------*/
{
  return (macroBitsgetdim (macroTyBitsSTree_getDescriptionr (TT)));
}

/* Creating a Bits type.
   @return a new BitsType with parameters VariableLst and term Term
*/
static TypeType
BitsCreate (ExpcalCstList PDim)
  /*---------------***********---------------------------------------*/
{
  /* Common Part */
  TypeType TT;
  BitsTypeRepr *Descr;
  Descr = (BitsTypeRepr *) (malloc (sizeof (BitsTypeRepr)));
  TT = NewTypeItem (BitsClass, Descr);
  AppendClassEntry (BitsClass, Descr);
  macroDesetmyself (Descr, TT);
  /* Specific Part */
  macroBitsset (Descr, PDim) return TT;
}

/* Finding a Bits Type.
   @return false if no BitsType with parameters Dim exists; true if some existing BitsType T has 
   parameter Dim
   @param TT (out) T is assigned to TT.
*/
static BoolType
BitsFind (ExpcalCstList Dim, TypeType * TT)
  /*---------------***********---------------------------------------*/
{
  BoolType result;
  TypeReprSubList ReprLst;
  BitsTypeRepr *Descr;
  result = pk_false;
  ReprLst = TypeClassTable[BitsClass].First;
  while (!((result == pk_true) || (NullPointerDef (ReprLst))))
    {
      Descr = (BitsTypeRepr *) (GetCar (ReprLst));
      ReprLst = GetCdr (ReprLst);
      if (ExpcalCstEq (macroBitsgetdim (Descr), Dim))
	{
	  result = pk_true;
	  *TT = macroDegetmyself (Descr);
	}
    }
  return result;
}
