/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

static TypeType UndefinedType;	// predefined undefined type (LBesnard Jul 2001)
#include "cstdio"



/**                                                      File TypeManager_m.c
							 |**						       	 ====================
							 |**						       	            **|
							 |**						       	            **|
							 |**						       	            **|
							 |**	      	THIS FILE CONTAINS T Y P E REPRESENTATION           **|
							 |**		           LOCAL DECLARATIONS                       **|
							 |**								    **|
							 |*********|*********|*********|*********|*********|*********|*********/

/************************************
				     |**  Types for DC Type designation
				     |************************************/

/***--- TypeType is the index in the type table for user defined types;
    typedef int TypeType;
*/

/************************************
				     |**  Type for DC type Classes
				     |************************************/
/*
  typedef int TypeClass;
*/


#define macroCltestExternClass(clcl) (clcl==ExternClass)
#define macroCltestEnumerationClass(clcl) (clcl==EnumerationClass)
#define macroCltestSubrangeClass(clcl) (clcl==SubrangeClass)
#define macroCltestBitsClass(clcl) (clcl==BitsClass)
#define macroCltestArrayClass(clcl) (clcl==ArrayClass)
#define macroCltestMatrixClass(clcl) (clcl==MatrixClass)
#define macroCltestNamedClass(clcl) (clcl==NamedClass)
#define macroCltestLambdaClass(clcl) (clcl==LambdaClass)
#define macroCltestAnyClass(clcl) (clcl==AnyClass)
#define macroCltestMetaClass(clcl) (clcl==MetaClass)
#define macroCltestTupleClass(clcl) (clcl==TupleClass)
#define macroCltestStructureClass(clcl) (clcl==StructureClass)
#define macroCltestBundleClass(clcl) (clcl==BundleClass)
#define macroCltestNodeClass(clcl) (clcl==NodeClass)
#define macroCltestGenericNodeClass(clcl) (clcl==GenericNodeClass)
#define macroCltestMetaNodeClass(clcl) (clcl==MetaNodeClass)

#define macroCltestSimple(clcl) \
((clcl >= ExternClass) &&(clcl <= SubrangeClass))
#define macroCltestArrayMatrix(clcl) \
((clcl== ArrayClass) || (clcl == MatrixClass))
#define macroCltestAbstract(clcl) \
 ((clcl >= LambdaClass) && (clcl <= MetaClass))
#define macroCltestProduct(clcl) \
((clcl >= TupleClass) && (clcl <= BundleClass))
#define macroCltestApplication(clcl) \
((clcl >= NodeClass) && (clcl <= MetaNodeClass))

#define macroCltestParameter(clcl) \
((clcl>= SubrangeClass) && (clcl <= MatrixClass))
/* A Type Table Entry is an Index composed of a category attribute
   (listed above) and a pointer to attribute description Refdescr
   (effective C type depends on the category) */

/*                                                      *************/

/*********|*********|*********|*********|*********|*********|*********|
	  |**					       			    **|
	  |**			     	TYPE Descriptors         	    **|
	  |**							       	    **|
	  |*********|*********|*********|*********|*********|*********|*********/

/***********************************************/
/*** define general clauses for local access ***/
/***********************************************/
#define macroDegetmyself(tyde) (tyde->WhoamI)
#define macroDesetmyself(tyde,ty) tyde->WhoamI = ty;
#define macroDegetcurrent(tyde) (tyde->CurrentType)
#define macroDesetcurrent(tyde,tyty) (tyde->CurrentType)=tyty;

BoolType TypeReduction (TypeType TT, TypeType * RTT);
