/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
/***                                         File TypeMemoryManagerRepr_i.c
					     |**					     ==============================
					     |**						       	            **|
					     |**						       	            **|
					     |**						       	            **|
					     |**						       	            **|
					     |**						       	            **|
					     |**	      	THIS FILE CONTAINS T Y P E REPRESENTATION           **|
					     |**		      low level LOCAL FUNCTIONS                     **|
					     |**								    **|
					     |*********|*********|*********|*********|*********|*********|*********/

/* Type Classes Table */
typedef Pointer ClassTypeRepr;
typedef struct LTypeReprCell
{
  struct LTypeReprCell *CdR;
  ClassTypeRepr CaR;
} TypeReprCell;
#define GetCar(XLst) (XLst->CaR)
#define GetCdr(XLst) (XLst->CdR)
typedef TypeReprCell *TypeReprSubList;
typedef struct
{
  TypeReprSubList First;
  TypeReprSubList Last;
} TypeReprList;

/***ITM Common Item Table Management
    ================================================================   */

TypeReprList TypeClassTable[LastClassNumber + 1];

#define macroCTgetfirst(k) (TypeClassTable[k].First)
#define macroCTgetlast(k) (TypeClassTable[k].Last)
#define macroCTsetfirst(k,v) TypeClassTable[k].First=v;
#define macroCTsetlast(k,v) TypeClassTable[k].Last=v;
#define macroCTempty(kk) {\
  TypeClassTable[kk].First=(TypeReprCell*)NullPointer;\
  TypeClassTable[kk].Last=(TypeReprCell*)NullPointer;\
}
#define macroCTtestempty(k) (TypeClassTable[k].First==NullPointer)
#define macroCTappend(k,v) (TypeClassTable[k].Last)->CdR=v;

#define TypeTableName "Type Table"


/* --------------------------------------------------------
   ClassTableInitiate()
   ========================================================
   side effect:
   Initializes the Class Table entries with empty lists
*/
static void
ClassTableInitiate ()
  /*----------*********************---------------*/
{
  int k;
  for (k = 0; k <= LastClassNumber; k++)
    {
    macroCTempty (k)}
}

/* --------------------------------------------------------
   AppendClassEntry(TypeClass Category, Pointer RefDescr)
   ========================================================
   side effect:
   Appends RefDescr at the end of the Category entry 
   in the Class Table
*/
static void
AppendClassEntry (TypeClass Category, Pointer RefDescr)
  /*---------------***********---------------------------------------*/
{
  TypeReprSubList RefCadR;
  RefCadR = (TypeReprSubList) (malloc (sizeof (TypeReprCell)));
  if (macroCTtestempty (Category))
    macroCTsetfirst (Category, RefCadR)
    else
    macroCTappend (Category, RefCadR) macroCTsetlast (Category, RefCadR) (GetCar (RefCadR)) = RefDescr;
  (GetCdr (RefCadR)) = (LTypeReprCell *) NullPointer;
}
