/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

extern TypeType
get_ErrorType ()
{
  return (ErrorType);
}

extern TypeType
get_LabelType ()
{
  return (LabelType);
}

extern TypeType
get_PureType ()
{
  return (PureType);
}

extern TypeType
get_BooleanType ()
{
  return (BooleanType);
}

extern TypeType
get_ShortType ()
{
  return (ShortType);
}

extern TypeType
get_IntegerType ()
{
  return (IntegerType);
}

extern TypeType
get_LongType ()
{
  return (LongType);
}

extern TypeType
get_RealType ()
{
  return (RealType);
}

extern TypeType
get_DRealType ()
{
  return (DRealType);
}

extern TypeType
get_ComplexType ()
{
  return (ComplexType);
}

extern TypeType
get_DComplexType ()
{
  return (DComplexType);
}

extern TypeType
get_CharType ()
{
  return (CharType);
}

extern TypeType
get_StringType ()
{
  return (StringType);
}

extern TypeType
get_ByteType ()
{
  return (ByteType);
}

extern TypeType
get_WordType ()
{
  return (WordType);
}


/* --------------------------------------------------------
   TypeTestPredef(TypeType TT)
   ========================================================
   returns:
   pk_true if the result is a predefined type
*/
extern BoolType
TypeTestPredef (TypeType TT)
{
  return (macroTytestpredef (TT));
}

/* Conversion between PREDEFINED types
   return pk_true : source and target are Predefined types of the same domain ; 
                 then using inclusion relation defined in the Signal reference manual.
*/
extern boolean
TypeImplicitConversionPredef (TypeType Source, TypeType Target)
{
  // appended by L. Besnard (Aug 2000)
  if (!macroTytestpredef (Source))
    return pk_false;
  if (!macroTytestpredef (Target))
    return pk_false;
  return (boolean) macroPredefTestImplicitConv (Source, Target);
}
