/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
/***
    |**
    |**                                                     File TypePredef_i.c
    |**						       	            **|
    |**						       	            **|
    |**						       	            **|
    |**	      	THIS FILE CONTAINS T Y P E REPRESENTATION           **|
    |**		            LOCAL FUNCTIONS                         **|
    |**		          for predefined types                      **|
    |**								    **|
    |*********|*********|*********|*********|*********|*********|*********/

#define PredefNumber 15
#define macroTytestpredef(tyty) ((tyty<0) && (tyty >= -(PredefNumber)))
/***	PredefinedSlocS types have the following TypeType: */

/* #define LabelType -1
   #define PureType -2
   #define BooleanType -3
   #define ShortType -4
   #define IntegerType -5
   #define LongType -6
   #define RealType -7
   #define DRealType -8
   #define ComplexType -9
   #define DComplexType -10
   #define CharType -11
   #define StringType -12
   #define ByteType -13
   #define WordType -14
   #define ErrorType -15
*/

int PredefSup[15][15] = {
  {15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15},
  {15, 1, 2, 3, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15},
  {15, 2, 2, 3, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15},
  {15, 3, 3, 3, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15},
  {15, 15, 15, 15, 4, 5, 6, 15, 15, 15, 15, 15, 15, 15, 15},
  {15, 15, 15, 15, 5, 5, 6, 15, 15, 15, 15, 15, 15, 15, 15},
  {15, 15, 15, 15, 6, 6, 6, 15, 15, 15, 15, 15, 15, 15, 15},
  {15, 15, 15, 15, 15, 15, 15, 7, 8, 15, 15, 15, 15, 15, 15},
  {15, 15, 15, 15, 15, 15, 15, 8, 8, 15, 15, 15, 15, 15, 15},
  {15, 15, 15, 15, 15, 15, 15, 15, 15, 9, 10, 15, 15, 15, 15},
  {15, 15, 15, 15, 15, 15, 15, 15, 15, 10, 10, 15, 15, 15, 15},
  {15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 11, 12, 15, 15},
  {15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 12, 12, 15, 15},
  {15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 13, 15},
  {15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 14}
};

#define macroPredefUpB(ty1, ty2) \
 (-(PredefSup[(-ty1)][(-ty2)]))

#define macroPredefGe(ty1, ty2) \
 ((PredefSup[(-ty1)][(-ty2)]) == (-ty1))

int PredefCast[15][15] = {
  {15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15},	// dummy
  {15, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14},	// label
  {15, 15, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14},	// pure
  {15, 15, 15, 3, 4, 5, 6, 7, 8, 9, 10, 15, 12, 15, 14},	// boolean
  {15, 15, 15, 15, 4, 5, 6, 7, 8, 9, 10, 15, 12, 15, 14},	//short 
  {15, 15, 15, 15, 15, 5, 6, 7, 8, 9, 10, 15, 12, 15, 14},	//int
  {15, 15, 15, 15, 15, 15, 6, 15, 8, 15, 10, 15, 12, 15, 15},	//long
  {15, 15, 15, 15, 15, 15, 15, 7, 8, 9, 10, 15, 12, 15, 14},	//real
  {15, 15, 15, 15, 15, 15, 15, 15, 8, 15, 15, 15, 12, 15, 15},	//dreal
  {15, 15, 15, 15, 15, 15, 15, 15, 15, 9, 10, 15, 12, 15, 15},	//complex
  {15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 10, 15, 12, 15, 15},	//dcomplex
  {15, 15, 15, 15, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14},	// char
  {15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 12, 15, 15},	//string
  {15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 11, 12, 13, 14},	// byte
  {15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 12, 15, 14}	// word
};

// Modif Loic Besnard
// #define macroPredefTestCast(ty1, ty2) ((PredefCast[-ty1][-ty2]) != ErrorType)
#define macroPredefTestCast(ty1, ty2) ((PredefCast[-(ty1)][-(ty2)]) != -(ErrorType))

int PredefImplicitConv[16][16] = {
  {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},	// Dummy
  {0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},	// label
  {0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},	// pure
  {0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},	// boolean
  {0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0},	// short 
  {0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0},	// int
  {0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0},	// long
  {0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0},	// real
  {0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0},	// dreal
  {0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0},	// complex
  {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0},	// dcomplex
  {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0},	// char
  {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0},	// string
  {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0},	// byte
  {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0},	// word
  {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}	// ErrorType
};

#define macroPredefTestImplicitConv(ty1, ty2) (PredefImplicitConv[-ty1][-ty2])


#define macroPredeftestlogical(tyty) \
  ((tyty <= PureType) && (tyty >=BooleanType))
#define macroPredeftestintnumber(tyty) \
  ((tyty <= ShortType) && (tyty >= LongType ))
#define macroPredeftestrealnumber(tyty) \
  ((tyty == RealType) || (tyty == DRealType))
#define macroPredeftestcomplexnumber(tyty) \
 ((tyty == ComplexType) || (tyty == DComplexType))
#define macroPredeftesttext(tyty) \
 ((tyty == CharType) || (tyty == StringType))
#define macroPredeftestmemory(tyty) \
 ((tyty == ByteType) || (tyty == WordType))

#define macroPredeftestnumerical(tyty) \
((tyty <= ShortType) && (tyty >= DComplexType))

#define macroPredeftestorder(tyty) \
 (((tyty <= ShortType) && (tyty >= DRealType )) || (macroPredeftesttext(tyty)))
#define macroPredeftestpartorder(tyty) ((tyty <= PureType) && (tyty >=StringType))

#define macroTytestLabelType(tyty) (tyty==LabelType)
#define macroTytestPureType(tyty) (tyty==PureType)
#define macroTytestBooleanType(tyty) (tyty==BooleanType)
#define macroTytestShortType(tyty) (tyty==ShortType)
#define macroTytestIntegerType(tyty) (tyty==IntegerType)
#define macroTytestLongType(tyty) (tyty==LongType)
#define macroTytestRealType(tyty) (tyty==RealType)
#define macroTytestDRealType(tyty) (tyty==DRealType)
#define macroTytestComplexType(tyty) (tyty==ComplexType)
#define macroTytestDComplexType(tyty) (tyty==DComplexType)
#define macroTytestCharType(tyty) (tyty==CharType)
#define macroTytestStringType(tyty) (tyty==StringType)
#define macroTytestByteType(tyty) (tyty==ByteType)
#define macroTytestWordType(tyty) (tyty==WordType)
