/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/


/**
   @return for a type TT (internal representation of the types), the associated Signal operator.
   It is restricted to the predefined types, for the other ones, it returns the \b opnil operator.
*/
extern noperators
predefTypeType2SignalType (TypeType TT)
{
  if (TypeTestPredef (TT))
    {
      switch ((int) TT)
	{
	case ErrorType:
	  return opnil;
	case LabelType:
	  return opnil;
	case PureType:
	  return opevent;
	case BooleanType:
	  return oplogical;
	case ShortType:
	  return opshort;
	case IntegerType:
	  return opinteger;
	case LongType:
	  return oplong;
	case RealType:
	  return opreal;
	case DRealType:
	  return opdpreal;
	case ComplexType:
	  return opcomplex;
	case DComplexType:
	  return opdcomplex;
	case CharType:
	  return opchar;
	case StringType:
	  return opstring;
	case ByteType:
	  return opnil;
	case WordType:
	  return opnil;
	}
    }
  return opnil;
}
