/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

/**
   |**                                                        TypeSigprint_g.c
   |**                                                        ================
   |**						       	            **|
   |**	      	THIS FILE CONTAINS T Y P E Signal Printing          **|
   |**		           GLOBAL FUNCTIONS                          **|
   |**								    **|
   |*********|*********|*********|*********|*********|*********|*********/


extern void
SigTypePrint (RefFILE stderrorout, TypeType TT)
  /*---------------************------------------------
    TT is any type */
{
  macrowInt (stderrorout, TT);
  macrowddot (stderrorout);
  if (macroTytestpredef (TT))
    SigPredefTypePrint (stderrorout, TT);
  else
    {
      TypeClass ClCl;
      ClCl = macroTygetclass (TT);
      switch (ClCl)
	{
	case ExternClass:
	  SigExternTypePrint (stderrorout, TT);
	  break;
	case EnumerationClass:
	  SigEnumerationTypePrint (stderrorout, TT);
	  break;
	case SubrangeClass:
	  SigSubrangeTypePrint (stderrorout, TT);
	  break;
	case BitsClass:
	  SigBitsTypePrint (stderrorout, TT);
	  break;
	case ArrayClass:
	  SigArrayMatrixTypePrint (stderrorout, TT);
	  break;
	case MatrixClass:
	  SigArrayMatrixTypePrint (stderrorout, TT);
	  break;
	case NamedClass:
	  SigNamedTypeDeclPrint (stderrorout, TT);
	  break;
	case LambdaClass:
	  SigLambdaTypePrint (stderrorout, TT);
	  break;
	case AnyClass:
	  SigAnyTypePrint (stderrorout, TT);
	  break;
	case MetaClass:
	  SigMetaTypePrint (stderrorout, TT);
	  break;
	case TupleClass:
	  SigTupleTypePrint (stderrorout, TT);
	  break;
	case StructureClass:
	  SigStructureTypePrint (stderrorout, TT);
	  break;
	case BundleClass:
	  macrowString (stderrorout, SigClassStr[ClCl]);
	  break;
	case NodeClass:
	  SigNodeTypePrint (stderrorout, TT);
	  break;
	case GenericNodeClass:
	  SigGenericNodeTypePrint (stderrorout, TT);
	  break;
	case MetaNodeClass:
	  SigMetaNodeTypePrint (stderrorout, TT);
	}
    }
}
