/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/


class TravelDepManager
{
public:
  
#include "TravelDepManager_m.h"
#include "TravelDepManagerAttributes_i.h"
#include "TravelDepManager_g.h"
#include "TravelDepManagerAttributes_g.h"

private:

  ptDCG AGRAPH;    ///< operand graph: the functionality is applied to this graph.
  ptExprManager EM;   ///< operand graph info: expression manager.
  ptClockManager CKM; ///< operand graph info: clock manager.
  ptNodeManager NM;   ///< operand graph info: node manager.

  ptinsth hcourante;   ///< current context: selected clock.
  ptgfd gfdhcourante;  ///< current context: the sub-graph assigned to hcourante
  ptINode bclcourante; ///< current context: current block (array node, sub graph)
  ptinsth toplancetre; ///< ???
  ptlinsth lancetre;   ///< list of the selected clocks by the algorithm.

  ptlinsth savhcour,   ///< saving context
    savtoplancetre;    ///< saving context
  ptlsucc savbclcour;  ///< saving context
 
  ptlinsth unClocks;  ///< unused clocks of the graph
  ptlINode unNodes;   ///< unused nodes of the graph
  boolean DEBUG_MODE; /// no comment !
};
