/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

/*  Node attributes for the travelling of the graph. */

#define NILTRAVELINODEATTRIBUTES (ptTravelINodeAttributes)pK_NIL

class TravelINodeAttributes
{
#include "TravelINodeAttributes_m.h"
#include "TravelINodeAttributes_g.h"
private:
  integer nbpredparc; ///< number of selected predecessors 
  integer nbpred;     ///< number of (waited) predecessors
  boolean parc;       ///< "true" when it have been selected, "false" otherwise.
  boolean reached;    ///< "true" when one (at least) of its predecessor has been selected by the algorithm, "false" otherwise.
};

#define NILTRAVELCLOCKEATTRIBUTES (ptTravelClockAttributes)pK_NIL

class TravelClockAttributes : public TravelINodeAttributes
{
#include "TravelClockAttributes_g.h"  
private:
  ptlsucc  lispredgen; ///< set of eligible nodes associated with a clock.
  ptlinsth lhspredgen; ///< set of eligible (children) clocks associated with a clock.
  ptinfoGenCodeSubTree nbspredtree;  ///< specific attributes associated with a node of a hierarchy (infoGenCodeSubTree class)
  boolean reached;     ///< "true" when one (at least) of its predecessor has been selected by the algorithm, "false" otherwise.
};



