/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PUBLIC_
/** 
   construtor.
   It specifies that vinit nodes are eligible for a block (bcl).
   It is not chained.
*/
  infoGenCodeSubTree::infoGenCodeSubTree (integer vinit, ptINode bcl)
{
  nbspred = vinit;
  blk = bcl;
  next = NILINFOGENCODESUBTREE;
}


/**
   @return "true" if from the current list there is an element (ptsp) associated with a selected block (bcl), "false" otherwise
*/
boolean infoGenCodeSubTree::findspredtree (ptINode bcl, ptinfoGenCodeSubTree * ptsp)
{
  boolean
    cont;

  *ptsp = this;
  cont = pk_true;
  while (cont)
    if (((*ptsp)->blk == bcl) || ((*ptsp)->next == NILINFOGENCODESUBTREE))
      cont = pk_false;
    else
      *ptsp = (*ptsp)->next;
  if ((*ptsp)->blk == bcl)
    return pk_true;
  return pk_false;
}

/**
   n becomes the next element of the current object.
*/
void
infoGenCodeSubTree::setnext (ptinfoGenCodeSubTree n)
{
  next = n;
}


/**
   @return the counter associated with the current object.
*/
integer
infoGenCodeSubTree::getnbspred ()
{
  return nbspred;
}

/**
   v becomes the new value of the counter of the current object.
*/
void
infoGenCodeSubTree::setnbspred (integer v)
{
  nbspred = v;
}

/**
   It increases the counter of the current object.
*/
void
infoGenCodeSubTree::incrnbspred ()
{
  nbspred++;
}
