/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

typedef class DCGBool2DCGSchTranslator * ptDCGBool2DCGSchTranslator;

class DCGBool2DCGSchTranslator
{
#include "DCGBool2DCGSchTranslatorDebug_i.h"
#include "DCGBool2DCGSchTranslator_m.h"
#include "DCGBool2DCGSchTranslator_g.h"

protected:
  ptDCG AGRAPH;    ///< the functionality is applied to this graph.
  ptExprManager EM;   ///< operand graph info: expression manager.
  ptClockManager CKM; ///< operand graph info: clock manager
  ptNodeManager NM;   ///< operand graph info: node manager.

  GraphLevelType graph_type; ///< graph info: Graph Level type (poly, endo, ...)
  ptlINode unNodes;          ///< graph info: Unused Nodes
  ptlinsth unClocks;         ///< graph info: Unused Clocks

  ptTravelDepManager PARC; ///< graph traveller.
  
  ptelemTableGenCode *SubGraphTable; ///< table of elemTableGenCode (one entry by cluster + a scheduller + a delay cluster)
  integer nbSets; ///< Number of (effective) entries in SubGraphTable.
  ptlINode lNodesHinit; ///< sets of nodes that can be generated at initial time (constant signals)
  ptlinstances lClocksNotToBeInitiliazed; ///< list of the boolean clocks which must not be initialized at each instant.

  boolean DEBUG; ///< debug tag.
};


