/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/**
   It creates a table (SubGraphTable) with \e nbSets elements of elemTableGenCode type.
   - SubGraphTable, nbSets are attributes member of the class.
   - nbSets = 1 for a graph without clusters 
   - nbSets = number of Clusters + 1 (scheduller) + 1 (for a particular "delay" cluster added at the end of the translation).
   - In all the cases, SubGraphTable[0] is the scheduller associated to the sbDC+ graph.
   - nbSets will be decreased when some cluster becomes empty by optimisations.

   Moreover, it initializes the following global lists:
   - lNodesHinit is initialized to the empty list. It will contain the list of the nodes that can be 
   defined at the initial time (constant signal).
   - lClocksNotToBeInitiliazed is initialized to the empty list. It will contain the list of the boolean clocks
   that depend on memories (they must not be initialized at each instant)
 */
void /*DCGBool2DCGSchTranslator::*/setsInitialize( void );

/**
   It finalizes DCGBool to DCGSch translation.
   The global informations (nbSets, SubGraphTable, lNodesHinit, lClocksNotToBeInitiliazed) are 
   associated with the graph.
   @return always "true".
 */
boolean /*DCGBool2DCGSchTranslator::*/finalize( void );

/**
   It adds a node (node) in the ordered list of node associated with an array (nodeArray).
   Here, a global predefined attribute (ARRAY_ORDER) is used (see CompilerAttributes.h).
 */
void /*DCGBool2DCGSchTranslator::*/appendInOrderedSetArray( ptINode node ,ptINode nodeArray );

/** 
    It orders the nodes with initial clock as contribution clock. Such a node defined a constant signal.
    \see orderingGraph().
  */
void /*DCGBool2DCGSchTranslator::*/orderingInitClockNodes( void );

/**
  It travels the nodes/clocks of the graph, for a block context (blockNode) and at the initial clock when bhinit, using the \ref GraphTravel API.
  When a node is selected, it calls nodeProcessing(), for a clock it calls clockProcessing().
 */
void /*DCGBool2DCGSchTranslator::*/orderingGraph( ptINode blockNode ,boolean bhinit );

/**
   @return "true" if the sub-graph (sg) is an entry of SubGraphTable, "false" otherwise.
   The first entry of SubGraphTable is reserved for sg is undefined.
   \see DCGBool2DCGSchTranslator::setsInitialize().
 */
boolean /*DCGBool2DCGSchTranslator::*/getSet( ptINode sg ,integer* n );

/**
   It stores a delay node (inst) in the iSet-th delay set.
   Delays are sorted: 
   for zzx := zx $ N and zx is a memory then zzx is inserted before zx.
   If the clock (boolean-clock) of zzx is a delay, zzx is inserted before its clock.  
 */
void /*DCGBool2DCGSchTranslator::*/storeNodeInDelaySet( ptINode inst ,integer iSet );

/**
   The node (inst) is inserted:
   - in the global list (lNodesHinit) if bhinit
   - in an array block (sg) when sg is a array node (appendInOrderedSetArray())
   - in a delay set when it is a delay node (storeNodeInDelaySet())
   - in the i-th entry of the global table SubGraphTable. The i-th sub-graph is given by getSet() method applied to sg.
 */
void /*DCGBool2DCGSchTranslator::*/storeNodeInSet( ptINode inst ,ptINode sg ,boolean bhinit );

/**
   It signals that a clock (h) has been visited (signalSelectedClock()).
 */
void /*DCGBool2DCGSchTranslator::*/clockProcessing( ptinsth h ,ptINode sg );

/**
   - It inserts a node (node) in an entry of the table of nodes (storeNodeInSet()).
   - For composed nodes (array, sub-graph) the travelling is recalled with a new context (to visit the internal nodes of the compsoed node).
   - It signals that the node has been visited (signalSelectedNode()).
 */
void /*DCGBool2DCGSchTranslator::*/nodeProcessing( ptINode node ,ptINode sg ,boolean bhinit );

/**
   It removes a node (sg) from the scheduller.
 */
void /*DCGBool2DCGSchTranslator::*/removeScheduller( ptINode sg );

/**
   It synthetizes the i/o signals of a sub-graph (aSubGraph).
 */
void /*DCGBool2DCGSchTranslator::*/setSubGraphIOReferences( ptINode aSubGraph );

/**
   It synthetizes the interface of a cluster (aCluster).
 */
void /*DCGBool2DCGSchTranslator::*/buildClusterInterface( ptINode aCluster );

/**
   For a sub-graph (aSubGraph):
   - It builds its interface
   - it inserts the sub-graph at the branching clock of the nodes of the sub-graph (ie the information must be available)
   - the branching clock becomes the clock of the label associated with the sub-graph. 
 */
void /*DCGBool2DCGSchTranslator::*/insertSubGraph( ptINode aSubGraph );

/**
   It is called when the graph is "clusterized" (input train clusters for example).

   It defines a new cluster for delay nodes (ldelays) when the list is not empty.
   This particular cluster is annotated with the global pragmas PRAGMA_DELAYCLUSTER and PRAGMA_CLUSTER and inserted in the graph.
   Its references is added in the scheduler.
   A dependence from this cluster to each other cluster is added.

   @return "true" if the operand list (ldelays) is not empty, "false" otherwise.
 */
boolean /*DCGBool2DCGSchTranslator::*/appendDelayCluster( ptlINode ldelays );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*DCGBool2DCGSchTranslator::*/moveEmptyEntry( int i ,boolean bclean );

/**
   @return "true" if graph is "clusterized", "false" otherwise.

   When the graph is "clusterized" (input train clusters for example):
   - It builds the delay cluster (appendDelayCluster()), it is the last element of the SubGraphTable table.
   - It cleans the empty clusters (induced by the previous operation).
   - It updates (buildClusterInterface()) the interfaces of the clusters (induced by the previous operations).

   <em> This operation modifies the graph. </em>
 */
boolean /*DCGBool2DCGSchTranslator::*/delayClustering( void );

/**
   It assigns name to clusters if the graph is a graph of clusters with a delay cluster is \e withDelayCluster.
   The name is built from the name of the graph (\e foo)
   \e foo_Cluster_i for i in [1, nbSets-1], and \e foo_Cluster_delays for the delay cluster.
 */
void /*DCGBool2DCGSchTranslator::*/setClusterName( boolean withDelayCluster );

/**
   It marks (GencodeMark global attribute) the cluster for code generation.
 */
void /*DCGBool2DCGSchTranslator::*/clusterMarkGenCode( void );

/** 
   This method builds the list of the boolean clocks (lClocksNotToBeInitiliazed) which must not be initialized at each instant.
   Such clocks are built on delay variables. This list is, at the end of the translation, associated with the graph (DCGBool2DCGSchTranslator::finalize()).

   It references markClocksNotToBeInitiliazed(ptlinstances) method.
 */
virtual void /*DCGBool2DCGSchTranslator::*/markClocksNotToBeInitiliazed( void );

/** 
   This method appends to the global list (lClocksNotToBeInitiliazed) 
   the boolean signals of the list lsig which are built on delay variables (isMemoryEquation()).
 */
virtual void /*DCGBool2DCGSchTranslator::*/markClocksNotToBeInitiliazed( ptlinstances lsig );

/**
   @return "true" if a node (node) is a memory node (delay, cell ,status, constant signal), "false" otherwise. 
 */
virtual boolean /*DCGBool2DCGSchTranslator::*/isMemoryEquation( ptINode node );

/** It associates a label (vlabel) to a node(n) if the node is without any outputs.
    The clock of the label is the clock of the node.
    @return true if a label is created, false otherwise.
 */
boolean /*DCGBool2DCGSchTranslator::*/addLabel( ptINode n );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*DCGBool2DCGSchTranslator::*/getnextIO( ptlINode* ln ,ptINode* ionode );

/**
   It reinforces the dependences n(i)->n(i+1) for n(i) an element of the operand list(lnodes).
 */
virtual void /*DCGBool2DCGSchTranslator::*/addReinforcingDependences( ptlINode lnodes );

/**
   It reinforces the dependences induces by the static schedulling.
   A complete static scheduling when btotally.
 */
virtual void /*DCGBool2DCGSchTranslator::*/addReinforcingDependences( boolean btotally );

/** 
    It finalizes the ordering operation: 
   - addReinforcingDependences(): dependence reinforcing. When btotally is pk_true, the graph is totally ordered (static scheduling) otherwise only the clusters are ataticaly scheduled (not the graph of the clusters).
   - delayClustering(): for a graph of clusters, the memories are isolated in a particular cluster.
   - setClusterName(): for a graph of clusters, names are associated with the clusters.
   - clusterMarkGenCode(): for a graph of clusters, it marks the clusters for code generation.
   - markClocksNotToBeInitiliazed(): it marks the clocks built on memories to inhibit optimizations
 */
virtual void /*DCGBool2DCGSchTranslator::*/finalizeOrderingGraph( boolean btotally );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
ptlINode /*DCGBool2DCGSchTranslator::*/optimizeNodes( ptlINode ln );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*DCGBool2DCGSchTranslator::*/optimize( integer indexSubGraphTable );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*DCGBool2DCGSchTranslator::*/optimize( void );


