/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

private:

/**
   @return "true" if the graph is not a DC+ and vh is an positive extraction, "false" otherwise.
 */
boolean /*ProfileBuilder::*/isTypeGraphSelected( ptinsth h );

/**
   @return "true" if a clock (vh) is representated by a signals in the inputs/outputs of the graph.
 */
boolean /*ProfileBuilder::*/isIOevent( ptinsth vh );

/**
   @return "true" if a node (vinstr) is useful, "false" otherwise.
   useful = not in the unused nodes set associated with the graph.
 */
boolean /*ProfileBuilder::*/isSelectedNode( ptINode vinstr );

/**
   @return "true" if a clock (vh) is useful, "false" otherwise.
   useful = not in the unused clocks set associated with the graph.
 */
boolean /*ProfileBuilder::*/isSelectedClock( ptinsth vh );

/**
   @return "true" if the clock (vh) is declared as an input of the graph, "false" otherwise.
 */
boolean /*ProfileBuilder::*/is_input_clock( ptinsth vh );

/**
   @return "true" if the clock (vh) is declared as an output of the graph, "false" otherwise.
 */
boolean /*ProfileBuilder::*/is_output_clock( ptinsth vh );

/** Very strange: should be replaced by getFahter.  */
ptinsth /*ProfileBuilder::*/getForcedFather( ptinsth vh );

/** 
    @return the branching of vh1 and vh2 if it exists, or the fictitious root clock otherwise.
 */
ptinsth /*ProfileBuilder::*/getForcedBranching( ptinsth vh1 ,ptinsth vh2 );

/**  
     It adds a signal (vexp) as an input for all the nodes of the hierarchy from vhf until vht.
     
     Assumed : vht is upper than vhf in the hierarchy.
 */
void /*ProfileBuilder::*/insert_signal_input_to_except( ptinsth vhf ,ptexpcal vexp ,ptinsth vht );

/**
   It adds a clock vhi as an input for all the nodes of the hierarchy from vhf until vht.
   
   Assumed: vht is upper than vhf in the hierarchy.
 */
void /*ProfileBuilder::*/insert_clock_input_to_except( ptinsth vhf ,ptinsth vhi ,ptinsth vht );

/** 
    It adds a signal (vexp) as an output for all the node of the hierarchy on the branch vhf until vht (excluded).
    Assumed : vht is upper than vhf in the hierarchy.
 */
void /*ProfileBuilder::*/insert_signal_output_to_except( ptinsth vhf ,ptexpcal vexp ,ptinsth vht );

/** 
    It adds a signal (vexp) as an input-output for all the node of the hierarchy on the branch vhf until vht (excluded).
    Assumed : vht is upper than vhf in the hierarchy.
 */
void /*ProfileBuilder::*/insert_signal_inout_to_except( ptinsth vhf ,ptexpcal vexp ,ptinsth vht );

/**
   It adds a clock vh (dc+ graph) or the boolean signals referenced in the condition otherwise, as a local to mclock.
   Assumed: mclock is the mother clock of vh (otherwise hierarchy will be unconsistent).
 */
void /*ProfileBuilder::*/insert_clock_local( ptinsth mclock ,ptinsth vh );

/**
   It adds a clock (vho) in the list of the outputs for all the nodes of the hierarchy
   from vho until vht (excluded). Then, if except, vho is becomes a local to vht, otherwise an output of vht.

   Assumed : vht is upper than vho in the hierarchy.
 */
void /*ProfileBuilder::*/insert_clock_output_to_except( ptinsth vho ,ptinsth vht ,boolean except );

/**
   It finalizes the interface of the sub graph.
     - the output signals are removed from the inputs
     - the boolean clocks are removed from the inputs.
 */
void /*ProfileBuilder::*/setInterfaceSubGraphFinalize( ptgfd vgfd );

/**
   @return the list obtained by the insertion of the signals of the list (l) into another 
   list (lmain). Moreover, the "declared" signals are also added to lmain (ie for the references X.Y, X[], X is also added).
   \warning  side effects on the lmain list.
 */
ptlinstances /*ProfileBuilder::*/addListAndDeclaredSignals( ptlinstances l ,ptlinstances lmain );

/**
   It updates the visibilty of signals (lsig) referenced at a clock (vh).
   For a signal (x) of the list, if x is 
     - an input of the graph it is added as input for each node of the branch from vh to the root of the hierarchy. 
     - not an input of the graph, the branching (e) of h and ^x is computed
           - if (vh = ^x) and bup is pk_true, e is the mother clock of vh, otherwise (bup pk_false) e is undefined.
	   - otherwise the branching (e) of vh and ^x is computed.
	   .
       If e is defined:
        - x is added as output on the branch from ^x until e,
        - x is added as input on the branch from vh until e,
	- x is added as a local signal at e ((if it is not already an output of the hierachy with e as root)
 */
void /*ProfileBuilder::*/visibilitySignalsAtClock( ptlinstances lsig ,ptinsth vh ,boolean bup );

/**
   For each node of a sub graph (vgfd)
     - it updates the interface of vgfd with the input/output signals and the clock referenced in the node
     - it updates the visibilty of the input signals referenced in the node (visibilitySignalsAtClock()).
 */
void /*ProfileBuilder::*/setInterfaceSubGraphNodes( ptgfd vgfd );

/**
   Without effect!.
 */
void /*ProfileBuilder::*/setInterfaceSubGraphClocks( ptgfd vgfd );

/** It builds the interface of a sub-graph (vgfd)-- Such an element is assigned to a clock--:
    - its nodes are visited (setInterfaceSubGraphNodes()),
    - its clocks are visited (setInterfaceSubGraphClocks()),
    - the calculus is then finalized (setInterfaceSubGraphFinalize())
 */
void /*ProfileBuilder::*/setInterfaceSubGraph( ptgfd vgfd );

/** 
    It updates the visibility of the signals referenced in the sub-graph associated with a clock (vh).
  */
void /*ProfileBuilder::*/mkSubHierarchyInterface( ptinsth vh );

/**
   Actions:
   - vh is declared as a local at it mother clock, and an input of its own hierarchy,
   - it builds the interface (setInterfaceSubGraph()) of a sub-graph associated with vh,
   - it updates the visibility of the signals referenced in the sub graph associated with vh (mkSubHierarchyInterface()),
   - then, vh is added as output on the branch vh until e, where e is the branching of the references of vh.
 */
void /*ProfileBuilder::*/visibilityOfClock( ptinsth vh );

/**
   It takes into account the formula/assertions of a clock (clk) 
   for the interface calculus. It applies insert_clock_local() for each element.
 */
void /*ProfileBuilder::*/addConstraintsDeclaration( ptinsth clk );

/**
   It creates the interface of an assumed root clock (vh).
   It calls setInterfaceSubGraph(), mkSubHierarchyInterface() and adds the clock as an input of its own hierarchy.
 */
void /*ProfileBuilder::*/rootProcessing( ptinsth vh );

/** It adds, as input, each signals of a list (vlent) on the branch form the clock of the node of the signal until the root of the hierarchy.
    This operation is not applied for a signal when it is marked "NO_DIFFUSION" (defined in CompilerAttributes.h).
 */
void /*ProfileBuilder::*/InputsGraphVisibility( ptlinstances vlent );

/**
   @return the clock of the node of a signal (vsig) taking into account the composed (array, sub graph):
   the clock is the clock of the upper level node.
 */
ptinsth /*ProfileBuilder::*/getUpperNodeClock( ptexpcal vsig );

/**
   The visibility of the input signals of a node (aNode) with vh as clock (assumed) is updated in the graph.
   For each input signal (x), and e the branching clock of vh with ^x, it adds
   - x as output on the branch from ^x until e,
   - x as input on the branch from vh until e,
   - x is added as a local signal of e (if it is not already an output of the hierachy with e as root).

   Obviously, it takes into account the case where vh and ^x are in the same branch.
 */
void /*ProfileBuilder::*/visibilityOfInputs( ptINode aNode ,ptinsth vh );

/**
   The visibility of the local signals of a node (aNode) with vh as clock (assumed) is updated in the graph.
   Only the signals that are the ouputs of the graph are considered. For such a signal (x), 
   - x is removed from the locals of the node,
   - x is added as output on the branch from vh until the root of the hierarchy.
   \note the interface of the operand node can be modified.
 */
void /*ProfileBuilder::*/visibilityOfLocals( ptINode aNode ,ptinsth vh );

/**
   The visibility of the output signals of a node (aNode) with vh as clock (assumed) is updated in the graph.
   For such a signal (x), x is added as a local signal of vh, if it is not already an output of the hierachy 
   with vh as root.
 */
void /*ProfileBuilder::*/visibilityOfOutputs( ptINode aNode ,ptinsth vh );

/**
   The visibility of a list of signals (lsig) referenced at a clock (vh) is updated in the graph.
   Only the signals that are the ouputs of the graph are considered. For such a signal (x), and e the branching
   of vh and ^x,
   - x is added as output on the branch ^x until e (when e = vh)
   - x is addded as a local signal of vh (if it is not already an output of the hierachy with vh as root).
 */
void /*ProfileBuilder::*/visibilityOf( ptlinstances lsig ,ptinsth vh );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*ProfileBuilder::*/visibilityOfSharedStateVar( ptlinstances lsig ,ptinsth vh );

/**
   The visibility of the signals, referenced in a node (aNode):
   - as inputs (visibilityOfInputs(), 
   - as local (vibilityOfLocals()),
   - as output  (visibilityOfOutputs()),
   at the clock of the node is updated in the graph.
 */
void /*ProfileBuilder::*/interfaceCalculus_composednode( ptINode aNode );

/**
   It applies interfaceCalculus_composednode() for each element of a list (lNodes) of nodes.
   (Recall: the interface of a single node is already known.)
 */
void /*ProfileBuilder::*/interfaceCalculus_composednodes( ptlINode lNodes );

/**
   It takes into account the constraints on placed clocks for the calculus of the visibility of the clocks.
   For such an element (h1=h2) and e their branching,
   h1 (h2) is added as output in the interface of each node of the hierarchy from h1 (resp. h2) to e.
 */
void /*ProfileBuilder::*/ConstrainstPlacedClocks( void );

/**
   @return "true" if a node (vinstr) produces an output (sig), "false" otherwise.
   (local to mkInterfaceDependence())
 */
virtual boolean /*ProfileBuilder::*/getDependenceFlow( ptINode vinstr ,ptexpcal* sig );

/** 
    For a dependence (n1 -> n2) when h, 
    s1 (resp. s2 and h) is added as output from its clock to the root of the hierarchy, where s1 (resp. s2) is the result of getDependenceFlow()
    with n1 (resp. n2) as parameter.
    \note dependencies are visible at the root of the process (Choice).
 */
void /*ProfileBuilder::*/mkInterfaceDependence( ptdependence aDep );

/** Taking into account the explicit dependencies for the interface of a process.
    Dependencies are visible at the root (choice) of the process.
    It applies mkInterfaceDependence() for each explicit dependence.
 */
void /*ProfileBuilder::*/mkInterfaceDependences( void );

/**
   Interface calculus for the node calls, array, subgraphs
   It applies the interfaceCalculus_composednodes() for each of them.
 */
void /*ProfileBuilder::*/interfaceComposedNodes( void );

/** This method realizes a left to right topdown traversal of the hierarchy with \e clock as root.
    The interface of the subgraph associated with the clock is produced then the xxx;
    For each \e useful node of the hierarchy, it applies:
    - rootProcessing() for a root of the hierarchy, visibilityOfClock() otherwise ,
    - addConstraintsDeclaration()
 */
void /*ProfileBuilder::*/leftRightTopdownTraversal( ptinsth clock );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*ProfileBuilder::*/visibilitySignalsOfExtraction( ptinsth vh ,ptinsth vhAt );

/**
   Method without effect when the formula (vh) is not an extraction.
   The visibility of the signals referenced in the expression associated with the formula is updated in the graph.
   It applies visibilitySignalsAtClock() for each signal.
 */
void /*ProfileBuilder::*/extractionInterface( ptinsth vh );

/** 
 */
void /*ProfileBuilder::*/substituableClocksInterface( ptinsth clock );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*ProfileBuilder::*/NullClockAssertions( void );


