/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#include <vector> ///< from STL
typedef class exclusiveClocks *ptexclusiveClocks;

class exclusiveClocks
{
#include "exclusiveClocks_m.h"
#include "exclusiveClocks_g.h"
private:
  ptDCG AGRAPH; ///< operand graph: the functionality is applied to this graph.
  ptClockManager CKM; ///< clock manager of AGRAPH
  ptinsth hundef; ///< predefined undefined clock.
  ptinsth the_nullClock_MC_copy; ///< predefined null clock.
  typedef std::vector <ptinsth> typetab;
  typetab table; ///< selected clocks table extracted from the graph.
  std::vector <int> tableIndex; ///< index of the selected clocks in table.
  std::vector <typetab> matrix;///< array  [tableSize, tableSize] of insth: it will contain the result of a calculus of clocks 2 x 2.
  integer tableSize;///< size of table.
  integer clockStartIndex;///< the max number of the clocks at the begining of the operation.

  typedef std::vector <boolean> BoolTabType;
  std::vector <BoolTabType> DoneMatrix; ///< matrix of booleans, false by default, true when an operation between two clocks is done in a initial step (optimisations).

  typeMark IndexAttr;
};
