/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef __Homomorphism_h__
#define __Homomorphism_h__

class Homomorphism:public AbstractHomomorphism
{
#include "Homomorphism_m.h"
#include "HomomorphismExpr_i.h"
#include "HomomorphismsbDCPlus_i.h"
#include "HomomorphismNode_i.h"
#include "HomomorphismClk_i.h"
#include "HomomorphismDep_i.h"
#include "Homomorphism_g.h"

protected:
  ptINode currentNodeOriginalGraph;
  boolean G_internalNode,  markExternalCall;
  ptrepstr str_pragma_morphism;
  ptident nilId, doneId, waitId, packId, idInternal, waitIdsbdcplus, idMorphismSuffix;
  ptINode currentBlock;
  ptHomomorphismTable pragmaOperatorTable;
  TypeType TypeCodeEnum; ///< Declared Type for coding types of the application (enumerated type) &t.
  TypeType G_HomoType;
  ptexpcal G_UndefinedValue;
  ptinsth currentClkDone;
  typeMark iomark, doneAttribute; 
  typeMark usedMarkBefore;

  ptident idDependence; ///< dependencies managment
  boolean keepDependenceOp; ///<  y --> x  is translated to Hx --> Hy when keepDependenceOp is "true";  with x := a + y, Hx := H+( idDependence(Hy, Ha), Hb)
  boolean externalGraph;
  int aCounter;
  ptident tableIdentOperator[SIG_NB_OPERATORS+1];

  /// ---------------------sBDCplus infos
  ptelemTableGenCode *SubGraphTable;///< sbDC+ info: set of subsgraphs, - SubGraphTable[i] set of ordered nodes of the i-th Cluster;
      ///< - SubGraphTable[0] is the sequential scheduler
  int nbSets;      ///< sbDC+ info: size of the SubGraphTable table
  ptlINode lNodesHinit;///< sbDC+ info: constant signals
  ptlinstances lClocksNotToBeInitiliazed; ///< sbDC+ info: Clocks built on memories ; they must not to be initialized.

};
		 
#endif
