/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/**
   @return the homomorphism of the type of a clock (vsig) in the new graph.
 */
virtual TypeType /*Homomorphism::*/homomorphismType( ptinsth clk );

/**
   @return a clock (h) as a signal (ie. true when h).
 */
virtual ptexpcal /*Homomorphism::*/clock2expr( ptinsth h );

/** 
    Without effect:  we suppose that the system (and its hierachy) has been 
    imported in the produced graph. 
 */
virtual void /*Homomorphism::*/homomorphismHierarchy( ptlinsth lh );

/**
   @return "true" if the clock is selected for the translation, "false" otherwise.
   It is selected iff it is not in the unused clocks of the original graph.
 */
virtual boolean /*Homomorphism::*/isSelectedClock( ptinsth h );

/** 
    @return the copy of the clock clk in the current builting graph.
    This clock have been built before the "cost homomorphism".
 */
virtual ptinsth /*Homomorphism::*/getClockCopy( ptinsth clk );

/**
   @return the created signal associated with a clock (clk). This signal is available via an attribute of the clock.
 */
virtual ptexpcal /*Homomorphism::*/assignAttribute( ptinsth clk );

/**
   It assigns the homomorphism signal (attribute) to a clock (clk, clock of the original graph)
   and also to its copy in the new graph.
 */
virtual void /*Homomorphism::*/homomorphismDclClock( ptinsth clk );

/**
   new graph objects: a clock (nclk) of the new graph is linked with its 
   boolean representation (vattr) in this new graph.
 */
virtual void /*Homomorphism::*/imageSetAttributeClock( ptinsth nclk ,ptexpcal vattr );

/**
   @return the boolean representation in this new graph of a clock (nclk) of this new graph.
 */
virtual ptexpcal /*Homomorphism::*/imageGetAttributeClock( ptinsth nclk );

/** @return "true" if the homomorphism-signal of a clock (clk) is available, "false" otherwise (the information is not 
    available via the attribute and clk is not a variable).
  */
virtual boolean /*Homomorphism::*/getAttribute( ptinsth clk ,ptexpcal* hs );

/**
   It defines the morphism of a formula (h) that represents a free variable.
   The associated boolean signal (x) is defined by x:= pk_true when M(h).
 */
virtual void /*Homomorphism::*/homoVari( ptinsth h );

/**
   It defines the morphism of a formula (h) that represents an extration by a positive condition (C).
   The associated boolean signal (x) is defined by x:= C when M(^C).
 */
virtual void /*Homomorphism::*/homoExtract( ptinsth h );

/**
   It defines the morphism of a formula (h) that represents an extration by a negative condition (not C).
   The associated boolean signal (x) is defined by x:= not C when M(^C).
 */
virtual void /*Homomorphism::*/homoExtractNega( ptinsth h );

/**
   @return the morphism of a binary clock (original graph) by scanning the associated translation defined 
   via a scanner object restricted to the outputs. 
   @param ScanPragObj (in) a scanner ready to analyze the translation of the outputs
   @param h (in) binary clock; current translated formula (original node)
   @param h1 (in)  the first operand of h
   @param h2 (in)  the second operand of h

   It takes into account the following tokens (see morphismPredefinedNames.h): 
   - tk_input, tk_output, tk_homo (&h). &h must be followed by &{i,o,p....}
   - end scanning: tk_2pe
   - separator: tk_virg
 */
virtual ptexpcal /*Homomorphism::*/homoClockBinaryOutputs( ptStrScanner ScanPragObj ,ptinsth h ,ptinsth h1 ,ptinsth h2 );

/**
   @return the morphism of a binary clock (original graph) by scanning the associated translation defined 
   via a scanner object restricted to the parameters. 
   @param ScanPragObj (in) a scanner ready to analyze the translation of the parameters.
   @param h (in) binary clock; current translated formula (original node)
   @param h1 (in)  the first operand of h
   @param h2 (in)  the second operand of h

   It takes into account the following tokens (see morphismPredefinedNames.h): 
   - tk_type, tk_dim
   - end scanning: tk_af
   - separator: tk_virg
 */
virtual ptexpcal /*Homomorphism::*/homoClockBinaryParameters( ptStrScanner ScanPragObj ,ptinsth h ,ptinsth h1 ,ptinsth h2 );

/**
   @return the morphism of a binary clock (original graph) by scanning the associated translation defined 
   via a scanner object restricted to the inputs. 
   @param ScanPragObj (in) a scanner ready to analyze the translation of the inputs
   @param h (in) binary clock; current translated formula (original node)
   @param h1 (in)  the first operand of h
   @param h2 (in)  the second operand of h

   It takes into account the following tokens (see morphismPredefinedNames.h): 
   - tk_homo (&h). &h must be followed by &{i,o,p....}
   - end scanning: tk_pf
   - separator: tk_virg
 */
virtual ptexpcal /*Homomorphism::*/homoClockBinaryInputs( ptStrScanner ScanPragObj ,ptinsth h ,ptinsth h1 ,ptinsth h2 );

/**
   It builds the definition of the signal-homomorphism for the formula defined by <em> h = h1 vop h2 </em>.
   The translation is given by a definition in the table of morphism (^+, ^*, ^- operators). The translation 
   is guided by a scanner on the definition. It calls:
   - homoClockBinaryOutputs() for the translation of the outputs
   - homoClockBinaryParameters() for the translation of the parameters
   - homoClockBinaryInputs() for the translation of the inputs
   .
   The results are used to build in the new graph the definition of the signal-homomorphism.
   \code 
   Example: 
   operator ^+ = (?x,y; !z; ) pragmas MORPHISM "(&h&o, &done):=CostClkPlus{&t}(&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
   - homoClockBinaryOutputs() analyzes (&h&o, &done)
   - homoClockBinaryParameters() analyzes {&t}
   - homoClockBinaryInputs() analyzes (&h&i1, &h&i2, &hck&o, &wait)
   \endcode
 */
virtual void /*Homomorphism::*/homoClockBinary( noperators vop ,ptinsth h ,ptinsth h1 ,ptinsth h2 );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
virtual void /*Homomorphism::*/formulaHomomorphism( ptinsth formula );

/**
   It produces for a "selected" clock (h) of the original graph, the definition of the its signal-homomorphism in the new graph.
   It is selected if the clone of h exists in the new graph.
 */
virtual void /*Homomorphism::*/homomorphismClock( ptinsth h );


