/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/**
   @return "true" if a node (n) is selected for the translation, "false" otherwise.
 */
virtual boolean /*Homomorphism::*/isSelectedNode( ptINode n );

/**
   @return a undefined node and signals an error.
 */
virtual ptINode /*Homomorphism::*/errorOnNode( ptINode n );

/**
   Finalizing the translation of a node (n1) of the orignal graph in a node (n) of the new graph.
   It adds a link from n1 to n using the attributeNumber attribut.
 */
virtual void /*Homomorphism::*/endHomomorphismNode( ptINode n1 ,ptINode n );

/**
   Initializing the translation of a node (n).
 */
virtual void /*Homomorphism::*/beginHomomorphismNode( ptINode n );

/**
   @return for an expression (expression) assumed to be of the form "E when/cell h"
   - E is ^E is h,
   - expression otherwise.

   Local to homomorphismEqu() method.
 */
ptexpcal /*Homomorphism::*/getSubTermFilteredClock( ptexpcal expression );

/**
   @return the morphism of a node (node) when it is an equation node (X:=E)
   The translation is given in the morphism table by the operator(E).
 */
virtual ptINode /*Homomorphism::*/homomorphismEqu( ptINode node );

/**
   @return the morphism of a node (node) when it is a delay node.
   The translation is given in the morphism table by the operators opret($) and opfen (window)
 */
virtual ptINode /*Homomorphism::*/homomorphismDelay( ptINode node );

/**
   @return a node produced by the definition associated with the opappe operator in the morphism table.
   It calls homomorphismExp(ptrepstr, noperators , ptexpcal, ptexpcal , ptexpcal , ptinsth)
   with (name, opappe, out, params, def, clk) as parameters.

   It manages the attribute member of the class \e markExternalCall:
   - it is set to "true". It will be referenced in insertNode() to tag the node by a mark ("DONTDECLARE") to specify 
   that the declaration of the model is not necessary.
   - it is popped at the end of the method.

   The name can be referenced (by &n) in the declaration of the definition associated with the opappe operator 
   in the translation table. For example:\n
   operator opappe = (? ! ) pragmas MORPHISM "(&h&o, &done) :=Cost&n{}(&h&i1, &h&i2 , &hck&o, &wait)" end pragmas; %
 */
virtual ptINode /*Homomorphism::*/homomorphismExternal( ptrepstr name ,ptexpcal out ,ptexpcal params ,ptexpcal def ,ptinsth clk );

/**
   @return the morphism of a node (node) when it is a external procedure call node.
   homomorphismExternal() is called with the name of the external procedure call.
   This name can be referenced (by &n) in the declaration of the definition associated with the opappe operator 
   in the translation table. For example:\n
   operator opappe = (? ! ) pragmas MORPHISM "(&h&o, &done) :=Cost&n{}(&h&i1, &h&i2 , &hck&o, &wait)" end pragmas; %
 */
virtual ptINode /*Homomorphism::*/homomorphismProccall( ptINode node );

/** 
    @return the morphism of a node (node) when it is a read node (associated with an input of the program).
    The translation is given by the opread operator in the table of morphism.
 */
virtual ptINode /*Homomorphism::*/homomorphismRead( ptINode node );

/** 
    @return the morphism of a node (node) when it is a write node (associated with an output of the program).
    The translation is given by the opwrite operator in the table of morphism.
 */
virtual ptINode /*Homomorphism::*/homomorphismWrite( ptINode node );

/**
   @return the morphism of a node (node) when it is an undefined node.
 */
virtual ptINode /*Homomorphism::*/homomorphismUndefined( ptINode node );

/**
   @return the morphism of a node (node) when it is a set of partial definitions.
   Each partial equation is translated homomorphismExp(ptexpcal, ptexpcal, ptinsth ).
 */
virtual ptINode /*Homomorphism::*/homomorphismPartialDefs( ptINode node );

/**
   @return aNode.
   Without effect: nothing to do, see homomorphismPartialDefs() method
 */
virtual ptINode /*Homomorphism::*/homomorphismPartialDef( ptINode aNode );

/**
   @return the morphism of a node (node) when it is a node call.
   homomorphismExternal() is called with the name of the referenced graph.
   This name can be referenced (by &n) in the declaration of the definition associated with the opappe operator 
   in the translation table. For example:\n
   operator opappe = (? ! ) pragmas MORPHISM "(&h&o, &done) :=Cost&n{}(&h&i1, &h&i2 , &hck&o, &wait)" end pragmas; %
 */
virtual ptINode /*Homomorphism::*/homomorphismNodecall( ptINode node );

/** 
    @return the node associated with a "label" (hlabel) of a subgraph (node).
    This node is created by the translation associated with the operator opentsor
    given in the morphism table.
    \see homomorphismExp(ptexpcal, ptexpcal, ptinsth ).
 */
virtual ptINode /*Homomorphism::*/homomorphismLabelSubGraph( ptexpcal hlabel ,ptINode node );

/**
   @return the morphism of a node (node) when it is a subgraph.
   See homomorphismLabelSubGraph() for the label translation.
   \note  doc must be completed.
 */
virtual ptINode /*Homomorphism::*/homomorphismSubGraph( ptINode node );

/**
   @return the morphism of a node (node) when it is a bundle (list of fields).
   It calls homomorphismExternal() with the type of the bundle as name.
   This name can be referenced (by &n) in the declaration of the definition associated with the opappe operator 
   in the translation table. For example:\n
   operator opappe = (? ! ) pragmas MORPHISM "(&h&o, &done) :=Cost&n{}(&h&i1, &h&i2 , &hck&o, &wait)" end pragmas; %
 */
virtual ptINode /*Homomorphism::*/homomorphismBundle( ptINode node );

/**
   It applies the homomorphismNodes() for the nodes of each sub-graph of the original graph.
 */
virtual void /*Homomorphism::*/homomorphismSubGraphs( void );

/**
   It inserts a node (n) in the new graph, at the clock h.
   It takes into account some context informations: the node is also inserted in a sub-graph, if the current block is set.
   Moreover, the node is marked "DONTDECLARE" (global mark of the compiler) to specify that the declaration of the model is not necessary,
   if markExternalCall is "false" (markExternalCall is an attribute of the class).
 */
virtual void /*Homomorphism::*/insertNode( ptINode n ,ptinsth h );

/**
   It achieves the morphism for the write nodes of the program.
   It applies homomorphismNodes() on the list of the write nodes.
 */
virtual void /*Homomorphism::*/homomorphismInterfaceOutputs( void );

/**
   It achieves the morphism for the read nodes of the program.
   It applies homomorphismNodes() on the list of the read nodes
 */
virtual void /*Homomorphism::*/homomorphismInterfaceInputs( void );

/**
   It achieves the morphism for the read/write nodes of the program.
   It calls 
   - homomorphismInterfaceInputs() 
   - homomorphismInterfaceOutputs()
 */
virtual void /*Homomorphism::*/homomorphismInterface( void );

/**
   For each node of ln (assumed to be a read/write node of x of the original graph), 
   it creates the clone of x in the new graph.
   An attribute (iomark, attrribute of the class) is used to link (x and its clone).
   This mark will be used in homomorphismRead(), homomorphismWrite().
 */
virtual void /*Homomorphism::*/mkAttributeInterface( ptlINode ln );

/**
   It applies mkAttributeInterface(ptlINode) for each read-node and write-node of the graph.
 */
virtual void /*Homomorphism::*/mkAttributeInterface( void );


