/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/** Constructor.
 */
/*Homomorphism::*/Homomorphism( void );

/**
   Destructor.
 */
virtual /*Homomorphism::*/~Homomorphism( void );

/**
   @return "true" if the operation succeeds, "false" otherwise.

   It produces a graph (gh) by a morphism of another one (g) using a table (homoTable). 
   This table gives for each Signal operator its definition in the new one.
   The clocks are already imported in gh (the hierachy of clocks is kept): the link from a clock of g to its 
   clone in gh is given by an attribute (usedMarkBefore defined by markCopy).
   It is composed of the several calls:
   - initialize()
   - mkAttributeInterface()
   - homomorphismTypeCode()
   - homomorphismDclIdentifiers()
   - homomorphismDclClocks()
   - homomorphismSubGraphs()
   - homomorphismNodes()
   - homomorphismClocks()
   - homomorphismInterface()
   - addInputs()
   - homomorphismDependences()
   - homomorphismEnd()
   - finalize()

   \note
   A clock (clk) of the original graph 
    - is associated with its clone (nclk) in the new graph using the usedMarkBefore attribute. This link is \e assumed available here.
    - will be associated with  the homomorphism signal (x) associated with the clock (nclk) in the new graph.
    .
    The  clock (nclk) of the new graph  will be also associated with the homomorphism signal (x).

    \code
    For example: in profiling studies, the "cost" of a clock, defined by the formula h = h1 ^+ h2, 
    is given by the definition in the morphism table by

    operator ^+ = (?x,y; !z; ) pragmas Morphism "(&h&o, &done) :=CostClkPlus{&t}(&h&i1, &h&i2, &hck&o, &wait)" end pragmas;

    In the new graph, we will have:
    - c(h) = c(h1) ^+ c(h2), c() stands for cloneOf(), the links (h,c(h)), (h1,c(h1)), (h2,c(h2)) are assumed available
    - the homomorphism signal associated with h, cost_h, will be defined by the node:
    (cost_h, done) := CostClkPlus(..)(cost_h1, cost_h2, ...)
    \endcode
    
 */
boolean /*Homomorphism::*/apply( ptDCG g ,ptDCG gh ,typeMark markCopy ,ptHomomorphismTable homoTable );


