/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/**
   @ingroup initHomoGroup
   It initializes the associative table tableIdentOperator.
   To each operator(int) is associated the identifier used in the homomorphism table
   to represent it. Some operators are associated with a predefined undefined name (UNDEFINED_IDENT), they
   are assumed not defined in the morphism table.

   \code
   tableIdentOperator[opplus] = string2ident("+");
   and in the homomorphism table, we have
   operator + = (?x,y; !z; ) pragmas Morphism "(&h&o, &done) :=CostPlus{&t&i1,&t&i2}( &h&i1, &h&i2, &hck&o, &wait)" end pragmas;
   \endcode
 */
virtual void /*Homomorphism::*/InitOp2stringOpTable( void );

/**
   @ingroup initHomoGroup
   It defines the G_HomoType attribute member.
   If the optype operator is defined in the homomorphism table via the name H_TYPE (see morphismPredefinedNames.h)
   the definition is taken otherwise _HomoType_.

   \code
   operator _TYPE_         = (? ! ) pragmas Morphism "HomoType" end pragmas;
   \endcode
 */
virtual void /*Homomorphism::*/mkhomomorphismType( void );

/**
   @ingroup initHomoGroup
   It initializes the homomorphism translation from an original graph (g1) to a new one (g2).
   In particular it initializes the member of the class: 
   - str_pragma_morphism, 
   - the associative table (operator, name of the operator) (InitOp2stringOpTable()), 
   - currentClkDone, doneAttribute, 
   - some identifiers :nilId, idMorphismSuffix, doneId, waitId, packId, idInternal, waitIdsbdcplus
   - G_UndefinedValue, G_HomoType (mkhomomorphismType())
   - markExternalCall: default value is false
   - aCounter is set to 0 (used to enchure the unicity of some calls (referenced in the morphism table by &cpt)
   - externalGraph: attribute of g1 graph.
 */
virtual void /*Homomorphism::*/initialize( ptDCG g1 ,ptDCG g2 );

/**
   @ingroup initHomoGroup
   It splits a list of nodes (ln) in two lists.
   @return the subset of the nodes of ln wihtout the node of lio.
   @param ln (in) a liust of node.
   @param lio (out) subset of ln that are io node (read, write nodes).

 */
virtual ptlINode /*Homomorphism::*/splitIONode( ptlINode ln ,ptlINode* lio );

/**
   @ingroup tableAccessGroup
   @return "true" if an operator (op) is defined in the tableIdentOperator, "false" otherwise.
   @param op (in) an operator.
   @param vid (out) the identifier assocaited with the operator. Available when it returns "true".
 */
virtual boolean /*Homomorphism::*/getIdentOperatorName( noperators op ,ptident* vid );

/**
   @ingroup tableAccessGroup
   @return 
   - "true" if an operator (op) is defined with a real name (different from UNDEFINED_IDENT) in the tableIdentOperator. The 
   name is returned in vstr.
   - "false" otherwise, the name (vstr) is nilstr value.
   
 */
virtual boolean /*Homomorphism::*/getStrOperatorName( noperators op ,ptrepstr* vstr );

/**
   @ingroup tableAccessGroup
   It returns the value of the morphism pragma associated with an identifier (id).
   \code
   For id referencing the "+" operator, it returns the tree representing
      "(&h&o, &done) :=CostPlus{&t&i1,&t&i2}( &h&i1, &h&i2, &hck&o, &wait)"
   It is extracted from the definition given in the table (pragmaOperatorTable):
   operator + = (?x,y; !z; ) pragmas Morphism "(&h&o, &done) :=CostPlus{&t&i1,&t&i2}( &h&i1, &h&i2, &hck&o, &wait)" end pragmas;
   \endcode
 */
virtual ntrees /*Homomorphism::*/getPragmaIdent( ptident id );

/**
   @ingroup tableAccessGroup
   @return "true" if the tree vt is defined, "false" ohterwise.
   @param op (in) an operator.
   @param vt (in) the pragma MORPHISM associated with op if it exists.
   @param ScanPragObj (out) a scanner object for analyzing vt (if it is defined).
 */
virtual boolean /*Homomorphism::*/mkScanPragObj( noperators op ,ntrees vt ,ptStrScanner* ScanPragObj );

/**
   @ingroup tableAccessGroup
   @return "true" if the morphism of an operator (op) is defined in the associated morphism table, "false" otherwise.
   @param op (in) an operator.
   @param ScanPragObj (out) a scanner object for analyzing the pragma MORPHISM associated to op (if its the morphism is defined),
 */
virtual boolean /*Homomorphism::*/scannerOnOp( noperators op ,ptStrScanner* ScanPragObj );

/**
   @ingroup tableAccessGroup
   @return true if an operator (op) is defined in the homomorphism table, "false" otherwise.
   Currently the parameters vstr, out, params def are unused.
   When it returns "true" the scanner object ScanPragObj is set: it is ready to analyze the pragma
   MORPHISM assocaited with the operator.
   \see getIdentOperatorName, IdentLocate, mkScanPragObj
 */
virtual boolean /*Homomorphism::*/scannerOn( noperators op ,ptrepstr vstr ,ptexpcal out ,ptexpcal params ,ptexpcal def ,ptinsth clk ,ptStrScanner* ScanPragObj );

/**
   @ingroup tableAccessGroup
   Unused method: Not documented. 
  */
virtual boolean /*Homomorphism::*/scannerOnIdent( ptident id ,ptStrScanner* ScanPragObj );

/**
   @return a new identifier name using the scanner object (ScanPragObj) 
   assumed to be initialized for the translation of such object.
   if the current token of the scanner object is
   - "ident" (tk_ident), the name is given by the identifier following the token
   - "name" (tk_name) the name is strId
   - "counter" (tk_cpt)  the internal counter (aCounter) is increased, the name is then the value of this counter.
 */
virtual ptident /*Homomorphism::*/homomorphismIdent( ptStrScanner ScanPragObj ,ptrepstr strId );

/**
   @return a new identifier name associated with id (from original graph) if the declaration of identifier is 
   defined in the homomorphism table, undefined name otherwise.
   When the declaration of identifier is defined in the homomorphism table, a scanner object is created and the 
   identifier name is produced from it (see homomorphismIdent(ptStrScanner, ptrepstr)).
 */
virtual ptident /*Homomorphism::*/homomorphismDcl( ptident id );

/**
   @return the identifier name associated with a signal (vsig) in the new graph.
   It calls homomorphismDcl(ptident) for this.
 */
virtual ptident /*Homomorphism::*/homomorphismIdent( ptexpcal vsig );

/**
   @return the identifier name associated with a clock (clk) in the new graph.
   It calls homomorphismDcl(ptident) for this.
 */
virtual ptident /*Homomorphism::*/homomorphismIdent( ptinsth clk );

/**
   @return the homomorphism type of a type (TT) in the new graph.
 */
virtual TypeType /*Homomorphism::*/homomorphismType( TypeType TT );

/** 
    It codifies the types of the program by a enumerated type (referenced by &t in MORPHISM pragma).
    For example, type __TC__ = enum (_event, _logical, _short, _integer, _long, _real, _dpreal, _complex, _dcomplex, _char, _string);
  */
virtual void /*Homomorphism::*/homomorphismTypeCode( void );

/**
   @ingroup finalHomoGroup
   Redefintion of the AbstractHomomorphism::finalize() method.
 */
virtual void /*Homomorphism::*/finalize( void );

/**
   @ingroup finalHomoGroup
   It finalizes the translation.
 */
virtual void /*Homomorphism::*/homomorphismEnd( void );


