/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

typedef class UtilityClock * ptUtilityClock;

#include <map>
typedef std::map<ptINode, ptinsth> TableNodeClockType;

class UtilityClock
{

#include "UtilityClock_m.h"
#include "UtilityClock_g.h"
  
protected:
  ptDCG AGRAPH;
  ptExprManager EM;
  ptClockManager CKM;
  ptNodeManager NM;
  ptINode SubGraph; ///< Set when the fonctionality is restricted to a subgraph.
  typeMark aMark, 
    SelectedObjectMark; ///< equal to -1 when it is for all the signals of the graph.
  ptinsth the_nullClock_UC_copy;
  TableNodeClockType TableNodeClock;
  ptlINode lSelectedNodes; ///< List of the nodes for which the utility clock must be computed. It is freed at the end of the functionality.
};

extern UtilityClock* pK_UtilityClock; ///< Predefined object.
