/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

typedef class mkaggregationsAndMultiplexings * ptmkaggregationsAndMultiplexings;

/**
   local enumerated type used to mark aggregated signals. A signal (x) is marked using a local attribute TYPEAGGREG
   with one of the following value.
*/
typedef enum { noag,    ///< no aggregated 
	       agid,    ///< renamming (x:=y)
	       agwhen, ///<  x:=y when c
	       agcell  ///<  x:=y cell c
             }  typeag;

class mkaggregationsAndMultiplexings
{

#include "mkaggregationsAndMultiplexings_m.h"
#include "mkaggregationsAndMultiplexingsDelay_i.h"
#include "mkaggregationsAndMultiplexings_g.h"
private:
  ptDCG AGRAPH;    ///< operand graph: the functionality is applied to this graph.
  ptExprManager EM;   ///< operand graph info: expression manager.
  ptClockManager CKM; ///< operand graph info: clock manager.
  ptNodeManager NM;   ///< operand graph info: node manager.
  ptinsth htop;       ///< operand graph info:root of the hierarchy.
  
  boolean MULTIPLEXINGDELAYS; ///< option for multiplexing or not delays build on the smae signal.
  ptTravelDepManager PARC;    ///< graph travelling object.

  ptlinstances lssigloc;      ///< list of all local signals of the graph (Union of the local of each clocks, sub graphs,...)
  ptlINode Glist; ///< list of nodes X:=Y and Y marked OPTIMIZED_MEMORY_ATTRIBUTE (revisited at the end of the functionality).
  typeag vnoag, vagid, vagwhen, vagcell; ///<  Attributes management: (devraient disparaitre)

  typeMark TYPEAGGREG; ///< Attributes management, cleaned at the end of the functionality. 
  ptlinstances markedList;      ///< Attributes management, list of the signals marked by TYPEAGGREG.
  
  ptCircuitCalculus CircuitDetector; ///< circuit detector: used after each reinforcing of the graph.
};
