/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

private:

/**
   It removes a delay tree (vmemtree) from a set of such trees (lmemtrees).
  */
ptlmemnode /*mkaggregationsAndMultiplexings::*/memtreeRemoveScalarDelayOne( ptmemnode vmemtree ,ptlmemnode lmemtrees );

/** @return "true" if the delay tree node (vmemtree) is a root of such a structure 
    reduced to one child and this node is a delay of 1, "false" otherwise.
 */
boolean /*mkaggregationsAndMultiplexings::*/isSimpleDelayTree( ptmemnode vmemtree );

/** For a tree of delays verifying the isSimpleDelayTree() condition (ie zx := x $1, and it is the only delay on x)
    If the signals are scalars, they are never multiplexed in the same area even the MULTIPLEXINGDELAYS is pk_true.
    When it is not multiplexed, the memtreeRemoveScalarDelayOne() method is applied.
  */
void /*mkaggregationsAndMultiplexings::*/setlmemtreesDelayOneScalarFirst( void );

/**
   It updates the delay trees of the graph:
   - it cleans the delay trees of the graph (removeMemtreesNullClock()),
   - it applies particular method for "$ 1" (setlmemtreesDelayOneScalarFirst())
   - it computes then the size of the arrays for a circular managing (each delay can be represented by a index on this array).
 */
void /*mkaggregationsAndMultiplexings::*/setlmemtrees( void );

/**
   Local to setlmemtrees() method.
   It removes each delay tree of the graph when the signal associated with the root is a signal synchonized with the null clock.
 */
void /*mkaggregationsAndMultiplexings::*/removeMemtreesNullClock( void );

/**
   @return "true" if the operation succeeds (optimization is applied), "false" otherwise.
   For a root of a delay tree (vmemtree) verifying the condition of isSimpleDelayTree(),
   it is possible to merge  x (associate with the root) and zx (associated with the child) n the same memory,
   - if x is not a memory (cell operator).
   - if the sucessors of x can be produced before the update of the memory (zx). To achieve this, a reinforcing of the graph is
   tested (reinforcingFromTo()). It there is no circuit after the reinforcing, the merging is possible. In this case, attributes
   are added (global compiler attributes defined in the CompilerAttributes.h file)
      - zx is attributed with the OPTIMIZED_MEMORY_ATTRIBUTE attribute, with x as value.
      - the node of zx is marked with the OPTIMIZED_MEMORY_ATTRIBUTE attribute,
      - the node of x is marked with the BELONG_MEMORY attribute.

      It is not applied for constant nodes (element of lNodesInitClk).
 */
boolean /*mkaggregationsAndMultiplexings::*/delayMemoryOptimisation( ptmemnode vmemtree ,ptlINode lNodesInitClk ,boolean bclu );

/** 
    @return "true" if the signal assigned to vmemtree, is not also assigned to another element of vlmemt, "false" otherwise.
    ( Example : For  zx := x $ init I1 and zx1 := x $ init I2.
      If I1, I2 are not compatible initialisations, two trees are built with x as root.)
 */
boolean /*mkaggregationsAndMultiplexings::*/isSingleMemtree( ptmemnode vmemtree ,ptlmemnode vlmemt );


