/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
   Constructor. The functionality is applied to a graph (vGraph).
 */
/*mkaggregationsAndMultiplexings::*/mkaggregationsAndMultiplexings( ptDCG vGraph );

/**
   Destructor.
 */
/*mkaggregationsAndMultiplexings::*/~mkaggregationsAndMultiplexings( void );

/**
   @return "true" is the operation succeeds, "false" otherwise.

     Its realizes optimizations related to the memory size using
     - the "when/cell" aggregations: two signals that can be represented in 
     the same area are annotated using the predefined attribute AGGREGATTRIBUTE. 
     -  the multiplexings of variables: signals built on the same signal using the "window"
     and "delay" operators are represented in the same area (circular array managing) if the initial values are compatible. 

   The graph is travelled taking account the dependences (see \ref GraphTravel documentation). 
   The specific operations are defined when a node is selected by the algorithm (graphTravelling()).
   After the travel, the multiplexing of memories is achieved in setlmemtrees() method.

   When MutliplexDelays, it specifies that the not scalar delays of 1 ($1) must be also multiplexed in the same area, otherwise the
   delays are separatly managed. This option is available in MULTIPLEXINGDELAYS attribute member.

   \note Assumed:
     - the graph is \e free cycle.
     - The multiplexing assumes that the trees of delays is build (mkDelayTree() method has been previously applied).

 */
boolean /*mkaggregationsAndMultiplexings::*/aggregationsAndMultiplexing( boolean MutliplexDelays );

/**
   Here is defined a functionality applied to delay operators.

   It tries to merge x and zx:=x$1 in the same memory by reinforcing the dependences
   (a node that references zx becomes a predecessor of the node of x).
   If such operations don't add a circuit in the graph, the signal x and zx can be merge into the same memory.
   Such an optimisation is specified by some global attributes:
   - zx and node(zx) are marked OPTIMIZED_MEMORY_ATTRIBUTE.
   - node(x) is marked BELONG_MEMORY.

   This method applies for each delay of the program this optimisation:
   if it satisfies some conditions (isSingleMemtree()) and if the operation delayMemoryOptimisation() succeeds, 
   the tree of delays is updated (memtreeRemoveScalarDelayOne()).

 */
void /*mkaggregationsAndMultiplexings::*/delaysMemoryOptimisation( boolean bclu );


