


boolean
AssignmentClock::computeCWDCVEquation (ptINode node, ptinsth * vhContrib, ptexpcal * vDefaultConstantValue)
{
  ptexpcal vdedef, vexpr, vop1, vop2;

  if (!NM->is_equation (node))
    return pk_false;

  if (!NM->get_rightOperand (node, &vdedef))
    return pk_false;
  vexpr = EM->getBasicExpr (vdedef);
  if (EM->IsCellExpr (vexpr))
    return pk_false;
  if (EM->getOperator (vexpr) != opmele)
    return pk_false;
  vop2 = EM->getBinaryArgstAt (vexpr, 2);
  if (EM->getOperator (vop2) == opmele)
    return pk_false;
  vop2 = EM->getWhenOrCellArg (vop2);
  if (!EM->IsConstantExpr (vop2))
    return pk_false;
  *vDefaultConstantValue = vop2;
  vop1 = EM->getBinaryArgstAt (vexpr, 1);
  *vhContrib = EM->getContributionClock (vop1);
  return pk_true;
}





/**
   It computes the assignment clock for each node of the operand list (lnodes).
   A node is assumed to be an equation (not a delay).
*/
void
AssignmentClock::computeCWDCVEquations (ptlINode lnodes)
{
  ptINode node;
  ptinsth vClock_WithoutDefaultConstantValue;
  ptexpcal vDefaultConstantValue, vDefinedSig;

  while (ptlINode_get_elem (&lnodes, &node))
    if (computeCWDCVEquation (node, &vClock_WithoutDefaultConstantValue, &vDefaultConstantValue))
      {
	vDefinedSig = NM->get_leftOperand (node);
	EM->setDefaultConstantValueInfos (vDefinedSig, vClock_WithoutDefaultConstantValue, vDefaultConstantValue);
      }
}

boolean
AssignmentClock::computeCWDCVPartialEquation (ptINode node, ptinsth * vClockWithoutDefaultConstantValue, ptexpcal * vDefaultConstantValue)
{
  ptlINode ln;
  ptINode n;
  boolean isDefaultValueConstant, defaultValueFound;
  ptinsth vh;
  ptexpcal vexpr;

  ln = NM->get_setOfPartialDefinitions_arg (node);
  defaultValueFound = pk_false;
  isDefaultValueConstant = pk_false;
  while (!defaultValueFound && ptlINode_get_elem (&ln, &n))
    if (NM->isDefaultValueNode (n))
      {
	defaultValueFound = pk_true;
	if (NM->get_rightOperand (n, &vexpr))
	  {
	    vexpr = EM->getBasicExpr (vexpr);
	    if (!EM->IsCellExpr (vexpr))
	      if (EM->IsConstantExpr (vexpr))
		{
		  isDefaultValueConstant = pk_true;
		  *vDefaultConstantValue = vexpr;
		}
	  }
      }
  if (!isDefaultValueConstant)
    return pk_false;

  vh = hundef;
  ln = NM->get_setOfPartialDefinitions_arg (node);
  while (ptlINode_get_elem (&ln, &n))
    if (!NM->isDefaultValueNode (n))
      vh = CKM->makeSup (vh, NM->get_nodeClock (n));
  *vClockWithoutDefaultConstantValue = vh;
  return pk_true;
}


void
AssignmentClock::computeCWDCVPartialEquations (ptlINode lnodes)
{
  ptINode node;
  ptinsth vClock_WithoutDefaultConstantValue;
  ptexpcal vDefaultConstantValue, vDefinedSig;

  while (ptlINode_get_elem (&lnodes, &node))
    if (computeCWDCVPartialEquation (node, &vClock_WithoutDefaultConstantValue, &vDefaultConstantValue))
      {
	vDefinedSig = NM->get_leftOperand (node);
	EM->setDefaultConstantValueInfos (vDefinedSig, vClock_WithoutDefaultConstantValue, vDefaultConstantValue);
      }
}
