/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PUBLIC_
/**
   Constructor.
   The functionality is applied to a graph (g).
*/
  AssignmentClock::AssignmentClock (ptDCG g)
{
  init (g);
}

/**
   Constructor.
*/
AssignmentClock::AssignmentClock ()
{
}

/** Destructor. */
AssignmentClock::~AssignmentClock ()
{
}

void
AssignmentClock::init (ptDCG g)
{
  AGRAPH = g;
  EM = AGRAPH->getExpressionManager ();
  CKM = AGRAPH->getClockManager ();
  NM = AGRAPH->getNodeManager ();
  hundef = CKM->getUndefClock ();
}

/**
   Not yet fully implemented. 
   Not yet documented.
*/
void
AssignmentClock::apply ()
{
  ptlINode ls;

  if (NM->getEquations (&ls))
    assignmentClockEquations (ls);
  if (NM->getGroupsOfPartialEquations (&ls))
    assignmentClockPartialEquations (ls);
}


/**
   Set the predefined attributes 
   - DefaultConstantValue : a constant value
   - ClockWithoutDefaultConstantValue :the clock at which a signal is not assigned to this value.
   It may be used to reduce the communications for distributed code.
*/
void
AssignmentClock::computeClockWithoutDefaultConstantValue ()
{
  ptlINode ls;
  // CWDCVE stands for "Clock Without Default Constant Value".
  if (NM->getEquations (&ls))
    computeCWDCVEquations (ls);
  if (NM->getGroupsOfPartialEquations (&ls))
    computeCWDCVPartialEquations (ls);
}


