/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef __RUNONMARK_H__
#define __RUNONMARK_H__
#include <vector> ///< from STL

typedef class  RunOnMark* ptRunOnMark;

#include "Clusters.h"

class  RunOnMark : public Clusters
{
#include "RunOnMarkColouring_m.h"
#include "RunOnMarkPartitionning_i.h"
#include "RunOnMark_g.h"
private:
  typedef std::vector <ptrepstr> RunOnNameTableType;
  RunOnNameTableType RunOnNameTable; ///< table of the RunOn symbol.
  ptlinsth selectedClockList;  ///< list of  the selected clocks.
  ptlINode LNodesWithoutPragma ; ///< List of the nodes without production localization (it must be empty at the end of the functionality).
  typeMark referencedInMark;  ///< internal mark used to have the list of sub-graphs referencing an object (node,clock).It is used to empty the LNodesWithoutPragma list.

protected:
  integer nbsets;           ///< the number of sub-graphs of the partitionning.
  ptINode * SubGraphTable;    ///< a table of nbsets sub graphs.
}; 


#endif // __RUNONMARK_H__


