/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PUBLIC_
/** Constructor.
    The clustering is applied on a graph (GraphInitial).
    It provides some standard methods useful to define partitionning functionalities.
*/
    Clusters::Clusters(ptDCG GraphInitial)
{
  ptexpcal vTick;

  BDEBUG = pk_false;

  AGRAPH = GraphInitial;
  EM = GraphInitial->getExpressionManager();
  CKM = GraphInitial->getClockManager();
  NM = GraphInitial->getNodeManager();
  graph_type = GraphInitial->getFormatLevel();
  bDCplusFormat = !isEventClockedFormat(graph_type);
  maxMark = -1;
  firstMark = -1;
  lSubGraph = NILLINODE;
  error = pk_false;
  unusedNodes = AGRAPH->getUnused(&unusedClocks);
  ClusterAttribute = getMark();
  if (CKM->isClockRepresentedBySignal(CKM->getTickClock(), &vTick))
    TickNode = EM->getNode(vTick);
  else
    TickNode = NILINODE;
}

/** Destructor. */
_VIRTUAL_ Clusters::~Clusters()
{
}

/**
   @return the error code.
*/
boolean Clusters::errored()
{
  return error;
}
