/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

private:

/** @return dependences + the Signal Abstract tree representation of the dependences from a sub-graph (aSubGraph)
    to other sub-graphs.
    \warning if aSubGraph is a "delay cluster" sub-graph (particular cluster annotated with the PRAGMA_DELAYCLUSTER pragma), the dependences are reversed.
 */
ntrees /*DCG2SignalTree::*/mkTreeAbstractDependencesSubGraph( ptINode aSubGraph ,ntrees dependences );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*DCG2SignalTree::*/isNextDependenceCompatibleWith( pticlosure iclos ,ptinsth hexp ,ptexpcal* expFrom );

/**
  It adds to the Signal Abstract tree representation of the closures (composition of dependences) the 
  closure informations (lclos).
  For each element <em> (Y,H) </em> of lclos, it adds to transclosure 
  the dependence <em> (Y ---> vsig) \b when H </em>.

  It assumes that when expg is defined hg is undefined,and when expg is undefined hg is defined,.
 */
ntrees /*DCG2SignalTree::*/solveclosure( ntrees transclosure ,ptlclosure lclos ,ptexpcal vsig );

/**
  It adds to the Signal Abstract tree representation of the closures (composition of dependences) the 
  closure informations (lclos).
  For each element <em> (Y,H) </em> of lclos, it adds to transclosure 
  the dependence <em> (Y ---> hg) \b when H  </em>

  It assumes that when expg is defined hg is undefined,and when expg is undefined hg is defined,.
 */
ntrees /*DCG2SignalTree::*/solveclosure( ntrees transclosure ,ptlclosure lclos ,ptinsth hg );

/**
   If the operand (aDep) is a i/o dependence, its Signal representation is added to the operand tree (transclosure).
 */
void /*DCG2SignalTree::*/mkIOClosureTree( ptdependence aDep ,ntrees* transclosure );

/**
   @return the Signal Abstract tree representation of the transitive closure of the current graph
   reduced to the input/output signals of the graph.
   For each selected node, it calls solveclosure().
 */
ntrees /*DCG2SignalTree::*/mkIOClosureTree( void );

/**
   @return "true" if a clock (vh) is the clock of an input/output signal, "false" oterhwise.
 */
boolean /*DCG2SignalTree::*/isIOClock( ptinsth vh );

/**
   @return the Signal Abstract tree representation of a list of the identifiers 
   of a list of clocks (lhorl) excluding the clocks of input/output signal.
 */
virtual ntrees /*DCG2SignalTree::*/mkNamesClocksWithoutIO( ptlinsth lhorl );

/**
   @return the Signal Abstract tree representation of a declaration of 
   a list of clocks (lhorl) excluding the clocks of input/output signals.
 */
virtual ntrees /*DCG2SignalTree::*/mkDeclNotExternalClocks( ptlinsth lhorl );

/** 
    @return the Signal Abstract tree representation of the projected system of the graph.
    It takes h as root if withTick (used for clusters).
  */
ntrees /*DCG2SignalTree::*/mkProjectionTree( ptinsth h ,boolean withTick ,ntrees* vtDeclSig );

/**
   @return the Signal Abstract tree representation of the 
   declaration of a list of signals represented as an combed expression (lInsGreyBox).
   The initial value is added to the declaration is binit.
 */
ntrees /*DCG2SignalTree::*/mkTreeDeclarations( ptexpcal lInsGreyBox ,boolean binit );

/**
  It adds to a Signal Abstract tree representation of a model (process)
  the pragma PRAGMA_BLACK_BOX "ident"  
 */
void /*DCG2SignalTree::*/addPragmaAbstractionBlackBox( ntrees process ,ptident PragmaStatement );

/**
  It adds to a Signal Abstract tree representation of a model (process)
  the pragma PRAGMA_GREY_BOX "ident"  
 */
void /*DCG2SignalTree::*/addPragmaAbstractionGreyBox( ntrees process ,ptident idGraph );

/**
   @return the Signal Abstract tree representation of a sub-graph (aSubGraph).
   It is a skeleton of a model with 
   - the name of the sub-graph as name of the process
   - the inputs/outputs of the sub-graph as inputs/outpust of the model
   - the pragmas of the sub-graph 
   - when isolated, the clock table is added, otherwise the model is considered as an external model implemented in "vlang" language.
 */
ntrees /*DCG2SignalTree::*/mkAbstractTreeGreyBoxSubGraphs( ptINode aSubGraph ,boolean isolated ,ntrees vlang );

/** @return nil tree currently.
    Not implemented. Explicit dependences.
 */
ntrees /*DCG2SignalTree::*/mkTreeExplicitDependencesAbstraction( void );

/** 
    @return the Signal Abstract tree representation of the synchronisation of 
    the label associated with a sub-graph (aSubGraph) to the clock of this sub-graph 
 */
ntrees /*DCG2SignalTree::*/mkClocklabelTree( ptINode aSubGraph );

/**
   It adds the Signal Abstract tree representation of the GreyBox abstraction of a list of sub-graphs (subGraphs)
   to a model (process). The Implementation Language (vlang) is used to define the expression of definition of the
   Signal Abstract tree representation of a sub-graph.

   For each element of subGraphs, 
   - the model associated with the sub-graph is produced (mkAbstractTreeGreyBoxSubGraphs()),
   - the model is annotated with the "Black Box" pragma (addPragmaAbstractionBlackBox()),
   - a reference to the sub-graph is inserted in the (upper) model (process) mkReferenceToSubGraphDefinition(),
   - the dependences from the sub-graph to other sub-graphs are built (mkTreeAbstractDependencesSubGraph())

   It finalizes the abstraction by the inserting (in process)
   - the inter sub-graph dependences
   - the declaration of the label associated with each sub-graph.
 */
void /*DCG2SignalTree::*/mkAbstractTreeGreyBoxSubGraphs( ntrees process ,ptlINode subGraphs ,ntrees vlang );

/**
   It declares in the model (process) the boolean representation of the tick of the hierarchy.
 */
void /*DCG2SignalTree::*/dclBooleanTick( ntrees process );

/**
   Cleaning the graph (local marks,...)
  */
void /*DCG2SignalTree::*/AbstractionFinalize( void );

/**
   Cleans the specification part of a model (vmodel).
 */
void /*DCG2SignalTree::*/cleanTreeSpec( ntrees vmodel );

/**
   @return the Signal Abstract tree representation of the abstraction of a graph (g).

   When the graph is a graph of clusters, the abstraction is a Grey Box abstraction otherwise it is a black box one.

   - For a black box abstraction, it is a model that specify the i/o data dependencies and the i/o clock relations.
   - For a Grey Box abstraction, the model is completed with the black box abstraction of the clusters and the 
   dependences beteween clusters are added.   

   \see mkOIClosureTree(), mkProjectionTree(),getTrainList(), mkAbstractTreeGreyBoxSubGraphs()
   addPragmaAbstractionGreyBox(), addPragmaAbstractionBlackBox(), dclBooleanTick().
 */
ntrees /*DCG2SignalTree::*/IGraph2AbtractionTree( ptDCG g );


