/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/** 
    @return true if a clock (vh) is a selected clock for the operation.
 */
boolean /*DCG2SignalTree::*/isSelectedClock( ptinsth vh );

/**
   @return true if a clock (vClk) is an element of the current block (\see{mkArrayDefinition}). 
 */
virtual boolean /*DCG2SignalTree::*/isClockOfCurrentBlock( ptinsth vClk );

/** @return vt + the local signals to the process with vh as root +  the external signals to the process with vh as root
    \note It assumes that vt is a composition.
 */
virtual ntrees /*DCG2SignalTree::*/addSynchroSignals( ptinsth vh ,ntrees vt );

/**
   It adds
   - the constraints on a clock (vh) to the global list lequnotprov: 
   for a clock defined by a set of fromula {f1, f2, ....,fn}, it adds the synchronisation of f1 with the explicited expression of the the fi formulas.
   - the assertions associated with this clock to the list lassertions

   It takes into account only the formulas of the clock, the constraints/assertions on placed formula are managed otherwise (appequformplnotprov()).
 */
virtual void /*DCG2SignalTree::*/addConstraintsAndAssertions( ptinsth vh );

/**
   @return the tree 
    - vh ^= t for a POLY graph (graph of "event" clocks)
    - 'when C ^= t', for boolean graph, vh is defined by when C.
 */
virtual ntrees /*DCG2SignalTree::*/initListSynchro( ptinsth vh ,ntrees t );

/**
   It adds in vtlni a synchronisation between vh and vsig.
   first (in) must be set  to "true" value the first call to this method, fisrt (out) is set to "false" value.
 */
virtual void /*DCG2SignalTree::*/addSynchroClockSignal( ptinsth vh ,ptexpcal vsig ,boolean* first ,ntrees* vtlni ,boolean bforce );

/**
   Adding the comment (numMess represents its index in the message table) to a tree vt (if is is defined).
   The name of the clock (aClock) is added at the end of the message.
 */
void /*DCG2SignalTree::*/addClockHierarchyComment( ptinsth aClock ,ntrees vt ,int numMess );

/**
   It removes duplicate identifiers from the operand list (vtSynchro).
   When a clock is represented by a signal x, x appears twice in the synchronisation expression(vtSynchro).
 */
ntrees /*DCG2SignalTree::*/ClockSynchroClean( ntrees vtSynchro );

/**
   It creates for a clock (vh) two lists:
   - vtli (out) : the list of signals synchronous to vh that are local signals to the process with vh as root.
   - vtlni (out) : the list of signals synchronous to vh that are external signals to the process with vh as root.
 */
virtual void /*DCG2SignalTree::*/mktreelsigsync( ptinsth vh ,ntrees* vtli ,ntrees* vtlni );

/**
   It adds the constraints name(vh1) ^= name(vh2) to the global list lequnotprov.
   The expression of vh1, vh2 are assumed to be explicited.
 */
virtual void /*DCG2SignalTree::*/hoaddcontrhopl( ptinsth vh1 ,ptinsth vh2 );

/**
  @return "true" if a SIGNAL Abstract Tree representation is associated with a clock (vh), "false" otherwise.
  Moreover, it is \b useful if the SIGNAL Abstract Tree representation is a model.
 */
virtual boolean /*DCG2SignalTree::*/isAlreadyVisited( ptinsth vh ,boolean* useful );

/** It masks the local signals of a clock (vh) in the body of its  SIGNAL Abstract Tree representation (vprocessus).
  */
virtual void /*DCG2SignalTree::*/_masksigloc_unused( ptinsth vh ,ntrees vprocessus );

/**
   @return the name of the model associated with a clock
   (for a clock with \em foo as name, it returns \em SUBTREE_of_foo).
 */
virtual ntrees /*DCG2SignalTree::*/mkClockNameTreeProcess( ptinsth vh );

/** @return  the SIGNAL Abstract Tree representation of  a reference to the model associated with a clock (vh).
    the name of the model is given by mkClockNameTreeProcess().
 */
virtual ntrees /*DCG2SignalTree::*/mkInstClockTreeProcess( ptinsth vh );

/** 
    @return the Signal abstract tree representation of a sub-graph (Actions) of a clock (aClock).
    It is a nil tree or a process.
 */
virtual ntrees /*DCG2SignalTree::*/buildGFDTree( ptinsth aClock );

/**
   It adds to a model (vhierarchy) the not proved equivalences stored in lequnotprov (attribute member of the class).
 */
virtual void /*DCG2SignalTree::*/applequnotprov( ntrees vhierarchy );

/**
   It initializes the translation of a node of the hierarchy (vh) by the following operations:
   - it adds a reference to the process associated with the clock (vh) to the expression of the process of the father clock (vexpro).
   - it builds a skeleton model for the clock; it is associated, as an attribute, with the clock. The attribute will be used later to complete the translation.
   - it adds the declaration of the model to the father clock (vt).
   - it adds in the expression of process of the created model the vli tree (list of the local signals of the clock synchronized with it)
   .
   It assumes that vexpro is a composition, vt is a model.
 */
virtual void /*DCG2SignalTree::*/initNodeHierarchyTranslation( ntrees* vexpro ,ptinsth vh ,ntrees vli ,ntrees vt );

/**
   It adds
   - to lequnotprov (attribute member of the class) the non proved equivalence for placed formula in the hierarchy.
   It calls hoaddcontrhopl() for each constraint.
   - to lassertions (attribute member of the class) the assertions on placed formula in the hierarchy.
   It calls assertion() for each assertion.
   .
   These lists are added at the end of the translation to the built model.
 */
virtual void /*DCG2SignalTree::*/appequformplnotprov( void );

/**
   @return the Signal Abstract Tree representation of a pragma statement (PragmaStatement).
 */
virtual ntrees /*DCG2SignalTree::*/mkPragmaStatement( ntrees PragmaStatement );

/**
   It adds (STree_addPragma()) a pragma (v) to the model (vt). The
   pragma statement is given by mkPragmaStatement().
 */
virtual void /*DCG2SignalTree::*/addPragma( ptpragma v ,ntrees vt );

/** 
    It adds each pragma, of a list (lpragmas), to a model (vtcurrent).
 */
virtual void /*DCG2SignalTree::*/addPragmasModel( ntrees vtcurrent );

/** 
    It adds each pragma, of a list (lpragmas), to a model (vtcurrent).
 */
virtual void /*DCG2SignalTree::*/addPragmas( ptlpragmas lpragmas ,ntrees vtcurrent );

/** 
    It adds to a model (vhierarchy) as comments the definitions of the nodes of a list of nodes (ln).
    A message (codemess) is added to this comment.
 */
virtual void /*DCG2SignalTree::*/addInfosNodes( ptlINode ln ,ntrees vhierarchy ,int codemess );

/** 
    It adds to a model (vhierarchy), the nodes not localized by the "RunOn" partitionning.
    This information is set by the runonpartitionning as an attribute of the graph.
 */
virtual void /*DCG2SignalTree::*/addErrorPartitionning( ntrees vhierarchy );

/** 
    It adds to a model (vhierarchy) a comment to specify that the signals (lsighnull) are synchronized with the null clock.
    (The auxillary signals are filtered).
 */
virtual void /*DCG2SignalTree::*/addSignalsSynchronizedWithNullClock( ptlinstances lsighnull ,ntrees vhierarchy );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*DCG2SignalTree::*/addAssertion( ptinsth vh1 ,ptinsth vh );

/**
   For a DC+ graph.
   For each clock of a list (lh), it adds to the attribute member (lasertions)
   as an assertion the equivalence of the clock with the null clock.
 */
virtual void /*DCG2SignalTree::*/addAssertionsNullClock( ptlinsth lh );

/**
   For each clock of a list (lh), it adds to the attribute member (lequnotprov)
   the synchronisation of the clock (formula2ntrees()) with the null clock.
 */
virtual void /*DCG2SignalTree::*/addConstraintsNullClock( ptlinsth lh );

/**
   It adds, to a model (vtcurrent), the synchronizations with the null clock (addSignalsSynchronizedWithNullClock())
   and the equivalences not proved to the null clock (addConstraintsNullClock()).
 */
virtual void /*DCG2SignalTree::*/insertNullClock( ntrees vtcurrent );

/**
   @return "true" when the Signal abstract tree representation of the definition of the hierarchy associated with a clock (vh) 
   is integrated to the model (vt), "false" otherwise.

   @param vh (in) a clock
   @param vli (in) local signals to the sub tree with vh as root and with vh as clock
   @param vt (in) the (assumed) Signal abstract tree representation of the model associate with the father clock of vh.
   @param isaextract (in) must be pk_true when vh is an extraction.
   @param vexpro (in/out) the Signal abstract tree representation associated with vh (set when it returns "true")
   \note It is done when vh is a leaf of the hierarchy and when the number of nodes associated with it is equal to 1.   
 */
virtual boolean /*DCG2SignalTree::*/doneForSubTree( ptinsth vh ,ntrees* vexpro ,ntrees vli ,ntrees vt ,boolean isaextract );

/**
   Adds id in the list of clock parameters.
   The global list (ClockParameterTree) is added to the model at the end of the transformation.
 */
void /*DCG2SignalTree::*/addToClockParameterTree( ntrees id );

/**
    @return "true" if the sub-tree associated with a clock (vh) is not integrated to vt, "false" otherwise.

    It adds to the body of a model (vt) -- vt assumed to be the model associated with the father clock of vh --
    - (1) the composition (vexppro) composed of the Signal abstract tree of the definition of a clock formula (vh)
    and the synchronisation with vh of the signals (non locals to the sub tree with vh as root).
    - (2) and the definition of the sub-tree associated with vh when it satisfies some conditions (see doneForSubTree().
 */
virtual boolean /*DCG2SignalTree::*/buildexprforfath( ptinsth vh ,ntrees vt ,ntrees* vexpro );

/**
   It adds the definition of the complementary clock of a clock (vh) assumed to be an extraction to the expression of process (vexpro) of a model (vt).
   This operation is achieved if such a clock is useful.
   @return "true" if the operation is achieved, "false" otherwise.
 */
boolean /*DCG2SignalTree::*/mkSubTreeComplExtraction( ptinsth vh ,ntrees vt ,ntrees* vexpro );

/**
   It defines, if it is not already done and when it is useful, the expression of vh for its father clock: 
   the definition of the formula (buildexprforfath()) is added to the body of the model associated to its father clock (vt).
   Moreover, under some conditions (it is a leaf with one node associated with it) the sub tree of vh is completely 
   integrated to the body of vt. 

   @return "true" if the operand clock (vh) is useful for the graph and the sub-tree associated with vh is not
   integrated to vt, "false" otherwise.
 */
virtual boolean /*DCG2SignalTree::*/mkSubTree( ptinsth vh ,ntrees vt );

/**
   Cleaning the composition.
   For a composition (vt), a sub-composition reduced to one element is replaced by this element.
   @return the simplified tree. If vt is reduced to one element, its child is returned.
 */
ntrees /*DCG2SignalTree::*/SimplifyComposition( ntrees vt ,boolean bRootClock );

/**
   The reference to the model (vt) associated with a clock (aClock) is removed from its father clock.
 */
void /*DCG2SignalTree::*/TreeRemoveChild( ptinsth aClock ,ntrees vt );

/**
   It finalizes the translation of a node of the hierarchy (aClock) as a SIGNAL Abstract Tree representation (vt):
   - If the expression of process of vt is undefined, the reference to the model in the body of the father
   clock is removed (ie the representation of the clock is optimized).
   - otherwise, the expression of definition is cleaned: a sub-composition reduced to one element is replaced by this element.
 */
virtual void /*DCG2SignalTree::*/buildHierachyTreeEnd( ptinsth aClock ,ntrees vt );

/** 
    It defines the SIGNAL Abstract Tree representation for a node of the clock hierarchy (aClock)
    and visits the hierarchy by a left to right topdown traversal.
    The SIGNAL Abstract Tree representation, associated with the clock, is a model (process). It is added as an attribute to the 
    clock.
    
    The following operations are achieved:
    - addConstraintsAndAssertions() it adds the constraints and the assertions associated with the clock to the model.
    - mtInterfaceTree() it defines the interface of the SIGNAL Abstract Tree model. 
    - mktreeloc() it defines the locals of the SIGNAL Abstract Tree model. 
    - for each child of aClock, it executes "if mkSubTree() then buildHierachyTree()".
    - buildGFDTree() it defines the body of the model
    - buildHierachyTreeEnd() it finalizes the SIGNAL Abstract Tree representation.
 */
virtual void /*DCG2SignalTree::*/buildHierachyTree( ptinsth aClock );

/**
   For an endochronous model, it adds 
   - a comment when the master clock is represented by a signal
   - a comment when the master clock is not a clock of an i/o signal (oversampling).
  */
virtual void /*DCG2SignalTree::*/annotRootClock( void );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*DCG2SignalTree::*/appClockParameters( ntrees vtcurrent );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*DCG2SignalTree::*/finalizeHierarchy( ntrees vtcurrent );

/**
   It adds to a model (vtcurrent) the SIGNAL Abstract Tree representation of a graph (aGraph)
   When the parameter bflat 
    - is "true", the clock hierarchy is recursively explicited as a list of subprocesses.
    - is "false", the clock hierarchy is flatenned (for example, if a graph contains some labels, it is necessary to flatten the hierarchy).
    .
    To achieve this translation, it calls
    - flatModeInit() it initializes the "flat mode" translation.
    - buildHierachyTree() it visits the hierarchy left to right, topdown. 
    - mkGraphTreeDependences() it adds the explicit dependences to the SIGNAL Abstract Tree representation
    - insertDeclarationsFlatMode() it adds the declarations in "flatened mode"
    - appequformplnotprov() it adds the not proved equivalences (constrainsts)
    - insertNullClock() it adds the synchronizations with the null clock.
    - addInfosNodes() it adds (comments) the unused objects (signals, clocks) of the graph to the SIGNAL Abstract Tree representation,
 */
virtual void /*DCG2SignalTree::*/IGraph2Process( ptDCG aGraph ,ntrees vtcurrent );

/**
   Local to DCG2SignalTree::cleanTree(ntrees).
   @return the equations of the composition (compTree) added to the global composition (vt).
 */
ntrees /*DCG2SignalTree::*/cleantree( ntrees compTree ,ntrees vt );

/**
   For the "flat mode", all the definitions of a model (vmodel) are defined in the same composition.
   The labelled sub-systems are kept but the no labelled ones are flattened.
   \see DCG2SignalTree::cleantree(ntrees, ntrees).
 */
void /*DCG2SignalTree::*/cleanTree( ntrees vmodel );

/**
   When the SpecMode 
   - is ON, it adds the specification part of a graph (aGrap) to its abstract tree representation (vtcurrent).
   - is OFF, the equations of the specification part is added to the body of the abstract tree representation.
 */
void /*DCG2SignalTree::*/addSpec( ntrees vtcurrent ,ptDCG aGraph );

/**
   @return "true" if it exists at least a signal of lsig synchronous with a clock (vh), "false" otherwise.
   It returns in vt the Signal Abstract tree representation of the signals (list of identifiers) of lsig synchronous with vh.
 */
boolean /*DCG2SignalTree::*/mkSynchronizedSignalsOfToClock( ptinsth vh ,ptlinstances lsig ,boolean boolFormat ,ntrees* vt );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*DCG2SignalTree::*/mkSignalsClockSynchro( ptinsth vh ,ptlinstances lsig ,boolean bDef ,ntrees* vabstract );

/**
   For each clock of lh it applies 
   @return the composition of these synchroniations.
 */
ntrees /*DCG2SignalTree::*/mkSignalsClockListSynchro( ptlinsth lh ,ptlinstances lsig ,boolean bDef );

/**
   @return the tree of the definitions of boolean signals such that (C)
   For a clock of the list lh, vh an extraction built on a boolean signal (C), 
   it adds the definition of C is C is defined by E and E is an expression on input/output signals then when C is replaced by E
 */
ntrees /*DCG2SignalTree::*/addBooleanDefinitions( ptlinsth lh ,ntrees* vtdecl );

/**
   @return the Signal Abstract tree representation of a clock table for a graph with boolean clocks (ie endochronous and boolean clocks)
   
   It produces a composition in which each signal of lsig appears with its clock and the definition of this clock. 
   (mkSynchronizedSignalsOfToClock(), mkClockExpression())
   
   @param h (in) assumed to be the branching clock of the clocks of lsig.
   @param lh (in) the clocks of the system
   @param lsig (in) a list of signals 
   @param bWithTick must be "true" when the definition of the local tick (h) must be added to the table, "false" otherwise.

   @note ---UNUSED-----
  */
ntrees /*DCG2SignalTree::*/_buildClockTableBool( ptinsth h ,ptlinsth lh ,ptlinstances lsig ,boolean bWithTick ,boolean babstract );

/**
   @return the Signal Abstract tree representation of a clock table for a graph.
   It produces a composition in which each signal of lsig appears with its clock and the definition of this clock. 
   @param h (in) assumed to be the branching clock of the clocks of lsig. It may be the fictitious root (polychronous program).
   @param lh (in) the clocks of the system
   @param lsig (in) a list of signals 
 */
ntrees /*DCG2SignalTree::*/buildClockTable( ptlinsth ExportedClocksBuiltOnIOClocks ,ptlinsth ExportedClocksNotBuiltOnIOClocks ,ptlinstances lsig ,ntrees* vtdecl );


