/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

private:

/**
   It adds an intrinsic "status" node defined at the clock vh, such that
   "zmemvx := status{vinit} (zvx)", where
      - zmemvx is the element of lout,
      - zvx is the element of lin ,
      - and vinit the element of lparam.
 */
ptINode /*statesVariables::*/addStatusNodeAt( ptexpcal lparam ,ptexpcal lin ,ptexpcal lout ,ptinsth vh );

/**
   @return a new signal with same type than x, same class identifier than x and with vclk as clock.
 */
ptexpcal /*statesVariables::*/mkCopyIdentExp( ptexpcal x ,ptinsth vclk );

/** @return "true" if the signal is selected, "false" otherwise.
    By default, operation is applied to each signal. 
  */
boolean /*statesVariables::*/isSelected( ptexpcal vsig );

/** It adds a state variable with partial definition.
   vy ::= vx when vhx.
 */
void /*statesVariables::*/addStateVar( ptexpcal vy ,ptexpcal vx ,ptinsth vhx );

/**
  @return a 1-delay signal zmx of mx synchroniezd to clkDelay clock.
 */
ptexpcal /*statesVariables::*/makeDelayOneAt( ptexpcal mx ,ptinsth clkDelay ,ptexpcal vinit );

/** 
   @return a 1-delayed-memory of a given delayed-signal to a given clock for "boolean" format.
   @param vx (in) signal that must be memorized as a state-variable.
   @param vhx (in) the clock of vx.
   @param vinit (in) initial value of the memory.
   @param vh (in) the clock of the memory.
   @param memx (out) cell of vx at vhx.
   The memory (zmemx) is defined by 
   - memx = (vx when vhx) default zmemx
   - zmemx = memx $ VALDELAY  init VINIT
   - synchro{ memx, vh }  

   \note restriction: 1-delay (VALDELAY), no window.
 */
ptexpcal /*statesVariables::*/makeMemoryofAt( ptexpcal vx ,ptinsth vhx ,ptexpcal vinit ,ptinsth vh ,ptexpcal* memx );

/** Creating and returning zmemvx  defined by zmemvx := status{zvx}, zmemvx init init(zvx)
   at the clock vhto.
   "status" is said intrinsic call.
 */
ptexpcal /*statesVariables::*/makeStatusCall( ptexpcal zvx ,ptexpcal vx ,ptinsth clkvx ,ptinsth vhto ,ptINode* createdNode );

/** Defining a state variable S ::= vx when vhx. If vy is an output, an internal state variable (S) is
   build (an output cannot be a state variable) and vy is defined by this statevar.
   Otherwise S is vy and the references to vy are replaced by a state variable reference expression (vy?).
   Assumed : vy is initialized.
 */
void /*statesVariables::*/mkStateVariable( ptexpcal vy ,ptexpcal vx ,ptinsth vhx );

/**
   It copies the partitionnning infos from a node (fnode) to an another one (tnode).
 */
void /*statesVariables::*/movePragmasFromTo( ptINode fnode ,ptINode tnode );

/** 
   @return true if the extension to a given clock of a delay node is achieved.
   @param delayNode (in) a node assumed to be a delay.
   @param vhto (in) a clock at which the delay is memorized (clock greater than the clock of the delay)
   The memorization is defined according to the sub-format level:
   - dc+ format : a SIGNAL state variable is created with partial definition assigned to it.
   - other format: the 1-delayed-memory (zmemx) is defined by
     -(| memx = (vx when ^vhx) default zmemx 
     - | zmemx = memx $ VALDELAY  init VINIT
     - | synchro{ memx, vh }  
     -|)

   \note Restriction: 1-delay (VALDELAY), no-window.

 */
boolean /*statesVariables::*/ExtendADelayToClock( ptINode delayNode ,ptinsth vhto );

/** @return true if the extension to a given clock of all the delay-node of a list of nodes is achieved.
   @param ln (in) a list of nodes.
   @param clkTo (in) a clock at which the delays are memorized (clock greater than the clock of such a delay).
 */
boolean /*statesVariables::*/ExtendDelaysToClock_loc( ptlINode ln ,ptinsth clkTo );

/**
   @return the list of the nodes associated with a clock (vclk).
 */
ptlINode /*statesVariables::*/getNodesAssignedTo( ptinsth vclk );

/** @return true if the extension to a given clock of all the delay-node assigned to a clock is achieved.
    @param clkFrom (in) a clock for which the extension of delay-nodes is applied.
    @param clkTo (in) a clock at which the delay are memorized (clock greater than clkFrom ).
 */
boolean /*statesVariables::*/ExtendDelaysToClock( ptinsth clkFrom ,ptinsth clkTo );

/** It defines the state variables (aStatevar) by a status call.
    For aStatevar a state variable, mx is defined by mx := STATUS{init(aStatevar)}(aStatevar), aStatevar becomes a signal.
    Assumed: the state variable is defined by ONE partial definition.
    (ie the PartialDefinitionsMerging() method has been applied on the graph).
 */
ptexpcal /*statesVariables::*/stateVariable2Status( ptexpcal aStatevar );


