/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/


///
typedef class HierarchyTravelModel * ptHierarchyTravelModel;

///
class HierarchyTravelModel
{
#include "HierarchyTravelModel_m.h"  // private methods
#include "HierarchyTravelModel_g.h"  // public methods
  // ----(you could have many components) --------------
  /// #include "myComponent.h"
  
 protected:
  ptDCG AGRAPH;     // the operand graph (set by the constructor)
  ptClockManager CKM;  // Clock manager of the graph AGRAPH
  ptNodeManager NM;    // Node manager of the graph AGRAPH
  ptExprManager EM;    // Expression manager of the graph AGRAPH
 
  GraphLevelType graph_type;  // level (DC+, bDC+, ...) of AGRAPH
  ptlinstances inputs, outputs;  // inputs/outputs of AGRAPH
  ptlINode unNodes;  // Set of unused nodes of AGRAPH  
  ptlinsth unClocks; // Set of unused clocks of AGRAPH  
  
  ptINode ArrayBlock;  // Current Array Block;
  // --- Here you can declare your attributes ---------------
  // ....
  
};
