/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

{
  ntrees vinit, name, description_type;
  NameList NL;
  boolean Goon;
  NameSubList NSubLst;

  vinit = STree_mkAtomNilTree ();
  if (TypeTestExternClass (t))
    {
      name = idfromstr (ExternTypeGetName (t));
      /**  ntrees description_type; 
	 description_type = nmakeunary(opexte, natomstring(opnil, nilstr));
	 SET_NILTREE(description_type); */
      description_type = STree_mkUndefinedExternalValue ();
      (*vtype) = mkDclType (name, description_type, vinit);
      return pk_true;
    }
  if (TypeTestEnumerationClass (t))
    {

      name = idfromstr (EnumerationTypeGetName (t));
      description_type = LL_make_tenum_emptylist ();
      NL = EnumerationTypeGetNameLst (t);
      NSubLst = NameListCast2SubList (NL);
      Goon = pk_true;
      while (Goon)
	{
	  description_type = ntreeList_appendLast (description_type, idfromstr (NameSubListGetHead (NSubLst)));
	  if (NameSubListTestLast (NSubLst))
	    Goon = pk_false;
	  else
	    NSubLst = NameSubListGetTail (NSubLst);
	}
      (*vtype) = mkDclType (name, description_type, vinit);
      return pk_true;
    }

  if (TypeTestMetaClass (t))
    {
      (*vtype) = mkDclType (idfromstr (MetaTypeGetName (t)), NILTREE, NILTREE);
      return pk_true;
    }

  if (TypeTestNamedClass (t))
    {
      (*vtype) = mkDclType (idfromstr (NamedTypeGetName (t)), TypeType2ntrees (NamedTypeGetTerm (t)), NILTREE);
      return pk_true;
    }
  return pk_false;

  /** 
    if (TypeTestSubrangeClass ( t )) return STree_mkNOTIMPLEMENTED();
    if (TypeTestBitsClass ( t )) return STree_mkNOTIMPLEMENTED();
    if (TypeTestLambdaClass ( t ))  return STree_mkNOTIMPLEMENTED();
    if (TypeTestNodeClass ( t ))  return STree_mkNOTIMPLEMENTED();
    if (TypeTestGenericNodeClass ( t ))  return STree_mkNOTIMPLEMENTED();
    if (TypeTestMetaNodeClass ( t )) return STree_mkNOTIMPLEMENTED();
    if (TypeTestMatrixClass ( t ))  return STree_mkNOTIMPLEMENTED();;
    if (TypeTestTupleClass ( t ))  return STree_mkNOTIMPLEMENTED();

  */
}


/**  @return the Abstract tree Signal representation of a type (t).*/
ntrees HierarchyTravelModel::TypeType2ntrees (TypeType t)
{
  ntrees
    treeTypeBase;

  t = Event2BooleanConversion (t, graph_type);
  if (TypeTestPredef (t))
    return STree_mkNullaryTree (predefTypeType2SignalType (t));
  if (TypeTestArrayClass (t))
    {
      treeTypeBase = TypeType2ntrees (ArrayMatrixTypeGetTerm (t));
      return nmakebinary (optvect, ptexpcal2ntrees (ArrayMatrixTypeGetDimLst (t)), treeTypeBase);
    }
  if (TypeTestExternClass (t))
    return idfromstr (ExternTypeGetName (t));
  if (TypeTestEnumerationClass (t))
    return idfromstr (EnumerationTypeGetName (t));
  if (TypeTestMetaClass (t))
    return idfromstr (MetaTypeGetName (t));
  if (TypeTestStructureClass (t))
    return TypeTypeStructure2ntrees (t);
  if (TypeTestBundleClass (t))
    return TypeTypeBundle2ntrees (t);
  if (TypeTestNamedClass (t))
    return idfromstr (NamedTypeGetName (t));

  if (TypeTestSubrangeClass (t))
    return STree_mkNOTIMPLEMENTED ();
  if (TypeTestBitsClass (t))
    return STree_mkNOTIMPLEMENTED ();
  if (TypeTestLambdaClass (t))
    return STree_mkNOTIMPLEMENTED ();
  if (TypeTestNodeClass (t))
    return STree_mkNOTIMPLEMENTED ();
  if (TypeTestGenericNodeClass (t))
    return STree_mkNOTIMPLEMENTED ();
  if (TypeTestMetaNodeClass (t))
    return STree_mkNOTIMPLEMENTED ();
  if (TypeTestMatrixClass (t))
    return STree_mkNOTIMPLEMENTED ();;
  if (TypeTestTupleClass (t))
    return STree_mkNOTIMPLEMENTED ();

  return STree_mkNullaryTree (opimplicit);
}

/**  @return the Abstract tree Signal representation of an expression (vexp).*/
ntrees HierarchyTravelModel::ptexpcal2ntrees (ptexpcal vexp)
{
  ptident
    id;
  noperators
    operateur;
  ptexpcal
    vexpcal1,
    vexpcal2,
    vexpcal3,
    nexp;
  ptinsth
    h;
  ntrees
    vt,
    t1,
    tclk;
  TypeType
    TT;

  if (vexp == NILEXPCAL)
    return NILTREE;

  if (EM->getIndirection (vexp, &nexp))
    vexp = nexp;		// A virer mais urgence

  switch ((int) (EM->getOperatorClass (vexp)))
    {
    case variabl:
      return STree_copy (EM->getName (vexp), pk_false);

    case constant:
      operateur = EM->getOperator (vexp);
      if (operateur == opcstenum)
	operateur = opnom;
      return natomstring (operateur, EM->getConstant (vexp));

    case oper1:
    case oper1tp:
      operateur = EM->getOperator (vexp);
      vexpcal1 = EM->getUnaryArg (vexp);
      /**  operateurs de conversion(DC+) */
      if (operateur == DCplusopconvIF)
	return nmakebinary (opconv, natomstring (opreal, nilstr), ptexpcal2ntrees (vexpcal1));
      if ((operateur == DCplusopconvID) || (operateur == DCplusopconvFD))
	return nmakebinary (opconv, natomstring (opdpreal, nilstr), ptexpcal2ntrees (vexpcal1));
      return nmakeunary (operateur, ptexpcal2ntrees (vexpcal1));

    case oper2:
    case oper2tp:
      operateur = EM->getOperator (vexp);
      if (LL_is_listOp (operateur))
	{ /**  liste */
	  vt = nmakemptylist (operateur);
	  while (vexp != NILEXPCAL)
	    vt = ntreeList_appendLast (vt, ptexpcal2ntrees (EM->getNaryArgs (&vexp)));
	  return vt;
	}
      vexpcal2 = EM->getBinaryArgstAt (vexp, 2);
      if (operateur == opvenum)
	if (EM->IsFreeType (vexp))
	  t1 = STree_mkAtomNilTree ();
	else
	  t1 = typeExp2ntrees (vexp);
      else
	t1 = ptexpcal2ntrees (EM->getBinaryArgstAt (vexp, 1));
      return nmakebinary (operateur, t1, ptexpcal2ntrees (vexpcal2));

    case oper3:
    case oper3tp:
      operateur = EM->getOperator (vexp);
      vexpcal1 = EM->getTernaryArgstAt (vexp, 1);
      vexpcal2 = EM->getTernaryArgstAt (vexp, 2);
      vexpcal3 = EM->getTernaryArgstAt (vexp, 3);
      if (operateur == opret)
	return mkTreeDelay (EM->getTernaryArgstAt (vexpcal1, 1), vexpcal2, vexpcal3, EM->getTernaryArgstAt (vexpcal1, 2), CKM->getUndefClock ());
      return nmaketernary (operateur, ptexpcal2ntrees (vexpcal1), ptexpcal2ntrees (vexpcal2), ptexpcal2ntrees (vexpcal3));

    case opereh:
      operateur = EM->getOperator (vexp);
      vexpcal1 = EM->getWhenOrCellArg (vexp);
      h = EM->getContributionClock (vexp);
      tclk = mkhonametree (h);
      if (operateur == opmemo)
	return nmaketernary (operateur, ptexpcal2ntrees (vexpcal1), tclk, NILTREE);
      if (graph_type == DCplus)
	{
	  noperators
	    op;
	  // if (vexpcal1 == NILEXPCAL) return NILTREE;
	  op = EM->getOperator (vexpcal1);
	  if (op == optrue)
	    return tclk;
	  if (op == opfalse)
	    return nmakeunary (opnon, tclk);
	}
      return nmakebinary (operateur, ptexpcal2ntrees (vexpcal1), tclk);

    case opertyp:
      TT = EM->getExpType (vexp);
      return TypeType2ntrees (TT);

    case call:
      EM->getFunctionCall (vexp, &id, &vexpcal2, &vexpcal1);
      if (existPragmaKeyword (EM->STree_getPragmas (vexp), string2repstr (PRAGMA_CONVERSION)))
	{
	  vt = STree_mkNullaryTree (predefTypeType2SignalType (identType2predefinedType (id)));	// Type predefini
	  return nmakebinary (opconv, vt, mkListIdentCall (vexpcal1, 2));
	}
      return mkRightPartCallTree (id, vexpcal2, vexpcal1);

    default:
      pK_messenger->Caseerror (currentLine, currentFile);
    }
  return NILTREE;
}


/** 
    @return the Signal Tree Abstraction representation of a formula of the clock calculus.
    @parameter vform (in): the formula to translate.
    @parameter signame (in): Used when the formula is a free variable. 
    In this case, if signame is defined,  it is used to defined the formula ( <identifier of vform>:= ^ signame), otherwise (signame is undefined)
    the returned tree is <identifier of vform>:= ^ <identifier of vform>.
    @parameter isaextract (out): set to pk_true when vform is an extraction.
*/
ntrees HierarchyTravelModel::formula2ntrees (ptinsth vform, ntrees signame, boolean * isaextract)
{
  ptexpcal
    aSig;
  ntrees
    vt,
    vtlni,
    vname;


  if (graph_type != DCplus)
    {
      if (CKM->satisfiesTickClock (vform))
	return Tick2Tree (vform);
      *isaextract = pk_true;
      return NILTREE;
    }
  if (CKM->isClockUnifiedWithSignal (vform, &aSig))
    if (ptlinstances_isin_exp (inputs, aSig))
      return NILTREE;

  *isaextract = pk_false;
  if (CKM->satisfiesNullClock (vform))
    return nmakebinary (opextr, STree_mkNullaryTree (optrue), STree_mkNullaryTree (opfalse));
  vname = mkhonametree (vform);
  if (!mkClockExpression (vform, isaextract, &vt))
    {
      if (IS_NILTREE (signame))
	signame = STree_copy (vname, pk_false);
      vt = nmakeunary (opevnt, signame);
    }
  return nmakebinary (opdefsig, STree_copy (vname, pk_false), vt);
}

<TYPE > DCG2SignalTree::inputsTravelling (ptinsth vh, ...)
{
  ptlinstances
    lsig;
  ptlinsth
    lhorl;

  // Getting the list of input signals assigned to hierarchy with vh as root.
  lsig = ptinterface_get_inputSignals (CKM->getInterfaceSubHierarchy (vh));
  //You can use ptlinstances_get_next()


  // Getting the list of input clocks assigned to the hierarchy with vh as root.
  lhorl = ptinterface_get_inputClocks (CKM->getInterfaceSubHierarchy (vh));
...}


<TYPE > DCG2SignalTree::parametersTravelling (ptinsth vh, ...)
{
  ptlinstances
    lsig;

  // Getting the list of parameters assigned to the hierarchy with vh as root.
  lsig = ptinterface_get_parameters (CKM->getInterfaceSubHierarchy (vh));
  // Travelling a ptlinstances list see \ref {xxx}
}

///
_VIRTUAL_ < TYPE > DCG2SignalTree::HierarchyInterface (ptinsth CurrentClock, ...)
{
  // if (CKM->satisfiesFictitiousRoot(CurrentClock))
  parametersTravelling (CurrentClock);
  inputsTravelling (CurrentClock);
  outputsTravelling (CurrentClock);
}

/** Travelling a hierarchy by a top-down left-right travel. */
<TYPE > DCG2SignalTree::HierachyTravelling (ptinsth CurrentClock, ...)
{
  ptlinsth
    lchild;
  ptinsth
    vh;

  // Interface assigned to the sub-hierarchy with CurrentClock as root.
  HierarchyInterface (CurrentClock, ...);
  // Getting the sub-graph assigned to the clock, and appliing operation.
  DataFlowGraphTravelling (CKM->getClockSubGraph (CurrentClock));
  // Recursively, for each child the method is applied.
  lchild = CKM->getChildren (CurrentClock);
  while (ptlinsth_get_next (&lchild, &vh))
    HierachyTravelling (vh);
}
