
/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef __COMMON_DCG_AUTOMATON__
#define __COMMON_DCG_AUTOMATON__
class Common_DCG_Automaton
{
#include "Common_DCG_Automaton_g.h"

 protected:
  ptident vname; ///<   Name of the process represented by this graph.
  ptNameManager aNameManager;   ///< name manager
  ptClockManager aClockManager; ///< Clock manager
  ptExprManager aExprManager;   ///< Expression manager
  ptNodeManager aNodeManager;   ///< Node manager
  ptTraceabilityManager aTraceabilityManager;   ///< Traceability manager
  ptlinstances lstatesvar;
  ptlDCG locGraphs;   ///< List of local graphs (a module) or list of States (an automaton).

};

#endif // __COMMON_DCG_AUTOMATON__
