/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

// Predefined Attributes 

/* Attributes of the compiler which are kept after calculus */
#define TRAVELATTRIBUTE -1
#define TRAVELATTRIBUTESUBTREE -2
#define CLOSUREATTRIBUTE -3
#define AGGREGATTRIBUTE -4
#define substituteGenCodeMark -5
#define GencodeMark -6
#define attrClusterName -7
#define ARRAY_ORDER -8
#define FIELD_SIGNAL -9
#define FIELDSLIST -10
#define PART_DEFINITION -11
#define PART_DEFAULT_DEFINITION -12
#define UTILITYCLOCK -13
#define CLKSIGUNIFICATION -14
#define DONTDECLARE -15
#define EXTERN_LANGUAGE_IMPL -16
#define SUBSTITUABLE_CLOCK -17
#define LinkToArrayIndexAttribute -18
#define ORDERINFO -19
#define AccessToArrayElement -20  /* x[...] */

#define pKbool2eventMark -21

#define DontOptimize -22
#define InitArrayMark -23

#define INTRINSIC -24

#define PREVIOUSVALUEATTR -25
#define CLK_REPRESENTED_BY -26

/* Spatial managing attributes
   --------------------------- */
///< OPTIMIZED_ATTRIBUTE: used to tag array whose all elements are defined by the same expression.
#define OPTIMIZED_ATTRIBUTE -27
///< CONSTANT_ATTRIBUTE: used to tag array whose all elements are constant (not necessary equal).
#define CONSTANT_ATTRIBUTE -28
///< OPTIMIZED_INDEX: tag the indexes defined by a arithmetic progression.
#define OPTIMIZED_INDEX_LIST -29
///< POSSIBLY_INDEX: tag used to specify that a signal can be used as an index. 
#define POSSIBLY_INDEX -30

// -------------- iterate node: x, x[i], x[i,..] are cloned signals, XXX is the CLONE_CLASS_HEAD.
#define CLONE_ATTRIBUTE -31
#define CLONE_CLASS_HEAD -32

// Optimising : zx := x $1, if zx and x are merged, x belongs a memory. 
// X marked BELONG_MEMORY and zx is attributed by OPTIMIZED_MEMORY_ATTRIBUTE
#define BELONG_MEMORY -33
#define OPTIMIZED_MEMORY_ATTRIBUTE -34

#define NO_NAME_FOR_OBJ -35
#define EXCLUSIVE_CLOCKS -36

// Sub-graph to graph extraction.
#define USED_MARK_EXTRACTION -37
// Sub-graph to graph extraction: link the new graph to the original one.
#define EXTRACTED_FROM -38

// Used to add a suffix for the name of the graph.
#define ATTRIBUTE_SUFFIX -39

// Managing of the nodes not localized for a partitionning.
#define RUNON_NODES_NOT_LOCALIZED -40

#define AUXILIARY_IDENT -41

// Assignment clock.
#define ASSIGNMENTCLOCK -42

#define UTILITYCLOCKINSUBGRAPH -43
#define ASSIGNMENTCLOCKPART -44
#define DEFAULCONSTANTVALUE -45

// Sharing signals between several graphs.
#define SHARED_BY_SEVERAL_GRAPHS -46
#define DONT_CHANGE_TYPE -47

#define POLYENDO_RDV -48

#define UNDEFINED_MARK -999
