/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
   @return "true" if the graph is not a graph of a module and it is endochronous, "false" otherwise.
 */
boolean /*DCG::*/isEndochronous( void );

/**
   It unmarks the objects of the graph (objects of the clock manager, the node manager and the expressions manager) 
   marked by m.
 */
void /*DCG::*/unmarkObjects( typeMark m );

/** 
    @return the clocks of lh  + the clocks assigned to the dependences (lclos). 
 */
ptlinsth /*DCG::*/getDependencesClocks( ptlclosure lclos ,ptlinsth lh );

/** @return the list of clocks assigned to the i/o dependences.
    \warning : it assumes that the closure calculus has been applied.
 */
ptlinsth /*DCG::*/getIODependencesClocks( void );

/**
   @return "true" if the list of the graphs (lg) referenced in the current graph, at one level only, 
   is not empty, "false" otherwise.
 */
boolean /*DCG::*/getReferencedGraphs( ptlDCG* lg );

/**
   @return the safety property of the graph (safe, unsafe, deterministic).
   See the reference manual for the definitions.
 */
safetyPropertyType /*DCG::*/getSafetyProperty( void );

/**
   Spatial processing.

   For x := f ( y[?] ), the expression y[?] specifies the value of y at the previous iteration.
   The "iteration precedence" x -> y has been assigned to the node during the production of the graph.
   This method tests that the dependence x -> y does not introduce circuit in the graph. 
   In this case:
   - an auxillary signals yy is created and defined by yy := y[?],
   - then y[?] is replaced by yy in other expressions,
   - some dependences are added : yy -> y.

   @return "true" if the graph is modified, "false" otherwise.
 */
boolean /*DCG::*/iterationPrecedences( void );

/**
   It synthesis the set of indices referenced in the equations and the partial definitions.
 */
void /*DCG::*/spatialIndicesSynthesis( void );

/**
   For each node (equation, partial definition) of ln, 
   it synthesis the set of indices referenced in the node.
 */
void /*DCG::*/spatialIndicesSynthesis( ptlINode ln );

/**
   It substitutes each expression such that x[vce] by x, when vce is an indice, x is a enumerator) 
   and x is marked previously by OPTIMIZED_ATTRIBUTE (see arithmeticalProgressionOptimizing(), sameDefinitionExpressionOptimizing))
   and x and vce are equivalent.\n
   Example : I:= 0..5, I[k] with k an index defined form 0 to 5, can be replaced by I.
   @return "true" is some substitutions have been applied, "false" otherwise.
 */
boolean /*DCG::*/spatialSubstitutions( void );

/**
   It applies some optimisations on spatial processing.
   @return "true" if some optimisations have been applied, "false" otherwise.
 */
boolean /*DCG::*/spatialOptimisations( void );

/**
   It marks the set of identifiers that are definitions of indices.
   It uses the predefined mark : POSSIBLY_INDEX.
 */
void /*DCG::*/indexDefinitionsOptimizing( void );

/**
   Signals defined by the same syntactic expression (taking account value of  expression) are marked.
   Restriction : only equations (X:=E) are considered.
   It uses the predefined mark : OPTIMIZED_ATTRIBUTE.
 */
boolean /*DCG::*/sameDefinitionExpressionOptimizing( void );

/**
   Indices defined by an arithmetical progression are marked.
   It uses the predefined mark: OPTIMIZED_ATTRIBUTE.
 */
boolean /*DCG::*/arithmeticalProgressionOptimizing( void );

/**
   It unifies the constants defined by the same syntactic expression.
 */
boolean /*DCG::*/ConstantsUnifying( void );

/**
   It eliminates the expressions "when e", for e an event.
   when e becomes e, when not e becomes the null clock.
 */
boolean /*DCG::*/eliminateWhenEvent( void );

/** 
    Removing, for the current graph, the signals without definitions. 
 */
void /*DCG::*/removeUndefinedSignals( void );

/**
   It rebuilts the interface of all the nodes of the graph.
   The clock hierarchy is not considered.
 */
void /*DCG::*/NodesInterfaceCalculus( void );

/** 
    Delay Rewriting: It applies the reductions defined in delaysRewriting1() and delaysRewriting2() methods.
    @return "true" if the graph is modified, "false" otherwise.
 */
boolean /*DCG::*/delaysRewriting( void );

/**
   It substitutes the evaluated expressions by their values.
   It calls 
   - ExprManager::substituteEvaluatedExpression() followed by
   - ExprManager::EM->rewritingExprEH, then 
   - updatePragmas() to update the objects assigned to the pragmas.
 */
void /*DCG::*/substituteEvaluatedExpression( void );

/** It cleans the structures used to build the interface of the graph (ie each node of the clock hierarchy).
    \see buildClockProcessInterfaceOneLevel 
 */
void /*DCG::*/interfaceReset( void );

/**
   It imports the result of the transitive closure into the graph.
   Informations stored in specific structures are translated into dependences.
   \see computeIOTransitiveClosure
 */
void /*DCG::*/importTransitiveClosure( void );

/**
   It sets the clocks that may be substitutable in the graph.
   \see setSubstitutable()
 */
void /*DCG::*/setSubstituableClocks( void );

/**
   Builts and stores the lists of external procedures and functions.
   They are respectively stored in list_extern_proc and list_extern_funcs attributes.
   \see setExternalReferencesUsingMark, setListExternalProc, getListExternalProcedure.
 */
void /*DCG::*/setExternalReferences( void );

/**
   @return the clock system as a sub-graph node.
 */
ptINode /*DCG::*/encapsulatingClockSystem( void );

/**
   Storing informations about the null clock (universal object) for the current graph.
   It assigns
   - the list of  the signals of the graph at null clock to \b lSigNullClock attribute,
   - the list of clocks (set of formula) not proved equivalent to null clock, to \b lConstraintsNullClock attribute.

   \see getNullClockSignal, getNullClockConstraints
 */
void /*DCG::*/storeNullClockInfo( void );

/** 
    It builds the list of the nodes of the current graph that are at the initial clock.
    To get this list use the getNodesAtInitClock() method.
 */
void /*DCG::*/storeInitClockInfo( void );

/** 
    Unmarks the current graph, marked by m, and recursively the graphs it references.
    All objects of the managers are visited (clocks, nodes, expressions).
 */
void /*DCG::*/resetMark( int m );

/**
   This method is used for completing the clock hierarchy to build an endochronous program.
   It adds:
   - an input boolean (name \b b based on \b id) synchronized to the clock clk,
   - the constraint vh ^= when \b b

   @return the created boolean signal.
 */
ptexpcal /*DCG::*/addBooleanInput( ptinsth vh ,ptinsth clk ,ptident id );

/**
   This method is used for completing the clock hierarchy to build an endochronous program.
   It adds a node call idClk := _PRESENT_id() at the clk clock.
   - an input boolean (name \b b based on \b id) synchronized to the clock clk,
   - the constraint vh ^= when \b b

   @return the created boolean signal.
 */
ptexpcal /*DCG::*/addPresentNode( ptinsth vh ,ptinsth clk ,ptexpcal vsig );

/**
   It updates the objects associated with the pragmas.
   Only signal identifiers are kept.
 */
void /*DCG::*/updatePragmas( void );

/**
   Removing nodes (ln) and clocks (lh) from the graph.
 */
void /*DCG::*/removeNodes( ptlINode ln ,ptlinsth lh );

/** Removing a node.  */
void /*DCG::*/removeNode( ptINode node );

/**
   The implicit conversions defined in the Signal Manual reference are explicited.
 */
void /*DCG::*/explicitConversions( void );

/**
   Garbaging types.
   Not implemented.
 */
void /*DCG::*/garbageTypes( void );

/** 
    Misc.
    
    Masking outputs of the graph. Outputs becomes local signals.
 */
void /*DCG::*/maskOutputs( void );

/** 
    @return true if it exists non predefined types (returned in lTypes) for the current object(DCG, Automaton), 
    false otherwise.
 */
boolean /*DCG::*/getUserTypesOneLevel( ptlinstances* lTypes );

/** 
    This method can be applied to a graph of a module (set of processes) or a process.
    \copydoc checkExplicitTypingOneLevel
 */
boolean /*DCG::*/checkExplicitTyping( void );

/**
   \copydoc setArrayClocksOneLevel
 */
boolean /*DCG::*/setArrayClocks( void );

/** 
    This  method can be applied to a graph of a module (set of processes) or a process.
    \copydoc splitDataStructureOneLevel
 */
boolean /*DCG::*/splitDataStructure( void );

/** 
    This  method can be applied to a graph of a module (set of processes) or a process.
    \copydoc setClockDependencesOneLevel
 */
boolean /*DCG::*/setComposedNodesDependences( void );

/** 
    This  method can be applied to a graph of a module (set of processes) or a process.
    \copydoc setClockDependencesOneLevel
 */
boolean /*DCG::*/setClockDependences( void );

/** 
    This  method can be applied to a graph of a module (set of processes) or a process.
    It detects cycles in all the graphs of the application.
    When bKeepCycles is "true", the cycles are kept in the graph sructures.
    \copydoc hasStaticCycleOneLevel
    \See getCycles(), getPseudoCycles()
 */
boolean /*DCG::*/isStaticCycleFree( boolean bmess ,boolean bKeepCycles );

/**
   @return the list of the nodes of the graph tagged with the pragma code (pragmaName).
 */
ptlINode /*DCG::*/getTaggedNodes( int pragmaName );

/**
   It finalyzes a binary partitionning functionality. 
   @param lSubGraphs (in) the result of the operation, composed of two subgraphs.
   @param part1 (out): the selected part.
   @param part2 (out): the other part.
   
   The nodes of the subgraphs are unlinked from their clock in the graph. The nodes are accessible by the subgraph.
 */
void /*DCG::*/finalyzeBinPart( ptlINode lSubGraphs ,ptINode* part1 ,ptINode* part2 );

/**
   The signals of the operand list (ls) are marked by the reserved mark DontOptimize.
 */
void /*DCG::*/DontOptimizeSignals( ptlinstances ls );

/**
   It merges the equations defined by the same function call: (| x:=f(E) | y := f(E) |) and f a function is rewritten (| x:=f(E) | y := x |).
   @return "true" if the graph is modified, "false" otherwise.
   
   It calls functionUnification(ptlINode) with the list of procedure call nodes, and the list of node call node.
 */
boolean /*DCG::*/functionUnification( void );

/** 
    It unifies the nodes defined by the same expression except for the renamings (see removeSignalEqualitiesOneLevel()) :
    If it exists a set of nodes Ni (i > 1)defined such that Xi := E, then one node is choosen 
    to be the representative element.
    @return "true" if some nodes have been selected, "false" otherwise.
 */
boolean /*DCG::*/nodesUnification( void );

/** 
    It marks nodes X:=E (E is not a delay expression) for which X is not referenced more than maxRef 
    time in the  graph.
    The node marked by the predefined mark \b DontOptimize are not considered.
    @return "true" if some node are selected, "false" otherwise.
 */
boolean /*DCG::*/markReferencedMaxTime( typeMark mark ,int maxRef ,boolean applyToClock );

/** 
    For n a node  of ln, if n is marked by mark, it is removed from the graph, otherwise
    the dependences (n -> m) with m marked by mark are removed.
 */
void /*DCG::*/cleaningNodes( ptlINode ln ,typeMark mark );

/** 
    For h a clock of lh, not marked by mark: 
    - the reference to h in a formula k, marked by mark, is removed, 
    - the nodes assigned to h marked by mark are removed. 
 */
void /*DCG::*/cleaningClocks( ptlinsth lh ,typeMark mark );

/**
   Cleaning the objects marked by mark or referencing objects marked by mark.
   \see cleaningNodes, cleaningClocks
 */
void /*DCG::*/removeMarkedNodes( typeMark mark );

/**
   @return "true" two constants are unified, "false" otherwise.
   For c a constant, element of the list lform,
   if c and aConst are defined by the same syntatic expression, c and aConst are unified (keeping aConst), in  this case
   c is then added to the list completelist (in/out  parameter).
 */
boolean /*DCG::*/UnifyConstant( ptexpcal aConst ,ptlinstances lfrom ,ptlinstances* completelist );

/**
   For an equation x:= E, marked with a mark (mark), x is replaced by E in the graph 
   and the equation is removed from the graph.
 */
void /*DCG::*/substituteMarkedVariables( typeMark mark );

/** 
    It unifies the nodes {N1,....,Nn} equivalent (defined by the same syntactic expression)
    to a node (node parameter) marked by mark keeping node. {N1,....,Nn} are removed from the graph.
 */
void /*DCG::*/unifyEquivalentTo( ptINode node );

/**
   @return "true" if a node (selectedNode, Xi:=E) is selected in the operand list (ln). Xi becomes the 
   representative signal of a set of signals {X1,...,Xn} such that nodes X1:= E, .... Xn:= E (n>1)
   "false" otherwise.
   The priority is given to an output signal, and the expression E can be a delay expression.
 */
boolean /*DCG::*/selectNodeForUnification( ptlINode ln ,ptINode* selectedNode );

/** 
    It marks nodes defined by x := y where y is a signal and x is not an output.
    The node marked by the predefined mark \b DontOptimize are not considered.
    @return "true" if some nodes are selected, "false" otherwise.
 */
boolean /*DCG::*/markRenamming( typeMark mark );

/** 
    Marking by the operand mark (mark) of the scalar constant signal for substitution .
    @return "true" if it exists such signals, "false" otherwise.
 */
boolean /*DCG::*/markScalarConstantSignal( typeMark mark );

/**
   Assumed : The operator of the node argument is "opdefsig" (equation, not partial, not a delay).
   @return 
   - "true" if a node (node) is now defined by a constant,
   - "false" otherwise.
 */
boolean /*DCG::*/makeConstantDefsig( ptINode node );

/**
   It defines the constant signals of the program.
   For each equation (not partial, not delay), it calls makeConstantDefsig().
 */
boolean /*DCG::*/makeConstantSignals( void );

/**
   Adding boolean signal X defined by X:=E, for E used in "when/cell E" and E is not reduced to a signal.
   When keepCondIO is pk_true, boolean expression build on input/outputs signals are not considered.
   When keepLogicalOperators is pk_true, boolean expression build on {or, and, not} are not considered.
   @return "true" if some signals are added, "false" otherwise.
 */
boolean /*DCG::*/undersamplingOnSignal( boolean keepCondIO ,boolean keepLogicalOperators );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
ptlinstances /*DCG::*/getSignalsRefinClocks( ptlinsth lh ,ptlinstances lsig );

/**
   It selects, using the mark m, the equations X := E , where type(X) is boolean and E is build on a boolean operator (or, and, not).
   The selected signals are removed from the operand list (lsig). The resulting list is returned.
 */
virtual ptlinstances /*DCG::*/booleanNodeSelecting( ptlinstances lsig ,typeMark m );

/**
   The useful signals become outputs of the graph.
 */
virtual void /*DCG::*/declareSignalsAsOutputs( ptlinstances lsig );

/**
   @return "true" if aSig is a declared I/O signal, "false" otherwise.
 */
boolean /*DCG::*/isIOSignal( ptexpcal aSig );

/**
   @return "true" if all the graph of lg are marked with mark value, "false" otherwise.
 */
boolean /*DCG::*/satisfiesMarkedGraphs( ptlDCG lg ,typeMark mark );

/** 
    Builts the lists of external proc/func. They are respectively stored in list_extern_proc and list_extern_funcs attributes.
    @param mark (in) temporary mark used to optimize the algorithm.
    \see setListExternalProc, getListExternalProcedure
 */
void /*DCG::*/setExternalReferencesUsingMark( typeMark mark );

/** 
    Update the link Signal/clock and node/clock of the current graph.
 */
void /*DCG::*/updateGraphClock( ptlinsth lh );

/** 
    Updates the references to clocks in the graph.
    (Recall: Clock calculus doesn't manage the graph!).
 */
void /*DCG::*/updateClocksGraph( void );

/**
   @return "true" if the graph contains assumptions, "false" oherwise.
 */
boolean /*DCG::*/existAssumptions( void );

/** 
    @return an extraction clock (undersampling by an expression) that represents a clock (clk) at another clock (hAt).
    If the clock hAt is the undefined clock, the clock clk is returned.
    
    The following order is used:
    - searching an equivalent
    - searching an equivalent placed above hAt (hAt is included in such a clock), then creating a when. 
    - Creating a signal defined by a left_tt that represent the clock to hAt.

    \note clk and hAT are assumed to be clocks such that the uper placed bound (in the hierarchy) is hAt.
 */
ptinsth /*DCG::*/mkBooleanClockScopeExtand( ptinsth clk ,ptinsth hAT );

/** 
    @return the name of the clock for DCGBool sub-format.
 */
ptident /*DCG::*/ChoiceNameBooleanClock( ptinsth clk );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*DCG::*/removeSignal( ptexpcal sig );

/**
   It completes the interface of a sub-graph (SubGraph) by computing the branching clock of all the clocks/clocks of the 
   nodes/clocks of the input/output signals of the sub-graph.
   It calls ClockManager::CompleteUpstreamParametrization().
 */
void /*DCG::*/upstreamProjectionSubGraph( ptINode SubGraph );

/** 
    Setting dependencies for code generators.
    It sets dependencies for complementary clock.
    @return none.
 */
void /*DCG::*/setsbDCplusDependencesForComplementaryClocks( void );

/**
   Check if all the signals have an explicit type.
   @return "true" if the signals have a explicit type, "false" otherwise.
 */
boolean /*DCG::*/checkExplicitTypingOneLevel( void );

/**
   Set the clocks of process arrays(see arrayClockUtl(), fixArrayClocks()).
   \ref GraphBuilder "For more details..."
 */
boolean /*DCG::*/setArrayClocksOneLevel( void );

/** 
    It splits the structured signals into a set of signals (one for each type of the structured type).

    \ref GraphBuilder "For more details..."
 */
void /*DCG::*/splitDataStructureOneLevel( void );

/**
   Setting dependencies for the current graph for composed nodes ( array, subgraph, nodecall, partial definition)
 */
void /*DCG::*/setComposedNodesDependencesOneLevel( void );

/**
   Setting dependencies for the current graph.
   Cross references between clocks/nodes.
 */
void /*DCG::*/setClockDependencesOneLevel( void );

/**
   It replaces the leftt() operator by a default.
 */
void /*DCG::*/lefttts2defaults( void );

/**
   @return the subgraph node of the hierarchy with rootclk as root.
 */
ptINode /*DCG::*/mkSubGraphTreeHierarchy( ptinsth rootclk );

/**
   It applies the NodeManager::rewDefinition(ptINode) method to the non dynamical equations.
   @return "true" if a node is rewritten, "false" otherwise.

   \todo: to be completed for the partial definitions.
 */
boolean /*DCG::*/rewDefinitions( void );

/**
   @return "true" if the verbose mode is set,"false" otherwise.
 */
boolean /*DCG::*/isVerboseMode( void );

/**
   @return the value of the verbose mode before calling this method.
   It sets the verbose mode to b.
 */
boolean /*DCG::*/setVerboseMode( boolean b );

/**
   It partitions the nodes of a subgraph by clocks.
 */
void /*DCG::*/nodeGroupingByClocks( ptINode aSubGraph );

/**
   Each (partial) definition x:=E becomes x::=E when hu(x) | x::=defaultvalue x$1 where hu(x) denotes the utility clock of x.
 */
boolean /*DCG::*/rewUsingProductiveClock( void );

/**
   Default/partial definition normalisation. 
   It applies, by construction H and K are exclusive so the default operator is commutative, the rules:
   - X:= (E when H) default (E when K) --> (E when H ^+ K)
   - X::= ((E when H) | X::= ((E when K) -->  X::= (E when H ^+ K)

   @return "true" if a definition is modified, "false" otherwise.
 */
boolean /*DCG::*/normalDefaults( void );

/**
   @return "true" if the graph is an endochronous with an internal root clock one, "false" otherwise (may be not computed).
   vhComplete : the "complete" clock (io clock, or the complete clock of a Signal thread,...)
 */
boolean /*DCG::*/isEndochronousWithInternalClockRoot( ptinsth* vhComplete );

/**
   NOT YET IMPLEMENTED (LBesnard).
   x := E  | y :=F  and x ^= y
   If we use the utility clock as the availibility clock, the signals must be desynchronized.
   MoreOver, it may introduce cycles!!!.
 */
boolean /*DCG::*/setUtilityClocksAsClock( void );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*DCG::*/markNodesFreeConditions( void );

/**
   It adds at the begining/at the end (depending on the value of the   b_inner parameter) of lStatesVar the boolean state variables assigned to a clock (vclk).
 */
void /*DCG::*/getDelayedSignalsAt( ptinsth vclk ,boolean b_inner ,ptlinstances* lStatesVar );

/**
   @return "true" if it exists a boolean state signal in the hierarchy with vclk as root, "false" otherwise.
   It selects (one of) the nearest signal of the root (vclk) of the hierarchy.
   b_inner used for the order on state variable, pk_true when the leafs have a hight priority.
 */
void /*DCG::*/mkListOfStatesVariables( ptinsth vclk ,boolean b_inner ,ptlinstances* lStatesVar );

/**
   @return the number assigned to the graph.
 */
integer /*DCG::*/getGraphNumber( void );

/**
   Suspend (when b is pk_true) or Resume (when b is pk_false) the setClocksName() action.
   @return the mode before the call.
  */
boolean /*DCG::*/getSetSuspendClockNameAction( boolean b );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*DCG::*/getIthRoot( integer n ,ptinsth* vr );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*DCG::*/isHierarchyWithNodes( ptinsth vh );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*DCG::*/getNextFreeRoot( ptinsth vh ,ptinsth* vr );

/**
   It adds a pragma (vpragma) to all the objects (clocks/nodes) of the hierarchy with vclk as root.
 */
void /*DCG::*/addPragmaToAllObjectsOfHierarchy( ptinsth vclk ,ptpragma vpragma );


