/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
   @return a DCG_poly object with all clocks solved for a DCG_basic graph (gbasic).
 */
static ptDCG_poly /*DCG_poly::*/DCG_basic2poly( ptDCG_basic gbasic );

/**
   @return a DCG_poly object with all clocks solved for a DCG_basic graph (gbasic).
   @param vd (in) depth of resolution for boolean reduction.
 */
static ptDCG_poly /*DCG_poly::*/DCG_basic2poly( ptDCG_basic gbasic ,int vd );

/**
   @return a DCG_poly object with all clocks solved for a DCG_basic graph (gbasic).
   @param vd (in) depth of resolution for boolean reduction.
 */
static ptDCG_poly /*DCG_poly::*/new_prePoly( ptDCG aDCG );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
/*DCG_poly::*/DCG_poly( void );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
/*DCG_poly::*/DCG_poly( ptDCG_basic gbasic );

/** 
    This  method can be applied to a graph of a module (set of processes) or a process.
    It realizes elementary optimizations by deleting objects of the graph which are 
    not used to produce (resp. consume) outputs (resp. inputs) of the program. 
 */
boolean /*DCG_poly::*/nonProductiveSignalElimination( void );

/** 
    This  method can be applied to a graph of a module (set of processes) or a process.
    For each graph of the application,

    \copydoc buildClockProcessInterfaceOneLevel
 */
boolean /*DCG_poly::*/buildClockProcessInterface( void );

/**
   This method is used for completing the clock hierarchy to have a endochronous program.
   It adds for all root clock of the system a node call (such that C_a :=_PRESENT_a()) with clk as clock.
   It adds induced constraints (ie a ^ when C_a).
   After each adding, the clock calculus is applied that may modify the set of roots.
   \see addBooleanInput, addPresentNode
 */
void /*DCG_poly::*/iterateNodeInputEndochronization( ptinsth clk ,boolean bAddinputs );

/** 
    It builds an abstract trees representation of the abstraction of the program:
    - I/O data dependences (assumed available, the I/O transitive closure has been computed)
    - I/O clock relations.

    This abstraction is useful for separated compiling
    @return the "black Box" or the "greyBox" abstraction representation of the current graph.
    \see{phylumClustering}
    \warning (\em restriction) This method can be applied to a graph of a process, not to a graph of a module.
 */
ntrees /*DCG_poly::*/produceInterfaceAbstraction( void );

/** 
    It builds an external representation of the exclusive clocks of the graph.
    It assumes that the functionality computeClockExclusions() has been already applied.
    @return the Signal abstract tree external representation of the exclusive clocks of the graph. 
    This tree can be printed using the \see{decsig} function.
 */
ntrees /*DCG_poly::*/produceExclusiveClocks( void );

/** 
    It performs the separating of booleans calculus and other calculus.

    @param booleans (out) denotes the sub-graph of booleans calculus.
    @param others (out) denotes the sub-graph of non-booleans calculus.

    \warning (\em restriction) This method can be applied to a graph of a process, not to a graph of a module.
 */
boolean /*DCG_poly::*/separateBooleansOthers( ptINode* booleans ,ptINode* others );

/** 
    It performs the separating of states nodes  and other nodes.
    @param states (out) denotes the sub-graph of state variables.
    @param others (out) denotes the sub-graph of static variables.

    \warning (\em restriction) This method can be applied to a graph of a process, not to a graph of a module.
 */
boolean /*DCG_poly::*/separateStatesOthers( ptINode* states ,ptINode* others );

/** 
    It performs the separating of boolean/integer nodes  and other nodes.
    @param BooleansIntegers (out) denotes the sub-graph of variables with boolean or int type.
    @param others (out) denotes the sub-graph of non-state variables.

    \warning (\em restriction) This method can be applied to a graph of a process, not to a graph of a module.
 */
boolean /*DCG_poly::*/separateBooleansIntegersOthers( ptINode* BooleansIntegers ,ptINode* others );

/** 
    It performs the separating of states nodes  and other nodes.
    @param finiteTypesSubGraph (out) denotes the sub-graph of variables with a finite type (booleans, integers and enumerated types).
    @param others (out) denotes the sub-graph of non-finite type variables.

    \warning (\em restriction) This method can be applied to a graph of a process, not to a graph of a module.
 */
boolean /*DCG_poly::*/separateFiniteTypesOthers( ptINode* finiteTypesSubGraph ,ptINode* others );

/** 
    It performs the separating of states nodes  and other nodes.
    @param selectedTypesSubGraph (out) denotes the sub-graph of variables with a finite type (booleans, integers and enumerated types).
    @param others (out) denotes the sub-graph of non-finite type variables.

    \warning (\em restriction) This method can be applied to a graph of a process, not to a graph of a module.
 */
boolean /*DCG_poly::*/separateSelectedTypesOthers( SelectedClassType clType ,ptINode* selectedTypesSubGraph ,ptINode* others );

/** 
    This  method can be applied to a graph of a module (set of processes) or a process.
    For each graph of the application, this method builds a set of "delay" trees.
    All the signals build on the same signal (X) using the delay/window operators
    can be represented as a tree (X as root) when initializations are compatible. 
    This delay-tree can be used for:

    - unifying signals ; for example, # (x $ 1 init 0) $1 init 0 # is equivalent to # x $ 2 init [0,0] #;
    - multiplexing of variables by code generators.

    @return "true" if the operation succeeds, "false" otherwise (cycle).

    \see{memoryOptimizations}
 */
boolean /*DCG_poly::*/delayTreeBuild( void );

/** 
    This  method can be applied to a graph of a module (set of processes) or a process.
    \copydoc setIntrinsicClocksOneLevel

    After, the \ref buildClockProcessInterface "Interface calculus" is also applied.
 */
boolean /*DCG_poly::*/setIntrinsicClocks( void );

/** 
    This method can be applied to a graph of a process or a module.
    \copydoc computeClockExclusionsOneLevel
 */
void /*DCG_poly::*/computeClockExclusions( int ecLevel );

/** 
    This  method can be applied to a graph of a module (set of processes) or a process.
    @param bstrong : at pk_true, the clock of the dependences are taken into account.
    \copydoc buildIOClockSubHierarchyOneLevel
 */
boolean /*DCG_poly::*/buildIOClockSubHierarchy( boolean bstrong );

/** 
    This  method can be applied to a graph of a module (set of processes) or a process.
    \copydoc setDelayMemoryOverloadingOneLevel
 */
boolean /*DCG_poly::*/setDelayMemoryOverloading( boolean bclu );

/** 
    This  method can be applied to a graph of a module (set of processes) or a process.
    \copydoc memoryOptimizationsOneLevel
 */
boolean /*DCG_poly::*/memoryOptimizations( boolean mutliplexDelays );

/** 
    This method can be applied to a graph of a module (set of processes) or a process.
    \copydoc computeIOTransitiveClosureOneLevel
 */
boolean /*DCG_poly::*/computeIOTransitiveClosure( void );

/** 
    @return a copy of the current graph (defined as a morphism).
    \warning (\e restriction) This method can be applied to a graph of a process, not to a graph of a module.
 */
ptDCG_poly /*DCG_poly::*/copy( void );

/** 
    This  method can be applied to a graph of a module (set of processes) or a process.
    \copydoc expressionExpandOneLevel
 */
boolean /*DCG_poly::*/expressionExpand( void );

/** 
    It prints informations on the clock hierarchy.
    See hierarchyStatistics().
 */
boolean /*DCG_poly::*/printCHStatistics( void );

/** 
    It calls ClockCalculus(int) with a default value for the depth of solving.
 */
boolean /*DCG_poly::*/ClockCalculus( void );

/** 
    This  method can be applied to a graph of a module (set of processes) or a process.
    It transforms a multi-root hierarchy of each process to a single root hierarchy (parametrization of the clock system).
    The processes become endochronous. The interface of the processes may be modified (some input booleans are added for the parametrization), in this 
    case the returned boolean (modified) is set to the value "true", otherwise it is set to the value "false".
    
    @return the value "true" if the operation is performed, "false" otherwise.
 */
boolean /*DCG_poly::*/parameterizeMasterClocks( boolean bAddinputs ,boolean* modified );

/**
   @return true if the DCG (for a module all the DCG) is endochronous, "false" otherwise.
 */
boolean /*DCG_poly::*/isEndochronous( void );

/** 
    This  method can be applied to a graph or a module.
    \copydoc dependenceReinforcingOneLevel
 */
boolean /*DCG_poly::*/dependenceReinforcing( void );

/**
   It produces the morphim of the current graph according to the definitions 
   assigned of the Signal operators given in the ht table. 
   When bSimul is "true", the current graph is modified (selected booleans become outputs).
  
   @return "true" if the operation succeeds, "false" otherwise.

   \ref MorphismDefinedInTable "For more details..."
 */
boolean /*DCG_poly::*/applyTabularMorphism( ptHomomorphismTable ht ,ptDCG_poly* gresult ,boolean bSimul );

/** 
    This  method can be applied to a graph or a module.
    \copydoc rewDefinitionsOneLevel()
 */
void /*DCG_poly::*/rewDefinitions( void );

/** 
    It computes the interface abstraction of the operand graph.
 */
void /*DCG_poly::*/buildInterfaceAbstraction( void );

/** 
    It performs the following partitionning (called input train or phylum Clustering) :
    <em>
    Two nodes are in the same set if and only if they depends on the same subset of inputs signals of the graph.
    </em> 
    The graph is modified. The nodes are clustered into sub-graphs.
    @return the value "false" if the operation failed, "true" otherwise.
    
    \warning 
    - (\e restriction) This method can be applied to a graph of a process, not to a graph of a module (set of processes).

    - The graph must be in DCGBool sub-format. --NO NO NO, it must be applied to a DCGPoly.
 */
boolean /*DCG_poly::*/phylumClustering( void );

/**
   \copydoc DCG_basic::undersamplingOnSignal
 */
boolean /*DCG_poly::*/undersamplingOnSignal( boolean bkeepCondIO ,boolean keepLogicalOperators );

/**
   Creates a container for the reduction of the communications of the input signals of the operand subgraph(aSubGraph).
   When bOnlyAssignmentClock, the reduction is applied using the assignment clock, otherwise the utility clock is also used.
   It is assumed that these clocks have been comptuded before the call to this method.
   \See {Container, Container.h}

 */
boolean /*DCG_poly::*/reduceComm( ptINode aSubGraph ,boolean bOnlyAssignmentClock );

/**
   It updates the dependences for the composed nodes (array, subgraph, bundle) then calls the clockcalculus in silent mode.
   \see {DCG_basic::setComposedNodesDependences(), ClockCalculus()}
 */
void /*DCG_poly::*/setComposedNodesDependences( void );

/**
   It builds a automaton by valuations of boolean state variables of the operand list (lSelectedStateVar).

   The resulting automaton is assigned to the graph, 1use getAutomaton() method to get it.

   Assumed: an element of l is a boolean state variable.
   Restriction: to the delays

 */
void /*DCG_poly::*/buildAutomaton( ptlinstances lSelectedStateVar );

/**
   It calls buildAutomaton(ptlinstances l) with l = {the boolean state variables of the graph}
 */
void /*DCG_poly::*/buildAutomaton( void );

/**
   It calls buildAutomaton(ptlinstances l) with l = {aStateVar}.
 */
void /*DCG_poly::*/buildAutomaton( ptexpcal aStateVar );

/**
   It must not be used (PRESENTLY IN TEST).
   \copydoc buildAbstractionOneLevel
   \todo buildAbstraction() must be finalized.
 */
boolean /*DCG_poly::*/buildAbstraction( ptDCG_poly* gResult );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
ptlinsth /*DCG_poly::*/getLocalMaxima( void );

/** 
    @return "true" if the graph is a polyEndochronous one, "false" otherwise.
    Tests: 
       - If the hierarchy = a set of tree without ^- operator as root and there are no constraints on theses roots.
       - If the constraints on placed clocks in different trees have free variables as root of their hierarchy.
       
       ! reqController is set to true when multi-roots with constrainst on placed clocks in different trees, false otherwise.
         It is undefined when the method returns false.
  */
boolean /*DCG_poly::*/isPolyEndoChronous( boolean* reqController );

/**
   Adding a "rendez-vous" for placed clocks not in the same hierarchy and declared as equal.

   Assumed: isPolyEndoChronous() has been called before this call.
  */
void /*DCG_poly::*/addRendezVousForPlacedConstraints( void );

/**
   It adds a rendez-vous for the constraints vh1 = vh2 where these clocks are 
   assumed to be placed and not in the same clock hierarchy.
    - For vh1 it adds the definitions, assigned to vh1: 
        (| (| n11 :: Send(rdv1) | n12::receive(rdv2) |) | n11 -> n12 | rdv1 ^= rdv2 ^= vh1 |)
        and for each node N assigned to vh1 (excluding the Send/receive) n12 -> N
    - For vh2 it adds the definitions, assigned to vh2:
        (| (| n21 :: Send(rdv2) | n22::receive(rdv1) |) | n21 -> n22 | rdv1 ^= rdv2  ^= vh2 |)
        and for each node N assigned to vh2 (excluding the Send/receive) n22 -> N
	
  */
void /*DCG_poly::*/addRendezVous( ptinsth vh1 ,ptinsth vh2 );


