
#define TRACE(s)

#define require_expr_manager_of(g, EM)  ptExprManager EM= g->getExpressionManager()
#define require_clock_manager_of(g, CKM) ptClockManager CKM=  g->getClockManager()
#define require_node_manager_of(g, NM) ptNodeManager NM =  g->getNodeManager()

#define require_expr_manager(EM)  require_expr_manager_of(this, EM)
#define require_clock_manager(CKM) require_clock_manager_of(this, CKM)
#define require_node_manager(NM) require_node_manager_of(this, NM)

/** It declares and defined the managers : 
    - EM : Expression manager, 
    - NM : node manager, 
    - CKM: clock manager
 */
#define require_managers(EM, NM, CKM) \
 require_expr_manager_of(this, EM);\
 require_clock_manager_of(this, CKM);\
 require_node_manager_of(this, NM);

/** Body associated with the macro "for_all_graphs_do_br" and "for_all_graphs_do" */
#define MACRO_BODY(thecode)\
myMark = getMark();\
lg = NILLDCG;\
  if (!getModuleGraphs(&lg)) ptlPointer_insert_elem(&lg,(pointer) getDCG()); \
while (ptlPointer_get_elemNext(&lg, &elem))\
{\
 g = (ptDCG) elem;\
   if (!g->satisfiesMarked(myMark))\
      {\
        g->addMark(myMark);\
        thecode ;\
        if (g->getReferencedGraphs(&lg1)) lg = ptlPointer_fusion(lg, lg1);\
      }\
   ptlPointer_remove_elem(&lg, elem);\
}\
resetMark(myMark);

/** It applies a method (methodName) to the graphs referenced in a graph. */
#define for_all_graphs_do(methodName)		\
  ptlDCG lg, lg1; \
  int myMark; \
  ptDCG g; \
  pointer elem; \
  MACRO_BODY(init(g); gw->methodName)

/** It applies a method (methodName) to the graphs referenced in a graph, and it returns a 
    status code (boolean). 
*/
#define for_all_graphs_do_br(methodName, breturn) \
  ptlDCG lg, lg1; \
  int myMark; \
  ptDCG g; \
  pointer elem; \
  boolean breturn; \
  breturn = pk_false; \
  MACRO_BODY(init(g); if (gw->methodName) breturn = pk_true)
