/* 
   Authors: Loïc Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#include "common_type.h"
#include "messignal_3.h"
#include "messignal_0.h"
#include "stringmemStr_type.h"
#include "typesSet1.h"
/* @End_import_type@ */
#include "atlist_g.h"
#include "stringmemStr_g.h"
#include "tree_api.h"
#include "markServer_g.h"
#include "atInodesList_g.h"
#include "atlinstances_g.h"
#include "atclocklist_g.h"
#include "atClosure_g.h"
#include "atinterfaceGet_g.h"
#include "atinterfaceSet_g.h"
#include "TraceabilityManager.h"
#include "ExprManager.h"
#include "ClockManagerExport.h"
#include "dependences.h"
#include "NodeManager.h"
#include "NameManager.h"
#include "ident_g.h"
#include "messenger.h"
#include "predefSignalNames_g.h"
#include "DCG.h"
#include "DCG_basic.h"
#include "booleans2events.h"
#include "assertions2events.h"
#include "Pruner.h"
#include "DCG2KernelTranslator.h"
#include "statesVariables.h"
#include "downstreamRetiming.h"
#include "AbstractHomomorphism.h"
#include "Duplicator.h"
#include "Inclusion.h"
#include "ProfileBuilder.h"
#include "CommManager.h"
#include "SubGraphExtract.h"
#include "RunOnMark.h"
#include "Colouring.h"
#include "ColouringGenCode.h"
#include "Pragmas_g.h"
#include "DCG2SignalTree.h"
#include "SignalPrinter.h"
#include "decsig_g.h"
#include "UtilityClock.h"
#include "AssignmentClock.h"
#include "Clusters.h"
#include "TrainClusters.h"
#include "separate_selected_others.h"
#include "typeSelection.h"
#include "mkStatesOther.h"
#include "mkBoolOther.h"
#include "mkSelectedOther.h"
#include "mkBooleanBoundedIntegerOther.h"
#include "mkFiniteTypesOther.h"
#include "HierarchyStatistics_g.h"
#include "eTypes.h"
#include "Closure.h"

/* @Begin_prog@ */
#include "DCG_access_basic_i.c"
#include "DCG_basic_m.c"
#include "DCG_basic_g.c"
