
_PUBLIC_ Automaton::Automaton (ptident id, ptlStates states, ptlTransitions lts, ptexpcal vCurrentState, ptident vLabInitState)
{
  init ();
  vname = id;
  States = states;
  CurrentStateVar = vCurrentState;
  initState = vLabInitState;
  Transitions = lts;
}

Automaton::Automaton ()
{
  init ();
}

Automaton::~Automaton ()
{
}

void
Automaton::setInitialState (ptident vlabInit)
{
  initState = vlabInit;
}


ptident
Automaton::getInitialState ()
{
  return initState;
}


void
Automaton::setCurrentStateVar (ptexpcal vsig)
{
  CurrentStateVar = vsig;
}

ptexpcal
Automaton::getCurrentStateVar ()
{
  return CurrentStateVar;
}

void
Automaton::addTransition (State sFrom, State sTo, ptinsth h)
{
  addTransition (new Transition (sFrom, sTo, h));
}

void
Automaton::addTransition (ptTransition vtransition)
{
  ptlPointer_insert_elem (&Transitions, (pointer) vtransition);
}

void
Automaton::addState (State aState)
{
  ptlPointer_insert_elem (&States, (pointer) aState);
}

void
Automaton::setTransitions (ptlPointer lts)
{
  Transitions = lts;
}

/**
   It removes a state (aState) and the associated transitions from/to this state.
*/
void
Automaton::rmState (State aState)
{
  ptTransition vtransition;
  ptlTransitions l;
  pointer velem;
  State s1, s2;
  ptinsth k;

  ptlPointer_remove_elem (&States, (pointer) aState);
  //removing the transitions from/to aState.
  l = Transitions;
  while (ptlPointer_get_elemNext (&l, &velem))
    {
      vtransition = (ptTransition) velem;
      vtransition->get (&s1, &s2, &k);
      if ((s1 == aState) || (s2 == aState))
	ptlPointer_remove_elem (&Transitions, velem);
    }
}

ptlStates
Automaton::getStates ()
{
  return States;
}

ptlTransitions
Automaton::getTransitions ()
{
  return Transitions;
}



ptinterface
Automaton::getInterface ()
{
  return Interface;
}


void
Automaton::setInterface (ptinterface vinter)
{
  Interface = vinter;
}

/** id becomes the name of the object. */
void
Automaton::setName (ptident id)
{
  Common_DCG_Automaton::setName (id);
}

/** @return the name of the graph, previously set by setName(). */
ptident Automaton::getName ()
{
  return Common_DCG_Automaton::getName ();
}

/** 
    @return the clock system manager of the graph.
*/
ptClockManager Automaton::getClockManager ()
{
  return Common_DCG_Automaton::getClockManager ();
}

/** @return the node manager of the graph.*/
ptNodeManager Automaton::getNodeManager ()
{
  return Common_DCG_Automaton::getNodeManager ();
}

/** @return the expresion manager of the graph.*/
ptExprManager Automaton::getExpressionManager ()
{
  return Common_DCG_Automaton::getExpressionManager ();
}

/** @return the name manager of the graph.*/
ptNameManager Automaton::getNameManager ()
{
  return aNameManager;
}


/** @return the traceability manager of the graph.*/
ptTraceabilityManager Automaton::getTraceabilityManager ()
{
  return Common_DCG_Automaton::getTraceabilityManager ();
}


/** @return the set of state variables of the program.*/
ptlinstances Automaton::getStatesVar ()
{
  return Common_DCG_Automaton::getStatesVar ();
}

/** l (in): set of state variables. */
void
Automaton::setStatesVar (ptlinstances l)
{
  Common_DCG_Automaton::setStatesVar (l);
}

/** It adds vsig in the set of state variables.*/
void
Automaton::addStatesVar (ptexpcal vsig)
{
  Common_DCG_Automaton::addStatesVar (vsig);
}

ptlpragmas Automaton::getPragmas (void)
{
  return ObjectCommonInfos::getPragmas ();
}

void
Automaton::setPragmas (ptlpragmas l)
{
  ObjectCommonInfos::setPragmas (l);
}

boolean Automaton::addPragma (ptpragma aPragma)
{
  return ObjectCommonInfos::addPragma (aPragma);
}

boolean Automaton::removePragma (ptrepstr name)
{
  return ObjectCommonInfos::removePragma (name);
}

void
Automaton::addPragmas (ptlpragmas pragmas)
{
  ObjectCommonInfos::addPragmas (pragmas);
}

void
Automaton::addMark (typeMark val)
{
  return ObjectCommonInfos::addMark (val);
}

boolean Automaton::satisfiesMarked (typeMark val)
{
  return ObjectCommonInfos::satisfiesMarked (val);
}

void
Automaton::removeMark (typeMark val)
{
  ObjectCommonInfos::removeMark (val);
}

boolean Automaton::getAttribute (int num, attributeValue * valAttribute)
{
  return ObjectCommonInfos::getAttribute (num, valAttribute);
}

void
Automaton::addAttribute (int num, attributeValue vattr)
{
  ObjectCommonInfos::addAttribute (num, vattr);
}

void
Automaton::removeAttribute (int num)
{
  ObjectCommonInfos::removeAttribute (num);
}
