/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PUBLIC_
/** 
    @return "true" if the translation of a DCGBool (gb) to a DCGSch (gs) succeeds, "false" otherwise.
*/
  _STATIC_ boolean DCG_sch::Ordering (ptDCG_bool gb, boolean btotally, boolean bcheck, ptDCG_sch * gs)
{
  if (!gb->DCG_bool::Ordering (btotally, bcheck)) return pk_false;
  *gs = new DCG_sch (gb);
  return pk_true;
}

DCG_sch::DCG_sch (ptDCG_bool gb):DCG_bool (gb)
{
  gb->setFormatLevel (DCG_SCH);
}

DCG_sch::DCG_sch ()
{
}


/**
   Nothing to do in this case.
*/
boolean DCG_sch::totallyOrder (boolean bCheck)
{
  return pk_true;
}

/**
   Setting ordering informations (DCGSch format).
   These informations are available after the \ref totallyOrder method. 
   @param nbsets (in) : the number of elements of the Table parameter;
   @param Table (in) : one entry by cluster and Table[0] contains a sequential scheduller.
   @param lnodeshinit (in) : set of nodes defining constant signals. They can be generated as initializations.
   @param lclocksnottobeinitiliazed (in) : set of clocks build on state variables. They must not to be intialized each step.
*/
void
DCG_sch::setDCGSchInfos (int nbsets, ptelemTableGenCode * Table, ptlINode lnodeshinit, ptlinstances lclocksnottobeinitiliazed)
{
  getDCG ()->setDCGSchInfos (nbsets, Table, lnodeshinit, lclocksnottobeinitiliazed);
}



/** 
    These informations are available after the \ref totallyOrder method. 
    @param nbsets (out) : the number of elements of the Table parameter;
    @param Table (out) : one entry by cluster and Table[0] contains a sequential scheduller.
    @param lnodeshinit (out) : set of nodes defining constant signals. They can be generated as initializations.
    @param lclocksnottobeinitiliazed (out) : set of clocks build on state variables. They must not to be intialized each step.
*/
void
DCG_sch::getDCGSchInfos (int *nbsets, ptelemTableGenCode ** Table, ptlINode * lnodeshinit, ptlinstances * lclocksnottobeinitiliazed)
{
  getDCG ()->getDCGSchInfos (nbsets, Table, lnodeshinit, lclocksnottobeinitiliazed);
}
