/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
/**
   @return the operand list (l_case) in with a new element of a CASE expression, is added at the end.
   This element is characterized by a selector (val) and an expression of definition (v_expr).
*/
extern ptlcase
kl_ptlcase_add (ptlcase l_case, ptklExprSig val, ptklExprProc v_expr)
{
  ptlcase res, vcase;

  if (v_expr == NILEXPFIL)
    return l_case;
  vcase = new lcase ();
  vcase->next = NILLCASE;
  vcase->val = val;
  vcase->expr = v_expr;
  if (l_case == NILLCASE)
    return vcase;
  res = l_case;
  while (l_case->next != NILLCASE)
    l_case = l_case->next;
  l_case->next = vcase;
  return res;
}


/**
   @return
   - "true" if a the list (l_case) in not empty, 
   then it returns
          - the case-selector (val), 
	  - the case-expression (vexpr) 
	  - the next element of the list (l_case)
	  .
   - "false" otherwise.
*/
extern boolean
kl_ptlcase_get_next (ptlcase * l_case, ptklExprSig * val, ptklExprProc * vexpr)
{
  ptlcase vcase;

  vcase = *l_case;
  if ((vcase) == NILLCASE)
    return pk_false;
  *val = vcase->val;
  *vexpr = vcase->expr;
  *l_case = vcase->next;
  return pk_true;
}
