/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PUBLIC_
/** Constructor.
 */
    elemHashTable::elemHashTable(ptident vident)
{
  val = NILPOINTER;
  next = NILELEMHASHTABLE;
  id = vident;
}

/** Destructor. 
*/
elemHashTable::~elemHashTable()
{
}

/**  
   @return the identifier assigned to the current element.*/
ptident elemHashTable::getId()
{
  return id;
}

/**  
   @return the next element of the current object. */
ptelemHashTable elemHashTable::getnext()
{
  return next;
}

/**  
   @return the external reference (stack for example) assigned to the current object.
*/
pointer elemHashTable::getExternalRef()
{
  return val;
}

/**  
   It assigns vid as the identifier of the current object.
*/
void elemHashTable::setId(ptident vid)
{
  id = vid;
}

/**  
  Adding n as the next element of the current object. */
void elemHashTable::setNext(ptelemHashTable n)
{
  next = n;
}

/**  
   It assigns p as the external reference (stack for example) to the current object.
*/
void elemHashTable::setExternalRef(pointer p)
{
  val = p;
}
