/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#include <map>

#define StrNilProc  "Nil_Process"
#define cstrhorl    "CLK"
#define cstrhupb    "TICK"
#define cstnull     "NULL"
#define cstralpha   "ALPHA"

#define cstinenv  "~inputenv"
#define cstoutenv  "~outputenv"

#define cstrstatus  "STATUS"
#define cstrassert  "assert_"

#define cst_nlabel      "nlabel"
// because (2011) C compiler on MacOs doesn't accept _foo , adding the prefix pK_
#define cst_Type        "Type"
#define cst_cst         "cst"
#define cst_I           "pK__I"
#define cst_exception   "_exception"
#define cst_bounds      "bounds"
#define cst_indices     "indices"
#define cst_size        "size"
#define cst_dim         "dim"
#define cst_CartesianProduct   "CartesianProduct"
#define cst_PrefixBooleanClock "C"
#define cst_subexpr     "_subexpr"
#define cst_idSubTreeOf "SUBTREE_of"
#define cst_constraints "_constraints_"
#define cst_MicroStep   "_microstep_"

// intrinsic functions defined in $Signal_lib/signal/libAffineClock.SIG file 
#define cst_sample     "affine_sample"
#define cst_affineclk  "affine_clock_relation"
#define cst_unsample   "affine_unsample"

static ptident AnonymousId;
static ptident idinputenv, idoutputenv, idPresent, vstrstatus;
static ptident vidLabel, vidType, vidConst, vidIndex, vidException;
static ptident vstrhupb, vstrhorl, vstrassert, vstrnull, vstralpha, vstrIOStep;
static ptident vstrbounds, vstrsize, vstrdim, vstrindices, vstrCartesianProduct, vPredicate;
static ptident vstrsample, vstraffineclk, vstrunsample, vnilproc;
static ptident AutomatonIsIn, initialStateId, transitionId, SetCurrentStateId, AutomatonClockId, AutomatonSetClockId; // Automaton predefined models.
static ptident idSubTreeOf, idConstraints, idMicroStep, vSubExpr, idPrefixBooleanClock, previousId, TT_id, FF_id, idVar;
static ptident regExpStarId, regExpConcId, regExpSumId, regExpPowId;
static ptident idReceive, idSend, DispatchId, CompleteId, ThreadClockId, ThreadBooleanClockId;

// Predefined names for conversions (signal operator/name of a process for the conversion).
#define cvEvent    "Event"
#define cvBoolean  "Boolean"
#define cvShort    "Short"
#define cvInteger  "Integer"
#define cvLong     "Long"
#define cvReal     "Real"
#define cvDreal    "Dreal"
#define cvComplex  "Complex"
#define cvDcomplex "Dcomplex"
#define cvChar     "Char"
#define cvString   "String"

// The table of the identifiers associated with the boolean operators.
typedef
 std::map < noperators, ptident > BooleanTableType;
BooleanTableType NameAssociatedWithOperatorTable;
