/* 
   Authors: Loïc Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef __OPERSIG__
#define __OPERSIG__

// "added operator" is an operator not referenced in the parser.

#define NULLOP         0   // added operator

// NULLARY OPERATORS.
#define opanynullary   0
#define opnullary      1

#define opnom          1
#define opchar         2
#define opcomplex      3
#define opcstcar       4
#define opcstcha       5
#define opcstdp        6
#define opcstent       7
#define opcstreel      8
#define opdcomplex     9
#define opdpreal      10
#define opevent       11
#define opfalse       12
#define ophnull       13
#define opimplicit    14
#define opinteger     15
#define oplogical     16
#define oplong        17
#define opnil         18
#define opreal        19
#define opretun       20
#define opshort       21
#define opstring      22
#define optabvide     23
#define optrue        24
#define opunsafe      25
// #define opmeta        26 
#define opcomment     27 /* not used in bison, used in Signal */
#define opnullproc    28
#define opop          29
#define opdeterm      30
#define opsafe        31
#define opintVal  32 /* not used in bison, used in Signal */
// #define opnommac      32 /* not used in bison, useless */  // for macros

// UNARY OPERATORS.
#define opanyunary  100
#define opunary 101

#define opappeassert 101
#define oppassert    102
// #define opcorpp 102
#define opevnt  103
#define opexte  104
#define opvvarin 105
#define oplab   106
#define opnega  107
#define opref   108
#define opnon   109
#define oppcar  110
#define opsdec  111
#define opstru  112
// free - #define opsuit  113
#define optran  114
// free - #define opvconp 115
// free - #define opvtypp 116
#define opwhen1 117

// free -126
#define opcstenum      127 /* not used in bison, used in Signal */  // added operator : access to a value of an enumerated type
#define opindirection  128 /* not used in bison, used in Signal, check ? */   // added operator : indirection operator (used for rewritting)
#define opread         129 /* not used in bison, used in Signal (should not be ?)*/   // added operator : read node (morphism)
#define opwrite        130 /* not used in bison, used in Signal (should not be ?)*/   // added operator : write node (morphism)

// BINARY OPERATORS.
#define opanybinary  200

#define opbinary     201

#define opappe       202
#define opbinf       203
#define opbsup       204
#define opbund       205
#define opcham       206
#define opcomp       207
#define opconc       208
#define opcons       209
#define opconv       210
#define opcplx       211
#define opdeccon     212
#define opdecconp    213
#define opdecsig     214
#define opdefsig     215
#define opdesc       216
#define opdiff       217
#define opdivi       218
#define opegal       219
#define opegeg       220
#define opelem       221
#define opelevec     222
#define opcas        223
#define opensvec     224
#define opentsor     225
#define opet         226
#define opextr       227
#define opformact    228
#define opiegal      229
#define opiieg       230
// free  #define opimpo       231
#define opindmot     232
#define opinfe       233
#define opinit       234
#define opinst       235
#define opmele       236
#define opdefegal    237
#define opmmul       238
#define opmod        239
#define opdescmodu   240
#define opdefpartdef 241
// free  #define optypeact    242 moved
#define opmodu       243
#define opmoin       244
#define opmult       245
#define opnomba      246
#define opnombd      247
#define opnombm      248
#define opobli       249
#define opou         250
#define oppconf      251
#define oppetiq      252
#define opparc       253
#define opplus       254
// free #define opfrmot      255
#define oppuis       256
#define opouex       257
#define opvenum      258
#define oprecu       259
#define oprepe       260
#define oprest       261
#define opsegal      262
#define opsequ       263
#define opspec       264
#define opdecvar     265
#define opsupe       266
#define optvect      267
// free #define opvali       268
#define opvar        269
#define opident      270   // added operator
// free #define opdefmul     273 /* not used in bison, useless ? Check */   // added operator
#define opdecpar     274
#define opidentfield 275 /* not used in bison, used in Signal */  // added operator
// free 275-308
#define opleft_tt    309 /* not used in bison, used in Signal, why not in the Language ? */  // added operator
// free 310-339
#define opintvff     340
#define opintvfo     341
#define opintvof     342
#define opintvoo     343
#define opdefpart    344
// free #define optypefunc   345 moved
// free #define optypenode   346 moved
// free #define optypeproc   347 moved
#define opformfunc   348
#define opformnode   349
#define opformproc   350
// free #define oplien       351   // for macros
// free #define oprefmac     352   // for macros*
#define opformprocedure 351
#define opformautomaton 352
#define oppcontrol   353


// LIST OPERATORS.
#define opanylist      400 /* not used in bison, used in Signal */  // added operator
#define oplists        401

#define opchai         401
#define oplcons        402
#define oplcrohor      403
#define opldechor      404
#define opldecs        405
#define opldecl        406
#define opleflot       407
#define oplepara       408
#define oplesign       409
#define oplevect       410
#define oplelevec      411
// free #define oplentmot      412
#define oplequhor      413
#define oplexchor      414
#define oplfeed        415
#define oplident       416
#define opldep         417
#define oplopra        418
#define oplparc        419
#define oplprag        420
#define oplsign        421
#define oplseq         422
#define opltype        423
#define opltypep       424

#define opcomments     425 /* not used in bison, used in Signal */
#define oplsuff        426 /* not used in bison, used in Signal; is it mandatory ??? */  // added operator
#define oplread        427 /* not used in bison, used in Signal; is it mandatory ???  */   // added operator
#define oplwrite       428 /* not used in bison, used in Signal; is it mandatory ???  */   // added operator
#define opldefpart     429 /* not used in bison, used in Signal; is it mandatory ???  */   // added operator

#define oplimpo        440
#define oplmodu        441
#define optenum        442
#define oplcas         443
#define oplattr        444
// free #define oplfflot       445   // for macros
// free #define opllien        446   // for macros
// free #define oplparmac      447   // for macros

// TERNARY OPERATORS.

#define opternary   501

#define opborn      501
#define opcond      502
#define opdepd      503
#define openum      504
#define opfen       505
#define opfunc      506
#define opfuncp     507
#define opinte      508
#define opmoti      509
#define opprag      510
#define opprocess   511
#define opprocessp  512
#define opret       513
#define optype      514
#define opnodecall  515 /* not used in bison, used in Signal; is it mandatory ???  */  // added operator
#define opsubgraph  516 /* not used in bison, used in Signal; is it mandatory ???   */  // added operator
#define opact       517
#define opactp      518
#define opiter      519
#define optypeact   520
#define optypefunc  521
#define opnode      522
#define opnodep     523
#define opmemo      524
#define opoper      525
#define optypenode  526
#define optypeproc  527
#define opautomaton      528
#define opautomatonp     529
#define opprocedure      530
#define opprocedurep     531
#define optypeprocedure  532
#define optypeautomaton  533
// free
#define oppcas      540
// free #define opparmac    541   // for macros

// If the number of operators is modified, you must update the file $Signal_environment/polychronyLangOperators.h
#include "polychronyLangOperators.h"

#define LL_is_atomOp(ARG1) ( (opanynullary <= ARG1) && (ARG1 < opanyunary) )
#define LL_is_unaryOp(ARG1) ( (opanyunary <= ARG1) && (ARG1 < opanybinary) )
#define LL_is_binaryOp(ARG1) ( (opanybinary <= ARG1) && (ARG1 < opanylist) )
#define LL_is_listOp(ARG1) ( (opanylist <= ARG1) && (ARG1 < opternary) )
#define LL_is_ternaryOp(ARG1) ( (opternary <= ARG1) && (ARG1 < SIG_NB_OPERATORS + 1  ) )

#define nmakenullatom(OPER) natomnil(OPER)

#define LL_make_char_atom() nmakenullatom(opchar) 
#define LL_make_complex_atom() nmakenullatom(opcomplex) 
#define LL_make_dcomplex_atom() nmakenullatom(opdcomplex) 
#define LL_make_determ_atom() nmakenullatom(opdeterm) 
#define LL_make_dpreal_atom() nmakenullatom(opdpreal) 
#define LL_make_event_atom() nmakenullatom(opevent) 
#define LL_make_false_atom() nmakenullatom(opfalse) 
#define LL_make_hnull_atom() nmakenullatom(ophnull) 
#define LL_make_implicit_atom() nmakenullatom(opimplicit) 
#define LL_make_integer_atom() nmakenullatom(opinteger) 
#define LL_make_logical_atom() nmakenullatom(oplogical) 
#define LL_make_long_atom() nmakenullatom(oplong) 
#define LL_make_nil_atom() nmakenullatom(opnil) 
#define LL_make_nullproc_atom() nmakenullatom(opnullproc) 
#define LL_make_real_atom() nmakenullatom(opreal) 
#define LL_make_retun_atom() nmakenullatom(opretun) 
#define LL_make_safe_atom() nmakenullatom(opsafe) 
#define LL_make_short_atom() nmakenullatom(opshort) 
#define LL_make_string_atom() nmakenullatom(opstring) 
#define LL_make_tabvide_atom() nmakenullatom(optabvide) 
#define LL_make_true_atom() nmakenullatom(optrue) 
#define LL_make_unsafe_atom() nmakenullatom(opunsafe) 

#define LL_make_comment_atom(ARG) natomstring(opcomment,ARG)
#define LL_make_car_atom(ARG) natomstring(opcstcar,ARG)
#define LL_make_cha_atom(ARG) natomstring(opcstcha,ARG)
#define LL_make_dp_atom(ARG) natomstring(opcstdp,ARG)
#define LL_make_ent_atom(ARG) natomstring(opcstent,ARG)
#define LL_make_reel_atom(ARG) natomstring(opcstreel,ARG)
#define LL_make_nom_atom(ARG) natomstring(opnom,ARG)
#define LL_make_op_atom(ARG) natomstring(opop,ARG)
#define LL_make_intVal_atom(ARG) natomint(opintVal, ARG)

#define LL_make_appeassert_tree(ARG) nmakeunary(opappeassert,ARG)
#define LL_make_evnt_tree(ARG) nmakeunary(opevnt,ARG)
#define LL_make_exte_tree(ARG) nmakeunary(opexte,ARG)
#define LL_make_lab_tree(ARG) nmakeunary(oplab,ARG)
#define LL_make_nega_tree(ARG) nmakeunary(opnega,ARG)
#define LL_make_non_tree(ARG) nmakeunary(opnon,ARG)
#define LL_make_passert_tree(ARG) nmakeunary(oppassert,ARG)
#define LL_make_pcar_tree(ARG) nmakeunary(oppcar,ARG)
#define LL_make_ref_tree(ARG) nmakeunary(opref,ARG)
#define LL_make_sdec_tree(ARG) nmakeunary(opsdec,ARG)
#define LL_make_stru_tree(ARG) nmakeunary(opstru,ARG)
#define LL_make_tran_tree(ARG) nmakeunary(optran,ARG)
#define LL_make_vvarin_tree(ARG) nmakeunary(opvvarin,ARG)
#define LL_make_when1_tree(ARG) nmakeunary(opwhen1,ARG)

#define LL_make_appe_tree(ARG1,ARG2) nmakebinary(opappe,ARG1,ARG2)
#define LL_make_binf_tree(ARG1,ARG2) nmakebinary(opbinf,ARG1,ARG2)
#define LL_make_bsup_tree(ARG1,ARG2) nmakebinary(opbsup,ARG1,ARG2)
#define LL_make_bund_tree(ARG1,ARG2) nmakebinary(opbund,ARG1,ARG2)
#define LL_make_cas_tree(ARG1,ARG2) nmakebinary(opcas,ARG1,ARG2)
#define LL_make_cham_tree(ARG1,ARG2) nmakebinary(opcham,ARG1,ARG2)
#define LL_make_comp_tree(ARG1,ARG2) nmakebinary(opcomp,ARG1,ARG2)
#define LL_make_conc_tree(ARG1,ARG2) nmakebinary(opconc,ARG1,ARG2)
#define LL_make_cons_tree(ARG1,ARG2) nmakebinary(opcons,ARG1,ARG2)
#define LL_make_conv_tree(ARG1,ARG2) nmakebinary(opconv,ARG1,ARG2)
#define LL_make_cplx_tree(ARG1,ARG2) nmakebinary(opcplx,ARG1,ARG2)
#define LL_make_deccon_tree(ARG1,ARG2) nmakebinary(opdeccon,ARG1,ARG2)
#define LL_make_decconp_tree(ARG1,ARG2) nmakebinary(opdecconp,ARG1,ARG2)
#define LL_make_decpar_tree(ARG1,ARG2) nmakebinary(opdecpar,ARG1,ARG2)
#define LL_make_decsig_tree(ARG1,ARG2) nmakebinary(opdecsig,ARG1,ARG2)
#define LL_make_decvar_tree(ARG1,ARG2) nmakebinary(opdecvar,ARG1,ARG2)
#define LL_make_defegal_tree(ARG1,ARG2) nmakebinary(opdefegal,ARG1,ARG2)
#define LL_make_defpart_tree(ARG1,ARG2) nmakebinary(opdefpart,ARG1,ARG2)
#define LL_make_defpartdef_tree(ARG1,ARG2) nmakebinary(opdefpartdef,ARG1,ARG2)
#define LL_make_defsig_tree(ARG1,ARG2) nmakebinary(opdefsig,ARG1,ARG2)
#define LL_make_desc_tree(ARG1,ARG2) nmakebinary(opdesc,ARG1,ARG2)
#define LL_make_descmodu_tree(ARG1,ARG2) nmakebinary(opdescmodu,ARG1,ARG2)
#define LL_make_diff_tree(ARG1,ARG2) nmakebinary(opdiff,ARG1,ARG2)
#define LL_make_divi_tree(ARG1,ARG2) nmakebinary(opdivi,ARG1,ARG2)
#define LL_make_egal_tree(ARG1,ARG2) nmakebinary(opegal,ARG1,ARG2)
#define LL_make_egeg_tree(ARG1,ARG2) nmakebinary(opegeg,ARG1,ARG2)
#define LL_make_elem_tree(ARG1,ARG2) nmakebinary(opelem,ARG1,ARG2)
#define LL_make_elevec_tree(ARG1,ARG2) nmakebinary(opelevec,ARG1,ARG2)
#define LL_make_ensvec_tree(ARG1,ARG2) nmakebinary(opensvec,ARG1,ARG2)
#define LL_make_entsor_tree(ARG1,ARG2) nmakebinary(opentsor,ARG1,ARG2)
#define LL_make_et_tree(ARG1,ARG2) nmakebinary(opet,ARG1,ARG2)
#define LL_make_extr_tree(ARG1,ARG2) nmakebinary(opextr,ARG1,ARG2)
#define LL_make_formact_tree(ARG1,ARG2) nmakebinary(opformact,ARG1,ARG2)
#define LL_make_formautomaton_tree(ARG1,ARG2) nmakebinary(opformautomaton,ARG1,ARG2)
#define LL_make_formfunc_tree(ARG1,ARG2) nmakebinary(opformfunc,ARG1,ARG2)
#define LL_make_formnode_tree(ARG1,ARG2) nmakebinary(opformnode,ARG1,ARG2)
#define LL_make_formproc_tree(ARG1,ARG2) nmakebinary(opformproc,ARG1,ARG2)
#define LL_make_formprocedure_tree(ARG1,ARG2) nmakebinary(opformprocedure,ARG1,ARG2)
#define LL_make_ident_tree(ARG1,ARG2) nmakebinary(opident,ARG1,ARG2)
#define LL_make_iegal_tree(ARG1,ARG2) nmakebinary(opiegal,ARG1,ARG2)
#define LL_make_iieg_tree(ARG1,ARG2) nmakebinary(opiieg,ARG1,ARG2)
#define LL_make_indmot_tree(ARG1,ARG2) nmakebinary(opindmot,ARG1,ARG2)
#define LL_make_infe_tree(ARG1,ARG2) nmakebinary(opinfe,ARG1,ARG2)
#define LL_make_init_tree(ARG1,ARG2) nmakebinary(opinit,ARG1,ARG2)
#define LL_make_inst_tree(ARG1,ARG2) nmakebinary(opinst,ARG1,ARG2)
#define LL_make_intvff_tree(ARG1,ARG2) nmakebinary(opintvff,ARG1,ARG2)
#define LL_make_intvfo_tree(ARG1,ARG2) nmakebinary(opintvfo,ARG1,ARG2)
#define LL_make_intvof_tree(ARG1,ARG2) nmakebinary(opintvof,ARG1,ARG2)
#define LL_make_intvoo_tree(ARG1,ARG2) nmakebinary(opintvoo,ARG1,ARG2)
#define LL_make_mele_tree(ARG1,ARG2) nmakebinary(opmele,ARG1,ARG2)
#define LL_make_mmul_tree(ARG1,ARG2) nmakebinary(opmmul,ARG1,ARG2)
#define LL_make_mod_tree(ARG1,ARG2) nmakebinary(opmod,ARG1,ARG2)
#define LL_make_modu_tree(ARG1,ARG2) nmakebinary(opmodu,ARG1,ARG2)
#define LL_make_moin_tree(ARG1,ARG2) nmakebinary(opmoin,ARG1,ARG2)
#define LL_make_mult_tree(ARG1,ARG2) nmakebinary(opmult,ARG1,ARG2)
#define LL_make_nomba_tree(ARG1,ARG2) nmakebinary(opnomba,ARG1,ARG2)
#define LL_make_nombd_tree(ARG1,ARG2) nmakebinary(opnombd,ARG1,ARG2)
#define LL_make_nombm_tree(ARG1,ARG2) nmakebinary(opnombm,ARG1,ARG2)
#define LL_make_obli_tree(ARG1,ARG2) nmakebinary(opobli,ARG1,ARG2)
#define LL_make_ou_tree(ARG1,ARG2) nmakebinary(opou,ARG1,ARG2)
#define LL_make_ouex_tree(ARG1,ARG2) nmakebinary(opouex,ARG1,ARG2)
#define LL_make_parc_tree(ARG1,ARG2) nmakebinary(opparc,ARG1,ARG2)
#define LL_make_pconf_tree(ARG1,ARG2) nmakebinary(oppconf,ARG1,ARG2)
#define LL_make_pcontrol_tree(ARG1,ARG2) nmakebinary(oppcontrol,ARG1,ARG2)
#define LL_make_petiq_tree(ARG1,ARG2) nmakebinary(oppetiq,ARG1,ARG2)
#define LL_make_plus_tree(ARG1,ARG2) nmakebinary(opplus,ARG1,ARG2)
#define LL_make_puis_tree(ARG1,ARG2) nmakebinary(oppuis,ARG1,ARG2)
#define LL_make_recu_tree(ARG1,ARG2) nmakebinary(oprecu,ARG1,ARG2)
#define LL_make_repe_tree(ARG1,ARG2) nmakebinary(oprepe,ARG1,ARG2)
#define LL_make_rest_tree(ARG1,ARG2) nmakebinary(oprest,ARG1,ARG2)
#define LL_make_segal_tree(ARG1,ARG2) nmakebinary(opsegal,ARG1,ARG2)
#define LL_make_sequ_tree(ARG1,ARG2) nmakebinary(opsequ,ARG1,ARG2)
#define LL_make_spec_tree(ARG1,ARG2) nmakebinary(opspec,ARG1,ARG2)
#define LL_make_supe_tree(ARG1,ARG2) nmakebinary(opsupe,ARG1,ARG2)
#define LL_make_tvect_tree(ARG1,ARG2) nmakebinary(optvect,ARG1,ARG2)
#define LL_make_var_tree(ARG1,ARG2) nmakebinary(opvar,ARG1,ARG2)
#define LL_make_venum_tree(ARG1,ARG2) nmakebinary(opvenum,ARG1,ARG2)

#define LL_make_act_tree(ARG1,ARG2,ARG3) nmaketernary(opact, ARG1, ARG2, ARG3)
#define LL_make_actp_tree(ARG1,ARG2,ARG3) nmaketernary(opactp, ARG1, ARG2, ARG3)
#define LL_make_automaton_tree(ARG1,ARG2,ARG3) nmaketernary(opautomaton, ARG1, ARG2, ARG3)
#define LL_make_automatonp_tree(ARG1,ARG2,ARG3) nmaketernary(opautomatonp, ARG1, ARG2, ARG3)
#define LL_make_born_tree(ARG1,ARG2,ARG3) nmaketernary(opborn, ARG1, ARG2, ARG3)
#define LL_make_cond_tree(ARG1,ARG2,ARG3) nmaketernary(opcond, ARG1, ARG2, ARG3)
#define LL_make_depd_tree(ARG1,ARG2,ARG3) nmaketernary(opdepd, ARG1, ARG2, ARG3)
#define LL_make_enum_tree(ARG1,ARG2,ARG3) nmaketernary(openum, ARG1, ARG2, ARG3)
#define LL_make_fen_tree(ARG1,ARG2,ARG3) nmaketernary(opfen, ARG1, ARG2, ARG3)
#define LL_make_func_tree(ARG1,ARG2,ARG3) nmaketernary(opfunc, ARG1, ARG2, ARG3)
#define LL_make_funcp_tree(ARG1,ARG2,ARG3) nmaketernary(opfuncp, ARG1, ARG2, ARG3)
#define LL_make_inte_tree(ARG1,ARG2,ARG3) nmaketernary(opinte, ARG1, ARG2, ARG3)
#define LL_make_iter_tree(ARG1,ARG2,ARG3) nmaketernary(opiter, ARG1, ARG2, ARG3)
#define LL_make_memo_tree(ARG1,ARG2,ARG3) nmaketernary(opmemo, ARG1, ARG2, ARG3)
#define LL_make_moti_tree(ARG1,ARG2,ARG3) nmaketernary(opmoti, ARG1, ARG2, ARG3)
#define LL_make_node_tree(ARG1,ARG2,ARG3) nmaketernary(opnode, ARG1, ARG2, ARG3)
#define LL_make_nodep_tree(ARG1,ARG2,ARG3) nmaketernary(opnodep, ARG1, ARG2, ARG3)
#define LL_make_oper_tree(ARG1,ARG2,ARG3) nmaketernary(opoper, ARG1, ARG2, ARG3)
#define LL_make_pcas_tree(ARG1,ARG2,ARG3) nmaketernary(oppcas, ARG1, ARG2, ARG3)
#define LL_make_procedure_tree(ARG1,ARG2,ARG3) nmaketernary(opprocedure, ARG1, ARG2, ARG3)
#define LL_make_procedurep_tree(ARG1,ARG2,ARG3) nmaketernary(opprocedurep, ARG1, ARG2, ARG3)
#define LL_make_process_tree(ARG1,ARG2,ARG3) nmaketernary(opprocess, ARG1, ARG2, ARG3)
#define LL_make_processp_tree(ARG1,ARG2,ARG3) nmaketernary(opprocessp, ARG1, ARG2, ARG3)
#define LL_make_prag_tree(ARG1,ARG2,ARG3) nmaketernary(opprag, ARG1, ARG2, ARG3)
#define LL_make_ret_tree(ARG1,ARG2,ARG3) nmaketernary(opret, ARG1, ARG2, ARG3)
#define LL_make_type_tree(ARG1,ARG2,ARG3) nmaketernary(optype, ARG1, ARG2, ARG3)
#define LL_make_typeact_tree(ARG1,ARG2,ARG3) nmaketernary(optypeact, ARG1, ARG2, ARG3)
#define LL_make_typeautomaton_tree(ARG1,ARG2,ARG3) nmaketernary(optypeautomaton, ARG1, ARG2, ARG3)
#define LL_make_typefunc_tree(ARG1,ARG2,ARG3) nmaketernary(optypefunc, ARG1, ARG2, ARG3)
#define LL_make_typenode_tree(ARG1,ARG2,ARG3) nmaketernary(optypenode, ARG1, ARG2, ARG3)
#define LL_make_typeproc_tree(ARG1,ARG2,ARG3) nmaketernary(optypeproc, ARG1, ARG2, ARG3)
#define LL_make_typeprocedure_tree(ARG1,ARG2,ARG3) nmaketernary(optypeprocedure, ARG1, ARG2, ARG3)

#define LL_make_anyList_list(ARG1) nmakelist(opanylist,ARG1)
#define LL_make_comments_list(ARG1) nmakelist(opcomments,ARG1)
#define LL_make_lattr_list(ARG1) nmakelist(oplattr,ARG1)
#define LL_make_lcas_list(ARG1) nmakelist(oplcas,ARG1)
#define LL_make_chai_list(ARG1) nmakelist(opchai,ARG1)
#define LL_make_lcons_list(ARG1) nmakelist(oplcons,ARG1)
#define LL_make_lcrohor_list(ARG1) nmakelist(oplcrohor,ARG1)
#define LL_make_ldechor_list(ARG1) nmakelist(opldechor,ARG1)
#define LL_make_ldecl_list(ARG1) nmakelist(opldecl,ARG1)
#define LL_make_ldecs_list(ARG1) nmakelist(opldecs,ARG1)
#define LL_make_ldep_list(ARG1) nmakelist(opldep,ARG1)
#define LL_make_lelevec_list(ARG1) nmakelist(oplelevec,ARG1)
#define LL_make_lepara_list(ARG1) nmakelist(oplepara,ARG1)
#define LL_make_lequhor_list(ARG1) nmakelist(oplequhor,ARG1)
#define LL_make_lesign_list(ARG1) nmakelist(oplesign,ARG1)
#define LL_make_levect_list(ARG) nmakelist(oplevect, ARG)
#define LL_make_lexchor_list(ARG1) nmakelist(oplexchor,ARG1)
#define LL_make_lfeed_list(ARG1) nmakelist(oplfeed,ARG1)
#define LL_make_lident_list(ARG1) nmakelist(oplident,ARG1)
#define LL_make_limpo_list(ARG1) nmakelist(oplimpo,ARG1)
#define LL_make_lmodu_list(ARG1) nmakelist(oplmodu,ARG1)
#define LL_make_lopra_list(ARG1) nmakelist(oplopra,ARG1)
#define LL_make_lparc_list(ARG1) nmakelist(oplparc,ARG1)
#define LL_make_lprag_list(ARG1) nmakelist(oplprag,ARG1)
#define LL_make_lseq_list(ARG1) nmakelist(oplseq,ARG1)
#define LL_make_lsign_list(ARG1) nmakelist(oplsign,ARG1)
#define LL_make_ltype_list(ARG1) nmakelist(opltype,ARG1)

#define LL_make_anyList_emptyList(ARG1) nmakemptylist(opanylist)
#define LL_make_lattr_emptyList() nmakemptylist(oplattr)
#define LL_make_lcas_emptyList() nmakemptylist(oplcas)
#define LL_make_chai_emptyList() nmakemptylist(opchai)
#define LL_make_lcons_emptyList() nmakemptylist(oplcons)
#define LL_make_lcrohor_emptyList() nmakemptylist(oplcrohor)
#define LL_make_ldechor_emptyList() nmakemptylist(opldechor)
#define LL_make_ldecl_emptyList() nmakemptylist(opldecl)
#define LL_make_ldecs_emptyList() nmakemptylist(opldecs)
#define LL_make_ldep_emptyList() nmakemptylist(opldep)
#define LL_make_leflot_emptyList() nmakemptylist(opleflot)
#define LL_make_lelevec_emptyList() nmakemptylist(oplelevec)
#define LL_make_lepara_emptyList() nmakemptylist(oplepara)
#define LL_make_lequhor_emptyList() nmakemptylist(oplequhor)
#define LL_make_lesign_emptyList() nmakemptylist(oplesign)
#define LL_make_levect_emptyList() nmakemptylist(oplevect)
#define LL_make_lexchor_emptyList() nmakemptylist(oplexchor)
#define LL_make_lfeed_emptyList() nmakemptylist(oplfeed)
#define LL_make_lident_emptyList() nmakemptylist(oplident)
#define LL_make_limpo_emptyList() nmakemptylist(oplimpo)
#define LL_make_lmodu_emptyList() nmakemptylist(oplmodu)
#define LL_make_lopra_emptyList() nmakemptylist(oplopra)
#define LL_make_lparc_emptyList() nmakemptylist(oplparc)
#define LL_make_lprag_emptyList() nmakemptylist(oplprag)
#define LL_make_lsign_emptyList() nmakemptylist(oplsign)
#define LL_make_lsuff_emptyList() nmakemptylist(oplsuff)
#define LL_make_ltype_emptyList() nmakemptylist(opltype)
#define LL_make_tenum_emptyList() nmakemptylist(optenum)

#define LL_isPublicModelFamilyOp(op) ((op == opprocess || op == opnode || op == opfunc || op == opact || op == opprocedure || op == opautomaton))
#define LL_isPrivateModelFamilyOp(op) ((op == opprocessp || op == opnodep || op == opfuncp || op == opactp || op == opprocedurep || op == opautomatonp))
#define LL_isModelFamilyOp(op) (LL_isPublicModelFamilyOp(op) || LL_isPrivateModelFamilyOp(op) || op == opoper)
#define LL_isCompilableOp(op) (( LL_isPublicModelFamilyOp(op) || op == oplmodu ))
#define LL_isActualParametersOp(op) (( op == oplepara))
#define isIdentifierOp(op) ((op == opnom) || (op == opident) || (op == opcham) || (op == opelem))
#define isClockOperator(op) ((op == opcomp) || (op == opbinf) || (op == opbsup) /* || (op == ophnull) */ )
#define isClockRelationOperator(op) ((op == oplcrohor) || (op == opldechor) || (op == oplequhor) || (op == oplexchor))
#define isRelationalOp(op)  ((op == opegeg) || (op == opiieg) || (op == opsupe) || (op == opinfe) || (op == opsegal) || (op == opiegal) || (op == opegal) || (op == opdiff))
#define isLogicalOp(op)  ((op == opouex) || (op == opet) || (op == opou) || (op == opnon))

#define LL_isFunctionFamilyOp(op) ((op == opfunc || op == opfuncp)) 
#define LL_isActionFamilyOp(op) ((op == opact || op == opactp)) 
#define LL_isProcedureFamilyOp(op) ((op == opprocedure || op == opprocedurep)) 
#define LL_isAutomatonFamilyOp(op) ((op == opautomaton || op == opautomatonp))
#define LL_isNodeFamilyOp(op) ((op == opnode || op == opnodep))
#define LL_isProcessFamilyOp(op) ((op == opprocess || op == opprocessp))

#define _isalist_(op) ((op >= oplists) && (op < opternary))
#define _isaleaf_(op)  (op < opunary)

#define LL_getModelType(op) ( (op == opprocess) ? optypeproc : ( (op == opact)  ? optypeact :( (op == opnode) ?optypenode: \
              ( (op == opfunc) ? optypefunc :( (op == opprocedure) ? optypeprocedure :( (op == opautomaton) ? optypeautomaton : NULLOP))))))

#define LL_isTypeOp(op) (( op == opchar)  || (op == opcomplex)  || (op == opdcomplex) || ( op == opdpreal) || ( op == opevent) \
  || ( op == opimplicit) || ( op == opinteger)  || ( op == oplogical) || ( op ==  oplong)  || ( op == opreal) || ( op == opshort)\
  || ( op == opstring) || ( op == opstru) || ( op == opbund) || ( op == optenum) || ( op == optvect))

#define LL_isModelType(op) (( op == optypeproc) || ( op ==  optypeact ) || ( op == optypefunc) || ( op == optypenode) || ( op == optypeprocedure ) || ( op ==optypeautomaton ))

#define LL_getFormalModelType(op) ( (op == opformproc) ? optypeproc : ( (op == opformact)  ? optypeact :( (op == opformnode) ?optypenode: \
              ( (op == opformfunc) ? optypefunc :( (op == opformprocedure) ? optypeprocedure :( (op == opformautomaton) ? optypeautomaton : NULLOP))))))

#endif


