

///
static ntrees
sigparser (char *filename, integer phylumCode, boolean * cc, boolean bseerror)
{
  yyin = (FILE *) fopen ((char *) filename, "r");
  if (yyin == NULL)
    {
      *cc = pk_false;
      return NILTREE;
    }

  pK_messenger->setErrorCode (pk_true);
  pK_messenger->parsing_logFileInitialize ();
  siganasetfilename (filename);
  init_lex (phylumCode);
  yyparse ();
  fclose (yyin);
  *cc = pK_messenger->getErrorCode ();
  if (bseerror)
    pK_messenger->parsing_logFileFinalize (!*cc);
  return (metafinalize (*cc));
}

///
static boolean
exist_file (ptrepstr vstr)
{
  if (sysExistFile (vstr))
    return pk_true;
  pK_messenger->globalMessageStr (error_openingFile, vstr);
  return pk_false;
}


/** 
    @return "true" if the Signal text specified in the file parsin
    and with  the waited phylum phylum is syntacticly correct.
    @param phylum (in) : phylum (without_phylum if no phylum, see phylaSignal.h file)
    @param parsin (in) : name of the input file to analyze.
    @param mpp (out) : abstract tree representation of the analyzed file.
 */
static boolean
sysparserLoc (integer phylum, char *parsin, ntrees * mpp, boolean bBatchCompiler)
{
  boolean b;
  integer omtable;

  omtable = pK_messenger->gmessload (parsermess);
  (*mpp) = sigparser (parsin, phylum, &b, bBatchCompiler);
  pK_messenger->gmessrestore (omtable);
  return b;
}
