/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#define YYLTYPE yyltype
#define siganasetfilename(filename) { __siganafilename__ = string2repstr(filename); }
#define siganawarnpos(x,y)  { pK_messenger -> parsing_errorLineColumn(__siganafilename__, LINENUMBER(x.first_line), x.first_column, y); }
#define siganaerrorpos(x,y) { pK_messenger -> parsing_errorLineColumn(__siganafilename__, LINENUMBER(x.first_line), x.first_column,y); }
#define siganafatalpos(x,y) { pK_messenger -> parsing_errorLineColumn( __siganafilename__, LINENUMBER(x.first_line), x.first_column,y); }

#define YYSTYPE ntrees
#define YYDEBUG 1
#define YYERROR_VERBOSE 1
#define YYINITDEPTH 2000

static ntrees root_signal;	/* result */

/*********************/
/** error management */
/*********************/
static void
sigerror (const char * /* s */ )
{
}


/**
   Add "COMMENT" annotation (commentsTree) to  a tree (aTree) in prefix position if bpre, postfix position otherwise.
*/
static void
complete_comments (ntrees aTree, boolean bpre)
{
  if (ongoing_comments)
    {
      STree_addPrintableTreeAttribute (aTree, commentsTree, bpre);
      ongoing_comments = pk_false;
    }
}


/*== == == == == == == == == == == == == == == == */
/*LOCAL VALUE SENT BY SIGPARSER() */
/* == == == == == == == == == == == == == == == == */

static ntrees
metafinalize (boolean breturncode)
{
  // if (!breturncode) return (NILTREE); removed 2010 Jan; Try to continue the compilation with syntactic errors.
  return ((ntrees) root_signal);
}
