// noperators -> int
// ntrees -> int

// ptrepstr -> String, it is not imported here.

// Parsing, pretty printer, Signal Tree builder.
public class SignalTree
{
    static {System.loadLibrary("SignalTree");} // libSignalTree.so(Unix) SignalTree.DLL(Windows); libSignalTree.jnilib(Mac)
    
    native boolean n_printTree ( ntrees vt );
    native boolean n_printTreeFile ( ntrees t, ptrepstr fileName);
    
    // COMMENTS ( no comment )
    native boolean n_getComment ( ntrees t, ntrees * varb);
    native void n_addStrComment ( ntrees t, ptrepstr cstr);
    native void n_addComment ( ntrees t, ntrees vattrtree);

    // Test
    native  boolean n_isList ( ntrees p);
    native  boolean n_isUnaryExprProc ( int ope);
    native  boolean n_isExprProc ( int ope);
    native  boolean n_isLocalDeclList ( ntrees p);
    native  boolean n_isInterface ( ntrees p);
    native  boolean n_isSpec ( ntrees p);
    native  boolean n_isInputOutput ( ntrees p);
    native  boolean n_isProcess ( ntrees p);
    native  boolean n_isModel ( ntrees p);
    native  boolean n_isPrivateDeclaration ( ntrees p);
    native  boolean n_isFunction ( ntrees p);
    native  boolean n_isNode ( ntrees p);
    native  boolean n_isAction ( ntrees p);
    native  boolean n_isModule ( ntrees p);
    native  boolean n_n_isModulesList ( ntrees p);
    native  boolean n_isExternModel ( ntrees p);
    native  boolean n_isBodyTree ( ntrees p);
    native  boolean n_isNameOfModel ( ntrees p);
    native  boolean n_isParametersOfModel ( ntrees p);
    native  boolean n_isEffectiveParameter ( ntrees p);
    native  boolean n_isSignalDecl ( ntrees p);
    native  boolean n_isConstantDecl ( ntrees p);
    native  boolean n_isTypeDecl ( ntrees p);
    native  boolean n_isModelWithoutParameters ( ntrees proc);
    native  boolean n_isPragmas ( ntrees p);
    native  boolean n_IdentEq ( ntrees p_nom1, ntrees p_nom2);
    native  boolean n_isInDeclList ( ntrees l_liste, ntrees declid);
    native  boolean n_isParamAtype ( ntrees l_param, int no);
    native  boolean n_isUndefinedTree ( ntrees vt);
    native  boolean n_TreeEq ( ntrees pt1, ntrees pt2);
    native  boolean n_isModelInList ( ntrees p_nom, ntrees list_proc, ntrees *p_decl);
    native  boolean n_isOperatorModel ( ntrees p);
    native  boolean n_isImplicitTypeTree ( ntrees t);

    // EXPLORING
    native  ntrees n_getModelName ( ntrees m);
    native  ptrepstr n_getModelNameStr ( ntrees m);
    native  integer n_getOperatorArity ( noperators voperator);
    native  boolean n_getRootTree ( ntrees t, ntrees *r);
    native  ntrees n_getNameCalledModel ( ntrees p_appel);
    native  boolean n_searchCallToIn ( ptident name, ntrees p_proc, ntrees *aCall);
    native  ntrees n_getModelInWhich ( ntrees p);
    native  ntrees n_getModelFather ( ntrees p);
    native  ntrees n_getIthModel ( ntrees aModel, int index);
    native  ntrees n_getParameters ( ntrees p);
    native  int n_getNbParameters ( ntrees p);
    native  ntrees n_getInterface ( ntrees p);
    native  ntrees n_getInputsOutputs ( ntrees p)    ;
    native  ntrees n_getOutputs ( ntrees p);
    native  int n_getNbOutputs ( ntrees p);
    native  ntrees n_getInputs ( ntrees p);
    native  int n_getNbInputs ( ntrees p);
    native  ntrees n_getSpec ( ntrees p);
    native  void n_getPragmaValues ( ntrees aPragma, ptrepstr *name, ntrees *p_obj,  ntrees *enonce);
    native  ntrees n_getLocalDeclarations ( ntrees p);
    native  ntrees n_getNameOfDeclaration ( ntrees decl);
    native  ntrees n_getDeclarationWithoutType ( ntrees decl);
    native  ntrees n_getInitExpr ( ntrees decl);
    native  ptrepstr n_getIdentStr ( ntrees p);
    native  int n_getType ( ntrees p_decl, ntrees *arb_typ);
    native  ntrees n_getNilTree () ;
    native  ntrees n_getDescription ( ntrees p);
    native  ntrees n_getPragmas ( ntrees p);
    native  ntrees n_getBody ( ntrees m);
    native  ntrees n_getDeclaration ( ntrees vtreeproc, integer *where);
    native  ptrepstr n_getExternalValue ( ntrees t);

    // BUILTING
    native  void n_replaceSon ( ntrees p1, ntrees p2, int i);
    native  ntrees n_mkModelCall ( ptrepstr name);
    native  ntrees n_mkEmptyTree () ;
    native  ntrees n_mkInterface () ;
    native  ntrees n_mkProcess ( ntrees p_nom, ntrees p_inte, ntrees p_desc);
    native  ntrees n_mkEmptyBody () ;
    native  ntrees n_mkEmptyConfinedExpr () ;
    native  ntrees n_mkModule ( ntrees name);
    native  void n_replaceInputsOutputs ( ntrees proc, ntrees inOut);
    native  void n_replaceInterface ( ntrees proc, ntrees interface);
    native  void n_setParameters ( ntrees proc, ntrees param);
    native  void n_set_external_graph ( ntrees proc, ntrees eg);
    native  void n_replaceInputsOutputsModel ( ntrees proc, ntrees l_sig, boolean binputs);
    native  void n_importDeclarations ( ntrees proc1, ntrees proc2);
    native  void n_replaceLocalDecl ( ntrees p, ntrees l_decl);
    native  void n_setdescription ( ntrees process, ntrees  desc);
    native  void n_setPragmas ( ntrees proc, ntrees pragmas);
    native  void n_addFlowDeclaration ( ntrees l_liste, ntrees arb_typ, ntrees arb_def) ;
    native  void n_mergeLocalDecl ( ntrees l_decl, ntrees l_decl_a_inserer);
    native  ntrees n_mkTreeSkeleton ( ptident id, noperators op);
    native  ntrees n_mkSqueletonExternProcess ( ptident nameprocess, ntrees vlang, noperators ope);
    native  ntrees n_mkSynchroIni ( ntrees fname);
    native  ntrees n_mkNOTIMPLEMENTED ( );
    native  ntrees n_mkNullaryTree ( noperators op);
    native  ntrees n_mkEmptyString ( );
    native  ntrees n_mkStringFromStr ( ptrepstr vstr);
    native  ntrees n_mkAtomNilTree ( );
    native  ntrees n_mkUndefinedExternalValue ( );
    native  ntrees n_mkExternalString ( ntrees vstring);
    native  ntrees n_mkSynchroTree ( ntrees list, ntrees t1, ntrees t2);
    native  ntrees n_mkReferenceToModel ( ptident id);
    native  ntrees n_mkConfinedExpression ( ntrees expr, ntrees decl);
    native  ntrees n_addLocalBlock ( ntrees p_desc);
    native  ntrees n_addEmptyInterface ( ntrees p_proc);
    native  ntrees n_mkPragmasList ( ntrees process);
    native  ntrees n_mkPragma ( ptrepstr kw, ptrepstr enonce);
    native  void n_addPragma ( ntrees aProcess, ntrees apragma);
    native ntrees mkDclType ( ntrees name, ntrees description, ntrees vinit);
    native  ntrees n_addDeclarationToList ( ntrees ldecl, ntrees vdecl);
    native  ntrees n_addEndDeclarationToList ( ntrees ldecl, ntrees vdecl);
    native  void n_addLocalDeclaration ( ntrees aProcess, ntrees vdecl);
    native  void n_addProcessDeclaration ( ntrees vtreeproc, ntrees vtreeproapp);
    native  ntrees n_addTypeToTypes ( ntrees vtypes, ntrees vtype);
    native  void n_addSpecification ( ntrees process, ntrees vtreeSpecif);
    native  void n_addExpressionOfProcessToaModel ( ntrees vtreeproc, ntrees vexprpro);
    native  void n_setBody ( ntrees vtreeproc, ntrees vexprpro);
    native  ntrees n_mkTreeinterface ( ntrees param, ntrees ins, ntrees outs, ntrees spec);
    native  ntrees n_duplicateInterfaceWithoutSpec ( ntrees process);
    native  void n_addDeclarationToInterface ( ntrees vtreeproc, ntrees vdecsig, integer where);
    native  void n_addExprToComposition_Post ( ntrees * vlfeed, ntrees vexpapp);
    native  void n_addExprToComposition_Pre ( ntrees * vlfeed, ntrees vexpapp);
    native  ntrees n_mkReferenceToModelWithParameter ( ntrees lpa, ntrees pro);
    native  void n_maskSignals ( ntrees vprocessus, ntrees SignalList);
    native  ntrees n_mkTreeEquation ( noperators op, ntrees opg, ntrees opd);
    native  void n_setProcessDeclarations ( ntrees aProcess, ntrees ldeclarations);
    native  ntrees n_mkDependenceTree ( ntrees vfrom, ntrees vto, ntrees tClock);
    native  ntrees n_mkLocalDeclaration ( ntrees p_proc);
    native  void n_deleteParameters ( ntrees p_proc);
    native  ntrees n_mkSignalDeclaration ( ntrees p_nom, ntrees p_typ, ntrees p_init);
    native  ntrees n_mkImplicitSignalDeclaration ( ptrepstr name);
    native  ntrees n_mkConstantDeclaration ( ntrees p_def, ntrees p_typ);
    native  void n_mergeExprProc ( ntrees vprocessus, ntrees vtreegfd);
    native  void n_mergeDeclarations ( ntrees vprocessus, ntrees vtreegfd);
    native  void n_mergeProcesses ( ntrees vprocessus, ntrees vtreegfd);
    native  void n_importDeclsFromTo (  ntrees lids, ntrees p, ntrees m);
    native  void n_removeDeclsFrom ( ntrees lids, ntrees p);
    native  void n_setNameModel ( ntrees m, ptident vident);
    native  ntrees n_copy ( ntrees p, boolean copyattr);
    native  ntrees n_setLocalDeclarations ( ntrees p, ntrees ndecls);
    native  ntrees n_mkTreeExternalImplLanguage ( integer cl);
    native  boolean n_mkTreeSelectedPragma ( ntrees prag, ptrepstr vstrcomment, ntrees *vt);
    native  ntrees n_updateModule ( ntrees vhierarchie);
    native  ntrees n_mkCompleteModelCall ( ntrees process);
    native  ntrees n_removeNilTree ( ntrees l_proc);
    native  void n_addLabelsInModel ( ntrees lids, ntrees p);


    public synchronized boolean getComment ( ntrees t, ntrees * varb)
    {
	return n_getComment ( ntrees t, ntrees * varb);
    }

    public synchronized void addStrComment ( ntrees t, ptrepstr cstr)
    {
	return n_addStrComment ( ntrees t, ptrepstr cstr);
    }

    public synchronized void addComment ( ntrees t, ntrees vattrtree)
    {
	return n_addComment ( ntrees t, ntrees vattrtree);
    }

    public synchronized boolean isList ( ntrees p)
    {
	return n_isList ( ntrees p);
    }

    public synchronized boolean isUnaryExprProc ( int ope)
    {
	return n_isUnaryExprProc ( int ope);
    }

    public synchronized boolean isExprProc ( int ope)
    {
	return n_isExprProc ( int ope);
    }

    public synchronized boolean isLocalDeclList ( ntrees p)
    {
	return n_isLocalDeclList ( ntrees p);
    }

    public synchronized boolean isInterface ( ntrees p)
    {
	return n_isInterface ( ntrees p);
    }

    public synchronized boolean isSpec ( ntrees p)
    {
	return n_isSpec ( ntrees p);
    }

    public synchronized boolean isInputOutput ( ntrees p)
    {
	return n_isInputOutput ( ntrees p);
    }

    public synchronized boolean isProcess ( ntrees p)
    {
	return n_isProcess ( ntrees p);
    }

    public synchronized boolean isModel ( ntrees p)
    {
	return n_isModel ( ntrees p);
    }

    public synchronized boolean isPrivateDeclaration ( ntrees p)
    {
	return n_isPrivateDeclaration ( ntrees p);
    }

    public synchronized boolean isFunction ( ntrees p)
    {
	return n_isFunction ( ntrees p);
    }

    public synchronized boolean isNode ( ntrees p)
    {
	return n_isNode ( ntrees p);
    }

    public synchronized boolean isAction ( ntrees p)
    {
	return n_isAction ( ntrees p);
    }

    public synchronized boolean isModule ( ntrees p)
    {
	return n_isModule ( ntrees p);
    }

    public synchronized boolean isModulesList ( ntrees p)
    {
	return n_isModulesList ( ntrees p);
    }

    public synchronized boolean isExternModel ( ntrees p)
    {
	return n_isExternModel ( ntrees p);
    }

    public synchronized boolean isBodyTree ( ntrees p)
    {
	return n_isBodyTree ( ntrees p);
    }

    public synchronized boolean isNameOfModel ( ntrees p)
    {
	return n_isNameOfModel ( ntrees p);
    }

    public synchronized boolean isParametersOfModel ( ntrees p)
    {
	return n_isParametersOfModel ( ntrees p);
    }

    public synchronized boolean isEffectiveParameter ( ntrees p)
    {
	return n_isEffectiveParameter ( ntrees p);
    }

    public synchronized boolean isSignalDecl ( ntrees p)
    {
	return n_isSignalDecl ( ntrees p);
    }

    public synchronized boolean isConstantDecl ( ntrees p)
    {
	return n_isConstantDecl ( ntrees p);
    }

    public synchronized boolean isTypeDecl ( ntrees p)
    {
	return n_isTypeDecl ( ntrees p);
    }

    public synchronized boolean isModelWithoutParameters ( ntrees proc)
    {
	return n_isModelWithoutParameters ( ntrees proc);
    }

    public synchronized boolean isPragmas ( ntrees p)
    {
	return n_isPragmas ( ntrees p);
    }

    public synchronized boolean IdentEq ( ntrees p_nom1, ntrees p_nom2)
    {
	return n_IdentEq ( ntrees p_nom1, ntrees p_nom2);
    }

    public synchronized boolean isInDeclList ( ntrees l_liste, ntrees declid)
    {
	return n_isInDeclList ( ntrees l_liste, ntrees declid);
    }

    public synchronized boolean isParamAtype ( ntrees l_param, int no)
    {
	return n_isParamAtype ( ntrees l_param, int no);
    }

    public synchronized boolean isUndefinedTree ( ntrees vt)
    {
	return n_isUndefinedTree ( ntrees vt);
    }

    public synchronized boolean TreeEq ( ntrees pt1, ntrees pt2)
    {
	return n_TreeEq ( ntrees pt1, ntrees pt2);
    }

    public synchronized boolean isModelInList ( ntrees p_nom, ntrees list_proc, ntrees *p_decl)
    {
	return n_isModelInList ( ntrees p_nom, ntrees list_proc, ntrees *p_decl);
    }

    public synchronized boolean isOperatorModel ( ntrees p)
    {
	return n_isOperatorModel ( ntrees p);
    }

    public synchronized boolean isImplicitTypeTree ( ntrees t)
    {
	return n_isImplicitTypeTree ( ntrees t);
    }


    public synchronized ntrees getModelName ( ntrees m)
    {
	return n_getModelName ( ntrees m);
    }

    public synchronized ptrepstr getModelNameStr ( ntrees m)
    {
	return n_getModelNameStr ( ntrees m);
    }

    public synchronized integer getOperatorArity ( noperators voperator)
    {
	return n_getOperatorArity ( noperators voperator);
    }

    public synchronized boolean getRootTree ( ntrees t, ntrees *r)
    {
	return n_getRootTree ( ntrees t, ntrees *r);
    }

    public synchronized ntrees getNameCalledModel ( ntrees p_appel)
    {
	return n_getNameCalledModel ( ntrees p_appel);
    }

    public synchronized boolean searchCallToIn ( ptident name, ntrees p_proc, ntrees *aCall)
    {
	return n_searchCallToIn ( ptident name, ntrees p_proc, ntrees *aCall);
    }

    public synchronized ntrees getModelInWhich ( ntrees p)
    {
	return n_getModelInWhich ( ntrees p);
    }

    public synchronized ntrees getModelFather ( ntrees p)
    {
	return n_getModelFather ( ntrees p);
    }

    public synchronized ntrees getIthModel ( ntrees aModel, int index)
    {
	return n_getIthModel ( ntrees aModel, int index);
    }

    public synchronized ntrees getParameters ( ntrees p)
    {
	return n_getParameters ( ntrees p);
    }

    public synchronized int getNbParameters ( ntrees p)
    {
	return n_getNbParameters ( ntrees p);
    }

    public synchronized ntrees getInterface ( ntrees p)
    {
	return n_getInterface ( ntrees p);
    }

    public synchronized ntrees getInputsOutputs ( ntrees p) 
    {
	return n_getInputsOutputs ( ntrees p) ;
    }

    public synchronized ntrees getOutputs ( ntrees p)
    {
	return n_getOutputs ( ntrees p);
    }

    public synchronized int getNbOutputs ( ntrees p)
    {
	return n_getNbOutputs ( ntrees p);
    }

    public synchronized ntrees getInputs ( ntrees p)
    {
	return n_getInputs ( ntrees p);
    }

    public synchronized int getNbInputs ( ntrees p)
    {
	return n_getNbInputs ( ntrees p);
    }

    public synchronized ntrees getSpec ( ntrees p)
    {
	return n_getSpec ( ntrees p);
    }

    public synchronized void getPragmaValues ( ntrees aPragma, ptrepstr *name, ntrees *p_obj, ntrees *enonce)
    {
	return n_getPragmaValues ( ntrees aPragma, ptrepstr *name, ntrees *p_obj, ntrees *enonce);
    }

    public synchronized ntrees getLocalDeclarations ( ntrees p)
    {
	return n_getLocalDeclarations ( ntrees p);
    }

    public synchronized ntrees getNameOfDeclaration ( ntrees decl)
    {
	return n_getNameOfDeclaration ( ntrees decl);
    }

    public synchronized ntrees getDeclarationWithoutType ( ntrees decl)
    {
	return n_getDeclarationWithoutType ( ntrees decl);
    }

    public synchronized ntrees getInitExpr ( ntrees decl)
    {
	return n_getInitExpr ( ntrees decl);
    }

    public synchronized ptrepstr getIdentStr ( ntrees p)
    {
	return n_getIdentStr ( ntrees p);
    }

    public synchronized int getType ( ntrees p_decl, ntrees *arb_typ)
    {
	return n_getType ( ntrees p_decl, ntrees *arb_typ);
    }

    public synchronized ntrees getNilTree () 
    {
	return n_getNilTree () ;
    }

    public synchronized ntrees getDescription ( ntrees p)
    {
	return n_getDescription ( ntrees p);
    }

    public synchronized ntrees getPragmas ( ntrees p)
    {
	return n_getPragmas ( ntrees p);
    }

    public synchronized ntrees getBody ( ntrees m)
    {
	return n_getBody ( ntrees m);
    }

    public synchronized ntrees getDeclaration ( ntrees vtreeproc, integer *where)
    {
	return n_getDeclaration ( ntrees vtreeproc, integer *where);
    }

    public synchronized ptrepstr getExternalValue ( ntrees t)
    {
	return n_getExternalValue ( ntrees t);
    }


    public synchronized void replaceSon ( ntrees p1, ntrees p2, int i)
    {
	return n_replaceSon ( ntrees p1, ntrees p2, int i);
    }

    public synchronized ntrees mkModelCall ( ptrepstr name)
    {
	return n_mkModelCall ( ptrepstr name);
    }

    public synchronized ntrees mkEmptyTree () 
    {
	return n_mkEmptyTree () ;
    }

    public synchronized ntrees mkInterface () 
    {
	return n_mkInterface () ;
    }

    public synchronized ntrees mkProcess ( ntrees p_nom, ntrees p_inte, ntrees p_desc)
    {
	return n_mkProcess ( ntrees p_nom, ntrees p_inte, ntrees p_desc);
    }

    public synchronized ntrees mkEmptyBody () 
    {
	return n_mkEmptyBody () ;
    }

    public synchronized ntrees mkEmptyConfinedExpr () 
    {
	return n_mkEmptyConfinedExpr () ;
    }

    public synchronized ntrees mkModule ( ntrees name)
    {
	return n_mkModule ( ntrees name);
    }

    public synchronized void replaceInputsOutputs ( ntrees proc, ntrees inOut)
    {
	return n_replaceInputsOutputs ( ntrees proc, ntrees inOut);
    }

    public synchronized void replaceInterface ( ntrees proc, ntrees interface)
    {
	return n_replaceInterface ( ntrees proc, ntrees interface);
    }

    public synchronized void setParameters ( ntrees proc, ntrees param)
    {
	return n_setParameters ( ntrees proc, ntrees param);
    }

    public synchronized void set_external_graph ( ntrees proc, ntrees eg)
    {
	return n_set_external_graph ( ntrees proc, ntrees eg);
    }

    public synchronized void replaceInputsOutputsModel ( ntrees proc, ntrees l_sig, boolean binputs)
    {
	return n_replaceInputsOutputsModel ( ntrees proc, ntrees l_sig, boolean binputs);
    }

    public synchronized void importDeclarations ( ntrees proc1, ntrees proc2)
    {
	return n_importDeclarations ( ntrees proc1, ntrees proc2);
    }

    public synchronized void replaceLocalDecl ( ntrees p, ntrees l_decl)
    {
	return n_replaceLocalDecl ( ntrees p, ntrees l_decl);
    }

    public synchronized void setdescription ( ntrees process, ntrees desc)
    {
	return n_setdescription ( ntrees process, ntrees desc);
    }

    public synchronized void setPragmas ( ntrees proc, ntrees pragmas)
    {
	return n_setPragmas ( ntrees proc, ntrees pragmas);
    }

    public synchronized void addFlowDeclaration ( ntrees l_liste, ntrees arb_typ, ntrees arb_def) 
    {
	return n_addFlowDeclaration ( ntrees l_liste, ntrees arb_typ, ntrees arb_def) ;
    }

    public synchronized void mergeLocalDecl ( ntrees l_decl, ntrees l_decl_a_inserer)
    {
	return n_mergeLocalDecl ( ntrees l_decl, ntrees l_decl_a_inserer);
    }

    public synchronized ntrees mkTreeSkeleton ( ptident id, noperators op)
    {
	return n_mkTreeSkeleton ( ptident id, noperators op);
    }

    public synchronized ntrees mkSqueletonExternProcess ( ptident nameprocess, ntrees vlang, noperators ope)
    {
	return n_mkSqueletonExternProcess ( ptident nameprocess, ntrees vlang, noperators ope);
    }

    public synchronized ntrees mkSynchroIni ( ntrees fname)
    {
	return n_mkSynchroIni ( ntrees fname);
    }

    public synchronized ntrees mkNOTIMPLEMENTED ( )
    {
	return n_mkNOTIMPLEMENTED ( );
    }

    public synchronized ntrees mkNullaryTree ( noperators op)
    {
	return n_mkNullaryTree ( noperators op);
    }

    public synchronized ntrees mkEmptyString ( )
    {
	return n_mkEmptyString ( );
    }

    public synchronized ntrees mkStringFromStr ( ptrepstr vstr)
    {
	return n_mkStringFromStr ( ptrepstr vstr);
    }

    public synchronized ntrees mkAtomNilTree ( )
    {
	return n_mkAtomNilTree ( );
    }

    public synchronized ntrees mkUndefinedExternalValue ( )
    {
	return n_mkUndefinedExternalValue ( );
    }

    public synchronized ntrees mkExternalString ( ntrees vstring)
    {
	return n_mkExternalString ( ntrees vstring);
    }

    public synchronized ntrees mkSynchroTree ( ntrees list, ntrees t1, ntrees t2)
    {
	return n_mkSynchroTree ( ntrees list, ntrees t1, ntrees t2);
    }

    public synchronized ntrees mkReferenceToModel ( ptident id)
    {
	return n_mkReferenceToModel ( ptident id);
    }

    public synchronized ntrees mkConfinedExpression ( ntrees expr, ntrees decl)
    {
	return n_mkConfinedExpression ( ntrees expr, ntrees decl);
    }

    public synchronized ntrees addLocalBlock ( ntrees p_desc)
    {
	return n_addLocalBlock ( ntrees p_desc);
    }

    public synchronized ntrees addEmptyInterface ( ntrees p_proc)
    {
	return n_addEmptyInterface ( ntrees p_proc);
    }

    public synchronized ntrees mkPragmasList ( ntrees process)
    {
	return n_mkPragmasList ( ntrees process);
    }

    public synchronized ntrees mkPragma ( ptrepstr kw, ptrepstr enonce)
    {
	return n_mkPragma ( ptrepstr kw, ptrepstr enonce);
    }

    public synchronized void addPragma ( ntrees aProcess, ntrees apragma)
    {
	return n_addPragma ( ntrees aProcess, ntrees apragma);
    }

    ntrees mkDclType ( ntrees name, ntrees description, ntrees vinit);

    public synchronized ntrees addDeclarationToList ( ntrees ldecl, ntrees vdecl)
    {
	return n_addDeclarationToList ( ntrees ldecl, ntrees vdecl);
    }

    public synchronized ntrees addEndDeclarationToList ( ntrees ldecl, ntrees vdecl)
    {
	return n_addEndDeclarationToList ( ntrees ldecl, ntrees vdecl);
    }

    public synchronized void addLocalDeclaration ( ntrees aProcess, ntrees vdecl)
    {
	return n_addLocalDeclaration ( ntrees aProcess, ntrees vdecl);
    }

    public synchronized void addProcessDeclaration ( ntrees vtreeproc, ntrees vtreeproapp)
    {
	return n_addProcessDeclaration ( ntrees vtreeproc, ntrees vtreeproapp);
    }

    public synchronized ntrees addTypeToTypes ( ntrees vtypes, ntrees vtype)
    {
	return n_addTypeToTypes ( ntrees vtypes, ntrees vtype);
    }

    public synchronized void addSpecification ( ntrees process, ntrees vtreeSpecif)
    {
	return n_addSpecification ( ntrees process, ntrees vtreeSpecif);
    }

    public synchronized void addExpressionOfProcessToaModel ( ntrees vtreeproc, ntrees vexprpro)
    {
	return n_addExpressionOfProcessToaModel ( ntrees vtreeproc, ntrees vexprpro);
    }

    public synchronized void setBody ( ntrees vtreeproc, ntrees vexprpro)
    {
	return n_setBody ( ntrees vtreeproc, ntrees vexprpro);
    }

    public synchronized ntrees mkTreeinterface ( ntrees param, ntrees ins, ntrees outs, ntrees spec)
    {
	return n_mkTreeinterface ( ntrees param, ntrees ins, ntrees outs, ntrees spec);
    }

    public synchronized ntrees duplicateInterfaceWithoutSpec ( ntrees process)
    {
	return n_duplicateInterfaceWithoutSpec ( ntrees process);
    }

    public synchronized void addDeclarationToInterface ( ntrees vtreeproc, ntrees vdecsig, integer where)
    {
	return n_addDeclarationToInterface ( ntrees vtreeproc, ntrees vdecsig, integer where);
    }

    public synchronized void addExprToComposition_Post ( ntrees * vlfeed, ntrees vexpapp)
    {
	return n_addExprToComposition_Post ( ntrees * vlfeed, ntrees vexpapp);
    }

    public synchronized void addExprToComposition_Pre ( ntrees * vlfeed, ntrees vexpapp)
    {
	return n_addExprToComposition_Pre ( ntrees * vlfeed, ntrees vexpapp);
    }

    public synchronized ntrees mkReferenceToModelWithParameter ( ntrees lpa, ntrees pro)
    {
	return n_mkReferenceToModelWithParameter ( ntrees lpa, ntrees pro);
    }

    public synchronized void maskSignals ( ntrees vprocessus, ntrees SignalList)
    {
	return n_maskSignals ( ntrees vprocessus, ntrees SignalList);
    }

    public synchronized ntrees mkTreeEquation ( noperators op, ntrees opg, ntrees opd)
    {
	return n_mkTreeEquation ( noperators op, ntrees opg, ntrees opd);
    }

    public synchronized void setProcessDeclarations ( ntrees aProcess, ntrees ldeclarations)
    {
	return n_setProcessDeclarations ( ntrees aProcess, ntrees ldeclarations);
    }

    public synchronized ntrees mkDependenceTree ( ntrees vfrom, ntrees vto, ntrees tClock)
    {
	return n_mkDependenceTree ( ntrees vfrom, ntrees vto, ntrees tClock);
    }

    public synchronized ntrees mkLocalDeclaration ( ntrees p_proc)
    {
	return n_mkLocalDeclaration ( ntrees p_proc);
    }

    public synchronized void deleteParameters ( ntrees p_proc)
    {
	return n_deleteParameters ( ntrees p_proc);
    }

    public synchronized ntrees mkSignalDeclaration ( ntrees p_nom, ntrees p_typ, ntrees p_init)
    {
	return n_mkSignalDeclaration ( ntrees p_nom, ntrees p_typ, ntrees p_init);
    }

    public synchronized ntrees mkImplicitSignalDeclaration ( ptrepstr name)
    {
	return n_mkImplicitSignalDeclaration ( ptrepstr name);
    }

    public synchronized ntrees mkConstantDeclaration ( ntrees p_def, ntrees p_typ)
    {
	return n_mkConstantDeclaration ( ntrees p_def, ntrees p_typ);
    }

    public synchronized void mergeExprProc ( ntrees vprocessus, ntrees vtreegfd)
    {
	return n_mergeExprProc ( ntrees vprocessus, ntrees vtreegfd);
    }

    public synchronized void mergeDeclarations ( ntrees vprocessus, ntrees vtreegfd)
    {
	return n_mergeDeclarations ( ntrees vprocessus, ntrees vtreegfd);
    }

    public synchronized void mergeProcesses ( ntrees vprocessus, ntrees vtreegfd)
    {
	return n_mergeProcesses ( ntrees vprocessus, ntrees vtreegfd);
    }

    public synchronized void importDeclsFromTo ( ntrees lids, ntrees p, ntrees m)
    {
	return n_importDeclsFromTo ( ntrees lids, ntrees p, ntrees m);
    }

    public synchronized void removeDeclsFrom ( ntrees lids, ntrees p)
    {
	return n_removeDeclsFrom ( ntrees lids, ntrees p);
    }

    public synchronized void setNameModel ( ntrees m, ptident vident)
    {
	return n_setNameModel ( ntrees m, ptident vident);
    }

    public synchronized ntrees copy ( ntrees p, boolean copyattr)
    {
	return n_copy ( ntrees p, boolean copyattr);
    }

    public synchronized ntrees setLocalDeclarations ( ntrees p, ntrees ndecls)
    {
	return n_setLocalDeclarations ( ntrees p, ntrees ndecls);
    }

    public synchronized ntrees mkTreeExternalImplLanguage ( integer cl)
    {
	return n_mkTreeExternalImplLanguage ( integer cl);
    }

    public synchronized boolean mkTreeSelectedPragma ( ntrees prag, ptrepstr vstrcomment, ntrees *vt)
    {
	return n_mkTreeSelectedPragma ( ntrees prag, ptrepstr vstrcomment, ntrees *vt);
    }

    public synchronized ntrees updateModule ( ntrees vhierarchie)
    {
	return n_updateModule ( ntrees vhierarchie);
    }

    public synchronized ntrees mkCompleteModelCall ( ntrees process)
    {
	return n_mkCompleteModelCall ( ntrees process);
    }

    public synchronized ntrees removeNilTree ( ntrees l_proc)
    {
	return n_removeNilTree ( ntrees l_proc);
    }

    public synchronized void addLabelsInModel ( ntrees lids, ntrees p)
    {
	return n_addLabelsInModel ( ntrees lids, ntrees p);
    }

};

