/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

// Treated pragmas by Signal environment.
// -------------------------------------

// no comment!
#define PRAGMA_COMMENT 0 
#define PRAGMA_NOTE  1

// Compiling directive
#define PRAGMA_MAIN  2
#define PRAGMA_UNEXPANDED  3
// DC+ Virtual machine pragmas
#define PRAGMA_SEPARATE  4

#define PRAGMA_CLUSTER  5

// Separated Compilation
#define PRAGMA_BLACK_BOX  6
#define PRAGMA_GREY_BOX  7
#define PRAGMA_DELAYCLUSTER  8

// Misc. Assigned to a node specifying a conversion. The C code for integer(x) will be (int) x
#define PRAGMA_CONVERSION  9

// Code Generator directive
// The user can specify its own code for external model
#define PRAGMA_CODEGEN_C  10
#define PRAGMA_CODEGEN_CPP  11
#define PRAGMA_CODEGEN_JAVA  12

#define PRAGMA_CODEGEN_THREADSJAVA  13
#define PRAGMA_CODEGEN_VHDL  14

// Used for profiling 
#define PRAGMA_PROCESSOR_TYPE  15

// Link with Sigali tool.
#define PRAGMA_SIGALI  16

// Used for clock system solving 
#define PRAGMA_DEFINED_CLOCK_HIERARCHY  17

// Partitionning information RunOn <string>
#define PRAGMA_RUN_ON  18

// Distributed code generation.
#define PRAGMA_MASTER        19
#define PRAGMA_SLAVES        20
#define PRAGMA_COMM_ENV      21
#define PRAGMA_COMM_RECEIVE  22
#define PRAGMA_COMM_SEND     23

#define PRAGMA_TOPOLOGY     24
#define PRAGMA_TARGET       25

#define PRAGMA_SELECTED_OTHERS_PARTITION  26
#define PRAGMA_MORPHISM      27

// alias to PRAGMA_RUN_ON
#define PRAGMA_BINDING 28
#define PRAGMA_BINDINGIO 29

#define PRAGMA_PROCESSOR_NAME 30
#define PRAGMA_BUS 31
#define PRAGMA_CONNECTION 32
#define PRAGMA_RESTRICTED_MODES 33

#define PRAGMA_CODEGEN_C_IMPORT  34
#define PRAGMA_CODEGEN_CPP_IMPORT 35
#define PRAGMA_CODEGEN_JAVA_IMPORT 36

#define PRAGMA_CODEGEN_C_DECLARE 37
#define PRAGMA_CODEGEN_CPP_DECLARE 38
#define PRAGMA_CODEGEN_JAVA_DECLARE 39
#define PRAGMA_GENERATED_FROM 40

#define PRAGMA_SIGNAL_THREAD 41

#define LAST_PRAGMA_NUMBER PRAGMA_SIGNAL_THREAD
#define NB_PREDEFINED_PRAGMAS LAST_PRAGMA_NUMBER

