/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef __SignalPrinter__
#define __SignalPrinter__

typedef class SignalPrinter * ptSignalPrinter;
#include "intePrinter.h"
class SignalPrinter
{
 #include "SignalPrinter_m.h"
 #include "SignalPrinter_g.h"

 protected:
  boolean notannounced, stdMode;
  ptintePrinter this_intePrinter;

  integer unarylevel; // managed in racunparse
  boolean viscomm;    // managed in racunparse
  integer vholoph; // managed in treeunparse
  ntrees treeunparseTree;       // managed in treeunparse
  noperators voperator;  // managed in treeunparse and ischildprint
  ntrees operande; // managed in treeunparse and ischildprint
  boolean shorten_clocks; // option for the unparsing of the unary when.
};

extern ptSignalPrinter pK_SignalPrinter; ///< Predefined object.
#endif
