/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
   Constructor.
   Such an object offers some functionalities (unparse(), print(), fileUnparse()) for printing a Signal abstract tree
   into a text.
   See initPrinter() for the initialisations.
   By default the expression "when C" is printed [:c], "when not C" is printed [/:c]. See setPrintOptionUnaryWhen().
 */
/*SignalPrinter::*/SignalPrinter( void );

/**
   Destructor.
 */
/*SignalPrinter::*/~SignalPrinter( void );

/**
  Printing a tree in a textual form with depth-printing.
  @param aTree (in) the tree to print.
  @param holoph (in) printing depth; when it is null, the tree is not printed it is replaced by a holophraste.
 */
virtual void /*SignalPrinter::*/unparse( ntrees aTree ,int holoph );

/**
   Similar to unparse() method. The text is not terminated by a line feed.
   Printing a tree in a textual form. 
   @param aTree (in) the tree to print.
 */
virtual void /*SignalPrinter::*/unparse1( ntrees aTree );

/**
  Printing a tree in a textual form with depth-printing.
  It realises the travel of the operand tree, calls indentation functions, prints the comment attribute.

  @param p (in) the tree to print.
  @param cbuf (in) printing buffer.
  @param name (in) prefix of the output file name. 
         It will be completed by a prefix given by the output directory (user option)
	 and completed by the signal predefined suffix.
  @param holoph (in) printing depth. When it is null, the tree is not printed, it is replaced by a holophraste.
  @param outputMode (in) : output mode (file, window, ...).
  @param effName (out) : the effective name of the file (file mode) or name.
  @return true, if the text has been printed, false otherwise (permissions problem, a keyword table is missing,...).
 */
virtual boolean /*SignalPrinter::*/fileUnparse( ntrees p ,ptrepbuf cbuf ,ptrepstr name ,int holoph ,printModeType outputMode ,ptrepstr* filePathName );

/**
  Printing a tree in a textual form with depth-printing.
  It realises the travel of the operand tree, calls indentation functions, prints the comment attribute.

  @param p (in) the tree to print.
  @param cbuf (in) printing buffer.
  @param name (in) prefix of the output file name. 
         It will be completed by a prefix given by the output directory (user option)
	 and completed by the signal predefined suffix.
  @param holoph (in) printing depth. When it is null, the tree is not printed, it is replaced by a holophraste.
  @param outputMode (in) : output mode (file, window, ...).
  @return true, if the text has been printed, false otherwise (permissions problem, a keyword table is missing,...).
 */
virtual boolean /*SignalPrinter::*/fileUnparse( ntrees p ,ptrepbuf cbuf ,ptrepstr name ,int holoph ,printModeType outputMode );

/**
  Printing a tree in a textual form into a file.
  @param p (in) the tree to print.
  @param cbuf (in) printing buffer.
  @param name (in) output file name.
  @return true, if the text has been printed, false otherwise (permission problems,...) 
 */
virtual boolean /*SignalPrinter::*/fileUnparse( ntrees p ,ptrepbuf cbuf ,ptrepstr fileNamePath );

/**
   It sets the printer to "textual" (resp. "graphical") mode when not graphiContext (resp. when graphiContext)
   @return the value of the printer mode before the call to this method, with 
   - "true" for a graphical mode (the comments are not printed).
   - "false" otherwise, this is the textual mode and the comments are printed.
 */
virtual boolean /*SignalPrinter::*/setPrinterContext( boolean graphiContext );

/** Signal printing finalizing.  */
virtual void /*SignalPrinter::*/end( void );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*SignalPrinter::*/reset( void );

/**
   When b is "true", the unary when is printed when C.
   Otherwise the shorten forms [:c] for when C, and  [/:c] for when not C, are used.
 */
void /*SignalPrinter::*/setPrintOptionUnaryWhen( boolean b );


