/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#define hocyclesuff "CYC"
#define hodbgsuff "DBG"
#define holissuff "LIS"
#define hoclusuff "CLU"
#define hodissuff "DIS"
#define hoextractsuff "BOOL"
#define CstParam "PARAM"

/// buffer used for printing
ptrepbuf xfilebuf;

/**
  Calling to the SIGNAL pretty printer.
  @param s (in) the abstract tree to print
  @param holoph (in) depth printing (when it is reached, the text is not printed, it is replaced by ...)
  @param om (in) output mode (file, screen...)
  @param filename (in) the name of the file.
  @param infomess (in) a number of the message to print in the user window, no annnounce when the "undefinedMessage" value is used.
  @return "true" if operation succeeds, false otherwise (permission problems,...).
*/

static boolean
decsig (ntrees aTree, ptrepstr fileName, int infomess)
{
  ptrepstr filePathName;
  if (pK_SignalPrinter->fileUnparse (aTree, xfilebuf, fileName, 9999, ofile, &filePathName))
    {
      if (infomess != undefinedMessage)
	pK_messenger->globalMessageStr (infomess, filePathName);
      return pk_true;
    }
  pK_messenger->globalMessageStr (ErrWritingFile, fileName);
  return pk_false;
}
