/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#define TREE_COMMENTS_PRE_ATTRIBUTENUMBER 4093
#define TREE_VM_ATTRIBUTENUMBER 4094
#define TREE_COMMENTS_POST_ATTRIBUTENUMBER 4095

/**
   It adds an annotation (vattrtree) to  a tree (t) as  the  numattr-th attribute. 
*/
static void
add_attr (short numattr, ntrees t, ntrees vattrtree)
{
  ntrees vattr;
  int i, n;
  // nDEBUG_subtree(0,10,"entering add_attr t is", t);
  if (nattrexist (t, numattr))
    {
      vattr = nattrntrees (t, numattr);
      if (noper (vattrtree) == opcomments)
	{
	  n = ntreearity (vattrtree);
	  for (i = 1; i <= n; i++)
	    ntreeList_appendLast (vattr, nchild (i, vattrtree));
	}
      else
	ntreeList_appendLast (vattr, vattrtree);
    }
  else
    {
      if (noper (vattrtree) == opcomments)
	nmakeattrntrees (t, numattr, vattrtree);
      else
	nmakeattrntrees (t, numattr, LL_make_comments_list (vattrtree));
    }
  // nDEBUG_subtree(0,10," exiting add_attr t is", t);
}


/**
   @return "true" if a tree (t) is annotated with an attribute (numattr) with varb as value, "false" otherwise.
*/
static boolean
get_attr (short numattr, ntrees t, ntrees * varb)
{
  if (!nattrexist (t, numattr))
    return pk_false;
  *varb = nattrntrees (t, numattr);
  return pk_true;
}
