/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef __BatchCompiler_H__
#define __BatchCompiler_H__

#include "BatchCompiler_type.h"
#include "pKServicesAPI.h"

class BatchCompiler:public pKServicesAPI
{
#include "BatchCompiler_m.h"
#include "BatchCompilerCommandAnalysis_i.h"
#include "BatchCompilerWizard_i.h"
#include "BatchCompiler_g.h"

private:
   ptOptionManager OM;  ///< option manager used to analyze the command line.
   boolean recallMode; ///< false by default, set to true when the supervisor is recalled.
   boolean this_erroredParsing;
   int this_commandIndex, this_strArrayLength;
   char * this_commandOption;
   char * this_lwCommandOption; /* command option in lower case letters */
   char * this_commandArgument;
   ptrepstr this_commandRepstr; ///< command line of the compiling.
   boolean Testing_reducingCommunications_assClock, Testing_reducingCommunications_b; ///< wizzard
};

#endif // __BatchCompiler_H__


