/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/


/**
   Redefined in GUI source.
   Writing on screen left spaces following by the string str.
*/
extern void
sysscreen (int left, ptreg str)
{
  int i, lg;
  char c;

  if (left != 0)
    {
      c = ' ';
      for (i = 1; i <= left; i++)
	fwrite (&c, sizeof (c), 1, stdout);
    }
  lg = nregGet_usedSize (str);
  if (lg > 0)
    for (i = 1; i <= lg; i++)
      {
	c = nregGet_char (str, i);
	fwrite (&c, sizeof (c), 1, stdout);
      }
  // c = '\n'; fwrite(&c, sizeof(c), 1, stdout);
}

/**
   Writing a new line on the screen.
*/
extern void
sysscreenln ()
{
  char c;

  c = '\n';
  fwrite (&c, sizeof (c), 1, stdout);
}

/**
   GUI Specific.
   Do nothing. Redefined in GUI source.
*/
extern void
sysgraph (int left, ptreg str)
{
}
