/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef __Trees2Kernel__
#define __Trees2Kernel__

#include <map>
typedef class Trees2Kernel *ptTrees2Kernel;
typedef std::map<ptrepstr, ptrepfi> libTableType;
typedef std::map<ptlrepid, ptlrepid> TablePredConstTypeType;

class Trees2Kernel
{
#include "Trees2Kernel_m.h"
#include "Trees2KernelGraphical_i.h"
#include "Trees2KernelModules_i.h"
#include "Trees2Kernel_g.h"

protected:
  ntrees listpro;                    ///< list of models of the current model.
  ptlrepid G_listOfReferencedModels; ///< list of referenced models; used to define external objects.
  ptrepfi G_process;                 ///< Current compiled model.

  ptIdStack unnamedStack;     ///< predefined stack for "unnamed" flow.
  ntrees operande;          ///< current compiled tree.
  noperators voperator;         ///< coperator of operande (current compiled tree).
  ptlrepid lindex,             ///< list of indexes of the current compiled model.
    G_ExternalOutputsModel,    ///< list of (local) signals of the current compiled model referenced outside the model..
    G_ExternalInputsModel;     ///< list of signals of the current compiled model referenced in the model, but not defined in the model, not declared as input.
  ptrepfi moduleInstrinsics;   ///< list of the instrinsics.
  ptStack toppilefc;         ///< internal stack :visited children of a list.
  boolean GUIContext,            ///< Context information: "true" for GUI calls.
	bWarSafeRestict,       ///< Safe is implemented as Unsafe (restriction)
        intrinsicLoading,      ///< context information: at "true" for the imports of the intrinsics.
	outputMode;            ///< context information: "true" for compiling left-part of equations, "false" othewise.
    libTableType loadedLibraries;
    // Managing the precedences for constants and types of a block.
    TablePredConstTypeType lpredConstTypes;
    boolean modeConstTypeCompiling;
    ptlrepid currentTypeConst, lConstTypesCurrentBlock ;
    
};


extern Trees2Kernel* pK_Tree2Kernel ; // Predefined Object

#endif
