/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/**
   It finalizes the compiling of the module represented by aModule:
     - labels cannot be declared in a module;
     - Signals cannot be declared in a module;
     - private models are removed.
 */
virtual void /*Trees2Kernel::*/moduleFinalize( ptrepfi aModule );

/** 
    @return the sub-list of a list of models (lsModel) composed of the models annotated by the pragma "main", or 
    or all the models when it does not exist one annotated with the pragma.
 */
ptlrepid /*Trees2Kernel::*/selectMainProcesses( ptlrepid lsModel ,ntrees x );

/**
   Compiling a Signal module.
   @return the kernel tree representation associated with a abstract tree module (aModule).
   @param aModule (in) a module represented as an abstract tree produced by the Signal syntactic analyzer.
   @param varid (out) stack associated with the name of the compiled module.
 */
virtual ptrepfi /*Trees2Kernel::*/moduleCompiling( ntrees aModule ,ptIdStack* varid );

/**
   Compiling a list of Signal module (lmodules).
   @return the kernel tree representation of the compiled list.
   @param lmodules a list of modules represented as an abstract tree produced by the Signal syntactic analyzer.
   @param oneModule (out) "true" if the size of the list is equal to 1, "false" otherwise. 
   In fact, the Signal grammar accepts several modules in a file, but our implementation restricts to one 
   module by file.
 */
ptlrepid /*Trees2Kernel::*/modulesListCompiling( ntrees lmodules ,boolean* oneModule );

/** Loading a Signal library from a file (strfilename).
    @return "true" if the operation succeeds, "false" otherwise.
 */
boolean /*Trees2Kernel::*/parseLibrary( ptrepstr strfilename ,ntrees* module );

/**
   Signal intrinsics.

   Pops the modules, stored in "moduleInstrinsics" field of the class, of Signal intrinsics.
 */
void /*Trees2Kernel::*/popIntrinsics( void );

/**
   Signal intrinsics.
   
   This method annotates the Signal intrinsics by a predefined attribute (see setInstrinsicAttribute()).
 */
void /*Trees2Kernel::*/AttributeIntrinsics( void );

/**
   Signal intrinsics.

   Compiling a library of intrinsics (Signal module) represented as an abstract tree (vlib) produced by the Signal parser.
   It stores the result in the field moduleInstrinsics  of the Trees2Kernel class.
 */
virtual void /*Trees2Kernel::*/loadIntrinsicLibrary( ntrees vlib );

/**
   @return "true" if it exists a file idNameFile.LIB or idNameFile.SIG using the SIGNAL_LIBRARY_PATH to found the absolute adress of this file.
   "false" otherwise.
   idNameFile.LIB is prior on idNameFile.SIG.
 */
boolean /*Trees2Kernel::*/getFileNameLibrary( ntrees idNameFile ,ptrepstr* fileName );

/**
   Loading (compiling) the SIGNAL program (assumed to be a library module) defined in a file (idNameFile). 
   It uses the SIGNAL_LIBRARY_PATH to found the absolute adress of the file.
   It calls the Signal parser and modulesListCompiling() method to produce the kernel tree representation (aModule) 
   from the abstrat tree (produced by the parser).
   @return "true" if the operation succeeds, "false" otherwise.
   \note: (Restriction) the Signal grammar accepts several modules in a file, but our implementation restricts to one 
   module by file.
 */
virtual boolean /*Trees2Kernel::*/loadLibraryFile( ntrees aImportedModule ,ptrepfi* aModule );

/**
   Similar to loadLibraryFile(). It was also the entry point for compiling the "use M.P" syntatic struture which 
   allows to select a model (P) in a module (M). This strucutre has bee removed from Signal grammar.

   @param aImportedModule (in) the name of an imported object (module).
   @param  aModule (out) the kernel tree representation (aModule) produced by loadLibraryFile() method.
   @return "true" if the operation succeeds, "false" otherwise.
 */
virtual boolean /*Trees2Kernel::*/importOfModule( ntrees aImportedModule ,ptrepfi* aModule );

/**
   Compiling a reference to modules (Signal Syntax : use M1, ..Mn).
   @param limports (in) list of names of modules (ie M1,...,Mn)
   @param lvfi (in/out) list of modules, in kernel tree representation, in which models are added taking account  visibility rules.
 */
virtual void /*Trees2Kernel::*/importOfModules( ntrees limports ,ptlrepid* lvfi );


