/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation121
, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#define GETBUF_REGISTER() this_buffer
#define CREATEBUF_() strregnew(&this_buffer)
#define RESETBUF_() strregreset(this_buffer)
#define DELETEBUF_() strregfree(this_buffer)
#define LINKBUF_() sysbuflink(this_file, this_buffer)
#define WRITEBUF_CHAR(ACHAR) strregconccha(this_buffer, ACHAR)
#define WRITEBUF_NCHAR(ACHAR, TIMES) strregconcmcha(this_buffer, ACHAR, TIMES)
#define WRITEBUF_ALFA(ANALFA, ITSLENGTH) strregconcalfatoreg(this_buffer, ANALFA, ITSLENGTH, pk_false)
#define WRITEBUF_REPSTR(AREPSTR) strregconcstr(this_buffer, AREPSTR, pk_false)
#define WRITEBUF_STRING(ASTRING) WRITEBUF_REPSTR(string2repstr(ASTRING))
#define WRITEBUF_REG(AREG) strregconcreg(this_buffer, AREG, pk_false)
#define GETBUF_SIZE() (nregGet_usedSize(this_buffer))
#define GETBUF_CHAR(APOS) (nregGet_char(this_buffer, APOS))
#define ISBUF_EMPTY() (GETBUF_SIZE() == 0)
#define DISPLAYBUF_SCREEN(LENGTH) sysscreen(LENGTH, this_buffer)
#define DISPLAYBUF_GRAPH(LENGTH) sysgraph(LENGTH, this_buffer)
#define DISPLAYBUF_FILE() syswriteln(this_file, this_buffer)

_PRIVATE_
/**
   @return  the current value for the tabluation.
*/
  integer buffer::getCurrentTabulValue ()
{
  if (tabul == NILLMARK)
    return 0;
  return ptlMark_top (tabul);
}


/**
   @return  the current value for the indentation.
*/
integer
buffer::getCurrentIndentValue ()
{
  if (indent == NILLMARK)
    return 0;
  return ptlMark_top (indent);
}

/**
   @return  the max value for the indentation.
*/
integer
buffer::getMaxIndentTabul ()
{
  integer vindent, vtabul;
  vindent = getCurrentIndentValue ();
  vtabul = getCurrentTabulValue ();
  if (vindent > vtabul)
    return vindent;
  return vtabul;
}

/**
   It Ajusts the left margin of the buffer by adding necessary spaces.
 */
void
buffer::ladjust ()
{
  if (GETBUF_SIZE () == 0)
    curl = getMaxIndentTabul ();
}
