/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/


#define KWSUFF "kw"
#define maxpasse 10

static int loadedTab[maxpasse + 1];	//loadedTab[i] is set to pk_true when the i-th table of messages is loaded.

static ptreptab taberrinterne[maxpasse + 1];
static ptreptab taberrfatale[maxpasse + 1];
static ptreptab tabinfo[maxpasse + 1];
static ptreptab taberr[maxpasse + 1];
static ptreptab tabwarning[maxpasse + 1];
static ptreptab tabcomment[maxpasse + 1];

static ptindtab saveindpass, indpasse;

static ptrepstr iemmess;	///< current message
static int pmsch;		///< index on iemmess


/** @return 
     - "true" if the table of messages defined in a file (filename) is loaded,
     - "false" when the operation failed (file does not exist, permission denied,....)
*/
static boolean
tabloaddia (ptreptab * res, char *filename)
{
  if (!strTableLoad (res, filename))
    return pk_false;
  tabcomment[indpasse] = strDiaTableLoad (*res, 0);
  taberr[indpasse] = strDiaTableLoad (*res, 1);
  taberrfatale[indpasse] = strDiaTableLoad (*res, 2);
  tabinfo[indpasse] = strDiaTableLoad (*res, 3);
  taberrinterne[indpasse] = strDiaTableLoad (*res, 4);
  tabwarning[indpasse] = strDiaTableLoad (*res, 5);

  loadedTab[indpasse] = pk_true;
  return pk_true;
}
