/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef __SME_Printer__
#define __SME_Printer__

typedef class SME_Printer * ptSME_Printer;

#include <map>
class SME_Printer  : public SignalPrinter
{
 #include "SME_Printer_m.h"
 #include "SME_Printer_g.h"

 protected:
  ptrepstr currentName; //< name context.
  integer cpt; //< counter used to fix the undefined SME:id of an unreferenced tree.
  ptrepstr undefSMEId; //< prefix of an undefined SME identifier, suffixed by the current value of cpt.
  boolean FirstHeader; //< tag used to generate xmlns information once.
  std::map<integer, integer> Names_Table;
  std::map<ptrepstr, integer> formalIdNames_Table;
  ntrees currentModule;
  ptreptab SMEbasekeyword;
  integer visibilityKW; //< private/public attribute
  boolean assertContext; //< Context for assertion area(true for the printing of the operand of assert(| |), false otherwise)
};

#endif
