/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef __SME_SyntaxRestriction__
#define __SME_SyntaxRestriction__


typedef class SME_SyntaxRestriction *ptSME_SyntaxRestriction;
#define NILXMISYNTAXRESTRICTION (ptSME_SyntaxRestriction)pK_NIL

class SME_SyntaxRestriction : public Trees2Kernel
{
#include "SME_SyntaxRestriction_m.h"
#include "SME_SyntaxRestriction_g.h"
 protected:
  ptident idNil; ///< the nil identifier.
  integer cptIds; ///< counter of the created new identifiers.
  ntrees lfeed, ///< list of added equations (managed by block).
    lids; ///< list of the current added identifiers (managed by block)
  boolean Ok; /**< status code of the translator: 
		 - "true" successesful of the translation.
		 - "false" the translation failed (not yet implemented structure)
	      */
};

#endif
