/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef __SME_Translator__
#define __SME_Translator__

#include <map>

typedef class SME_Translator *ptSME_Translator;
#define NILSMETRANSLATOR (ptSME_Translator)pK_NIL
typedef std::map<ntrees, ntrees> TypeRefTable;
typedef TypeRefTable *ptTypeRefTable;

class SME_Translator : public Trees2Kernel
{
#include "SME_Translator_m.h"
#include "SME_Translator_g.h"
 protected:
  ntrees currentBlock, ///< current block
    currentModule, ///< current compiled module.
    currentModel,///< current compiled model.
    topModel; ///< the main model or module.
    boolean modeSME; /**< current SME mode: 
		      - "true" : the expression is solved to define the connections,
		      - "false" the expression will be a Signal text in the xmi file.
		   */
    integer cpt, ///< counter to define the xmi identifiers.
      cptName; ///< counter to define the added named constants.
  ptrepstr addedNameStr; ///< prefix used to define the name of the added named constants.

  libTableType FirstStepLoadedLibraries; // Table of the loaded library in the XmiSyntacticRestriction (the trees are already modidied)
  boolean Ok; /**< status code of the translator: 
		 - "true" successesful of the translation.
		 - "false" the translation failed (not yet implemented structure)
	      */

  ptTypeRefTable RefTable;
};

#endif
