/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

// If the number of operators is modified, you must update the file $Signal_environment/polychronyLangOperators.h
#include "polychronyLangOperators.h"

// Operators added for Xmi, used to define the attributes.
// Caution : these trees cannot be duplicated by the standart copy (STree_copy() because it uses the arity).
// SIG_NB_OPERATORS is the last number associated with a SIGNAL operateur
#define opSMEid opnom 

#define opSMEvalue 1 +SIG_NB_OPERATORS
#define opDataflowConnection 2 +SIG_NB_OPERATORS
#define opConditionConnection 3 +SIG_NB_OPERATORS
#define opClockRelationConnection 4 +SIG_NB_OPERATORS
#define opSMEdef 5+SIG_NB_OPERATORS
#define opsrc_dfc 6+SIG_NB_OPERATORS
#define opdst_dfc 7+SIG_NB_OPERATORS
#define opsrc_condc 8+SIG_NB_OPERATORS
#define opdst_condc 9+SIG_NB_OPERATORS

#define opsrc_clockc 10+SIG_NB_OPERATORS
#define opdst_clockc 11+SIG_NB_OPERATORS

#define opSMEList 12+SIG_NB_OPERATORS
#define oploports 13+SIG_NB_OPERATORS
#define opport 14+SIG_NB_OPERATORS
#define opSMEtag 15+SIG_NB_OPERATORS

#define opConstantAffectation 16+SIG_NB_OPERATORS
#define opsrc_cstaff 17+SIG_NB_OPERATORS
#define opdst_cstaff 18+SIG_NB_OPERATORS

#define opCaseConnection 19+SIG_NB_OPERATORS
#define opsrc_case 20+SIG_NB_OPERATORS
#define opdst_case 21+SIG_NB_OPERATORS

#define opDependenceConnection 22+SIG_NB_OPERATORS
#define opsrc_dependences 23+SIG_NB_OPERATORS
#define opdst_dependences 24+SIG_NB_OPERATORS
#define opSMEImportList 25+SIG_NB_OPERATORS
#define opSMEImportType 26+SIG_NB_OPERATORS
#define opSMEImportCons 27+SIG_NB_OPERATORS
 
#define opSMESignalRef 28+SIG_NB_OPERATORS
#define opSMEConstantRef 29+SIG_NB_OPERATORS
#define opSMEModelRef 30+SIG_NB_OPERATORS
// opSMETypeRef doest not exist ?



#define LL_make_SMEList_emptyList() nmakemptylist(opSMEList)
#define LL_make_SMEdef_emptyList() nmakemptylist(opSMEdef)
#define LL_make_SMEImportList_emptyList() nmakemptylist(opSMEImportList)
#define LL_make_loports_emptyList() nmakemptylist(oploports)
#define LL_make_SMEList_emptyList() nmakemptylist(opSMEList)
#define LL_make_SMEList_emptyList() nmakemptylist(opSMEList)
