/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#define IKWundef -1

#define IKWparameters 0  
#define IKWinputs 1
#define IKWoutputs 2
#define IKWlocals 3
#define IKWconstants 4
#define IKWtypes 5
#define IKWspec 6
#define IKWname 7
#define IKWsme 8
#define IKWxmi 9
#define IKWversion 10
#define IKWtype 11
#define IKWid 12
#define IKWxml 13
#define IKWxsi 14
#define IKWModelDeclaration 15
#define IKWconnections 16
#define IKWsrc_DataflowConnections 17
#define IKWdst_DataflowConnections 18
#define IKWsrc_conditions 19
#define IKWdst_condition 20
#define IKWsrc 21
#define IKWdst 22
#define IKWValue 23
#define IKWoperators 24
#define IKWDelay 25
#define IKWExtraction 26
#define IKWMerge 27
#define IKWArithmeticOperator 28
#define IKWComparisonOperator 29
#define IKWoperatorParent 30
#define IKWoperator 31
#define IKWClockRelation 32
#define IKWDataflowConnection 33
#define IKWCondition 34
#define IKWconditionKind 35
#define IKWbooleanExprSrc 36
#define IKWsignalSrc 37
#define IKWConstraints 38
#define IKWconstant 39
// #define IKWConstantRef 40
#define IKWreferences 41
#define IKWins 42
#define IKWfirstOperand 43
#define IKWSecondOperand 44
#define IKWInitialValue 45
#define IKWLiterals 46
#define IKWClockConstraintOperator 47
#define IKWClockRelationOperator 48
#define IKWClockSpeedOperator 49
#define IKWinitValue 50
#define IKWin 51
#define IKWVar 52
#define IKWCell 53
#define IKWWindow 54
#define IKWWindowSize 55
#define IKWsrc_clockRelation 56
#define IKWdst_clockRelation 57
#define IKWArrayDimensions 58
#define IKWRefModel 59
#define IKWRefInterface 60
#define IKWModule 61
#define IKWparameter 62
#define IKWinput 63
#define IKWoutput 64
#define IKWencoding 65
#define IKWxmlns 66
#define IKWcomment 67
#define IKWand 68
#define IKWor 69
#define IKWxor 70
#define IKWnot 71
#define IKWnullClock 72
#define IKWNbInstants 73
#define IKWModelDeclarations 74
#define IKWIf 75
#define IKWSrcField 76
#define IKWDstField 77
#define IKWConfinedProcess 78
#define IKWUminus 79
#define IKWConstantAffectation 80
#define IKWsrc_cstaff 81
#define IKWdst_cstaff 82
#define IKWEnumerationType 83
#define IKWEnumerationValue 84
#define IKWSubstitutionType 85
#define IKWisExternal 86
#define IKWTupleType 87
#define IKWbundle 88
#define IKWModelType 89
#define IKWCaseConnection 90
#define IKWsrc_case 91
#define IKWdst_case 92
#define IKWSwitch 93
#define IKWsignal 94
#define IKWcaseKind 95
#define IKWEnumeration 96
#define IKWenumeration 97
#define IKWClosedOpenedInterval 98
#define IKWOpenedClosedInterval 99
#define IKWOpenedOpenedInterval 100
#define IKWClosedClosedInterval 101
#define IKWlowerBound  102
#define IKWupperBound  103
#define IKWElseCase 104
#define IKWDependence 105
#define IKWsrc_Dependences 106
#define IKWdst_Dependences  107
#define IKWDependenceOperator 108
#define IKWTransposition 109
#define IKWConcatenation 110
#define IKWCounter 111
#define IKWrepetition 112
#define IKWNbrepetitions 113
#define IKWArrayProduct 114
#define IKWComplexOperator 115
#define IKWCartesianProduct 116
#define IKWIndex 117
#define IKWfrom  118
#define IKWto 119
#define IKWstep 120
#define IKWindexes 121
#define IKWouts 122
#define IKWnext 123
#define IKWarrayRestructuration 124
#define IKWarrayEnumeration 125
#define IKWIterate 126
#define IKWiterationInit 127
#define IKWmodelType 128
#define IKWfunction 129
#define IKWnode 130
#define IKWaction 131
#define IKWprocess 132
#define IKWvisibility 133
#define IKWprivate 134
#define IKWpublic  135
#define IKWmodelClass 136
#define IKWsafe 137
#define IKWunsafe 138
#define IKWdeterministic 139
#define IKWassertions 140
#define IKWpragmas 141
#define IKWpragma 142
#define IKWtargets 143
#define IKWexpression 144
#define IKWprocessorTypePragma 145
#define IKWrunOnPragma 146
#define IKWcompilationDirectivePragma 147
#define IKWhref 148
#define IKWconstantValue 149
#define IKWtypeRef 150
#define IKWuse 151
#define IKWmodules 152
#define IKWcCodePragma 153
#define IKWcppCodePragma 154
#define IKWjavaCodePragma 155
#define IKWTupleOperator 156
#define IKWBasicIterate 157
#define IKWIterator 158
#define IKWArrayRecovery 159
#define IKWSignalRef 160
#define IKWConstantRef 161
#define IKWModelRef 162
#define IKWStatusKind 163
#define IKWStatevar 164
#define IKWShared 165
#define IKWCstName 166
#define IKWRefEnumerationValue 167
#define IKWTypeValue 168
#define IKWAssertionClockConstraintOperator 169
#define IKWAssertionClockSpeedOperator 170
//--------- Flags 
// ----------------------------------------------------------------------------------------------
// WARNING: The FirstFlag constant MUST BE DEFINED by the last of the previous keyword number + 1
// ----------------------------------------------------------------------------------------------
#define FirstFlag IKWAssertionClockSpeedOperator+1
#define undefFlag -1
#define trueFlag 0
#define falseFlag 1
#define useSrcClockFlag 2
#define partialDefFlag 3
#define defaultValuepartialDefFlag 4
#define castTypeFlag 5
#define conditionKindFlag 6
#define presentFlag 7
#define kindFlag 8
#define externalFlag 9
#define counterKindFlag 10
#define useLastIterationValueFlag 11
// Because a subset of pragmas are treated as particular cases!!!
#define mainFlag 12
#define sigaliFlag 13
#define BlackBoxFlag 14
#define GreyBoxFlag 15
#define DelayClusterFlag 16
#define separateFlag 17
#define unexpandedFlag 18
#define TrueFlag 19
#define FalseFlag 20
