/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/


_PUBLIC_
/**
   Constructor.

   @param t (in) table of the loaded libraries by for example a previous step of this one.
   In our case, some Signal constructions are rewritten in the class XmiSyntaxRestriction before calling this translation. 
   So, we need the modified form.
*/
  SME_Translator::SME_Translator (libTableType t)
{
  Ok = pk_true;
  GUIContext = pk_false;
  cpt = 0;
  cptName = 0;
  addedNameStr = string2repstr ("_V_");
  SET_NILTREE (currentBlock);
  modeSME = pk_false;
  SET_NILTREE (currentModule);
  SET_NILTREE (currentModel);
  SET_NILTREE (topModel);
  FirstStepLoadedLibraries = t;
}


/**
   Destructor.
*/
SME_Translator::~SME_Translator ()
{
}

/**
   @return "true" if the translation is complete, "false" otherwise (not yet implemented construction,...).
*/
boolean SME_Translator::getStatusCode ()
{
  return Ok;
}
