/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/**
   It prints an external representation (Signal code) of a sub-graph (aSubGraph) of a graph (vgraph).
 */
void /*pKServicesAPI::*/printSubGraph( ptDCG_basic vgraph ,ptINode aSubGraph );

/**
   It prints an external representation (Signal code) of a list of sub-graphs (lSubGraph) of a graph (vgraph).
   It calls printSubGraph() for each.
 */
void /*pKServicesAPI::*/printSubGraphs( ptDCG_basic vgraph ,ptlINode lSubgraph );

/**
   Specific to the morphism functionality.
   @return 
   - "true" if the internal file "MORPHISM.table" is found in the environment. It defines the translation (morphism) associated with the Signal operators.
   aModule is the graph of this module, one graph by operator.
   - "false" otherwise, aModule is not modified
 */
boolean /*pKServicesAPI::*/mkMorphismModule( ptDCG_poly* aModule );

/**
   Specific to the morphism functionality.
   It adds some use of libraries
    - use STD, COSTBIB, Cost_Context"
    - use XXX, COSTBIB, Cost_Context" where XXX is the value of the pragma "PROCESSOR_TYPE" associated with a graph (og)
    .
    in a tree (hierarchy). 

    Assumed : hierarchy is the result of the mophism operation (profiling) applied to the graph og.
 */
void /*pKServicesAPI::*/addLibraryProfiling( ptDCG_bool og ,ntrees hierarchy );

/**
   Specific to the morphism functionality.\n
   @return "true" if the operation succeeds, "false" otherwise.
   - It loads (mkMorphismModule()) the predefined morphim table called "MORPHISM.table",
   - When this operation succeeds, it builds an operator table (ht object; attribute member of the pKServicesAPI object)
   - When this operation succeeds, it signals that the table is loaded (MLoaded is set to "true")
 */
boolean /*pKServicesAPI::*/loadProfilingModule( void );

/**
   Specific to the morphism functionality.
   @return "true" if the operation succeeds, "false" otherwise.
   It applies a morphism defined by a table (ht) on a graph vgraph.
   The table gives the translation associated to each Signal operator.
 */
boolean /*pKServicesAPI::*/mkMorphism( ptDCG_bool vgraph ,ptHomomorphismTable ht );

/**
   Assumed: P1 and P2 are sub-graphs of the operand graph (vgraph).
   - it applies DCG_poly::encapsulatingClockSystem() on vgraph; It produces the synchronisation part (P3) of vgraph
   - it applies DCG_poly::updateInterfacesSubGraphs() on (P3,P1) and (P3,P2)
   - and calls printSubGraph() for each Pi

   At the end, the graph represents the program (| P1() | P2() | P3() |)
   */
void /*pKServicesAPI::*/binPartitionningEnd( ptDCG_poly vgraph ,ptINode P1 ,ptINode P2 );

/**
   The hierarchy of a basic graph is completed to apply the same methods than a Poly graph (without applying the clock calculus):
   a virtual root is created as root of the hierarchy and all the clocks becomes a child of this vitual root.
   
   The resetEnvForUnparse() must be applied to remove the virtual root.
 */
ptDCG_basic /*pKServicesAPI::*/mkEnvForUnparse( ptDCG_basic vgraph );

/**
   Reset the operations of setIntrinsicClocks(), previously applied in mkEnvForUnparse().
 */
void /*pKServicesAPI::*/resetEnvForUnparse( ptDCG_basic g ,ptDCG_basic g1 );

/**
   Export (Signal file) the subgraph (vPart) of a graph (vgraph).
   The name of the file is the name associated with the sub-graph.

   Assumed: vPart denotes a subgraph of vgraph.
   
   Useful for verifying the correctness of the partitionings.
 */
void /*pKServicesAPI::*/exportPartition( ptDCG_poly vgraph ,ptINode vPart );


