/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/


_PUBLIC_
/**
   Constructor of an hight level interface to the Signal Compiler.
   It gives access to parsing functionalities, graph transformations and code generation.
*/
pKServicesAPI::pKServicesAPI () 
{}

/**
   Destructor.
*/
pKServicesAPI::~pKServicesAPI ()
{
}



/**
   Global initializing of the virtual machine.
   - Tree memory
   - string memory
   - name manager
   - stack manager (why here ?)
   - message manager
*/
void
pKServicesAPI::userbegin_init ()
{
  pKServicesAPImkGraph::userbegin_init ();
  pK_Graph2SignalTreeBuilder->setInterfaceMode (ToolContext == eclipsePlugin);	// useful/necessary for signal2xmi.
}
