/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/


/* Global messages of the batch compiler.
   The constant (i) give access to the i-th message (info or warning or error or fatal error)
   of the table messignal.0.txt provided in $signalBin_data directory.
*/

#define undefinedMessage -1

/* Infos  
   ----- */
#define polychronySignalToolbox_announce 1
#define polychronyCopyright 2
#define BASIC_announce 3
#define usebddInfo 4
#define bddCopyright 5
#define announcesepline 6
#define announceSignalCompletion 7
#define announceSignalFailure 8
#define PARSING_announce 9
#define parameterPARSING_subAnnounce 10
#define errinfolis 11
#define infotra 12
#define infocycle 13
#define infoclos 14
#define infoz3z 15
#define infosyndex 16
#define messline 17
#define infoRestrictionModule1 18
#define infostatistics 19
#define infonbclocks   20
#define infodepthStat      21
#define infobreadth    22
#define infoclu 23
#define infodist 24
#define infodisttraines 25
#define infobool 26
#define InfoHeaderPrinter 27
#define subinfo_PARSING 28
#define infoprint 29
#define infolis  30
#define POLY_announce 31
#define ENDO_announce 32
#define numinfoEndoper 33
#define infosubgraph 34
#define trainesmess 35
#define ProgramWithoutParameter  36
#define traceMess 37
#define infoLustreMess 38
#define error_PARSING 39
#define error_parameterPARSING 40
#define errFileNotFound 41
#define infoNotEndochonousProgram 42
#define BOOL_announce 43
#define ErrEmptyCode 44
#define error_openingFile 45
#define codeNotYetImplemented 46
#define errFileNotaModule 47
#define infoMorphismResult1 48
#define infoMorphismResult2 49
#define infoLoading 50
#define ErrWritingFile 51
#define ErrCycleAddedByReinforcing 52
#define abort1 53 
#define abort2 54
#define infoExclusiveClocks 55
#define infoIncompatibleOptions 56
#define InfoRunConfigFile 57
#define InfoSMEPrinter 58
#define InfoSMENotYetImplemented 59
#define InfoFileNotGenerated 60
#define InfoSynopticPrinter 61
#define InfoEmptyGraph 62
#define InfoSSMEPrinter 63
#define FLAT_announce 64
#define MONO_announce 65
#define ParameterFileRequired 66
#define infolisisf 67
#define subinfo_ISFPARSING 68
#define FORMATPARSING_announce 69
#define SignalExport_announce 70
#define SCHED_announce 71
#define messGeneratorFile 72

/* Errors 
   ------ */
#define commandArgument_VALUE_ERROR  1
#define commandArgument_ATMOSTONE_ERROR 2
#define ERR_TOO_MANY_FILES  3
#define ERR_NO_SRC_FILE 4
#define ERR_UNKNOWN_OPTION 5
#define ERR_NOTAVAILABLE_OPTION 6
#define ERR_NOT_COMPILABLE 7


#define Comment_SIGNALVersion 16
#define Comment_commandline 17

/* Fatal errors
   ----------- */
#define fatalerr_StringTableOverflow 1
