/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/


/* Messages used in the Kernel2Graph translation and in the Graph transformations.
   The constant (i) give access to the i-th message (info or warning or error or fatal error)
   of the table messignal.3.txt provided in $signalBin_data directory.
*/

/* Infos
   ----- */
#define graphGeneration_subAnnounce 1
#define messInfoIn 2
#define clockCalculus_announce 3
#define mbegclockEnvBuilding 4
#define infoopt 5
#define messlequnoprov 6
#define inforewc 7
#define infofreeform 8
#define infonormform 9
#define infosolveroots 10
#define infofactroots 11
#define infocontrroots 12
#define infopostck 13
#define infochrepr 14
#define infomarksigho 15
#define infoInterfaceCalculus 16
#define infodepth 17
#define infonormformrac 18
#define info_hnull 19
#define infoUnused 20
#define infosigmotif 21
#define infoclock 22
#define mbegprojection 23
#define infoTransitiveClosure 24
#define generatorMess 25
#define infoPseudoCycle 26
#define infoCycleAnalysis 27
#define mess_gen_main  28
#define mess_gen_body  29
#define mess_gen_io  30
#define mess_gen_comm  31
#define mess_tasks_dcl 32
#define messUtilityClock 33
#define messAssignmentClock 34
// #define free_35 35
#define mess_gen_types  36
#define mess_gen_externals  37
#define mess_gen_ioExternal  38 
#define mess_gen_bodyExternal  39
#define infoz3zState 40
#define mbeginOper 41
#define mendOper 42
#define mbeginOperName 43
#define mendOperName 44
#define mbadLevelFormat 45
#define mgoodLevelFormat 46
#define mextendedSpec 47
#define mtickFailure 48
#define mexochronous 49
#define dretiming 50
#define defaultInit1 51
#define infoUnify 52
#define messReinforcingDep 53
// #define free_54 54
#define mbegExcluClocks 55
#define opNotApplied 56
#define internalError 57
#define infoExterns1 58
#define mexpandNodeCall 59
#define mincluding 60
// #define free_61 61
#define infoz3zNotStandard 62
#define messOperName 63
#define defaultInit2 64
#define infoEnumNameModified 65
#define infoExceptions 66
#define infoDotFile 67
#define infoGraph2SignalTree 68
#define infoRunOnNotFound 69
#define infoEventDelay 70
#define warInterfaceModified 71
#define infoArchiNotDefined 72
/* Errors
   ------ */
#define errtypesignaldelay 3
#define errStateVar 5
#define errctdim 7
#define errctren1 10
#define errElemType 11
#define errctEffectiveFormal 14
#define errMultipleDefinition 15
#define errctUnexpectedType 16
#define errctaff1 17
#define errctaff2 18
#define errOutOfBound 19
#define errctlogiq 25
#define errctreltab 30
#define errctarithm 32
#define errNotTypedId 33
#define errctconc2 37
#define errnotimplemented 38
#define errTypeParamNotAllowed 39
#define errenumvalue 41
#define errctsormotif1 42
#define errctmotif2 43
#define errctmotif3 44
#define errctelem1 45
#define errUnexpectedExpr 46
#define errUnexpectedValue 47
#define errValueMustBeKnown 48
#define errctTypeExtension 49
#define errctPositiveValue 50
#define errRestrict 51
#define errctfen2 52
#define errcsteint 54
#define errCannotDefineClock 55
#define errcycle 56
#define errctparc1 57
#define errctparc2 58
#define errctIntegerExpected 59
#define errNotConstantExpr 60
#define errhnull 61
#define errinarray 62
#define errcycledep 63
#define errbcldelay 64
#define errcompilerbug 66
#define errrecsystem 67
#define errProfiling 68 
#define errFieldNotDefined  72
#define errRefStateVar  73
#define errDuplCaseValue  74
#define errctNumberOfElements 75
#define errDCGBool2DCGSchInternalError 76
#define errMultipleDefaultValue 77
#define errTypeIndex  78
#define erropnotimpl 79
#define errInterfaceToLanguage 80
#define errOnPragma 81
#define errtypecond 83
#define errArrayClock 84
#define errRestrictionAffineClockValue 85
#define errArrayClockSig 86
#define errBundleType 87
#define errBundleType2 88
#define errTypeStateVar 89
#define errMainModelWithFormalProcess 90
#define errExtensionNotYetImplemented 91
#define errNotBounded 92
#define errCannotAdjustInitvalue 93
#define errNotInitializedAutomaton 94
#define errClockAutomatonAlreadyFixed 95
#define errUndefSignalSignalThread 96
#define errThreadAutomaton 97

/* Warnings  
   -------- */
#define warFileNotFound 1
#define wariosep 2
#define warFalseCycles 3
#define warcontrole 4
// #define warFree_5 5
#define warctinit 6
#define warctinit2 7
#define warcreateinst 8
#define warctparc1 9
#define warctelevec1 10
#define warctelem1 11
#define warsighnull 12
#define warsigunused 13
#define warexphnull 14
// #define warlequnoprov 15
#define warnotlocalized 16
#define warIgnoreInit 17
#define warctValue 18
#define warNoct 19
#define warUntypedSignal 20
#define warLabelAction  21
#define warNoDefaultValue 22
#define warNoDefinition 23
#define warNotDefined 24
#define warDefForUndefinedSignals 25
#define warningAssumptions 26
#define warDCGBool2DCGSch1 27
#define war2kernel 28


/* Comments inserted in the generated code.
   ---------------------------------------- */
#define comment_polychrony 1
#define comm_SignalInit    2
#define comm_DelayTreeEq   3
#define comm_Done          4
#define comm_paramNotDefined 5
#define comm_dclpar      6
#define comm_dclloc      7
#define comm_dclsort     8
#define comm_dclent      9
#define comm_dclclk      10
#define comm_TaskNumber  11
#define comment_commandline free-free
#define comment_actions 13
#define comment_clockrepresentedby 14
#define comment_endorepresentedby 15
#define comment_endointernalclock 16
#define comment_clockconstraint 17
#define comment_clockparameters 18

//----------------------
// These constants should be in a table!!! (to do. LBesnard).

#define cstSetTick "Setting Tick"
#define csttransformToBooleanControl "Events -> Booleans"
#define cstflattenCH "Hierarchy flattening"
#define csttotallyOrder "Sequentializing"
#define cstRunOnPartition "RunOn Partitionning"
#define cstBoolOtherPartition "Control/Actions Partitionning"
#define cstStateOtherPartition "States/Static Partitionning"
#define cstZ3ZGen "Z3Z Generation"
#define cstInputTrain "Inputs Train Calculus"
#define cstConstraintsAsExceptions "IGraphConstraintsAsExceptions"
#define cstPerfEval "performance Evaluation"
#define cstForModule "for module"
#define cstCost "_COST"
#define cstCGen "C"
#define cstCppGen "C++"
#define cstJavaGen "Java"
#define cstSyndexGen "Syndex"
#define cstExtract "EXTRACT"
#define cstvhdlGen "VHDL"
#define cstLustreGen "Lustre"
#define cstTestAbstraction "Test AbstractionGraph"
#define cstSyndexExport "Syndex translation"
