/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

/** EXIT STATUS */

#define polychronyNoError 0           ///< No error

#define polychronyUnexpected -4       ///< Unexpected Syntax form
#define polychronyOptionError -3      ///< option error
#define polychronyNoArgs -2           ///< missing argument
#define polychronyNoFile -1           ///< missing file argument


#define polychronyInitError 1         ///< Error during the initialization (library not found,...)
#define polychronySyntaxErrorProg  2  ///< Syntax error in program
#define polychronySyntaxErrorParam 3  ///< Syntax error for parameters
#define polychronySolvingRefError 4   ///< Error during the solving reference step
#define polychronyTypeError 5         ///< Program not well typed
#define polychronyCycle 6             ///< Program with cycles
#define polychronyProfilingErr 7      ///< Error during the profiling functionality
#define polychronyAbstractionErr 8    ///< Error during the abstraction functionality
#define polychronyArrayError 9        ///< Not well defined signal in array/iterate.

#define polychronyExportError 10       ///< exportation failed
#define polychronyNotEndochronous 11   ///< The programm is not endochounous

#define polychronyInternalError 9999  ///<  Internal error
