
module AFFINECLOCK_INTRINSICS=
       % ------------------------------------------------------------------------ %
       % Affine clock library  ( For more details, see Irina Smarandache Ph.D )   %
       % ------------------------------------------------------------------------ %

process affine_sample={integer phi, d} (? INE; ! OUT;)
  pragmas 
    Comment 
    " The output OUT is obtained by an undersampling with phi phase "
    " and the d period on the input INE "
    " The definition in Signal : "
    " "
    "  (| C := (d-1) when (ZC=0) default (ZC-1)"
    "           | C ^= INE "
    "          | ZC := C $ 1 init phi "
    "         | OUT := INE when (ZC=0) "
    "        |) where integer C, ZC; end "
%     C_Code "&o1 = &n (&p1, &p2, &i1) "
     CPP_Code "&o1 = &n(&p1, &p2, &i1) "
     Java_Code  "&o1 = &n(&p1, &p2, &i1) " %
  end pragmas
  ;
  
process affine_clock_relation={integer n, phi, d} (? IN1, IN2;)
  pragmas 
    Comment   
    " The clocks of the signals IN1 and IN2 are in affine relation (n, phi, d) "
    " The definition in Signal : "
    "   (| hINE := affine_sample{ max(0, -phi), n }(hU)        "
    "    | hOUT := affine_sample{ max(0, phi), d }(hU)         "
    "    | hINE  ^= IN1                                        "
    "    | hOUT ^=  IN2                                        "
    "    |)                                                    "
    "   hU is the clock built by the affine relation.          "
  end pragmas
  ;
  
  
process affine_unsample={integer n, phi} (? INE1, INE2; ! OUT;)
  pragmas 
    Comment   
    " The definition in Signal : " 
    "   (| affine_clock_relation{n, phi, 1}(INE1, OUT) "
    "    | OUT := ( INE1 when ^OUT ) default INE2 "
    "    | OUT ^= INE2 "
    "    |) "
  end pragmas
  ;
end;
        
