/* PLG: 20110505
 * $Source: BDD/pack/util.h $
 *    definition of ALLOC functions are extracted here
 */

/*
 * Revision Control Information
 *
 * $Source: /vol/opua/opua2/sis/sis-1.1/common/src/sis/util/RCS/util.h,v $
 * $Author: sis $
 * $Revision: 1.3 $
 * $Date: 1992/05/06 19:03:25 $
 *
 */
#ifndef Alloc_H
#define Alloc_H
/* requires free in <stdlib.h> Integer in "BDD_StdTypes.h", ansi.h */
/* MMalloc, MMrealloc are defined in safe_mem.c
 */

/* ======================================================================= Memory allocator */
/* This was taken out and defined at compile time in the SIS Makefile
   that uses the OctTools.  When the OctTools are used, USE_MM is defined,
   because the OctTools contain libmm.a.  Otherwise, USE_MM is not defined,
   since the mm package is not distributed with SIS, only with Oct. */

/* #define USE_MM */		/* choose libmm.a as the memory allocator */

#ifdef USE_MM
/*
 *  assumes the memory manager is libmm.a
 *	- allows malloc(0) or realloc(obj, 0)
 *	- catches out of memory (and calls MMout_of_memory())
 *	- catch free(0) and realloc(0, size) in the macros
 */
#define ALLOC(type, num)	\
    ((type *) malloc(sizeof(type) * (num)))
#define REALLOC(type, obj, num)	\
    (obj) ? ((type *) realloc((char *) obj, sizeof(type) * (num))) : \
	    ((type *) malloc(sizeof(type) * (num)))
#define FREE(obj)		\
    ((obj) ? (free((char *) (obj)), (obj) = 0) : 0)
#else
/*
 *  enforce strict semantics on the memory allocator
 *	- when in doubt, delete the '#define USE_MM' above
 */
#define ALLOC(type, num)	\
    ((type *) MMalloc((Integer) sizeof(type) * (Integer) (num)))
#define REALLOC(type, obj, num)	\
    ((type *) MMrealloc((char *) (obj), (Integer) sizeof(type) * (Integer) (num)))
#define FREE(obj)		\
    ((obj) ? (free((void *) (obj)), (obj) = 0) : 0)
#endif
/* ---------- :: Memory allocator ---------- */
#endif

