/*
 * Revision Control Information
 * split bdd.h: exported declarations
 *
 * $Source: /vol/hyper/hyper3/shiple/sis/bdd/RCS/bdd.h,v $
 * $Author: PLG $
 * $Revision: 1.2 $
 * $Date: 2011/03/02 $
 * see bdd.h
 *
 */
/* requires
 * #include <stddef.h>
 * #include "boolean.h"
 * #include "BDD_StdTypes.h"
 * #include "bdd_export_type.h"
 */
#ifndef bdd_export_h /* { */
#define bdd_export_h

#include "bdd_export_define.h"
/* Required by foreach_bdd_node
 * ============================
 */


/* =========================================
 * transitively required by foreach_bdd_node
 */

/*
 * ==========================================================================
 * Required in BDDPackApi_g.c
 */
/*
 *    The external user's view of a bdd is a bdd_t* (an external pointer)
 *
 *    A ``bdd'' proper is this thing which is a pointer to a (possibly
 *    complemented) node and a pointer to the bdd manager that manages
 *    that node.    The package user always references into the bdd package
 *    with a ``bdd_t*'' which provides a safe, indirect way of referencing
 *    into the garbage-collecting heap.
 */
struct __bdd_t {
    boolean free;		/* TRUE if this is free, FALSE otherwise ... */
    bdd_node_pointer node;		/* the node referenced */
    bdd_manager_pointer bdd;		/* the manager from whence this came */
}bdd_t;

#define BDD_REGULAR(node)		((bdd_node_pointer ) ((Integer) (node) & ~01))


#endif /* } */

