/*
 * Traversal of BDD Formulas
 */
typedef enum {
    bdd_EMPTY,
    bdd_NONEMPTY
} bdd_gen_status;

typedef enum {
    bdd_gen_cubes,
    bdd_gen_nodes
} bdd_gen_type;

typedef struct __bdd_gen {
    bdd_manager_pointer manager;
    bdd_gen_status status;
    bdd_gen_type type;
    union {
	struct {
	    array_t_pointer cube;	/* bdd_cube_literal */
	    /* ... expansion ... */
	} cubes;
	struct {
	    st_table_pointer visited;	/* of bdd_node* */
	    /* ... expansion ... */
	} nodes;
    } gen;	
    struct {
	Integer sp;
	bdd_node_pointer *stack;
    } stack;
    bdd_node_pointer node;
} bdd_gen;

/* typedef struct bdd_node bdd_node is in bdd.h */
struct __bdd_node {
    bdd_variableId id;		/* variableId is the index of the variable in the bdd */
    bdd_variableId last;        /* ajoute par moi pour avoir la derniere var sans parcours*/
    bdd_node_pointer T;		/* then */
    bdd_node_pointer E;		/* else */
    bdd_node_pointer next;	/* chain pointer of the containing hashtable */
}bdd_node;

/*
 *    foreach_bdd_node(fn, gen, node)
 *    bdd_t_pointer fn;
 *    bdd_gen_pointer gen;
 *    array_t *node;	- return
 */
#define foreach_bdd_node(fn, gen, node)\
  for((gen) = bdd_first_node(fn, &node);\
      ((gen)->status != bdd_EMPTY) ? pk_true: bdd_gen_free(gen);\
      (void) bdd_next_node(gen, &node))


