/* PLG 2011/05/09
 * extracted from bdd_int
 * requires bdd_export.h id_ord.h
 */
/* remove age, uniqueId, halfspace in bdd_nodeDEBUG)  (done)
   remove age, uniqueId, trace, log, debug in bdd_manager(DEBUG) (done)
   remove BDD_FLIGHT_RECORDER ...DEBUG... (FALSE)  (done)
   remove origin in bdd_t (DEBUG) (done)
   (BDD_ASSERT, BDD_ASSERT_REGNODE, BDD_ASSERT_NOTNIL, BDD_ASSERT_BROKEN_HEART, BDD_ASSERT_NOT_BROKEN_HEART, BDD_ASSERT_FRAMES_CORRECT) -> TRUE
   check manager-> undef1
   remove origin in arguments of bdd_make_external_pointer (done)
   remove "bdd_assert...", "bdd_dump_..." (unused extern decl)
   remove BDD_DFLT_ITE_ON, BDD_DFLT_ITE_CONST_ON, BDD_DFLT_ADHOC_ON, BDD_DFLT_GARB_COLLECT_ON  (TRUE)
*/
/*
 * Revision Control Information
 *
 * $Source: /vol/hyper/hyper3/shiple/sis/bdd/RCS/bdd_int.h,v $
 * $Author: shiple $
 * $Revision: 1.3 $
 * $Date: 1992/09/19 03:45:08 $
 *
 */
/*
 * Revision Control Information
 *
 * $Source: /vol/hyper/hyper3/shiple/sis/bdd/RCS/bdd_int.h,v $
 * $Author: shiple $
 * $Revision: 1.3 $
 * $Date: 1992/09/19 03:45:08 $
 * $Log: bdd_int.h,v $
 * Revision 1.3  1992/09/19  03:45:08  shiple
 * Fix typo on change just made.
 *
 * Revision 1.2  1992/09/19  02:35:33  shiple
 * Version 2.4
 * Prefaced compile time debug switches with BDD_.   Added declaration of bdd_get_percentage.
 * Defined bdd_const_hash macro.  Before, the constcache was using the bdd_ITE_hash function, and
 * thus there was an implicit assumption that the constcache and ITE cache had the same number of
 * entries.  Renamed hashtable struct in manager to itetable. Changed ITE and ITE_const caches to
 * be arrays of pointers.  In manager, added rehash_at and max_size fields to caches.  In manager,
 * added node_ratio, init_node_blocks, and memory structure.
 *
 * Revision 1.1  1992/07/29  00:26:47  shiple
 * Initial revision
 *
 * Revision 1.2  1992/05/06  18:51:03  sis
 * SIS release 1.1
 *
 * Revision 1.1  92/01/08  17:34:27  sis
 * Initial revision
 * 
 * Revision 1.1  91/03/27  14:35:30  shiple
 * Initial revision
 * 
 *
 */
/********************/
/* EXTERN UnsignedInteger bdd_get_ord ARGS((UnsignedInteger)); */
/***********  Pascalin*/
/*
 *    Internal stuff for the BDD package
 *
 *    None of this stuff is exported back to the package user.
 */

/* stuff.h - generic useful stuff */
/*
 *    Stuff to make the code more pleasant
 *
 *    These kinds of things ought to be in
 *    the global .h files for any project.
 */

#if ! defined(__STDC__) && ! defined(boolean)
/*
 * Ansi C defines this right?
 * this otta be a typedef somewhere
 * PLG _Bool is a standard qualifier;
 * PLG An object declared as type _Bool is large enough to store the values 0 and 1.
 * PLG <boolean.h> defines boolean, true(1), false(0), _ _boolean_true_false_are_defined(1)
 */
#define boolean int	/* either 0 or 1 */
#endif

#ifndef TRUE	/* Ansi C defines this right? */
#define TRUE 1
#endif
#ifndef FALSE	/* Ansi C defines this right? */
#define FALSE 0
#endif

#ifndef string	
/* Ansi C defines this right? 
 * PLG string is not defined in the standard */
#define string char *	/* a real live '\0' terminated string, not a refany */
#endif

#define sizeof_el(thing)                (sizeof (thing)/sizeof (thing[0]))

#ifndef MIN	/* Ansi C defines this right? */
#define MIN(a, b)       ((a) < (b) ? (a): (b))
#endif

#ifndef MAX	/* Ansi C defines this right? */
#define MAX(a, b)       ((a) > (b) ? (a): (b))
#endif

#ifndef MIN3
#define MIN3(a, b, c)   MIN(a, MIN(b, c))
#endif

#ifndef MAX3
#define MAX3(a, b, c)   MAX(a, MAX(b, c))
#endif

#ifndef MIN_ORD	/* Ansi C defines this right? */
#define MIN_ORD(a, b)       (bdd_get_ord(a) < bdd_get_ord(b) ? (a): (b))
#endif

#ifndef MIN_ORD3
#define MIN_ORD3(a, b, c)   MIN_ORD(a, MIN_ORD(b, c))
#endif

/* end stuff.h - end generic useful stuff */

/*
 *    This is the formal beginning of the internal bdd stuff
*/

/*
 *    The id's and how some are reserved for system use
*/
#define BDD_ONE_ID		((bdd_variableId) (1<<30))
#define BDD_BROKEN_HEART_ID	((bdd_variableId) (1<<30)-1)	/* see the broken_heart implementation below */
#define BDD_USER_0_ID		((bdd_variableId) 0)		/* the 0th variableId */

typedef struct bdd_nodeBlock * bdd_nodeBlock_pointer;
#define NIL_bdd_nodeBlock (bdd_nodeBlock_pointer)NULL

/*
 *    WATCHOUT A sign bit is encoded in the low-order bit of a
 *    node pointer.  This allows a bdd node to represent both the
 *    positive phase and negative phase of the function at the same
 *    time.  The phase all depends on how you reference the bdd.
 *
 *    bdd_node_pointer 
 *    BDD_NOT(node)
 *    bdd_node_pointer node;
 *
 *        Create the negated function of the bdd
 *
 *    bdd_node_pointer 
 *    BDD_REGULAR(node)
 *    bdd_node_pointer node;
 *
 *        Create the regular function of the bdd
 *
 *    boolean
 *    BDD_IS_COMPLEMENT(node)
 *    bdd_node_pointer node;
 *
 *        Does this reprsent the complemented function?
 *
 */
#define BDD_NOT(node)			((bdd_node_pointer ) ((Integer) (node) ^ 01))
#define BDD_REGULAR(node)		((bdd_node_pointer ) ((Integer) (node) & ~01))
#define BDD_IS_COMPLEMENT(node)		((Integer) (node) & 01)



/*
 *    The hash following function is the one that is suggested by Rudell's paper
 *
 *    UnsignedInteger
 *    bdd_generic_hash(a, b, c, nbuckets)
 *    UnsignedInteger a;
 *    UnsignedInteger b;
 *    UnsignedInteger c;
 *    UnsignedInteger nbuckets;	- presumably a prime
 */
#define bdd_generic_hash(a, b, c, nbuckets)	\
  (Integer)(((((UnsignedInteger) (a)) << 5) + (((UnsignedInteger) (b)) << 7) + (((UnsignedInteger) (c)) << 11)) % ((UnsignedInteger) (nbuckets)))


#define BDD_HASHTABLE_INITIAL_SIZE		113	/* the cache must be the same size, must match an entry in bdd_get_next_hash_prime */
#define BDD_CACHE_INITIAL_SIZE			113

#define BDD_CACHE_GROW_FACTOR			2.0	/* grow the caches by this factor */

#define BDD_HASHTABLE_MAXCHAINLEN		4	/* max number bdd_nodes per chain (before a rehash) */
#define BDD_HASHTABLE_GROW_FACTOR		2.0	/* grow the hashtable by this factor */

