/* PLG 2011/05/09
 * extracted from bdd_int
 * requires  bdd_export, (bdd_int.h ?)
 */

/*
 *    The hashtable cache
 *
 *    Statement: For the purposes of validation of the BDD package it should
 *    be (e.g. it is and always must be) possible to turn off the cache.
 */
typedef struct bdd_hashcache_entry {
    struct {
	bdd_node_pointer f;
	bdd_node_pointer g;
	bdd_node_pointer h;
    } ITE;		/* ITE(f, g, h) */
    bdd_node_pointer data;		/* (NIL_bdd_node_pointer) indicates in invalid entry */
} bdd_hashcache_entry;
#define NIL_bdd_hashcache_entry (bdd_hashcache_entry *)NULL
#define NIL_bdd_hashcache_entry_star (bdd_hashcache_entry **)NULL


/*
 *    The constant cache
 *
 *    Statement: For the purposes of validation of the BDD package it should
 *    be (e.g. it is and always must be) possible to turn off the cache.
 */
typedef enum bdd_constant_status {
    bdd_status_unknown,		/* the cache entry is invalid */
    bdd_constant_zero,		/* has the constant value of zero */
    bdd_constant_one,		/* has the constant value of one */
    bdd_nonconstant		/* has a nonconstant value */
} bdd_constant_status;

typedef struct bdd_constcache_entry {
    struct {
	bdd_node_pointer f;
	bdd_node_pointer g;
	bdd_node_pointer h;
    } ITE;		/* ITE(f, g, h) */
    bdd_constant_status data;	/* bdd_status_unknown indicates an invalid entry */
} bdd_constcache_entry;
#define NIL_bdd_constcache_entry (bdd_constcache_entry *)NULL
#define NIL_bdd_constcache_entry_star (bdd_constcache_entry **)NULL


/*
 *    The ad hoc cache
 */
typedef Integer bdd_int;		/* any integer value */

typedef struct bdd_adhoccache_key {
    bdd_node_pointer f;		/* may be (NIL_bdd_node_pointer) */
    bdd_node_pointer g; 		/* may be (NIL_bdd_node_pointer) */
    bdd_int v;			/* may be any integer value */
} bdd_adhoccache_key;


