/* PLG 2011/05/09
 * extracted from bdd_int
 * requires bdd_export.h, stddef.h
 */

/*
 *    Safe pointers so that garbage-collection can be called with impunity
 *    in specially-written routines (e.g. inside a recursive bdd__ITE_())
 *
 *    A bdd_safenode is a safe pointer
 *    A bdd_safeframe is a list of safe pointers which are all
 *        used in the same routine
 */
typedef struct bdd_safenode {
    bdd_node_pointer node;			/* the node referenced */
    bdd_node_pointer *arg;			/* the address of a value to clean up */
    struct bdd_safenode *next;		/* next (safe) node in the list */
} bdd_safenode;

typedef struct bdd_safeframe {
    struct bdd_safeframe *prev;
    bdd_safenode *nodes;
} bdd_safeframe;
#define NIL_bdd_safeframe (bdd_safeframe *)NULL
