/*
 * Revision Control Information
 *
 * $Source: /vol/opua/opua2/sis/sis-1.1/common/src/sis/array/RCS/array.c,v $
 * $Author: sis $
 * $Revision: 1.2 $
 * $Date: 1992/05/06 18:50:03 $
 *
 */
/* LINTLIBRARY */

#include <stdlib.h>
#include "BDD_StdTypes.h"
#include "ansi.h"
#include "Alloc.h"

#include <stddef.h>
#include "boolean.h"
#include "bdd_export_type.h"
#include "bdd_export.h"

#include "bdd_int.h"

#include <string.h>
#include <stdio.h>
#include "util.h"

#include "array.h"
#include "array_g.h"
#include "safe_mem_g.h"

Integer array_i;		/* global for macro's */

#define INIT_SIZE	3


array_t_pointer
array_do_alloc (Integer size, Integer number)
{
  array_t_pointer array;

  array = ALLOC_ARRAY_T;
  array->num = 0;
  array->n_size = MAX (number, INIT_SIZE);
  array->obj_size = size;
  array->space = ALLOC (char, array->n_size * array->obj_size);
  (void) memset (array->space, 0, array->n_size * array->obj_size);
  return array;
}


void
array_free (array_t_pointer array)
{
  FREE (array->space);
  FREE (array);
}


char *
array_do_data (array_t_pointer array)
{
  char *data;

  data = ALLOC (char, array->num * array->obj_size);
  (void) memcpy (data, array->space, array->num * array->obj_size);
  return data;
}


Integer				/* would like to be void, except for macro's */
array_resize (array_t_pointer array, Integer new_size)
{
  Integer old_size;
  char *pos;

  old_size = array->n_size;
  array->n_size = MAX (array->n_size * 2, new_size);
  array->space = REALLOC (char, array->space, array->n_size * array->obj_size);
  pos = array->space + old_size * array->obj_size;
  (void) memset (pos, 0, (array->n_size - old_size) * array->obj_size);
  return 1;			/* added by PLG */
}


Integer				/* would like to be void, except for macro's */
array_abort (Integer i)
{
  switch (i)
    {
    case 0:
      fail ("array: array access out of bounds\n");
      /* NOTREACHED */
    case 1:
      fail ("array: object size mismatch\n");
      /* NOTREACHED */
    case 2:
      fail ("array: append not defined for arrays of different sizes\n");
      /* NOTREACHED */
    case 3:
      fail ("array: join not defined for arrays of different sizes\n");
      /* NOTREACHED */
    default:
      fail ("array: unknown error\n");
      /* NOTREACHED */
    }
}
