/*
 * Revision Control Information
 *
 * $Source: /vol/hyper/hyper3/shiple/sis/bdd/RCS/bdd_end.c,v $
 * $Author: shiple $
 * $Revision: 1.2 $
 * $Date: 1992/09/19 02:29:20 $
 *
 */


#include <stdlib.h>
#include "BDD_StdTypes.h"
#include "ansi.h"
#include "Alloc.h"

#include <stddef.h>
#include "boolean.h"
#include "bdd_export_type.h"
#include "bdd_export.h"

#include "bdd_int.h"
#include "bdd_int_hashcache.h"
#include "bdd_int_safenodeframe.h"
#include "bdd_int_nodeBlock.h"
#include "bdd_int_bddBlock.h"
#include <stdio.h>
#include "bdd_inner.h"
#include "bdd_int_manager.h"

#include "adhoc_cache_g.h"
/* HERE */

/*
 * Revision Control Information
 *
 * $Source: /vol/hyper/hyper3/shiple/sis/bdd/RCS/bdd_end.c,v $
 * $Author: shiple $
 * $Revision: 1.2 $
 * $Date: 1992/09/19 02:29:20 $
 * $Log: bdd_end.c,v $
 * Revision 1.2  1992/09/19  02:29:20  shiple
 * Version 2.4
 * Prefaced compile time debug switches with BDD_. Added typecast to void to some function calls.
 * Changed ITE and ITE_const caches to be arrays of pointers. Added call to
 *
 * Revision 1.1  1992/07/29  00:26:46  shiple
 * Initial revision
 *
 * Revision 1.2  1992/05/06  18:51:03  sis
 * SIS release 1.1
 *
 * Revision 1.1  92/01/08  17:34:26  sis
 * Initial revision
 * 
 * Revision 1.1  91/03/27  14:35:30  shiple
 * Initial revision
 * 
 *
 */

/*
 *    bdd_end - terminate a bdd manager
 *
 *    return nothing, just do it.
 */
void
bdd_end (bdd_manager_pointer manager)
{
  Integer h;
  bdd_nodeBlock_pointer b, next_b;
  bdd_bddBlock *bb, *next_bb;
  Integer i;
  bdd_hashcache_entry *hentry;
  bdd_constcache_entry *centry;

  if (manager == (NIL_bdd_manager_pointer))
    return;			/* for compatibility with v2.2 */


  /* Destruct in order in the structure declaration */

  /*
   *    Free the hashtable
   */
  FREE (manager->heap.hashtable.buckets);

  /*
   *    Free the ITE cache, and any entries it contains.
   */
  for (i = 0; i < manager->heap.cache.itetable.nbuckets; i++)
    {
      hentry = manager->heap.cache.itetable.buckets[i];
      if (hentry != (NIL_bdd_hashcache_entry))
	{
	  FREE (hentry);
	}
    }
  FREE (manager->heap.cache.itetable.buckets);

  /*
   *    Free the ITE constant cache, and any entries it contains.
   */
  for (i = 0; i < manager->heap.cache.consttable.nbuckets; i++)
    {
      centry = manager->heap.cache.consttable.buckets[i];
      if (centry != (NIL_bdd_constcache_entry))
	{
	  FREE (centry);
	}
    }
  FREE (manager->heap.cache.consttable.buckets);

  /*
   *    Free the adhoc cache.
   */
  if (manager->heap.cache.adhoc.table != (NIL_st_table))
    {
      bdd_adhoccache_uninit (manager);
    }

  /*
   *    Free the external references 
   */
  for (bb = manager->heap.external_refs.map; bb != (NIL_bdd_bddBlock); bb = next_bb)
    {
      next_bb = bb->next;
      FREE (bb);
    }

  /*
   *    Free the nodeBlocks in the heap halves
   */
  for (h = 0; h < sizeof_el (manager->heap.half); h++)
    {
      for (b = manager->heap.half[h].inuse.top; b != (NIL_bdd_nodeBlock); b = next_b)
	{
	  next_b = b->next;
	  FREE (b);
	}
      for (b = manager->heap.half[h].free; b != (NIL_bdd_nodeBlock); b = next_b)
	{
	  next_b = b->next;
	  FREE (b);
	}
    }

  /*
   *    DO NOT touch the mis-specific info that is freed in bdd_quit.
   *    This routine is designed to be called from network_free
   */

  FREE (manager);
}
