/*
 * Revision Control Information
 *
 * $Source: /vol/hyper/hyper3/shiple/sis/bdd/RCS/bdd_ite.c,v $
 * $Author: shiple $
 * $Revision: 1.2 $
 * $Date: 1992/09/19 01:46:00 $
 *
 */

#include <stddef.h>
#include "BDD_StdTypes.h"
#include "boolean.h"
#include "bdd_export_type.h"
#include "ansi.h"
#include "bdd_export.h"
#include "id_ord.h"
#include "bdd_int.h"

#include <stdlib.h>
#include <string.h>
#include "util.h"

#include "bdd_int_hashcache.h"
#include "bdd_int_safenodeframe.h"
#include "bdd_int_bddBlock.h"
#include <stdio.h>
#include "bdd_inner.h"
#include "bdd_int_manager.h"
#include "ite_g.h"
#include "external_ptr_g.h"

/* HERE */

/*
 * Revision Control Information
 *
 * $Source: /vol/hyper/hyper3/shiple/sis/bdd/RCS/bdd_ite.c,v $
 * $Author: shiple $
 * $Revision: 1.2 $
 * $Date: 1992/09/19 01:46:00 $
 * $Log: bdd_ite.c,v $
 * Revision 1.2  1992/09/19  01:46:00  shiple
 * Version 2.4
 * Prefaced compile time debug switches with BDD_.
 *
 * Revision 1.1  1992/07/29  00:26:48  shiple
 * Initial revision
 *
 * Revision 1.2  1992/05/06  18:51:03  sis
 * SIS release 1.1
 *
 * Revision 1.1  92/01/08  17:34:27  sis
 * Initial revision
 * 
 * Revision 1.1  91/03/27  14:35:31  shiple
 * Initial revision
 * 
 *
 */

/*
 *    bdd_ite - returns the ite of three bdd's
 *
 *    ITE Identity: ITE(F, G, H) = ITE(F, G, H)	<---- no kidding
 *
 *    return the new bdd (external pointer)
 */
bdd_t_pointer
bdd_ite (bdd_t_pointer f, bdd_t_pointer g, bdd_t_pointer h, boolean f_phase, boolean g_phase, boolean h_phase)
				/* if ! f_phase then negate f */
				/* if ! g_phase then negate g */
				/* if ! h_phase then negate g */
{
  bdd_safeframe frame;
  bdd_safenode real_f, real_g, real_h, ret;
  bdd_t_pointer i;
  bdd_manager_pointer manager;

  if (f == (NIL_bdd_t_pointer) || g == (NIL_bdd_t_pointer) || h == (NIL_bdd_t_pointer))
    fail ("bdd_ite: invalid BDD");

  if (f->bdd != g->bdd || g->bdd != h->bdd)
    fail ("bdd_ite: different bdd managers");

  manager = f->bdd;		/* either this or g->bdd or h->bdd will do */

  /*
   *    After the input is checked for correctness, start the safe frame
   *    f and g are already external pointers so they need not be protected
   */
  bdd_safeframe_start (manager, frame);
  bdd_safenode_declare (manager, real_f);
  bdd_safenode_declare (manager, real_g);
  bdd_safenode_declare (manager, real_h);
  bdd_safenode_declare (manager, ret);

  real_f.node = f_phase ? f->node : BDD_NOT (f->node);
  real_g.node = g_phase ? g->node : BDD_NOT (g->node);
  real_h.node = h_phase ? h->node : BDD_NOT (h->node);

  ret.node = bdd__ITE_ (manager, real_f.node, real_g.node, real_h.node);

  /*
   *    End the safe frame and return the result
   */
  bdd_safeframe_end (manager);
  i = bdd_make_external_pointer (manager, ret.node);


  return (i);
}
