/****************************************************************************/
/***  Name: id_ord.c                                                      ***/
/***  Version:                                                            ***/
/***                                                                      ***/
/***  Author: TAM                                                         ***/
/***                                                                      ***/
/***  Desciption: Ce fichier exporte 2 fonctions qui etablissent le lien  ***/
/***              entre l'id d'une variable booleaneenne et son numero dans  ***/
/***              l'ordre total                                           ***/
/***              Il est important de noter que les variables sont        ***/
/***              sense's appartenir au me^me manager                     ***/
/***              Cela de'truit purement et simplement la notion de       ***/
/***              manager et interdit l'existence de deux sessions bdd    ***/
/***              Mais il fallait vraiment que ce fichier soit amene'     ***/
/***              dans la bibliothe`que parce ce qu'il constitue une      ***/
/***              modification du package et non un couche                ***/
/***                                                                      ***/
/***  Creation Date: 1993/11/19                                           ***/
/***                                                                      ***/
/***  Last Modification: 1995/03/31                                       ***/
/***  Modification Author:                                                ***/
/***                                                                      ***/
/****************************************************************************/

#include <stdio.h>
#include "BDD_StdTypes.h"
#include "ansi.h"
#include "id_ord.h"
static UnsignedInteger list[BDD_MAX_VAR];

/****************************************************************************/
/*** Name: bdd_get_ord                                                    ***/
/*** Usage                                                                ***/
/***   arguments: UnsignedInteger id                                                 ***/
/***                                                                      ***/
/***   returns:   UnsignedInteger ord                                                ***/
/***          le numero de la variable id dans l'ordre total              ***/
/***       ce numero ayant ete defini un precedent appel a bdd_set_ord    ***/
/***              (id,ord).                                               ***/
/***              Il n'y a aucun traitement d'erreur                      ***/
/***                                                                      ***/
/*** Comments:                                                            ***/
/***                                                                      ***/
/*** Side effects:                                                        ***/
/***                                                                      ***/
/*** See also:                                                            ***/
/***                                                                      ***/
/****************************************************************************/
UnsignedInteger
bdd_get_ord (UnsignedInteger id)
{
  if (id == BDD_ZERO_ID)
    return id;
  if (id < BDD_MAX_VAR)
    return list[id];
  fprintf (stderr, "severe error\nunexpected id\n");
  return id;			/* il a fallu loucher vers le bdd_int pour savoir quoi renvoyer */
}

/****************************************************************************/
/*** Name: bdd_set_ord                                                    ***/
/*** Usage                                                                ***/
/***   arguments: UnsignedInteger id, UnsignedInteger ord                                       ***/
/***                                                                      ***/
/***   returns: void                                                      ***/
/***            definit ord comme etant le numero de la variable id dans  ***/
/***            l'ordre total. Si la variable id n'avait pas encore ete   ***/
/***            enregistree, cet appel l'enregistre                       ***/
/***                                                                      ***/
/*** Comments:                                                            ***/
/***                                                                      ***/
/*** Side effects:                                                        ***/
/***                                                                      ***/
/*** See also:                                                            ***/
/***                                                                      ***/
/****************************************************************************/
void
bdd_set_ord (UnsignedInteger id, UnsignedInteger ord)
{
  if (id >= BDD_MAX_VAR)
    return;
  list[id] = ord;
}
