/* 
   Authors: Loïc Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

static form_struct one = { FORM_LIT, {NILBDDFORMULA, NILBDDFORMULA} };

//static form_struct one = {.op=FORM_LIT, .what = {.args = {NILBDDFORMULA, NILBDDFORMULA}}};
//static form_struct zero = {.op=FORM_LIT, .what = {.args = {NILBDDFORMULA, NILBDDFORMULA}}};
static form_struct zero = { FORM_LIT, {NILBDDFORMULA, NILBDDFORMULA} };

/****************************************************************************/
extern void
form_print (FILE * out, form_type f)
{
  if (f == &one)
    {
      fprintf (out, "1 ");
      return;
    }
  if (f == &zero)
    {
      fprintf (out, "0");
      return;
    }
  switch (f->op)
    {
    case FORM_LIT:
      {
	fprintf (out, "%lx", (UnsignedInteger) (f->what.literal));
	return;
      }
    case FORM_AND:
      {
	fprintf (out, "^*(");
	break;
      }
    case FORM_OR:
      {
	fprintf (out, "^+(");
	break;
      }
    case FORM_DIFF:
      {
	fprintf (out, "^-(");
	break;
      }
    default:
      {
	fprintf (stderr, "unexpected value for op\n");
	fprintf (out, "^YYYYYYYYYYY(");
	return;
	// exit(1);
      }
    }
  form_print (out, f->what.args.form1);
  fprintf (out, ",");
  form_print (out, f->what.args.form2);
  fprintf (out, ")");
}
