_PRIVATE_
#define stdLineSize 127
#define stdLineIndent 63
#define CHAR_DIGIT(II) (char)(II+48)
#define IS_NIL_STRING(STR) ( STR == NIL_String )
#define IS_NULL_STRING(STR) ( IS_NIL_STRING(STR) || ( STR[0] == NULL_char ) )
#define ISNOT_NIL_STRING(STR) ( STR != NIL_String )
#define ISNOT_NULL_STRING(STR) ( ISNOT_NIL_STRING(STR) && ( STR[0] != NULL_char ) )
/* FILE Mmaximal line size */
#define MAX_AVAILABLE_SPACE() maximalLineLength
/* FILE LINE COUNT */
#define INCR_LINECOUNTER() lineCounter = lineCounter+1
#define ADDTO_LINECOUNTER(_VAL_) lineCounter = lineCounter + _VAL_
/* UNSAFE FILE DIRECT ACTIONS */
#define PUT_CHAR(CC) ( fputc(CC, this_file) != EOF )
#define PUT_DIGIT(II) PUT_CHAR(CHAR_DIGIT(II))
#define PUT_STRING(STR) ( fputs(STR, this_file) != EOF )
#define PUT_CONTINUATION_MARK() ( PUT_CHAR(this_continuationCharacter) )
#define PUT_EOL() PUT_CHAR('\n')
#define PUT_PREFIX() PUT_STRING(this_prefix)
#define PUT_CONTAINER() PUT_STRING(this_container)
#define CHARFAILURE() setInError("failed to put char")
#define DIGITFAILURE() setInError("failed to put digit")
#define SPACEFAILURE() setInError("failed to put space")
#define STRINGFAILURE() setInError("failed to put string")
#define CONTINUATIONFAILURE() setInError("failed to put continuation mark")
#define EOLFAILURE() setInError("failed to put eol")
#define PREFIXFAILURE() setInError("failed to put prefix")
#define CONTAINERFAILURE() setInError("failed to put container")
#define return_FF_on_putCHAR_err(CC) if ( !(PUT_CHAR(CC)) ) { CHARFAILURE(); return pk_false; }
#define return_FF_on_putDIGIT_err(DD) if ( !(PUT_DIGIT(DD)) ) { DIGITFAILURE(); return pk_false; }
#define return_FF_on_putSPACE_err() if ( !(PUT_CHAR(' ')) ) { SPACEFAILURE(); return pk_false; }
#define return_FF_on_putSTRING_err(STR) if ( !(PUT_STRING(STR)) ) { STRINGFAILURE(); return pk_false; }
#define return_FF_on_putCONTINUATION_err() if ( !(PUT_CONTINUATION_MARK()) ) { CONTINUATIONFAILURE(); return pk_false; }
#define return_FF_on_putEOL_err() if ( !PUT_EOL() ) { EOLFAILURE(); return pk_false; }
#define return_FF_on_putPREFIX_err() if ( !PUT_PREFIX() ) { PREFIXFAILURE(); return pk_false; }
#define return_FF_on_putCONTAINER_err() if ( !PUT_CONTAINER() ) { CONTAINERFAILURE(); return pk_false; }
/* BUFFERED FILE STATUS */
/* file status is
 *    ISNOT_SAFE() xor IS_SAFE()
 *    ISNOT_SAFE() xor IS_CLOSED() xor IS_OPEN()
 *    ISNOT_OPEN() xor IS_OPEN()
 *    ISNOT_OPEN() xor IS_EMPTY() xor IS_NOTEMPTY()
 */
#define SET_IN_ERROR() this_index = -2
#define SET_CLOSED() this_index = -1
#define SET_EMPTY() this_index = 0
#define SET_ADDED(INCR) this_index = this_index + INCR
#define ISNOT_SAFE() ( this_index < -1 )
#define IS_SAFE() ( this_index >= -1 )
#define IS_CLOSED() ( this_index == -1 )
#define ISNOT_OPEN() ( this_index < 0 )
#define IS_OPEN() ( this_index >= 0 )
#define IS_EMPTY() ( this_index == 0 )
#define IS_NOTEMPTY() ( this_index > 0 )
/* BUFFER ACTIONS */
#define CONTAINER_FREETAIL() ((this_container+this_index))
#define CONTAINER_LASTACTUALCHAR() (this_container[this_index-1])
#define EMPTY_CONTAINER() SET_EMPTY(); this_container[0] = NULL_char
#define ASSIGN_CHAR(CC) this_container[this_index] = CC
#define ASSIGN_CHAR_AHEAD(CC, INCR) this_container[this_index+INCR] = CC
#define ASSIGN_CHAR_CHAR(CC1, CC2) ASSIGN_CHAR(CC1); ASSIGN_CHAR_AHEAD(CC2, 1)
#define SET_SPACED() isSpaced = pk_true
#define SET_NOTSPACED() isSpaced = pk_false
#define ISNE_SPACE_TERMINATED() ( CONTAINER_LASTACTUALCHAR() == ' ' )
#define IS_SPACE_TERMINATED() ( IS_NOTEMPTY() && ISNE_SPACE_TERMINATED() )	/* isSpaced == pk_true */
#define ISNE_NOTSPACE_TERMINATED() ( CONTAINER_LASTACTUALCHAR() != ' ' )
#define IS_NOTSP_TERMINATED() ( IS_NOTEMPTY() && ISNE_NOTSPACE_TERMINATED() )	/* isSpaced == pk_false */
#define ADD_NULL_AHEAD(INCR) SET_ADDED(INCR); ASSIGN_CHAR(NULL_char)
#define ADD_CHAR(CC) ASSIGN_CHAR(CC); ADD_NULL_AHEAD(1)
#define ADD_CHAR_AHEAD(CC, INCR) ASSIGN_CHAR_AHEAD(CC, INCR); ADD_NULL_AHEAD(INCR+1)
#define ADD_CHAR_NS(CC) ADD_CHAR(CC); SET_NOTSPACED()
#define ADD_SP() ADD_CHAR(' '); SET_SPACED()	/*SET_SPACED()= */
#define ADD_SP_AHEAD(INCR) ADD_CHAR_AHEAD(' ', INCR); SET_SPACED()	/*SET_SPACED()= */
#define ADD_CHAR_SP(CC) ASSIGN_CHAR(CC); ADD_SP_AHEAD(1)	/*SET_SPACED()= */
#define ADD_WH_CHAR(CC) ADD_CHAR_CHAR(' ', CC)
#define ADD_WH_CHAR_NS(CC) ADD_WH_CHAR(CC); SET_NOTSPACED()
#define ADD_WH_CHAR_SP(CC) ASSIGN_CHAR_CHAR(' ', CC); ADD_SP_AHEAD(2)	/*SET_SPACED()= */
#define ADD_CHAR_CHAR(CC1, CC2) ASSIGN_CHAR(CC1); ADD_CHAR_AHEAD(CC2, 1)
#define ADD_CHAR_CHAR_NS(CC1, CC2) ADD_CHAR_CHAR(CC1, CC2); SET_NOTSPACED()
#define ADD_CHAR_CHAR_SP(CC1, CC2) ASSIGN_CHAR_CHAR(CC1, CC2); ADD_SP_AHEAD(2)
#define ADD_CHAR_CHAR_CHAR(CC1, CC2, CC3) ASSIGN_CHAR_CHAR(CC1, CC2); ADD_CHAR_AHEAD(CC3, 2)
#define ADD_POSINT(_VAL_, _LG_) unsafe_cpyIntAbsVal(CONTAINER_FREETAIL(), _VAL_, _LG_); SET_ADDED(_LG_)
#define ADD_POSINT_NS(_VAL_, _LG_) ADD_POSINT(_VAL_, _LG_); SET_NOTSPACED()
#define ADD_STRING(STR) SET_ADDED(unsafe_cpyString(CONTAINER_FREETAIL(), STR))
#define ADD_PREFIX(STR, LENGTH) unsafe_NcpyPrefix(CONTAINER_FREETAIL(), STR, LENGTH); SET_ADDED(LENGTH)
#define ADD_STRING_NS(STR) ADD_STRING(STR); SET_NOTSPACED()
#define ADD_STRING_SP(STR) ADD_STRING(STR); ADD_SP()
#define ADD_STRING_CHAR(STR, CC) ADD_STRING(STR); ADD_CHAR(CC);
#define ADD_STRING_CHAR_NS(STR, CC) ADD_STRING(STR); ADD_CHAR_NS(CC);
#define ADD_CHAR_STRING(CC, STR) ADD_CHAR(CC); ADD_STRING(STR);
#define ADD_CHAR_STRING_NS(CC, STR) ADD_CHAR(CC); ADD_STRING_NS(STR);
/* ======================================
   LINE SRUCTURE */
/* Margin properties
 *    maximalActualMargin == 0 => virtualMargin = 0
 *    virtualMargin == 0 => actualMargin = 0
 * ==> HAS_ACTUALMARGIN() => MAY_HAVE_MARGIN()
 */
#define SET_MARGINFREE() maximalActualMargin = 0
#define SET_MARGIN(_SIZE_) maximalActualMargin = _SIZE_
#define MAY_HAVE_MARGIN() ( maximalActualMargin > 0 )
#define HAS_ACTUALMARGIN() ( actualMargin > 0 )
#define VIRTUAL_INDEX() ( virtualMargin + this_index )
#define ACTUAL_INDEX() ( actualMargin + this_index )
/* MARGIN FREE ACTIONS 
 * actual margin : MAY_HAVE_MARGIN() is false */
#define MARGINFREE_AVAILABLE_SPACE() ( MAX_AVAILABLE_SPACE() - this_index )
#define IS_MARGINFREE_FULL() ( MAX_AVAILABLE_SPACE() <= this_index )
#define MARGINFREE_FIT_INEMPTY(LG) ( MAX_AVAILABLE_SPACE()>=(LG) )
#define MARGINFREE_FIT(LG) ( MARGINFREE_AVAILABLE_SPACE()>=(LG) )
#define MARGINFREE_OVER(LG) ( MARGINFREE_AVAILABLE_SPACE()<(LG) )
/* ACTUAL MARGIN ACTIONS 
 * actual margin : MAY_HAVE_MARGIN() is pk_true */
#define SET_ACTUALMARGIN() if ( virtualMargin >= maximalActualMargin) actualMargin = maximalActualMargin; \
  else actualMargin = virtualMargin;
#define ACTUALMARGIN_AVAILABLE_SPACE() ( MAX_AVAILABLE_SPACE() - ACTUAL_INDEX() )
#define IS_ACTUALMARGIN_FULL() ( MAX_AVAILABLE_SPACE() <= ACTUAL_INDEX() )
#define ACTUALMARGIN_FIT_INEMPTY(LG) ( MAX_AVAILABLE_SPACE() >= actualMargin + (LG) )
#define ACTUALMARGIN_FIT(LG) ( ACTUALMARGIN_AVAILABLE_SPACE()>=(LG) )
#define ACTUALMARGIN_OVER(LG) ( ACTUALMARGIN_AVAILABLE_SPACE()<(LG) )
#define ACTUALMARGIN_LOOP(II) II = 0; II < actualMargin ; II++
/* UNDEFINED MARGIN ACTIONS */
/* margin or no margin  */
#define FIT(LG) ( ( MAY_HAVE_MARGIN() ) ? (ACTUALMARGIN_FIT(LG)) : (MARGINFREE_FIT(LG)) )
/* PREFIX */
#define SET_PREFIXFREE() this_prefix = NIL_String; this_prefixLgth = 0;
#define RESET_PREFIXFREE() MAX_AVAILABLE_SPACE() = MAX_AVAILABLE_SPACE() + this_prefixLgth; SET_PREFIXFREE()
#define SET_EMPTYPREFIX() this_prefix = ""; this_prefixLgth = 0;
#define SET_CHARPREFIX(CC) this_prefix = CC; this_prefixLgth = 1;
#define SET_STRINGPREFIX(STR) this_prefix = STR; this_prefixLgth = strlen(STR);
#define HAS_PREFIX() ( ISNOT_NIL_STRING(this_prefix) )
#define IS_EMPTYPREFIX() ( this_prefixLgth <= 0 )
#define ISNOT_EMPTYPREFIX() ( this_prefixLgth > 0 )
/* put to file */
#define INIT_LINE() EMPTY_CONTAINER(); SET_SPACED(); lineCounter = 1	/*SET_SPACED()= */
#define return_FF_on_putEOL_NL_err() return_FF_on_putEOL_err(); INCR_LINECOUNTER(); EMPTY_CONTAINER()
#define return_FF_on_putCONTINUATIONEOL_NL_err() return_FF_on_putCONTINUATION_err(); return_FF_on_putEOL_NL_err()
#define return_FF_on_putCONTINUEDLINE_err() return_FF_on_putCONTAINER_err(); return_FF_on_putCONTINUATIONEOL_NL_err()
#define return_END_MARGINLINE() return_FF_on_putEOL_NL_err(); SET_SPACED(); SET_ACTUALMARGIN(); return pk_true	/*SET_SPACED()= */
#define return_END_MARGINFREELINE() return_FF_on_putEOL_NL_err(); SET_SPACED(); return pk_true	/*SET_SPACED()= */
#define return_END_LINE() return_FF_on_putEOL_NL_err(); SET_SPACED(); if ( MAY_HAVE_MARGIN() ) { SET_ACTUALMARGIN(); }; return pk_true	/*SET_SPACED()= */
/* if ( MAY_HAVE_MARGIN() ) is pk_true stack is unused */
  typedef struct intStack
{
  int val;
  ref2IntStack pred;
} intStack;

/* ======================== list of functions 
 * 
 * ===> appends to file without splitting
 * boolean NBuffer::put_nChar(char cc, int factor) <cc> is put n times in my file; failure is an error
 * boolean NBuffer::put_prefix(char * strValue, int strLength) puts in this_file <strLength> first characters of <strValue> 
 *                                         failure is an error    
 * boolean NBuffer::put_digits(int YY); failure is an error
 * boolean NBuffer::put_marginFreeLine(); failure is an error; is SET_SPACED()
 * boolean NBuffer::put_MARGIN() margin is put in this_file; failure is an error
 * boolean NBuffer::put_emptyLines(int factor) put in this_file <factor> times margin and prefix followed by line termination
 *                                         failure is an error    
 * boolean NBuffer::put_marginLine(); failure is an error; is SET_SPACED()
 * boolean NBuffer::put_prefixFreeLine(); failure is an error; is SET_SPACED()
 * boolean NBuffer::putLineIfNotFit_fit(int lg); 
 *                 on failure is SET_SPACED(); not an error when required space is too large on empty buffer
 *
 * ===> append to empty buffer continued line content
 * void NBuffer::add_nChar(char cc, int factor)
 * void NBuffer::add_subString(char * str, int strlg)
 * void NBuffer::add_digits(int positiveNumber)
 * 
 * 
 * 
 * ===> output, strings values of arguments, splited if required and 
 *      this_container is margin free
 *      if arguments have enough space in this_container appends these argument string translation to this_container
 *      if arguments are too large
 *          arguments are split in greatest substrings str0 ... str_1...strn st
 *          str0 is appent to this container; this container is printed
 *          str_1  str_n-1 each str_i is output at end of file followed by a continuation mark (if any) folloewd by eol
 *          strn is copied to this container, set as a (margin free) continuation line
 * boolean NBuffer::appendMFOver_split_string(char * strValue, int strLength); failure is an error
 * boolean NBuffer::appendMFOver_split_digits(int positiveNumber); failure is an error
 *
 * boolean NBuffer::appendMF_lGlueSplit_nChar(char cc, int factor); failure is an error
 * boolean NBuffer::appendMF_lGlueSplit_string(char *strValue, int strLength)
 *
 * HERE TODO below
 *      check above use
 * ===> 

 * ===> appends to container, puts container content and splits strings if required and allowed
 * ===> output, strings values of arguments, splited if required and 
 *      this_container may have margin
 *      if arguments have enough space in this_container appends these argument string translation to this_container
 *      if arguments are too large
 *          arguments are split in greatest substrings str0 ... str_1...strn st
 *          str0 is appent to this container; this container is printed with current margin rule
 *          str_1  str_n-1 each str_i is output at end of file followed by a continuation mark (if any) folloewd by eol
 *          strn is copied to this container, set as a (margin free) continuation line

 * === ===> <<<<<<<<<< entry points for _g >>>>>>>>>>
 * 
 * 
 * ===> appends to container, puts container content and splits strings if required and allowed
 *      those functions are standard call in open buffer
 * boolean NBuffer::Uprint_sp()  -->entry points for _g
 * boolean NBuffer::Uprint(char cc) -->entry points for _g
 * boolean NBuffer::Uprint_sp_(char cc)  -->entry points for _g
 * boolean NBuffer::Uprint_sp__sp(char cc)
 * boolean NBuffer::Uprint__sp(char cc)  -->entry points for _g
 * boolean NBuffer::Uprint__sp(char cc1, char cc2) -->entry points for _g
 * boolean NBuffer::Uprint_eolIfSplit_nChar(char cc, int factor)   -->entry points for _g
 * boolean NBuffer::Uprint_eolIfSplit_str(char *strValue)   -->entry points for _g
 * boolean NBuffer::Uprint_eolIfSplit_str_sp(char *strValue)   -->entry points for _g
 * boolean NBuffer::Uprint_eolIfSplit_chr_str(char cc, char *strValue) 
 * boolean NBuffer::Uprint_eolIfSplit_str_chr(char *strValue, char cc)
 * boolean NBuffer::Uprint_eolIfSplit_chr_str_chr(char cc1, char *strValue, char cc2)
 * boolean NBuffer::Uprint_eolIfSplit_str_str(char *strValue1, char *strValue2)  -->entry points for _g
 * boolean NBuffer::Uprint_eolIfSplit_strArray(int nbElem, char * strArray[], int fullLength)
 * boolean NBuffer::Uprint_eolIfSplit_strArray_sp(int nbElem, char * strArray[])
 * boolean NBuffer::Uprint_eolIfSplit_int(int positiveNumber)  -->entry points for _g
 * boolean NBuffer::Uprint_eolIfSplit_chr_int(char cc, int positiveNumber)
 * boolean NBuffer::Uprint_eolIfSplit_str_int(char *strValue, int positiveNumber) 
 * boolean NBuffer::Uprint_eolIfSplit_chr_str_int(char cc, char *strValue, int positiveNumber) 

*/
/* ==== ==== Section error log
 */
void
NBuffer::stderr_error (const char *mess)
{
  if (IS_NULL_STRING (this_fileName))
    if (IS_NULL_STRING (mess))
      fprintf (stderr, "## Buffer ERROR ## in unknown file\n");
    else
      fprintf (stderr, "## Buffer ERROR ## in unknown file: %s\n", mess);
  else if (IS_NULL_STRING (mess))
    fprintf (stderr, "## Buffer ERROR ## line %i in file %s\n", lineCounter, this_fileName);
  else
    fprintf (stderr, "## Buffer ERROR ## line %i in file %s: %s\n", lineCounter, this_fileName, mess);
}

void
NBuffer::stderr_warning (const char *mess)
{
  if (IS_NULL_STRING (mess))
    fprintf (stderr, "-- Buffer WARNING -- No more explanation\n");
  else
    fprintf (stderr, "-- Buffer WARNING -- %s\n", mess);
}

void
NBuffer::stderr_errorPrinting ()
{
  fprintf (stderr, "## ERROR ## during printing line %i in file %s\n", lineCounter, this_fileName);
}

void
NBuffer::setInError (const char *mess)
{
  stderr_error (mess);
  SET_IN_ERROR ();
  MAX_AVAILABLE_SPACE () = 0;
  this_container = NIL_String;
  this_stringRegister = NIL_LGString;
}

/* 
 * this is set in error
 * stderr puts an error message
 */
void
NBuffer::illegalUse ()
{
  if (IS_CLOSED ())
    setInError ("file not open");
  else
    stderr_warning ("illegal use of errored Buffer");
}

/* ==== ==== Section Indentation level
 */

/* PLG 2005-05-04
 * WARNING only if ( MAY_HAVE_MARGIN() OK ) 
 * pushes topValue as the current top indentation
 * sets current line virtual left margin if Buffer is empty
 */
ref2IntStack
NBuffer::push (ref2IntStack aStack, int topValue)
{
  ref2IntStack currentTop = aStack;
  aStack = new intStack;
  aStack->val = topValue;
  aStack->pred = currentTop;
  return aStack;
}

/* PLG 2005-05-04
 * WARNING only if ( MAY_HAVE_MARGIN() OK ) 
 * returns the current top indentation of aStack
 */
int
NBuffer::top (ref2IntStack aStack)
{
  if (aStack == NIL_IntStack)
    return 0;
  return aStack->val;
}

/* PLG 2005-05-04
 * WARNING only if ( MAY_HAVE_MARGIN() OK ) 
 * removes the last pushed value in aStack
 * unsafe: aStack is not empty
 */
ref2IntStack
NBuffer::unsafe_pop (ref2IntStack aStack)
{
  ref2IntStack currentTop = aStack;
  aStack = currentTop->pred;
  delete currentTop;
  return aStack;
}

/* PLG 2005-05-04
 * WARNING only if ( MAY_HAVE_MARGIN() OK )
 * empties and garbage aStack
 */
void
NBuffer::closeStack (ref2IntStack aStack)
{
  ref2IntStack delStack;
  while (aStack != NIL_IntStack)
    {
      delStack = aStack;
      aStack = aStack->pred;
      delete delStack;
    }
}

/* PLG 2005-05-04
 * WARNING only if ( MAY_HAVE_MARGIN() OK )
   empties and garbage all stacks
 */
void
NBuffer::closeStacks ()
{
  closeStack (leftIndentationMarks);
  closeStack (allIndentationMarks);
}

/* ==== ==== Section MARGIN
 */
/* PLG 2005-04-20
 * WARNING only if ( MAY_HAVE_MARGIN() OK )
 * pushes nm as the current top indentation
 * sets current line virtual left margin if Buffer is empty
 */
void
NBuffer::pushIndentation (int nm)
{
  if (nm < 0)
    nm = 0;
  allIndentationMarks = push (allIndentationMarks, nm);
  allDepth = allDepth + 1;
  virtualMargin = nm;
  if (IS_EMPTY ())
    {
      SET_ACTUALMARGIN ();
    }
}

/* PLG 2005-04-20
 * WARNING only if ( MAY_HAVE_MARGIN() OK)
 * pops the current top margin 
 * assumes a correct text and left marks nesting
 */
void
NBuffer::popIndentation ()
{
  if (allIndentationMarks != NIL_IntStack)
    {
      allIndentationMarks = unsafe_pop (allIndentationMarks);
      allDepth = allDepth - 1;
      virtualMargin = top (allIndentationMarks);
      if (IS_EMPTY ())
	{
	  SET_ACTUALMARGIN ();
	}
    }
}

/* PLG 2005-04-20
 * WARNING only if ( MAY_HAVE_MARGIN() OK)
 * pushes n as the current top and left indentation
 * sets current line virtual left margin to this value if Buffer is still empty
 */
void
NBuffer::pushLeftIndentation (int n)
{
  if (n < 0)
    n = 0;
  leftIndentationMarks = push (leftIndentationMarks, n);
  leftDepth = leftDepth + 1;
  pushIndentation (n);
}

/* PLG 2005-04-20
 * WARNING only if ( MAY_HAVE_MARGIN() OK)
 * pops the current left and top margin 
 * assumes a correct nesting of text and left marks
 * sets current line virtual left margin to this value if Buffer is still empty
 */
void
NBuffer::popLeftIndentation ()
{
  if (leftIndentationMarks != NIL_IntStack)
    {
      leftIndentationMarks = unsafe_pop (leftIndentationMarks);
      leftDepth = leftDepth - 1;
      popIndentation ();
    }
}

/* PLG 2005-04-20
 * WARNING only if ( MAY_HAVE_MARGIN()  OK)
 * pops at most n times the current left and top margin 
 * assumes a correct nesting of text and left marks
 * sets current line virtual left margin to this value if Buffer is still empty
 */
void
NBuffer::popLeftIndentation (int n)
{
  int i;
  for (i = 1; i <= n; i++)
    {
      if (leftIndentationMarks == NIL_IntStack)
	break;
      leftIndentationMarks = unsafe_pop (leftIndentationMarks);
      leftDepth = leftDepth - 1;
      popIndentation ();
    }
}

/* current left mark is as string printed after indentation spaces during each line printing
 * if current buffer is not empty, prints its content preceded by current mark
 * sets current left mark equal NIL_String
 * returns previous left mark
 */
void
NBuffer::resetLeftMark (const char *lMargin, int lSize)
{
  MAX_AVAILABLE_SPACE () = MAX_AVAILABLE_SPACE () - lSize;
  if (MAX_AVAILABLE_SPACE () < 2)
    {
      MAX_AVAILABLE_SPACE () = MAX_AVAILABLE_SPACE () + lSize - 1;
      if (MAX_AVAILABLE_SPACE () < 2)
	{
	  MAX_AVAILABLE_SPACE () = MAX_AVAILABLE_SPACE () + 1;
	  SET_EMPTYPREFIX ();
	}
      else
	{
	  SET_CHARPREFIX (";");
	}
    }
  else
    {
      SET_STRINGPREFIX (lMargin);
    }
}

/* ==== ==== Section Direct file output
 */

/* ==== SubSection output margin 
 */

/* ==== SubSection output values
 */

/* PLG 2005-05-02, PLG 2007-03-14
 * this_file is a correctly open file descriptor
 * success: <cc> is put <factor> times in this_file
 * failure: writing in this_file failed
 *          this is set in error
 *          stderr puts an error message
 * this_container remains unchanged
 */
boolean
NBuffer::put_nChar (char cc, int factor)
{
  int ii;
  for (ii = 0; ii < factor; ii++)
    {
      return_FF_on_putCHAR_err (cc);
    }
  return pk_true;
}

/* PLG 2005-05-03, PLG 2007-03-14
 * this_file is a correctly open file descriptor
 * <strValue> is not NIL (not checked)
 * 1 <= <strLength> <= <strValue> length (not checked)
 * success: <strLength> <= 0, no effect
 *          <strLength> > 0, <strLength> first characters of <strValue> are put in this_file
 * failure: writing in this_file failed
 *          this is set in error
 *          stderr puts an error message
 * this_container remains unchanged
 */
boolean
NBuffer::put_prefix (const char *strValue, int strLength)
{
  int ii;
  for (ii = 0; ii < strLength; ii++)
    {
      if (!(PUT_CHAR (strValue[ii])))
	{
	  STRINGFAILURE ();
	  return pk_false;
	}
    }
  return pk_true;
}

/* PLG 2005-05-03, PLG 2007-03-14
 * this_file is a correctly open file descriptor
 * <positiveNumber> >= 0 (not checked)
 * success: puts string decimal representation of <positiveNumber> 
 * failure: error in file printing
 *          this is set in error
 *          stderr puts an error message
 * this_container remains unchanged
 */
boolean
NBuffer::put_digits (int positiveNumber)
{
  if (positiveNumber >= 10)
    {
      int n = positiveNumber / 10;
      if (!put_digits (n))
	return pk_false;
      positiveNumber = positiveNumber - 10 * n;
    }
  return_FF_on_putDIGIT_err (positiveNumber);
  return pk_true;
}

/* ==== SubSection eol, no splitting
 */

/* PLG 2005-05-02, PLG 2007-03-14
 * this_file is a correctly open file descriptor
 * this_container is not empty and is not larger than printableLineLength - this_prefix size
 * success: puts optionaly left mark, followed by this container followed by eol
 *          sets container empty, spaced
 * failure: writting in this_file failed
 *          this is set in error
 *          stderr puts an error message
 */
boolean
NBuffer::put_marginFreeLine ()
{
  if (ISNOT_EMPTYPREFIX ())
    {
      return_FF_on_putPREFIX_err ();
    }
  return_FF_on_putCONTAINER_err ();
  return_FF_on_putEOL_NL_err ();
  SET_SPACED ();		/*SET_SPACED() */
  return pk_true;
}

#define PURGE_MARGINFREELINE() ( (IS_EMPTY()) ? pk_true : (put_marginFreeLine()) )

/* PLG 2005-05-03, PLG 2007-03-14
 * WARNING HAS_ACTUALMARGIN() is pk_true
 * this_file is a correctly open file descriptor
 * success: puts in this_file current left margin; does not put left mark
 *          returns actualMargin
 * failure: this_file writing failed
 *          this is set in error
 *          stderr puts an error message
 *          returns -1
 * this_container remains unchanged
 */
boolean
NBuffer::put_MARGIN ()
{
  int ii;
  for (ACTUALMARGIN_LOOP (ii))
    {
      return_FF_on_putSPACE_err ();
    }
  return pk_true;
}

/* PLG 2005-05-02, PLG 2007-03-14
 * this_file is a correctly open file descriptor
 * this_prefix size is at most printableLineLength
 * current line is continuation free
 * success: factor<=0 this has no effect
 *          factor > 0, puts factor empty lines in this_file
 *          each line is continuation free and
 *          if this_prefix is NIL
 *             each line has empty left margin
 *          if this_prefix is not NIL
 *             each line has optionnal current left margin, current prefix
 * failure: this_file writing failed
 *          set this buffer in error
 *          puts an error message
 * this_container remains unchanged
 */
boolean
NBuffer::put_emptyLines (int factor)
{
  int ii;
  if (IS_EMPTYPREFIX ())
    {
      for (ii = 0; ii < factor; ii++)
	{
	  return_FF_on_putEOL_err ();
	}
    }
  else if (HAS_ACTUALMARGIN ())
    {
      for (ii = 0; ii < factor; ii++)
	{
	  if (!put_MARGIN ())
	    return pk_false;
	  return_FF_on_putPREFIX_err ();
	  return_FF_on_putEOL_err ();
	}
    }
  else
    for (ii = 0; ii < factor; ii++)
      {
	return_FF_on_putPREFIX_err ();
	return_FF_on_putEOL_err ();
      }
  ADDTO_LINECOUNTER (factor);
  return pk_true;
}

/* PLG 2005-05-02, PLG 2007-03-14
 * WARNING only if ( MAY_HAVE_MARGIN() OK ) 
 * this_file is a correctly open file descriptor
 * this_container is not empty and is not larger than printableLineLength - this_prefix size
 * success: puts margin optionaly followed by left mark, followed by this container followed by eol
 *          sets container empty, spaced
 * failure: writting in this_file failed
 *          this is set in error
 *          stderr puts an error message
 */
boolean
NBuffer::put_marginLine ()
{
  if (HAS_ACTUALMARGIN ())
    if (!put_MARGIN ())
      return pk_false;
  if (ISNOT_EMPTYPREFIX ())
    {
      return_FF_on_putPREFIX_err ();
    }
  return_FF_on_putCONTAINER_err ();
  return_END_MARGINLINE ();	/*SET_SPACED() */
}

#define PURGE_MARGINLINE() ( (IS_EMPTY()) ? pk_true : (put_marginLine()) )

#define PURGE_LINE() ( (MAY_HAVE_MARGIN()) ? (PURGE_MARGINLINE()) : (PURGE_MARGINFREELINE()) )
#define PUT_LINE() ( (MAY_HAVE_MARGIN()) ? (put_marginLine()) : (put_marginFreeLine()) )


/* PLG 2005-05-02, PLG 2007-03-14
 * this_file is a correctly open file descriptor
 * this_container is not empty and is not larger than printableLineLength - this_prefix size
 * success: puts optionaly margin followed by this container followed by eol
 *          sets container empty, spaced
 * failure: writting in this_file failed
 *          this is set in error
 *          stderr puts an error message
 */
boolean
NBuffer::put_prefixFreeLine ()
{
  if (HAS_ACTUALMARGIN ())
    {
      if (!put_MARGIN ())	/* error is set */
	return pk_false;
      return_FF_on_putCONTAINER_err ();
      return_END_MARGINLINE ();	/*SET_SPACED() */
    }
  return_FF_on_putCONTAINER_err ();
  return_END_LINE ();		/*SET_SPACED() */
}

#define PURGE_PREFIXFREELINE() ( (IS_EMPTY()) ? pk_true : (put_prefixFreeLine()) )

/* PLG 2005-05-13, PLG 2007-03-14
 * lg > 0
 * success: container has lg spaces available
 *          container has less than lg spaces available, container is put in this_file
 *                  emptied container has lg spaces available, container is spaced
 * failure: this_file is not correctly open or 
 *          a writing error has occured or file is not open but this is not in error
 *              this is set in error
 *              an error message is printed
 *          current available size is too small even after printing
 */
boolean
NBuffer::putLineIfNotFit_fit (int lg)
{
  //  fprintf(stderr, "DEBUG NBuffer::putLineIfNotFit_fit, length is %i\n", lg);
  if (MAY_HAVE_MARGIN ())
    {
      if (ACTUALMARGIN_FIT (lg))
	return pk_true;
      if (IS_EMPTY ())
	return pk_false;
      if (!put_marginLine ())
	return pk_false;
      return ACTUALMARGIN_FIT_INEMPTY (lg);
    }
  if (MARGINFREE_FIT (lg))
    return pk_true;
  if (IS_EMPTY ())
    return pk_false;
  if (!put_marginFreeLine ())
    return pk_false;		/* SET_SPACED() */
  return MARGINFREE_FIT_INEMPTY (lg);
}

#define return_TT_IF_Uprint_CHAR_CHAR_NS(CC1, CC2) if ( putLineIfNotFit_fit(2) ) { ADD_CHAR_CHAR_NS(CC1, CC2); return pk_true; }
#define return_Uprint_CHAR_CHAR_NS(CC1, CC2)  return_TT_IF_Uprint_CHAR_CHAR_NS(CC1, CC2); return pk_false;

/* ==== SubSection append continued line
 */

/* PLG 2007-03-08, PLG 2007-03-14
 * this_file is a correctly open file descriptor in an empty container
 * available space in this_container is large enough to hold argument
 * <cc> is added <factor> times in this_container;
 * remains unchanged IS_SPACED()
 */
void
NBuffer::add_nChar (char cc, int factor)
{
  if (factor > 2)
    {
      int ii;
      for (ii = 0; ii < factor - 1; ii++)
	{
	  ASSIGN_CHAR_AHEAD (cc, ii);
	}
      ADD_CHAR_AHEAD (cc, factor - 1);
    }
  else if (factor == 2)
    {
      ADD_CHAR_CHAR (cc, cc);
    }
  else if (factor == 1)
    {
      ADD_CHAR (cc);
    }
}

/* PLG 2007-03-08, PLG 2007-03-14
 * this_file is a correctly open file descriptor in an empty container
 * available space in this_container is large enough to hold argument
 * <str> is added in this_container
 * remains unchanged IS_SPACED()
 */
void
NBuffer::add_subString (const char *str, int strlg)
{
  ADD_PREFIX (str, strlg);
}

/* PLG 2005-05-02, PLG 2007-03-14
 * this_file is a correctly open file descriptor
 * <positiveNumber> >= 0 (not checked)
 * current buffer is a margin free line having enough available space for <positiveNumber> decimal string
 * success: if line is completed, puts line continuation
 *          puts (possibly split) <strValue> in this_file
 * failure: error in file printing
 *          this is set in error
 *          stderr puts an error message
 * remains unchanged IS_SPACED()
 */
void
NBuffer::add_digits (int positiveNumber)
{
  if (positiveNumber >= 10)
    {
      int nn = positiveNumber / 10;
      add_digits (nn);
      positiveNumber = positiveNumber - 10 * nn;
    }
  ADD_CHAR (CHAR_DIGIT (positiveNumber));
}

/* ==== SubSection with possible continued splitting
 */

/* PLG 2005-05-02, PLG 2007-03-14
 * this_file is a correctly open file descriptor
 * <strValue> is not NIL and not empty
 * <strLength> > 0, is <strValue> length
 * current buffer is a margin free line, 
 *       <strLength> first characters of <strValue> have to be left glued to this current buffer
 * success: puts <strValue> (arbitrary split) in this_file
 *          puts remainder in this container
 * failure: error in file printing
 *          this is set in error
 *          stderr puts an error message
 * remains unchanged IS_SPACED()
 */
boolean
NBuffer::appendMFOver_split_string (const char *strValue, int strLength)
{
  //  fprintf(stderr, "DEBUG NBuffer::appendMFOver_split_string, MAX_AVAILABLE_SPACE is %i, MARGINFREE_AVAILABLE_SPACE is %i\n", MAX_AVAILABLE_SPACE(), MARGINFREE_AVAILABLE_SPACE());
  //  fprintf(stderr, "DEBUG NBuffer::appendMFOver_split_string, length is %i, strValue is \n++<%s>++\n", strLength, strValue);
  int availableSpace = MARGINFREE_AVAILABLE_SPACE ();
  add_subString (strValue, availableSpace);
  return_FF_on_putCONTINUEDLINE_err ();
  strLength = strLength - availableSpace;
  strValue = (strValue + availableSpace);
  while ((MAX_AVAILABLE_SPACE ()) < strLength)
    {
      if (!put_prefix (strValue, MAX_AVAILABLE_SPACE ()))
	return pk_false;
      strLength = strLength - MAX_AVAILABLE_SPACE ();
      if (strLength == 0)
	return pk_true;
      return_FF_on_putCONTINUATIONEOL_NL_err ();
      strValue = (strValue + MAX_AVAILABLE_SPACE ());
    }
  ADD_STRING (strValue);
  return pk_true;
}

/* PLG 2005-05-02, PLG 2007-03-14
 * this_file is a correctly open file descriptor
 * <positiveNumber> >= 0 (not checked)
 * current buffer is a margin free line, 
 * success: if line is completed, puts line continuation
 *          puts split <positiveNumber> string digital value in this container
 * failure: error in file printing
 *          this is set in error
 *          stderr puts an error message
 * remains unchanged IS_SPACED()
 */
boolean
NBuffer::appendMFOver_split_digits (int positiveNumber)
{
  if (positiveNumber >= 10)
    {
      int n = positiveNumber / 10;
      if (!appendMFOver_split_digits (n))
	return pk_false;
      positiveNumber = positiveNumber - 10 * n;
    }
  if (MARGINFREE_OVER (1))
    {
      return_FF_on_putCONTINUEDLINE_err ();
    }
  ADD_CHAR (CHAR_DIGIT (positiveNumber));
  return pk_true;
}

/* PLG 2007-03-08, PLG 2007-03-14
 * this_file is a correctly open file descriptor
 * <strLength> > 0 
 * current buffer is a margin free line, <strLength> occurrences of <cc> have to be left glued to this current buffer
 * success: puts in this_file (possibly split) 
 *             <strLength> times <cc>
 *          puts remainder in this container in a coninued line
 * failure: error in this_file printing
 *          this is set in error
 *          stderr puts an error message
 * remains unchanged IS_SPACED()
 */
boolean
NBuffer::appendMF_lGlueSplit_nChar (char cc, int strLength)
{
  if (MARGINFREE_OVER (strLength))
    {
      int availableSpace = MARGINFREE_AVAILABLE_SPACE ();
      add_nChar (cc, availableSpace);
      return_FF_on_putCONTINUEDLINE_err ();
      strLength = strLength - availableSpace;
      while ((MAX_AVAILABLE_SPACE ()) < strLength)
	{
	  if (!put_nChar (cc, MAX_AVAILABLE_SPACE ()))
	    return pk_false;
	  strLength = strLength - MAX_AVAILABLE_SPACE ();
	  if (strLength == 0)
	    return pk_true;
	  return_FF_on_putCONTINUATIONEOL_NL_err ();
	}
    }
  /* 0 < strLength < MAX_AVAILABLE_SPACE() */
  add_nChar (cc, strLength);
  return pk_true;
}

/* PLG 2005-05-03, PLG 2007-03-14
 * this_file is a correctly open file descriptor
 * margin free printing in "splitable" file
 * <strValue> is not NIL and not empty string
 * success: strLength is not greater than available space
 *              <strValue> is added to container
 *          strLength is greater than available space
 *              <strValue> is <cc1>...<cc_a><STR_1>...<STR_n><ss_1>...<ss_l>
 *                    where a is at most available space in container,
 *                          for each i <STR_i> length is >0 and is at most container size
 *                          l is smaller than container size
 *                  prefix <cc1>...<cc_a> is added to container followed by continuation mark
 *                      container is put into file
 *                  <STR_i> followed by continuation mark are put into file
 *                  <ss_1>...<ss_l> is copied in container to be margin free printed
 * failure: error in this_file printing
 *          this is set in error
 *          stderr puts an error message
 * remains unchanged IS_SPACED()
 */
boolean
NBuffer::appendMF_lGlueSplit_string (const char *strValue, int strLength)
{
  //  fprintf(stderr, "DEBUG NBuffer::appendMF_lGlueSplit_string, length is %i, strValue is \n++<%s>++\n", strLength, strValue);
  if (MARGINFREE_OVER (strLength))
    {
      if (this_breakCharList == NIL_String)
	return appendMFOver_split_string (strValue, strLength);	/*remains unchanged IS_SPACED() */
      int printedLength;
      do
	{
	  printedLength = largestPrefixLengthUntilCharInStr (strValue, this_breakCharList, MARGINFREE_AVAILABLE_SPACE ()) + 1;
	  if (printedLength <= 0)
	    {
	      if ((MAX_AVAILABLE_SPACE ()) < strLength)
		{
		  printedLength = largestPrefixLengthUntilCharInStr (strValue, this_breakCharList, MAX_AVAILABLE_SPACE ()) + 1;
		  if (printedLength <= 0)
		    return appendMFOver_split_string (strValue, strLength);
		}		/*remains unchanged IS_SPACED() */
	      return_FF_on_putCONTINUEDLINE_err ();
	      break;
	    }
	  add_subString (strValue, printedLength);
	  strLength = strLength - printedLength;
	  if (strLength == 0)
	    return pk_true;
	  return_FF_on_putCONTINUEDLINE_err ();
	  strValue = (strValue + printedLength);
	}
      while (MARGINFREE_OVER (strLength));
    }
  ADD_STRING (strValue);
  //  fprintf(stderr, "DEBUG NBuffer:: appendMF_lGlueSplit_string  DONE OUT, MAX_AVAILABLE_SPACE is %i, MARGINFREE_AVAILABLE_SPACE is %i\n", MAX_AVAILABLE_SPACE(), MARGINFREE_AVAILABLE_SPACE());
  return pk_true;
}

/* PLG 2005-05-02, PLG 2007-03-14
 * this_file is a correctly open file descriptor
 * <positiveNumber> >= 0 (not checked)
 * current buffer is a margin free line, 
 * success: if line is completed, puts line continuation
 *          puts (possibly split) <positiveNumber> string digital value in this container
 * failure: error in file printing
 *          this is set in error
 *          stderr puts an error message
 * remains unchanged IS_SPACED()
 */
boolean
NBuffer::appendMF_lGlueSplit_posInt (int positiveNumber, int decimalLength)
{
  if (MARGINFREE_OVER (decimalLength))
    return appendMFOver_split_digits (positiveNumber);	/*remains unchanged IS_SPACED() */
  ADD_POSINT (positiveNumber, decimalLength);
  return pk_true;
}

/* ==== ==== Section this_container file printing
 */

/* PLG 2005-05-13
 * success: if available space in container is too small 
 *              puts container content in this_file
 *              empties container
 *          appends <cc> to container, set container not spaced
 * failure: error in this_file printing
 *          this is set in error
 *          stderr puts an error message
 */
boolean
NBuffer::appendMargin_ (char cc)
{
  if (IS_ACTUALMARGIN_FULL ())	/* SET_SPACED() */
    if (!(put_marginLine ()))
      return pk_false;
  ADD_CHAR (cc);
  SET_NOTSPACED ();		/* SET_NOTSPACED() */
  return pk_true;
}

/* PLG 2005-05-13
 * success: if available space in container is too small 
 *              puts container content in this_file
 *              empties container
 *          appends <cc> to container, set container not spaced
 * failure: error in this_file printing
 *          this is set in error
 *          stderr puts an error message
 */
boolean
NBuffer::appendMarginFree_ (char cc)	/* PLG chek if required */
{
  if (IS_MARGINFREE_FULL ())	/* SET_SPACED() */
    if (!(put_marginFreeLine ()))
      return pk_false;
  ADD_CHAR (cc);
  SET_NOTSPACED ();		/* SET_NOTSPACED() */
  return pk_true;
}

/* ====================================== inner printing functions 
 */


/* PLG 2005-05-02, PLG 2007-03-14
 * this_file is a correctly open file descriptor
 * margin free actual printing in "splitable" file
 * <strValue> is not NIL and not empty string
 * success: <strLength>+1 is not greater than margin free available space
 *              current container content followed by <strValue> <cc> is margin free put in file
 *          strLength is greater than available space
 *                <strValue> is <cc1>...<cc_a><STR_1>...<STR_n><ss_1>...<ss_l>
 *                    where a is at most available space in container,
 *                          for each i <STR_i> length is >0 and is at most container size
 *                          l is smaller than container size
 *              current container content followed by <cc1>...<cc_a> followed by continuation mark is margin free put in file
 *              <STR_i> followed by continuation mark are margin free put in file
 *              <ss_1>...<ss_l><cc> is margin free put in file
 *          SET SPACED
 * failure: error in file printing
 *          this is set in error
 *          stderr puts an error message
 */
boolean
NBuffer::UprintMF_eolIfSplit_str_chr (const char *strValue, int strLength, char cc)
{
  if (MARGINFREE_OVER (strLength + 1))
    {
      if (!appendMF_lGlueSplit_string (strValue, strLength))
	return pk_false;
      if (IS_MARGINFREE_FULL ())
	{
	  return_FF_on_putCONTINUEDLINE_err ();
	}
      ADD_CHAR (cc);
    }
  else
    {
      ADD_STRING_CHAR (strValue, cc);
    }
  return_FF_on_putCONTAINER_err ();
  return_END_LINE ();		/*SET_SPACED() */
}

/* PLG 2005-05-02, PLG 2007-03-14
 * this_file is a correctly open file descriptor
 * margin free actual printing in "splitable" file
 * <strValue> is not NIL and not empty string
 * <decimalLength> is the length of <positiveNumber> decimal representation
 * success: <strLength>+<decimalLength> is not greater than margin free available space
 *              current container content followed by <strValue><cc> is margin free put in file
 *          strLength is greater than available space
 *                <strValue> is <cc1>...<cc_a><STR_1>...<STR_n><ss_1>...<ss_l>
 *                <positiveNumber> is <d_1>...<d_m>, <decimalLength>=m
 *                    where a is at most available space in container,
 *                          for each i <STR_i> length is >0 and is at most container size
 *                          l is smaller than container size
 *              current container content followed by <cc1>...<cc_a> followed by continuation mark is margin free put in file
 *              <STR_i> followed by continuation mark are margin free put in file
 *              l+m is not greater than container size
 *                   <ss_1>...<ss_l><d_1>...<d_m> is margin free put in file
 *              l+m is greater than container size
 *                   <ss_1>...<ss_l> followed by continuation mark is margin free put in file
 *                   <d_1>...<d_m> is margin free put in file
 *          SET SPACED
 * failure: error in file printing
 *          this is set in error
 *          stderr puts an error message
 */
boolean
NBuffer::UprintMF_eolIfSplit_str_int (const char *strValue, int strLength, long int positiveNumber, int decimalLength)
{
  if (MARGINFREE_OVER (strLength + decimalLength))
    {
      if (!appendMF_lGlueSplit_string (strValue, strLength))
	return pk_false;
      if (MARGINFREE_OVER (decimalLength))
	{
	  if (!appendMFOver_split_digits (positiveNumber))
	    return pk_false;
	}
      else
	{
	  ADD_POSINT (positiveNumber, decimalLength);
	}
    }
  else
    {
      ADD_STRING (strValue);
      ADD_POSINT (positiveNumber, decimalLength);
    }
  return_FF_on_putCONTAINER_err ();
  return_END_LINE ();		/*SET_SPACED() */
}

/* PLG 2005-05-03, PLG 2007-03-15
 * this_file is a correctly open file descriptor
 * this container is not space terminated
 * success: container is full wrt current margin rule
 *             puts container content in this_file
 *             empties container
 *          container is not full wrt current margin rule
 *              appends ' ' to this container
 *          cpntainer is SET_SPACED() 
 * failure: error in this_file printing
 *          this is set in error
 *          stderr puts an error message
 */
boolean
NBuffer::Uprint_sp ()
{
  if (MAY_HAVE_MARGIN ())
    {
      if (IS_ACTUALMARGIN_FULL ())
	return put_marginLine ();
    }				/*SET_SPACED() */
  else if (IS_MARGINFREE_FULL ())
    return put_marginFreeLine ();	/* SET_SPACED() */
  ADD_SP ();			/* SET_SPACED() */
  return pk_true;
}

/* PLG 2005-05-13, PLG 2007-03-15
 * success: if available space in container is too small 
 *              puts container content in this_file
 *              empties container
 *          appends <cc> to container, set container not spaced
 * failure: error in this_file printing
 *          this is set in error
 *          stderr puts an error message
 */
boolean
NBuffer::Uprint (char cc)
{
  if (MAY_HAVE_MARGIN ())
    {
      if (IS_ACTUALMARGIN_FULL ())
	if (!(put_marginLine ()))
	  return pk_false;
    }				/* SET_SPACED() */
  else if (IS_MARGINFREE_FULL ())
    if (!(put_marginFreeLine ()))
      return pk_false;		/* SET_SPACED() */
  ADD_CHAR_NS (cc);		/* SET_NOTSPACED() */
  return pk_true;
}

/* PLG 2005-05-03, PLG 2007-03-15
 * this container is not space terminated
 * success: container has less than two available spaces
 *             puts container content in this_file
 *             empties container
 *             appends <cc> to container
 *          container has at least two available spaces
 *             appends ' ' followed by <cc> to container
 * failure: error in this_file printing
 *          this is set in error
 *          stderr puts an error message
 */
boolean
NBuffer::Uprint_sp_ (char cc)
{
  if (MAY_HAVE_MARGIN ())
    {
      if (ACTUALMARGIN_OVER (2))
	{
	  if (!put_marginLine ())
	    return pk_false;	/* SET_SPACED() */
	  ADD_CHAR_NS (cc);
	  return pk_true;
	}
    }
  else if (MARGINFREE_OVER (2))
    {
      if (!put_marginFreeLine ())
	return pk_false;		/* SET_SPACED() */
      ADD_CHAR_NS (cc);
      return pk_true;
    }
  ADD_WH_CHAR_NS (cc);
  return pk_true;
}

/* PLG 2005-05-03, PLG 2007-03-15
 * this container is not space terminated
 * success: container is full
 *             puts container content in this_file
 *             empties container
 *             appends <cc> followed by ' ' to container
 *          container has a single space available
 *             appends <cc> to container
 *             puts container content in this_file
 *             empties container
 *          container has more than one space available
 *             appends <cc> followed by ' ' to container
 * failure: error in this_file printing
 *          this is set in error
 *          stderr puts an error message
 */
boolean
NBuffer::Uprint_sp__sp (char cc)
{
  if (MAY_HAVE_MARGIN ())
    {
      if (ACTUALMARGIN_FIT (3))
	{
	  ADD_WH_CHAR_SP (cc);	/* SET_SPACED() */
	  return pk_true;
	}
      if (ACTUALMARGIN_FIT (2))
	{
	  ADD_WH_CHAR (cc);
	  return put_marginLine ();
	}			/* SET_SPACED() */
      if (!(put_marginLine ()))
	return pk_false;
    }				/* SET_SPACED() */
  else
    {
      if (MARGINFREE_FIT (3))
	{
	  ADD_WH_CHAR_SP (cc);	/* SET_SPACED() */
	  return pk_true;
	}
      if (MARGINFREE_FIT (2))
	{
	  ADD_WH_CHAR (cc);
	  return put_marginFreeLine ();
	}			/* SET_SPACED() */
      if (!(put_marginFreeLine ()))
	return pk_false;
    }				/* SET_SPACED() */
  ADD_CHAR_SP (cc);		/* SET_SPACED() */
  return pk_true;
}

/* PLG 2005-05-03, PLG 2007-03-15
 * success: container is full
 *             puts container content in this_file
 *             empties container
 *             appends <cc> followed by ' ' to container
 *          container has a single space available
 *             appends <cc> to container
 *             puts container content in this_file
 *             empties container
 *          container has more than one space available
 *             appends <cc> followed by ' ' to container
 * failure: error in this_file printing
 *          this is set in error
 *          stderr puts an error message
 */
boolean
NBuffer::Uprint__sp (char cc)
{
  if (MAY_HAVE_MARGIN ())
    {
      if (ACTUALMARGIN_OVER (2))
	if (IS_ACTUALMARGIN_FULL ())
	  {
	    if (!(put_marginLine ()))
	      return pk_false;
	  }
	else
	  {
	    ADD_CHAR (cc);
	    return put_marginLine ();
	  }
    }				/* SET_SPACED() */
  else if (MARGINFREE_OVER (2))
    if (IS_MARGINFREE_FULL ())
      {
	if (!(put_marginFreeLine ()))
	  return pk_false;
      }
    else
      {
	ADD_CHAR (cc);
	return put_marginFreeLine ();
      }				/* SET_SPACED() */
  ADD_CHAR_SP (cc);		/* SET_SPACED() */
  return pk_true;
}

/* PLG 2005-05-03, PLG 2007-03-15
 * success: container is full
 *             puts container content in this_file
 *             empties container
 *             appends <cc> followed by ' ' to container
 *          container has a single space available
 *             appends <cc> to container
 *             puts container content in this_file
 *             empties container
 *          container has more than one space available
 *             appends <cc> followed by ' ' to container
 * failure: error in this_file printing
 *          this is set in error
 *          stderr puts an error message
 */
boolean
NBuffer::Uprint__sp (char cc1, char cc2)
{
  if (MAY_HAVE_MARGIN ())
    {
      if (ACTUALMARGIN_OVER (3))
	{
	  if (ACTUALMARGIN_FIT (2))
	    {
	      ADD_CHAR_CHAR (cc1, cc2);
	      return put_marginLine ();
	    }			/* SET_SPACED() */
	  if (!(put_marginLine ()))
	    return pk_false;
	}
    }				/* SET_SPACED() */
  else
    {
      if (MARGINFREE_OVER (3))
	{
	  if (MARGINFREE_FIT (2))
	    {
	      ADD_CHAR_CHAR (cc1, cc2);
	      return put_marginFreeLine ();
	    }			/* SET_SPACED() */
	  if (!(put_marginFreeLine ()))
	    return pk_false;
	}
    }				/* SET_SPACED() */
  ADD_CHAR_CHAR_SP (cc1, cc2);	/* SET_SPACED() */
  return pk_true;
}

/* PLG 2005-05-03, PLG 2007-03-15
 * this_file is a correctly open file descriptor
 * <factor> > 0
 * success: if available space in container is greater than <factor>
 *              appends <factor> occurrences of <cc> to container 
 *          if available space in container is smaller than <factor>
 *             puts container content in this_file
 *             empties container
 *             if available space in container becomes greater than <factor>
 *                appends <factor> occurrences of <cc> to container, followed by eol
 *             if available space cannot be made large enough in container
 *                if splitting is allowed  
 *                   puts split <factor> occurrences of <cc>  in this_file, followed by eol
 *                   each intermediate line is terminated b continuation mark
 *                if splitting is not allowed  
 *                   puts <factor> occurrences of <cc>  in this_file, followed by eol
 * failure: error in this_file printing
 *          this is set in error
 *          stderr puts an error message
 */
boolean
NBuffer::Uprint_eolIfSplit_nChar (char cc, int factor)
{
  if (putLineIfNotFit_fit (factor))
    {				/* SET_SPACED() if container is emptied */
      unsafe_cpyNChar (CONTAINER_FREETAIL (), cc, factor);
      SET_ADDED (factor);
      SET_NOTSPACED ();
      return pk_true;
    }
  if (IS_SAFE ())
    {
      if (this_canBeSplit)
	{
	  if (!appendMF_lGlueSplit_nChar (cc, factor))
	    return pk_false;	/*remains unchanged IS_SPACED() */
	  return_FF_on_putCONTAINER_err ();
	}
      else if (!put_nChar (cc, factor))
	return pk_false;
      return_END_LINE ();	/*SET_SPACED() */
    }
}

/* PLG 2005-05-03, PLG 2007-03-15
 * this_file is a correctly open file descriptor
 * <strValue> is not NIL and not empty string
 * success: if available space in container is greater than <factor>
 *              appends <strValue> to container 
 *          if available space in container is smaller than <strValue> length (LG)
 *             puts container content in this_file
 *             empties container
 *             if available space in container becomes greater than <factor>
 *                appends <strValue> to container, followed by eol
 *             if available space cannot be made large enough in container 
 *                if splitting is allowed  
 *                   puts split <strValue> in this_file, followed by eol
 *                   each intermediate line is terminated b continuation mark
 *                if splitting is not allowed  
 *                   puts <strValue>  in this_file, followed by eol
 * failure: error in this_file printing
 *          this is set in error
 *          stderr puts an error message
 */
boolean
NBuffer::Uprint_eolIfSplit_str (const char *strValue)
{
  int strLength = strlen (strValue);
  //  fprintf(stderr, "DEBUG NBuffer::Uprint_eolIfSplit_str, length is %i, strValue is \n++<%s>++\n", strLength, strValue);
  if (putLineIfNotFit_fit (strLength))
    {				/* SET_SPACED() if container is emptied */
      ADD_STRING_NS (strValue);
      return pk_true;
    }
  if (IS_SAFE ())
    {
      if (this_canBeSplit)
	{
	  if (!appendMF_lGlueSplit_string (strValue, strLength))
	    return pk_false;
	  return_FF_on_putCONTAINER_err ();
	}
      else
	{
	  return_FF_on_putSTRING_err (strValue);
	}
      return_END_LINE ();	/*SET_SPACED() */
    }
  return pk_false;
}

/* PLG 2005-05-03, PLG 2007-03-15
 * this_file is a correctly open file descriptor
 * <strValue> is not NIL and not empty string
 * equivalent to Uprint_eolIfSplit_str(strValue); Uprint_sp()
 */
boolean
NBuffer::Uprint_eolIfSplit_str_sp (const char *strValue)
{
  int strLength = strlen (strValue);
  if (putLineIfNotFit_fit (strLength))
    {				/* SET_SPACED() if container is emptied */
      ADD_STRING (strValue);
      return Uprint_sp ();
    }
  if (IS_SAFE ())
    {
      if (this_canBeSplit)
	{
	  if (!appendMF_lGlueSplit_string (strValue, strLength))
	    return pk_false;
	  return_FF_on_putCONTAINER_err ();
	}
      else
	{
	  return_FF_on_putSTRING_err (strValue);
	}
      return_END_LINE ();	/*SET_SPACED() */
    }
  return pk_false;
}

/* PLG 2005-05-03, PLG 2007-03-15
 * this_file is a correctly open file descriptor
 * <strValue> is not NIL and not empty string, 
 * equivalent to Uprint_eolIfSplit_str(fullString)
 *    where fullString is the concatenation of <cc> and <strValue>
 */
boolean
NBuffer::Uprint_eolIfSplit_chr_str (char cc, const char *strValue)
{
  int strLength = strlen (strValue);
  if (putLineIfNotFit_fit (strLength + 1))
    {				/* SET_SPACED() if container is emptied */
      ADD_CHAR_STRING_NS (cc, strValue);
      return pk_true;
    }
  if (IS_SAFE ())
    {
      if (this_canBeSplit)
	{
	  ADD_CHAR (cc);
	  if (!appendMF_lGlueSplit_string (strValue, strLength))
	    return pk_false;
	  return_FF_on_putCONTAINER_err ();
	}
      else
	{
	  return_FF_on_putCHAR_err (cc);
	  return_FF_on_putSTRING_err (strValue);
	}
      return_END_LINE ();	/*SET_SPACED() */
    }
  return pk_false;
}

/* PLG 2005-05-03, PLG 2007-03-15
 * this_file is a correctly open file descriptor
 * <strValue> is not NIL and not empty string, 
 * equivalent to Uprint_eolIfSplit_str(fullString)
 *    where fullString is the concatenation of <strValue> and <cc> 
 */
boolean
NBuffer::Uprint_eolIfSplit_str_chr (const char *strValue, char cc)
{
  int strLength = strlen (strValue);
  if (putLineIfNotFit_fit (strLength + 1))
    {				/* SET_SPACED() if container is emptied */
      ADD_STRING_CHAR_NS (strValue, cc);
      return pk_true;
    }
  if (IS_SAFE ())
    {
      if (this_canBeSplit)
	return UprintMF_eolIfSplit_str_chr (strValue, strLength, cc);
      return_FF_on_putSTRING_err (strValue);
      return_FF_on_putCHAR_err (cc);
      return_END_LINE ();	/*SET_SPACED() */
    }
  return pk_false;
}

/* PLG 2005-05-03, PLG 2007-03-15
 * this_file is a correctly open file descriptor
 * <strValue> is not NIL and not empty string, 
 * equivalent to Uprint_eolIfSplit_str(fullString)
 *    where fullString is the concatenation of <cc1>, <strValue> and <cc2> 
 */
boolean
NBuffer::Uprint_eolIfSplit_chr_str_chr (char cc1, const char *strValue, char cc2)
{
  int strLength = strlen (strValue);
  if (putLineIfNotFit_fit (strLength + 2))
    {				/* SET_SPACED() if container is emptied */
      ADD_CHAR_STRING (cc1, strValue);
      ADD_CHAR_NS (cc2);
      return pk_true;
    }
  if (IS_SAFE ())
    {
      if (this_canBeSplit)
	{
	  ADD_CHAR (cc1);
	  return UprintMF_eolIfSplit_str_chr (strValue, strLength, cc2);	/*SET_SPACED() */
	}
      return_FF_on_putCHAR_err (cc1);
      return_FF_on_putSTRING_err (strValue);
      return_FF_on_putCHAR_err (cc2);
      return_END_LINE ();	/*SET_SPACED() */
    }
  return pk_false;
}

/* PLG 2005-05-03, PLG 2007-03-15
 * this_file is a correctly open file descriptor
 * <strValue1> is not NIL and not empty string, <strValue2> is not NIL and not empty string
 * equivalent to Uprint_eolIfSplit_str(fullString)
 *    where fullString is the concatenation of <strValue1> and <strValue2> 
 */
boolean
NBuffer::Uprint_eolIfSplit_str_str (const char *strValue1, const char *strValue2)
{
  int strLength1 = strlen (strValue1);
  int strLength2 = strlen (strValue2);
  int totalLength = strLength1 + strLength2;
  if (putLineIfNotFit_fit (totalLength))
    {				/* SET_SPACED() if container is emptied */
      ADD_STRING (strValue1);
      ADD_STRING_NS (strValue2);
      return pk_true;
    }
  if (IS_SAFE ())
    {
      if (this_canBeSplit)
	{
	  if (MARGINFREE_OVER (totalLength))
	    {
	      if (!appendMF_lGlueSplit_string (strValue1, strLength1))
		return pk_false;	/*remains unchanged IS_SPACED() */
	      if (!appendMF_lGlueSplit_string (strValue2, strLength2))
		return pk_false;
	    }
	  else
	    {
	      ADD_STRING (strValue1);
	      ADD_STRING_NS (strValue2);
	    }
	  return_FF_on_putCONTAINER_err ();
	}			/*SET_SPACED() */
      else
	{
	  return_FF_on_putSTRING_err (strValue1);
	  return_FF_on_putSTRING_err (strValue2);
	}
      return_END_LINE ();
    }				/*SET_SPACED() */
  return pk_false;
}

/* PLG 2005-05-03, PLG 2007-03-15
 * this_file is a correctly open file descriptor
 * <nbElem> > 0 is not greater than <strArray> element numbers
 * <fullString> is the concatenation of <nbElem> first strings in <strArray>
 * first strArray element is not empty string
 * equivalent to Uprint_eolIfSplit_str(fullString)
 */
boolean
NBuffer::Uprint_eolIfSplit_strArray (int nbElem, const char *strArray[])
{
  int ii;
  const char *curString;
  int totalLength = get_strArraySize (strArray, nbElem);
  if (putLineIfNotFit_fit (totalLength))
    {				/* SET_SPACED() if container is emptied */
      for (ii = 0; ii < nbElem; ii++)
	{
	  curString = strArray[ii];
	  if (ISNOT_NULL_STRING (curString))
	    ADD_STRING (curString);
	}
      SET_NOTSPACED ();
      return pk_true;
    }
  if (IS_SAFE ())
    {
      if (this_canBeSplit)
	{
	  if (MARGINFREE_OVER (totalLength))
	    {
	      for (ii = 0; ii < nbElem; ii++)
		{
		  curString = strArray[ii];
		  if (ISNOT_NULL_STRING (curString))
		    if (!appendMF_lGlueSplit_string (curString, strlen (curString)))
		      return pk_false;
		}
	    }
	  else
	    {
	      for (ii = 0; ii < nbElem; ii++)
		{
		  curString = strArray[ii];
		  if ((ISNOT_NULL_STRING (curString)))
		    {
		      ADD_STRING (curString);
		    }
		}
	    }
	  return_FF_on_putCONTAINER_err ();
	}
      else
	{
	  for (ii = 0; ii < nbElem; ii++)
	    {
	      curString = strArray[ii];
	      if ((ISNOT_NULL_STRING (curString)))
		{
		  return_FF_on_putSTRING_err (curString);
		}
	    }
	}
      return_END_LINE ();	/*SET_SPACED() */
    }
  return pk_false;
}

/* PLG 2005-05-03, PLG 2007-03-15
 * this_file is a correctly open file descriptor
 * <nbElem> > 0 is not greater than <strArray> element numbers
 * <fullString> is the concatenation of space separated <nbElem> first strings in <strArray>
 * first strArray element is not empty string
 * equivalent to Uprint_eolIfSplit_str(fullString)
 */
boolean
NBuffer::Uprint_eolIfSplit_strArray_sp (int nbElem, const char *strArray[])
{
  int ii;
  const char *curString;
  int totalLength = get_strCondSepArraySize (strArray, nbElem, 1);
  if (putLineIfNotFit_fit (totalLength))
    {				/* SET_SPACED() if container is emptied */
      for (ii = 0; ii < nbElem; ii++)
	{
	  curString = strArray[ii];
	  if (ISNOT_NULL_STRING (curString))
	    ADD_STRING_SP (curString);
	}
      return pk_true;
    }
  if (IS_SAFE ())
    {
      if (this_canBeSplit)
	{
	  if (MARGINFREE_OVER (totalLength))
	    {
	      for (ii = 0; ii < (nbElem - 1); ii++)
		{
		  curString = strArray[ii];
		  if (ISNOT_NULL_STRING (curString))
		    {
		      if (!appendMF_lGlueSplit_string (curString, strlen (curString)))
			return pk_false;
		      if (MARGINFREE_OVER (1))
			{
			  return_FF_on_putCONTAINER_err ();
			}
		      else
			{
			  ADD_SP ();
			}
		    }
		}
	      curString = strArray[nbElem - 1];
	      if (ISNOT_NULL_STRING (curString))
		{
		  if (!appendMF_lGlueSplit_string (curString, strlen (curString)))
		    return pk_false;
		}
	      else
		{
		  for (ii = 0; ii < (nbElem - 1); ii++)
		    {
		      curString = strArray[ii];
		      if ((ISNOT_NULL_STRING (curString)))
			{
			  ADD_STRING_SP (curString);
			}
		    }
		  curString = strArray[nbElem - 1];
		  if ((ISNOT_NULL_STRING (curString)))
		    {
		      ADD_STRING (curString);
		    }
		}
	    }
	  return_FF_on_putCONTAINER_err ();
	}
      else
	{
	  for (ii = 0; ii < (nbElem - 1); ii++)
	    {
	      curString = strArray[ii];
	      if ((ISNOT_NULL_STRING (curString)))
		{
		  return_FF_on_putSTRING_err (curString);
		  return_FF_on_putSPACE_err ();
		}
	    }
	  curString = strArray[nbElem - 1];
	  if ((ISNOT_NULL_STRING (curString)))
	    {
	      return_FF_on_putSTRING_err (curString);
	    }
	}
      return_END_LINE ();	/*SET_SPACED() */
    }
  return pk_false;
}

/* PLG 2005-05-03, PLG 2007-03-15
 * this_file is a correctly open file descriptor
 * <positiveNumber> > 0
 * equivalent to Uprint_eolIfSplit_str(fullString)
 *    where fullString is the decimal, string representation of <positiveNumber>
 */
boolean
NBuffer::Uprint_eolIfSplit_int (long int positiveNumber)
{
  short decimalLength = get_strPosIntSize (positiveNumber);
  if (putLineIfNotFit_fit (decimalLength))
    {				/* SET_SPACED() if container is emptied */
      ADD_POSINT_NS (positiveNumber, decimalLength);
      return pk_true;
    }
  if (IS_SAFE ())
    {
      if (this_canBeSplit)
	{
	  if (MARGINFREE_OVER (decimalLength))
	    {
	      if (!(appendMFOver_split_digits (positiveNumber)))
		return pk_false;
	    }
	  else
	    {
	      ADD_POSINT (positiveNumber, decimalLength);
	    }
	  return_FF_on_putCONTAINER_err ();
	}
      else if (!put_digits (positiveNumber))
	return pk_false;
      return_END_LINE ();	/*SET_SPACED() */
    }
  return pk_false;
}

/* PLG 2007-03-15
 * this_file is a correctly open file descriptor
 * <positiveNumber> >= 0
 * equivalent to Uprint_eolIfSplit_str(fullString)
 *    where fullString is the concatenation of <cc> and <DSR>,
 *          <DSR> is the decimal, string representation of <positiveNumber>
 */
boolean
NBuffer::Uprint_eolIfSplit_chr_int (char cc, long int positiveNumber)
{
  short decimalLength = get_strPosIntSize (positiveNumber);
  if (putLineIfNotFit_fit (decimalLength + 1))
    {				/* SET_SPACED() if container is emptied */
      ADD_CHAR (cc);
      ADD_POSINT_NS (positiveNumber, decimalLength);
      return pk_true;
    }
  if (IS_SAFE ())
    {
      if (this_canBeSplit)
	{
	  ADD_CHAR (cc);
	  if (MARGINFREE_OVER (decimalLength + 1))
	    {
	      if (MARGINFREE_OVER (decimalLength))
		{
		  if (!appendMFOver_split_digits (positiveNumber))
		    return pk_false;
		}
	      else
		{
		  ADD_POSINT (positiveNumber, decimalLength);
		}
	    }
	  else
	    {
	      ADD_POSINT (positiveNumber, decimalLength);
	    }
	  return_FF_on_putCONTAINER_err ();
	}
      else
	{
	  return_FF_on_putCHAR_err (cc);
	  if (!put_digits (positiveNumber))
	    return pk_false;
	}
      return_END_LINE ();
    }				/*SET_SPACED() */
  return pk_false;
}

/* PLG 2007-03-15
 * this_file is a correctly open file descriptor
 * <strValue> is not NIL
 * <positiveNumber> >= 0
 * equivalent to Uprint_eolIfSplit_str(fullString)
 *    where fullString is the concatenation of <strValue> and <DSR>,
 *          <DSR> is the decimal, string representation of <positiveNumber>
 */
boolean
NBuffer::Uprint_eolIfSplit_str_int (const char *strValue, long int positiveNumber)
{
  int strLength = strlen (strValue);
  short decimalLength = get_strPosIntSize (positiveNumber);
  if (putLineIfNotFit_fit (strLength + decimalLength))
    {				/* SET_SPACED() if container is emptied */
      ADD_STRING (strValue);
      ADD_POSINT_NS (positiveNumber, decimalLength);
      return pk_true;
    }
  if (IS_SAFE ())
    {
      if (this_canBeSplit)
	return UprintMF_eolIfSplit_str_int (strValue, strLength, positiveNumber, decimalLength);
      return_FF_on_putSTRING_err (strValue);
      if (!put_digits (positiveNumber))
	return pk_false;
      return_END_LINE ();
    }
  return pk_false;
}

/* PLG 2007-03-15
 * this_file is a correctly open file descriptor
 * <strValue> is not NIL
 * <positiveNumber> >= 0
 * equivalent to Uprint_eolIfSplit_str(fullString)
 *    where fullString is the concatenation of <cc>, <strValue> and <DSR>,
 *          <DSR> is the decimal, string representation of <positiveNumber>
 */
boolean
NBuffer::Uprint_eolIfSplit_chr_str_int (char cc, const char *strValue, long int positiveNumber)
{
  int strLength = strlen (strValue);
  short decimalLength = get_strPosIntSize (positiveNumber);
  int totalLength = strLength + decimalLength + 1;
  if (putLineIfNotFit_fit (totalLength))
    {				/* SET_SPACED() if container is emptied */
      ADD_CHAR (cc);
      ADD_STRING (strValue);
      ADD_POSINT (positiveNumber, decimalLength);
      return pk_true;
    }
  if (IS_SAFE ())
    {
      if (this_canBeSplit)
	{
	  ADD_CHAR (cc);
	  return UprintMF_eolIfSplit_str_int (strValue, strLength, positiveNumber, decimalLength);
	}
      return_FF_on_putCHAR_err (cc);
      return_FF_on_putSTRING_err (strValue);
      if (!put_digits (positiveNumber))
	return pk_false;
      return_END_LINE ();
    }
  return pk_false;
}

/* PLG 2005-04-19
 */
void
NBuffer::activateContainer ()
{
  INIT_LINE () /*SET_SPACED() */ ;
  if (MAY_HAVE_MARGIN ())
    {
      leftIndentationMarks = push (NIL_IntStack, 0);
      allIndentationMarks = push (NIL_IntStack, 0);
      virtualMargin = 0;
      actualMargin = 0;
    }
}

/* PLG 2005-04-19
 * init this_prefix, this_fileName, this_file to empty value
 * init MAX_AVAILABLE_SPACE() to taille
 * success: taille > 8
 * failure: taille <= 8
 */
boolean
NBuffer::initCommon (int taille)
{
  leftDepth = 0;		/* DEBUG : left stack depth */
  allDepth = 0;			/* DEBUG : all stack depth */
  SET_PREFIXFREE ();
  this_fileName = "no file association";
  this_file = NIL_File;
  SET_CLOSED ();
  MAX_AVAILABLE_SPACE () = taille;
  return (taille > 8);
}

/* PLG 2005-04-19
 * init leftIndentationMarks, allIndentationMarks to NIL values
 * init maximalActualMargin to maxindent if MAX_AVAILABLE_SPACE() <= 2*maxindent, to MAX_AVAILABLE_SPACE()/2 otherwise
 */
void
NBuffer::initIndent (int maxindent)
{
  if (MAX_AVAILABLE_SPACE () <= (2 * maxindent))
    SET_MARGIN (MAX_AVAILABLE_SPACE () / 2);
  else
    SET_MARGIN (maxindent);
  leftIndentationMarks = NIL_IntStack;
  allIndentationMarks = NIL_IntStack;
}

boolean
NBuffer::initContainer ()
{
  printableLineLength = MAX_AVAILABLE_SPACE ();
  return new_sizedPKStringContainer (MAX_AVAILABLE_SPACE () + 1, &this_stringRegister, &this_container);
}

boolean
NBuffer::initSContainer ()
{
  if (new_sizedPKStringContainer (MAX_AVAILABLE_SPACE () + 1, &auxiliaryBuf, &auxiliaryContainer))
    return initContainer ();
  return pk_false;
}

/* PLG 2005-04-19
 * sets this as a splittable line buffer
 * sets this_breakCharList and this_continuationCharacter respectively to breakCharList and continuationCharacter
 * init this_prefix, this_fileName, this_file to empty value
 * init MAX_AVAILABLE_SPACE() to max (1, taille)
 */
boolean
NBuffer::initSplitting (int taille, const char *breakCharList, char continuationCharacter)
{
  this_canBeSplit = pk_true;
  if ((breakCharList != NIL_String) && ((breakCharList[0]) != NULL_char))
    this_breakCharList = breakCharList;
  else
    this_breakCharList = NIL_String;
  this_continuationCharacter = continuationCharacter;
  return initCommon (taille);
}

/* PLG 2005-04-19
 * init a buffer such that writing at least one character remains possible
 * sets this_canBeSplit to false
 * failure: malloc failed
 */
boolean
NBuffer::init (int maxindent, int taille)
{
  this_canBeSplit = pk_false;
  if (initCommon (taille))
    {
      initIndent (maxindent);
      return initContainer ();
    }
  return pk_false;
}
