#define CHAR_DIGIT(II) (char)(II+48)
char *_emptyCString = NIL_String;	/* _emptyCString is given an empty C char* at its first use */

/* 2005-01-04
 */
void
stderr_alloc (const char *moduleName)
{
  fprintf (stderr, "## system ERROR ##: Memory allocation error in %s\n", moduleName);
}

/* 2005-01-04
 * success: nb >= 0 is assumed
 *          returns in <container> a new malloc'd container large enough to contain nb characters 
 *             and a NULL_char string termination 
 *             this container is initiated with empty string
 * failure: memory allocation failed
 *             an error message is stderr printed
 *             returns NIL_String in <container> 
 *          nb < 0 result is host dependent
 */
boolean
unsafe_Cstrmalloc (int nb, char **container)
{
  (*container) = (char *) malloc ((nb + 1) * sizeof (char));
  if ((*container) == NULL)
    {
      stderr_alloc ("unsafe_Cstrmalloc");
      (*container) = NIL_String;
      return pk_false;
    }
  (*container)[0] = NULL_char;
  return pk_true;
}
