/* the following are NOT ANSI host dependent features
   _SUFFIXEDFILENAMELENGTH(NAMELGTH, SUFFIXLGTH) defined below, returns length of name-suffixing 
            NAMELGTH characters by SUFFIXLGTH characters
   _MAKESUFFIXEDFILENAME(FILENAME, LENGTH, SUFFIX) defined below, name-suffixes in FILENAME
            LENGTH first characters by SUFFIX
   _FILENAMEPREFIXEND(FILENAME) defined below,
           returns address of first character following greatest name-prefix in FILENAME
   _REMOVEFILENAMESUFFIX(FILENAME, LENGTH) defined below,
           removes suffix in FILENAME which prefix has LENGTH chracters

   _MAXPATHLEN defined below, is maximum size for a path length
   _ISROOTEDPATHNAME(PATHNAME) defined below, true if PATHNAME is a host absolute pathname
   _DIRECTORYSEPARATOR defined below, directory separator character in pathnames
   _ISDIRECTORYPREFIX(PATHNAME, INDEX) defined below, true if PATHNAME upto INDEX is a directory prefix
   _ISNOTDIRECTORYPREFIX(PATHNAME, INDEX) defined below, not _ISDIRECTORYPREFIX(PATHNAME, INDEX)
   _MAKEDIRECTORYPREFIX(PATHNAME, LGTH) defined below, 
              makes PATHNAME upto LGTH-1 a NULL char terminated directory prefix 
              resets LGTH to this prefix length
   _GETDIRECTORYSUFFIX(PATHNAME) defined below,
              if PATHNAME is not directory prefixed returns NULL address
              if PATHNAME is directory prefixed returns address following the largest directory prefix

   _ENVNAMETAG  defined below, prefix of host variable occurrences 
   _ISENVNAME(NAME, INDEX) defined below, true if NAME[INDEX] begins an host variable occurrence
   _NOTENVNAMECHARSET defined below
 */

#ifdef xKHOST
#if (xKHOST == xKwinNT) 

#define _SUFFIXEDFILENAMELENGTH(NAMELGTH, SUFFIXLGTH) ( ( NAMELGTH + SUFFIXLGTH + 2) )
#define _MAKESUFFIXEDFILENAME(FILENAME, LENGTH, SUFFIX) FILENAME[LENGTH] = '.';\
FILENAME[LENGTH+1] = NULL_char;\
FILENAME = strcat(FILENAME, SUFFIX)
#define _FILENAMEPREFIXEND(FILENAME) ( strrchr(FILENAME, '.') )
#define _REMOVEFILENAMESUFFIX(FILENAME, LENGTH) ( FILENAME[LENGTH] = NULL_char )

/* an environment variable is the longest string following _ENVNAMETAG without _NOTENVNAMECHARSET " */
#define _MAXPATHLEN MAXPATHLEN
/* Not correct for windows,  DRIVE:*/
#define _ISROOTEDPATHNAME(PATHNAME) ( ((PATHNAME[0]) == '/') )
#define _DIRECTORYSEPARATOR '\\'
#define _ISDIRECTORYPREFIX(PATHNAME, INDEX) ( ((PATHNAME[INDEX]) == _DIRECTORYSEPARATOR) )
#define _ISNOTDIRECTORYPREFIX(PATHNAME, INDEX) ( ((PATHNAME[INDEX]) != _DIRECTORYSEPARATOR) )
#define _MAKEDIRECTORYPREFIX(PATHNAME, LGTH) PATHNAME[LGTH] = _DIRECTORYSEPARATOR;\
  LGTH=LGTH+1; PATHNAME[LGTH] = NULL_char
#define _GETDIRECTORYSUFFIX(PATHNAME) ( strrchr(PATHNAME, _DIRECTORYSEPARATOR) )

#define _ENVNAMETAG '%'
#define _ISENVNAME(NAME, INDEX) ( ((NAME[INDEX]) == _ENVNAMETAG) )
#define _NOTENVNAMECHARSET ";% /!\n"

#define pathSeparatorInPathList ';'

/* the environment variable USER holds user name" */
#define L_cusername 20
#define _ENV_USERNAME "USERNAME"
/* the environment variable PWD contnuously holds current working directory */
/* Windows : %HOMEPATH%, or set PWD=%CD% but %CD% is not available. */
#define _ENV_WORKINGDIR "HOMEPATH"
/* _COM_MKDIR holds the command name to build a directory */
#define _COM_MKDIR "mkdir " 
/* _COM_SETEXECUTABLE holds the command to set a file owner executable */
#define _COM_SETEXECUTABLE "IDONTKNOW "

#else
#define _SUFFIXEDFILENAMELENGTH(NAMELGTH, SUFFIXLGTH) ( ( NAMELGTH + SUFFIXLGTH + 2) )
#define _MAKESUFFIXEDFILENAME(FILENAME, LENGTH, SUFFIX) FILENAME[LENGTH] = '.';\
FILENAME[LENGTH+1] = NULL_char;\
FILENAME = strcat(FILENAME, SUFFIX)
#define _FILENAMEPREFIXEND(FILENAME) ( strrchr(FILENAME, '.') )
#define _REMOVEFILENAMESUFFIX(FILENAME, LENGTH) ( FILENAME[LENGTH] = NULL_char )

/* an environment variable is the longest string following _ENVNAMETAG without _NOTENVNAMECHARSET " */
#define _MAXPATHLEN MAXPATHLEN
#define _ISROOTEDPATHNAME(PATHNAME) ( ((PATHNAME[0]) == '/') )
#define _DIRECTORYSEPARATOR '/'
#define _ISDIRECTORYPREFIX(PATHNAME, INDEX) ( ((PATHNAME[INDEX]) == _DIRECTORYSEPARATOR) )
#define _ISNOTDIRECTORYPREFIX(PATHNAME, INDEX) ( ((PATHNAME[INDEX]) != _DIRECTORYSEPARATOR) )
#define _MAKEDIRECTORYPREFIX(PATHNAME, LGTH) PATHNAME[LGTH] = _DIRECTORYSEPARATOR;\
  LGTH=LGTH+1; PATHNAME[LGTH] = NULL_char
#define _GETDIRECTORYSUFFIX(PATHNAME) ( strrchr(PATHNAME, _DIRECTORYSEPARATOR) )

#define _ENVNAMETAG '$'
#define _ISENVNAME(NAME, INDEX) ( ((NAME[INDEX]) == _ENVNAMETAG) )
#define _NOTENVNAMECHARSET ":$ /!\n"

#define pathSeparatorInPathList ':'

/* the environment variable USER holds user name" */
#define L_cusername 20
#define _ENV_USERNAME "USER"
/* the environment variable PWD contnuously holds current working directory */
#define _ENV_WORKINGDIR "PWD"
/* _COM_MKDIR holds the command name to build a directory */
#define _COM_MKDIR "mkdir " 
/* _COM_SETEXECUTABLE holds the command to set a file owner executable */
#define _COM_SETEXECUTABLE "chmod u+x "
#endif
#endif
/* ===================================================================== 
 * Environment variables management
 *
 */
typedef struct LstRefVarType * ref2LstRefVarType; 
typedef struct HostVariable * ref2HostVariable;
typedef ref2HostVariable ref2VariableType;

typedef struct LstRefVarType {
  ref2HostVariable car;
  ref2LstRefVarType cdr; } t11;
#define NIL_LstRefVarType  (ref2LstRefVarType)NULL

typedef struct HostVariable {
  boolean inError;
  const char *envName;
  char *value; } t12;
#define NIL_HostVariable (ref2HostVariable)NULL


