_PROTECTED_
/* prevents further reading not preceded by new file attachment:
 *     this_lineAnalyzer current atom becomes empty
 */
  void
FileAnalyzer::setInError ()
{
  if (fileReading_OK)
    {
      this_lineAnalyzer->lineClose ();
      fileReading_OK = pk_false;
    }
  fileReading_Errored = pk_true;
}

/* sets this ready to be linked to a file
   when this_fileBuffer is an empty string container then this_lineAnalyzer is NIL_LineAnalyzer
   checks this correction
   success: this_lineAnalyzer != NIL_LineAnalyzer
   failure: this_lineAnalyzer is NIL_LineAnalyzer
            sets this in error
*/
boolean
FileAnalyzer::freezeFileReading ()
{
  fileReading_OK = pk_false;
  if (this_lineAnalyzer == NIL_LineAnalyzer)
    setInError ();
  else
    {
      this_lineAnalyzer->lineClose ();
      fileReading_Errored = pk_false;
    }
  fileReading_Close = pk_true;
  this_lineCounter = -1;
  return pk_true;
}

_PRIVATE_ _PROTECTED_
/* prevents further reading not preceded by new file attachment:
 *     this_lineAnalyzer current atom becomes empty
 */
  void
FileAnalyzer::setFileReadingEnd ()
{
  if (fileReading_OK)
    {
      this_lineAnalyzer->lineClose ();
      fileReading_OK = pk_false;
    }
}

/* 
 * retuns pk_true if FileAnalyzer has been fully read
 * and is not yet closed
 */
boolean
FileAnalyzer::isFileReadingCompleted ()
{
  if (fileReading_OK)
    return pk_false;
  if (fileReading_Close)
    return pk_false;
  if (fileReading_Errored)
    return pk_false;
  return pk_true;
}

/* sets file properties (name and FILE *)
 * does not begin reading
 * success: returns pk_true
 * failure: assign an error message to mess
 *          this remains unchanged
 *          returns false
 */
boolean
FileAnalyzer::attachFile (const char *name, FILE * aFile)
{
  if (fileReading_Errored)
    return pk_false;
  if (aFile == NIL_File)
    {
      setFileReadingEnd ();
      return pk_false;
    }
  this_fileName = name;
  this_file = aFile;
  fileReading_Close = pk_false;
  this_lineCounter = 0;
  fileReading_OK = pk_true;
  return pk_true;
}

boolean
FileAnalyzer::init (int lSize, ref2LineAnalyzer aLineAnalyzer)
{
  if (new_sizedPKStringContainer (lSize, &this_fileRegister, &this_fileBuffer))
    {
      this_fileBufferSize = strregGetSize (this_fileRegister);
      if (this_fileBufferSize > 0)
	this_lineAnalyzer = aLineAnalyzer;
      else
	this_lineAnalyzer = NIL_LineAnalyzer;
    }
  else
    {
      this_fileRegister = NIL_LGString;
      this_fileBuffer = NIL_String;
      this_lineAnalyzer = NIL_LineAnalyzer;
    }
  this_fileName = NIL_String;
  this_file = NIL_File;
  return freezeFileReading ();
}
