/* 
   Authors: Loïc Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
/***************************************************************************/
/* fichier contenant les valeurs des codes d'erreurs lors                  */
/* de l'allocation memoire, de la construction ou modification d'arbre     */
/* ou lors de la navigation dans l'arbre                                   */
/***************************************************************************/
#ifndef __F_CODERR__
#define __F_CODERR__

/* codes d'erreurs lies a la gestion memoire, 1 a 20 */

#define GM_SATARBRE     2 /* saturation dans zone arbres non modifiables */
#define GM_SATCHAINE    4 /* saturation dans zone chaines non modifiables */
#define GM_SATCOLL      7 /* saturation dans zone descripteurs d'ident */
#define GM_PILEVIDE     11 /* pile vide */
#define GM_PILEPLEINE   12 /* pile saturee */
#define GM_LANG         13 /* table des langages pleines */
#define LANGNONPRESENT  14 /* langage non present dans la table des langages */
#define GM_REGPLEIN     15 /* zone registre plein */
#define GM_REGVIDE      16 /* zone registre vide */

/*codes d'erreurs lies a la construction et modification d'arbres ,21 a 40 */
#define CS_INCOMPATT  27 /*incompatibilite de construction entre un operateur*/
                         /*d'un noeud et l'attribut  */
#define CS_INCOMP     21 /*incompatibilite de type lors de la construction */
#define CS_OPNONDEF   22 /*operateur non defini  */
#define CS_OPATTENDU  23 /*operateur attendu */
#define CS_CARINV     24 /*caractere invalide lors de la lecture d'un arbre*/
#define CS_POMANQ     25 /*parenthese ouvrante manquante lors de la lecture*/
                         /*d'un arbre */
#define CS_PFATT      26 /*parenthese fermante attendue lors de la lecture */
                         /*d'un arbre */



/*codes erreurs lies a la navigation , valeurs de 41 a 50*/

#define NV_DEC       41 /* erreur liee a la decompilation d'1 attribut dont */
                        /* le type n'est pas connu */
#define NV_ATT       42 /* attribut inexistant */


/* codes erreurs lies a la compilation d'un langage , valeurs de 51 a 60 */

#define LG_VALNONDEF    51 /* valeur d'un label non defini */
#define LG_DDEFLAB      52 /* double definition de label   */
#define LG_LABNONDEF    53 /* label utilise mais non defini*/


/*codes erreurs lies au filtrage d'arbre , valeurs de 61 a 70 */

#define FL_SSARBREVID  61 /* echec du filtrage a un sous_arbre vide */
#define FL_NOMOP       62 /* echec du filtrage au nom d'operateur   */
#define FL_CASLIST     63 /* echec au filtrage de deux listes       */
                          /* de tailles differentes                 */


#define LGABSENT 71 /* langage inconnu du systeme */
#define CHLONG 72 /* chaine de caracteres trop longue */

#endif
