/* 
   Authors: Loïc Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef __LTA_CTRE__
#define __LTA_CTRE__


EXTERN void DEBUG_MEMORY(const char * mess);
EXTERN void DEBUG_STACK_FULL(const char * mess);
EXTERN void DEBUG_srcORtgt(int margin, int maxLevel, const char * mess, const char * name, ptfilsAny aFilsAny);
EXTERN void DEBUG_src_tgt(int margin, int maxLevel, const char * mess, ptfilsAny srcFilsAny, ptfilsAny tgtFilsAny);

EXTERN short cellCategory(ptSHORT pp);
EXTERN boolean isTM_anAtom(ptnode aNode, short ATOMOP);

EXTERN int getTM_listNode_sonNumber(ptnode aNodeList);
EXTERN ptfilslist getTM_node_nFilslist(ptnode aNode, int pos);
EXTERN ptfilsAny getTM_node_nFilsAny(ptnode aNode, int pos);

EXTERN ptfilslist getTM_filslist_nNext(ptfilslist aFilsList, int n);
EXTERN ptfilslist getTM_filslist_nPrevious(ptfilslist aFilsList, int n);
EXTERN boolean getCondTM_filsAny_nSon(ptfilsAny anyFilsParam, int n, ptfilsAny * anyFilsRes);
EXTERN boolean getCondTM_nextSubtree(ptfilsAny anyilsParam, ptfilsAny *anyFilsRes);

EXTERN void insertTM_filslist_first (ptfilsd filsdListDescriptor, ptfilslist aFilslist);
EXTERN ptfilslist insertTM_newFilslist_before(ptfilslist successor);
EXTERN ptfilslist insertTM_newFilslist_after(ptfilslist predecessor);
EXTERN ptfilslist insertTM_newFilslist_first (ptfilsd filsdListDescriptor);

EXTERN short getAccesTM_firstSon(ptfilsAny tgtFilsAny, ptfilsAny * tgtFilsAny_res);
EXTERN short getAccessTM_rightNeighbor(ptfilsAny tgtFilsAny, ptfilsAny * tgtFilsAny_res);
EXTERN short getAccessTM_father(ptfilsAny tgtFilsAny, ptfilsAny * tgtFilsAny_res);
EXTERN ptfilsd getTM_filsd_root(ptfilsAny aFilsAny);
EXTERN ptfilsd getTM_filsd_hyperRoot(ptfilsAny aFilsAny);
EXTERN ptfilsAny copyTM_FilsAnySubtree(ptfilsAny srcFilsAny, boolean copyAttributes);
EXTERN void assignTM_stringValue2FilsAny(ptfilsAny aFilsAny, char * val);
EXTERN void assignTM_nodeValue2Filsd(ptfilsd link2DestinationSon, ptnode assignedSubtree);

EXTERN ptnode getTM_node_nNextInFix(ptnode aNode, int n);
EXTERN ptnode getTM_node_nNextInlist(ptnode aNode, int n);
EXTERN ptnode getTM_node_nPreviousInFix(ptnode aNode, int n);
EXTERN ptnode getTM_node_nPreviousInlist(ptnode aNode, int n);
#endif
