/* 
   Authors: Loïc Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef __MARQUER__
#define __MARQUER__

#define SHORT_MARQLIBRE 0x0000
#define SHORT_MARQFINCHAINE 0x4000  /* the cell is marked and fin de chainage inverse */
#define SHORT_NONMARQFINCHAINE 0xbfff
#define SHORT_MOVEDMARK 0x8000      /* the cell is marked and linked */
#define SHORT_NONMOVEDMARK 0x7fff   
#define SHORT_INITIALMARK 0xc000    /* the cell is marked but remains free */

/* TEMPORARY SHORT_MARKS are used for garbage purpose
   they apply to the first and second bit of the argument
 */
#define SHORT_SET_INITIALMARK(pt) *pt = *pt | SHORT_INITIALMARK

#define SHORT_TESTMARQUE(pt) (*pt & SHORT_INITIALMARK)
#define SHORT_NONMARQUE(pt) ( SHORT_TESTMARQUE(pt) == 0)
#define SHORT_SET_MOVEDMARK(pt) *pt = ((*pt | SHORT_MOVEDMARK) & SHORT_NONMARQFINCHAINE)
#define SHORT_SET_FINDECHAINE(pt) *pt = ((*pt | SHORT_MARQFINCHAINE) & SHORT_NONMOVEDMARK)

/* CATEGORY SHORT_MARKS are permanent marks used to identify a category of object (node, ...)
   they apply to the third and fourth bits of the argument
 */

EXTERN boolean estarbre(ptSHORT pp);
EXTERN void chaineinverse(ptptSHORT pt);
EXTERN void marquerpile(void);

#endif
