/* 
   Authors: Loïc Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
/*****************************************************************************/
/*									     */
/*	initsysteme.c							     */
/*									     */
/*  Module contenant la primitive de chargement et d'initialisation de la    */
/* machine de traitement d'arbres, c'est a dire :			     */
/*	- initialisation de la memoire (initmem)			     */
/*	- initialisation du langage noyau LNTA (genererlnta)		     */
/*									     */
/*****************************************************************************/

#include <stdio.h>
#include "StdTypeDefs.h"
#include "varglobal.h"
#include "gm_pile.h"
#include "gm_init.h"
#include "conslnta.h"
#include "lta_ctree.h"
#include "initsyst.h"

EXTERN void
initsysteme (void)
{
  // printf("DEBUG entering initsyst::initsysteme\n"); fflush(stdout);
  initmem ();
  genererlnta ();
  RESET_TREEMEMORYSTART ();	/*les arbres construits avant ne sont pas a garbager */
  // printf("DEBUG  exiting initsyst::initsysteme \n"); fflush(stdout);
}
