
PRINT("DIRECTORY: ${utl_Tree}")
SET(PREFIX Tree_)
SET(DIRS Treepack src mod doc utltext2trees)
SETVARIABLES("${DIRS}" ${utl_Tree} ${PREFIX} utl_Tree)

USER_DEF_VAR(${utl_Tree} ${PREFIX}obj utl_obj)
USER_DEF_VAR(${utl_Tree} ${PREFIX}bin utl_bin)
USER_DEF_VAR(${utl_Tree} ${PREFIX}incl utl_incl)

DECLARECOMPONENTS("${DIRS}" ${PREFIX})

GEN_CONFIG_STD_PACKAGE(utl_Tree Tree Tree_ ${TreeDoc_html})

IF(PKCONFIG)
  # It generates the txt2Trees command
  MK_CONFIG_NAME(txt2Trees CONFIG_NAME)
  SET(CONFIG_FILE ${Tree_bin}/${CONFIG_NAME})
  GEN_HEADER_SCRIPT(${CONFIG_FILE})
  GEN_COMMENT( ${CONFIG_FILE} "-------------------------------------------------------------------------")
  GEN_COMMENT( ${CONFIG_FILE} " Requires : Tree_bin")
  GEN_COMMENT( ${CONFIG_FILE} " Parameters:")
  GEN_COMMENT( ${CONFIG_FILE} "     1- emacs lisp function (modmess or modkw)to apply on the input filename")
  GEN_COMMENT( ${CONFIG_FILE} "     2- input filename  : textual file containing messages or keywords.")
  GEN_COMMENT( ${CONFIG_FILE} "     3- output filename : result (tree representation).")
  GEN_COMMENT( ${CONFIG_FILE} "     4- the Tree_bin value ")
  GEN_COMMENT( ${CONFIG_FILE} "     5- the pK_tmp value ")
  GEN_COMMENT( ${CONFIG_FILE} " Action : ascii file(messages or keywords) to Trees Translation.")
  GEN_COMMENT( ${CONFIG_FILE} " -------------------------------------------------------------------------")
#  GEN_REQUIRE_SHELL_VAR(${CONFIG_FILE} Tree_bin)
    
  IF(UNIX)
    FILE(APPEND ${CONFIG_FILE} "emacs $2 -batch -l $4/modmess2.el -f $1\n")
    FILE(APPEND ${CONFIG_FILE} "# Tree memory parameter\n")
    FILE(APPEND ${CONFIG_FILE} "setenv T_MEM_ARB 10000000\n")
    FILE(APPEND ${CONFIG_FILE} "# String memory parameter\n")
    FILE(APPEND ${CONFIG_FILE} "setenv T_MEM_CHAIN 1048576\n")
    FILE(APPEND ${CONFIG_FILE} "$4/mk_tree_prog $3 $4 $5\n")
    FILE(APPEND ${CONFIG_FILE} "\\rm $5/__fich.tmp__\n")
  ELSE(UNIX)
    FILE(APPEND ${CONFIG_FILE} "emacs %2 -batch -l %4\\modmess2.el -f %1\n")
#    FILE(APPEND ${CONFIG_FILE} "copy %SignalBin_data%\\__fich.tmp__  %pK_tmp%\\.\n")
    FILE(APPEND ${CONFIG_FILE} "rem Tree memory parameter\n")
    FILE(APPEND ${CONFIG_FILE} "set T_MEM_ARB=10000000\n")
    FILE(APPEND ${CONFIG_FILE} "rem String memory parameter\n")
    FILE(APPEND ${CONFIG_FILE} "set T_MEM_CHAIN=1048576\n")
    FILE(APPEND ${CONFIG_FILE} "%4\\mk_tree_prog %3 %4 %5\n")
#    FILE(APPEND ${CONFIG_FILE} "erase %SignalBin_data%\\__fich.tmp__\n")
    FILE(APPEND ${CONFIG_FILE} "erase %5\\__fich.tmp__\n")
  ENDIF(UNIX)
  ADD_EXECUTE_RIGHT(${CONFIG_FILE})
  # It generates the messages2Trees command
  MK_CONFIG_NAME(messages2Trees CONFIG_NAME)
  SET(CONFIG_FILE ${Tree_bin}/${CONFIG_NAME})
  GEN_HEADER_SCRIPT(${CONFIG_FILE})
  GEN_COMMENT( ${CONFIG_FILE} "-------------------------------------------------------------------------")
  GEN_COMMENT( ${CONFIG_FILE} " Messages(ascii file) to Trees Translation.")
  GEN_COMMENT( ${CONFIG_FILE} " Parameters:")
  GEN_COMMENT( ${CONFIG_FILE} "    1 - message file name.")
  GEN_COMMENT( ${CONFIG_FILE} "    2 - output file name for storing tree representation.")
  GEN_COMMENT( ${CONFIG_FILE} "    3 - the Tree_bin value ")
  GEN_COMMENT( ${CONFIG_FILE} "    4- the pK_tmp value ")
  GEN_COMMENT( ${CONFIG_FILE} " -------------------------------------------------------------------------")

#  GEN_REQUIRE_SHELL_VAR(${CONFIG_FILE} Tree_bin)
  IF(UNIX)
    FILE(APPEND ${CONFIG_FILE} "$3/txt2Trees modmess2 $1 $2 $3 $4\n")
  ELSE(UNIX)
    FILE(APPEND ${CONFIG_FILE} "%3\\txt2Trees.bat modmess2 %1 %2 %3 %4\n")
  ENDIF(UNIX)
  ADD_EXECUTE_RIGHT(${CONFIG_FILE})

  # It generates the keywords2Trees command.
  MK_CONFIG_NAME(keywords2Trees CONFIG_NAME)
  SET(CONFIG_FILE ${Tree_bin}/${CONFIG_NAME})
  GEN_HEADER_SCRIPT(${CONFIG_FILE})
  GEN_COMMENT( ${CONFIG_FILE} "-------------------------------------------------------------------------")
  GEN_COMMENT( ${CONFIG_FILE} " keywords2Trees(ascii file) to Trees Translation.")
  GEN_COMMENT( ${CONFIG_FILE} " Parameters:")
  GEN_COMMENT( ${CONFIG_FILE} "    1 - message file name.")
  GEN_COMMENT( ${CONFIG_FILE} "    2 - output file name for storing tree representation.")
  GEN_COMMENT( ${CONFIG_FILE} "    3 - the Tree_bin value ")
  GEN_COMMENT( ${CONFIG_FILE} "    4 - the pK_tmp value ")
  GEN_COMMENT( ${CONFIG_FILE} " -------------------------------------------------------------------------")
#  GEN_REQUIRE_SHELL_VAR(${CONFIG_FILE} Tree_bin)
  IF(UNIX)
    FILE(APPEND ${CONFIG_FILE} "$3/txt2Trees modkw $1 $2  $3 $4\n")
  ELSE(UNIX)
    FILE(APPEND ${CONFIG_FILE} "%3\\txt2Trees.bat modkw %1 %2 %3 %4\n")
  ENDIF(UNIX)
  ADD_EXECUTE_RIGHT(${CONFIG_FILE})

ENDIF(PKCONFIG)
