

#include <cstdio>
#include "boolean.h"
#include "StdTypeDefs.h"
#include "typesbase.h"
#include "system.h"
#include "io_inter.h"
#include "aslnta.h"
#include "initsyst.h"
#include "chaine.h"


#include "C_string.h"
#include "systemFrontEnd_g.h"

char *
lirech (int argc, char *argv[])
{
  if (argc == 1)
    {
      fprintf (stderr, "mk_tree_prog: Waiting for an argument (output file name)...aborting...\n ");
      exit (1);
    }
  return (argv[1]);
}

static char *
getTmpFile ()
{
  char *tmpDir;
  tmpDir = getEnvDef ("pK_tmp");
  if (tmpDir == NIL_String)
    fprintf (stderr, "mk_tree_prog: Undefined Shell variable pK_tmp.\n");
  return getFilePathName (tmpDir, "__fich.tmp__");
}

int
main (int argc, char *argv[])
{
  FILE *srcFile, *tgtFile;
  char *fileName;
  int taille;
  ptfilsAny ANYSON_saveRoot;

  initsysteme ();
  fileName = getTmpFile ();
  srcFile = ouvrelect (fileName);
  if (srcFile == (FILE *) NULL)
    return pk_false;
  if (lirearbredepl (srcFile, &ANYSON_saveRoot))
    {
      fclose (srcFile);
      fileName = lirech (argc, argv);
      // tgtFile = fopen (fileName, "w+"); if (tgtFile == (FILE *)NULL) return pk_false; fclose(tgtFile);
      tgtFile = initsave (fileName);
      taille = sauvegarde (pk_false, pk_false, tgtFile, ANYSON_saveRoot);
      finsave (tgtFile, taille);
      return pk_true;
    }
  fclose (srcFile);
  return pk_false;
}
