; --------------------------------------------------------------------------------
; Normalisation des fonctions
; --------------------------------------------------------------------------------
; Ce fichier doit servir a la conversion des sources des developpeurs
; Pour l'appliquer a un fichier X.c il faut 
;     copier ce fichier dans votre repertoire (YOUR_EMACS_NORMALISATION.el)
;     puis ajouter la ligne 
;            (:modifyref "X.c" ".") 
; a la fin de ce fichier. 
; Iterer l'operation pour chacun de vos fichiers.
;
; ENSUITE
;    executer la commande 
;    gnu-emacs -batch -l YOUR_EMACS_NORMALISATION.el
; Cette commande vous indique les appels de fonctions dont l'ordre des parametres
; est a  modifier.
;
; Le fichier ORDRE_PARAMETRES_MODIFIE.lis  contient l'ensemble des fonctions 
; dont l'ordre des parametres est modifie.
; --------------------------------------------------------------------------------
;
;


(defun ref_func (funcname)
  (goto-char (point-min))
  (if (re-search-forward funcname nil t)
      (print (concat "REVOIR ORDRE DES PARAMETRES POUR :" funcname))
    ()
    )
)

(defun :verify_func_param_mod ()

;(ref_func "ptexpcal_fusion_luseexp")

)



(defun :replaceString(str1 str2)

    (goto-char (point-min))
    (replace-string str1 str2)
)

(defun change_name (str1 str2)

    (goto-char (point-min))
    (replace-string (concat " " (concat str1 "(" )) (concat " " (concat str2 "(" )))
    (goto-char (point-min))
    (replace-string (concat "(" (concat str1 "(" )) (concat "(" (concat str2 "(")))
    (goto-char (point-min))
    (replace-string (concat "!" (concat str1 "(" )) (concat "!" (concat str2 "(")))
    (goto-char (point-min))
    (replace-string (concat "\t" (concat str1 "(" )) (concat "\t" (concat str2 "(")))
)


(defun change_name_def (str1 str2)
(goto-char (point-min))
(if (re-search-forward str1 nil t)
    (replace-match str2 nil nil)
    ()
)
)



(defun :modif-call (type-mess)
  (let (nb-par chaine point-virg point1 point2 pointDebut)
    (goto-char (point-min))
    (while (search-forward type-mess nil t)
      (setq pointDebut (progn (forward-word -1) (point)))
      (setq point1 (progn (search-forward "(") (point)) )
      (setq nb-par 1)
      (setq point-virg -1)

      (while (> nb-par 0)
	(forward-char 1)
	(print (char-after (point)))


	(if (looking-at "(") 
	    (setq nb-par (+ nb-par 1))
	  (if (looking-at ",") 
	      (if (and  (eq point-virg -1) (= nb-par 1)) (setq point-virg (point)) ())
	    (if (looking-at ")") 
		(setq nb-par (- nb-par 1)) 
	      ()
	      )
	    )
	  )
	)
      
      (if (eq point-virg -1) 
	  (setq point2 (point))
	(setq point2 point-virg )
	(goto-char point2)
	(delete-char 1)
	)
      (kill-region point1 point2)
      (goto-char pointDebut)
      (yank)
      (insert-string "->")
      (search-forward type-mess nil t)
      )
    )
)

(defun :kill-popf-one ()
  (let (nb-par point-virg point1 point2 pointDebut)
    (setq point1 (point))
    (setq nb-par 1)
    (setq point-virg -1)
    
    (while (> nb-par 0)
      (forward-char 1)
      (print (char-after (point)))
      (if (looking-at "(") 
	  (setq nb-par (+ nb-par 1))
	(if (looking-at ")") 
	    (setq nb-par (- nb-par 1)) 
	  ()
	  )
	)
      )
    
;    (if (eq point-virg -1) 
;	(setq point2 (point))
;      (setq point2 point-virg )
;      (goto-char point2)
;      (delete-char 1)
;    )
    (setq point2 (point))
    (kill-region point1 point2)
    )
  )

(defun :modif-def (type-mess)
  (let (nb-par  point-virg point1 point2 pointDebut)
    (goto-char (point-min))
    (while (search-forward type-mess nil t)
      (setq pointDebut (progn (forward-word -1) (point)))
      (:kill-popf-one)
      )
    ;; (goto-char pointDebut)
    (search-forward "{" nil t)
    (insert-string "\n")
    (yank)
    (insert-string "= this;")
    (beginning-of-line)
    (indent-according-to-mode)
    )
  )


(defun :killLinesWithString (TheString)
  (goto-char (point-min))
  (while (search-forward TheString nil t)
      (beginning-of-line)
      (kill-line 1)
      )
)


(defun :kill-popf ()
  (let (nb-par  point-virg point1 point2 pointDebut)
    (goto-char (point-min))
    (while (search-forward "(" nil t)
      (:kill-popf-one)
      )
    )
  )

; Suppression des espaces entre name et car
(defun :delSpaceFromto(name car)
  (let (nb-par )
    (goto-char (point-min))
    (while (search-forward name nil t)
      (setq point1 (point))
      (setq point2 ( - (progn (search-forward car nil t) (point)) 1))

      (if (eq point1 point2) 
	  ()
	(kill-region point1 point2)
	)
      )
    )
)


(defun :CutSpaces_1 (name)
  (:delSpaceFromto name "(")
)


(defun :selectFirstParam ()
  (let (p1 p2 nb-par)
    (setq p1 (progn (search-forward "(") (point)) )
    (setq nb-par 1)
    
    (while (> nb-par 0)
      (forward-char 1)
      (if (looking-at "(") 
	  (setq nb-par (+ nb-par 1))
	(if (looking-at ")") 
	    (setq nb-par (- nb-par 1)) 
	  (if (and (looking-at ",") (= nb-par 1))
	      (setq nb-par (- nb-par 1))
	    ()
	    )
	  )
	)
      )
    (setq p2 (point))
    (if (looking-at ",")
	(delete-char 1)
      ()
      )
    (kill-region p1 p2)
    )
)

(defun :func2method (funcName)
  (let (nb-par  point-virg point1 point2 pointDebut)
    (:CutSpaces_1 funcName)
    (goto-char (point-max))
    (while (search-backward funcName nil t)
      (setq point1 (point))
      (:selectFirstParam)
      (goto-char point1)
      (yank)
      (insert-string "->")
      )
    )
  )



(defun :c2cpp (funcName)
  (:CutSpaces_1 funcName)
  (:func2method funcName)
)



(defun :selectPrevious ()
 (let ( point1 point2)
   (setq point1 (point))
   (backward-word 1)
   (kill-region (point) point1)
   )
)

(defun :insertNM (funcName)
  (let (nb-par  point-virg point1 point2 pointDebut)
;    (:CutSpaces_1 funcName)
    (goto-char (point-max))
    (while (search-backward funcName nil t)
      (setq point1 (point))
      (:selectPrevious)
      (insert-string "NM")
;      (goto-char point1)
      (search-forward "(")
      (yank)
      (insert-string ",")
      (goto-char point1)
      )
    (goto-char (point-min))
    (:replaceString ",)" ")")
    )

  )
 
(defun :replaceStringInLine (textInLine currentText newText)
  (let (nb-par )
    (goto-char (point-min))
    (while (search-forward textInLine nil t)
      (beginning-of-line)
      (kill-line 1)
      
      (switch-to-buffer "XXXXBUFFER")
      (yank)
      (:replaceString currentText newText)
      (goto-char (point-min))
      (copy-region-as-kill (point-min) (point-max))
      (kill-this-buffer)
      (yank)
      )
    )
)
