/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

#ifndef __BDDPackApi_g__
#define __BDDPackApi_g__

/**
This module is the Polychrony tool set interface to external bdd package.
All fucnctions defined here must be defined for an other BDD implementation
It is written as a front end to Berkeley BDD package.
This interface requires the definition of (see export/BDDPackApi_type.h)
     - bdd_type seen as (void *) in Polychrony, to denote a BDD
     - bdd_id_boolean_variable_type seen as UnsignedInteger in Polychrony, to denote a boolean variable
     - bdd_rank_in_order_type seen as UnsignedInteger in Polychrony, to denote the rank of a boolean variable in the current variable order
     - UnsignedInteger is an unsigned integer the length of which is defined in export/BDD_StdTypes.h depending on the target architecture
 */

/** BDD Initialize
   Initialize the bdd manager with the maximal number of variables.
   It is necessary for some BDD package (called with the value 0 currently).
 */
EXTERN void /*BDDPackApi_g*/pK_bdd_init( int max_var );

/** BDD Finalize

   @return none.
 */
EXTERN void /*BDDPackApi_g*/pK_bdd_end( void );

/** BDD Formulas. BDD constant TRUE

   @return the representation of the bdd BDD constant TRUE.
 */
EXTERN bdd_type /*BDDPackApi_g*/pK_bdd_one( void );

/** BDD Formulas. BDD constant FALSE

   @return the representation of the BDD constant FALSE.
 */
EXTERN bdd_type /*BDDPackApi_g*/pK_bdd_zero( void );

/** BDD Formulas. BDD AND

   @param first (in) a bdd.
   @param second (in) a bdd.
   @return the unique bdd that denotes the conjonction of first and second.
 */
EXTERN bdd_type /*BDDPackApi_g*/pK_bdd_and( bdd_type first ,bdd_type second );

/** BDD Formulas. BDD OR

   @param first (in) a bdd.
   @param second (in) a bdd.
   @return the unique bdd that denotes the disjonction of first and second. 
 */
EXTERN bdd_type /*BDDPackApi_g*/pK_bdd_or( bdd_type first ,bdd_type second );

/** BDD Formulas. BDD NOT

   @param arg (in) : a bdd .
   @return the unique bdd that denotes the negation of arg.
 */
EXTERN bdd_type /*BDDPackApi_g*/pK_bdd_not( bdd_type arg );

/** BDD operation - equality test-.

   @param first (in) a bdd.
   @param second (in) a bdd.
   @return "true" if the two bdds are equals, false otherwise.
 */
EXTERN boolean /*BDDPackApi_g*/pK_bdd_equal( bdd_type first ,bdd_type second );

/** BDD operation - cofactor -.

   @param  first (in) a bdd.
   @param  second (in) a bdd.
   @return the cofactor first by second.
 */
EXTERN bdd_type /*BDDPackApi_g*/pK_bdd_cofactor( bdd_type first ,bdd_type second );

/** BDD access -then-side- .

   @param  arg (in) a bdd.
   @return the then-side of bdd operand.
 */
EXTERN bdd_type /*BDDPackApi_g*/pK_bdd_then( bdd_type arg );

/** bdd access -else-side-.

   @param  arg (in) a bdd.
   @return the else-side bdd of the bdd operand.
 */
EXTERN bdd_type /*BDDPackApi_g*/pK_bdd_else( bdd_type arg );

/** bdd access - top variable-.

   @param arg (in)a bdd.
   @return the (new) bdd of the top variable of the bdd operand.
 */
EXTERN bdd_type /*BDDPackApi_g*/pK_bdd_topvar( bdd_type arg );

/** BDD Formula Management:duplicate.

   @param  bdd  (in) : a  bdd descriptor.
   @returns a copy of the given bdd.
 */
EXTERN bdd_type /*BDDPackApi_g*/pK_bdd_dup( bdd_type bdd );

/** BDD Formula Management: free.
   This function frees the given bdd.
   @return none.
 */
EXTERN void /*BDDPackApi_g*/pK_bdd_free( bdd_type bdd );

/** BDD Variable Allocation.
   It links boolean variable/bdd.
   @param id (in) a boolean variable of the bdd "package".
   @return the bdd of the variable id.
 */
EXTERN bdd_type /*BDDPackApi_g*/pK_bdd_get( bdd_id_boolean_variable_type id );

/**
  Access to boolean variable of a bdd.

 @param  bdd (in) : a bdd.
 @return the first variable of the bdd operand. 
 */
EXTERN bdd_id_boolean_variable_type /*BDDPackApi_g*/pK_bdd_topvar_id( bdd_type bdd );

/**
  Access to boolean variable of a bdd.

 @param  bdd (in): a bdd.
 @return the last variable of the bdd operand.
 */
EXTERN bdd_id_boolean_variable_type /*BDDPackApi_g*/pK_bdd_lastvar_id( bdd_type bdd );

/** Order on variables.

   @return the first element for the order.
 */
EXTERN bdd_rank_in_order_type /*BDDPackApi_g*/pK_bdd_get_order_first( void );

/** Order on variables.

 @return the element following ord th.
 */
EXTERN bdd_rank_in_order_type /*BDDPackApi_g*/pK_bdd_get_order_next( bdd_rank_in_order_type ord );

/**    Order on variables. 
      It Assigns the rank of boolean variable.
      @param id (in) : a boolean variable identifier of a bdd.
      @param ord (in): a rank number.
      @return none.
 */
EXTERN void /*BDDPackApi_g*/pK_bdd_set_ord( bdd_id_boolean_variable_type id ,bdd_rank_in_order_type ord );

/** 
    new bdd boolean variable.
    @return a new descriptor of boolean variable. 
 */
EXTERN bdd_id_boolean_variable_type /*BDDPackApi_g*/pK_bdd_new_id( void );


#endif /*__BDDPackApi_g__*/
