/*
  Gestion des tampons d'impression (mise en page,...)
  CONVENTIONS : 
     - pour les mthodes de la forme pri* l'operation est garantie par passage a la ligne sur insuffisance de place dans le tampon, 
     - out* la valeur `false' est retournee en cas de non insertion dans le tampon.
     - wri* l'operation n'est pas garantie.
*/

class NBuffer
{
#include "NBuffer_m.h"
#include "NBuffer_g.h"
protected:
  FILE *this_file;
  const char *this_fileName;
  char *this_container; /* Buffer of buf */
  int this_index; /* first NULL_char position in this_container
		when file is not correctly open, index is -1 */
  const char *this_prefix;
  int this_prefixLgth;
  int maximalLineLength; /* size of accumulated strings written by print .. */
  int printableLineLength; /* maximal size for a line including left indentation, left marks, splitting character .. */
private:
  LGString this_stringRegister;
  int leftDepth; /* debug purpose to trace push/pop actions if required*/
  int allDepth; /* debug purpose to trace push/pop actions if required */
  int lineCounter;
  int maximalActualMargin;
  boolean this_canBeSplit; /* if false this_breakCharList, this_continuationCharacter
			          are meaningLess
			     if true 
			     maximalActualMargin, leftIndentationMarks, allIndentationMarks, virtualMargin, actualMargin
			           auxiliaryBuf, auxiliaryContainer are meaningLess
			   */
  const char * this_breakCharList;
  char this_continuationCharacter;
  LGString auxiliaryBuf;
  char *auxiliaryContainer;
  ref2IntStack leftIndentationMarks, allIndentationMarks;
  int virtualMargin, actualMargin;
  boolean isSpaced;
};
