class Argument :public ArgumentReporting
/* this is a string (stringArg StringArgument), a parameterized strings (metaArg MetaArgument),
 *         a list (stringListArg ArgumentList)
 *         a contextual identifier (identArg NamedArgument) linked to an Identifier
 *                              that holds a string or a string list,
 *         a reference to parameter (identArg NamedArgument) linked to a formal Identifier
 *                              that is assigned a string or a string list during function call,
 *         a string or string list generative function (commandArg CommandArgument)
 *                              which calling result can be a string or a string list
 * an argument is parameter occurrence free iff
 *         it is a StringArgument excluding MetaStringArgument
 *         or it is an ArgumentList which elements are occurrence free
 * an argument is fully expanded iff
 *         it is a StringArgument excluding MetaStringArgument
 *         or it is an ArgumentList which elements are StringArgument
 * a NIL_Argument is distinct from a  string argument which value is NIL_String 
 */
{
#include "Argument_g.h"
protected:
  int this_scope; /*    -1 if this parameterSign is unknown or this type is unknown
		   *     0 if this definition is empty (empty list or empty string or list of empty string)
		   *     1 if this definition is not empty without parameter/iterator occurrences
		   *     2 if this definition has some parameter occurrence but does not have iterator occurrence
		   *     3 if this definition has some iterator occurrence
		   */
  int this_type; /* -1: unknown type, 0: char * type, 1 char * list type */
  char * this_CString_expandedValue; /* is an actual value of this argument
			 if type is unknown, this_string is NIL_String
			 if this has char * type and is linked, this linked value
			 if this has char * list type and is linked to a string list,
			 is used as a register for string concatenation */
};
