/* 
 * call to argument function
 * the called function name is FunctionCall::thisFunctionName
 * the actual parameter list is FunctionCall::thisActualParameterList
 *
 * FunctionCall defines 
 *                 boolean this_isIterated;
 *                 int this_scope; (this parameter list scope)
 *                 char * this_functionName;
 *                 ref2ArgumentList these_actualParameters; 
 *         
 */
class ArgumentFunctionCall :public FunctionCall
{
#include "ArgumentFunctionCall_g.h"
protected:
  int this_type; /* this resulting type
		    0: char * type, 1 char * list type */
  // PLG this_expandedArgument should be a ref2ArgumentList in most cases
  ref2Argument this_expandedArgument; /* used as an accelerator
                                         for context access if this occurs several times in a function called
                                         for a parameter access if this occurs in an iteration
                                         for an iterator if this occurs in nesting iterations
                                         overhead: function body resetting before calling a function
                                              iteration body resetting before each inner iteration */
};
