/* 
 * call to argument, ancestor or node function
 * the called function name is FunctionCall::thisFunctionName
 * the actual parameter list is FunctionCall::thisActualParameterList
 *
 */
class FunctionCall :public Soundness
{
#include "FunctionCall_g.h"
 protected:
  ref2Context this_readingContext; 
  int this_scope; /*      -1 this scope is unknown
		   *      1 this call and its refered to generator are static
		   *      2 this call and its refered to generator 
		   *                 do not have iterator identifier occurrence
		   *                 this call or its refered to generator has parameter occurrence
		   *      3 this call or its refered to generator has iterator identifier occurrence
		   */
 private:
  boolean this_isIterated;
 protected:
  const char * this_functionName;
  /* ref2Context this_callingContext; single_call ... should use this_callingContext as search root */
  int this_parameterScope; /* this scope is this actual parameter list scope
			    *      -1 if this actual parameter scope is unknown
			    *      0 this actual parameter list is empty
			    *      1 this actual parameter list is not empty, all actual parameters are static or NIL
			    *      2 this actual parameter list is not empty, 
			    *             some actual parameter refers to a formal parameter
			    *             none of these actual parameters refer to an iterator identifier
			    *      3 this actual parameter list is not empty, 
			    *             some actual parameter refers to an iterator identifier
			    */
  ref2ArgumentList these_actualParameters; /* this has list type unless for val function
					      when this function is a user defined function 
					      thisActualParameters is a ref2ArgumentList */
};
