class NodeElement  :public Element
{
 public: 
  static time_t NOW, FUTURE, APOCALYPSE;
  static int the_stepIndex;
  /* expected: NIL_time < GENESIA < actual dates <= NOW < FUTURE < APOCALYPSE */
#include "NodeElement_g.h"
 protected:
  /* ====> when not in error: individual data */
  /* Time dependence analysis: */
  boolean this_isDefined; /* true: a definition occurrence has been met during mkf file reading
			     this is an MKFFile
			     false: only references to this node has been met */
  boolean this_isExecutable; /* when this_isDefined is true
				true: this is an executable variable or an executable direct file
				false: this is a not executable variable or a not executable direct file
				a variable may not be buildable
				a buildable variable may executable
				DirectFileNode may be executable
			     */
  boolean this_isRegistered;/* when this_isDefined is true
			       true: this is registered as a generation root
			       false: this not yet registered as a generation root
			    */
  time_t this_date; /* initial value is set as 
		       ExternNode: UNKNOWN_TIME
		       VariableNode: OLDEST
		       FileNode stdin: OLDEST 
			           existing: its host actual date
				   not existing MISSING (APOCALYPSE) 
		       computed value is set as
		          VariableNode: youngest date of its ancestors (including FUTURE)
			  FileNode: FUTURE if this has to be generated (one of its ancestors is younger)
			            its own date otherwise
		       generated node date is set to NOW */
  boolean this_buildingRequired; /* this has to be built due to natural dependence or to forced requirement */
  ref2BuildingData this_buildingData; /* when this_isDefined is true, definition body used to build node 
					this_buildingData is NIL for MKFFile and Extern nodes
					this_buildingData is not NIL for all other nodes */
  int this_stepIndex; /* when this_isDefined is true
				  the index value of the last traversal during dependence analysis  TODO check 
				  this index is initiated to 0
				  this_creator may be NIL */
  ref2NodeElement this_creator; /* when this_stepIndex is not 0
                                  this_creator is set to the nearest nesting constructor node
			          a referred to constructive node has this_creator set to this
			          a MKFFileNode node has this_creator set to this
			          an extern node has this_creator set to this
			     */
  ref2NodeElement made; /* when this_isDefined is true
		        During building recursive checking, cycle detection: 
		           node that has immediately required this node checking
			During node generation, single generation checking:
		           an executable variable or a file is generated at most once time
			   other variables are generated at mots once for each file */
};
