#define GET_VERBOSELEVEL() (Soundness::the_verboseLevel)
#define SET_VERBOSELEVEL(_LEVEL_) (Soundness::the_verboseLevel) = _LEVEL_
#define SET_SILENT() (Soundness::the_verboseLevel) = 0

#define ISVERBOSE() (GET_VERBOSELEVEL()>=1)
#define ISLVERBOSE() (GET_VERBOSELEVEL()>=2)
#define ISDEBUG() (GET_VERBOSELEVEL()>=3)
#define ISLDEBUG() (GET_VERBOSELEVEL()>=4)

#define LOGMARKS() (Lexical::the_staticLexical)
#define LOGFILE() (Soundness::the_logBuffer)
#define SET_LOGFILE(_LOFFILE_) (Soundness::the_logBuffer) = _LOFFILE_

#define LOG_SP() LOGFILE()->space()
#define LOG_TAB(_NN_) LOGFILE()->tabulation(_NN_)
#define LOG_BACKTAB() LOGFILE()->backTabulation()
#define LOG_LN() LOGFILE()->line()
#define LOG_LN_(_NN_) LOGFILE()->line(_NN_)
#define LOG_STR_(_STR_) LOGFILE()->print(_STR_)
#define LOG_STR_SP(_STR_) LOGFILE()->space(_STR_)
#define LOG_STR_LN(_STR_) LOGFILE()->line(_STR_)
#define LOG_STR_SP_CHAR_(_STR_, _CHAR_) LOGFILE()->space(_STR_); LOGFILE()->print(_CHAR_)
#define LOG_STR_SP_CHAR_SP(_STR_, _CHAR_) LOGFILE()->space(_STR_); LOGFILE()->space(_CHAR_)
#define LOG_STR_SP_STR_SP(_STR_A, _STR_B) LOGFILE()->space(_STR_A, _STR_B)
#define LOG_STR_SP_STR_LN(_STRA, _STRB) LOG_STR_SP(_STRA); LOG_STR_LN(_STRB)

#define LOG_INT(_INT_) LOGFILE()->print((long int)_INT_)
#define LOG_INT_SP(_INT_) LOGFILE()->space((long int)_INT_)
#define LOG_INT_LN(_INT_) LOG_INT(_INT_);LOGFILE()->line()

#define LOG_ADR(_ADR_) LOGFILE()->print((long int)(_ADR_))
#define LOG_ADR_SP(_ADR_) LOGFILE()->space((long int)(_ADR_))
#define LOG_ADR_LN(_ADR_) LOG_ADR(_ADR_);LOGFILE()->line()

#define LOG_SPN_STR_SP(_NN_, _STR_) LOGFILE()->put_SPACES__sp(_NN_, _STR_)
#define LOG_SPN_STR_LN(_NN_, _STR_) LOGFILE()->put_SPACES__ln(_NN_, _STR_)
#define LOG_PREFIX1_STR_SP(_NN_, _STR_) LOGFILE()->put_PREFIX1__sp(_NN_, _STR_)
#define LOG_PREFIX1_STR_LN(_NN_, _STR_) LOGFILE()->put_PREFIX1__ln(_NN_, _STR_)
#define LOG_PREFIX2_STR_(_NN_, _STR_) LOGFILE()->put_PREFIX2__(_NN_, _STR_)
#define LOG_PREFIX2_STR_SP(_NN_, _STR_) LOGFILE()->put_PREFIX2__sp(_NN_, _STR_)
#define LOG_PREFIX2_STR_LN(_NN_, _STR_) LOGFILE()->put_PREFIX2__ln(_NN_, _STR_)

#define LOG_COMMENT_SP() LOGFILE()->comment_sp()
#define LOG_COMMENT_STR_SP(_STR_) LOGFILE()->comment__sp(_STR_)
#define LOG_COMMENTITEM_SP() LOGFILE()->commentITEM_sp();
#define LOG_LN_COMMENT_STR_SP(_STR_) LOGFILE()->put_ln_comment__sp(_STR_)
/* appends  'eol'';''spc''--:''spc'<_STR_>'spc' */
#define LOG_LN_COMMENTITEM_STR_SP(_STR_) LOGFILE()->put_ln_COMITEM__sp(_STR_);
/* appends  'eol'';''spc''--:''spc'<_STR_>'eol' */
#define LOG_LN_COMMENTITEM_STR_LN(_STR_) LOGFILE()->put_ln_COMITEM__ln(_STR_);
/* appends  'eol'';''spc''--:''spc'<_STRA_>'spc'<_STRB_>'eol' */
#define LOG_LN_COMMENTITEM_STR_SP_STR_LN(_STRA_, _STRB_) LOG_LN_COMMENTITEM_STR_SP(_STRA_); LOG_STR_LN(_STRB_)

#define LOG_INFO_STR_SP(_STR_) LOGFILE()->put_INFO__sp(_STR_)
#define LOG_LN_INFO_SP() LOGFILE()->put_ln_INFO_sp();
#define LOG_LN_INFO_STR_SP(_STR_) LOGFILE()->put_ln_INFO__sp(_STR_)
#define LOG_LN_INFO_STR_LN(_STR_) LOGFILE()->put_ln_INFO__ln(_STR_)
#define LOG_LN_INFO_STR_SP_STR_LN(_STR_A, _STR_B) LOGFILE()->put_ln_INFO__sp__ln(_STR_A, _STR_B)

#define LOG_LN_WARN_SP() LOGFILE()->put_ln_WARN_sp();
#define LOG_LN_WARN_STR_SP(_STR_) LOGFILE()->put_ln_WARN__sp(_STR_)
#define LOG_LN_WARN_STR_LN(_STR_) LOGFILE()->put_ln_WARN__ln(_STR_)

#define LOG_ERRO_STR_SP(_STR_) LOGFILE()->put_ERRO__sp(_STR_)
#define LOG_LN_ERRO_SP() LOGFILE()->put_ln_ERRO_sp()
#define LOG_LN_ERRO_STR_SP(_STR_) LOGFILE()->put_ln_ERRO__sp(_STR_)
#define LOG_LN_ERRO_STR_LN(_STR_) LOGFILE()->put_ln_ERRO__ln(_STR_)
#define LOG_LN_ERRO_STR_SP_STR_SP(_STRA_, _STRB_) LOG_LN_ERRO_STR_SP(_STRA_); LOG_STR_SP(_STRB_)
#define LOG_LN_ERRO_STR_SP_STR_LN(_STRA_, _STRB_) LOG_LN_ERRO_STR_SP(_STRA_); LOG_STR_LN(_STRB_)

#define LOG_LN_FATA_SP() LOGFILE()->put_ln_FATA_sp()
#define LOG_LN_FATA_STR_SP(_STR_) LOGFILE()->put_ln_FATA__sp(_STR_)

#define LOG_INNERREF_SP(_NUM_, _OWNNUM_) LOGFILE()->put_innerRef_sp(_NUM_, _OWNNUM_)

#define LOG_STEPTITLE_STR_LN(_STR_) LOGFILE()->put_titleLine_INFO__ln_tab(GET_VERBOSELEVEL()-1, _STR_)

#define LOG_LN_DEBU_STR_SP(_STR_) LOGFILE()->put_ln_DEBU__sp(_STR_)
#define LOG_LN_DEBU_STR_LN(_STR_) LOGFILE()->put_ln_DEBU__ln(_STR_)
#define LOG_OPENDEBUG_SP() LOGFILE()->open_DEBUG_sp()
#define LOG_CLOSEDEBUG() LOGFILE()->close_DEBUG();
