_PUBLIC_ _VIRTUAL_ const char *
AncestorFunctionCall::myClassName ()
{
  return "AncestorFunctionCall";
}

/* ========== Attributes
 */

/* ========== Writer
 */

/* ========== Set
 */

/* ========== Printer
 */

/* ========== Reader
 */

/* ========== Generator
 */

/* runs this call
 * if this is safe, this_readingContext is not NIL (not checked)
 * returns in res the computed ancestor list (may be empty)
 */
boolean
AncestorFunctionCall::call (ref2Context callingContext, ref2AncestorList * res)
{
  // logDEBUG_in("call(ref2Context, ref2AncestorList *) call to ", this_functionName);
  // logDEBUG_actualParameters();
  if (IS_SAFE ())
    {
      if (this_linkedFunction != NIL_AncestorFunctionElement)
	{
	  boolean lCorrect = pk_true;
	  boolean hasEmptyList;
	  if (setIterate (&lCorrect, &hasEmptyList))
	    {
	      if (hasEmptyList)
		{
		  (*res) = NIL_AncestorList;
		  return pk_true;
		}
	      if (this_linkedFunction->
		  call_iteration (callingContext, (ref2IteratorContext) this_readingContext, these_actualParameters, &lCorrect, res))
		return pk_true;
	      (*res) = NIL_AncestorList;
	      return lCorrect;
	    }
	  if (lCorrect)
	    return this_linkedFunction->single_call (callingContext, these_actualParameters, res);
	}
    }
  return pk_false;
}

/* ========== Grapher
 */

/* ========== Builder
 */

/*
 * LG SOURCE OF CONSTRAINTS ON SPACE READING AncestorFunctionCall::AncestorFunctionCall
 */
AncestorFunctionCall::AncestorFunctionCall (ref2Context aContext, char *functionName, ref2AncestorFunctionElement linkedFunction, ref2ArgumentList actualParameters, boolean * correct):FunctionCall (aContext, functionName,
	      actualParameters)
{
  this_linkedFunction = linkedFunction;
}

/* 2004-09-20
 * creates an ancestor function call in context <aContext>
 * the function call is iterated 
 * success: the next not space not comment in this file is a list opening mark
 *          an argument list terminated by list closing mark is correctly read
 *          the end of line containing list closing mark is reached
 *          terminates on line completion following function call closing mark
 * failure: terminates on line completion following function call closing mark
 */
AncestorFunctionCall::AncestorFunctionCall (ref2IteratorContext aContext, char *functionName, ref2AncestorFunctionElement linkedFunction,
					    ref2ArgumentList actualParameters, boolean * correct):
FunctionCall (aContext, functionName, actualParameters)
{
  this_linkedFunction = linkedFunction;
}
