_PUBLIC_ _VIRTUAL_ const char *
ArgumentFunctionCall::myClassName ()
{
  return "ArgumentFunctionCall";
}

/* ========== Attributes
 */


/* PLG 2005-10-13
 * External entry point
 * if this is safe, this is supposed to have been correctly expanded
 * returns this expanded value
 */
boolean
ArgumentFunctionCall::get_expanded (ref2Argument * arg_res)
{
  if (IS_SAFE ())
    {
      (*arg_res) = this_expandedArgument;
      return pk_true;
    }
  unsafe_use ("ArgumentFunctionCall::get_expanded");
  return pk_false;
}

/* PLG 2007-02-26 FATAL when failure
 * should be protected
 * this is supposed to be SAFE 
 * these_actualParameters is supposed to have one and only one (string) element
 * success: this string element is correctly expanded to an identifier syntax
 *          <idName> is set to
 *               this string element expansion
 * failure: this string element cannot be expanded to an identifier syntax
 *          (fatal)error message is printed
 */
boolean
ArgumentFunctionCall::get_identifier_expand_ (ref2Argument strArg, char **idName)
{
  if (strArg->getIf_CString_cast_expand_ (idName))
    {
      if ((*idName) != NIL_String)
	{
	  if (are_leftChar_in_rightString (*idName, identifierCharSet))
	    return pk_true;
	  fatal_named_expansion_ln (*idName, "not a correct identifier");
	  return pk_false;
	}
    }
  fatal_expansion_ln ("in ArgumentFunctionCall::get_identifier_expand_ not a correct identifier");
  return pk_false;
}

/* PLG 2007-02-26 FATAL when failure
 * should be protected
 * this is supposed to be SAFE 
 * these_actualParameters is supposed to have one and only one (string) element
 * success: this string element is correctly expanded to an identifier syntax
 *          <idName> is set to
 *               this string element expansion
 * failure: this string element cannot be expanded to an identifier syntax
 *          (fatal)error message is printed
 */
boolean
ArgumentFunctionCall::get_identifier_expand_singleton_ (char **idName)
{
  return get_identifier_expand_ (these_actualParameters->content (), idName);
}

_PUBLIC_ _VIRTUAL_ boolean ArgumentFunctionCall::is_isomorphic (ref2ArgumentFunctionCall arg_funcCall)
{
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean ArgumentFunctionCall::is_isomorphic (ref2StringFunctionCall arg_funcCall)
{
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean ArgumentFunctionCall::is_isomorphic (ref2HostValFunctionCall arg_funcCall)
{
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean ArgumentFunctionCall::is_isomorphic (ref2StringValFunctionCall arg_funcCall)
{
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean ArgumentFunctionCall::is_isomorphic (ref2UserStringFunctionCall arg_funcCall)
{
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean ArgumentFunctionCall::is_isomorphic (ref2ListFunctionCall arg_funcCall)
{
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean ArgumentFunctionCall::is_isomorphic (ref2ListValFunctionCall arg_funcCall)
{
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean ArgumentFunctionCall::is_isomorphic (ref2UserListFunctionCall arg_funcCall)
{
  return pk_false;
}

/* ========== LOG
 */
_PUBLIC_ _VIRTUAL_ void
ArgumentFunctionCall::log_formula_ ()
{
  log_innerOpen ();
  log_formula ();
  log_valueOpen ();
  if (((ref2Argument) this_expandedArgument) == NIL_Argument)
    {
      log_nil ();
    }
  else
    {
      this_expandedArgument->log_formula_ (HAS_STRING_TYPE ());
    }
  log_valueClose ();
  log_innerClose ();
}


/* ========== Writer
 */

/* ========== Set
 */

/* ========== Printer
 */

/* ========== Reader
 */

/* ========== Generator
 */
/* PLG 2005-12-08
 * success: never
 * failure: always
 *          system error message is printed
 */
_VIRTUAL_ boolean
ArgumentFunctionCall::single_call ()
{
  unsafe_use ("single_call");
  return pk_false;
}

/* PLG 2005-12-12
 * should be protected
 * this is supposed to be SAFE, 
 * actual argument list and formal argument list fit
 * generates a new string list (NSL) returned in <argumentList_res>
 * <iteratorList> is not NIL (not checked)
 * success: <iteratorList> has a single identifier element D  which value is a not empty string list D[1]...D[n]
 *          resulting list NSL has n elements 
 *          NSL[i] is the rersult of applying single_call to these_actualParameters 
 *                in which occurrences of identifier D are replaced by D[i]
 *          if these_actualParameters has no D occurrence the same element is generated n times
 * failure: these_actualParameters expansion failed
 *          error message is printed
 */
_PRIVATE_ boolean ArgumentFunctionCall::tail_singleCall (ref2IdentifierList iteratorList, ref2ArgumentList * argumentList_res)
{
  // logDEBUG_in("tail_singleCall(ref2IdentifierList, ref2ArgumentList *) to", this_functionName);
  if (single_call ())
    {
      ref2Argument
	car_arg = this_expandedArgument;
      if (iteratorList->stepThisCurrentList ())
	{
	  ref2ArgumentList
	    cdr_listArg;
	  if (!tail_singleCall (iteratorList, &cdr_listArg))
	    return pk_false;
	  (*argumentList_res) = new ArgumentList (car_arg, cdr_listArg);
	  return pk_true;
	}
      (*argumentList_res) = new ArgumentList (car_arg);
      return pk_true;
    }
  return pk_false;
}

/* PLG 2005-12-12
 * should be protected
 * this is supposed to be SAFE, 
 * actual argument list and formal argument list fit
 * generates a new string list (NSL) returned in <argumentList_res>
 * <iteratorList> is not NIL (not checked)
 * success: <iteratorList> has a single identifier element D  which value is a not empty string list D[1]...D[n]
 *          resulting list NSL has n elements 
 *          NSL[i] is the rersult of applying single_call to these_actualParameters 
 *                in which occurrences of identifier D are replaced by D[i]
 *          if these_actualParameters has no D occurrence the same element is generated n times
 * failure: these_actualParameters expansion failed
 *          error message is printed
 */
_PRIVATE_ boolean ArgumentFunctionCall::coTail_singleCall (ref2IdentifierList iteratorList, ref2ArgumentList * argumentList_res)
{
  // logDEBUG_in("tail_singleCall(ref2IdentifierList, ref2ArgumentList *) to", this_functionName);
  if (single_call ())
    {
      ref2Argument
	car_arg = this_expandedArgument;
      if (iteratorList->coStepThisCurrentList ())
	{
	  ref2ArgumentList
	    cdr_listArg;
	  if (!coTail_singleCall (iteratorList, &cdr_listArg))
	    return pk_false;
	  (*argumentList_res) = new ArgumentList (car_arg, cdr_listArg);
	  return pk_true;
	}
      (*argumentList_res) = new ArgumentList (car_arg);
      return pk_true;
    }
  return pk_false;
}

/* 2004-12-10
 * should be protected
 * this is supposed to be SAFE, 
 * actual argument list and formal argument list fit
 * generates a new string list 
 * <iteratorList> is not NIL (not checked)
 * success: <iteratorList> has m identifiers I1,...Im  
 *                each DD[j] element value is a not empty string list DD[j]=DD[j][1]...DD[j][nj]
 *             resulting string list NSL has n elements where n is the minimal value of the ni
 *               NSL[i] is the result of applying single_call to these_actualParameters 
 *                   in which occurrences of identifier D[j] are replaced by D[j][i], for j in 1..m
 *             <argumentList_res> is set to NSL
 *             NSL[i] is the rersult of applying single_call to these_actualParameters 
 *                   in which occurrences of identifier D are replaced by D[i]
 * failure: this current element of <iteratorList> is NIL or its actual list value is empty
 *          or these_actualParameters expansion failed
 *          <argumentList_res> may be changed
 *          error message is printed
 */
_PRIVATE_ boolean ArgumentFunctionCall::innerCall_iteration (ref2IdentifierList iteratorList, boolean * correct, ref2ArgumentList * argumentList_res)
{
  // logDEBUG_in("innerCall_iteration(ref2IdentifierList, ref2ArgumentList *) to", this_functionName);
  // fprintf(stderr, "DEBUG ArgumentFunctionCall::innerCall_iteration first identifier is <%s>\n", iteratorList->get_name());
  ref2IdentifierList
    innerIterator = iteratorList->next ();
  if (innerIterator == NIL_IdentifierList)
    {
      if (iteratorList->downThisCurrentList (correct))
	{
	  if (tail_singleCall (iteratorList, argumentList_res))
	    return pk_true;
	  (*correct) = pk_false;
	}
      return pk_false;
    }
  if (iteratorList->coDownThisCurrentList (correct))
    {
      if (coTail_singleCall (iteratorList, argumentList_res))
	return pk_true;
      (*correct) = pk_false;
    }
  return pk_false;
}

/* PLG 2005-12-12
 * should be protected
 * this is supposed to be SAFE, 
 * actual argument list and formal argument list fit
 * <iteratorList> is not NIL (not checked)
 * generates a new string list (NSL) assigned to this_expandedArgument
 * success: <iteratorList> has a tuple of identifier element D[1]...D[m]  
 *                  which values are not empty string list ISL[D[J]]=ISL[1]...ISL[n[J]]
 *          resulting string list NSL has n[1]*...*n[m] elements 
 *          <argumentList_res> is set to NSL
 *          NSL[k[1],...,k[n]] is the concatenation of these_actualParameters in which occurrences of D[J] are replaced by ISL[k[J]]
 *          if these_actualParameters has no D[J] occurrence the same string is generated n times
 *          NSL is appent to last; <last> is set to the lat element of resulting list
 * failure: this current element of <iteratorList> is NIL or its actual list value is empty
 *          or these_actualParameters expansion failed
 *          error message is printed
 *          <last> remains unchanged
 */
_PROTECTED_ boolean ArgumentFunctionCall::call_iteration (boolean * correct, ref2ArgumentList * argumentList_res)
{
  // logDEBUG_in("ArgumentFunctionCall::call_iteration() to ", this_functionName);
  // logDEBUG_actualParameters();
  ref2IdentifierList
    iteratorList = ((ref2DynamicContext) this_readingContext)->get_identifierList ();
  /* iteratorList is not empty */
  if (innerCall_iteration (iteratorList, correct, argumentList_res))
    {
      this_expandedArgument = *argumentList_res;
      return pk_true;
    }
  return pk_false;
}

/* External entry point
 * runs this string function call 
 * returns in <CString_res> the computed Argument 
 */
_PUBLIC_ _VIRTUAL_ boolean ArgumentFunctionCall::CString_call (char **CString_res)
{
  unsafe_use ("CString_call(char ** CString_res)");
  return pk_false;
}

/* PLG 2005-12-07
 * success: never
 * failure: always
 *          system error message is printed
 */
_PUBLIC_ _VIRTUAL_ boolean ArgumentFunctionCall::string_call (ref2StringArgument * stringArgument_res)
{
  unsafe_use ("string_call(ref2StringArgument_res)");
  return pk_false;
}

/* PLG 2005-12-07
 * success: never
 * failure: always
 *          system error message is printed
 */
_PUBLIC_ _VIRTUAL_ boolean ArgumentFunctionCall::list_call (ref2ArgumentList * argumentList_res)
{
  unsafe_use ("list_call(ref2ArgumentList * argumentList_res)");
  return pk_false;
}

/* ========== Grapher
 */

/* ========== Builder
 */

/* PLG 2005-10-13
 * failure: this string element cannot be expanded to an identifier syntax
 *          (fatal)error message is printed
 */
_PROTECTED_ boolean ArgumentFunctionCall::set_stringIdentifierArg (ref2Argument actualParameter, char **staticArgVal)
{
  // logDEBUG_in("set_stringIdentifierArg(ref2Argument, char **) of ", this_functionName);
  if (actualParameter->is_static ())
    {
      if (get_identifier_expand_ (actualParameter, staticArgVal))
	{			/*(fatal)error message is printed, fatal is set */
	  SET_STATIC_PARAMETER ();
	  return pk_true;
	}
      return pk_false;
    }
  SET_PARAMETER_SCOPE (actualParameter->get_scope ());
  return pk_true;
}

boolean
ArgumentFunctionCall::set_actualParameters_scope ()
{
  // logDEBUG_in("set_actualParameters_scope() of ", this_functionName);
  if (HAS_EMPTY_PARAMETER () || HAS_STATIC_PARAMETER ())
    {
      if (single_call ())
	{
	  SET_STATIC ();
	  return pk_true;
	}
      return pk_false;
    }
  return pk_true;
}

/* referred to 
 *    in StringFunctionCall::
 *              StringFunctionCall(ref2Context readingContext, char * name, ref2Argument actualParameter)
 *          as ArgumentFunctionCall(readingContext, pk_false, name, actualParameter)
 *    in ListFunctionCall::
 *              ListFunctionCall(ref2Context readingContext, char * name, ref2Argument actualParameter)
 *          as ArgumentFunctionCall(readingContext, pk_true, name, actualParameter)
 */
ArgumentFunctionCall::ArgumentFunctionCall (ref2Context readingContext, boolean isList, const char *CString_name, ref2Argument actualParameter):FunctionCall (readingContext, CString_name,
	      new
	      ArgumentList (actualParameter))
{
  this_expandedArgument = NIL_Argument;
  if (isList)
    SET_LIST_TYPE ();
  else
    SET_STRING_TYPE ();
}

/* PLG 2007-02-08 ::ArgumentFunctionCall(ref2Context readingContext, boolean isList, char * CString_name)
 * call to list or string function
 * <readingContext> is the reading context of this function call
 * <isList> is pk_true if the resukting value has string type
 * <CString_name> is the function name 
 * this scope remains unknown
 */
/* referred to 
 *    in StringFunctionCall::
 *             StringFunctionCall(ref2Context readingContext, char * name, ref2ArgumentList actualParameters)
 *          as ArgumentFunctionCall(readingContext, pk_false, name, actualParameters)
 *    in StringFunctionCall::
 *             StringFunctionCall(ref2Context readingContext, ref2ArgumentList actualParameters, boolean *correct)
 *          as ArgumentFunctionCall(readingContext, pk_false, stringWORD, actualParameters)
 *    in ListFunctionCall::
 *             ListFunctionCall(ref2Context readingContext, char * name, ref2ArgumentList actualParameters)
 *          as ArgumentFunctionCall(readingContext, pk_true, name, actualParameters)
 *    in ListFunctionCall::
 *             ListFunctionCall(ref2Context readingContext, ref2ArgumentList actualParameters, boolean *correct)
 *          as ArgumentFunctionCall(readingContext, pk_true, listWORD, actualParameters)
 */
ArgumentFunctionCall::ArgumentFunctionCall (ref2Context readingContext, boolean isList, const char *CString_name, ref2ArgumentList actualParameters):
FunctionCall (readingContext, CString_name, actualParameters)
{
  this_expandedArgument = NIL_Argument;
  if (isList)
    SET_LIST_TYPE ();
  else
    SET_STRING_TYPE ();
  these_actualParameters = actualParameters;
  if (these_actualParameters == NIL_ArgumentList)
    SET_EMPTY_PARAMETER ();
  else
    SET_PARAMETER_SCOPE (these_actualParameters->get_scope ());
}

/* referred to 
 *    in StringFunctionCall::
 *             StringFunctionCall(ref2IteratorContext readingContext, char * name, ref2Argument actualParameter)
 *          as ArgumentFunctionCall(readingContext, name, actualParameter)
 *    in ListFunctionCall::
 *             ListFunctionCall(ref2IteratorContext readingContext, char * name, ref2Argument actualParameter)
 *          as ArgumentFunctionCall(readingContext, name, actualParameter)
 */
ArgumentFunctionCall::ArgumentFunctionCall (ref2IteratorContext readingContext, const char *CString_name, ref2Argument actualParameter):
FunctionCall (readingContext, CString_name, new ArgumentList (actualParameter))
{
  this_expandedArgument = NIL_Argument;
  SET_LIST_TYPE ();
  these_actualParameters = new ArgumentList (actualParameter);
}

/* PLG 2007-02-08 ::ArgumentFunctionCall(ref2IteratorContext readingContext, char * CString_name)
 * 2005-01-17
 * iterated call to list or string function
 * <readingContext> is the reading context of this function call
 * <CString_name> is the function name 
 * this scope is set to iterated
 */
/* referred to 
 *    in StringFunctionCall::
 *             StringFunctionCall(ref2teratorContext readingContext, char * name, ref2ArgumentList actualParameters))
 *          as ArgumentFunctionCall(readingContext, name, actualParameters)
 *    in StringFunctionCall::
 *             StringFunctionCall(ref2teratorContext readingContext, ref2ArgumentList actualParameters, boolean *correct))
 *          as ArgumentFunctionCall(readingContext, 'string', actualParameters)
 *    in ListFunctionCall::
 *             ListFunctionCall(ref2teratorContext readingContext, char * name, ref2ArgumentList actualParameters))
 *          as ArgumentFunctionCall(readingContext, name, actualParameters)
 *    in ListFunctionCall::
 *             ListFunctionCall(ref2teratorContext readingContext, ref2ArgumentList actualParameters, boolean *correct))
 *          as ArgumentFunctionCall(readingContext, 'list', actualParameters)
 */
ArgumentFunctionCall::ArgumentFunctionCall (ref2IteratorContext readingContext, const char *CString_name, ref2ArgumentList actualParameters):
FunctionCall (readingContext, CString_name, actualParameters)
{
  this_expandedArgument = NIL_Argument;
  SET_LIST_TYPE ();
  these_actualParameters = actualParameters;
  if (these_actualParameters == NIL_ArgumentList)
    SET_EMPTY_PARAMETER ();
  else
    SET_PARAMETER_SCOPE (these_actualParameters->get_scope ());
}
