#define IS_EMPTY() ( this_genericArgument == NIL_Argument )
#define IS_STATIC() ( IS_EMPTY() || (this_genericArgument->is_static()) )

_PUBLIC_ _VIRTUAL_ const char *
ArgumentFunctionElement::myClassName ()
{
  return "ArgumentFunctionElement";
}

/* ========== Attributes
 */

/* returns pk_true if this Argument is static (does not have parameter or iterator occurrence)
 * this type is assumed to be list type NOT CHECKED
 */
boolean
ArgumentFunctionElement::is_static ()
{
  return IS_STATIC ();
}

/* ========== Writer
 */

/* prints object standard header: "{ <NAME>" or "{ <TYPE> <NAME>"
 */
_VIRTUAL_ void
ArgumentFunctionElement::print_type_sp (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  outBuffer->print ("## unkNownType ##");
}

_VIRTUAL_ void
ArgumentFunctionElement::print_declBody (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  outBuffer->print ("## ERRORED ##");
}

/* ========== Log
 */

/* detailss in <outBuffer> file this context and local declarations
 * <outBuffer> is not NIL_IntePrinter
 */
_VIRTUAL_ void
ArgumentFunctionElement::logDebug_declBody (int level)
{
  log_spn_str_ln (level, "this argument is not defined");
}

/* ========== Set
 */

/* ========== Printer
 */

/* ========== Reader
 */

/* 2004-11-24
 * reads body of a function declaration
 * success: cursor starts .[string_ARGUMENT] [fileSpace*]#'}:'
 *          cursor is moved to '}'
 * failure: an error occurred
 *          cursor is moved to errored position
 *          error message is printed
 */
_VIRTUAL_ boolean
ArgumentFunctionElement::read_declBody_fSpStar_nSp ()
{
  return pk_true;
}

/* ========== Generator
 */

/* ========== Builder
 */
/* 2005-02-01
 * creates and returns a new string function descriptor named <name>
 * <embeddingContext> is not NIL
 * <embeddingContext> is the context in which this declaration occurs
 * <comments> are comments associated with this declaration
 * <innerContext> is the new internal context
 * success: cursor starts .[string_ARGUMENT] [fileSpace*] #'}:'
 *          [string_ARGUMENT] is read in <innerContext>
 *          <correct> remains unchanged
 *          cursor is moved to '}:'
 * failure: an error occurs
 *          error message is printed
 *          <correct> is set to false
 */
_PROTECTED_ ArgumentFunctionElement::ArgumentFunctionElement (ref2Context embeddingContext, char *name, ref2DynamicContext innerContext, ref2ArgumentList comments):FunctionElement (embeddingContext, name, innerContext,
		 comments)
{
  // this_context->log_ASDEBUG("ArgumentFunctionElement::ArgumentFunctionElement 1");
  this_genericArgument = NIL_Argument;
}
