
/* ==========  ==========  ==========  ========== TITLE: printing 
/* ==========  ==========  ==========  ========== TITLE: printing in log
 */
_PROTECTED_ void
ArgumentReporting::log_listOpen ()
{
  LOG_STR_ ("(");
}

_PROTECTED_ void
ArgumentReporting::log_listSeparator ()
{
  LOG_STR_ (", ");
}

_PROTECTED_ void
ArgumentReporting::log_listClose ()
{
  LOG_STR_ (")");
}

_PROTECTED_ void
ArgumentReporting::log_subFormulaOpen ()
{
  LOG_STR_ ("(");
}

_PROTECTED_ void
ArgumentReporting::log_subFormulaClose ()
{
  LOG_STR_ (")");
}

_PROTECTED_ void
ArgumentReporting::log_openParameter ()	/* NamedArgument */
{
  LOG_STR_ ("$(");
}

_PROTECTED_ void
ArgumentReporting::log_closeParameter ()
{
  LOG_STR_ (")");
}

/* used in Meta Argument*/
_PROTECTED_ void
ArgumentReporting::log_stringMark ()
{
  (LOGMARKS ())->out_stringMark (LOGFILE ());
}

/* PLG 2005-12-08
 * success: never
 * failure: always
 *          system error message is printed
 */
_VIRTUAL_ void
ArgumentReporting::glueLog_ (const char *str)
{
  (LOGFILE ())->print (str);
}

/* used in Meta Argument*/
_PROTECTED_ void
ArgumentReporting::log_stringConstant (const char *str)
{
  (LOGMARKS ())->out_stringConstant (LOGFILE (), str);
}

/* */
_PROTECTED_ void
ArgumentReporting::log_parameter (const char *str)
{
  (LOGMARKS ())->out_parameter (LOGFILE (), str);
}

/* PLG 2005-12-08
 * success: never
 * failure: always
 *          system error message is printed
 */
_PUBLIC_ void
ArgumentReporting::logUnsafe_parameterizedFormula ()	/* DONE */
{
  unsafe_use ("print__parameterizedFormula(...)");
}

/* used in Meta Argument*/
_PUBLIC_ void
ArgumentReporting::log_extendedDebug_stringConstant (int level, const char *str)
{
  LOG_PREFIX2_STR_ (level, "this string actual value is <");
  LOG_STR_ (str);
  LOG_STR_LN (">");
}

/* ==========  ==========  ==========  ========== TITLE: INFO
 */
/* ==========  ==========  ==========  ========== TITLE: LEVEL INFO
 */
/* ==========  ==========  ==========  ========== TITLE: WARNING
 */
/* ==========  ==========  ==========  ========== TITLE: ERROR
 */
void
ArgumentReporting::unsafe_named_argumentUse (const char *objectName, const char *className, const char *functionName)
{
  LOG_LN_ERRO_STR_SP ("in");
  LOG_STR_SP_STR_SP (objectName, className);
  LOG_STR_SP_STR_LN ("unsafe call to", functionName);
}

void
ArgumentReporting::unsafe_argumentUse (const char *Subclass, const char *functionName)
{
  LOG_LN_ERRO_STR_SP (Subclass);
  LOG_STR_SP_STR_LN ("unsafe call to", functionName);
}

/* ==========  ==========  ==========  ========== TITLE: FATAL
 */
void
ArgumentReporting::fatal_typeConflict_ln (const char *typeStr)
{
  LOG_LN_FATA_STR_SP ("type conflict: expected type is");
  LOG_STR_LN (typeStr);
  set_fatal ();
}

/* ==========  ==========  ==========  ========== TITLE: DEBUG
 */
_PROTECTED_ void
ArgumentReporting::logDebug_thisIs_ln (int level, const char *category)
{
  LOG_SPN_STR_SP (level, "this is");
  LOG_STR_LN (category);
}

_PUBLIC_ void
ArgumentReporting::log_hasStringType (int level)
{
  log_spn_str_ln (level, "this type is string");
}

_PUBLIC_ void
ArgumentReporting::log_hasListType (int level)
{
  log_spn_str_ln (level, "this type is list");
}

_PUBLIC_ void
ArgumentReporting::log_hasUnknowmType (int level)
{
  log_spn_str_ln (level, "this type is unknown");
}

_PUBLIC_ void
ArgumentReporting::log_isInError (int level)
{
  log_spn_str_ln (level, "this is ## in error ##");
}
