
/* ==========  ==========  ==========  ========== TITLE: these attributes
 */
_PUBLIC_ _VIRTUAL_ const char *
ContextTreeList::myClassName ()
{
  return "ContextTreeList";
}

/* ========== Declaration registration
 */

_PUBLIC_ ref2ContextTree ContextTreeList::content ()
{
  return car;
}

_PUBLIC_ ref2ContextTreeList ContextTreeList::next ()
{
  return cdr;
}

/* ==========  ==========  ==========  ========== TITLE: PRINTER
 */
_PUBLIC_ void
ContextTreeList::printReverseRefLst (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{

  if (cdr != NIL_ContextTreeList)
    cdr->printReverseRefLst (printingContext, outBuffer);
  car->print_nameValue_sp (printingContext, outBuffer);
  outBuffer->line ();
}

/* ==========  ==========  ==========  ========== TITLE: COMPLEX ACTIONS
 */
/* ==========  ==========  ==========  ========== TITLE: BUILDER
 */
/* creates and returns a new static root context associated to <aMKFFile> 
 * a new reader is created
 * this is static
 */
ContextTreeList::ContextTreeList (ref2ContextTree _value):Soundness ()
{
  car = _value;
  cdr = NIL_ContextTreeList;
}

/* creates and returns a new static root context associated to <aMKFFile> 
 * a new reader is created
 * this is static
 */
ContextTreeList::ContextTreeList (ref2ContextTree _value, ref2ContextTreeList succ):Soundness ()
{
  car = _value;
  cdr = succ;
}
