/* 
   ref2MKFFileNode comingFrom -> ref2ContextTree comingFrom
      DirectFileNode::set_rootUpdate(ref2ContextTree comingFrom, int force) 
      FileNode::set_rootUpdate(ref2ContextTree comingFrom, int force)
      NodeElement::set_rootUpdate(ref2ContextTree comingFrom, int force)
      VariableNode::set_rootUpdate(ref2ContextTree comingFrom, int force)

DirectFileNode::
_visitMessIf_buildable_recursiveEverUpdate(this, comingFrom, &updatedDate, &cycleRoot)
_visitMess_present_toBeBuilt((ref2NodeElement)comingFrom, &cycleRoot);
_visitMess_present_(GET_FUTURE(), (ref2NodeElement)comingFrom, &isToBeBuilt, &cycleRoot); }
_visitMess_missing_toBeBuilt((ref2NodeElement)comingFrom, &cycleRoot);
_visit_inner_toBeBuilt
VariableNode::
_visitIf_executable_recursiveEverUpdate((ref2NodeElement)comingFrom, &updatedDate, &cycleRoot);
_visitMessIf_executable_toBeBuilt((ref2NodeElement)comingFrom, &cycleRoot); 
_visitMess_executable_(GET_FUTURE(), (ref2NodeElement)comingFrom, &updatedDate, &isToBeBuilt, &cycleRoot); }
*/
#define HAS_LOCALDECLARATIONS() ( this_localDeclarationList != NIL_ElementList )
#define ATTACH_LOCALDECLARATIONS(_ELTREFLIST_) this_localDeclarationList = _ELTREFLIST_
#define PRINT_LOCALDECLARATIONS(_CO_,_OUT_) this_localDeclarationList->print(_CO_,_OUT_, this_owner)
#define INIT_LOCALDECLARATIONS() this_localDeclarationList = NIL_ElementList
#define CREATE_LOCALDECLARATION(_ELTREF_) this_localDeclarationList = new ElementList(_ELTREF_)
#define APPEND_LOCALDECLARATION(_ELTREF_) this_localDeclarationList->append(_ELTREF_)
#define FIND_LOCALDECLARATION(_NAME_, _ELTREF_) (this_localDeclarationList->find(_NAME_, _ELTREF_))

#define GET_LOCALCONSTRUCTORS() this_constructorList
#define HAS_LOCALCONSTRUCTORS() ( this_constructorList != NIL_ElementList )
#define PRINT_LOCALCONSTRUCTORS(_CO_,_OUT_) this_constructorList->print(_CO_, _OUT_, this_owner)
#define INIT_LOCALCONSTRUCTORS() this_constructorList = NIL_ElementList
#define CREATE_LOCALCONSTRUCTORS(_ELTREF_) this_constructorList = new ElementList(_ELTREF_)
#define APPEND_LOCALCONSTRUCTOR(_ELTREF_) this_constructorList->append(_ELTREF_)

#define GET_IMPORTEDCONTEXTS() this_contextTreeList
#define HAS_IMPORTEDCONTEXTS() ( this_contextTreeList != NIL_ContextTreeList )
#define PRINT_IMPORTEDCONTEXTS(_LEX_, _OUT_) this_contextTreeList->printReverseRefLst(_LEX_, _OUT_)
#define INIT_IMPORTEDCONTEXTS() this_contextTreeList = NIL_ContextTreeList
#define CREATE_IMPORTEDCONTEXT(_CONTEXTTREE_) this_contextTreeList = new ContextTreeList(_CONTEXTTREE_)
#define INSERT_IMPORTEDCONTEXT(_CONTEXTTREE_) this_contextTreeList = new ContextTreeList(_CONTEXTTREE_, this_contextTreeList)

#define FIND_GLOBALEXTERN(_NAME_, _INDEX_, _NODEREF_) (the_externTable->find_(_NAME_, _INDEX_, (ref2Element *)(_NODEREF_)))
#define FIND_GLOBALVARIABLE(_NAME_, _INDEX_, _NODEREF_) (the_variableTable->find_(_NAME_, _INDEX_, (ref2Element *)(_NODEREF_)))
#define FIND_GLOBALFILE(_NAME_, _INDEX_, _NODEREF_) (the_fileTable->find_(_NAME_, _INDEX_, (ref2Element *)(_NODEREF_)))

/* ==========  ==========  ==========  ========== TITLE: these attributes
 */
_PUBLIC_ _VIRTUAL_ const char *
ContextTree::myClassName ()
{
  return "ContextTree";
}

_PUBLIC_ void
ContextTree::linkToContext (ref2Context owner)
{
  this_owner = owner;
}

/* ========== Declaration registration
 */

_PUBLIC_ void
ContextTree::register_element_ (ref2Element pt2Element)
{
  if (HAS_LOCALDECLARATIONS ())
    {
      APPEND_LOCALDECLARATION (pt2Element);
    }
  else
    {
      CREATE_LOCALDECLARATION (pt2Element);
    }
}

/* success: no previous declaration with the same name exists
 *          returns pk_true
 * failure: an element XX is found in this local or in the global context
 *          sets XX errored
 *          error message NOT printed
 *          return false
 */
_PUBLIC_ boolean ContextTree::check_localDeclAbsence (char *name)
{
  if (HAS_LOCALDECLARATIONS ())
    {
      ref2Element
	foundElement;
      return !(FIND_LOCALDECLARATION (name, &foundElement));
    }
  return pk_true;
}

/* PLG 2006-01-17
 * <pt2Element> is supposed to be not NIL
 * if this constructor list does not already contains <pt2Element> 
 *   appends a new element containing <pt2Element> at the end of this constructor list 
 */
_PRIVATE_ void
ContextTree::register_constructive (ref2NodeElement directNode)
{
  if (HAS_LOCALCONSTRUCTORS ())
    APPEND_LOCALCONSTRUCTOR (directNode);
  else
    CREATE_LOCALCONSTRUCTORS (directNode);
  register_element_ (directNode);
}

/* registers this file reference or declaration at entry hashi
 */
_PUBLIC_ void
ContextTree::register_staticArgumentElement (ref2ArgumentElement argument, int hashi)
{
  the_argumentTable->register_ ((ref2Element) argument, hashi);
}

/* registers this file reference or declaration at entry hashi
 */
_PRIVATE_ void
ContextTree::register_staticFile (ref2FileNode aFileNode, int hashi)
{
  the_fileTable->register_ ((ref2Element) aFileNode, hashi);
}

/* registers this file reference or declaration at entry hashi
 */
_PUBLIC_ void
ContextTree::register_staticFile (ref2FileNode aFileNode, char *fullName)
{
  the_fileTable->register_ ((ref2Element) aFileNode, fullName);
}

/* substitutes <target> file declaration to this file reference
 * success: redirection does not introduce cycle
 *          sets this referring to <target>
 * failure: redirection would introduce cycle
 *          this and its successors are set in error
 */
_PRIVATE_ void
ContextTree::replace_file (char *name, ref2FileNode src, ref2FileNode target, int hashi)
{
  // fprintf(stderr, "DEBUG ContextTree::replace_file\n");
  target->resetNumber (src->get_number ());	/* may be erroneous action */
  if (target->isNamed (name))
    the_fileTable->replace_ ((ref2Element) src, (ref2Element) target, hashi);
}

/* registers a system file
 */
_PRIVATE_ void
ContextTree::register_hostFile (ref2FileNode aFileNode, ref2ElementList predecessor, int hashi)
{
  if (the_linkedFileList == NIL_ElementList)
    the_linkedFileList = new ElementList (aFileNode);
  else if (predecessor == NIL_ElementList)
    {
      the_linkedFileList = new ElementList (aFileNode, the_linkedFileList);
    }
  else
    {
      ref2ElementList succ = predecessor->next ();
      predecessor->setNext (new ElementList (aFileNode, succ));
    }
  the_fileTable->register_ ((ref2Element) aFileNode, hashi);
}

_PUBLIC_ void
ContextTree::register_rootFile (ref2MKFFileNode rootFile, char *rootPath)
{
  the_linkedFileList = new ElementList (rootFile);
  the_fileTable->register_ ((ref2Element) rootFile, rootPath);
}

/* PLG 2006-01-17
 * <innerContext> is supposed to be not NIL
 * if this context list does not already contains <innerContext> 
 *      inserts before this context list a new element containing <innerContext>
 */
_PUBLIC_ void
ContextTree::register_context (ref2ContextTree innerContext)
{
  if (HAS_IMPORTEDCONTEXTS ())
    {
      INSERT_IMPORTEDCONTEXT (innerContext);
    }
  else
    {
      CREATE_IMPORTEDCONTEXT (innerContext);
    }
}

/* ==========  ==========  ==========  ========== TITLE: PRINTER
 */
_PUBLIC_ _VIRTUAL_ void
ContextTree::print_nameValue_sp (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  this_owner->print_fileNameValue_sp (printingContext, outBuffer);
}


_PRIVATE_ void
ContextTree::print_local (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  if (HAS_LOCALDECLARATIONS ())
    {
      PRINT_LOCALDECLARATIONS (printingContext, outBuffer);
    }				/* PLG 2007-03-26 previous parameter was this; TO BE CHECKED */
}

_PRIVATE_ void
ContextTree::print_constructors (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  if (HAS_LOCALCONSTRUCTORS ())
    PRINT_LOCALCONSTRUCTORS (printingContext, outBuffer);
}

/* prints in <outBuffer> file this context declaration
 * <outBuffer> is not NIL_IntePrinter
 */
_PRIVATE_ void
ContextTree::print_innerContext (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  if (HAS_IMPORTEDCONTEXTS ())
    {
      printingContext->out_ln_declOpening_context_spTab (outBuffer);
      PRINT_IMPORTEDCONTEXTS (printingContext, outBuffer);
      outBuffer->put_ln_declClosing_context_backTabLn ();
    }
}

_PUBLIC_
/* prints in <outBuffer> file this context declaration
 * <outBuffer> is not NIL_IntePrinter
 */
  void
ContextTree::print (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  print_innerContext (printingContext, outBuffer);
  print_local (printingContext, outBuffer);
}

/* ==========  ==========  ==========  ========== TITLE: LOG
 */
_PUBLIC_ void
ContextTree::logAll (ref2NodeManager nodeTable, const char *category)
{
  fullVerboseInfo_opening (category);
  nodeTable->print (LOGMARKS (), LOGFILE ());
  fullVerboseInfo_closing ();
}

_PUBLIC_ void
ContextTree::logAllNodes ()
{
  logAll (the_argumentTable, "Argument Table");
  logAll (the_variableTable, "Variable Table");
  logAll (the_fileTable, "File Table");
  logAll (the_externTable, "Extern Table");
}

_PUBLIC_ void
ContextTree::log_unreferedNodes ()
{
  if (ISLDEBUG ())
    {
      fullVerboseInfo_opening ("Nodes unreferred to");
      the_fileTable->logUnreferred ();
      the_variableTable->logUnreferred ();
      fullVerboseInfo_closing ();
    }
}

_PRIVATE_ void
ContextTree::log_prof_fileNameValue_sp (int prof)
{
  int ii;
  for (ii = 0; ii < prof; ii = ii + 1)
    LOG_STR_SP ("--");
  this_owner->print_fileNameValue_sp (LOGMARKS (), LOGFILE ());
}

_PUBLIC_ void
ContextTree::debug_constructiveNodeList ()
{
  if (ISDEBUG ())
    {
      fullVerboseInfo_opening ("Constuctive nodes");
      the_constructiveNodes->log_list ();
      fullVerboseInfo_closing ();
    }
}

_PUBLIC_ void
ContextTree::logStatistics (boolean allStat)
{
  fullVerboseInfo_opening ("Statistics");
  the_argumentTable->logStatistics ("Argument ", allStat, the_elementNumber);
  the_variableTable->logStatistics ("Variable ", allStat, the_elementNumber);
  the_fileTable->logStatistics ("File ", allStat, the_elementNumber);
  the_externTable->logStatistics ("Extern ", pk_false, the_elementNumber);
  fullVerboseInfo_closing ();
}

/* ==========  ==========  ==========  ========== TITLE: FIND in CONTEXTREE
 */
/* PLG 2007-02-05
 * search for an existing node named <name> 
 * success: a node named <name> is found in this local context, 
 *          a node named <name> is found recursively in one of these nesting contexts
 *              an accelerator to found declaration is set in this local context
 *          <correct> remains unchanged
 *          returns this node in <refFoundElement>, <refFoundElement> is not NIL
 * failure: this context does not contain node named <name>
 *              <refFoundElement> may be changed
 *          a cyclic context nesting is met
 *              WARNING is printed
 *              <refFoundElement> remains unchanged
 */
_PUBLIC_ boolean ContextTree::find_element_ (char *name, ref2Element * foundElement)
{
  // fprintf(stderr, "DEBUG ContextTree::find_element_ of name %s \n", name);
  ref2ContextTreeList
    curRefContextTreeList;
  ref2ContextTree
    curContextTree;;
  if (HAS_LOCALDECLARATIONS ())
    if (FIND_LOCALDECLARATION (name, foundElement))
      return pk_true;
  curRefContextTreeList = GET_IMPORTEDCONTEXTS ();
  while (curRefContextTreeList != NIL_ContextTreeList)
    {
      curContextTree = curRefContextTreeList->content ();
      if (curContextTree->find_element_ (name, foundElement))
	{			/* never errored */
	  register_element_ (*foundElement);	/* search accelerator */
	  return pk_true;
	}
      curRefContextTreeList = curRefContextTreeList->next ();
    }
  return pk_false;
}

/* ==========  ==========  FIND argument element in CONTEXTREE
 */
/* finds an argument reference to identifier named <CString_name>
 * success: gets an existing atom or creates a new one which name is a new mallocated copy of <CString_name>
 *          sets it as used
 *          returns object found in table
 * failure: if found object is in error
 */
_PUBLIC_ boolean ContextTree::find_staticArgumentElement (char *CString_name, int *index, ref2Element * pt2ArgumentElement)
{
  return (the_argumentTable->find_ (CString_name, index, pt2ArgumentElement));
}

/* PLG 2007-02-05
 * search for an argument identifier declaration named <CString_name>
 * search root is this
 * required: not empty <CString_name>
 * success: an argument identifier declaration is found
 *          returns this declaration in <argumentElement>
 *          <correct> remains unchanged
 * failure: a cyclic search has been met
 *             <argumentElement> remains unchanged
 *          <CString_name> has been found but is not an argument name
 *             (fatal) error message is printed
 *             <correct> is set to false
 *             <argumentElement> is set to found node declaraion
 *          <CString_name> has not been found in this context
 *             <correct> remains unchanged
 *             <argumentElement> may be changed
 */
_PUBLIC_ boolean ContextTree::find_argumentElement_in_ (char *CString_name, boolean * correct, ref2ArgumentElement * argumentElement)
{
  ref2Element
    element;
  if (!find_element_ (CString_name, &element))
    {				/* never errored */
      int
	index;
      if (!find_staticArgumentElement (CString_name, &index, &element))
	return pk_false;
    }
  if (element->isArgumentElement ())
    {
      (*argumentElement) = (ref2ArgumentElement) element;
      return pk_true;
    }
  (*correct) = pk_false;
  fatal_named_typeConflict_ln (CString_name, "argument");
  return pk_false;
}

_PUBLIC_ boolean ContextTree::appendNew_fileArgumentElement (ref2ArgumentList comments, boolean isString, char *CString_name, ref2Argument value)
{
  // this_owner->log_ASDEBUG("ContextTree::appendNew_fileArgumentElement");
  if (check_localDeclAbsence (CString_name))
    {
      ref2ArgumentElement
	curArgElement;
      curArgElement = new ArgumentElement (this_owner, pk_true, isString, CString_name, comments, value);
      register_element_ (curArgElement);
      return pk_true;
    }
  this_owner->ASFatal_doubleDecl (CString_name);
  return pk_false;
}

_PUBLIC_ boolean ContextTree::appendNew_staticArgumentElement (ref2ArgumentList comments, boolean isString, char *CString_name, ref2Argument value)
{
  // fprintf(stderr, "DEBUG ContextTree::appendNew_staticArgumentElement================>       name is <%s>\n", CString_name);
  int
    index;
  ref2Element
    curElement;
  ref2ArgumentElement
    curArgElement;
  if (find_staticArgumentElement (CString_name, &index, &curElement))
    {
      this_owner->ASFatal_doubleDecl (CString_name);
      return pk_false;
    }
  curArgElement = new ArgumentElement (this_owner, pk_false, isString, CString_name, comments, value);
  register_staticArgumentElement (curArgElement, index);
  return pk_true;
}

/* ==========  ==========  FIND extern in CONTEXTREE
 */

/* finds an extern reference to identifier named <name>
 * success: gets an existing atom or creates a new one which name is a new mallocated copy of <name>
 *          sets it as used
 *          returns object found in table
 * failure: if found object is in error
 */
_PRIVATE_ ref2ExternNode ContextTree::get_externReference (char *name)
{
  int
    hashi;
  ref2ExternNode
    pt2ExternNode;

  if (!FIND_GLOBALEXTERN (name, &hashi, &pt2ExternNode))
    {
      pt2ExternNode = new ExternNode (hashi, newCstr_String (name));
      the_externTable->register_ ((ref2Element) pt2ExternNode, hashi);
    }
  return pt2ExternNode;
}

/* PLG 2008-06-11
 * build an extern definition
 * <readingContext> is not NIL (not checked)
 * success: always
 *          <curExternNodeRef> is not NIL
 *          <curExternNodeRef>::this_buildingData is not NIL
 * failure: conflicting definition
 *          error message is printed
 */
_PUBLIC_ boolean ContextTree::getIf_externDeclaration (ref2Context owner, char *name, ref2ExternNode * curExternNodeRef)
{
  // fprintf(stderr, "DEBUG ContextTree::getIf_externDeclaration, name is %s\n", name);
  int
    hashi;

  if (FIND_GLOBALEXTERN (name, &hashi, curExternNodeRef))
    return (*curExternNodeRef)->set_declared_in (owner, name);	/* <curExternNodeRef>::this_buildingData is not NIL */
  (*curExternNodeRef) = new ExternNode (owner, hashi, newCstr_String (name));
  the_externTable->register_ ((ref2Element) (*curExternNodeRef), hashi);
  return pk_true;
}

/* ==========  ==========  FIND variable node in CONTEXTREE
 */
/* finds an variable reference to identifier named <name>
 * success: gets an existing atom or creates a new one which name is a new mallocated copy of <name>
 *          sets it as used
 *          returns object found in table
 * failure: if found object is in error
 */
_PRIVATE_ ref2VariableNode ContextTree::get_variableReference (char *name)
{
  int
    hashi;
  ref2VariableNode
    pt2VariableNode;

  if (!FIND_GLOBALVARIABLE (name, &hashi, &pt2VariableNode))
    {
      pt2VariableNode = new VariableNode (hashi, newCstr_String (name));
      the_variableTable->register_ ((ref2Element) pt2VariableNode, hashi);
    }
  return pt2VariableNode;
}

/* PLG 2006-01-17
 * build a variable definition
 * <readingContext> is not NIL (not checked)
 * success: always
 *          <curVariableNodeRef> is not NIL, <curVariableNodeRef>::this_buildingData is not NIL
 * failure: conflicting definition
 *          error message is printed
 */
_PUBLIC_
  boolean ContextTree::getIf_variableDeclaration (ref2Context owner, char *name, boolean is_constructive, ref2VariableNode * curVariableNodeRef)
{
  // fprintf(stderr, "DEBUG ContextTree::getIf_variableDeclaration, name is %s\n", name);
  int
    hashi;

  if (FIND_GLOBALVARIABLE (name, &hashi, curVariableNodeRef))
    {
      if (!(*curVariableNodeRef)->set_declared_in (owner, name))	/* curVariableNodeRef::this_buildingData is not NIL */
	return pk_false;
    }
  else
    (*curVariableNodeRef) = new VariableNode (owner, hashi, newCstr_String (name));
  the_variableTable->register_ ((ref2Element) (*curVariableNodeRef), hashi);
  if (is_constructive)
    register_constructive (*curVariableNodeRef);
  register_element_ ((ref2Element) (*curVariableNodeRef));
  return pk_true;
}

/* ==========  ==========  FIND file in CONTEXTREE
 */
_PRIVATE_ boolean ContextTree::find_staticFile (char *name, int *index, ref2FileNode * curNodeRef)
{
  ref2Element
    nodeRef;
  if (FIND_GLOBALFILE (name, index, &nodeRef))
    {
      (*curNodeRef) = ((ref2FileNode) nodeRef)->get_redirection ();
      return pk_true;
    }
  return pk_false;
}

/* PLG 2006-01-17
 * search for an existing file node which name is expanded <name> system name (including path from the root)
 * success: a file node exists with the same full path system name 
 *          <refFoundFile> is set to this not NIL file descriptor
 *          <filePathName> is set to NIL_String
 * failure: <refFoundFile> is set to NIL_Element
 *          <name> has no corresponding full path file name: 
 *                 <filePathName> is set to NIL_String
 *          <name> has a corresponding full path file name: 
 *                 <filePathName> refers to a new malloc'd string containing this full path file name
 *                 current linked list has some smaller named files, <filePathName> is not found 
 *                        static attribute "predecessor" is set to previous cell in list
 *                 current linked file does not have smaller named files, name is not found 
 *                        "predecessor" is set to NIL_ElementList
 */
_PRIVATE_ boolean ContextTree::find_aliasFile (char *name, char **filePathName, ref2FileNode * refFoundFile, ref2ElementList * predecessor)
{
  char *
    lFileName;
  lFileName = getEnv_RootedPathName (name);
  (*filePathName) = lFileName;

  (*predecessor) = NIL_ElementList;
  if ((lFileName != NIL_String) && (the_linkedFileList != NIL_ElementList))
    {
      ref2ElementList
	curElementList = the_linkedFileList;
      ref2FileNode
	curFileInList = (ref2FileNode) (curElementList->content ());
      int
	cmpRes = curFileInList->cmp_fileName (lFileName);
      (*filePathName) = lFileName;
      if (cmpRes < 0)
	{
	  (*predecessor) = curElementList;
	  while (((*predecessor)->next ()) != NIL_ElementList)
	    {
	      curElementList = (*predecessor)->next ();
	      curFileInList = (ref2FileNode) (curElementList->content ());
	      cmpRes = curFileInList->cmp_fileName (lFileName);
	      if (cmpRes >= 0)
		break;
	      (*predecessor) = curElementList;
	    }
	}
      if (cmpRes == 0)
	{
	  //delete lFileName;
	  if (name != lFileName)
	    delete
	      lFileName;
	  (*refFoundFile) = curFileInList->get_redirection ();
	  return pk_true;
	}
    }
  return pk_false;
}

/* PLG 2006-01-17
 * finds a file reference to current (identifier) atom in buffer 
 * success: gets an existing file descriptor or creates a new one which name is a new mallocated copy of <name>
 *          sets it as used
 *          returns not NIL reference to built or found file descriptor
 * failure: if found object is in error
 */
_PRIVATE_ ref2FileNode ContextTree::get_fileReference (char *name)
{
  int
    hashi;
  ref2FileNode
    resFileNode;
  if (find_staticFile (name, &hashi, &resFileNode))
    {
      resFileNode->setReferredTo ();
    }
  else
    {
      char *
	filePathName;
      ref2ElementList
	predecessor;
      if (find_aliasFile (name, &filePathName, &resFileNode, &predecessor))
	{
	  ref2FileNode
	    aliasedFileNode;
	  aliasedFileNode = new FileNode (resFileNode, newCstr_String (name));	/* FN1 */
	  register_staticFile (aliasedFileNode, hashi);
	}
      else
	{
	  resFileNode = new FileNode (newCstr_String (name), filePathName);	/* FN2 */
	  register_hostFile (resFileNode, predecessor, hashi);
	}
    }
  return resFileNode;
}

_PUBLIC_ ref2NodeElement ContextTree::get_nodeReference (char *name, boolean isVar, boolean isFile)
{
  if (isVar)
    return (ref2NodeElement) get_variableReference (name);
  if (isFile)
    return (ref2NodeElement) get_fileReference (name);
  return (ref2NodeElement) get_externReference (name);
}

/* PLG 2006-01-17
 * builds or finds a file declaration
 * success: <fileNode_res> is a not NIL reference to <name> file declaration, <fileNode_res>::this_buildingData is not NIL 
 * failure: conflict, syntax error, or onaccurate file ref
 *          <curFileNode> remains unchanged
 *          error message is printed
 */
_PUBLIC_ boolean ContextTree::getIf_fileDeclaration (ref2Context owner, char *name, ref2FileNode * fileNode_res)
{
  // fprintf(stderr, "DEBUG ContextTree::getIf_fileDeclaration, name is %s\n", name);
  int
    hashi;
  ref2FileNode
    foundFileNode;
  char *
    filePathName;
  ref2ElementList
    predecessor;

  if (find_staticFile (name, &hashi, fileNode_res))
    {
      /* node has been found */
      return (*fileNode_res)->set_declared_in (owner, name);
    }				/* fileNode_res::this_buildingData is not NIL */
  if (find_aliasFile (name, &filePathName, &foundFileNode, &predecessor))
    {
      /* node has not been found, aliased file has been found, sets this as defined file reference */
      if (foundFileNode->set_declared_in (owner, name))
	{			/* foundFileNode::this_buildingData is not NIL */
	  foundFileNode->aliasWarning_ (name);
	  (*fileNode_res) = new FileNode (owner, newCstr_String (name), foundFileNode);	/* FN4 */
	  (*fileNode_res)->set_defined (foundFileNode);	/*fileNode_res ::this_buildingData is set equal to foundFileNode::this_buildingData */
	  register_staticFile (*fileNode_res, hashi);
	  return pk_true;
	}
      return pk_false;
    }
  /* neither node nor aliased file have  been found */
  (*fileNode_res) = new FileNode (owner, newCstr_String (name), filePathName);	/* FN5 */
  (*fileNode_res)->set_defined ();	/*fileNode_res ::this_buildingData is set equal to new BuildingData */
  register_hostFile (*fileNode_res, predecessor, hashi);
  return pk_true;
}

/* ======= directfile node:: file node
 * success: <curDirectFileNode> is not NIL, <curDirectFileNode>::this_buildingData is not NIL
 * failure:
*/
_PUBLIC_ boolean ContextTree::getIf_directFileDeclaration (ref2Context owner, char *name, boolean execIt, ref2DirectFileNode * curDirectFileNode)
{
  // fprintf(stderr, "DEBUG ContextTree::getIf_directFileDeclaration, name is %s\n", name);
  int
    hashi;
  ref2FileNode
    foundFileNode;
  char *
    filePathName;
  ref2ElementList
    predecessor;

  if (find_staticFile (name, &hashi, &foundFileNode))
    {
      if (foundFileNode->set_declared_in (owner, name))
	{			/* foundFileNode::this_buildingData is not NIL */
	  (*curDirectFileNode) = new DirectFileNode (owner, foundFileNode, execIt);	/* D1 */
	  register_constructive (*curDirectFileNode);
	  replace_file (name, foundFileNode, *curDirectFileNode, hashi);
	  return pk_true;
	}
      return pk_false;
    }
  if (find_aliasFile (name, &filePathName, &foundFileNode, &predecessor))
    {
      /* node has not been found, aliased file has been found, sets this as defined file reference */
      if (foundFileNode->set_declared_in (owner, name))
	{			/* foundFileNode::this_buildingData is not NIL */
	  (*curDirectFileNode) = new DirectFileNode (owner, foundFileNode, newCstr_String (name), execIt);	/* D2 */
	  register_constructive (*curDirectFileNode);
	  register_staticFile (*curDirectFileNode, hashi);
	  return pk_true;
	}
      return pk_false;
    }
  /* neither node nor aliased file have  been found */
  (*curDirectFileNode) = new DirectFileNode (owner, newCstr_String (name), filePathName, execIt);	/* D3 */
  register_hostFile (*curDirectFileNode, predecessor, hashi);
  register_constructive (*curDirectFileNode);
  return pk_true;
}

/* ======= formatted file node:: directfile node
 * success: <formattedFileNode_res> is not NIL, <formattedFileNode_res>::this_buildingData is not NIL
 * failure:
 */
_PUBLIC_
  boolean ContextTree::getIf_formattedFileDeclaration (ref2Context owner, char *name, boolean execIt,
						       char *breakCharList, char continuationChar, ref2FormattedFileNode * formattedFileNode_res)
{
  // fprintf(stderr, "DEBUG ContextTree::getIf_formattedFileDeclaration, name is %s\n", name);
  int
    hashi;
  ref2FileNode
    foundFileNode;
  char *
    filePathName;
  ref2ElementList
    predecessor;

  if (find_staticFile (name, &hashi, &foundFileNode))
    {
      if (foundFileNode->set_declared_in (owner, name))
	{			/* foundFileNode::this_buildingData is not NIL */
	  (*formattedFileNode_res) = new FormattedFileNode (owner, foundFileNode,	/* F1 */
							    execIt, breakCharList, continuationChar);
	  register_constructive (*formattedFileNode_res);
	  replace_file (name, foundFileNode, *formattedFileNode_res, hashi);
	  return pk_true;
	}
      return pk_false;
    }
  if (find_aliasFile (name, &filePathName, &foundFileNode, &predecessor))
    {
      /* node has not been found, aliased file has been found, sets this as defined file reference */
      if (foundFileNode->set_declared_in (owner, name))
	{			/* foundFileNode::this_buildingData is not NIL */
	  (*formattedFileNode_res) = new FormattedFileNode (owner, foundFileNode, newCstr_String (name),	/* F2 */
							    execIt, breakCharList, continuationChar);
	  register_constructive (*formattedFileNode_res);
	  register_staticFile (*formattedFileNode_res, hashi);
	  return pk_true;
	}
      return pk_false;
    }
  /* neither node nor aliased file have  been found */
  (*formattedFileNode_res) = new FormattedFileNode (owner, newCstr_String (name), filePathName,	/* F3 */
						    execIt, breakCharList, continuationChar);
  register_hostFile (*formattedFileNode_res, predecessor, hashi);
  register_constructive (*formattedFileNode_res);
  return pk_true;
}


/* ======= mkf file node:: file node
   <owner>
   <name> is expected to be a mkf file name
   success: file is found and readable its description is returned in <curMKFFileNode>
   failure: file is not found <isMissing> is set to pk_true
            errored file is found: <isMissing> remains unchanged
*/
_PUBLIC_ boolean ContextTree::getIf_mkfFileOccurrence (ref2Context owner, char *name, ref2MKFFileNode * curMKFFileNode, boolean * isMissing)
{
  // fprintf(stderr, "DEBUG ContextTree::getIf_mkfFileOccurrence, name is %s\n", name);
  int
    hashi;
  ref2FileNode
    resFileNode;
  boolean
    isMkf = pk_false;
  boolean
    lCorrect = pk_true;

  if (find_staticFile (name, &hashi, &resFileNode))
    {
      if (resFileNode->aliasToMkf (owner, name, &isMkf))
	{
	  if (isMkf)
	    {
	      (*curMKFFileNode) = (ref2MKFFileNode) resFileNode;
	      return pk_true;
	    }
	  (*curMKFFileNode) = new MKFFileNode (owner, resFileNode, &lCorrect, isMissing);	/* resFileNode is redirected to this */
	  replace_file (name, resFileNode, *curMKFFileNode, hashi);
	  return lCorrect;
	}
      return pk_false;
    }
  else
    {
      char *
	filePathName;
      ref2ElementList
	predecessor;
      if (find_aliasFile (name, &filePathName, &resFileNode, &predecessor))
	{
	  if (resFileNode->aliasToMkf (owner, name, &isMkf))
	    {
	      if (isMkf)
		{
		  (*curMKFFileNode) = new MKFFileNode ((ref2MKFFileNode) resFileNode, name, &lCorrect, isMissing);	/* resFileNode is redirected to this */
		  register_staticFile (*curMKFFileNode, hashi);
		  return lCorrect;
		}
	      (*curMKFFileNode) = new MKFFileNode (owner, resFileNode, name, &lCorrect, isMissing);	/* resFileNode is redirected to this */
	      register_staticFile (*curMKFFileNode, hashi);
	      return lCorrect;
	    }
	  return pk_false;
	}
      /* neither node nor aliased file have  been found */
      (*curMKFFileNode) = new MKFFileNode (owner, newCstr_String (name), filePathName, &lCorrect, isMissing);	/* PLG OK 4 */
      register_hostFile (*curMKFFileNode, predecessor, hashi);
      return lCorrect;
    }
  return pk_true;
}


/* ==========  ==========  ==========  ========== TITLE: DEPENDENCE CHECKING
 */
/* builds the well ordered list of nodes to be built/executed from constructive root node named makeRoot 
 *         root node belongs is one of these nodes or belongs to the first context refered to 
 * <force> is 1 (2) if building is required for this make root (and recursively its predecessors)
 * each of them is marked visited and not made
 * effective sorted list of nodes to build/execute is collected in the_constructiveNodes
 */
_PUBLIC_ boolean ContextTree::root_dependenceChecking (char *makeRoot, int force)
{
  ref2VariableNode
    varRoot;
  int
    hashi;

  fprintf (stderr, "DEBUG ContextTree::root_dependenceChecking(char*, int) makeRoot is %s\n", makeRoot);
  if (FIND_GLOBALVARIABLE (makeRoot, &hashi, &varRoot))
    {
      if (varRoot->set_rootUpdate (this_owner->getMKFFile (), force))
	return pk_true;
    }
  else
    {
      ref2FileNode
	fileRoot;
      int
	index;
      if (find_staticFile (makeRoot, &index, &fileRoot))
	{
	  if (fileRoot->set_rootUpdate (this_owner->getMKFFile (), force))
	    {
	      return pk_true;
	    }
	}
      else
	{
	  char *
	    filePathName;
	  ref2ElementList
	    predecessor;
	  if (find_aliasFile (makeRoot, &filePathName, &fileRoot, &predecessor))
	    return fileRoot->set_rootUpdate (this_owner->getMKFFile (), force);
	  LOG_LN_ERRO_STR_SP_STR_LN (makeRoot, "is neither a knowm variable nor a known file");
	}
    }
  return pk_false;
}				/* root_dependenceChecking */

/* builds the well ordered list of nodes to be built/executed  from these executable variables and direct files
 *          (listed in this constructor list attribute)
 * <force> is 1 (2) if building is required for all constructive nodes in the list (and recursively their predecessors)
 * each of listed nodes is marked visited
 * effective sorted list of nodes to build/execute is collected in the_constructiveNodes static attribute
 */
_PUBLIC_ boolean ContextTree::allLocalRoots_dependenceChecking (int force)
{
  boolean
    lCorrect = pk_true;
  ref2ElementList
    curProductiveNodeLst = GET_LOCALCONSTRUCTORS ();
  ref2NodeElement
    curProductiveNode;

  // fprintf(stderr, "DEBUG ContextTree::allRoots_dependenceChecking(int) \n");
  while (curProductiveNodeLst != NIL_ElementList)
    {
      curProductiveNode = (ref2NodeElement) (curProductiveNodeLst->content ());
      curProductiveNode->setReferredTo ();
      if (!(curProductiveNode->set_rootUpdate (this_owner->getMKFFile (), force)))
	lCorrect = pk_false;
      curProductiveNodeLst = curProductiveNodeLst->next ();
    }
  return lCorrect;
}

/* builds the well ordered list of nodes to be built/executed  from these executable variables and direct files
 *          (listed in this constructor list attribute)
 *          and recursively in these context files (listed in this context list attribute)
 * <force> is 1 (2) if building is required for all constructive nodes in the list (and recursively their predecessors)
 * each of listed nodes is marked visited
 * effective sorted list of nodes to build/execute is collected in the_constructiveNodes static attribute
 */
_PUBLIC_ boolean ContextTree::allRoots_dependenceChecking (int force)
{
  boolean
    lCorrect = pk_true;
  ref2ContextTreeList
    curContextTreeList = GET_IMPORTEDCONTEXTS ();
  ref2ContextTree
    curContextTree;

  // fprintf(stderr, "DEBUG ContextTree::allRoots_dependenceChecking(int) \n");
  this_owner->debugAnnounce ("CHECK context of");
  lCorrect = allLocalRoots_dependenceChecking (force);
  debugTabulation (3);
  while (curContextTreeList != NIL_ContextTreeList)
    {
      curContextTree = curContextTreeList->content ();
      if (!curContextTree->allRoots_dependenceChecking (force))
	lCorrect = pk_false;
      curContextTreeList = curContextTreeList->next ();
    }
  debugBackTabulation ();
  return lCorrect;
}				/* dependenceChecking */

/* ==========  ==========  ==========  ========== TITLE: NODE CONSTRUCTION
 */
/* Generates eligible direct nodes registered in firstConstructiveNode (up to a nil pointer)
 */
_PUBLIC_ boolean ContextTree::generate_constructiveNodeList ()
{
  boolean
    lCorrect = pk_true;
  ref2NodeElement
    curConstructiveNode;
  ref2ElementList
    curConstructiveNodeList = the_constructiveNodes;
  // fprintf(stderr, "DEBUG ContextTree::generate_constructiveNodeList\n");

  while (curConstructiveNodeList != NIL_ElementList)
    {
      curConstructiveNode = (ref2NodeElement) (curConstructiveNodeList->content ());
      if (!(curConstructiveNode->root_generate ()))
	lCorrect = pk_false;
      curConstructiveNodeList = curConstructiveNodeList->next ();
    }
  if (!lCorrect)
    LOG_LN_ERRO_STR_LN ("generate_constructiveNodeList failed");
  return lCorrect;
}

/* ==========  ==========  ==========  ========== TITLE: BUILDER
 */
/* creates and returns a new static root context associated to <aMKFFile> 
 * a new reader is created
 * this is static
 */
_PUBLIC_ ContextTree::ContextTree (ref2Context owner):Soundness ()
{
  INIT_LOCALDECLARATIONS ();
  INIT_LOCALCONSTRUCTORS ();
  INIT_IMPORTEDCONTEXTS ();
  linkToContext (owner);
}

_PUBLIC_ ContextTree::ContextTree ():Soundness ()
{
  INIT_LOCALDECLARATIONS ();
  INIT_LOCALCONSTRUCTORS ();
  INIT_IMPORTEDCONTEXTS ();
}

// ======================================================================================================================================================================
/*
 *
 * Static Elements
 *
 */
/* global list of nodes to be built or processed, sorted during dependence analysis*/

ref2ContextTree
  ContextTree::the_staticContextTree;
int
  ContextTree::the_elementNumber;
int
  ContextTree::the_constructiveNumber;
int
  ContextTree::the_passiveNumber;

ref2NodeManager
  ContextTree::the_argumentTable;
ref2NodeManager
  ContextTree::the_variableTable;
ref2NodeManager
  ContextTree::the_fileTable;
ref2NodeManager
  ContextTree::the_externTable;
ref2ElementList
  ContextTree::the_constructiveNodes;
ref2ElementList
  ContextTree::the_passiveNodes;

/* global list of nodes to be built or processed, sorted during dependence analysis*/

ref2ElementList
  ContextTree::the_linkedFileList;

_STATIC_ void
ContextTree::setStatic (int argTableSize, int varTableSize, int fileTableSize, int externTableSize)
{
  the_staticContextTree = new ContextTree ();
  the_elementNumber = 0;
  the_constructiveNumber = 0;
  the_passiveNumber = 0;
  the_argumentTable = new NodeManager (argTableSize);
  the_variableTable = new NodeManager (varTableSize);
  the_fileTable = new NodeManager (fileTableSize);
  the_externTable = new NodeManager (externTableSize);
  the_constructiveNodes = NIL_ElementList;
  the_passiveNodes = NIL_ElementList;
  the_linkedFileList = NIL_ElementList;
}

_STATIC_ int
ContextTree::new_elementNumber ()
{
  the_elementNumber = the_elementNumber + 1;
  return the_elementNumber;
}

_STATIC_ int
ContextTree::get_constructiveNodeNumber ()
{
  // fprintf(stderr,"DEBUG ContextTree::get_constructiveNodeNumber; this has %i constructive nodes\n",the_constructiveNumber);
  return the_constructiveNumber;
}

/* PLG 2006-01-17
 * <constructiveNode> is supposed to be not NIL
 * if this_MKFFileContext does not contain <constructiveNode>
 *       appends a new element containing <constructiveNode> at the end of  this_MKFFileContext
 */
_STATIC_ void
ContextTree::append_constructiveNode (ref2NodeElement constructiveNode)
{
  if (the_constructiveNodes == NIL_ElementList)
    {
      the_constructiveNodes = new ElementList (constructiveNode);
      the_constructiveNumber = 1;
    }
  else if (the_constructiveNodes->appendInSet (constructiveNode))
    the_constructiveNumber = the_constructiveNumber + 1;
}

_STATIC_ int
ContextTree::get_passiveNodeNumber ()
{
  // fprintf(stderr,"DEBUG ContextTree::get_passiveNodeNumber; this has %i passive nodes\n",the_passiveNumber);
  return the_passiveNumber;
}

/* PLG 2006-01-17
 * <passiveNode> is supposed to be not NIL
 * if this_MKFFileContext does not contain <passiveNode>
 *       appends a new element containing <passiveNode> at the end of  this_MKFFileContext
 */
_STATIC_ void
ContextTree::append_passiveNode (ref2NodeElement passiveNode)
{
  if (the_passiveNodes == NIL_ElementList)
    {
      the_passiveNodes = new ElementList (passiveNode);
      the_passiveNumber = 1;
    }
  else if (the_passiveNodes->appendInSet (passiveNode))
    the_passiveNumber = the_passiveNumber + 1;
}
