#define IS_TOBEBUILT() this_buildingRequired
#define SET_FILE_BUILT() this_buildingRequired = pk_false; SET_PROCESSED()

#define GENERATE_() ( this_buildingData->generate(this, this_fileToPrint) )
#define DO_INNER_() ( this_buildingData->do_innerConstructive(this_declarationContext, pk_true) )
/* a DirectFileNode can be redirected: its subclass is found in file node definition */

_PUBLIC_ _VIRTUAL_ const char *
DirectFileNode::myClassName ()
{
  return "DirectFileNode";
}

/* ========== Attributes
 */
/* ========== Log
 */
void
DirectFileNode::verboseExecAnnounce ()
{
  verboseAnnounce ("exec file");
}

void
DirectFileNode::verboseGenerateAnnounce ()
{
  // logDEBUG_formula_ln("DirectFileNode::verboseGenerateAnnounce file is");
  verboseAnnounce ("generate");
}

/* ========== Printer
 */

_VIRTUAL_ void
DirectFileNode::print_attributes_ln (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  printingContext->out_fileWriteContext_sp (outBuffer, this_isExecutable);
  outBuffer->line ();
}

/* ========== Reader
 */

/* ==========  ==========  Grapher
 */
/*
 * PLG 2008-06-13: this is safe and present, this_isDefined (implicit), this is not registered, standard visit
 * <comingFrom> is the most inner file (transitively) preceded by this
 * success: this not in a cyclic dependence, all referred to nodes are properly defined 
 *               this date is set to FUTURE
 *               this is set to be built
 *               this is registered as a building root
 *               this_stepIndex is set to the_stepIndex
 * failure: this is not safe, or this is host missing or this is not properly defined
 *          a cyclic dependence including this is found, this is not the cycle root
 *                sets <cycleRoot> to cycle root
 *          no cyclic dependence includes this, or this is the cycle root
 *                <cycleRoot> remains unchanged
 */
boolean
DirectFileNode::_visitIf_present_ (time_t contextTime, ref2NodeElement comingFrom, boolean * isToBeBuilt, ref2NodeElement * cycleRoot)
{
  // fprintf(stderr, "DEBUG DirectFileNode::_visitIf_present_ node is  %s \n", this_name);
  time_t updatedDate;
  if (_innerExplorationToDo_ln (cycleRoot))
    {
      /* this is safe and present, this_isDefined (implicit), this is not registered, this has ancestors, standard visit */
      if (reset_ancestor_constructive (contextTime, isToBeBuilt))
	return pk_true;
      /* this_stepIndex is smaller than the_stepIndex */
      updatedDate = GET_DATE ();
      if (_visit_standardUpdate (this, GET_DATE (), comingFrom, &updatedDate, isToBeBuilt, cycleRoot))
	{
	  if (!(*isToBeBuilt))
	    if (IS_strictlyOLDER_THAN (updatedDate))
	      {
		set_toBeBuilt ();
		(*isToBeBuilt) = pk_true;
	      }
	    else
	      return pk_true;
	  SET_FUTURE ();
	  register_constructiveNode ();
	  return pk_true;
	}
      return pk_false;
    }
  if (IS_SAFE ())
    {
      /* this is safe and present, this_isDefined (implicit), this is not registered, this is ancestor free, standard visit */
      if (reset_ancestorFree_constructive (contextTime, isToBeBuilt))
	return pk_true;
      /* this_stepIndex is smaller than the_stepIndex */
      set_actualCreator (this);
      if (IS_TOBEBUILT ())
	{
	  (*isToBeBuilt) = pk_true;
	  register_constructiveNode ();
	}
      return pk_true;
    }
  return pk_false;
}

/*
 * PLG 2008-06-13: this is safe and present, this_isDefined (implicit), this is not registered, building is forced
 * <comingFrom> is the most inner file (transitively) preceded by this
 * success: this not in a cyclic dependence, all referred to nodes are properly defined 
 *               this date is set to FUTURE
 *               this is set to be built
 *               this registered as a building root
 *               this_stepIndex is set to the_stepIndex
 * failure: this is not safe, or this is host missing or this is not properly defined
 *          a cyclic dependence including this is found, this is not the cycle root
 *                sets <cycleRoot> to cycle root
 *          no cyclic dependence includes this, or this is the cycle root
 *                <cycleRoot> remains unchanged
 */
_PRIVATE_ boolean DirectFileNode::_visitIf_present_toBeBuilt (ref2NodeElement comingFrom, ref2NodeElement * cycleRoot)
{
  // fprintf(stderr, "DEBUG DirectFileNode::_visitIf_present_toBeBuilt node is  %s \n", this_name);
  /* this is defined (=>this_buildingData is not NIL) */
  if (_innerExplorationToDo_ln (cycleRoot))
    {
      time_t
	updatedDate;
      if (IS_UPDATED ())
	{
	  /* is buildable, stated, consistent and has been visited or is being visited */
	  set_toBeBuilt ();
	  register_constructiveNode ();
	  return pk_true;
	}
      if (_visit_standard_toBeBuilt (this, comingFrom, &updatedDate, cycleRoot))
	{
	  if (IS_strictlyOLDER_THAN (updatedDate))
	    SET_FUTURE ();
	  register_constructiveNode ();
	  return pk_true;
	}
      return pk_false;
    }
  if (IS_SAFE ())
    {
      /* this is ancestor free */
      set_toBeBuilt ();
      register_constructiveNode ();
      return pk_true;
    }
  return pk_false;
}

/*
 * this is safe and missing
 * this_isDefined is pk_true 
 * this is not registered
 * <comingFrom> is the most inner file (transitively) preceded by this
 * success: this not in a cyclic dependence, all referred to nodes are properly defined 
 *               this date is set to FUTURE
 *               this is set to be built
 *               this is registered as a building root
 *               this_stepIndex is set to the_stepIndex
 * failure: this is not safe, or this is host missing or this is not properly defined
 *          a cyclic dependence including this is found, this is not the cycle root
 *                sets <cycleRoot> to cycle root
 *          no cyclic dependence includes this, or this is the cycle root
 *                <cycleRoot> remains unchanged
 */
_PRIVATE_ boolean DirectFileNode::_visitMessIf_missing_toBeBuilt (ref2NodeElement comingFrom, ref2NodeElement * cycleRoot)
{
  // fprintf(stderr, "DEBUG DirectFileNode::_visitMessIf_missing_toBeBuilt node is  %s \n", this_name);
  levelInfo_comment_missing_ln ();
  /* this is defined (=>this_buildingData is not NIL */
  if (_innerExplorationToDo_ln (cycleRoot))
    {
      time_t
	updatedDate;
      if (IS_UPDATED ())
	{
	  set_toBeBuilt ();
	  register_constructiveNode ();
	  return pk_true;
	}
      SET_FUTURE ();
      if (_visit_standard_toBeBuilt (this, comingFrom, &updatedDate, cycleRoot))
	{
	  register_constructiveNode ();
	  return pk_true;
	}
      return pk_false;
    }
  if (IS_SAFE ())
    {
      /* this is ancestor free */
      SET_FUTURE ();
      set_toBeBuilt ();
      register_constructiveNode ();
      return pk_true;
    }
  return pk_false;
}

/* PLG 2006-01-09
 * assumes this_buildingData not NIL when this is defined and safe
 * this node analysis is required by a presence inquiring dependence following an active link
 * <creator> is the most inner constructive node that precedes this
 * <comingFrom> is the most inner file (transitively) preceded by this
 * a safe DirectFileNode is not redirected and defined
 * success: this is safe and host present
 *               <isMissing> remains unchanged
 *          this is safe, not host present, defined, not in a cyclic dependence, all referred to nodes are properly defined 
 *               <isMissing> is set to pk_true
 *               this date is set to FUTURE
 *               this is set to be built
 *               this is registered as a building root if needed
 *               this_stepIndex is set to the_stepIndex
 * failure: this is not safe, or this is host missing or this is not properly defined
 *          a cyclic dependence including this is found, this is not the cycle root
 *                sets <cycleRoot> to cycle root
 *          no cyclic dependence includes this, or this is the cycle root
 *                <cycleRoot> remains unchanged
 */
_PUBLIC_
  _VIRTUAL_ boolean DirectFileNode::set_missingUpdate (ref2NodeElement creator, ref2NodeElement comingFrom,
						       boolean * isMissing, ref2NodeElement * cycleRoot)
{
  // fprintf(stderr, "DEBUG FileNode::set_missingUpdate name is %s, pathname is %s\n", this_name, this_filePathName);
  if (IS_SAFE ())
    {
      if (this_isPresent)
	{
	  levelInfo_comment_ref_date_ln ();
	  return pk_true;
	}
      (*isMissing) = pk_true;
      if (IS_REGISTERED ())
	{
	  levelInfo_comment_missing_ln ();
	  return pk_true;
	}
      return _visitMessIf_missing_toBeBuilt (comingFrom, cycleRoot);
      /* TRUE: registered as a building root */ }
  levelInfo_comment_ancestor_unsafe_ln ();
  return pk_false;
}

/* PLG 2006-01-09
 * assumes this_buildingData not NIL, when this is safe
 * <context_time> is the time of the file which building can be decided when looking at this
 * <comingFrom> is the node immediately preceded by this
 * a safe DirectFileNode is not redirected and defined
 * success: this is not in a cyclic dependence, all referred to nodes are properly defined 
 *          this_stepIndex is not smaller than the_stepIndex
 *             this_date is assigned to <updatedDate>
 *          this_stepIndex is smaller than the_stepIndex
 *             this is present
 *                this does not have newer ancestor file
 *                     this updated date is this_date
 *                this has newer ancestor file
 *                     this updated date is FUTURE
 *                     this is to be built is set to pk_true
 *             this is missing
 *                 this updated date is FUTURE
 *                 this is to be built is set to pk_true
 *             this updated date is assigned to this_date, <updatedDate>
 *             this_stepIndex is set to the_stepIndex
 *          <cycleRoot> remains unchanged
 * failure: this is not safe, or some referred to node is not properly defined or some missing file does not have definition
 *          a cyclic dependence including this is found, this is not the cycle root
 *                sets <cycleRoot> to cycle root
 *          no cyclic dependence includes this, or this is the cycle root
 *                <cycleRoot> remains unchanged
 *          <updatedDate> remains unchanged
 */
_PUBLIC_
  _VIRTUAL_ boolean DirectFileNode::set_intrinsicUpdate (time_t contextTime, ref2NodeElement comingFrom,
							 time_t * updatedDate, ref2NodeElement * cycleRoot)
{
  // fprintf(stderr, "DEBUG  DirectFileNode::set_intrinsicUpdate name is %s, pathname is %s\n", this_name, this_filePathName);
  if (IS_SAFE ())
    return _visitMessIf_intrinsicUpdate (contextTime, comingFrom, updatedDate, cycleRoot);
  levelInfo_comment_ancestor_unsafe_ln ();
  return pk_false;
}

/* PLG 2005-08-30 
 * assumes this defined, this_buildingData not NIL when this is safe
 * <creator> is the most inner constructive node that precedes this
 * <contextTime> is the time of the file which building can be decided when looking at this
 * <comingFrom> is the node immediately preceded by this
 * a safe DirectFileNode is not redirected and defined
 * success: updating dates have been computed for this node and its ancestors
 *          this is registered as a building root if needed
 * failure: this is set in error 
 *            this is cycle free
 *               <cycleRoot> remains unchanged
 *            this participates to a cycle
 *               <cycleRoot> is set to the root of this cycle
 * 
 */
_PUBLIC_
  _VIRTUAL_ boolean DirectFileNode::set_standardUpdate (ref2NodeElement creator, time_t contextTime, ref2NodeElement comingFrom,
							time_t * updatedDate, boolean * isToBeBuilt, ref2NodeElement * cycleRoot)
{
  // fprintf(stderr, "DEBUG  DirectFileNode::set_standardUpdate name is %s, pathname is %s\n", this_name, this_filePathName);
  if (IS_SAFE ())
    {
      if (IS_REGISTERED ())
	{
	  levelInfo_comment_presentAncestor_ln (contextTime);
	  (*updatedDate) = GET_DATE ();
	  return pk_true;
	}
      if (this_isPresent)
	{
	  levelInfo_comment_presentAncestor_ln (contextTime);
	  if (_visitIf_present_ (contextTime, comingFrom, isToBeBuilt, cycleRoot))
	    {
	      /* registered as a constructive node */
	      (*updatedDate) = GET_DATE ();
	      if (IS_TOBEBUILT ())
		(*isToBeBuilt) = pk_true;
	      return pk_true;
	    }
	  return pk_false;
	}
      (*updatedDate) = GET_FUTURE ();
      (*isToBeBuilt) = pk_true;
      return _visitMessIf_missing_toBeBuilt (comingFrom, cycleRoot);
      /* TRUE: registered as a building root */ }
  levelInfo_comment_ancestor_unsafe_ln ();
  return pk_false;
}

/*
 * assumes this defined, this_buildingData not NIL, when this is safe
 * context_time is the time of the file which building can be decided when looking at this
 * <comingFrom> is the node which some dependence immediately refers to this
 * assumes objects and missing files being either in error or defined 
 * a safe DirectFileNode is not redirected and defined
 * success: this is not in a cyclic dependence, all referred to nodes are properly defined 
 *          this is registered as a building root if needed
 *          <cycleRoot> remains unchanged
 * failure: some referred to node is not properly defined or some missing file does not have definition
 *          a cyclic dependence including this is found, this is not the cycle root
 *                sets <cycleRoot> to cycle root
 *          no cyclic dependence includes this, or this is the cycle root
 *                <cycleRoot> remains unchanged
 */
_PUBLIC_ _VIRTUAL_ boolean DirectFileNode::set_everUpdate (ref2NodeElement creator, ref2NodeElement comingFrom, ref2NodeElement * cycleRoot)
{
  // fprintf(stderr, "DEBUG DirectFileNode::set_everUpdate name is %s, pathname is %s\n", this_name, this_filePathName);
  if (IS_SAFE ())
    {
      if (IS_REGISTERED ())
	{
	  levelInfo_comment_ref_date_ln ();
	  return pk_true;
	}
      if (this_isPresent)
	{
	  levelInfo_comment_ref_date_ln ();
	  return _visitIf_present_toBeBuilt (comingFrom, cycleRoot);
	  /* TRUE: registered as a building root */ }
      return _visitMessIf_missing_toBeBuilt (comingFrom, cycleRoot);
      /* TRUE: registered as a building root */ }
  levelInfo_comment_ancestor_unsafe_ln ();
  return pk_false;
}

/*
 * assumes this defined, this_buildingData not NIL, when this is safe
 * context_time is the time of the file which building can be decided when looking at this
 * <comingFrom> is the node which some dependence immediately refers to this
 * assumes objects and missing files being either in error or defined 
 * a safe DirectFileNode is not redirected and defined
 * set this stated to pk_true
 * success: this is not in a cyclic dependence, all referred to nodes are properly defined 
 *          this is registered as a building root if needed
 *          <cycleRoot> remains unchanged
 * failure: some referred to node is not properly defined or some missing file does not have definition
 *          a cyclic dependence including this is found, this is not the cycle root
 *                sets <cycleRoot> to cycle root
 *          no cyclic dependence includes this, or this is the cycle root
 *                <cycleRoot> remains unchanged
 */
_PUBLIC_
  _VIRTUAL_ boolean DirectFileNode::set_recursiveEverUpdate (ref2NodeElement creator, ref2NodeElement comingFrom,
							     time_t * updatedDate, boolean * isToBeBuilt, ref2NodeElement * cycleRoot)
{
  // fprintf(stderr, "DEBUG DirectFileNode::set_recursiveEverUpdate name is %s, pathname is %s\n", this_name, this_filePathName);
  if (IS_SAFE ())
    {
      (*isToBeBuilt) = pk_true;
      if (_visitMessIf_buildable_recursiveEverUpdate (this, comingFrom, updatedDate, cycleRoot))
	{
	  if (!IS_REGISTERED ())
	    register_constructiveNode ();
	  return pk_true;
	}
      return pk_false;
    }
  levelInfo_comment_ancestor_unsafe_ln ();
  return pk_false;
}

/* this should be a direct file 
 * assumes this_buildingData not NIL when this is defined and safe
 * <force>: 0 this node is to be built if this recursively depends of some newer node
 * <force>: 1 this node is to be built whatever are its ancestor ages
 * <force>: 2 this node and recursively its ancestors have be built whatever are its ancestor age
 *             this recursivity ends on never dependence
 * assumes objects and missing files being either in error or defined 
 * a safe DirectFileNode is not redirected and defined
 * set this stated to pk_true
 * success: no cyclic dependence
 *          this is registered as a building root if needed
 * failure: if a cyclic dependence is found
 *          set this in error
 */
_PUBLIC_ _VIRTUAL_ boolean DirectFileNode::set_rootUpdate (ref2MKFFileNode comingFrom, int force)
{
  // fprintf(stderr, "DEBUG DirectFileNode::set_rootUpdate name is %s, pathname is %s\n", this_name, this_filePathName);
  if (IS_SAFE ())
    {
      ref2NodeElement
	cycleRoot = NIL_NodeElement;
      levelInfo_objectCategory_sp ("DIRECT FILE ROOT");
      if (force > 1)
	{
	  time_t
	    updatedDate;
	  if (_visitMessIf_buildable_recursiveEverUpdate (this, (ref2NodeElement) comingFrom, &updatedDate, &cycleRoot))
	    {
	      if (!IS_REGISTERED ())
		register_constructiveNode ();
	      return pk_true;
	    }
	  return pk_false;
	}
      if (IS_REGISTERED ())
	{
	  levelInfo_comment_ref_date_ln ();
	  return pk_true;
	}
      if (this_isPresent)
	{
	  boolean
	    isToBeBuilt = pk_false;
	  if (force == 1)
	    {
	      levelInfo_comment_ref_date_ln ();
	      return _visitIf_present_toBeBuilt ((ref2NodeElement) comingFrom, &cycleRoot);
	      /* TRUE: registered as a building root */ }
	  levelInfo_comment_presentAncestor_ln (GET_FUTURE ());
	  return _visitIf_present_ (GET_FUTURE (), (ref2NodeElement) comingFrom, &isToBeBuilt, &cycleRoot);
	  /* TRUE: registered as a building root */ }
      return _visitMessIf_missing_toBeBuilt ((ref2NodeElement) comingFrom, &cycleRoot);
      /* TRUE: registered as a building root */ }
  levelInfo_comment_ancestor_unsafe_ln ();
  return pk_false;
}

/* ========== Generator
 */
/* open a direct file that is being generated
 */
_VIRTUAL_ boolean
DirectFileNode::openGeneration ()
{
  boolean lCorrect = pk_true;
  if (IS_SAFE ())
    {
      this_fileToPrint = new NBuffer (1023, &lCorrect);
      if (lCorrect && this_fileToPrint->open (this_filePathName))
	return pk_true;
      delete this_fileToPrint;
      set_fatal ();
    }
  else
    OUPS_name ("unsafe direct file node", this_name);
  return pk_false;
}

/* close a direct file that has been generated
 */
void
DirectFileNode::closeGeneration ()
{
  this_fileToPrint->close ();
  delete this_fileToPrint;
}

/* ========== Generator
 */

/* assumes this not redirected 
 * success: this is safe, 
 *          this has not to be built
 *              <somethingToDo> remains unchanged
 *          this has to be built, this has a creator
 *              <somethingToDo> is set to pk_true
 * failure: this is not safe
 *          or this is safe, this has to be built, this does not have creator
 *          <somethingToDo> remains unchanged
 *          error message is printed
 */
boolean
DirectFileNode::_checkGenerator (boolean * _remainsToBoBuilt)
{
  // fprintf(stderr, "DEBUG _checkGenerator\n");
  if (IS_SAFE ())
    {
      if (IS_TOBEBUILT ())
	{
	  if (IS_PROCESSED ())
	    {
	      levelInfo_DefaultGeneration (pk_false, "already done");
	      (*_remainsToBoBuilt) = pk_false;
	    }
	  else
	    (*_remainsToBoBuilt) = pk_true;
	  return pk_true;
	}
      (*_remainsToBoBuilt) = pk_false;
      return pk_true;
    }
  else
    OUPS_name ("unsafe file node", this_name);
  return pk_false;
}

/* calls system for executing this file
 * stops and returns false if file execution failed (results is not 0)
*/
boolean
DirectFileNode::__execute ()
{
  // fprintf(stderr, "DEBUG DirectFileNode::execute this_name is <%s>\n", this_name);
  if (!(sysSetExecutable (this_filePathName)))
    {
      error_line_reference ("execution permission denied");
      return pk_false;
    }
  verboseExecAnnounce ();
  if (sysExec (this_filePathName))
    return pk_true;
  error_line_reference ("execution failed");
  return pk_false;
}

/* assumes safe and defined, this_buildingData not NIL, this not processed, this to be built
*/
boolean
DirectFileNode::generate_file ()
{
  verboseGenerateAnnounce ();
  SET_FILE_BUILT ();
  if (DO_INNER_ ())
    if (openGeneration ())
      {
	if (GENERATE_ ())
	  {
	    closeGeneration ();
	    return pk_true;
	  }
	closeGeneration ();
      }
  return pk_false;
}

/* 2005-08-26
 * assumes this_buildingData not NIL when this is safe
 * this method is called when this is a never modality ancestor of a constructive node 
 * success: this safe and 
 *              this is executable, this construction/execution is required and correctly done
 *              this is not executable, this construction is required and correctly done
 *              this construction/execution is no more required 
 * failure: this is in error
 *          or this execution is required and
 *                this is executable and execution failed
 *                or this is not executable
 */
_VIRTUAL_ boolean
DirectFileNode::nested_requiredConstructive ()
{
  // fprintf(stderr, "DEBUG DirectFileNode::nested_requiredConstructive this_name is <%s>\n", this_name);
  boolean remainsToBoBuilt;
  if (_checkGenerator (&remainsToBoBuilt))
    {
      if (remainsToBoBuilt)
	{
	  if (generate_file ())
	    {
	      if (this_isExecutable)
		{
		  return __execute ();
		}
	      return pk_true;
	    }
	  return pk_false;
	}
      return pk_true;
    }
  return pk_false;
}

/* assumes safe and defined, this_buildingData not NIL
 * calls system for executing the commandString
 * stops and returns false if command execution failed (results is not 0)
*/
_VIRTUAL_ boolean
DirectFileNode::execute (ref2NodeElement curExecutedNode)
{
  return nested_requiredConstructive ();
}

/*
 * on the fly generation of a not constructive file construction commands when building curBuiltFile
 * a not constructive file cannot be a generation root
 * curBuiltFile is the nearest file that depends on this
 */
_VIRTUAL_ boolean
DirectFileNode::generate (ref2NodeElement curBuiltFile, ref2Buffer fileToPrint)
{
  return nested_requiredConstructive ();
}

/* do_innerConstructive generates this directfile
 */
_VIRTUAL_ boolean
DirectFileNode::do_innerConstructive (boolean activeDependence)
{
  return nested_requiredConstructive ();
}

/* assumes safe and defined, this_buildingData not NIL
 * writes this if it has not been previously written and
 *        IS_TOBEBUILT is pk_true (main content is used)
 *        IS_TOBEBUILT is false but conditionnal is pk_true (default content is used)
 */
_VIRTUAL_ boolean
DirectFileNode::root_generate ()
{
  // fprintf(stderr, "DEBUG DirectFileNode::root_generate this_name is <%s>\n", this_name);
  return nested_requiredConstructive ();
}

/* ========== Builder
 */
/* 
 */
_PUBLIC_ _VIRTUAL_ boolean DirectFileNode::aliasToMkf (ref2Context readingContext, char *name, boolean * isMkf)
{
  return pk_false;
}

/* PLG 2005-09-07
 * cloning a reference to get a declaration
 * <readingContext> is not NIL (not checked)
 *     this and prevNode have the same name and the same host name
 *     <prevNode> is not defined
 *     this is used as declaration
 *     <execIt> is pk_true if this is executable
 * 
 * sets this defined, initializes corresponding attributes
 * sets <prevNode> redirected to this
 * initial date is <prevNode> initial date
 * replaces <prevNode> by this in adressing actions
 * F1: USED TO INIT FormattedFileNode(ref2Context readingContext, ref2FileNode prevNode, int hashi, ...
 * D1: used in ContextTree::getIf_directFileDeclaration
 */
_PUBLIC_ DirectFileNode::DirectFileNode (ref2Context readingContext, ref2FileNode prevNode, boolean execIt)	/* D1 */
:FileNode (readingContext, prevNode)	/* FN3 */
{
  set_defined (prevNode);	/* set this_buildingData equal to prevNode::this_buildingData */
  this_isWritable = pk_true;
  if (execIt)
    this_isExecutable = pk_true;
  this_fileToPrint = NIL_Buffer;
}

/* PLG 2005-09-07
 * <readingContext> is not NIL (not checked)
 *     this and prevNode have distinct name but refer to the same host file
 *     <prevNode> is not defined
 *     this is used as declaration
 *     <execIt> is pk_true if this is executable
 *
 * sets this defined, initializes corresponding attributes
 * sets <prevNode> redirected to this
 * initial date is <prevNode> initial date
 * F2: USED TO INIT FormattedFileNode(ref2Context readingContext, int hashi, char * name, ref2FileNode prevNode, ...
 * D2: used in ContextTree::getIf_directFileDeclaration
 */
_PUBLIC_ DirectFileNode::DirectFileNode (ref2Context readingContext, ref2FileNode prevNode, char *name, boolean execIt)	/* D2 */
  :
FileNode (readingContext, name, prevNode)	/* FN4 */
{
  prevNode->aliasWarning_ (name);
  set_defined (prevNode);	/* set this_buildingData equal to prevNode::this_buildingData */
  this_isWritable = pk_true;
  if (execIt)
    this_isExecutable = pk_true;
  this_fileToPrint = NIL_Buffer;
}


/* PLG 2005-09-07
 * <readingContext> is not NIL (not checked)
 *     this is the first occurrence of host file <fullFileName>)
 *     this is the (unique) declaration descriptor
 *     this is the unique reference and declaration descriptor node named <name>
 *
 * sets this defined, initializes corresponding attributes
 * initial date is host file modification date if host file exists
 * initial date is APOCALYPSE if host file doesn't exist
 * registers this as file
 * F3: USED TO INIT FormattedFileNode(ref2Context readingContext, int hashi, char * name, char * filePathName, ...
 * D3: used in ContextTree::getIf_directFileDeclaration
 */
_PUBLIC_ DirectFileNode::DirectFileNode (ref2Context readingContext, char *name, char *filePathName, boolean execIt)	/* D3 */
  :
FileNode (readingContext, name, filePathName)	/* FN5 */
{
  set_defined ();		/* set this_buildingData equal to new BuildingData  */
  this_isWritable = pk_true;
  if (execIt)
    this_isExecutable = pk_true;
  this_fileToPrint = NIL_Buffer;
}
