_PUBLIC_
/* ========== Attributes
 */
_VIRTUAL_ const char *
ElementFunctionCall::myClassName ()
{
  return "ElementFunctionCall";
}

/* ========== Writer
 */

/* ========== Set
 */

/* ========== Printer
 */

/* ========== Reader
 */

/* ========== Generator
 */
/* runs this call
 */
boolean
ElementFunctionCall::call (ref2Context callingContext, ref2FunctionElement client)
{
  // logDEBUG_in("call to element function", this_functionName);
  // logDEBUG_actualParameters();
  if (IS_SAFE ())
    {
      if (this_linkedFunction != NIL_ElementFunctionElement)
	{
	  boolean lCorrect = pk_true;
	  boolean hasEmptyList;
	  if (setIterate (&lCorrect, &hasEmptyList))
	    {
	      if (hasEmptyList)
		return pk_true;
	      if (this_linkedFunction->call_iteration (callingContext, (ref2IteratorContext) this_readingContext, these_actualParameters, &lCorrect))
		return pk_true;
	      return lCorrect;
	    }
	  if (lCorrect)
	    return this_linkedFunction->single_call (callingContext, these_actualParameters);
	}
    }
  return pk_false;
}

/* ========== Grapher
 */

/* ========== Builder
 */

/* creates a new node function call
 * function call is to be read in <inBuffer> provided by <aContext>
 * terminates on not space character following function call closing mark
 * if outBuffer is not NIL_IntePrinter, call is printed in outBuffer
 * if mainLevel is pk_true, node decl opening and closing are printed during possible log 
 */
ElementFunctionCall::ElementFunctionCall (ref2Context aContext, char *name, ref2ArgumentList comments, ref2ElementFunctionElement linkedFunction, ref2ArgumentList actualParameters, boolean * correct):FunctionCall (aContext, name,
	      actualParameters)
{
  // fprintf(stderr, "DEBUG ElementFunctionCall::ElementFunctionCall ref2Context\n");
  these_comments = comments;
  this_linkedFunction = linkedFunction;
}

/* creates a new node function call
 * function call is to be read in <inBuffer> provided by <aContext>
 * terminates on not space character following function call closing mark
 * if outBuffer is not NIL_IntePrinter, call is printed in outBuffer
 * if mainLevel is pk_true, node decl opening and closing are printed during possible log 
 */
ElementFunctionCall::ElementFunctionCall (ref2IteratorContext aContext, char *name,
					  ref2ArgumentList comments, ref2ElementFunctionElement linkedFunction,
					  ref2ArgumentList actualParameters, boolean * correct):
FunctionCall (aContext, name, actualParameters)
{
  // fprintf(stderr, "DEBUG ElementFunctionCall::ElementFunctionCall ref2IteratorContext\n");
  these_comments = comments;
  this_linkedFunction = linkedFunction;
}
