/* TODO 
 */
_PUBLIC_ _VIRTUAL_ const char *
ElementFunctionElement::myClassName ()
{
  return "ElementFunctionElement";
}

/* ========== Attributes
 */

_PUBLIC_ _VIRTUAL_ boolean ElementFunctionElement::isElementFunctionElement ()
{
  return pk_true;
}

/* ========== Writer
 */

/* prints nothing: node is implicit 
 */
_VIRTUAL_ void
ElementFunctionElement::print_type_sp (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  printingContext->out_nodeType_sp (outBuffer);
}

_VIRTUAL_ void
ElementFunctionElement::print_declBody (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  this_innerContext->print (outBuffer);
}

/* detailss in <outBuffer> file this context and local declarations
 * <outBuffer> is not NIL_IntePrinter
 */
_VIRTUAL_ void
ElementFunctionElement::logDebug_declBody (int level)
{
  this_innerContext->logDebug (level);
}

/* ========== Log
 */

/* ========== Set
 */

/* ========== Printer
 */

/* ========== Reader
 */


/* 2005-04-04
 * reads a new node function body
 * success: cursor starts [inner_NODE_GENERATOR_fSp+] [eol]#'}:'
 *          where
 *             [inner_NODE_GENERATOR] ::= '{' [fileSpace*] [_NODE_GENERATOR_fSp] '}' 
 *          cursor is moved to '}:'
 * failure: a syntax or context error has occurred in [Character*]
 *             cursor starts [Character*] '}:', '{' '}' are well balanced in [Character*]
 *               cursor is moved to '}:'
 *             cursor starts [Character*] [EOF], '{' '}' are well balanced in [Character*]
 *               cursor is moved to [EOF]
 *             error message is printed
 */
_VIRTUAL_ boolean
ElementFunctionElement::read_declBody_fSpStar_nSp ()
{
  // this_innerContext->log_ASDEBUG("entering ElementFunctionElement::read_declBody_fSpStar_");
  return ((ref2MetaContext) this_innerContext)->starRead_genericElement_fSpStar_nSp ();
}

/* ========== Generator
 */

/* generates a node from this
 * <callingContext> is not NIL (not checked)
 * parameterValues attribute is previously set as actual list of strings
 * failure: 
 */
boolean
ElementFunctionElement::single_call (ref2Context callingContext, ref2ArgumentList parameterValues)
{
  // logDEBUG_in("single_call to element function", this_name);
  // logDEBUG_in("----------------------------- parameterValues is");
  /* DEBUG  parameterValues->log_formula_(pk_false); DEBUG */
  if (IS_SAFE ())
    return this_innerContext->build_instance_in (callingContext, parameterValues);
  return pk_false;
}

/* builds a new node list (NNL)
 * <iteratorContext> is not NIL (not checked)
 * iterator is a singleton associated with a string list type Context variable or parameter declaration D
 * if actual string list ISL associated with D is empty does not build any node
 * if string list ISL holds n(>0) actual values ISL[1]...ISL[n]
 *     node list NNL has n elements 
 *     NNL[i] is the node resulting of this function call
 *         when parameterValues elements are expanded while declaration D holds ISL[i]
 * failure:
 *     iteratorList value is NIL_ArgumentList
 *       <correct> remains unchanged
 *     an error occurred when calling the function
 *       <correct> is set to false
 *     returns pk_false;
 */
_PRIVATE_
  boolean ElementFunctionElement::iterate_singleCall (ref2Context callingContext, ref2IteratorContext iteratorContext,
						      ref2ArgumentList parameterValues, ref2IdentifierList iteratorList, boolean * correct)
{
  // logDEBUG_in("iterate_singleCall to element function", this_name);
  // logDEBUG_in("----------------------------- parameterValues is");
  /* DEBUG parameterValues->log_formula_(pk_false); DEBUG */
  // logDEBUG_in("----------------------------- iteratorList is");
  /* DEBUG iteratorList->log_formula_(); DEBUG */
  // logDEBUG_in("-----------------------------");
  if (iteratorList->downThisCurrentList (correct))
    {
      while (single_call (callingContext, parameterValues))
	{
	  if (!iteratorList->stepThisCurrentList ())
	    {
	      return pk_true;
	    }
	}
      (*correct) = pk_false;
    }
  return pk_false;
}

/* expands actual parameter values and assign them to formal parameters
 * iteratively creates nodes
 * failure:
 *     some iterator value is NIL_ArgumentList
 *       <correct> remains unchanged
 *     an error occurred when calling the function
 *       <correct> is set to false
 *     returns pk_false;
 */
_PRIVATE_
  boolean ElementFunctionElement::innerCall_iteration (ref2Context callingContext, ref2IteratorContext iteratorContext,
						       ref2ArgumentList parameterValues, ref2IdentifierList iteratorList, boolean * correct)
{
  // logDEBUG_in("innerCall_iteration 1 to element function", this_name);
  /* DEBUG parameterValues->log_formula_(pk_false); END DEBUG */
  ref2IdentifierList
    innerIterator = iteratorList->next ();
  if (innerIterator == NIL_IdentifierList)
    {
      return iterate_singleCall (callingContext, iteratorContext, parameterValues, iteratorList, correct);
    }
  if (iteratorList->downThisCurrentList (correct))
    {
      if (innerCall_iteration (callingContext, iteratorContext, parameterValues, innerIterator, correct))
	{
	  while (iteratorList->stepThisCurrentList ())
	    {
	      if (!innerCall_iteration (callingContext, iteratorContext, parameterValues, innerIterator, correct))
		return pk_false;
	    }
	  return pk_true;
	}
    }
  return pk_false;
}

/* expands actual parameter values and assign them to formal parameters
 * iteratively creates nodes
 * failure: this not empty GenericElementList attribute is not a correct ancestor generator
 *               error message is printed
 */
_PUBLIC_
  boolean ElementFunctionElement::call_iteration (ref2Context callingContext, ref2IteratorContext iteratorContext, ref2ArgumentList parameterValues,
						  boolean * correct)
{
  // logDEBUG_in("call_iteration 2 to element function", this_name);
  /* DEBUG  parameterValues->log_formula_(pk_false); END DEBUG */
  ref2IdentifierList
    theseIterators = ((ref2DynamicContext) iteratorContext)->get_identifierList ();
  if (theseIterators != NIL_IdentifierList)
    return innerCall_iteration (callingContext, iteratorContext, parameterValues, theseIterators, correct);
  (*correct) = pk_false;
  return pk_false;
}

/* ========== Builder
 */

/* 2004-12-31 syntax OK
 * creates and returns a new node function descriptor named <name>
 * <embeddingContext> is not NIL
 * <embeddingContext> is the context in which this declaration occurs
 * <innerContext> is the new internal context
 * <comments> are comments associated with this declaration
 * success: cursor starts  .[inner_NODE_GENERATOR_fSp+] #'}:'
 *          where
 *             [inner_NODE_GENERATOR] ::= '{' [fileSpace*] [_NODE_GENERATOR_fSp] '}' 
 *             [_NODE_GENERATOR] ::= opt{[ITERATOR_fSpStar]} [NODE_CALL_fSp] 
 *             [_NODE_GENERATOR] ::= [_NODE_EQUATION]
 *          <correct> remains unchanged
 *          cursor is moved to '}:'
 * failure: an error occurs
 *          error message is printed
 *          <correct> is set to false
 */
ElementFunctionElement::ElementFunctionElement (ref2Context owner_context, char *name, ref2DynamicContext innerContext, ref2ArgumentList comments):FunctionElement (owner_context, name, innerContext,
		 comments)
{
}
