
/* ==========  ==========  ==========  ========== TITLE: printing 
/* ==========  ==========  ==========  ========== TITLE: printing in log
 */
/* 2004-09-20
 * prints <anElement> full reference (name + index) in the log buffer, preceded by comment tag if asComment is pk_true
 */

_PROTECTED_ void
ElementReporting::log_innerRef_sp (int number, int ownerNumber)
{
  (LOGFILE ())->put_innerRef_sp (number, ownerNumber);
}

_PROTECTED_ void
ElementReporting::log_status_sp ()
{
  if (!(IS_SAFE ()))
    LOG_STR_SP ("*** in error");
}

_PROTECTED_ _VIRTUAL_ void
ElementReporting::log_name_sp ()
{
}

_PROTECTED_ _VIRTUAL_ void
ElementReporting::log_innerRef_sp ()
{
}

_PROTECTED_ void
ElementReporting::log_fullReference_sp ()
{
  log_innerRef_sp ();
  log_name_sp ();
  log_status_sp ();
}


_PUBLIC_ void
ElementReporting::log_fullReference_ln ()
{
  log_fullReference_sp ();
  log_ln ();
}

/* 2004-09-20
 * prints <anElement> full reference (name + index) followed by eol in the log buffer
 */
_PUBLIC_ void
ElementReporting::log_comment_Reference_ln ()
{
  log_commentItem_sp ();	/* "; --:: " */
  log_fullReference_ln ();
}


_VIRTUAL_ void
ElementReporting::log_outerName_ln ()
{
  log_name_sp ();
  log_ln ();
}

/* ==========  ==========  ==========  ========== TITLE: INFO
 */

/* prints object standard attributes: empty
 */
_PUBLIC_ void
ElementReporting::log_ln_INFO_ref__ln (const char *mess)
{
  log_ln_INFO_sp ();
  log_fullReference_sp ();
  log_str_sp_str_ln ("==>", mess);
}

_PROTECTED_ boolean ElementReporting::levelInfo_comment_ref_sp ()
{
  if (ISDEBUG ())
    {
      LOG_COMMENT_SP ();
      log_fullReference_sp ();
      return pk_true;
    }
  return pk_false;
}

void
ElementReporting::levelInfo_comment_ref_sp__ln (const char *mess)
{
  if (levelInfo_comment_ref_sp ())
    LOG_STR_LN (mess);
}

_PROTECTED_ void
ElementReporting::debug_declHeader_ln (const char *mess)
{
  if (ISDEBUG ())
    {
      /* appends  'eol'';''spc''--:' 'spc'<mess>'spc' <this_name>'eol' */
      LOG_LN_COMMENTITEM_STR_SP (mess);
      log_name_sp ();
      log_ln ();
    }
}

void
ElementReporting::verboseAnnounce (const char *text)
{
  if (ISLVERBOSE ())
    {
      if (ISDEBUG ())
	{
	  if (ISLDEBUG ())
	    log_ln_INFO_ref__ln (text);
	  else
	    {
	      /* appends  'eol'';''spc''--:''spc' <text> 'eol' */
	      LOG_LN_COMMENTITEM_STR_LN (text);
	    }
	  log_fullReference_ln ();
	}
      else
	{
	  /* appends  'eol'';''spc''--:' 'spc'<text>'spc' */
	  LOG_LN_COMMENTITEM_STR_SP (text);
	  log_outerName_ln ();
	}
    }
}

/* ==========  ==========  ==========  ========== TITLE: WARNING
 */
/* ==========  ==========  ==========  ========== TITLE: ERROR
 */
void
ElementReporting::error_line_reference (const char *mess)
{
  LOG_LN_ERRO_STR_SP (mess);
  log_fullReference_ln ();
  set_error ();
}

void
ElementReporting::error_line_reference (const char *mess1, const char *mess2)
{
  LOG_LN_ERRO_STR_SP_STR_SP (mess1, mess2);
  log_fullReference_ln ();
  set_error ();
}

void
ElementReporting::error_missingIdentifier (const char *category, const char *CString_name)	/* Element::NodeElement::VariableNode */
{
  LOG_LN_ERRO_STR_SP ("missing declaration for ");
  LOG_STR_SP_STR_LN (category, CString_name);
  set_error ();
}

void
ElementReporting::error_constructiveVariable (const char *CString_name)	/* Element::NodeElement::VariableNode */
{
  error_ln_ (CString_name, " is not a constructive variable (exec)");
}

void
ElementReporting::error_constructiveFile (const char *CString_name)	/* Element::NodeElement::FileNode */
{
  error_ln_ (CString_name, " is not a constructive file (write or exec)");
}

/* ==========  ==========  ==========  ========== TITLE: FATAL
 */
void
ElementReporting::fatal_line_reference (const char *mess)
{
  LOG_LN_ERRO_STR_SP (mess);
  log_fullReference_ln ();
  set_fatal ();
}

/* ==========  ==========  ==========  ========== TITLE: DEBUG
 */

_PUBLIC_ _VIRTUAL_ void
ElementReporting::logDebug_comment (int level)
{
}

_PUBLIC_ _VIRTUAL_ void
ElementReporting::logExtendedDebug_formula_ln (int level)
{
  logDebug_declOpening (level);
  logDebug_declHeader (level);
  logDebug_declBody (level);
  log_ln ();
}

/* prints object standard attributes: empty
 */
void
ElementReporting::logDebug_declOpening (int level)
{
  logDebug_objAnnounce_ln (level);
  logDebug_comment (level);
}

/* prints object standard header: "{ <NAME>" <exec/write/cond attributes>
 */
_PROTECTED_ _VIRTUAL_ void
ElementReporting::print_declHeader (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
}

/* prints object standard header: "{ <NAME>" <exec/write/cond attributes>
 */
void
ElementReporting::logDebug_declHeader (int level)
{
  log_subTitle_ln (level, "this header is");
  print_declHeader (LOGMARKS (), LOGFILE ());
}

/* prints object standard body: empty
 */
_VIRTUAL_ void
ElementReporting::logDebug_declBody (int level)
{
}

/* 2004-09-20
 * prints <mess> in a new DEBUG line
 */
_PUBLIC_ void
ElementReporting::logDebug_element_ln ()
{
  log_fullReference_sp ();
  logExtendedDebug_formula_ln (0);
}

/* ==========  ==========  ==========  ========== TITLE: DEBUG NodeElement
 */

_PROTECTED_ void
ElementReporting::log_releaseDate_sp (time_t date)
{
  (LOGFILE ())->put_releaseDate_sp (date);
}

_PROTECTED_ void
ElementReporting::levelInfo_MainGeneration (boolean somethingToDo)
{
  if (ISDEBUG ())
    {
      LOG_COMMENT_SP ();
      log_fullReference_sp ();
      if (somethingToDo)
	log_str_ln ("BUILD action");
      else
	log_str_ln ("empty BUILD action");
    }
}

void
ElementReporting::levelInfo_DefaultGeneration (boolean somethingToDo, const char *mess)
{
  if (ISDEBUG ())
    {
      LOG_COMMENT_SP ();
      log_fullReference_sp ();
      if (somethingToDo)
	log_str_ln (mess);
      else
	{
	  LOG_STR_SP_STR_LN (mess, "empty DEFAULT action");
	}
    }
}

void
ElementReporting::levelInfo_ObjectToBuild ()
{
  if (ISDEBUG ())
    {
      LOG_LN_COMMENT_STR_SP ("+++ build object");
      log_fullReference_ln ();
    }
}

void
ElementReporting::levelInfo_shouldBeDone ()
{
  if (ISDEBUG ())
    {
      LOG_LN_COMMENT_STR_SP ("--- is not yet processed");
      log_fullReference_ln ();
    }
}

void
ElementReporting::levelInfo_objectCategory_sp (const char *category)
{
  if (ISDEBUG ())
    {
      /* appends  'eol'';''spc''--:''spc' <category>'spc' */
      LOG_LN_COMMENTITEM_STR_SP (category);
    }
}

_VIRTUAL_ void
ElementReporting::log_date_sp ()
{
}


/* PLG 2005-08-31
 * this is supposed to be safe
 * prints commented ancestor reference
 */
boolean
ElementReporting::levelInfo_comment_ref_date_sp ()
{
  if (levelInfo_comment_ref_sp ())
    log_date_sp ();
  return pk_true;
}

/* PLG 2005-08-31
 * this is supposed to be safe
 * prints commented ancestor reference
 */
void
ElementReporting::levelInfo_comment_ref_date_ln ()
{
  if (levelInfo_comment_ref_sp ())
    {
      log_date_sp ();
      LOG_LN ();
    }
}

/* error message is printed
 * sets this in fatal error
 */
void
ElementReporting::fatal_reflexive ()
{
  fatal_line_reference ("dependence: self reference to ");
}

/* error message is printed
 * sets this in fatal error
 */
void
ElementReporting::fatal_cycle ()
{
  fatal_line_reference ("dependence: a cycle contains");
}

/* ==========  ==========  ==========  ========== END: DEBUG NodeElement
 */
