/*  this_declarationContext is never NIL */
/* ==========  ==========  ==========  ========== TITLE: these attributes
 */

_VIRTUAL_ const char *
Element::myClassName ()
{
  return "Element";
}

/* ========== Attributes
 */
_PUBLIC_ _VIRTUAL_ boolean Element::isUserStringFunctionElement ()
{
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean Element::isUserListFunctionElement ()
{
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean Element::isAncestorFunctionElement ()
{
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean Element::isElementFunctionElement ()
{
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean Element::isArgumentElement ()
{
  return pk_false;
}

/* returns obj positive number
 */
_PUBLIC_ int
Element::get_number ()
{
  return this_number;
}

_PUBLIC_ void
Element::setComments (ref2ArgumentList comments)
{
  these_commentLines = comments;
}

/* 
 * sets this_declarationContext as readingContext
 * if readingContext is NIL 
 *    error message is printed
 */
_PROTECTED_ void
Element::setContext (ref2Context readingContext)
{
  if (readingContext == NIL_Context)
    {
      OUPS ("Illegal empty argument in Element::setContext");
      this_declarationContext = Context::the_staticContext;
    }
  else
    this_declarationContext = readingContext;
}


/* returns obj name
 */
_PUBLIC_ const char *
Element::get_name ()
{
  return this_name;
}


/* returns pk_true if 
 */
_PUBLIC_ boolean Element::isNamed (char *aName)
{
  if (strcmp (aName, this_name) == 0)
    return pk_true;
  return pk_false;
}

/* returns pk_true if anObject is in error
 */
_PUBLIC_ boolean Element::isInError ()
{
  return !(IS_SAFE ());
}

/* returns pk_true if anObject is in error
 */
_PUBLIC_ boolean Element::isReferredTo ()
{
  return this_isUsed;
}

/* set anObject in error
 */
_PUBLIC_ void
Element::setReferredTo ()
{
  this_isUsed = pk_true;
}


/* returns this owner
 */
_PUBLIC_ boolean Element::has_owner (ref2Context aContext)
{
  return (this_declarationContext == aContext);
}

/* if this has an owner returns this owner number
   else returns -1
 */
_PUBLIC_ int
Element::get_ownerNumber ()
{
  return this_declarationContext->get_ownerNumber ();
}

/* if this has an owner returns this owner number
   else returns -1
 */
_PUBLIC_ ref2Context Element::get_context ()
{
  return this_declarationContext;
}

/* ==========  ==========  ==========  ========== TITLE: PRINTING
 */

/* prints object standard name: its label
 */
_PUBLIC_ _VIRTUAL_ void
Element::print_nameValue_sp (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  outBuffer->space (this_name);
}

/* prints object standard attributes: empty
 */
_PROTECTED_ _VIRTUAL_ void
Element::print_attributes_ln (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  outBuffer->line ();
}

/* prints object standard header: "{ <NAME>" <exec/write/cond attributes>
 */
_PROTECTED_ _VIRTUAL_ void
Element::print_declHeader (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  print_nameValue_sp (printingContext, outBuffer);
  print_attributes_ln (printingContext, outBuffer);
}

/* prints object standard body: empty
 */
_PROTECTED_ _VIRTUAL_ void
Element::print_declBody (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
}

/* prints object standard completion: "}" on a new line
 */
_PROTECTED_ _VIRTUAL_ void
Element::print_declCompletion (ref2IntePrinter outBuffer)
{
  outBuffer->put_ln_declClosing_ln ();
  outBuffer->line (1);
}

_PUBLIC_ void
Element::print (ref2Lexical printingContext, ref2IntePrinter outBuffer, boolean actual)
{
  outBuffer->put_ln_declOpening_sp ();	// <outBuffer> = PREFIX . 'eol' '{' ' '
  if (these_commentLines != NIL_ArgumentList)
    {
      these_commentLines->print_commentList (printingContext, outBuffer, actual);
      outBuffer->line ();
    }
  print_declHeader (printingContext, outBuffer);
  print_declBody (printingContext, outBuffer);
  print_declCompletion (outBuffer);
}

/* ==========  ==========  ==========  ========== TITLE: LOG
 */

_PUBLIC_ _VIRTUAL_ void
Element::log_name_sp ()
{
  log_str_sp (this_name);
}

_PROTECTED_ _VIRTUAL_ void
Element::log_innerRef_sp ()
{
  ElementReporting::log_innerRef_sp (this_number, this_declarationContext->get_ownerNumber ());
}

/* prints object standard attributes: empty
 */
_VIRTUAL_ void
Element::logDebug_comment (int level)
{
  if (these_commentLines == NIL_ArgumentList)
    log_NILComponent_ln (level, "comment");
  else
    {
      log_spn_str_ln (level, "these comment lines are");
      these_commentLines->logExtendedDebug_formula_ln (level + 1);
    }
}

/* ==========  ==========  ==========  ========== TITLE: INFO
 */

/* ==========  ==========  ==========  ========== TITLE: LEVEL INFO
 */

/* ==========  ==========  ==========  ========== TITLE: LEVEL INFO OR PRINTING
 */

/* ========== Set
 */
/* ========== Printer
 */

/* ========== Reader
 */

/* ========== Grapher
 */

/* ========== Builder
 */
_PUBLIC_ void
Element::resetNumber (int number)
{
  this_number = number;
}

/* PLG 2005-09-07
 * creates and returns a new element descriptor named <name>, declared in <embeddingContext>, as not used
 * owned by MKFFile associated to <embeddingContext>
 * <embeddingContext> is not NIL (otherwise error message is oupsed)
 * <comments> are comment lines associated with this declaration
 */
_PROTECTED_ Element::Element (ref2Context embeddingContext, const char *name, ref2ArgumentList comments):
ElementReporting ()
{
  this_number = ContextTree::new_elementNumber ();
  setContext (embeddingContext);
  this_name = name;
  these_commentLines = comments;
}

/* PLG 2005-09-07
 * creates and returns a new element reference descriptor named <name>, declared not used
 */
Element::Element (const char *name):
ElementReporting ()
{
  this_number = ContextTree::new_elementNumber ();
  this_declarationContext = Context::the_staticContext;
  this_name = name;
  these_commentLines = NIL_ArgumentList;
}
