#define LOG_NAME_LN() LOGFILE()->put_externName_ln(this_name)

_PUBLIC_ _VIRTUAL_ const char *
ExternNode::myClassName ()
{
  return "ExternNode";
}

/* ==========  ==========  static actions
 */
/* ==========  ==========  Attributes
 */
/* ==========  ==========  Writer
 */

_VIRTUAL_ void
ExternNode::print_nameValue_sp (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  printingContext->out_externName (outBuffer, this_name);
  outBuffer->space ();
}

_VIRTUAL_ void
ExternNode::log_outerName_ln ()
{
  LOG_NAME_LN ();
}

/* ==========  ========== Reader
 */

/* 2005-01-21
 * reads empty declaration content
 * success: FILE = PREFIX.#'}' [Any*][EOF]
 * failure: never
 */
_PUBLIC_ boolean ExternNode::read_dataDecl_fSpStar_nSp (ref2ArgumentList comments)
{
  debug_declHeader_ln ("declared extern");
  setComments (comments);
  return pk_true;
}

/* ==========  ==========  Grapher
 */
/* 
 */
_VIRTUAL_ boolean
ExternNode::nested_requiredConstructive ()
{
  return pk_true;
}

_VIRTUAL_ boolean
ExternNode::execute (ref2NodeElement curExecutedNode)
{
  return pk_true;
}

_VIRTUAL_ boolean
ExternNode::do_innerConstructive (boolean activeDependence)
{
  return pk_true;
}

_VIRTUAL_ boolean
ExternNode::generate (ref2NodeElement curBuiltFile, ref2Buffer fileToPrint)
{
  return pk_true;
}

/* ==========  ==========  Generator
 */
/* this does not have specific generator action */
/* ==========  ==========  Builder
 */
/* ==========  Reference to not defined node
 */
/* PLG 2005-09-07
 * creates and returns a new forward reference to an extern node descriptor named <name>
 * NODE:: sets this_isDefined to false
 *        sets initial date as the universal OLDEST date (GENESIA)
 *        sets this context as the static context
 */
ExternNode::ExternNode (int hashi, char *name):NodeElement (name)
{
  this_isUsed = pk_false;
}

/* ==========  Declaration in embeddingContext
 */

/* PLG 2005-09-07
 * <readingContext> is not NIL
 * creates and returns a new extern node descriptor named <name>
 * NODE::sets initial date as the universal OLDEST date (GENESIA)
 */
ExternNode::ExternNode (ref2Context readingContext, int hashi, char *name):
NodeElement (readingContext, name)
{
  set_defined ();		/* this_buildingData is not NIL */
  this_isUsed = pk_false;
}
