_PUBLIC_ _VIRTUAL_ const char *
FunctionElement::myClassName ()
{
  return "FunctionElement";
}

/* ========== Attributes
 */

/* returns formal parameter list
 */
ref2IdentifierList
FunctionElement::getFormalParameters ()
{
  return this_innerContext->get_parameterList ();
}

/* ========== Writer
 */

/* prints object standard header: "{ <NAME>" or "{ <TYPE> <NAME>"
 */
_VIRTUAL_ void
FunctionElement::print_type_sp (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
}

/* prints object standard header: "{ <NAME>" or "{ <TYPE> <NAME>"
 */
_VIRTUAL_ void
FunctionElement::print_declHeader (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  printingContext->out_defineHeader_sp (outBuffer);
  print_type_sp (printingContext, outBuffer);
  this_innerContext->print_funcProfile_ln (printingContext, outBuffer, this_name);
}

_VIRTUAL_ void
FunctionElement::print_declBody (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
}

/* prints object standard completion: "}:" on a new line
 */
_VIRTUAL_ void
FunctionElement::print_declCompletion (ref2IntePrinter outBuffer)
{
  outBuffer->put_ln_declClosing_func_ln ();
}

/* ========== Log
 */
/* detailss in <outBuffer> file this context and local declarations
 * <outBuffer> is not NIL_IntePrinter
 */
_VIRTUAL_ void
FunctionElement::logDebug_declBody (int level)
{
}

/* ========== Set
 */

/* ========== Printer
 */

/* ========== Reader
 */

/* 2004-11-23 ##########
 * reads body of a function declaration
 * current char is the first not space following a node opening mark
 * success: terminates on function declaration closure mark
 * failure: let the buffer unchanged or on Eof()
 *          sets this node errored
 *          error message is printed
 */
_VIRTUAL_ boolean
FunctionElement::read_declBody_fSpStar_nSp ()
{
  return pk_false;
}

/* 2004-11-29
 * reads declaration content
 * success: cursor starts [FUNCTION_BODY] '}:'
 *          cursor is moved to '}:'
 * failure: syntax or context error
 *          cursor is moved to errored character
 *          sets this node errored
 *          error message is printed
 */
_PUBLIC_ boolean FunctionElement::read_functionBody_fSpStar_nSp ()
{
  // this_declarationContext->log_ASDEBUG("entering FunctionElement::read_functionBody_fSpStar_nSp");
  debug_declHeader_ln ("declared function");
  if (read_declBody_fSpStar_nSp ())
    {
      this_innerContext->printORlevelInfo_declCompletion (this);
      return pk_true;
    }
  return pk_false;
}

/* ========== Grapher
 */

/* ========== Generator
 */

/* PLG 2005-12-08
 * success: sets expansion of elements in <parameterValues> as formal parameter values
 * failure: this is not safe or expansion failed or types do not fit
 *          error message is printed
 */
boolean
FunctionElement::parameterListLink_expand_ (ref2ArgumentList parameterValues)
{
  // logDEBUG_in("parameterListLink_expand_");
  return this_innerContext->parameterListLink_listExpand_ (parameterValues);
}

/* ========== Builder
 */

/* 2004-11-24
 * <embeddingContext> is not NIL
 * creates and returns a new function descriptor named <name> in <embeddingContext>
 * owned by MKFFile associated to <embeddingContext>
 * <comments> are comments associated with this declaration
 * <innerContext> is the new internal context
 */
FunctionElement::FunctionElement (ref2Context embeddingContext, char *name, ref2DynamicContext innerContext, ref2ArgumentList comments):Element ((ref2Context) embeddingContext, name,
	 comments)
{
  this_isUsed = pk_false;
  this_innerContext = innerContext;
  locker = NIL_FunctionElement;
}
