/* TODO 
 */

_PUBLIC_ _VIRTUAL_ const char *
GenericAncestor::myClassName ()
{
  return "GenericAncestor";
}

/* ========== Attributes
 */

/* ========== Log
 */
_VIRTUAL_ void
GenericAncestor::logDebug_header (int level)
{
}

void
GenericAncestor::logDebug_postAction (int level)
{
  if (this_postAncestorAction == NIL_ArgumentList)
    log_NILComponent_ln (level, "post action");
  else
    {
      log_subTitle_ln (level, "these post action lines are");
      this_postAncestorAction->logExtendedDebug_formula_ln (level);
    }
}

_PUBLIC_ _VIRTUAL_ void
GenericAncestor::logExtendedDebug_formula_ln (int level)
{
  logDebug_header (level);
  logDebug_postAction (level);
}

/* ========== Printer
 */

_VIRTUAL_ void
GenericAncestor::print_ActualHeader (ref2Lexical printingContext, ref2IntePrinter outBuffer, int depth)
{
}

void
GenericAncestor::line_actualPostAction (ref2Lexical printingContext, ref2IntePrinter outBuffer, int depth)
{
  if (this_postAncestorAction != NIL_ArgumentList)
    this_postAncestorAction->line_actualFormula (printingContext, outBuffer, depth);
}

void
GenericAncestor::print_actualFormula (ref2Lexical printingContext, ref2IntePrinter outBuffer, int depth)
{
  print_ActualHeader (printingContext, outBuffer, depth);
  line_actualPostAction (printingContext, outBuffer, depth);
}

_VIRTUAL_ void
GenericAncestor::print_header (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
}

void
GenericAncestor::print_postAction_ln (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  if (this_postAncestorAction != NIL_ArgumentList)
    this_postAncestorAction->line_formula (printingContext, outBuffer);
}

void
GenericAncestor::print_formula (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  print_header (printingContext, outBuffer);
  print_postAction_ln (printingContext, outBuffer);
}

/* ========== Grapher
 */

/* ========== Generator
 */

/* 
 */
boolean
GenericAncestor::build_ancestorAction (ref2LineList * lineList_res)
{
  // fprintf(stderr, "DEBUG GenericAncestor::build_ancestorAction\n");
  if (IS_SAFE ())
    {
      if (this_postAncestorAction == NIL_ArgumentList)
	{
	  (*lineList_res) = NIL_LineList;
	  return pk_true;
	}
      if (this_postAncestorAction->getIf_lineList_cast_flatExpand_ (lineList_res))
	return pk_true;
    }
  return pk_false;
}

/* generates a ancestor list from this
 * <callingContext> is not NIL (not checked)
 * if this list is empty, following meta actions are ignored
 * success: generated ancestors are returned in <ancestorList_res>
 *              <ancestorList_res> may be empty
 * failure: this is not a correct ancestor generator
 *               error message is printed
 */
_VIRTUAL_ boolean
GenericAncestor::build_ancestors (ref2Context callingContext, ref2AncestorList * ancestorList_res)
{
  // fprintf(stderr, "DEBUG GenericAncestor::build_ancestors \n");
  return pk_false;
}

/* generates a ancestor list from this
 * <callingContext> is not NIL (not checked)
 * if this list is empty, following meta actions are ignored
 * success: generated ancestors are returned in <ancestorList_res>
 *              <ancestorList_res> may be empty
 * failure: this is not a correct ancestor generator
 *               error message is printed
 */
boolean
GenericAncestor::build_ancestorList (ref2Context callingContext, ref2AncestorList * ancestorList_res)
{
  // fprintf(stderr, "DEBUG GenericAncestor::build_ancestorList, this is %i \n", (int)this);
  ref2LineList ancestorAction;
  if (IS_SAFE ())
    {
      if (build_ancestors (callingContext, ancestorList_res))
	{
	  if ((*ancestorList_res) == NIL_AncestorList)
	    {
	      return pk_true;
	    }
	  if (build_ancestorAction (&ancestorAction))
	    {
	      if (ancestorAction != NIL_LineList)
		(*ancestorList_res)->append_ancestorActions (ancestorAction);
	      return pk_true;
	    }
	}
    }
  return pk_false;
}

/* ========== Reader
 */

/* ========== Builder
 */
/* 
 * Empty ancestor list creation
 */
GenericAncestor::GenericAncestor (ref2ArgumentList ancestorAction):Soundness ()
{
  this_postAncestorAction = ancestorAction;
}
