/* TODO 
 */
_PUBLIC_ _VIRTUAL_ const char *
GenericElementList::myClassName ()
{
  return "GenericElementList";
}

/* ========== Attributes
 */

ref2GenericElementList
GenericElementList::next ()
{
  return cdr;
}

void
GenericElementList::append (ref2GenericElementList genericNode)
{
  if (cdr == NIL_GenericElementList)
    cdr = genericNode;
  else
    cdr->append (genericNode);
}

/* ========== Log
 */

_VIRTUAL_ void
GenericElementList::logDebug_inner (int level)
{
}

_PUBLIC_ _VIRTUAL_ void
GenericElementList::logExtendedDebug_formula_ln (int level)
{
}

/* ========== Writer
 */

/* ========== Printer
 */

_VIRTUAL_ void
GenericElementList::print_genericInner (ref2Lexical lexicalContext, ref2IntePrinter outBuffer)
{
}

void
GenericElementList::print_formula (ref2Lexical lexicalContext, ref2IntePrinter outBuffer)
{
  outBuffer->put_ln_declOpening_sp ();	// <outBuffer> = PREFIX . 'eol' '{' 'spc'
  print_genericInner (lexicalContext, outBuffer);
  outBuffer->put_ln_declClosing_ln ();
  if (cdr != NIL_GenericElementList)
    cdr->print_formula (lexicalContext, outBuffer);
}

/* ========== Set
 */

/* ========== Reader
 */

/* 
 * reads body of a function declaration
 * current char is the first not space following a node opening mark
 * success: terminates on function declaration closure mark
 * failure: let the buffer unchanged or on Eof()
 *          sets this node errored
 *          error message is printed
 */
_VIRTUAL_ boolean
GenericElementList::read (ref2Context readingContext)
{
  return pk_true;
}

/* ========== Generator
 */

/* builds a node from this
 * <callingContext> is not NIL (not checked)
 * parameterValues has been assigned to formal parameters
 * remains callingContext unchanged
 * failure: this is not a correct node generator
 *               error message is printed
 */
_VIRTUAL_ boolean
GenericElementList::build_element (ref2DynamicContext callingContext)
{
  // logDEBUG_in("build_element in GenericElementList");
  return pk_true;
}

/* builds a node from this
 * <callingContext> is not NIL (not checked)
 * parameterValues has been assigned to formal parameters
 * remains callingContext unchanged
 * failure: this is not a correct node generator
 *               error message is printed
 */
boolean
GenericElementList::build_elementDeclaration (ref2DynamicContext callingContext)
{
  // logDEBUG_in("build_elementDeclaration");
  ref2GenericElementList current_genericDeclaration = this;
  if (IS_SAFE ())
    {
      do
	{
	  // logDEBUG_inner("elementDeclaration --------------------------- in do");
	  if (!(current_genericDeclaration->build_element (callingContext)))
	    {
	      return pk_false;
	    }
	  current_genericDeclaration = current_genericDeclaration->cdr;
	}
      while (current_genericDeclaration != NIL_GenericElementList);
      return pk_true;
    }
  return pk_false;
}

/* ========== Builder
 */

/* creates and returns a new object descriptor named <name>
   PLG: used in ElementFunctionElement
 */
GenericElementList::GenericElementList (ref2DynamicContext readingContext):Soundness ()
{
  this_readingContext = readingContext;
  cdr = NIL_GenericElementList;
}
