/* 2004-12-21, 2007-02-06, 2009-06-29
 * success: <name> is an identifier
 * failure: <name> is not an identifier
 * this remains unchanged
 * 2004-12-21 */
_PROTECTED_ boolean InteLineAnalyzer::isString_identifier (char *name)	/* PLG 2007-02-16 FULLY CHECKED */
{
  return (strlen (name) == strspn (name, identifierCharSet));
}

/* 2004-12-07, 2007-02-06, 2009-06-29
 * success: BUFFER = [fileEndTAG] [NULL_char]
 * failure: BUFFER /= [fileEndTAG] [NULL_char]
 * this remains unchanged
 * 2004-12-07, 2007-02-06 */
_PROTECTED_ boolean InteLineAnalyzer::is_fileClosing ()	/* PLG 2007-02-16 FULLY CHECKED */
{
  if (thisLineActualLength == 1)
    return is_ (fileEndTAG);
  return pk_false;
}

/* 2004-12-07, 2007-02-066, 2009-06-29 */

/** success: BUFFER = .# [declClosingTAG][Character*][NULL_char]
 * failure: BUFFER = .# opt{[Character_but_declClosingTAG][Character*]}[NULL_char]
 *          BUFFER = PREFIX .# [Character*][NULL_char]       
 * this remains unchanged
 * 2004-12-07, 2007-02-06 */
_PROTECTED_ boolean InteLineAnalyzer::is_startClosing ()	/* PLG 2007-02-16 FULLY CHECKED */
{
  return is_start (declClosingTAG);
}

/* 2004-12-07, 2007-02-066, 2009-06-29
 * success: BUFFER = [funcDeclClosingMARK][Character*][NULL_char]
 * failure: BUFFER /= [funcDeclClosingMARK][Character*][NULL_char]
 * this remains unchanged
 * 2004-12-07, 2007-02-06 */
_PROTECTED_ boolean InteLineAnalyzer::is_funcDeclClosing ()
{
  return is_ (funcDeclClosingMARK);
}

/* 2004-12-07, 2007-02-066, 2009-06-29
 * success: BUFFER = PREFIX .# [declOpeningTAG][Character*][NULL_char]
 * failure: BUFFER = PREFIX .# opt{[Character_but_declOpeningTAG][Character*]}[NULL_char]
 * 2004-12-07, 2007-02-06 */
_PROTECTED_ boolean InteLineAnalyzer::is_nodeDeclOpening (boolean * isEol)
{
  if (is_lineCompleted ())
    {
      /* BUFFER = PREFIX .# [NULL_char] */
      (*isEol) = pk_true;
      return pk_false;
    }
  /* BUFFER = PREFIX[Character+] .# [NULL_char] */
  (*isEol) = pk_false;
  return is_ (declOpeningTAG);
}

/* 2004-12-07, 2007-02-066, 2009-06-29
 * success: BUFFER = [declClosingTAG][Character*][NULL_char]
 * failure: BUFFER /= [declClosingTAG][Character*][NULL_char]
 * this remains unchanged
 * 2004-12-07, 2007-02-06 */
_PROTECTED_ boolean InteLineAnalyzer::is_nodeDeclClosing ()
{
  return is_ (declClosingTAG);
}


/* PLG 2009-06-25, 2009-06-29
 * success: BUFFER = PREFIX.[Comment]# [NULL_char]
 *          a fresh copy of [Comment] is assigned to <commentCharSeq>
 * failure: BUFFER = PREFIX .# opt{[Character_but_commentTAG][Character*]}[NULL_char]
 * this atom remains unchanged
 */
_PROTECTED_ boolean InteLineAnalyzer::stepIf_comment_eo (char **commentCharSeq)	/* PLG 2007-02-16 FULLY CHECKED */
{
  if (stepIf_arg_ (commentTAG))
    {
      (*commentCharSeq) = strdupRemainingString ();
      set_completed ();
      return pk_true;
    }
  return pk_false;
}

/* 2004-11-02, 2007-02-06, 2008_07_04, 2009-07-09
 * skip "C whitespace" character occurrences and line terminating comment
 * success: BUFFER = PREFIX . opt{[lineSpaces]} # [NULL_char]
 * failure: BUFFER = PREFIX . [White*] # [Character_but_Space][Character*] [NULL_char]
 * this atom remains unchanged
 */
_PROTECTED_ boolean InteLineAnalyzer::step_optLineSpaces_eo ()	/* step_spStar_eol */
{
  if (step_whStar_nWh ())
    {
      /* BUFFER = PREFIX.[White*]#[Character_but_White][Character*] [NULL_char] */
      if (is_ (commentTAG))
	{
	  /* BUFFER = PREFIX.[White*]# ';'[Character*] [NULL_char] */
	  set_completed ();
	  /* BUFFER = PREFIX.[White*]';'[Character*] # [NULL_char] */
	  return pk_true;
	}
      /* BUFFER = PREFIX.[White*]# [Character_but_Space] [Character*] [NULL_char] */
      return pk_false;
    }
  /* BUFFER = PREFIX.[White*]# [NULL_char] */
  return pk_true;
}

/* 2004-11-02, 2007-02-06, 2008_07_04, 2009-06-25
 * skip "C whitespace" character occurrences and line terminating comment
 * success: BUFFER = PREFIX . [lineSpaces] # [NULL_char]
 *          BUFFER = PREFIX . [White+] # [Character_but_Space][Character*] [NULL_char]
 * failure: BUFFER = PREFIX .# opt{[Character_but_Space][Character*]}[NULL_char]
 * <isEol> is set according to final position
 * this atom remains unchanged
 */
_PROTECTED_ boolean InteLineAnalyzer::stepIf_spPlus_ (boolean * isEol)	/* PLG 2007-02-16 FULLY CHECKED */
{
  if (step_whPlus_ (isEol))
    {
      /* this atom remains unchanged */
      if (*isEol)		/* PREFIX . [White+] # [NULL_char] */
	return pk_true;
      /* PREFIX . [White+] # [Character_but_White] [Character*] [NULL_char] */
      if (is_ (commentTAG))
	{
	  set_completed ();
	  (*isEol) = pk_true;
	};			/*isEol is set TRUE if current lexical is a comment */
      return pk_true;
    }
  if (*isEol)			/* PREFIX . # [NULL_char] */
    return pk_false;
  /* PREFIX . # [Character_but_White] [Character*] [NULL_char] */
  if (is_ (commentTAG))
    {
      set_completed ();
      (*isEol) = pk_true;
      return pk_true;
    }
  /* PREFIX . # [Character_but_Space] [Character*] [NULL_char] */
  return pk_false;
}

/* 2004-12-06, 2008_07-04
 * extracts a (possibly empty) string XX as the longest sub-string beginning at cursor position,
 *                      and terminated before next occurrence of <charEnd>
 * success: <charEnd> is not [NULL_char], <charEnd> does not occur in [Character*] 
 *          BUFFER = PREFIX . [Character*]<charEnd> opt{[lineSpaces]} # [NULL_char]
 *          BUFFER = PREFIX . [Character*]<charEnd>[White*] # [Character_but_Space][Character+] [NULL_char]
 *          [Character*] is loaded in this atom
 *          <correct> remains unchanged
 * failure: BUFFER = PREFIX .# [Character*][NULL_char], <charEnd> is [NULL_char] or <charEnd> does not occur in [Character*]
 *             empties this atom
 *             <correct> remains unchanged
 *          FATAL!!!: memory error occurs
 *              BUFFER = PREFIX . [Character*]<charEnd> opt{[lineSpaces]} # [NULL_char], 
 *                  or   PREFIX . [Character*]<charEnd>[White*] # [Character_but_Space][Character+] [NULL_char]
 *              error message is printed
 *              <correct> is set FALSE
 * <isEol> is set according to final position
 */
_PRIVATE_ boolean InteLineAnalyzer::__stepLoad_charStar__arg_spStar_ (char charEnd, boolean * correct, boolean * isEol)	/* PLG 2007-02-16 FULLY CHECKED */
{
  boolean
    lCorrect = pk_true;
  if (stepAndLoad_charStar_before_ (charEnd, &lCorrect, isEol))
    {
      /* PREFIX.[Character*] <charEnd> # [Character*] [NULL_char], <isEol> is set */
      if (*isEol)
	return pk_true;
      /* PREFIX.[Character*] <charEnd> # [Character+] [NULL_char] */
      (*isEol) = step_optLineSpaces_eo ();
      /* *isEol TT: PREFIX.[Character*] <charEnd> opt{[lineSpaces]}# [NULL_char]; 
       *isEol FF: PREFIX.[Character*] <charEnd> [White*] # [Character_but_Space][Character*][NULL_char] */
      return pk_true;
    }
  if (lCorrect)
    /* PREFIX .# [Character*] [NULL_char],  <charEnd> does not occur in [Character*], <isEol> is set */
    return pk_false;
  /* PREFIX . [Character*] <charEnd> # [Character*] [NULL_char], memory error occurs, <isEol> is set */
  OUPS_memory ("InteLineAnalyzer::__stepLoad_charStar__arg_spStar_");
  (*correct) = pk_false;
  if (*isEol)
    return pk_false;
  (*isEol) = step_optLineSpaces_eo ();
  return pk_false;
}

/* 2008_07-04
 * success: all characters in [Identifier] belong to <identifierCharSet>, [Identifier] length is > 0
 *          BUFFER = PREFIX . [Identifier] # opt{[Character_but_<identifierCharSet>][Character*]}[NULL_char]
 *              <correct> remains unchanged
 *              [Identifier] is loaded in Atom
 * failure: BUFFER = PREFIX .# opt{[Character_but_<identifierCharSet>][Character*]}[NULL_char]
 *              <correct> remains unchanged
 *          FATAL!!! internal error:
 *              BUFFER = PREFIX .# <identifierCharSet>[Character*][NULL_char]
 *              <correct> is set FALSE
 *              error message is printed
 * <isEol> is set according to final position
 */
_PROTECTED_ boolean InteLineAnalyzer::stepIf_identifier (boolean * correct, boolean * isEol)	/* PLG 2007-02-18 FULLY CHECKED */
{
  boolean
    lCorrect = pk_true;
  if (stepAndLoad_charPlus_in_ (identifierCharSet, &lCorrect, isEol))
    /* all characters in [Character+] belong to <identifierCharSet>
     * BUFFER = PREFIX.<identifierCharSet>+ # opt{[Character_but_<identifierCharSet>][Character*]}[NULL_char], 
     * <isEol> is set 
     * <identifierCharSet>+ is loaded in this atom
     * <lCorrect> remains unchanged */
    return pk_true;
  if (lCorrect)
    /* BUFFER = PREFIX .# opt{[Character_but_<identifierCharSet>][Character*]}[NULL_char], <isEol> is set */
    return pk_false;
  OUPS_memory ("InteLineAnalyzer::stepIf_identifier");
  (*correct) = pk_false;
  /* internal error: atom becomes unsafe
   *              BUFFER = PREFIX .# <identifierCharSet>[Character*][NULL_char]
   * <isEol> is set 
   * empties this atom */
  return pk_false;
}

/* 2004-12-06, 2008_07-04
 * BOUNDEDSTRING = <boundMark>[Character*]<boundMark>
 * success: BUFFER = PREFIX . BOUNDEDSTRING opt{[lineSpaces]}# [NULL_char] 
 *          BUFFER = PREFIX . BOUNDEDSTRING [White*]#[Character_but_Space][Character+] [NULL_char] 
 *          if [Character*] is empty, NIL_String is returned in <strRes>
 *          if [Character*] is not empty, a new fresh copy of [Character*] is returned in <strRes>
 *          <correct> remains unchanged
 * failure: BUFFER = PREFIX .# opt{[Character_but_<boundMark>][Character*]}[NULL_char] 
 *              <correct> remains unchanged
 *          BUFFER = PREFIX .<boundMark> # [Character_but_<boundMark>]*[NULL_char]
 *              <correct> is set FALSE
 *              <erroredTermination> is set TRUE
 *          BUFFER = PREFIX .  BOUNDEDSTRING  opt{[lineSpaces]} # [NULL_char]
 *              or   PREFIX .  BOUNDEDSTRING [White*] # [Character_but_Space][Character*] [NULL_char]
 *              some memory error occurred
 *              error message is printed
 *              <correct> is set FALSE
 *              <erroredTermination> is set FALSE
 * <isEol> is set according to final position
 */
_PROTECTED_
  boolean InteLineAnalyzer::stepLoadIf_boundedString_spStar_ (char boundMark,
							      boolean * correct, char **strRes, boolean * erroredTermination, boolean * isEol)
{
  if (stepIf_arg_ (boundMark))
    {
      boolean
	lCorrect = pk_true;
      if (__stepLoad_charStar__arg_spStar_ (boundMark, &lCorrect, isEol))
	{
	  (*strRes) = strcatchAtom ();
	  return pk_true;
	}
      if (!lCorrect)
	OUPS_memory ("coming from InteLineAnalyzer::stepLoadIf_boundedString_spStar_");
      (*erroredTermination) = lCorrect;
      (*correct) = pk_false;
    }
  return pk_false;
}

/* HERE below BUFFER ELEMENTARY TAG functions ========= */

/* 2004-11-27, 2007-02-06, PLG-2009-09-18 REF TODO
 * success: BUFFER = PREFIX . <cc>opt{[lineSpaces]} # [NULL_char]
 *          BUFFER = PREFIX . <cc>[White*] # [Character_but_Space][NULL_char]
 * failure: BUFFER = PREFIX .#  opt{[Character_but_<cc>][Character*]}[NULL_char]
 * <isEol> is set according to # position
 * this atom remains unchanged
 * 2004-11-27 */
_PROTECTED_ boolean InteLineAnalyzer::stepIf_arg_spStar_ (char cc, boolean * isEol)	/* PLG 2007-02-16 FULLY CHECKED */
{
  // fprintf(stderr, "DEBUG InteLineAnalyzer::stepIf_arg_spStar_\n");
  if (stepIf_arg_whStar_ (cc, isEol))
    {				/* success: <cc> is not NULL_char
				 *          BUFFER = PREFIX . <cc>[White*] # [Character_but_White][Character*][NULL_char]
				 *               <isEol> becomes false
				 *          BUFFER = PREFIX . <cc> [White*] # [NULL_char]
				 *               <isEol> becomes pk_true
				 * failure: BUFFER = PREFIX .# [NULL_char].
				 *               <isEol> becomes pk_true
				 *          BUFFER = PREFIX .# [Character_but_<cc>][Character*][NULL_char]
				 *               <isEol> becomes false
				 */
      if (*isEol)
	return pk_true;
      if (is_ (commentTAG))
	{
	  set_completed ();
	  (*isEol) = pk_true;
	};
      return pk_true;
    }
  return pk_false;
}

/* 2004-11-27, 2007-02-06, PLG-2009-09-18 REF TODO 
 * success: BUFFER = PREFIX . <cc>opt{[lineSpaces]} # [NULL_char]
 *                  <isSpaced> is set TRUE
 *          BUFFER = PREFIX . <cc>[White*] # [Character_but_Space][NULL_char]
 *                  <isSpaced> is set
 * failure: BUFFER = PREFIX .# opt{[Character_but_<cc>][Character*]}[NULL_char]
 * <isEol> is set according to # position
 * this atom remains unchanged
 * 2004-11-27 */
_PROTECTED_ boolean InteLineAnalyzer::stepIf_arg_spStar_ (char cc, boolean * isSpaced, boolean * isEol)	/* PLG 2007-02-16 FULLY CHECKED */
{
  if (stepIf_arg_whStar_ (cc, isSpaced, isEol))
    {				/* success: <cc> is not NULL_char
				 *          BUFFER = PREFIX . <cc>[White*] # [NULL_char], 
				 *               <isSpaced> becomes pk_true
				 *          BUFFER = PREFIX . <cc> [White+] # [Character_but_White][Character*][NULL_char]
				 *               <isSpaced> becomes pk_true
				 *          BUFFER = PREFIX . <cc> # [Character_but_White][Character*][NULL_char]
				 *               <isSpaced> becomes false
				 * failure: BUFFER = PREFIX .# [NULL_char]
				 *               <isEol> becomes pk_true
				 *          BUFFER = PREFIX .# [Character_but_<cc>][Character*][NULL_char]
				 *               <isEol> becomes false
				 *          this remains unchanged */
      if (*isEol)
	return pk_true;
      if (is_ (commentTAG))
	{
	  set_completed ();
	  (*isEol) = pk_true;
	  (*isSpaced) = pk_true;
	  return pk_true;
	}
      return pk_true;
    }
  return pk_false;
}

/* 2004-11-27, 2007-02-06, PLG-2009-09-18 REF TODO  
 * success: BUFFER = PREFIX . <cc1><cc2>opt{[lineSpaces]} # [NULL_char]
 *          BUFFER = PREFIX . <cc1><cc2>[White*] # [Character_but_Space][NULL_char]
 * failure: BUFFER = PREFIX .# opt{[Character_but_<cc1>][Character*]}[NULL_char]
 *          BUFFER = PREFIX .# <cc1>opt{[Character_but_<cc2>][Character*]}[NULL_char]
 * <isEol> is set according to # position
 * this atom remains unchanged
 * 2004-11-27 */
_PROTECTED_ boolean InteLineAnalyzer::stepIf_arg_spStar_ (char cc1, char cc2, boolean * isEol)	/* PLG 2007-02-16 FULLY CHECKED */
{
  if (stepIf_arg_whStar_ (cc1, cc2, isEol))
    {				/* success: neither <cc1> nor <cc2> is NULL_char
				 *          BUFFER = PREFIX . <cc1><cc2>[White*] # [Character_but_White][Character*][NULL_char]
				 *          BUFFER = PREFIX . <cc1><cc2>[White*] # [NULL_char]
				 * failure: BUFFER = PREFIX .# [NULL_char]
				 *          BUFFER = PREFIX .# [Character_but_<cc1>][Character*][NULL_char]
				 *              or   PREFIX .# <cc1> opt{[Character_but_<cc2>][Character*]}[NULL_char]
				 *              or   PREFIX.# [Character*][NULL_char] if  <cc1> or <cc2> is [NULL_char]
				 * <isEol> is set according to # position */
      if (*isEol)
	return pk_true;
      if (is_ (commentTAG))
	{
	  set_completed ();
	  (*isEol) = pk_true;
	};			/*isEol is set TRUE if current lexical is a comment */
      return pk_true;
    }
  return pk_false;
}

/* 2004-11-27, 2007-02-06, PLG-2009-09-18 REF TODO  
 * success: ( if <str> is NIL_String )
 *          BUFFER = PREFIX . <str>opt{[lineSpaces]} # [NULL_char]
 *          BUFFER = PREFIX . <str>[White*] # [Character_but_Space][NULL_char]
 * failure: BUFFER = PREFIX .# [Character*][NULL_char], <str> is not a prefix in [Character*]
 * <isEol> is set according to # position
 * this atom remains unchanged
 * 2004-11-27 */
_PROTECTED_ boolean InteLineAnalyzer::stepIf_arg_spStar_ (const char *str, boolean * isEol)	/* PLG 2007-02-16 FULLY CHECKED */
{
  if (stepIf_arg_whStar_ (str, isEol))
    {				/* success: BUFFER = PREFIX . <str> [White*] # opt{[Character_but_White][Character*]}[NULL_char]
				 *              <str> may be NIL_String
				 * failure: BUFFER = PREFIX . [Character*][NULL_char]
				 *              <str> is not NIL_String, second [Character*] does not start with <str>
				 * <isEol> is set according to # position
				 *          this remains unchanged */
      if (*isEol)
	return pk_true;
      if (is_ (commentTAG))
	{
	  set_completed ();
	  (*isEol) = pk_true;
	};			/*isEol is set TRUE if current lexical is a comment */
      return pk_true;
    }
  return pk_false;
}

/* 2004-11-27, 2007-02-06, PLG-2009-09-18 REF TODO  
 * success: BUFFER = PREFIX . <cc1>opt{[lineSpaces]} # [NULL_char]
 *          BUFFER = PREFIX . <cc1>[White*] # [Character_but_Space][Character*][NULL_char], [Character_but_Space] is not <cc2> if [White*] is empty
 * failure: BUFFER = PREFIX .# <cc1><cc2>[Character*][NULL_char]
 *          BUFFER = PREFIX .# opt{[Character_but_White_but_<cc1>][Character*]}[NULL_char]
 * <isEol> is set
 * 2004-11-27 */
_PROTECTED_ boolean InteLineAnalyzer::stepIf_char1_notChar2_spStar_ (char cc1, char cc2, boolean * isEol)	/* PLG 2007-02-16 FULLY CHECKED */
{
  if (stepIf_char1_notChar2_whStar_ (cc1, cc2, isEol))
    {
      /* BUFFER = PREFIX . <cc1>[White+] # opt{[Character_but_White][Character*]}[NULL_char]
       * BUFFER = PREFIX . <cc1> # opt{[Character_but_White_but_<cc2>][Character*]}[NULL_char]
       * <isEol> is set */
      if (*isEol)
	/* BUFFER = PREFIX . <cc1>[White*] # [NULL_char] */
	return pk_true;
      /* BUFFER = PREFIX . <cc1>[White+] # [Character_but_White][Character*][NULL_char]
       * BUFFER = PREFIX . <cc1> # [Character_but_White_but_<cc2>][Character*][NULL_char] */
      if (is_ (commentTAG))
	{
	  set_completed ();
	  (*isEol) = pk_true;
	};			/*isEol is set TRUE if current lexical is a comment */
      /* BUFFER = PREFIX . <cc1>[White+] # [Character_but_Space][Character*][NULL_char]
       * BUFFER = PREFIX . <cc1> # [Character_but_Space_but_<cc2>][Character*][NULL_char]
       * BUFFER = PREFIX . <cc1>[White*][Comment] # [NULL_char] */
      return pk_true;
    }
  /* BUFFER = PREFIX .# <cc1><cc2>[Character*][NULL_char]
   * BUFFER = PREFIX .# opt{[Character_but_White_but_<cc1>][Character*]}[NULL_char]
   * <isEol> is set */
  return pk_false;
}



/** HERE above are buffer elementary tag actions */

/* HERE below STRING/IDENTIFIER functions ========= */

/* PUBLIC SORTED
 */

/* 2004-12-06, 2007-02-06, 2008_07-04, PLG-2009-09-18 REF TODO  
 * reads a parameter name
 * success: BUFFER = PREFIX . [referenceTAG] <leftChar> [White*] # [Character_but_Space][Character*] [NULL_char]
 *          BUFFER = PREFIX . [referenceTAG] <leftChar> opt{[lineSpaces]} # [NULL_char]
 * failure: BUFFER = PREFIX .# opt{[Character_but_<cc1>][Character*]}[NULL_char]
 *          BUFFER = PREFIX .# <cc1>opt{[Character_but_<cc2>][Character*]}[NULL_char]
 * <isEol> is set TRUE according to # position
 *          
 * 2004-12-06 */
_PUBLIC_ boolean InteLineAnalyzer::stepIf_referenceHead_spStar_ (char leftChar, boolean * isEol)	/* PLG 2007-02-18 FULLY CHECKED */
{
  return stepIf_arg_spStar_ (referenceTAG, leftChar, isEol);
}

/* 2004-12-29, 2007-02-06
 * reads context mark modifier
 * success: BUFFER = PREFIX . [contextLexicalMARK] # [Character*] [NULL_char]
 *            <isEol> is set according to final position
 * failure: BUFFER = PREFIX .# opt{[Character_but_contextLexicalMARK]}[Character*][NULL_char]...
 *            <isEol> is set according to final position
 * this atom remains unchanged
 * 2004-12-29 */
_PROTECTED_ boolean InteLineAnalyzer::stepIf_lexicalModifierMark (boolean * isEol)	/* PLG 2007-02-18 FULLY CHECKED */
{
  return stepIf_arg_ (contextLexicalMARK, isEol);
}

/* 
 * creates a line analyzer able to contain atomSize large atoms
 * used in InteReader(int lineSize, int atomSize)
 */
_PUBLIC_ InteLineAnalyzer::InteLineAnalyzer (int atomSize):LineAnalyzer (atomSize)
{
}

_PUBLIC_ InteLineAnalyzer::InteLineAnalyzer (char *str):
LineAnalyzer (str)
{
}

_PUBLIC_ InteLineAnalyzer::InteLineAnalyzer ():LineAnalyzer ()
{
}

_PUBLIC_ InteLineAnalyzer::~InteLineAnalyzer ()
{
}

/*
 *
 * Static Elements
 *
 */
/* 2004-12-21, 2007-02-06, 2009-06-29 */
/** success: <name> is not a reserved word
 * failure: <name> is a reserved word
 * this remains unchanged
 * 2004-12-21 */
_STATIC_ int
InteLineAnalyzer::get_reservedCode (char *name)	/* PLG 2007-02-16 FULLY CHECKED */
{
  // fprintf(stderr,"DEBUG entering InteLineAnalyzer::get_reservedCode, name is <<%s>>\n", name);
  int compRes = strcmp (name, iterateWORD);
  if (compRes == 0)
    return iterateCODE;		/* 'iterate' */
  if (compRes < 0)
    {				/* name < iterateWORD: ... define ... */
      // fprintf(stderr,"   <<<<>>>>  name <<%s>> is smaller than iterate \n", name);
      compRes = strcmp (name, defineWORD);
      if (compRes == 0)
	return defineCODE;	/* 'define' */
      if (compRes < 0)
	{			/* name < defineWORD: ancestor, boot, context */
	  compRes = strcmp (name, bootWORD);
	  if (compRes == 0)
	    return bootCODE;	/* 'boot' */
	  if (compRes < 0)
	    {			/* name < bootWORD: ancestor */
	      if (strcmp (name, ancestorWORD) == 0)
		return ancestorCODE;	/* 'ancestor' */
	    }
	  else
	    {			/* bootWORD < name < defineWORD: context */
	      if (strcmp (name, contextWORD) == 0)
		return contextCODE;	/* 'context' */
	    }
	}
      else
	{			/* defineWORD < name < iterateWORD : exec, hostval, inner */
	  compRes = strcmp (name, hostvalWORD);
	  if (compRes == 0)
	    return hostvalCODE;	/* 'hostval' */
	  if (compRes < 0)
	    {			/* defineWORD < name < hostvalWORD: exec */
	      if (strcmp (name, execWORD) == 0)
		return execCODE;	/* 'exec' */
	    }
	  else
	    {			/* hostvalWORD < name < iterateWORD: inner  NOT IMPLEMENTED  */
	      if (strcmp (name, innerWORD) == 0)
		return innerCODE;	/* 'inner'  not implemented scope */
	    }
	}
    }
  else
    {				/* iterateWORD < name: ... static ... */
      // fprintf(stderr,"   <<<<>>>>  name <<%s>> is greater than <<%s>> \n", name, iterateWORD);
      compRes = strcmp (name, staticWORD);
      if (compRes == 0)
	return globalCODE;	/* 'static' */
      if (compRes < 0)
	{			/* iterate < name < static: list, listval, node, public */
	  // fprintf(stderr,"   <<<<>>>>  name <<%s>> is smaller than static \n", name);
	  compRes = strcmp (name, listvalWORD);
	  if (compRes == 0)
	    return listvalCODE;	/* 'listval' */
	  if (compRes < 0)
	    {			/* iterate < name < listval: list */
	      if (strcmp (name, listWORD) == 0)
		return listCODE;	/* 'list' */
	    }
	  else
	    {			/* listval < name  < static: node public */
	      compRes = strcmp (name, nodeWORD);
	      if (compRes == 0)
		return nodeCODE;	/* 'node' */
	      if (compRes > 0)
		{		/* iterate < name < listval: list */
		  if (strcmp (name, publicWORD) == 0)
		    return publicCODE;	/* 'public' not implemented scope */
		}
	    }
	}
      else
	{			/* static < name : string, stringval, write */
	  // fprintf(stderr,"   <<<<>>>>  name <<%s>> is greater than <<%s>> \n", name, staticWORD);
	  compRes = strcmp (name, stringvalWORD);
	  if (compRes == 0)
	    return stringvalCODE;	/* 'stringval' */
	  if (compRes < 0)
	    {			/* static < name < stringval : string */
	      // fprintf(stderr,"   <<<<>>>>  name <<%s>> is smaller than <<%s>> \n", name, stringvalWORD);
	      if (strcmp (name, stringWORD) == 0)
		return stringCODE;	/* 'string' */
	    }
	  else
	    {			/* stringval < name : write */
	      // fprintf(stderr,"   <<<<>>>>  name <<%s>> is greater than <<%s>> \n", name, stringvalWORD);
	      if (strcmp (name, writeWORD) == 0)
		return writeCODE;	/* 'write' */
	    }
	}
    }
  return userCODE;		/* not a reserved word */
}

/** success: <varName> is a pKMake user identifier
 *           returns a new allocated copy of varName in CString_name
 *  failure: varName> is no a pKMake identifier
 */
_STATIC_ boolean
InteLineAnalyzer::is_userVarName (char *varName)
{
  int varNameLgth = strlen (varName);
  if (varNameLgth == 0)
    return pk_false;
  if (strspn (varName, identifierCharSet) != varNameLgth)
    return pk_false;
  return (get_reservedCode (varName) == userCODE);
}
