#define LN_SETCOMMENTSTATE() line_setLeftMark(";")
#define LN_UNSETCOMMENTSTATE() line_removeLeftMark()

#define PRINT_EXTERNMARK() print(externTAG)
#define PRINT_FILEMARK() print(fileTAG)
#define PRINT_REFERENCEMARK() print(referenceTAG)

#define PRINT_NEVERMARK_SP() space(neverTAG)
#define PRINT_NEVERMARK_LN() line(neverTAG)
#define PRINT_EVERMARK_LN() line(everTAG)
#define PRINT_RECURSIVEEVERMARK_LN() print(everTAG); line(recursiveTAG)
#define PRINT_MISSINGMARK_LN() line(missingTAG)
#define PRINT_MISSINGNEVERMARK_LN() print(missingTAG); line(neverTAG)

#define PRINT_EXTERNNAME(_NAME_) print(externTAG, _NAME_, externTAG)
#define PRINT_FILENAME(_NAME_) print(fileTAG, _NAME_, fileTAG)
#define PRINT_FILENAME_SP(_NAME_) PRINT_FILENAME(_NAME_); space()

#define PRINT_TAG_COMMAND(commandChar, commandWORD) print(commandChar, commandWORD)
#define PRINT_TAG_COMMAND_SP(commandChar, commandWORD) PRINT_TAG_COMMAND(commandChar, commandWORD); space()
#define PRINT_TAG_COMMAND_LN(commandChar, commandWORD) PRINT_TAG_COMMAND(commandChar, commandWORD); line()

#define PRINT_TAG_CONTEXT_COMMAND_SP(commandChar) PRINT_TAG_COMMAND_SP(commandChar, contextWORD)
#define PRINT_TAG_BOOT_COMMAND_LN(commandChar) PRINT_TAG_COMMAND_LN(commandChar, bootWORD)
#define PRINT_TAG_STATIC_COMMAND_SP(commandChar) PRINT_TAG_COMMAND_SP(commandChar, staticWORD)
#define PRINT_TAG_WRITE_COMMAND_SP(commandChar) PRINT_TAG_COMMAND_SP(commandChar, writeWORD)
#define PRINT_TAG_EXEC_COMMAND_SP(commandChar) PRINT_TAG_COMMAND_SP(commandChar, execWORD)
#define PRINT_TAG_STRING_TYPE_SP(commandChar) PRINT_TAG_COMMAND_SP(commandChar, stringWORD)
#define PRINT_TAG_LIST_TYPE_SP(commandChar) PRINT_TAG_COMMAND_SP(commandChar, listWORD)

#define PRINT_TAG_ITERATE_COMMAND_SP(commandChar) PRINT_TAG_COMMAND_SP(commandChar, iterateWORD)
#define PRINT_TAG_DEFINE_COMMAND_SP(commandChar) PRINT_TAG_COMMAND_SP(commandChar, defineWORD)

#define PRINT_TAG_ANCESTOR_TYPE_SP(commandChar) PRINT_TAG_COMMAND_SP(commandChar, ancestorWORD)
#define PRINT_TAG_NODE_TYPE_SP(commandChar) PRINT_TAG_COMMAND_SP(commandChar, nodeWORD)
#define PRINT_TAG_CONTEXT_TYPE_SP(commandChar) PRINT_TAG_COMMAND_SP(commandChar, contextWORD)

/* appends ';''spc' */
#define PRINT_COMMENT_SP() space(commentTAG)
 /* appends ';''spc' <_MESS_> 'spc' */
#define PRINT_COMMENT_STR_SP(_MESS_) PRINT_COMMENT_SP(); space(_MESS_)
 /* appends ';''spc''--:''spc' */
#define PRINT_COMMENT_ITEM_SP()    PRINT_COMMENT_STR_SP("--:")
 /* appends ';''spc''---MKF INFO:''spc' */
#define PRINT_COMMENT_INFO_SP()    PRINT_COMMENT_STR_SP("---MKF INFO:")
 /* appends ';''spc''--#MKF WARNING:''spc' */
#define PRINT_COMMENT_WARN_SP() PRINT_COMMENT_STR_SP("--#MKF WARNING:")
 /* appends ';''spc''-##MKF ERROR:''spc' */
#define PRINT_COMMENT_ERRO_SP()   PRINT_COMMENT_STR_SP("-##MKF ERROR:")
 /* appends ';''spc''###MKF FATAL ERROR:''spc' */
#define PRINT_COMMENT_FATA_SP()   PRINT_COMMENT_STR_SP("###MKF FATAL ERROR:")
 /* appends ';''spc''---MKF DEBUG:''spc' */
#define PRINT_COMMENT_DEBUG_SP()   PRINT_COMMENT_STR_SP("---MKF DEBUG:")

#define PRINT_SPACES(_NN_) printNChars(' ', _NN_);
/* ======== lexical marks printing */

#define INDENTDEBUG_(level) printNChars('=', 2*level); space('>')
#define INDENTDEBUG_CHAR(level, CC) printNChars(CC, 2*level+1); space()

/* prints object standard attributes: empty
 */
_PUBLIC_ void
IntePrinter::put_PREFIX1__sp (int level, const char *mess)
{
  INDENTDEBUG_ (level);
  space (mess);
}

_PUBLIC_ void
IntePrinter::put_PREFIX1__ln (int level, const char *mess)
{
  INDENTDEBUG_ (level);
  line (mess);
}

/* prints object standard attributes: empty
 */
_PUBLIC_ void
IntePrinter::put_PREFIX2__ (int level, const char *mess)
{
  INDENTDEBUG_CHAR (level, '-');
}

/* prints object standard attributes: empty
 */
_PUBLIC_ void
IntePrinter::put_PREFIX2__sp (int level, const char *mess)
{
  INDENTDEBUG_CHAR (level, '-');
  space (mess);
}

/* prints object standard attributes: empty
 */
_PUBLIC_ void
IntePrinter::put_PREFIX2__ln (int level, const char *mess)
{
  INDENTDEBUG_CHAR (level, '-');
  line (mess);
}

/* prints object standard attributes: empty
 */
_PUBLIC_ void
IntePrinter::put_SPACES__sp (int level, const char *mess)
{
  PRINT_SPACES (2 * level + 2);
  space (mess);
}

_PUBLIC_ void
IntePrinter::put_SPACES__ln (int level, const char *mess)
{
  PRINT_SPACES (2 * level + 2);
  line (mess);
}

_PUBLIC_ void
IntePrinter::put_timeCounts_ln (long int cpuTime, long int fullTime)
{
  if (cpuTime < 0)
    {
      space ("unknown cpu time,");
    }
  else
    {
      space (cpuTime);
      space ("ms of cpu time,");
    }
  space (fullTime);
  line ("sec full time");
}

/*
 */
_PUBLIC_ void
IntePrinter::put_ln_setCommentState ()
{
  LN_SETCOMMENTSTATE ();	/* result is not useful: const char * curMark = */
}

/* PLG 2008-06-04
 *   PRE: this = STRING
 *   POST: this = STRING 'eol'
 */
_PUBLIC_ void
IntePrinter::put_ln_unsetCommentState ()
{
  LN_UNSETCOMMENTSTATE ();	/* result is not useful: const char * curMark = */
}


/* PLG 2008-06-04
 *   PRE: this = STRING
 *   POST: this = STRING 'eol'';''spc''{''spc'
 */
_PUBLIC_ void
IntePrinter::put_ln_setComment_declOpening_sp ()
{
  LN_SETCOMMENTSTATE ();
  print_sp__sp (declOpeningTAG);
}

_PUBLIC_ void
IntePrinter::put_ln_declClosing_ln_unsetComment ()
{
  line ();
  print (declClosingTAG);
  LN_UNSETCOMMENTSTATE ();	/* result is not useful: const char * curMark = */
}

_PUBLIC_ void
IntePrinter::comment_sp ()
{
  PRINT_COMMENT_SP ();
}				/* appends ';''spc' */

_PUBLIC_ void
IntePrinter::comment__sp (const char *mess)
{
  PRINT_COMMENT_STR_SP (mess);
}				/* appends ';''spc'<mess>'spc' */

/* PLG 2008-06-04
 *   PRE: this = STRING
 *   POST: this = STRING 'eol'';''spc''--:''spc'<mess>'spc'
 */
_PUBLIC_ void
IntePrinter::put_ln_comment__sp (const char *mess)
{
  line ();
  PRINT_COMMENT_STR_SP (mess);	/* appends 'eol'';''spc'<mess>'spc' */
}

/* appends "; --:: "  to the current line
 */

_PUBLIC_ void
IntePrinter::commentITEM_sp ()
{
  PRINT_COMMENT_ITEM_SP ();	/* appends ';''spc''--:''spc' */
}

/* prints current line
   appends "; --:: mess" followed by a space in a new line
 */
_PUBLIC_ void
IntePrinter::put_ln_COMITEM__sp (const char *mess)
{
  line ();
  PRINT_COMMENT_ITEM_SP ();
  space (mess);			/* appends 'eol'';''spc''--:''spc'<mess>'spc' */
}

/* PLG 2008-06-04
 *   PRE: this = STRING
 *   POST: this = STRING 'eol'';''spc''--:''spc'<mess>'eol'
 */
_PUBLIC_ void
IntePrinter::put_ln_COMITEM__ln (const char *mess)
{
  line ();
  PRINT_COMMENT_ITEM_SP ();
  line (mess);			/* appends 'eol'';''spc''--:''spc'<mess>'eol' */
}

/* ==== general command tag ====
*/

/* PLG 2008-06-04
 *   PRE: this = STRING
 *   POST: this = STRING 'eol''{''spc'
 */

_PUBLIC_ void
IntePrinter::put_ln_declOpening_sp ()
{
  line ();
  space (declOpeningTAG);
}

/* PLG 2008-06-04
 * PRE: this == STRING
 * POST: this == STRING <commandChar> 'context''spc'
 */
_PUBLIC_ void
IntePrinter::tabDecl ()
{
  tabulation (7);
}

/* PLG 2008-06-04
 * PRE: this == STRING
 * POST: this == STRING <commandChar> 'context''spc'
 */
_PUBLIC_ void
IntePrinter::put_contextDeclHeader_spTab (char commandChar)
{
  PRINT_TAG_CONTEXT_COMMAND_SP (commandChar);
  tabDecl ();
}

/* PLG 2008-06-04
 * PRE: this == STRING
 * POST: this == STRING <commandChar> 'boot''eol'
 */
_PUBLIC_ void
IntePrinter::put_bootCommand_ln (char commandChar)
{
  PRINT_TAG_BOOT_COMMAND_LN (commandChar);
}

_PUBLIC_ void
IntePrinter::put_staticCommand_sp (char commandChar)
{
  PRINT_TAG_STATIC_COMMAND_SP (commandChar);
}

_PUBLIC_ void
IntePrinter::put_stringType_sp (char commandChar)
{
  PRINT_TAG_STRING_TYPE_SP (commandChar);
}

_PUBLIC_ void
IntePrinter::put_listType_sp (char commandChar)
{
  PRINT_TAG_LIST_TYPE_SP (commandChar);
}

_PUBLIC_ void
IntePrinter::put_ancestorType_sp (char commandChar)
{
  PRINT_TAG_ANCESTOR_TYPE_SP (commandChar);
}

_PUBLIC_ void
IntePrinter::put_nodeType_sp (char commandChar)
{
  PRINT_TAG_NODE_TYPE_SP (commandChar);
}

_PUBLIC_ void
IntePrinter::put_contextType_sp (char commandChar)
{
  PRINT_TAG_CONTEXT_TYPE_SP (commandChar);
}

/* PLG 2008-06-04
 * PRE: this = STRING
 * POST: this = STRING <commandChar> 'define''spc'
 */
_PUBLIC_ void
IntePrinter::put_defineCommand_sp (char commandChar)
{
  PRINT_TAG_DEFINE_COMMAND_SP (commandChar);
}

_PUBLIC_ void
IntePrinter::put_iterate_sp (char commandChar)
{
  PRINT_TAG_ITERATE_COMMAND_SP (commandChar);
  space (openingTAG);
}

_PUBLIC_ void
IntePrinter::put_stringConstant (char strTag, const char *strVal)
{
  print (strTag, strVal, strTag);

}

_PUBLIC_ void
IntePrinter::put_stringConstant (char strTag, char charVal)
{
  print (strTag, charVal, strTag);
}

_PUBLIC_ void
IntePrinter::put_type_sp (boolean isList)
{
  if (isList)
    print (listTAG);
}

_PUBLIC_ void
IntePrinter::put_typedName_sp (boolean isList, const char *name)
{
  if (isList)
    print (listTAG);
  space (name);
}

_PUBLIC_ void
IntePrinter::put_callHeader (char commandChar, const char *name)
{
  PRINT_TAG_COMMAND (commandChar, name);
}

_PUBLIC_ void
IntePrinter::put_externNameCallHeader (char commandChar, const char *name)
{
  print (externGeneratorTAG);
  PRINT_TAG_COMMAND (commandChar, name);
}

_PUBLIC_ void
IntePrinter::put_fileNameCallHeader (char commandChar, const char *name)
{
  print (fileGeneratorTAG);
  PRINT_TAG_COMMAND (commandChar, name);
}

_PUBLIC_ void
IntePrinter::put_varNameCallHeader (char commandChar, const char *name)
{
  print (varGeneratorTAG);
  PRINT_TAG_COMMAND (commandChar, name);
}

_PUBLIC_ void
IntePrinter::put_callOpening_sp (char commandChar, const char *name)
{
  put_callHeader (commandChar, name);
  space (openingTAG);
}

_PUBLIC_ void
IntePrinter::put_openCloseTag_sp ()
{
  space (openingTAG);
  space (closingTAG);
}

_PUBLIC_ void
IntePrinter::put_openTag_sp ()
{
  space (openingTAG);
}

_PUBLIC_ void
IntePrinter::put_nameValue_openTag_sp (const char *name)
{
  print (name);
  space (openingTAG);
}

_PUBLIC_ void
IntePrinter::put_closing_sp ()
{
  space (closingTAG);
}

_PUBLIC_ void
IntePrinter::put_closeTAG ()
{
  print (closingTAG);
}

_PUBLIC_ void
IntePrinter::put_closeTag_ln ()
{
  line (closingTAG);
}

_PUBLIC_ void
IntePrinter::put_parameter (const char *name, char leftChar, char rightChar)
{
  print (referenceTAG, leftChar);
  print (name);
  print (rightChar);
}

/* PLG 2008-06-04
 * PRE: this = STRING
 * POST: this = STRING '$$' <leftChar> <rightChar> <commandChar> <stringChar> 'spc'
 */
_PUBLIC_ void
IntePrinter::put_lexicalContext_sp (char leftChar, char rightChar, char commandChar, char stringChar)
{
  if (lineIfOver (6))
    {
      print (contextLexicalMARK, leftChar);
      print (rightChar, commandChar, stringChar);
      space ();
    }
}

/* PLG 2008-06-04
 * PRE: this = STRING
 * POST: this = STRING '$$' <leftChar> <rightChar> <commandChar> <stringChar> 'eol'
 */
_PUBLIC_ void
IntePrinter::put_lexicalContext_ln (char leftChar, char rightChar, char commandChar, char stringChar)
{
  if (lineIfOver (6))
    {
      print (contextLexicalMARK, leftChar);
      print (rightChar, commandChar, stringChar);
      line ();
    }
}

_PUBLIC_ void
IntePrinter::put_varAttributes_sp (char commandChar, boolean isExec, boolean isBuildable)
{
  if (isExec)
    {
      PRINT_TAG_EXEC_COMMAND_SP (commandChar);
    }
  else if (!isBuildable)
    {
      PRINT_NEVERMARK_SP ();
    }
}

_PUBLIC_ void
IntePrinter::put_conditionMark_ln ()
{
  line (defaultTAG);
}

_PUBLIC_ void
IntePrinter::put_fileWriteContext_sp (char commandChar, boolean isExec)
{
  space ();
  if (isExec)
    {
      PRINT_TAG_EXEC_COMMAND_SP (commandChar);
    }
  else
    {
      PRINT_TAG_WRITE_COMMAND_SP (commandChar);
    }
}

_PUBLIC_ void
IntePrinter::put_fileWriteContext_sp (char commandChar, char strTag, boolean isExec, const char *brkStr, char continuationChar)
{
  put_fileWriteContext_sp (commandChar, isExec);
  print ('(');
  put_stringConstant (strTag, brkStr);
  space ();
  put_stringConstant (strTag, continuationChar);
  space (')');
}

/* PLG 2008-06-04
 * PRE: this = STRING
 * POST: this = STRING 'eol' '}' 'eol'
 */
_PUBLIC_ void
IntePrinter::put_ln_declClosing_ln ()
{
  line ();
  line (declClosingTAG);
}

/* PLG 2008-06-04
 * PRE: this = STRING
 * POST: this = STRING 'eol' '}' 'eol'
 */
_PUBLIC_ void
IntePrinter::put_ln_declClosing_lnBackTab ()
{
  line ();
  backTabulation ();
  line (declClosingTAG);
}

_PUBLIC_ void
IntePrinter::put_ln_declClosing_func_ln ()
{
  line ();
  line ("}:");
  line (1);
}

_PUBLIC_ void
IntePrinter::put_ln_preludeOpening_ln ()
{
  line ();
  line ("{");
}

_PUBLIC_ void
IntePrinter::put_ln_defaultOpening_ln ()
{
  line ();
  line (defaultOpeningMARK);
}

_PUBLIC_ void
IntePrinter::put_ln_dependenceOpening_spN ()
{
  line ();
  print (ancestorOpeningMARK);
  PRINT_SPACES (5);
}

/* PLG 2008-06-04
 * PRE: this = STRING
 * POST: this = STRING 'eol' '}' 'eol'
 */
_PUBLIC_ void
IntePrinter::put_ln_declClosing_context_backTabLn ()
{
  line ();
  backTabulation ();
  line (1);
}

_PUBLIC_ void
IntePrinter::put_externTAG ()
{
  PRINT_EXTERNMARK ();
}

_PUBLIC_ void
IntePrinter::put_externName_sp (const char *name)
{
  PRINT_EXTERNNAME (name);
  space ();
}

_PUBLIC_ void
IntePrinter::put_externName_ln (const char *name)
{
  PRINT_EXTERNNAME (name);
  line ();
}

/* 
 */
_PUBLIC_ void
IntePrinter::put_fileTAG ()
{
  PRINT_FILEMARK ();
}

/* 
 */
_PUBLIC_ void
IntePrinter::put_referenceTAG ()
{
  PRINT_REFERENCEMARK ();
}

/* appends file name followed by space to current line
 */
_PUBLIC_ void
IntePrinter::put_fileNameValue_sp (const char *name)
{
  PRINT_FILENAME_SP (name);
}

_PUBLIC_ void
IntePrinter::put_fileNameValue (const char *name)
{
  PRINT_FILENAME (name);
}

_PUBLIC_ void
IntePrinter::put_fileNameValue_ln (const char *name)
{
  PRINT_FILENAME (name);
  line ();
}

/* prints current line
 * appends file name followed by a space in a new current line
 */
_PUBLIC_ void
IntePrinter::put_ln_fileName_sp (const char *name)
{
  line ();
  PRINT_FILENAME_SP (name);
}

/* ======== Object attributes printing
 */

_PUBLIC_ void
IntePrinter::put_innerRef_sp (int num, int ownerNum)
{
  print ('(');
  space ((long int) num);
  space ("in");
  if (ownerNum >= 0)
    print ((long int) ownerNum);
  else
    print ('?');
  space (')');
}

/* appends object identification to current line
 */
_PUBLIC_ void
IntePrinter::put_releaseDate_sp (time_t date)
{
  space ("rel:");
  space (strcvtTime (date));
}

/* <depValue> -2 in Error, -1: never, 0: if required, 1: force, 2: recursively force */
_PUBLIC_ void
IntePrinter::put_dependenceAttribute_ln (int dependenceNature, boolean highDependenceLevel)
{
  if (dependenceNature == newerBuildCODE)
    {
      if (highDependenceLevel)
	line ();
      else
	{
	  PRINT_NEVERMARK_LN ();
	}
    }
  else if (dependenceNature == everBuildCODE)
    {
      if (highDependenceLevel)
	{
	  PRINT_RECURSIVEEVERMARK_LN ();
	}
      else
	{
	  PRINT_EVERMARK_LN ();
	}
    }
  else if (dependenceNature == missingBuildCODE)
    {
      if (highDependenceLevel)
	{
	  PRINT_MISSINGMARK_LN ();
	}
      else
	{
	  PRINT_MISSINGNEVERMARK_LN ();
	}
    }
  else				/* dependenceNature == errorCODE */
    line ("*** dependence attribute in error");
}

/* prints current line
 * if <skipLine> is strictly positive, prints a separation line
 * terminates on a new empty line
 */
_PUBLIC_ void
IntePrinter::put_separatorLine (int skipLine)
{
  if (skipLine > 1)
    {
      line (skipLine - 2);
      /* appends 'eol'';''spc' '0#########0=========0*********0=========0#########' 'spc' */
      put_ln_comment__sp ("0#########0=========0*********0=========0#########");
    }
  line ();
}

/* +=+=+=+=+=+=+=+=+ INFO +=+=+=+=+=+=+=+=+ 
 */
_PUBLIC_ void
IntePrinter::put_INFO__sp (const char *mess)
{
  PRINT_COMMENT_INFO_SP ();
  space (mess);			/* appends ';''spc''---MKF INFO:''spc'<mess>'spc' */
}

_PUBLIC_ void
IntePrinter::put_ln_INFO_sp ()
{
  line ();
  PRINT_COMMENT_INFO_SP ();	/* appends 'eol'';''spc''---MKF INFO:''spc' */
}

/* prints current line
 * prints commented info prefix followed by mess in a new line 
 * terminates on a new empty line
 */
_PUBLIC_ void
IntePrinter::put_ln_INFO__sp (const char *mess)
{
  line ();
  PRINT_COMMENT_INFO_SP ();
  space (mess);			/* appends 'eol'';''spc''---MKF INFO:''spc'<mess>'spc' */
}

/* prints current line
 * prints commented info prefix followed by mess in a new line 
 * terminates on a new empty line
 */
_PUBLIC_ void
IntePrinter::put_ln_INFO__ln (const char *mess)
{
  line ();
  PRINT_COMMENT_INFO_SP ();
  line (mess);			/* appends 'eol'';''spc''---MKF INFO:''spc'<mess>'eol' */
}

/* prints current line
 * prints commented info prefix followed by mess in a new line 
 * terminates on a new empty line
 */
_PUBLIC_ void
IntePrinter::put_ln_INFO__sp__ln (const char *mess1, const char *mess2)
{
  line ();
  PRINT_COMMENT_INFO_SP ();
  space (mess1);
  line (mess2);
  /* appends 'eol'';''spc''---MKF INFO:''spc'<mess1>'spc'<mess2>'eol' */
}

/* prints current line
 * if <skipLine> is strictly positive, prints separation lines
 * prints commented info prefix followed by mess in a new line 
 * terminates on a new empty line
 */
_PUBLIC_ void
IntePrinter::put_titleLine_INFO__ln_tab (int skipLine, const char *mess)
{
  put_separatorLine (skipLine);
  PRINT_COMMENT_INFO_SP ();
  line (mess);			/* appends ';''spc''---MKF INFO:''spc'<mess>'eol' */
  tabulation (2);
}

/* prints current line
 * prints statistics on a new line
 * terminates on a new empty line
 */
_PUBLIC_ void
IntePrinter::put_ln_INFO__statLine (const char *name, int n1, int n2)
{
  line ();
  PRINT_COMMENT_INFO_SP ();	/* appends 'eol'';''spc''---MKF INFO:''spc' */
  space (name);
  space ("table entry");
  space ((long int) n1);
  space ("contains");
  space ((long int) n2);
  if (n2 <= 1)
    {
      if (n2 <= 0)
	line ("is empty.");
      else
	line ("contains one node.");
    }
  else
    {
      space ("contains");
      space ((long int) n2);
      line ("nodes.");
    }
}

/* prints current line
 * prints statistics on a new line
 * terminates on a new empty line
 */
_PUBLIC_ void
IntePrinter::put_ln_INFO__statGlobLines (const char *name, int n1, int n2, int smallest, int greatest)
{
  line ();
  PRINT_COMMENT_INFO_SP ();
  space (name);			/* appends 'eol'';''spc''---MKF INFO:''spc'<name>'spc' */
  space ("table holds");
  space ((long int) n1);
  space ("nodes in");
  space ((long int) n2);
  line ("entries");
  PRINT_SPACES (5);
  space ("entries contain from");
  space ((long int) smallest);
  space ("to");
  space ((long int) greatest);
  line ("nodes.");
}

/* +=+=+=+=+=+=+=+=+ WARNING +=+=+=+=+=+=+=+=+ 
 */

/* prints current line
 * appends commented warning prefix followed by mess in a new line 
 */
_PUBLIC_ void
IntePrinter::put_ln_WARN_sp ()
{
  line ();
  PRINT_COMMENT_WARN_SP ();	/* appends 'eol'';''spc''--#MKF WARNING:''spc' */
}

/* prints current line
 * appends commented warning prefix followed by mess in a new line 
 */
_PUBLIC_ void
IntePrinter::put_ln_WARN__sp (const char *mess)
{
  line ();
  PRINT_COMMENT_WARN_SP ();
  space (mess);			/* appends 'eol'';''spc''--#MKF WARNING:''spc'<mess>'spc' */
}

/* prints current line
 * prints commented warning prefix followed by mess in a new line 
 * terminates on a new empty line
 */
_PUBLIC_ void
IntePrinter::put_ln_WARN__ln (const char *mess)
{
  line ();
  PRINT_COMMENT_WARN_SP ();
  line (mess);			/* appends 'eol'';''spc''--#MKF WARNING:''spc'<mess>'eol' */
}

/* prints current line
 * appends commented warning prefix followed by "in file"-name-space in a new line 
 */
_PUBLIC_ void
IntePrinter::put_inFile__sp (const char *name)
{
  space ("in file");
  PRINT_FILENAME_SP (name);
}

/* prints current line
 * appends commented warning prefix followed by "in file"-name-space in a new line 
 */
_PUBLIC_ void
IntePrinter::put_ln_WARN_inFile__sp (const char *name)
{
  put_ln_WARN_sp ();
  put_inFile__sp (name);
}

/* +=+=+=+=+=+=+=+=+ ERROR +=+=+=+=+=+=+=+=+ 
 */
/* prints current line
 * appends commented error prefix 
 */
_PUBLIC_ void
IntePrinter::put_ERRO__sp (const char *mess)
{
  PRINT_COMMENT_ERRO_SP ();
  space (mess);			/* appends ';''spc''-##MKF ERROR:''spc'<mess>'spc' */
}

_PUBLIC_ void
IntePrinter::put_ln_ERRO_sp ()
{
  line ();
  PRINT_COMMENT_ERRO_SP ();	/* appends 'eol'';''spc''-##MKF ERROR:''spc' */
}

/* prints current line
 * appends commented error prefix followed by mess followed by a space in a new line 
 */
_PUBLIC_ void
IntePrinter::put_ln_ERRO__sp (const char *mess)
{
  put_ln_ERRO_sp ();
  space (mess);
}

/* prints current line
 * appends commented error prefix followed by mess followed by a space in a new line 
 */
_PUBLIC_ void
IntePrinter::put_ln_ERRO__ln (const char *mess)
{
  put_ln_ERRO_sp ();
  line (mess);
}

/* prints current line
 * appends commented error prefix followed by "in file"-name-space in a new line 
 */
_PUBLIC_ void
IntePrinter::put_ln_ERRO_in__sp (const char *name)
{
  put_ln_ERRO_sp ();
  put_inFile__sp (name);
}

/* +=+=+=+=+=+=+=+=+ FATAL +=+=+=+=+=+=+=+=+ 
 */
/* prints current line
 * appends commented error prefix 
 */
void
IntePrinter::put_ln_FATA_sp ()
{
  line ();
  PRINT_COMMENT_FATA_SP ();	/* appends 'eol'';''spc''###MKF FATAL ERROR:''spc' */
}

void
IntePrinter::put_ln_FATA__sp (const char *mess)
{
  line ();
  PRINT_COMMENT_FATA_SP ();
  space (mess);			/* appends 'eol'';''spc''###MKF FATAL ERROR:''spc'<mess>'spc' */
}

void
IntePrinter::put_ln_FATA__ln (const char *mess)
{
  line ();
  PRINT_COMMENT_FATA_SP ();
  line (mess);			/* appends 'eol'';''spc''###MKF FATAL ERROR:''spc'<mess>'eol' */
}

void
IntePrinter::put_ln_FATA__sp__ln (const char *mess1, const char *mess2)
{
  line ();
  PRINT_COMMENT_FATA_SP ();
  space (mess1);
  line (mess2);
/* appends 'eol'';''spc''###MKF FATAL ERROR:''spc'<mess1>'spc'<mess2>'eol' */
}

/* +=+=+=+=+=+=+=+=+ DEBUG +=+=+=+=+=+=+=+=+ 
 */

/* prints current line
 * appends commented debug prefix in a new line
 */
void
IntePrinter::open_DEBUG_sp ()
{
  freeze_indent (pk_false);
  PRINT_COMMENT_DEBUG_SP ();	/* appends ';''spc''---MKF DEBUG:''spc' */
}

/* prints current line
 * appends commented debug prefix in a new line
 */
void
IntePrinter::put_ln_DEBU_sp ()
{
  line ();
  PRINT_COMMENT_DEBUG_SP ();	/* appends 'eol'';''spc''---MKF DEBUG:''spc' */
}

/* prints current line
 * appends commented debug prefix in a new line
 */
void
IntePrinter::close_DEBUG ()
{
  release_indent (pk_false);
}

/* prints current line
 * appends commented debug prefix followed by mess-space in a new line
 */
void
IntePrinter::put_ln_DEBU__sp (const char *mess)
{
  line ();
  PRINT_COMMENT_DEBUG_SP ();
  space (mess);			/* appends 'eol'';''spc''---MKF DEBUG:''spc'<mess>'spc' */
}

/* prints current line
 * appends commented debug prefix followed by mess-space in a new line
 */
void
IntePrinter::put_ln_DEBU__ln (const char *mess)
{
  line ();
  PRINT_COMMENT_DEBUG_SP ();
  line (mess);			/* appends 'eol'';''spc''---MKF DEBUG:''spc'<mess>'eol' */
}

/* prints current line
 * appends commented warning prefix followed by "in file"-name-space in a new line 
 */

IntePrinter::IntePrinter (int verLevel, int lineLgth, boolean * correct)	/* PLG 2007_03_02 should not fail DONE */
  :
LogPrinter (verLevel == 0, "==>", stderr, "stderr", lineLgth, correct)
{
}

IntePrinter::IntePrinter (int verLevel, int lineLgth, const char *brkStr,	/* PLG 2007_03_02 should not fail DONE */
			  char continuationChar, boolean * correct):
LogPrinter (verLevel == 0, "==>", stderr, "stderr", lineLgth, brkStr, continuationChar, correct)
{
}
