#define STEPIFCONSTANTCHAR(_CORRECT_, _RES_, _ISEOL_)
/* ==========  ==========  ==========  ========== TITLE: lexical context
 */
/* ==========  ==========  ==========  ========== TITLE: these attributes
 */
_PUBLIC_ _VIRTUAL_ const char *
Lexical::myClassName ()
{
  return "Lexical";
}


/* 2004-12-07, 2007-02-06
 * returns in <leftChar> (<rightChar>) initial left (right) parameter tag
 * this remains unchanged
 * 2004-12-07 */
_PUBLIC_ void
Lexical::get_lexicalMarks (ref2InteReader * inBuffer, char *leftChar, char *rightChar, char *stringChar, char *commandChar)	/* DONE */
{
  (*inBuffer) = this_inBuffer;
  (*leftChar) = this_openingChar;
  (*rightChar) = this_closingChar;
  (*stringChar) = this_stringTag;
  (*commandChar) = this_commandChar;
}

/* ==========  ==========  ==========  ========== TITLE: LOG
 */
/* ==========  ==========  ==========  ========== TITLE: lexical context printing
 */

/* PLG 2008-06-04
 * PRE: <outBuffer> is not NIL_IntePrinter; 
 *      <outBuffer> == STRING
 * POST:<outBuffer> == STRING '$$' L R C S 'spc'
 *      where  L, R, C, S are respectively this_openingChar, this_closingChar, this_commandChar, this_stringTag
 */
_PUBLIC_			/* IP_ */
  void
Lexical::out_lexicalContext_sp (ref2IntePrinter outBuffer)	/* DONE */
{
  outBuffer->put_lexicalContext_sp (this_openingChar, this_closingChar, this_commandChar, this_stringTag);
}

/* PLG 2008-06-04
 * PRE: <outBuffer> is not NIL_IntePrinter; 
 *      <outBuffer> == STRING
 * POST:<outBuffer> == STRING '$$' L R C S 'eol'
 *      where  L, R, C, S are respectively this_openingChar, this_closingChar, this_commandChar, this_stringTag
 */
_PUBLIC_			/* IP_ */
  void
Lexical::out_lexicalContext_ln (ref2IntePrinter outBuffer)	/* DONE */
{
  outBuffer->put_lexicalContext_ln (this_openingChar, this_closingChar, this_commandChar, this_stringTag);
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_stringMark (ref2IntePrinter outBuffer)	/* DONE */
{
  outBuffer->print (this_stringTag);
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_stringConstant (ref2IntePrinter outBuffer, const char *_str)	/* DONE */
{
  outBuffer->put_stringConstant (this_stringTag, _str);
}

_PUBLIC_ void
Lexical::out_externName (ref2IntePrinter outBuffer, const char *identName)	/* DONE */
{
  outBuffer->put_externTAG ();
  outBuffer->print (identName);
  outBuffer->put_externTAG ();
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_externNameCommand (ref2IntePrinter outBuffer, const char *identName)	/* DONE */
{
  outBuffer->put_externNameCallHeader (this_commandChar, identName);
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_fileNameCommand (ref2IntePrinter outBuffer, const char *identName)	/* DONE */
{
  outBuffer->put_fileNameCallHeader (this_commandChar, identName);
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_fileNameValue (ref2IntePrinter outBuffer, const char *identName)	/* DONE */
{
  outBuffer->put_fileNameValue (identName);
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_varNameCommand (ref2IntePrinter outBuffer, const char *identName)	/* DONE */
{
  outBuffer->put_varNameCallHeader (this_commandChar, identName);
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_parameter (ref2IntePrinter outBuffer, const char *identName)	/* DONE */
{
  outBuffer->put_parameter (identName, this_openingChar, this_closingChar);
}

/* PLG 2008-06-04
 * PRE: <outBuffer> is not NIL_IntePrinter; 
 *      <outBuffer> == STRING
 * POST:<outBuffer> == STRING C 'context''spc'
 *      where  C is this_commandChar
 */
_PUBLIC_			/* IP_ */
  void
Lexical::out_contextDeclHeader_spTab (ref2IntePrinter outBuffer)	/* DONE */
{
  outBuffer->put_contextDeclHeader_spTab (this_commandChar);
}

/* PLG 2008-06-04
 * PRE: <outBuffer> is not NIL_IntePrinter; 
 *      <outBuffer> == STRING
 * POST:<outBuffer> == STRING C 'boot' 'eol'
 *      where  C is this_commandChar
 */
_PUBLIC_			/* IP_ */
  void
Lexical::out_bootDeclHeader_ln (ref2IntePrinter outBuffer)	/* DONE */
{
  outBuffer->put_bootCommand_ln (this_commandChar);
}

/* PLG 2008-06-04
 * PRE: <outBuffer> is not NIL_IntePrinter; 
 *      <outBuffer> == STRING
 * POST:<outBuffer> == STRING 'eol' ';''spc''{''spc'
 *      set ';' as line prefix
 */
_PUBLIC_			/* IP_ */
  void
Lexical::out_ln_setComment_declOpening_sp (ref2IntePrinter outBuffer)	/* DONE */
{
  outBuffer->put_ln_setComment_declOpening_sp ();
}

/* PLG 2008-06-04
 * PRE: <outBuffer> is not NIL_IntePrinter; 
 *      <outBuffer> == STRING
 * POST:<outBuffer> == STRING '$$' L R C S 'spc' C 'define' 'spc'
 *      where  L, R, C, S are respectively this_openingChar, this_closingChar, this_commandChar, this_stringTag
 */
_PUBLIC_ void
Lexical::out_defineHeader_sp (ref2IntePrinter outBuffer)	/* DONE */
{
  out_lexicalContext_sp (outBuffer);
  outBuffer->put_defineCommand_sp (this_commandChar);
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_staticCommand_sp (ref2IntePrinter outBuffer)	/* DONE */
{
  outBuffer->put_staticCommand_sp (this_commandChar);
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_stringType_sp (ref2IntePrinter outBuffer)	/* DONE */
{
  outBuffer->put_stringType_sp (this_commandChar);
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_listType_sp (ref2IntePrinter outBuffer)	/* DONE */
{
  outBuffer->put_listType_sp (this_commandChar);
}

/* PLG 2007-03-20
 * <outBuffer> is not NIL_IntePrinter
 * prints in <outBuffer>: contextual list or string notation notation
 */
_PUBLIC_ void
Lexical::out_argumentType_sp (ref2IntePrinter outBuffer, boolean isGlobal, boolean isList)
{
  if (isList)
    out_listType_sp (outBuffer);
  else
    out_stringType_sp (outBuffer);
  if (isGlobal)
    out_staticCommand_sp (outBuffer);
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_iterate_sp (ref2IntePrinter outBuffer)	/* DONE */
{
  outBuffer->put_iterate_sp (this_commandChar);
}

/* PLG 2007-03-20
 * <outBuffer> is not NIL_IntePrinter
 * prints in <outBuffer>: contextual file context writting attibutes
 */
_PUBLIC_			/* IP_ */
  void
Lexical::out_fileWriteContext_sp (ref2IntePrinter outBuffer, boolean isExec)	/* DONE */
{
  outBuffer->put_fileWriteContext_sp (this_commandChar, isExec);
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_fileWriteContext_sp (ref2IntePrinter outBuffer, boolean isExec, const char *brkStr, char continuationCharacter)	/* DONE */
{
  outBuffer->put_fileWriteContext_sp (this_commandChar, this_stringTag, isExec, brkStr, continuationCharacter);
}

/* PLG 2007-03-20
 * <outBuffer> is not NIL_IntePrinter
 * prints in <outBuffer>: contextual varaiable attibutes
 */
_PUBLIC_			/* IP_ */
  void
Lexical::out_varAttributes_sp (ref2IntePrinter outBuffer, boolean isExec, boolean isBuildable)	/* DONE */
{
  outBuffer->put_varAttributes_sp (this_commandChar, isExec, isBuildable);
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_varAttributes_ln (ref2IntePrinter outBuffer, boolean isExec, boolean isBuildable, boolean condMark)	/* DONE */
{
  outBuffer->put_varAttributes_sp (this_commandChar, isExec, isBuildable);
  if (condMark)
    outBuffer->put_conditionMark_ln ();
  else
    outBuffer->line ();
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_callHeader (ref2IntePrinter outBuffer, const char *CString_name)	/* DONE */
{
  outBuffer->put_callHeader (this_commandChar, CString_name);
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_callOpening_sp (ref2IntePrinter outBuffer, const char *CString_name)	/* DONE */
{
  outBuffer->put_callOpening_sp (this_commandChar, CString_name);
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_callClosing (ref2IntePrinter outBuffer)
{
  outBuffer->put_closeTAG ();
}


_PUBLIC_			/* IP_ */
  void
Lexical::out_ancestorType_sp (ref2IntePrinter outBuffer)	/* DONE */
{
  outBuffer->put_ancestorType_sp (this_commandChar);
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_nodeType_sp (ref2IntePrinter outBuffer)	/* DONE */
{
  outBuffer->put_nodeType_sp (this_commandChar);
}

_PUBLIC_			/* IP_ */
  void
Lexical::out_contextType_sp (ref2IntePrinter outBuffer)	/* DONE */
{
  outBuffer->put_contextType_sp (this_commandChar);
}

/* PLG 2008-06-04
 * PRE:<outBuffer> == STRING
 * POST:<outBuffer> == STRING 'eol' '{' 'spc'
 */
_PUBLIC_			/* IP_ */
  void
Lexical::out_ln_declOpening_sp (ref2IntePrinter outBuffer)	/* DONE */
{
  outBuffer->put_ln_declOpening_sp ();
  outBuffer->put_lexicalContext_sp (this_openingChar, this_closingChar, this_commandChar, this_stringTag);
}

/* PLG 2008-06-04
 * PRE:<outBuffer> == STRING, <this_commandChar> = C
 * POST:<outBuffer> == STRING 'eol' '{' 'spc' C 'context''spc' 
 */
_PUBLIC_			/* IP_ */
  void
Lexical::out_ln_declOpening_context_spTab (ref2IntePrinter outBuffer)
{
  out_ln_declOpening_sp (outBuffer);	/* appends 'eol' '{' 'spc' */
  outBuffer->tabDecl ();
}

/* ==========  ==========  ==========  ========== TITLE: READER
 */

/* ==========  ==========  ==========  ========== TITLE: LOG
 */

_PRIVATE_			/* IR_G3 */
  void
Lexical::logAS_in__lineColumn_ln ()
{
  if (this_inBuffer != NIL_InteReader)
    this_inBuffer->log_in__lineColumn_ln ();
}

/* ==========  ==========  ==========  ========== TITLE: LOG DEBUG
 */
_PUBLIC_			/* IR_G4 */
  void
Lexical::log_ASDEBUG (const char *mess)
{
  if (this_inBuffer != NIL_InteReader)
    this_inBuffer->log_ASDEBUG (mess);
}

/* ==========  ==========  ==========  ========== TITLE: WARNING
 */
/* PLG 2007-03-20 
 */
_PUBLIC_ void
Lexical::ASInfo_emptyBuilder_ln ()
{
  if (FALSE)
    {
      //  if ( levelInfo_ln_WARN_sp() ) {
      logAS_in__lineColumn_ln ();
      LOG_STR_LN ("empty builder");
    }
}

/* ==========  ==========  ==========  ========== TITLE: LOG ERROR
 */

_PUBLIC_ void
Lexical::logERR_ln_LineColumn_ln__ln (const char *mess)
{
  LOG_LN_ERRO_SP ();
  logAS_in__lineColumn_ln ();
  LOG_STR_LN (mess);
}

/* ==========  ==========  ==========  ========== TITLE: FATAL
 */

_PRIVATE_ void
Lexical::logFATA_ln_trace_ln ()
{
  LOG_LN_FATA_SP ();
  logAS_in__lineColumn_ln ();
}

_PRIVATE_ void
Lexical::logFATA_ln_trace_ln__ln (const char *mess)
{
  logFATA_ln_trace_ln ();
  LOG_STR_LN (mess);
}

_PRIVATE_ void
Lexical::logFATA_ln_trace_ln__sp__ln (const char *mess1, const char *mess2)
{
  logFATA_ln_trace_ln ();
  LOG_STR_SP_STR_LN (mess1, mess2);
}

_PRIVATE_ void
Lexical::logFATA_ln_trace_ln__sp__sp__ln (const char *mess1, const char *mess2, const char *mess3)
{
  logFATA_ln_trace_ln ();
  LOG_STR_SP_STR_SP (mess1, mess2);
  LOG_STR_LN (mess3);
}

_PRIVATE_ void
Lexical::ASFatal_ln__ln (const char *mess)
{
  logFATA_ln_trace_ln ();
  LOG_STR_LN (mess);
  set_fatal ();
}

_PRIVATE_ void
Lexical::ASFatal_ln__sp__ln (const char *mess1, const char *mess2)
{
  logFATA_ln_trace_ln ();
  LOG_STR_SP_STR_LN (mess1, mess2);
  set_fatal ();
}

_PRIVATE_ void
Lexical::ASFatal_ln__sp__sp__ln (const char *mess1, const char *mess2, const char *mess3)
{
  logFATA_ln_trace_ln ();
  LOG_STR_SP_STR_SP (mess1, mess2);
  LOG_STR_LN (mess3);
  set_fatal ();
}

_PUBLIC_ void
Lexical::ASFatal_defaultMissing (const char *CString_name)
{
  logFATA_ln_trace_ln__sp__ln ("default missing in", CString_name);
}

_PUBLIC_ void
Lexical::ASFatal_afterDeclOpening ()
{
  logFATA_ln_trace_ln__ln ("after reading declaration opening mark");
  set_fatal ();
}

_PUBLIC_ void
Lexical::ASFatal_expected (const char *mess)
{
  logFATA_ln_trace_ln__sp__ln ("expected", mess);
  set_fatal ();
}

_PUBLIC_ void
Lexical::ASFatal_unexpected (const char *mess)
{
  logFATA_ln_trace_ln__sp__ln ("unexpected", mess);
  set_fatal ();
}

_PUBLIC_ void
Lexical::ASFatal_unexpected (boolean printMess, const char *mess)
{
  if (printMess)
    logFATA_ln_trace_ln__sp__ln ("unexpected", mess);
  set_fatal ();
}

/* ==========  ==========  ==========  ========== TITLE: FATAL LOG
 */
_PUBLIC_ void
Lexical::ASFatal_emptyIteratorList ()	/* PLG check required eol, change _nSp to _spStar_ */
{
  logFATA_ln_trace_ln__ln ("empty string list not allowed in iteration");
  set_fatal ();
}

_PUBLIC_ void
Lexical::ASFatal_contextCycle ()	/* PLG check required eol, change _nSp to _spStar_ */
{
  logFATA_ln_trace_ln__ln ("cyclic context references");
  set_fatal ();
}

/* 2005-03-29
 */
_PUBLIC_ void
Lexical::ASFatal_list_argument (boolean printMail)
{
  if (printMail)
    logFATA_ln_trace_ln__ln ("expected: argument list");
  set_fatal ();
}

_PUBLIC_ void
Lexical::ASFatal_missingDecl (boolean printMess, const char *category, const char *CString_name)
{
  if (printMess)
    logFATA_ln_trace_ln__sp__sp__ln (category, CString_name, ": declaration missing");
  set_fatal ();
}

_PUBLIC_ void
Lexical::ASFatal_named_typeConflict_ln (const char *CString_name, const char *typeExpected)
{
  logFATA_ln_trace_ln__sp__sp__ln (CString_name, ": expected type is", typeExpected);
  set_fatal ();
}

_PUBLIC_ void
Lexical::ASFatal_named_typeConflict_ln (const char *typeExpected)
{
  if (this_inBuffer != NIL_InteReader)
    ASFatal_named_typeConflict_ln (this_inBuffer->unsafeGetAtom (), typeExpected);
}

_PUBLIC_ void
Lexical::ASFatal_expansion (const char *mess)
{
  logFATA_ln_trace_ln__sp__ln (mess, "required expansion failed");
  set_fatal ();
}

_PUBLIC_ void
Lexical::ASFatal_doubleDecl (const char *CString_name)
{
  logFATA_ln_trace_ln__sp__ln (CString_name, ": double declaration");
  set_fatal ();
}

_PUBLIC_ void
Lexical::ASFatal_eof ()
{
  this_inBuffer->fatal_eof ();
  set_fatal ();
}

/* ==========  ==========  ==========  ========== TITLE: ERROR recovery
 */


/* ==========  ==========  ==========  ========== TITLE: lexical context line reading
 */

_PUBLIC_			/* ILA_G */
char *
Lexical::strdupRemainingString ()
{
  return this_inBuffer->strdupRemainingString ();
}

/* PLG 2008_07-04
 * success: BUFFER = PREFIX.[referenceTAG] <this_openingChar> [White*] # [Character_but_Space][Any*][EOF]
 *             <isEol> is set FALSE
 *          BUFFER = PREFIX.[referenceTAG] <this_openingChar> opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
 *             <isEol> is set TRUE
 * failure: BUFFER = PREFIX.#[Any*], [referenceTAG]<this_openingChar> is not a prefix in [Any*]
 *             <isEol> is set FALSE
 *          BUFFER = PREFIX.#[eol],
 *             <isEol> is set TRUE
 */
_PUBLIC_			/* ILA_G */
  boolean Lexical::stepIf_referenceHead_spStar_ (boolean * isEol)	/* DONE */
{
  return this_inBuffer->stepIf_referenceHead_spStar_ (this_openingChar, isEol);
}

/* ==========  ==========  ==========  ========== TITLE: lexical context file reading
 */
_PUBLIC_			/* IR_G1 */
  boolean Lexical::isString_userIdentifier (char *CString_name)
{
  return this_inBuffer->isString_userIdentifier (CString_name);
}

/* PLG 2009-08-11 REF TODO
 * assumes: NONE
 * success: FILE = PREFIX . [Character*][eol] # [Any*][EOF]
 * failure: FILE = PREFIX . [Character*] # [EOF] 
 *          or FILE = PREFIX . ... # [EOF], reading failed
 *          error message is printed; this is set ERRORCOMPLETED or ERRORCLOSED
 */
_PUBLIC_			/* IR_G5 */
  boolean Lexical::load_nl ()
{
  return this_inBuffer->req_nl_ ();	/* success: FILE = PREFIX . [Character*][eol] # [Any*][EOF] 
					 * failure: error message is printed; this is set ERRORCOMPLETED or ERRORCLOSED */
}

/* PLG 2009-08-11 REF TODO
 * assumes: FILE = PREFIX . [Any*][EOF]
 * success: FILE = PREFIX . [eol] # [Any*][EOF]
 * failure: FILE = PREFIX . # [Character][Any*][EOF]
 *              <correct> remains unchanged
 *          FILE = PREFIX . # [EOF] 
 *          or FILE = PREFIX . ... [EOF], reading failed
 *              <correct> is set FALSE
 *              error message is printed
 *              this is set ERRORCOMPLETED or ERRORCLOSED
 */
_PUBLIC_			/* IR_G5 */
  boolean Lexical::loadIf_eol_ (boolean * correct)
{
  if (this_inBuffer->is_lineCompleted ())
    {
      /* FILE = PREFIX .# opt{[eol][Any*]}[EOF] */
      if (this_inBuffer->req_nl_ ())
	/* FILE = PREFIX . [eol] # [Any*][EOF] */
	return pk_true;
      /* FILE = PREFIX . # [EOF] 
       * FILE = PREFIX . ... # [EOF], reading failed
       * error message is printed; this is set ERRORCOMPLETED or ERRORCLOSED */
      (*correct) = pk_false;
    }
  /* FILE = PREFIX . # [Character][Any*][EOF] */
  return pk_false;
}

/* PLG 2009-08-13, PLG 2009-09-30 REF TODO
 * assumes: NONE
 * success: FILE = PREFIX . [Character*][eol][fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 * failure: FILE = PREFIX . [Character*] # [EOF]
 *             this is set XXXCOMPLETED
 *          FILE = PREFIX . ... # [EOF], reading failed
 *             error message is printed; this is set ERRORCOMPLETED
 * <isEof> is set according to  # position
 */
_PUBLIC_			/* IR_G5_0 */
  boolean Lexical::step_nl_fSpStar_ (boolean * isEof)
{
  return this_inBuffer->step_nl_fSpStar_ (isEof);
}

/* PLG 2009-09-15 REF TODO
 * assumes: NONE
 * success: FILE = PREFIX . [Character*][eol] [fileSpace*] # [Character_but_Space][Any*][EOF]
 * failure: FILE = PREFIX . [Character*]opt{[eol][fileSpace*]} # [EOF] 
 *          FILE = PREFIX . ... # [EOF], reading failed
 *          error message is printed; this is set ERRORCOMPLETED
 */
_PUBLIC_			/* IR_G5bis */
  boolean Lexical::req_nl_fSpStar_nSp ()
{
  return this_inBuffer->req_nl_fSpStar_nSp ();
}

/* PLG 2009-08-11 REF TODO
 * reads a list type mark ('*') and skip following spaces
 * assumes: IS_READY() ==> FILE = PREFIX . [Character_but_Space][Any*][EOF]
 * success: FILE = PREFIX . '*'[fileSpace*] # [Character_but_Space][Any*][EOF]
 * failure: FILE = PREFIX .# [Character_but_Space_but_'*'][Any*][EOF]
 *            <correct> remains unchanged
 * failure: FILE = PREFIX . '*'[fileSpace*] # [EOF]
 *          or  FILE = PREFIX . ...  # [EOF] error occurred during reading
 *          or file is closed
 *            error message is printed
 *            <correct> is set FALSE
 *            this is set  ERRORCOMPLETED or ERRORCLOSED
 */
_PUBLIC_			/* IR_G6 */
  boolean Lexical::stepIf_listMark_fSpStar_nSp (boolean * correct)
{
  return this_inBuffer->stepIf_listMark_fSpStar_nSp (correct);
}

/* PLG 2009-08-11
 * assumes: IS_READY() ==> FILE = PREFIX . [Character_but_Space][Any*][EOF]
 * success: FILE = PREFIX . '{' opt{[lineSpaces]}[eol] # [Any*][EOF]
 *             <correct> remains unchanged
 * failure: FILE = PREFIX .# [Any_but_'{'][Any*][EOF]
 *             <correct> remains unchanged
 * failure: FILE = PREFIX . '{' [White*] # [Character_but_Space][Any*] 
 *          or FILE = PREFIX . '{' opt{[lineSpaces]} # [EOF]
 *          or FILE = PREFIX . ... [EOF], reading failed
 *             <correct> is set FALSE
 *             error message is printed
 *             this is set ERRORREADY or ERRORCOMPLETED
 */
_PUBLIC_			/* IR_G7 */
  boolean Lexical::stepIf_bodyPreludeO_spStar_eol_ (boolean * correct)
{
  return this_inBuffer->stepIf_bodyPreludeO_spStar_eol_ (correct);
  /* success: FILE = PREFIX . '{' opt{[lineSpaces]}[eol] # [Any*][EOF]; <correct> remains unchanged */
  /* failure; FILE = PREFIX .# [Any_but_'{'][Any*][EOF]
   *             <correct> remains unchanged
   *          FILE = PREFIX . '{' [White*] # [Character_but_Space][Any*] 
   *          or FILE = PREFIX . '{' opt{[lineSpaces]} # [EOF]
   *          or FILE = PREFIX . ... [EOF], reading failed
   *             <correct> is set FALSE
   *             error message is printed
   *             this is set ERRORXXX */
}

/* PLG 2009-08-11 
 * assumes: IS_READY() ==> FILE = PREFIX . [Character_but_Space][Any*][EOF]
 * success: FILE = PREFIX . '}?'[fileSpace*] # [Character_but_Space][Any*][EOF]
 *            <correct> remains unchanged
 * failure: FILE = PREFIX .# [Character_but_Space_but_'}?'][Any*][EOF]
 *            <correct> remains unchanged
 * failure: FILE = PREFIX . '}?'[fileSpace*] # [EOF]
 *          or FILE = PREFIX . ... [EOF], reading failed
 *            error message is printed
 *            <correct> is set FALSE
 *            this is set  ERRORCOMPLETED or ERRORCLOSED
 */
_PUBLIC_			/* IR_G8 */
  boolean Lexical::stepIf_ancestorMark_fSpStar_nSp (boolean * correct)
{
  return this_inBuffer->stepIf_ancestorMark_fSpStar_nSp (correct);
}

/* PLG 2008_07-02, PLG 2009-08-11
 * assumes: IS_READY() ==> FILE = PREFIX . [Character_but_Space][Any*][EOF]
 * success: FILE = PREFIX . '}/'opt{[lineSpaces]}[eol] # [Any*][EOF]
 *             <correct> remains unchanged
 * failure: FILE = PREFIX .# [Character_but_Space][Any*], '}/' is not a prefix of [Character_but_Space][Any*]
 *             <correct> remains unchanged
 * failure:  FILE = PREFIX . '}/' [White*] # [Character_but_Space][Any*] 
 *          or FILE = PREFIX . '}/' opt{[lineSpaces]} # [EOF]
 *          or FILE = PREFIX . ... [EOF], reading failed
 *             <correct> is set FALSE
 *             error message is printed
 *            this is set  ERRORCOMPLETED or ERRORCLOSED
 */
_PUBLIC_			/* IR_G9 */
  boolean Lexical::stepIf_defaultOpeningLine_eol_ (boolean * correct)
{
  return this_inBuffer->stepIf_defaultOpeningMark_spStar_eol_ (correct);
}

/* PLG 2009-08-11
 * assumes: IS_READY() ==> FILE = PREFIX . [Character_but_Space][Any*][EOF]
 * success: FILE = PREFIX . '(' [fileSpace*] # [Character_but_Space][Any*][EOF]
 *             <correct> remains unchanged
 * failure: FILE = PREFIX .# [Character_but_Space_but_'('][Any*][EOF]
 *            <correct> remains unchanged
 * failure: FILE = PREFIX . '('[fileSpace*] # [EOF]
 *          FILE = PREFIX ... # [EOF], reading failed
 *          or file is closed
 *          error message is printed
 *          <correct> is set FALSE
 *            this is set  ERRORCOMPLETED or ERRORCLOSED
 */
_PUBLIC_			/* IR_G10 */
  boolean Lexical::stepIf_listO_fSpStar_nSp (boolean * correct)
{
  return this_inBuffer->stepIf_listO_fSpStar_nSp (correct);
}

/* PLG 2009-08-11 
 * assumes: IS_READY() ==> FILE = PREFIX . [Character_but_Space][Any*][EOF]
 * success: FILE = PREFIX . '(' [fileSpace*] # [Character_but_Space][Any*][EOF]
 * failure: FILE = PREFIX .# [Character_but_Space_but_'('][Any*][EOF]
 *          FILE = PREFIX . '('[fileSpace*] # [EOF]
 *          FILE = PREFIX ... # [EOF], reading failed
 *          or file is closed
 *            error message is printed
 *            <correct> is set FALSE
 *            this is set ERROR
 */
_PUBLIC_			/* IR_G11 */
  boolean Lexical::req_listO_fSpStar_nSp ()
{
  return this_inBuffer->req_listO_fSpStar_nSp ();
}

/* PLG 2009-09-22 OK
 * assumes: IS_READY() ==> FILE = PREFIX . [Character_but_Space][Any*][EOF]
 * success: FILE = PREFIX . ')' [White*] # [Character_but_Space][Any*][EOF]
 *          FILE = PREFIX . ')' opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
 * failure: FILE = PREFIX . ... # [EOF], reading or recovering failed
 *
 *          WELLBALANCED is [Any_but_'}:'_but_'}']*  that is well balanced wrt to '(', ')'
 *          FILE = PREFIX . [Character_but_'}:'_but_'}']*  # '}'[Any*][EOF]
 *             [Character_but_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>> 
 *          FILE = PREFIX . WELLBALANCED ')'[White*] # [Character_but_Space][Any*][EOF]
 *            or   PREFIX . WELLBALANCED ')'opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
 *          error message is printed
 * <isEol> is set according to  # position
 */
_PUBLIC_			/* IR_G12 */
  boolean Lexical::req_listC_spStar_ (boolean * isEol)
{
  if (this_inBuffer->req_listC_spStar_ (isEol))
    /* FILE = PREFIX . ')' [White*] # [Character_but_Space][Any*][EOF]
     * FILE = PREFIX . ')' opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
     * <isEol> is set according to  # position */
    return pk_true;
  /* FILE = PREFIX . [Character_but_Space_but_')'][Any*][EOF]
   *             error message is printed */
  if (recover_second_spStar_ (isEol));	/* WELLBALANCED is [Character_but_'}:'_but_'}']* that is well balanced wrt to '(', ')'
					 * FILE = PREFIX . [Character_but_'}:'_but_'}']*  # '}'[Any*][EOF]
					 *             [Character_but_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>> 
					 * FILE = PREFIX . WELLBALANCED ')'[White*] # [Character_but_Space][Any*][EOF]
					 *   or   PREFIX . WELLBALANCED ')'opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
					 * FILE = PREFIX . ... # [EOF], reading failed
					 * FILE = PREFIX . WELLBALANCED opt{'('[Any_but_'}:'_but_'}']*} # [EOF], 
					 *              [Any_but_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>>
					 * info or error message is printed; 
					 * <isEol> is set according to # position  */
  return pk_false;
}

/* 2005-03-22, PLG 2007-06-25, PLG 2009-09-30, DOING DOING DOING DOING DOING 
 * assumes: IS_READY() ==> FILE = PREFIX . [Character_but_Space][Any*][EOF]
 * success: FILE = PREFIX . ')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 * failure: WELLBALANCED is [Any_but_'}:'_but_'}']* in which '(', ')' are well balanced
 *          FILE = PREFIX . ... # [EOF], reading failed
 *          FILE = PREFIX . WELLBALANCED opt{'('[Any_'}:'_but_'}']*} # [EOF], 
 *             [Any_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>>
 *          
 *          FILE = PREFIX . [Any_but_'}:'_but_'}']*  # '}:'[Any*][EOF]
 *            or   PREFIX . [Any_but_'}:'_but_'}']*  # '}'[Any*][EOF]
 *             [Any_but_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>> 
 *          FILE = PREFIX . WELLBALANCED ')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *          error message is printed
 * <isEof> is set according to # position
 */
_PUBLIC_			/* IR_G13 */
  boolean Lexical::req_listC_fSpStar_ (boolean * isEof)
{
  // log_ASDEBUG("entering Lexical::req_listC_fSpStar_");
  if (this_inBuffer->req_listC_fSpStar_ (isEof))
    /* FILE = PREFIX . ')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF] */
    return pk_true;
  /* FILE = PREFIX . # [Any_but_')'][Any*][EOF] 
   * FILE = PREFIX . ... [EOF], reading failed */
  if (*isEof)
    return pk_false;
  if (recover_second_fSpStar_ (isEof));	/* WELLBALANCED is [Any_but_'}:'_but_'}']* that is well balanced wrt to '(', ')'
					 * FILE = PREFIX . ... # [EOF], reading failed
					 * FILE = PREFIX . WELLBALANCED opt{'('[Any_'}:'_but_'}']*} # [EOF], 
					 * 
					 * FILE = PREFIX . [Any_but_'}:'_but_'}']*  # '}:'[Any*][EOF]
					 *   or   PREFIX . [Any_but_'}:'_but_'}']*  # '}'[Any*][EOF]
					 *             [Any_but_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>> 
					 * FILE = PREFIX . WELLBALANCED ')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
					 *              [Any_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>>
					 * error message is printed
					 * <isEof> is set according to # position
					 */
  return pk_false;
}

/* PLG-2009-08-12
 * success: FILE = PREFIX . '{' [fileWhite*] # [Character_but_White][Any*][EOF]
 *             <correct> remains unchanged
 * failure: FILE = PREFIX .# opt{[Any_but_'{'][Any*]}[EOF]
 *             <correct> remain unchanged
 * failure: FILE = PREFIX . '{' [fileWhite*] # [EOF]
 *          FILE = PREFIX . '{' ... # [EOF], reading failed
 *          error message is printed
 *          <correct> is set false
 *          this is set ERRORCOMPLETED
 */
_PUBLIC_			/* IR_G14 */
  boolean Lexical::stepIf_declOpening_fWhStar_nWh (boolean * correct)
{
  return this_inBuffer->stepIf_declOpening_fWhStar_nWh (correct);
}

/* PLG  2009-08-26, PLG  2009-09-30 REF TODO
 * assumes: IS_READY() ==> FILE = PREFIX . [Character_but_Space][Any*][EOF]
 * success:  FILE = PREFIX . '}'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *                 [Character_but_Space] is not ':' if [fileSpace*] is empty and [EOF] is not reached
 * failure: WELLBALANCED is [Any_but_'}:']* in which '{', '}' are well balanced
 *          FILE = PREFIX . opt{[Character_but_Space_but_'}'] WELLBALANCED } # '}:' [Any*][EOF]
 *            or   PREFIX . [Character_but_Space_but_'}'] WELLBALANCED '}' [fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *            or   PREFIX . [Character_but_Space_but_'}'] WELLBALANCED  # [EOF]
 *            or   PREFIX . '}' ... # [EOF], reading failed
 *          error message is printed
 * <isEof> is set according to # position
 */
_PUBLIC_			/* IR_G15 */
  boolean Lexical::req_declClosing_fSpStar_ (boolean * isEof)
{
  boolean
    isMain;
  if (this_inBuffer->req_declClosing_fSpStar_ (isEof))
    /* FILE = PREFIX . '}'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF], '}' is not followed by ':' */
    return pk_true;
  /* FILE = PREFIX . # [Any_but_'}'][Any*][EOF] 
   * PREFIX . # '}:'[Any*][EOF]
   * FILE = PREFIX . ... [EOF], reading failed */
  if (*isEof)
    return pk_false;
  if (this_inBuffer->recover_main_fSpStar_ (&isMain, isEof));	/* WELLBALANCED is [Any_but_'}:']*  that is well balanced wrt to '{', '}'
								 * ANY2 is [Any_but_'}:']* that does not match <<WELLBALANCED'}'[Any*]>>
								 * success: FILE = PREFIX . WELLBALANCED '}'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
								 *             <isMain> is set TRUE
								 *          FILE = PREFIX . ANY2  # '}:'[Any*][EOF]
								 *             ANY2 is [Any_but_'}:']* that does not match <<WELLBALANCED'}'[Any*]>> 
								 *             <isMain> is set FALSE
								 *          info message is printed;
								 * failure: FILE = PREFIX . ... # [EOF], reading failed
								 *          FILE = PREFIX . WELLBALANCED '{' ANY2 # [EOF]
								 *          FILE = PREFIX . WELLBALANCED # [EOF]
								 *          error message is printed; this is set ERRORCOMPLETED
								 * <isEof> is set according to # position
								 */
  return pk_false;
}

/* PLG  2009-08-12, PLG  2009-09-30 REF TODO
 * assumes: IS_READY() ==> FILE = PREFIX . [Character_but_Space][Any*][EOF]
 * success: FILE = PREFIX . '}:' [fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 * failure: FILE = PREFIX . [Character_but_Space_but_'}:'][Any_but_'}:']* '}:' [fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *            or   PREFIX . [Character_but_Space_but_'}:'][Any_but_'}:']* # [EOF]
 *            or   PREFIX . '}:' ... # [EOF], somme error occurred
 *          error message is printed
 * <isEof> is set according to # position
 */
_PUBLIC_			/* IR_G16 */
  boolean Lexical::req_funcDeclClosing_fSpStar_ (boolean * isEof)
{
  if (this_inBuffer->req_funcDeclClosing_fSpStar_ (isEof))
    return pk_true;
  if (*isEof)
    return pk_false;
  if (this_inBuffer->recover_funcDecl_fSpStar_ (isEof));	/* success: FILE = PREFIX . [Any_but_'}:']*'}:'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
								 *          info message is printed;
								 * failure: FILE = PREFIX . ... # [EOF], reading failed
								 *          FILE = PREFIX . [Any_but_'}:']* # [EOF]
								 *          error message is printed; this is set ERRORCOMPLETED
								 * <isEof> is set according to # position
								 */
  return pk_false;
}

/*  PLG 2009-08-14, PLG 2009-09-16
 * assumes: IS_READY() ==> FILE = PREFIX . [Character_but_Space][Any*][EOF]
 * success: FILE = PREFIX . <commandChar>'static'[fileSpace*] # [Character_but_Space][Any*][EOF] OK
 *             first character after 'static' is not an IdentCharacter
 *             <isGlobal> is set TRUE
 *          FILE = PREFIX .# [Character_but_Space_but_<commandChar>][Any*][EOF]
 *             <isGlobal> is set FALSE
 * failure: FILE = PREFIX . <commandChar>opt{[Identifier]}[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF], 
 *                      [Identifier] is not 'static'
 *                      or first Character after <commandChar> is not an IdentCharacter
 *                      or [EOF] is reached
 *               this is set ERRORREADY (ERRORCOMPLETED) 
 *          FILE = PREFIX . <commandChar> ... # [EOF], reading failed or internal error
 *               this is set ERRORREADY (ERRORCOMPLETED)  
 *          error message is printed; 
 */
_PUBLIC_			/* IR_G17 REF TODO */
  boolean Lexical::stepOpt_scope_fSpStar_nSp (boolean * isStatic)	/* DONE */
{
  return this_inBuffer->stepOpt_scope_fSpStar_nSp (this_commandChar, isStatic);
}

/* PLG 2009-08-14
 * assumes: IS_READY() ==> FILE = PREFIX . [Character_but_Space][Any*][EOF]
 * success: FILE = PREFIX . <commandChar>[functionType][fileSpace*] # [Character_but_Space][Any*][EOF]
 *              [functionType] belongs to {'ancestor', 'context', 'list', 'node' , 'string'}
 *              <funcTypeCode> is assigned the code associated with [functionType]
 *          FILE = PREFIX .# [Character_but_Space_but_<commandChar>][Any*][EOF]
 *              <funcTypeCode> is assigned nodeCODE
 * failure: FILE = PREFIX . <commandChar>opt{[Identifier]}[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF], 
 *                      [Identifier] does not belong to {'ancestor', 'context', 'list', 'node' , 'string'} 
 *                      or first Character after <commandChar> is not an IdentCharacter
 *                      or [EOF] is reached
 *               this is set ERRORREADY (ERRORCOMPLETED) 
 *          FILE = PREFIX . <commandChar> ... # [EOF], reading failed or internal error
 *               this is set ERRORREADY (ERRORCOMPLETED)  
 *          error message is printed; 
 */
_PUBLIC_			/* IR_G18 REF TODO */
  boolean Lexical::stepOpt_functionType_fSpStar_nSp (int *commandCode)	/* DONE */
{
  return this_inBuffer->stepOpt_functionType_fSpStar_nSp (this_commandChar, commandCode);
}

/* PLG 2009-08-12, PLG 2009-09-30 REF TODO
 * assumes: IS_READY() ==> FILE = PREFIX . [Any+][EOF]
 * success: FILE = PREFIX . [commentTAG][Character*][eol][fileWhite*] # opt{[Character_but_White][Any*]}[EOF]
 *          FILE = PREFIX . [commentTAG][Character*] # [EOF]
 *             [Character*] between [commentTAG] and [eol] (or EOF) are assigned to <comments>
 *             <correct> remains unchanged
 * failure: FILE = PREFIX .# [Any_but_commentTAG][Any*][EOF]
 *             <correct>, <comments> remain unchanged
 * failure: FILE = PREFIX . [Comment] ... # [EOF], reading failed
 *             <correct> is set FALSE, 
 * <isEof> is set according to # position
 */
_PUBLIC_			/* IR_G20 */
  boolean Lexical::stepIf_comment_fWhStar_ (boolean * correct, char **commentCharSeq, boolean * isEof)
{
  return this_inBuffer->stepIf_comment_fWhStar_ (correct, commentCharSeq, isEof);
}

/* 2005-12-12, PLG 2009-09-30 REF TODO
 * assumes: <this_stringTag> is not NULL
  * STRING = <this_stringTag>[Character_but_<this_stringTag>]*<this_stringTag>
 * success: FILE = PREFIX . STRING[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *          a new fresh copy of [Character*] is returned in <strRes>
 *          <correct> remains unchanged
 * failure: FILE = PREFIX .# opt{[Character_but_<this_stringTag>][Any*]}[EOF]
 *                 <correct> remains unchanged
 * failure: FILE = PREFIX . ... # [EOF], internal error or reading failed
 *          FILE = PREFIX . <stringChar> [Character_but_<stringChar>]* [eol][fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *            or   PREFIX . <stringChar> [Character_but_<stringChar>]* # [EOF]
 *          <correct> is set FALSE
 *          error message is printed
 * <isEof> is set TRUE if [EOF] is reached
 */
_PUBLIC_			/* IR_G22 REF TODO */
  boolean Lexical::stepIf_stringConstant_fSpStar_ (boolean * correct, char **strRes, boolean * isEof)	/* DONE */
{
  return this_inBuffer->stepIf_stringConstant_fSpStar_ (this_stringTag, correct, strRes, isEof);
}

/* PLG 2009-08-14, PLG 2009-09-09 REF TODO
 * success: FILE = opt{[Any*][eol]}. # [declClosingTAG][Any*][EOF]
 * failure: FILE = [Any*][Character+] .# [Any*][EOF]
 *          FILE = opt{[Any*][eol]}. # opt{[Any_but_declClosingTAG][Any*]}[EOF]
 *          FILE is not READY, error message is printed; this is set ERRORXXX 
 */
_PUBLIC_			/* IR_G23 */
  boolean Lexical::is_actionClosing ()
{
  return this_inBuffer->is_actionClosing ();
}

/* PLG 2007-03-21,  PLG 2007-06-05, PLG 2009-09-30 REF TODO
 * success: FILE = PREFIX . [_SyntaxAdaptation][fileSpace+] # opt{[Character_but_Space][Any*]}[EOF]
 *            or   PREFIX . [_SyntaxAdaptation] # [EOF]
 *                 with [_SyntaxAdaptation] = [leftCharacter][rightCharacter]opt{[commandCharacter]opt{[stringCharacter]}}
 *                                            <leftChar>, <rightChar>, <commandChar>, <stringChar> are conflict free
 *         <this_openingChar>, <this_closingChar>, <this_commandChar>, <this_stringTag> are respectively assigned
 *                    <leftChar>, <rightChar>, <commandChar>, <stringChar> (or previous alue when tag is missing)
 * failure: syntax as for success, but 2 or more tags among <leftChar>, <rightChar>, <commandChar>, <stringChar> are equal (conflict)
 *                error  message is printed
 *          FILE = PREFIX . opt{[leftCharacter]} # [EOF]
 *                NULL_char is returned in <leftChar> or <rightChar>
 *          FILE = PREFIX . opt{[leftCharacter]}[fileSpace+] # opt{[Character_but_Space][Any*]}[EOF]
 *                NULL_char is returned in <leftChar> or <rightChar>
 *                error message is printed
 *          FILE = PREFIX . opt{[leftCharacter]opt{[rightCharacter]opt{[commandCharacter]}}} # [reservedCharacter][Any*][EOF]
 *                error message is printed
 *          FILE = PREFIX . [leftCharacter][rightCharacter][commandCharacter][stringCharacter] # [Character_but_Space][Any*][EOF]
 *                error message is printed
 *          file error, conflict error occurred during reading, including too large line
 *                error message is printed
 * <isEof> is set according to # position
 */
_PUBLIC_			/* IR_G24 */
  boolean Lexical::stepSet_contextMarks_fSpStar_ (boolean * isEof)	/* DONE */
{
  return this_inBuffer->req_lexInit_fSpStar_ (&this_openingChar, &this_closingChar, &this_commandChar, &this_stringTag, isEof);
}

/* 2005-01-21, PLG 2007-06-05, PLG 2008_07-03, PLG 2009-09-30 TODO
 * reads contextual syntax marks
 * success: FILE = PREFIX . '$$'[_SyntaxAdaptation][fileSpace+] # opt{[Character_but_Space][Any*]}[EOF]
 *            or   PREFIX . '$$'[_SyntaxAdaptation] # [EOF]
 *            with [_SyntaxAdaptation] = [leftCharacter][rightCharacter]opt{[commandCharacter]opt{[stringCharacter]}}
 *                                        <leftChar>, <rightChar>, <commandChar>, <stringChar> conflict free
 *                   <newLexical> is set TRUE
 *                   a new Lexical is pushed and assigned to <new_lexicalContext>
 *                          <its_openingChar>, <its_closingChar>, <its_commandChar>, <its_stringChar> are respectively assigned
 *                               <leftChar>, <rightChar>, <commandChar>, <stringChar> (or previous alue when tag is missing)
 *          FILE = PREFIX . '$$'[fileSpace+] # [Character_but_Space][Any*][EOF],
 *            or   PREFIX . '$$'[fileSpace*] # [EOF]
 *            or   PREFIX . # [eol][fileSpace*]opt{[Character_but_Space][Any*]}[EOF]
 *            or   PREFIX . # opt{[Character_but_'$$'][Any*]}[EOF]
 *                   <newLexical>, <new_lexicalContext> remain unchanged
 *          if [EOF] is reached, <isEof> is set TRUE and this is set COMPLETED
 * failure: FILE = PREFIX . '$$'[_SyntaxAdaptation][fileSpace+] # opt{[Character_but_Space][Any*]}[EOF]
 *            or   PREFIX . '$$'[_SyntaxAdaptation] # [EOF]
 *                  some marks in [_SyntaxAdaptation] are in conflict
 *          FILE = PREFIX . '$$'opt{[leftCharacter]} # [EOF]
 *                <isEof> is set TRUE and this is set COMPLETED
 *          FILE = PREFIX . '$$'opt{[leftCharacter]}[fileSpace+] # opt{[Character_but_Space][Any*]}[EOF]
 *                if [EOF] is reached, <isEof> is set TRUE and this is set COMPLETED
 *          FILE = PREFIX . '$$'opt{[leftCharacter]opt{[rightCharacter]opt{[commandCharacter]}}} # [reservedCharacter][Any*][EOF]
 *                error message is printed
 *          FILE = PREFIX . '$$'[leftCharacter][rightCharacter][commandCharacter][stringCharacter] # [Character_but_Space][Any*][EOF]
 *          <new_lexicalContext>, <newLexical> remain unchanged
 *          FILE = PREFIX . ... [EOF], reading failed
 *          error message is printed
 * <isEof> is set according to # position
 */
_PUBLIC_			/* IR_G24bis */
  boolean Lexical::stepOpt_lexical_fSpStar_ (boolean * newLexical, ref2Lexical * new_lexicalContext, boolean * isEof)
{
  boolean
    isSeparated;
  // log_ASDEBUG("Context::stepOpt_lexical_fSpStar_");
  /*  FILE = PREFIX.'$$'[_SyntaxAdaptation_fSpStar]#opt{[Character_but_Space][Any*]}[EOF] */
  if (this_inBuffer->stepOpt_lexicalModifierMark_fSpStar_ (&isSeparated, isEof))
    {
      /* FILE = PREFIX . '$$'[fileSpace+] # [Character_but_Space][Any*][EOF],
       *   or   PREFIX . '$$'[fileSpace*] # [EOF]
       *                   <isSeparated> is set TRUE
       * FILE = PREFIX . '$$' # opt{[Character_but_Space][Any*]}[EOF], 
       *                   <isSeparated> is set FALSE
       * FILE = PREFIX . [eol][fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
       *   or   PREFIX . # opt{[Character_but_'$$'][Any*]}[EOF]
       *                   <isSeparated> is set TRUE
       * <isEof> is set according to # position */
      if (isSeparated)
	/* FILE = PREFIX . '$$'[fileSpace+] # [Character_but_Space][Any*][EOF],
	 *            or   PREFIX . '$$' # [EOF]
	 * FILE = PREFIX . [eol][fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
	 *            or   PREFIX . # opt{[Character_but_'$$'][Any*]}[EOF]
	 * if [EOF] is reached, <isEof> is set TRUE and this is set COMPLETED */
	return pk_true;
      /* FILE = PREFIX . '$$' # opt{[Character_but_Space][Any*]}[EOF], 
       *                   if [EOF] is reached, <isEof> is set TRUE and this is set COMPLETED */
      if (*isEof)
	{
	  isSeparated = pk_true;
	  return pk_true;
	}
      /* FILE = PREFIX . '$$' # [Character_but_Space][Any*][EOF] */
      (*new_lexicalContext) = push ();
      if ((*new_lexicalContext)->stepSet_contextMarks_fSpStar_ (isEof))
	{
	  /* FILE = PREFIX . '$$'[_SyntaxAdaptation][fileSpace+] # opt{[Character_but_Space][Any*]}[EOF]
	   *   or = PREFIX . '$$'[_SyntaxAdaptation] # [EOF]
	   *   with [_SyntaxAdaptation] = [leftCharacter][rightCharacter]opt{[commandCharacter]opt{[stringCharacter]}}
	   *         <leftChar>, <rightChar>, <commandChar>, <stringChar> are conflict free
	   *         if [EOF] is reached, <isEof> is set TRUE and this is set COMPLETED
	   *         <leftChar>, <rightChar>, <commandChar>, <stringChar> are assigned their new values is redefined  */
	  (*newLexical) = pk_true;
	  return pk_true;
	}
      /* syntax as for success, but 2 or more tags among <leftChar>, <rightChar>, <commandChar>, <stringChar> are equal (conflict)
       *                error  message is printed
       * FILE = PREFIX . '$$'opt{[leftCharacter]} # [EOF]
       *                NULL_char is returned in <leftChar> or <rightChar>
       *                <isEof> is set TRUE and this is set COMPLETED
       * FILE = PREFIX . '$$'opt{[leftCharacter]}[fileSpace+] # opt{[Character_but_Space][Any*]}[EOF]
       *                NULL_char is returned in <leftChar> or <rightChar>
       *                if [EOF] is reached, <isEof> is set TRUE and this is set COMPLETED
       *                error message is printed
       * FILE = PREFIX . '$$'opt{[leftCharacter]opt{[rightCharacter]opt{[commandCharacter]}}} # [reservedCharacter][Any*][EOF]
       *                error message is printed
       * FILE = PREFIX . '$$'[leftCharacter][rightCharacter][commandCharacter][stringCharacter] # [Character_but_Space][Any*][EOF]
       *                error message is printed
       *          file error, conflict error occurred during reading, including too large line
       *                error message is printed
       */
      pop ();
    }
  /* <isEof> is set according to # position */
  return pk_false;
}

/* 2004-12-24, 2007-02-06, PLG 2008-08-18
 * reads variable attributes 
* success: FILE = PREFIX . <commandChar>'exec'[White*]['/'][fileSpace*] # [Character_but_Space][Any*][EOF]
 *              (isBuildable,isCond,isExec) =  (pk_true,true,true), isExec is pk_true iff 'exec' is present
 *          FILE = PREFIX . ['/'][fileSpace*] # [Character_but_Space][Any*][EOF]
 *              (isBuildable,isCond,isExec) =  (pk_true,true,false), isExec is pk_true iff 'exec' is present
 *          FILE = PREFIX . <commandChar>'exec'[fileSpace*] # [Character_but_Space][Any*][EOF]
 *                  if [fileSpace*] is empty  opt{[Character_but_Space][Any*]} does not start with an IdentCharacter
 *                  if [fileSpace*] has no [eol] occurrence,   opt{[Character_but_Space][Any*]} does not start with '/'
 *             (isBuildable,isCond,isExec) =  (pk_true,false,true)
 *          FILE = PREFIX . '~'[fileSpace*] # [Character_but_Space][Any*][EOF]
 *             (isBuildable,isCond,isExec) = (pk_false,false,false)
 *          FILE = PREFIX .# [Character_but_Space][Any*][EOF], [Character_but_Space] not in {':', '/', '~'}
 *             (isBuildable,isCond,isExec) =  (pk_true,false,false)
 * failure: FILE = PREFIX . ...# [EOF], reading failed
 *          FILE = PREFIX . <commandChar> [fileSpace*] # opt{[Character_but_Space][Any*]}[EOF],
 *                      first [Any] in <<[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]>> is not an IdentCharacter
 *            or   PREFIX . <commandChar>[Identifier][fileSpace*] # opt{[Character_but_Space][Any*]}[EOF], [Identifier] is not 'exec'
 *            or   PREFIX . VARMODE[fileSpace*] # [EOF]
 *          error message is printed
_PUBLIC_  /* IR_G25 REF TODO */
boolean
Lexical::stepOpt_varDefinitionMode_fSpStar_nSp (boolean * isBuildable, boolean * isExec, boolean * isCond)	/* DONE */
{
  return this_inBuffer->stepOpt_varDefinitionMode_fSpStar_nSp (this_commandChar, isBuildable, isExec, isCond);
}

/* 2005-08-31, PLG 2009-08-24
 * success: FILE = PREFIX . <commandChar>'exec'[fileSpace*] # [Character_but_Space][Any*][EOF]
 *             <isWrite, isExec> is set (TRUE, TRUE)
 *          FILE = PREFIX . <commandChar>'write'[fileSpace*] # [Character_but_Space][Any*][EOF]
 *             <isWrite, isExec> is set (TRUE, FALSE)
 *          FILE = PREFIX .# [Character_but_Space_but_<commandChar>][Any*][EOF]
 *             <isWrite, isExec> is set (FALSE, unchanged)
 * failure: FILE = PREFIX . ... # [EOF], reading failed or internal error
 *          FILE = PREFIX . <commandChar>opt{[Identifier]}[fileSpace*] # [EOF]
 *
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Character_but_Space][Any*][EOF]
 *                 [Identifier] not in {'exec', 'write'}
 *          FILE = PREFIX . <commandChar>[White+] # [Character_but_Space][Any*][EOF]
 *            or   PREFIX . <commandChar> # [Character_but_Space_but_IdentCharacter][Any*][EOF] 
 *          error message is printed
 */
_PUBLIC_			/* IR_G26 REF TODO */
  boolean Lexical::stepOpt_fileDefinitionMode_fSpStar_nSp (boolean * isWrite, boolean * isExec)	/* PLG TODO */
{
  return this_inBuffer->stepOpt_fileAttribute_fSpStar_nSp (this_commandChar, isWrite, isExec);
}

/* 2004-11-16, 2007-02-06, PLG 2007-05-31, PLG 2009-08-17
 * reads dependence attributes 
 * assumes: IS_READY() ==> FILE = PREFIX . [Any_but_Space][Any*][EOF] !!! Character or eol
 * success: FILE = PREFIX . opt{'~'opt{[lineSpaces]} }[eol] # [Any*][EOF] 
 *              <dependenceNature> is set newerBuildCODE
 *              <highDependenceLevel> is set  FALSE if '~' is present, TRUE otherwise
 *          FILE = PREFIX . '!'opt{[White*]'*'}opt{[lineSpaces]}[eol] # [Any*][EOF]
 *              <dependenceNature> is set everBuildCODE
 *              <highDependenceLevel> is set TRUE if '*' is present, FALSE otherwise
 *          FILE = PREFIX . '-'opt{[White*]'~'}opt{[lineSpaces]}[eol] # [Any*][EOF]
 *              <dependenceNature> is set missingBuildCODE
 *              <highDependenceLevel> is set FALSE if '~' is present, TRUE otherwise
 * failure: FILE = PREFIX . ... # [EOF], reading failed
 *          
 *          FILE = PREFIX . opt{'~'opt{[lineSpaces]}} # [EOF] 
 *          FILE = PREFIX . '!'opt{[White*]'*'} opt{[lineSpaces]} # [EOF] 
 *          FILE = PREFIX . '-'opt{[White*]'~'} opt{[lineSpaces]} # [EOF] 
 *
 *          FILE = PREFIX .# [Character_but_Space_but_'~'_but_'!'_but_'-'][Any*][EOF] 
 *          FILE = PREFIX . '~'[White*] # [Character_but_Space][Any*][EOF] 
 *          FILE = PREFIX . '!'[White*] # [Character_but_Space_but_'*'][Any*][EOF] 
 *          FILE = PREFIX . '!'[White*]'*' [White*] # [Character_but_Space][Any*][EOF] 
 *          FILE = PREFIX . '-'[White*] # [Character_but_Space_but_'~'][Any*][EOF] 
 *          FILE = PREFIX . '-'[White*]'~' [White*] # [Character_but_Space][Any*][EOF] 
 *          error message is printed
 */
_PUBLIC_			/* IR_G27 REF TODO */
  boolean Lexical::stepOpt_antecedenceModality_eol_ (int *dependenceNature, boolean * highDependenceLevel)
{
  // log_ASDEBUG("Lexical::stepOpt_antecedenceModality_eol_");
  return this_inBuffer->stepOpt_ancestorDoingMode_spStar_eol_ (dependenceNature, highDependenceLevel);
}

/* 2005-03-22, PLG-2007-05-24 , PLG-2009-08-18
 * success: FILE = PREFIX . [Any_but_'{']* # '{' [Any*][EOF]
 *             <correct> remains unchanged
 * failure: FILE = PREFIX . [Any_but_'{']* # [EOF]
 *             <correct> remains unchanged
 *          on error
 *             error message is printed
 *             <correct> is set FALSE
 */
_PUBLIC_			/* IR_G28 */
  boolean Lexical::reachOpt_declOpening (boolean * correct)
{
  return this_inBuffer->reachOpt_declOpening (correct);
}

/* PLG, PLG 2009-08-20 REF TODO
  * success: [Identifier] is not a reserved word
 *          FILE = PREFIX . [Identifier]opt{[lineSpaces]} # opt{[eol][Any*]}[EOF], 
 *            or   PREFIX . [Identifier][White+] # [Character_but_Space][Any*][EOF]
 *              <isSpaced> is set TRUE
 *          FILE = PREFIX . [Identifier] # [Character_but_Space_but_IdentCharacter][Any*][EOF]
 *              <isSpaced> is set FALSE
 *          a new fresh copy of [Identifier] is returned in <name>
 *          <correct> remains unchanged
 * failure: FILE = PREFIX .# opt{[Any_but_IdentCharacter][Any*]}[EOF]
 *              <correct> remains unchanged
 * failure: FILE = PREFIX . <IdentCharacter>[Character*]opt{[eol][Any*]} # [EOF]
 *              internal error occurred
 *          [Identifier] is a reserved word in
 *              FILE = PREFIX . [Identifier] opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
 *                or   PREFIX . [Identifier] [White+] # [Character_but_Space][Any*][EOF]
 *                or   PREFIX . [Identifier] # [Character_but_Space_but_IdentCharacter][Any*][EOF]
 *          FILE = [Any*][EOF].#
 *          <correct> is set FALSE
 *          error message is printed
 *          <name>  remains unchanged
* <isEol> is set according to final cursor position
 */
_PUBLIC_			/* IR_G30 REF TODO */
  boolean Lexical::stepIf_userIdentifier_spStar_ (boolean * correct, char **CString_name, boolean * isSpaced, boolean * isEol)
{
  return this_inBuffer->stepIf_userIdentifier_spStar_ (correct, CString_name, isSpaced, isEol);
}


/* 2005-03-17, 2007-02-06, PLG 2009-08-20 REF TODO
 * a user identifier is required
 * success: [Identifier] is not a reserved word
 *          FILE = PREFIX . [Identifier] # [Character_but_Space_but_IdentCharacter][Any*][EOF]
 *                <isSpaced> is set FALSE
 *          FILE = PREFIX . [Identifier][fileSpace+] # [Character_but_Space][Any*][EOF]
 *                <isSpaced> is set TRUE
 *          a new fresh copy of [Identifier] is returned in <CString_name>
 *          <correct> remains unchanged
 * failure: FILE = PREFIX .# [Any_but_IdentCharacter][Any*][EOF]
 *                 <correct> remains unchanged
 * failure: FILE = PREFIX . [Identifier][fileSpace*] # [EOF]
 *                <CString_name> is loaded with a new m'allocated copy of [Identifier]
 *          FILE = PREFIX . [Identifier][fileSpace+] # [Any*][EOF]
 *                 [Identifier] is a reserved word
 *          FILE = PREFIX . ... # [EOF], reading failed
 *                 <CString_name>  remains unchanged
 *          error message is printed
 *          <correct> is set FALSE
 */
_PUBLIC_			/* IR_G31 REF TODO */
  boolean Lexical::stepIf_userIdentifier_fSpStar_nSp (boolean * correct, char **CString_name, boolean * isSpaced)
{
  return this_inBuffer->stepIf_userIdentifier_fSpStar_nSp (correct, CString_name, isSpaced);
}

/* PLG 2009-08-20
 * success: [Identifier] is not a reserved word
 *          FILE = PREFIX . [Identifier][fileSpace+] # [Character_but_Space][Any*][EOF]
 *          FILE = PREFIX . [Identifier] # [Character_but_Space_but_IdentCharacter][Any*][EOF]
 *          <CString_name> is loaded with a new m'allocated copy of [Identifier]
 * failure: FILE = PREFIX . [Identifier][fileSpace*] # [EOF]
 *                <CString_name> is loaded with a new m'allocated copy of [Identifier]
 *          FILE = PREFIX . [Identifier][fileSpace+] # [Any*][EOF]
 *                 [Identifier] is a reserved word
 *          FILE = PREFIX .# [Any_but_IdentCharacter][Any*][EOF]
 *          FILE = PREFIX . ... # [Any*][EOF], reading failed
 *          error message is printed
 */
_PUBLIC_			/* IR_G31req */
  boolean Lexical::req_userIdentifier_fSpStar_nSp (char **CString_name)
{
  return this_inBuffer->req_userIdentifier_fSpStar_nSp (CString_name);
}

/* PLG 2008-07-15, PLG 2009-08-24 
 * success: FILE = PREFIX . [Identifier][White*]<rightChar>[White*] # [Character_but_Space][Any*][EOF]
 *            or   PREFIX . [Identifier][White*]<rightChar> opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
 *             [Identifier] is not a reserved word
 *             <isSpaced> is set according to [Any] that immediately follows <rightChar> (TRUE if [Any] is [eoX]
 *             <CString_name> is loaded with a new m'allocated copy of [Identifier]
 * failure: WELLBALANCED is [Character_but_'}:'_but_'}']* that is well balanced wrt to '(', ')'
 *          UNRECOVERED is [Character_but_'}:'_but_'}']* that does not match <<WELLBALANCED')'[Any*]>> 
 *          FILE = PREFIX . ... # [EOF], reading failed or internal error
 *          FILE = PREFIX . ERROR_REFERENCETAIL UNRECOVERED # [EOF], 
 *          FILE = PREFIX . ERROR_REFERENCETAIL UNRECOVERED  # '}:'[Any*][EOF]
 *          FILE = PREFIX . ERROR_REFERENCETAIL UNRECOVERED  # '}'[Any*][EOF]
 *          FILE = PREFIX . ERROR_REFERENCETAIL WELLBALANCED ')'[White*] # [Character_but_Space][Any*][EOF]
 *            or   PREFIX . ERROR_REFERENCETAIL WELLBALANCED ')'opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
 *          error message is printed
 * <isEol> is set according to # position
 */
_PUBLIC_			/* IR_G32 REF TODO */
  boolean Lexical::req_referenceTail_C_spStar_ (char **CString_name, boolean * isSpaced, boolean * isEol)	/* DONE */
{
  if (this_inBuffer->req_referenceTail_C_spStar_ (this_closingChar, CString_name, isSpaced, isEol))
    /* FILE = PREFIX . [Identifier][White*]<this_closingChar>[White*] # [Character_but_Space][Any*][EOF]
     *   or   PREFIX . [Identifier][White*]<this_closingChar> opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
     * [Identifier] is not a reserved word
     * <isSpaced> is set according to [Any] that immediately follows <this_closingChar> (TRUE if [Any] is [eoX] or Space)
     * <name> is loaded with a new m'allocated copy of [Identifier]
     * <isEol> is set according to # position
     */
    return pk_true;
  /* FILE = PREFIX . ... # [EOF], internal error or reading failed
   * FILE = PREFIX .# [Character_but_Space_but_<IdentCharacter>][Any*][EOF]
   * FILE = PREFIX . [Identifier][White*] # [Character_but_Space_but_<rightChar>][Any*][EOF]
   *              [Identifier] is not a reserved word
   * FILE = PREFIX . [Identifier]opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
   * FILE = PREFIX . [Identifier][White*] # [Character_but_Space][Any*][EOF], 
   *              [Identifier] is a reserved word
   * error message is printed */
  if (recover_second_spStar_ (isEol));
  /* WELLBALANCED is [Character_but_'}:'_but_'}']* that is well balanced wrt to '(', ')'
   * UNRECOVERED is [Character_but_'}:'_but_'}']* that does not match <<WELLBALANCED')'[Any*]>> 
   * FILE = PREFIX . ... # [EOF], reading failed or internal error
   * FILE = PREFIX . ERROR_REFERENCETAIL UNRECOVERED # [EOF], 
   * FILE = PREFIX . ERROR_REFERENCETAIL UNRECOVERED  # '}:'[Any*][EOF]
   * FILE = PREFIX . ERROR_REFERENCETAIL UNRECOVERED  # '}'[Any*][EOF]
   * FILE = PREFIX . ERROR_REFERENCETAIL WELLBALANCED ')'[White*] # [Character_but_Space][Any*][EOF]
   *   or   PREFIX . ERROR_REFERENCETAIL WELLBALANCED ')'opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
   *          info message is printed;
   *          error message is printed; 
   * <isEol> is set according to # position
   */
  return pk_false;
}

/* PLG 2009-08-24 REF TODO
 * success: FILE = PREFIX . '~'[Character+]'~' opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
 *          FILE = PREFIX . '~'[Character+]'~'[White*] # [Character_but_Space][Any+][EOF]
 *          a new fresh copy of [Character+] is returned in <CString_name>
 *          <correct> remains unchanged
 * failure: FILE = PREFIX .# opt{[Character_but_Space_but_'~'][Any*]}[EOF]
 *              <correct> remains unchanged
 * failure: FILE = PREFIX . '~''~' opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
 *            or   PREFIX . '~''~'[White*] # [Character_but_Space][Any+][EOF]
 *            or   PREFIX . '~'[Character*]'~' ...  # [EOF]
 *                     internal error
 *            or   PREFIX . '~' # [Character_but_'~']* opt{[eol][Any*]}[EOF]
 *          <correct> is set FALSE
 *          error message is printed
 * <isEol> is set according to  # position
 */
_PUBLIC_			/* IR_G33 REF TODO */
  boolean Lexical::stepIf_externIdentifier_spStar_ (boolean * correct, char **CString_name, boolean * isEol)
{
  return this_inBuffer->stepIf_externIdentifier_spStar_ (correct, CString_name, isEol);
}

/* 2004-12-06, 2008_07-04, PLG 2009-08-24 
 * assumes: IS_READY() ==> FILE = PREFIX . [Character_but_Space][Any*][EOF]
 * success: FILE = PREFIX . '!'[Character+]'!' opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
 *          FILE = PREFIX . '!'[Character+]'!'[White*] # [Character_but_Space][Any+][EOF]
 *          a new fresh copy of [Character+] is returned in <CString_name>
 *          <correct> remains unchanged
 * failure: FILE = PREFIX .# opt{[Character_but_Space_but_'!'][Any*]}[EOF]
 *              <correct> remains unchanged
 * failure: FILE = PREFIX . '!''!' opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
 *            or   PREFIX . '!''!'[White*] # [Character_but_Space][Any+][EOF]
 *            or   PREFIX . '!'[Character*]'!' ...  # [EOF]
 *                     internal error
 *            or   PREFIX . '!' # [Character_but_'!']* opt{[eol][Any*]}[EOF]
 *              <correct> is set FALSE
 *              error message is printed
 * <isEol> is set 
 */
_PUBLIC_			/* IR_G34 REF TODO */
  boolean Lexical::stepIf_fileIdentifier_spStar_ (boolean * correct, char **CString_name, boolean * isEol)
{
  return this_inBuffer->stepIf_fileIdentifier_spStar_ (correct, CString_name, isEol);
}

/* PLG 2009-08-24 REF TODO
 * success: FILE = PREFIX . <commandChar>'boot'opt{[lineSpaces]}[eol] # [Any*][EOF]
 *             <identifierCode> is set bootCODE
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Character_but_Space][Any*][EOF]
 *                 first character in [fileSpace*][Character_but_Space] is not an [IdentCharacter]
 *                 [Identifier] is in {'static', 'string', 'iterate', 'list', 'define', 'context'}
 *             <identifierCode> is set according to [Identifier] (see keywordDecl_i.h)
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Character_but_Space][Any*][EOF]
 *                 first character in [fileSpace*][Character_but_Space] is not an [IdentCharacter]
 *                 [Identifier] is  not a reserved word
 *             <identifierCode> is set userCODE
 *          atom is loaded with [Identifier]
 * failure: FILE = PREFIX .# [Character_but_Space_but_<commandChar>][Any*][EOF]
 *             <identifierCode> is set notACommandCODE
 * failure: FILE = PREFIX . <commandChar>[Identifier] ... # [EOF], reading failed or internal error
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [EOF]
 *            or   PREFIX . <commandChar>[Identifier][fileSpace*] # [EOF]
 *          FILE = PREFIX . <commandChar>[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *                 first [Any] in <<[fileSpace*] opt{[Character_but_Space][Any*]}[EOF]>> is not an IdentCharacter
 *          FILE = PREFIX . <commandChar>'boot'[White*] # [Character_but_Space][Any*][EOF]
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *             [Identifier] is a reserved word not in {'boot', 'static', 'string', 'iterate', 'list', 'define', 'context'}
 *          <identifierCode> is set errorCODE
`*          error message is printed
 */
_PUBLIC_			/* IR_G37 REF TODO */
/* ================================================================================ HERE PLG 2009-08-26 */
  boolean Lexical::stepIf_commandHead_fSpStar_nlORnSp (int *commandCode, char **functionName)	/* DONE */
{
  return this_inBuffer->stepIf_commandHead_fSpStar_nlORnSp (this_commandChar, commandCode, functionName);
}

/* PLG 2009-08-24 
 * success: FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Character_but_Space][Any*][EOF]
 *                 [Identifier] is in {'iterate', 'string', 'list'}
 *             <identifierCode> is set according to [Identifier] (see keywordDecl_i.h)
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Character_but_Space][Any*][EOF]
 *                 [Identifier] is  not a reserved word
 *             <identifierCode> is set userCODE
 *             a new fresh copy of [Identifier] is returned in <functionName>
 *          FILE = PREFIX .# [Character_but_Space_but_<commandChar>][Any*][EOF]
 *             <identifierCode> is set notACommandCODE
 * failure: FILE = PREFIX . <commandChar> ... # [EOF], internal error or reading failed
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [EOF]
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Character_but_Space][Any*][EOF] 
 *                 [Identifier] is a reserved word not in {'iterate', 'string', 'list'}
 *          FILE = PREFIX . <commandChar>[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *                 first [Any] in [fileSpace*] # opt{[Character_but_Space][Any*]} is not an IdentCharacter
`*          error message is printed
 *          <identifierCode> is set errorCODE
 */
_PUBLIC_			/* IR_G39 REF TODO */
  boolean Lexical::stepOpt_elementCategory_fSpStar_nSp (int *commandCode, char **functionName)	/* DONE */
{
  return this_inBuffer->stepOpt_elementCategory_fSpStar_nSp (this_commandChar, commandCode, functionName);
}

/* PLG 2009-08-25 REFTODO
 * success: FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Character_but_Space][Any*][EOF]
 *                 [Identifier] is in { 'string',  'stringval', 'hostval'}
 *                      <identifierCode> is set according to [Identifier] (see keywordDecl_i.h)
 *                 [Identifier] is  not a reserved word
 *                      <identifierCode> is set userCODE
 *                      a new fresh copy of [Identifier] is returned in <functionName>
 * failure: FILE = PREFIX .# [Character_but_Space_but_<commandChar>][Any*][EOF]
 *             <identifierCode> is set notACommandCODE
 * failure:FILE = PREFIX . <commandChar> ... # [EOF], internal error or reading failed
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [EOF]
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Character_but_Space][Any*][EOF] 
 *                 [Identifier] is a reserved word not in { 'string',  'stringval', 'hostval'}
 *          FILE = PREFIX . <commandChar>[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *                 first [Any] in [fileSpace*] # opt{[Character_but_Space][Any*]} is not an IdentCharacter
`*          error message is printed
 *          <identifierCode> is set errorCODE
 */
_PUBLIC_			/* IR_G40 REF TODO */
  boolean Lexical::stepIf_stringCallHead_fSpStar_nSp (int *commandCode, char **strRes)	/* DONE */
{
  return this_inBuffer->stepIf_stringCallHead_fSpStar_nSp (this_commandChar, commandCode, strRes);
}

/* PLG 2009-08-25 
 * success: FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Character_but_Space][Any*][EOF]
 *                 [Identifier] is in {'iterate', 'list', 'listval'}
 *                      <identifierCode> is set according to [Identifier] (see keywordDecl_i.h)
 *                 [Identifier] is  not a reserved word
 *                      <identifierCode> is set userCODE
 *                      a new fresh copy of [Identifier] is returned in <functionName>
 * failure: FILE = PREFIX .# [Character_but_Space_but_<commandChar>][Any*][EOF]
 *             <identifierCode> is set notACommandCODE
 * failure: FILE = PREFIX . <commandChar> ... # [EOF], internal error or reading failed
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [EOF]
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Character_but_Space][Any*][EOF] 
 *                 [Identifier] is a reserved word not in {'iterate', 'list', 'listval'}
 *          FILE = PREFIX . <commandChar>[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *                 first [Any] in [fileSpace*] # opt{[Character_but_Space][Any*]} is not an IdentCharacter
`*          error message is printed
 *          <identifierCode> is set errorCODE
 */
_PUBLIC_			/* IR_G42 REF TODO */
  boolean Lexical::stepIf_listCallHead_fSpStar_nSp (int *commandCode, char **functionName)	/* DONE */
{
  return this_inBuffer->stepIf_listCallHead_fSpStar_nSp (this_commandChar, commandCode, functionName);
}

/* PLG  2009-08-25 
 * success: FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Character_but_Space][Any*][EOF]
 *                 [Identifier] is in {'string',  'stringval', 'hostval', 'iterate', 'list', 'listval'}
 *                      <identifierCode> is set according to [Identifier] (see keywordDecl_i.h)
 *                 [Identifier] is  not a reserved word
 *                      <identifierCode> is set userCODE
 *                      a new fresh copy of [Identifier] is returned in <functionName>
 * failure: FILE = PREFIX .# [Character_but_Space_but_<commandChar>][Any*][EOF]
 *             <identifierCode> is set notACommandCODE
 * failure:  FILE = PREFIX . <commandChar> ... # [EOF], internal error or reading failed
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [EOF]
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Character_but_Space][Any*][EOF] 
 *                 [Identifier] is a reserved word not in {'string',  'stringval', 'hostval', 'iterate', 'list', 'listval'}
 *          FILE = PREFIX . <commandChar>[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *                 first [Any] in [fileSpace*] # opt{[Character_but_Space][Any*]} is not an IdentCharacter
`*          error message is printed
 *          <identifierCode> is set errorCODE
 */
_PUBLIC_			/* IR_G43 REF TODO */
  boolean Lexical::stepIf_argumentCallHead_fSpStar_nSp (int *commandCode, char **functionName)	/* DONE */
{
  return this_inBuffer->stepIf_argumentCallHead_fSpStar_nSp (this_commandChar, commandCode, functionName);

}

/* PLG  2009-08-25 
 * success: FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Character_but_Space][Any*][EOF]
 *                 [Identifier] is 'iterate'
 *                      <isIterate> is set TRUE
 *                 [Identifier] is  not a reserved word
 *                      <isIterate> is set FALSE
 *                      a new fresh copy of [Identifier] is returned in <functionName>
 *          <correct> remains unchanged
 * failure: FILE = PREFIX .# [Character_but_Space_but_<commandChar>][Any*][EOF]
 *              <correct> remains unchanged
 * failure: FILE = PREFIX . <commandChar> ... # [EOF], internal error or reading failed
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [EOF]
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Character_but_Space][Any*][EOF] 
 *                 [Identifier] is a reserved word but 'iterate'
 *          FILE = PREFIX . <commandChar>[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *                 first [Any] in [fileSpace*] # opt{[Character_but_Space][Any*]} is not an IdentCharacter
 *          <correct> is set false
`*          error message is printed
 */
_PUBLIC_			/* IR_G44 REF TODO */
  boolean Lexical::stepIf_userCallHeader_fSpStar_nSp (boolean * correct, boolean * inIteration, char **functioName)	/* DONE */
{
  return this_inBuffer->stepIf_userCallHeader_fSpStar_nSp (this_commandChar, correct, inIteration, functioName);
}

/* PLG 2009-09-07
 * assumes: IS_READY() ==> FILE = PREFIX . [Character_but_Space][Any*][EOF]
 * success: FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Character_but_Space][Any*][EOF]
 *                 [Identifier] is  not a reserved word
 *                      a new fresh copy of [Identifier] is returned in <functionName>
 * failure: FILE = PREFIX .# [Character_but_Space_but_<commandChar>][Any*][EOF]
 *          FILE = PREFIX . <commandChar> ... # [EOF], internal error or reading failed
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [EOF]
 *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Character_but_Space][Any*][EOF] 
 *                 [Identifier] is a reserved word not in {'string',  'stringval', 'hostval', 'iterate', 'list', 'listval'}
 *          FILE = PREFIX . <commandChar>[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *                 first [Any] in [fileSpace*] # opt{[Character_but_Space][Any*]} is not an IdentCharacter
`*          error message is printed
 *          <identifierCode> is set errorCODE
 */
_PUBLIC_			/* IR_G45 REF TODO */
  boolean Lexical::req_userElementaryCallHead_fSpStar_nSp (char **functionName)	/* DONE */
{
  return this_inBuffer->req_userElementaryCallHead_fSpStar_nSp (this_commandChar, functionName);
}

/* PLG 2009-08-25 
 * success: FILE = PREFIX . '$:'[Identifier] [fileSpace*] # [Character_but_Space][Any*][EOF]
 *             [Identifier] is in { 'string',  'stringval', 'hostval'}
 *                <identifierCode> is set according to Identifier
 *             [Identifier] is not a reserved word
 *                <identifierCode> is set userCODE
 * failure: FILE = PREFIX . [Character_but_Space_but_'$:'][Any*][EOF]
 *             <identifierCode> is set notACommandCODE
 * failure: FILE = PREFIX . ... # [EOF], reading failed
 *          FILE = PREFIX . '$:'[Identifier] [fileSpace*] # [EOF]
 *          FILE = PREFIX . '$:' # opt{[Any_but_IdentHeaderCharacter][Any*]}[EOF]
 *          FILE = PREFIX . '$:'[Identifier] [fileSpace*] # [Character_but_Space][Any*][EOF]
 *                 [Identifier] is a reserved word not in { 'string',  'stringval', 'hostval'}
 *          <identifierCode> is set errorCODE
 *          an error message is printed
 */
_PUBLIC_			/* IR_G46 REF TODO */
  boolean Lexical::stepIf_varIdentCommandHead_fSpStar_nSp (int *commandCode, char **strRes)
{
  return this_inBuffer->stepIf_varIdentCommandHead_fSpStar_nSp (this_commandChar, commandCode, strRes);
}

/* PLG 2009-08-25 
 * success: FILE = PREFIX . '!:'[Identifier] [fileSpace*] # [Character_but_Space][Any*][EOF]
 *             [Identifier] is in { 'string',  'stringval', 'hostval'}
 *                <identifierCode> is set according to Identifier
 *             [Identifier] is not a reserved word
 *                <identifierCode> is set userCODE
 * failure: FILE = PREFIX . [Character_but_Space_but_'!:'][Any*][EOF]
 *             <identifierCode> is set notACommandCODE
 * failure: FILE = PREFIX . ... # [EOF], reading failed
 *          FILE = PREFIX . '!:'[Identifier] [fileSpace*] # [EOF]
 *          FILE = PREFIX . '!:' # opt{[Any_but_IdentHeaderCharacter][Any*]}[EOF]
 *          FILE = PREFIX . '!:'[Identifier] [fileSpace*] # [Character_but_Space][Any*][EOF]
 *                 [Identifier] is a reserved word not in { 'string',  'stringval', 'hostval'}
 *          <identifierCode> is set errorCODE
 *          an error message is printed
 */
_PUBLIC_			/* IR_G47 Ref TODO */
  boolean Lexical::stepIf_fileIdentCommandHead_fSpStar_nSp (int *commandCode, char **strRes)
{
  return this_inBuffer->stepIf_fileIdentCommandHead_fSpStar_nSp (this_commandChar, commandCode, strRes);
}

/* 2004-12-21, PLG 2007-06-27, PLG 2009-08-25 
 * success: FILE = PREFIX . '~:'[Identifier] [fileSpace*] # [Character_but_Space][Any*][EOF]
 *             [Identifier] is in { 'string',  'stringval', 'hostval'}
 *                <identifierCode> is set according to Identifier
 *             [Identifier] is not a reserved word
 *                <identifierCode> is set userCODE
 * failure: FILE = PREFIX . [Character_but_Space_but_'~:'][Any*][EOF]
 *             <identifierCode> is set notACommandCODE
 * failure: FILE = PREFIX . ... # [EOF], reading failed
 *          FILE = PREFIX . '~:'[Identifier] [fileSpace*] # [EOF]
 *          FILE = PREFIX . '~:' # opt{[Any_but_IdentHeaderCharacter][Any*]}[EOF]
 *          FILE = PREFIX . '~:'[Identifier] [fileSpace*] # [Character_but_Space][Any*][EOF]
 *                 [Identifier] is a reserved word not in { 'string',  'stringval', 'hostval'}
 *          <identifierCode> is set errorCODE
 *          an error message is printed
 */
_PUBLIC_			/* IR_G48  Ref TODO */
  boolean Lexical::stepIf_extIdentCommandHead_fSpStar_nSp (int *commandCode, char **strRes)	/* DONE */
{
  return this_inBuffer->stepIf_extIdentCommandHead_fSpStar_nSp (this_commandChar, commandCode, strRes);
}

/* PLG-2009-08-19 REF TODO
 * attempts to recover next '}:' occurrence 
 * success: FILE = PREFIX . [Any_but_'}:']*'}:'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *          info message is printed;
 * failure: FILE = PREFIX . [Any_but_'}:']* # [EOF] 
 *          FILE = PREFIX . ... [EOF], reading failed
 *          error message is printed; this is set ERRORCOMPLETED
 * <isEof> is set according to # position
 */
_PUBLIC_			/* IR_G50 */
  boolean Lexical::recover_funcDecl_fSpStar_ (boolean * isEof)
{
  return this_inBuffer->recover_funcDecl_fSpStar_ (isEof);
}

/* PLG-2009-08-19, PLG-2009-09-30 isEof changed REF TODO
 * attempts to recover next '}' occurrence 
 * WELLBALANCED is [Any_but_'}:']*  that is well balanced wrt to '{', '}'
 * ANY2 is [Any_but_'}:']* that does not match <<WELLBALANCED'}'[Any*]>>
 * success: FILE = PREFIX . WELLBALANCED '}'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *             <isMain> is set TRUE
 *          FILE = PREFIX . ANY2  # '}:'[Any*][EOF]
 *             ANY2 is [Any_but_'}:']* that does not match <<WELLBALANCED'}'[Any*]>> 
 *             <isMain> is set FALSE
 *          info message is printed;
 * failure: FILE = PREFIX . ... # [EOF], reading failed
 *          FILE = PREFIX . WELLBALANCED '{' ANY2 # [EOF]
 *          FILE = PREFIX . WELLBALANCED # [EOF]
 *          error message is printed; this is set ERRORCOMPLETED
 * <isEof> is set according to # position
 */
_PUBLIC_			/* IR_G51 */
  boolean Lexical::recover_main_fSpStar_ (boolean * isEof)
{
  boolean
    isMain;
  return this_inBuffer->recover_main_fSpStar_ (&isMain, isEof);
}

/* PLG-2009-09-22 OK
 * attempts to recover next ')' occurrence in current line
 * WELLBALANCED is [Character_but_'}:'_but_'}']* that is well balanced wrt to '(', ')'
 * success: FILE = PREFIX . [Character_but_'}:'_but_'}']*  # '}'[Any*][EOF]
 *             [Character_but_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>> 
 *          FILE = PREFIX . WELLBALANCED ')'[White*] # [Character_but_Space][Any*][EOF]
 *            or   PREFIX . WELLBALANCED ')'opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
 *          info message is printed;
 * failure: FILE = PREFIX . ... # [EOF], reading failed
 *          FILE = PREFIX . WELLBALANCED opt{'('[Any_but_'}:'_but_'}']*} # [EOF], 
 *              [Any_but_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>>
 *          error message is printed; 
 * <isEol> is set according to # position
 */
_PUBLIC_ boolean Lexical::recover_second_spStar_ (boolean * isEol)
{
  boolean
    isSecond;
  return this_inBuffer->recover_second_spStar_ (&isSecond, isEol);
}

/* PLG-2009-09-22 REF TODO
 * attempts to recover next ')' occurrence 
 * WELLBALANCED is [Any_but_'}:'_but_'}']* that is well balanced wrt to '(', ')'
 * UNRECOVERED  is [Any_but_'}:'_but_'}']* that does not match <<WELLBALANCED')'[Any*]>>
 * success: FILE = PREFIX . UNRECOVERED  # '}:'[Any*][EOF]
 *            or   PREFIX . UNRECOVERED  # '}'[Any*][EOF]
 *          FILE = PREFIX . WELLBALANCED ')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *          info message is printed;
 * failure: FILE = PREFIX . ... # [EOF], reading failed
 *          FILE = PREFIX . UNRECOVERED # [EOF], 
 *          error message is printed; this is set ERRORCOMPLETED
 * <isEof> is set according to  # position
 */
_PUBLIC_ boolean Lexical::recover_second_fSpStar_ (boolean * isEof)
{
  boolean
    isSecond;
  return this_inBuffer->recover_second_fSpStar_ (&isSecond, isEof);
}


/* 2004-11-25, PLG 2009-08-12, PLG 2009-09-30 REF TODO
 * reads file declaration attributes
 * [StringConstant] = <this_stringTag>[Character*]<this_stringTag>
 * CONSTANTCHAR = <this_stringTag>[Character]<this_stringTag>
 * SPLITTINGATTRIBUTES = [StringConstant] [fileSpace*] CONSTANTCHAR
 * UNRECOVERED  is [Any_but_'}:'_but_'}']* that does not match <<WELLBALANCED')'[Any*]>>
 * success: FILE = PREFIX . '('[fileSpace*] SPLITTINGATTRIBUTES[fileSpace*]')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *                <continuationMark> value is set to [Character] in CONSTANTCHAR
 *          FILE = PREFIX . '('[fileSpace*][StringConstant][fileSpace*]')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *                <continuationMark> remains unchanged
 *          a new fresh copy of [Character*] in [StringConstant] is returned in breakCharList
 *          <correct> remains unchanged
 * failure: FILE = PREFIX .# [Character_but_Space_but_'('][Any*][EOF]
 *                <correct> remains unchanged
 *          FILE = PREFIX . ... # [EOF], reading failed
 *            or   PREFIX . '(' ERROR_SPLITTINGATTRIBUTES UNRECOVERED # [EOF] 
 *            or   PREFIX . '(' ERROR_SPLITTINGATTRIBUTES UNRECOVERED # '}:'[Any*][EOF]
 *            or   PREFIX . '(' ERROR_SPLITTINGATTRIBUTES UNRECOVERED # '}'[Any*][EOF]
 *            or   PREFIX . '(' ERROR_SPLITTINGATTRIBUTES WELLBALANCED ')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *                <correct> is set FALSE
 * if [EOF] is reached <isEof> is set TRUE, and this is set COMPLETED
 */
_PUBLIC_ boolean Lexical::stepIf_splittingAttributes_fSpStar_nSp (boolean * correct, char **breakCharList, char *continuationMark)
{
  /* assumes: IS_READY() ==> FILE = PREFIX . [Character_but_Space][Any*][EOF] */
  if (this_inBuffer->stepIf_listO_fSpStar_nSp (correct))
    {
      /* FILE = PREFIX . '(' [fileSpace*] # [Character_but_Space][Any*][EOF]
       *             <correct> remains unchanged */
      boolean
	isEof = pk_false;
      boolean
	lCorrect = pk_true;
      if (this_inBuffer->stepIf_stringConstant_fSpStar_ (this_stringTag, &lCorrect, breakCharList, &isEof))
	{
	  /* [StringConstant] = <this_stringTag>[Character_but_<this_stringTag>]* <this_stringTag> 
	   * FILE = PREFIX . '(' [fileSpace*][StringConstant][fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
	   * <isEof> is set according to # position
	   *          a new fresh copy of [Character*] is returned in breakCharList
	   *          <lCorrect> remains unchanged
	   */
	  if (isEof)
	    {
	      /* FILE = PREFIX . '(' [fileSpace*][StringConstant][fileSpace*] # [EOF] */
	      ASFatal_eof ();
	      (*correct) = pk_false;
	      return pk_false;
	    }
	  /* CONSTANTCHAR = <this_stringTag>[Character]<this_stringTag> 
	   * SPLITTINGATTRIBUTES = [StringConstant][fileSpace*]CONSTANTCHAR
	   * FILE = PREFIX . '(' [fileSpace*][StringConstant][fileSpace*] # [Character_but_Space][Any*][EOF] */
	  if (!(this_inBuffer->stepIf_constantChar_fspStar_nSp (this_stringTag, &lCorrect, continuationMark)))
	    {
	      /* failure: FILE = PREFIX . '(' [fileSpace*][StringConstant][fileSpace*] # [Character_but_Space_but_<this_stringTag>][Any*][EOF]
	       *              <lCorrect>, <char_res> remain unchanged
	       * failure: FILE = PREFIX . '(' [fileSpace*]SPLITTINGATTRIBUTES[fileSpace*] # [EOF] 
	       *             or  PREFIX . '(' [fileSpace*]SPLITTINGATTRIBUTES ...  # [EOF], reading failed;
	       *          FILE = PREFIX . '(' [fileSpace*][StringConstant][fileSpace*]<this_stringTag>[Character][fileSpace+] # opt{[Character_but_Space][Any*]}[EOF]
	       *            or   PREFIX . '(' [fileSpace*][StringConstant][fileSpace*]<this_stringTag>[Character] # opt{[Character_but_Space_but_<this_stringTag>][Any*]}[EOF]
	       *          FILE = PREFIX . '(' [fileSpace*][StringConstant][fileSpace*]<this_stringTag>[eol][fileSpace*] # opt{[Character_but_Space][Any*]}[EOF] 
	       *            or   PREFIX . '(' [fileSpace*][StringConstant][fileSpace*]<this_stringTag> # [EOF] 
	       *          if [EOF] is reached, this is set completed
	       *          error message is printed
	       *          <lCorrect> is set false
	       */
	      if (!lCorrect)
		{
		  /* FILE = PREFIX . '(' [fileSpace*]SPLITTINGATTRIBUTES ...  # [EOF], reading failed;
		   *   or   PREFIX . '(' [fileSpace*]SPLITTINGATTRIBUTES[fileSpace*] # [EOF] 
		   *   or   PREFIX . '(' [fileSpace*][StringConstant][fileSpace*]<this_stringTag> # [EOF] 
		   * FILE = PREFIX . '(' [fileSpace*][StringConstant][fileSpace*]<this_stringTag>[Character][fileSpace+] # opt{[Character_but_Space][Any*]}[EOF]
		   *   or   PREFIX . '(' [fileSpace*][StringConstant][fileSpace*]<this_stringTag>[Character] # opt{[Character_but_Space_but_<this_stringTag>][Any*]}[EOF]
		   * FILE = PREFIX . '(' [fileSpace*][StringConstant][fileSpace*]<this_stringTag>[eol][fileSpace*] # opt{[Character_but_Space][Any*]}[EOF] 
		   * if [EOF] is reached, this is set completed
		   * error message is printed
		   */
		  if (recover_second_fSpStar_ (&isEof));
		  /* WELLBALANCED is [Any_but_'}:'_but_'}']* that is well balanced wrt to '(', ')'
		   * FILE = PREFIX . '(' [fileSpace*]SPLITTINGATTRIBUTES ...  # [EOF], reading failed;
		   * 
		   * FILE = PREFIX . '(' ERROR_SPLITTINGATTRIBUTES UNRECOVERED # [EOF] 
		   * 
		   * FILE = PREFIX . '(' ERROR_SPLITTINGATTRIBUTES UNRECOVERED  # '}:'[Any*][EOF]
		   * FILE = PREFIX . '(' ERROR_SPLITTINGATTRIBUTES UNRECOVERED  # '}'[Any*][EOF]
		   * FILE = PREFIX . '(' ERROR_SPLITTINGATTRIBUTES WELLBALANCED ')'[fileSpace*] # [Character_but_Space][Any*][EOF]
		   * <isEof> is set according to  # position
		   */
		  (*correct) = pk_false;
		  return pk_false;
		}
	      /* [StringConstant] = <this_stringTag>[Character*]<this_stringTag>
	       * FILE = PREFIX . '(' [fileSpace*][StringConstant][fileSpace*] # [Character_but_Space_but_<this_stringTag>][Any*][EOF]
	       *              <continuationMark> remains unchanged */
	    }
	  /* success stepIf_constantChar_fspStar_nSp
	   * CONSTANTCHAR = <this_stringTag>[Character]<this_stringTag>
	   * SPLITTINGATTRIBUTES = [StringConstant][fileSpace*]CONSTANTCHAR
	   * FILE = PREFIX . '(' [fileSpace*]SPLITTINGATTRIBUTES [fileSpace*] # [Character_but_Space][Any*][EOF]
	   * <continuationMark> value is set [Character]
	   */
	  /* [StringConstant] = <this_stringTag>[Character*]<this_stringTag>
	   * CONSTANTCHAR = <this_stringTag>[Character]<this_stringTag>
	   * SPLITTINGATTRIBUTES = [StringConstant][fileSpace*]CONSTANTCHAR
	   * success_stepIf_constantChar_fspStar_nSp : 
	   *        FILE = PREFIX . '(' [fileSpace*] SPLITTINGATTRIBUTES [fileSpace*] # [Character_but_Space][Any*][EOF]
	   *        <continuationMark> value is set to [Character]
	   * failure_stepIf_constantChar_fspStar_nSp, lCorrect pk_true
	   *        FILE = PREFIX . '(' [fileSpace*] [StringConstant] [fileSpace*] # [Character_but_Space_but_<this_stringTag>][Any*][EOF]
	   *        <continuationMark> remains unchanged */
	  /* HERE */
	  if (req_listC_fSpStar_ (&isEof))
	    /* [StringConstant] = <this_stringTag>[Character*]<this_stringTag>
	     * CONSTANTCHAR = <this_stringTag>[Character]<this_stringTag>
	     * SPLITTINGATTRIBUTES = [StringConstant][fileSpace*]CONSTANTCHAR
	     * FILE = PREFIX . '('[fileSpace*] SPLITTINGATTRIBUTES[fileSpace*]')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
	     *        <continuationMark> value is set to [Character]
	     * FILE = PREFIX . '('[fileSpace*][StringConstant][fileSpace*]')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
	     *        <continuationMark> remains unchanged
	     * <isEof> is set according to # position
	     */
	    return pk_true;
	  /* WELLBALANCED is [Any_but_'}:'_but_'}']* in which '(', ')' are well balanced
	   * FILE = PREFIX . '(' [fileSpace*] SPLITTINGATTRIBUTES [fileSpace*]... [EOF], reading failed
	   * FILE = PREFIX . '(' [fileSpace*] [StringConstant] [fileSpace*] ... [EOF], reading failed
	   * FILE = PREFIX . '(' [fileSpace*] SPLITTINGATTRIBUTES [fileSpace*] UNRECOVERED # [EOF]
	   * FILE = PREFIX . '(' [fileSpace*] [StringConstant] [fileSpace*] UNRECOVERED # [EOF]
	   * FILE = PREFIX . '(' [fileSpace*] SPLITTINGATTRIBUTES [fileSpace*] WELLBALANCED '('[Any_'}:'_but_'}']* # [EOF], 
	   *             [Any_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>>
	   * FILE = PREFIX . '(' [fileSpace*] SPLITTINGATTRIBUTES [fileSpace*] WELLBALANCED ')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
	   * FILE = PREFIX . '(' [fileSpace*] SPLITTINGATTRIBUTES [fileSpace*][Any_but_'}:'_but_'}']*  # '}'[Any*][EOF]
	   *             [Any_but_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>> 
	   * FILE = PREFIX . '(' [fileSpace*] [StringConstant] [fileSpace*] WELLBALANCED '('[Any_'}:'_but_'}']* # [EOF], 
	   *             [Any_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>>
	   * FILE = PREFIX . '(' [fileSpace*] [StringConstant] [fileSpace*] WELLBALANCED ')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
	   * FILE = PREFIX . '(' [fileSpace*] [StringConstant] [fileSpace*] [Any_but_'}:'_but_'}']*  # '}'[Any*][EOF]
	   *             [Any_but_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>> 
	   * <isEof> is set according to # position
	   * error message is printed */
	  (*correct) = pk_false;
	  return pk_false;
	}
      /* failure stepIf_stringConstant_fSpStar_
       * FILE = PREFIX . '(' [fileSpace*] # opt{[Character_but_Space_but_<this_stringTag>][Any*]}[EOF]
       *                 <lCorrect> remains unchanged
       *
       * FILE = PREFIX . '(' [fileSpace*] ... # [EOF], internal error or reading failed
       * FILE = PREFIX . '(' [fileSpace*] <this_stringTag> [Character_but_<this_stringTag>]* [eol][fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
       *   or   PREFIX . '(' [fileSpace*] <this_stringTag> [Character_but_<this_stringTag>]* # [EOF]
       *                 <lCorrect> is set FALSE
       *                 error message is printed
       * <isEof> is set TRUE if [EOF] is reached
       */
      if (lCorrect)
	/* FILE = PREFIX . '(' [fileSpace*] # opt{[Character_but_Space_but_<this_stringTag>][Any*]}[EOF] */
	ASFatal_expected ("list of break character(string)");
      (*correct) = pk_false;
      if (isEof)
	/* FILE = PREFIX . '(' [fileSpace*] # [EOF] 
	 * FILE = PREFIX . '(' [fileSpace*] ... # [EOF], reading failed or internal error
	 *   or   PREFIX . '(' [fileSpace*]<this_stringTag> [Character_but_<this_stringTag>]* opt{[eol][fileSpace*]} # [EOF] */
	return pk_false;
      /* FILE = PREFIX . '(' [fileSpace*] # [Character_but_Space_but_<stringChar>][Any*][EOF]
       *   or   PREFIX . '(' [fileSpace*]<this_stringTag> [Character_but_<this_stringTag>]* [eol][fileSpace*] # [Character_but_Space][Any*][EOF]
       */
      if (recover_second_fSpStar_ (&isEof));
      /* WELLBALANCED is [Any_but_'}:'_but_'}']* that is well balanced wrt to '(', ')'
       * UNRECOVERED  is [Any_but_'}:'_but_'}']* that does not match <<WELLBALANCED')'[Any*]>>
       * FILE = PREFIX . '(' ERROR_SPLITTINGATTRIBUTES UNRECOVERED  # '}:'[Any*][EOF]
       *   or   PREFIX . '(' ERROR_SPLITTINGATTRIBUTES UNRECOVERED  # '}'[Any*][EOF]
       * FILE = PREFIX . '(' ERROR_SPLITTINGATTRIBUTES WELLBALANCED ')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
       * FILE = PREFIX . '(' [fileSpace*]... # [EOF], reading failed
       * FILE = PREFIX . '(' ERROR_SPLITTINGATTRIBUTES UNRECOVERED # [EOF], 
       * <isEof> is set according to  # position
       * info or error message is printed;
       */
      return pk_false;
    }
  /* FILE = PREFIX .# [Character_but_Space_but_'('][Any*][EOF]
   *            <correct> remains unchanged
   * FILE = PREFIX . '('[fileSpace*] # [EOF]
   *   or   PREFIX ... # [EOF], reading failed
   *            <correct> is set FALSE
   *            error message is printed
   *            this is set  ERRORCOMPLETED or ERRORCLOSED
   */
  return pk_false;
}

/* ==========  ==========  ==========  ========== TITLE: FILE OPEN/CLOSE
 */
/* PLG 2009-08-04 INNER OK, REF TODO
 * creates a reader, open file named CString_fileName, associates this file to the new created reader
 * success: FILE = [fileWhite*] # opt{[Character_but_White][Any*]}[EOF]
 * failure: file cannot be open or error occurred during initial reading
 *             error message is printed
 */
_PUBLIC_ boolean Lexical::fileOpen_fWhStar_ (const char *CString_fileName, boolean * isEof)
{
  // fprintf(stderr,"DEBUG Lexical::fileOpen_fWhStar_ +++++++++++++++++++++++++++++++++++++++++++++ \n");
  this_inBuffer = new InteReader (1024, 64);
  return this_inBuffer->fileOpen_fWhStar_ (CString_fileName, isEof);
  /* success: FILE = .[fileWhite*] # opt{[Character_but_White][Any*]}[EOF], <isEof> is set TRUE if [EOF] is reached
   * failure: errro message is printed, file is or remains closed
   */
}

/* PLG 2009-08-04 INNER OK, REF TODO
 * creates a reader, open file named "stdin", associates this file to the new created reader
 * success: FILE = [fileWhite*] # opt{[Character_but_White][Any*]}[EOF]
 * failure: file cannot be open or error occurred during initial reading=====================
 *             error message is printed
 */
_PUBLIC_ boolean Lexical::stdinOpen_fWhStar_ (char *stdinName, boolean * isEof)
{
  this_inBuffer = new InteReader ();
  return this_inBuffer->fileOpen_fWhStar_ (stdin, stdinName, isEof);
  /* success: FILE = .[fileWhite*] # opt{[Character_but_White][Any*]}[EOF], <isEof> is set TRUE if [EOF] is reached
   * failure: errro message is printed, file is or remains closed
   */
}

void
Lexical::closeFileReading ()
{
  this_inBuffer->closeFileReading ();
  delete this_inBuffer;
}

/* ==========  ==========  ==========  ========== TITLE: BUILDER
 */
/* creates and returns a new static root context associated to <aMKFFile> 
 * this is static
 */
ref2Lexical
Lexical::push ()
{
  // fprintf(stderr,"Lexical::push +++++++++++++++++++++++++++++++++++++++++++++ from %i\n", (int)this);
  return new Lexical (this);
}

ref2Lexical
Lexical::pop ()
{
  // fprintf(stderr,"Lexical::pop ---------------------------------------------- to %i\n", (int)this_predecessor);
  return this_predecessor;
}

/* creates and returns a new static lexical context using marks of toBeCloned set as predecessor
 */
Lexical::Lexical (ref2Lexical ancestor)	/* DONE */
:Soundness ()
{
  ancestor->get_lexicalMarks (&this_inBuffer, &this_openingChar, &this_closingChar, &this_stringTag, &this_commandChar);
  this_predecessor = ancestor;
}

/* creates and returns a new static lexical context using standard marks
 */
Lexical::Lexical ()		/* DONE */
:Soundness ()
{
  this_predecessor = NIL_Lexical;
  this_openingChar = openingTAG;
  this_closingChar = closingTAG;
  this_stringTag = stringTAG;
  this_commandChar = commandTAG;
}

/*
 *
 * Static Elements
 *
 */
/* global list of nodes to be built or processed, sorted during dependence analysis*/

ref2Lexical
  Lexical::the_staticLexical;

_STATIC_ void
Lexical::setStatic ()
{
  the_staticLexical = new Lexical ();
}
