_PUBLIC_
/* ========== Attributes
 */
/* ========== Printer
 */
  void
LineList::generate (ref2Buffer fileToPrint)
{
  ref2CStringList headAction = (ref2CStringList) this;

  while (headAction != NIL_CStringList)
    {
      if (headAction->content () == NIL_String)
	{
	  fileToPrint->line (1);
	}
      else
	{
	  fileToPrint->line (headAction->content ());
	}
      headAction = headAction->next ();
    }
}

_PUBLIC_ void
LineList::line (ref2IntePrinter outBuffer)
{
  generate ((ref2Buffer) outBuffer);
}

/* ========== Reader
 */

/* ========== Generator
 */
/* calls system for executing the sequence of lines beginning at this one
 * stops and returns false if command execution failed (results is not 0)
*/
_PUBLIC_ boolean LineList::execute ()
{
  // logDEBUG_in("execute");
  ref2CStringList
    headAction = (ref2CStringList) this;
  char *
    commandLine;
  while (headAction != NIL_CStringList)
    {
      commandLine = headAction->content ();
      if (commandLine == NIL_String)
	debugInfoExecEmptyString ();
      else
	{
	  debugInfoExec (commandLine);
	  if (!sysExec (commandLine))
	    return pk_false;
	}
      headAction = headAction->next ();
    }
  // logDEBUG_in("execute RETURN OK");
  return pk_true;
}

/* calls system for executing the sequence of lines beginning at this one
 * executes all lines despite errors
 * returns false if some command execution failed (results is not 0)
 */
boolean
LineList::forceExecute ()
{
  ref2CStringList headAction = (ref2CStringList) this;
  char *commandLine;
  boolean lCorrect = pk_true;
  while (headAction != NIL_CStringList)
    {
      commandLine = headAction->content ();
      debugInfoExec (commandLine);
      if (!sysExec (commandLine))
	lCorrect = pk_false;
      headAction = headAction->next ();
    }
  return pk_true;
}

/* ========== Builder
 */

/* creates an action line cell valued with aString
 * used in ArgumentList
 */
LineList::LineList (char *aString, ref2LineList succ):CStringList (aString, (ref2CStringList) succ), LineListReporting ()
{
  // logDEBUG_in("LineList(char * aString, ref2LineList succ)");
  // fprintf(stderr, "DEBUG        this adress is %i\n", (int)this);
}

/* creates an action line cell valued with aString
 * used in ArgumentList
 */
LineList::LineList (char *aString):
CStringList (aString),
LineListReporting ()
{
  // logDEBUG_in("LineList(char * aString)");
  // fprintf(stderr, "DEBUG        this adress is %i\n", (int)this);
}

/* creates an action line cell valued with aString
 * used in ArgumentList
 */
LineList::LineList ():CStringList (), LineListReporting ()
{
  // logDEBUG_in("LineList()");
  // fprintf(stderr, "DEBUG        this adress is %i\n", (int)this);
}

LineList::~LineList ()
{
  // logDEBUG_in("~LineList");
  // fprintf(stderr, "DEBUG        this adress is %i\n", (int)this);
}
