_PUBLIC_
/* ========== Attributes
 */
_VIRTUAL_ const char *
ListValFunctionCall::myClassName ()
{
  return "ListValFunctionCall";
}

_PUBLIC_ _VIRTUAL_ boolean ListValFunctionCall::is_isomorphic (ref2ArgumentFunctionCall arg_funcCall)
{
  if ((ref2ArgumentFunctionCall) this == arg_funcCall)
    return pk_true;
  if (arg_funcCall != NIL_ArgumentFunctionCall)
    {
      return arg_funcCall->is_isomorphic (this);
    }
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean ListValFunctionCall::is_isomorphic (ref2ListValFunctionCall arg_funcCall)
{
  if (this == arg_funcCall)
    return pk_true;
  return have_isomorphicParameters (arg_funcCall);
}

/* ========== Log
 */

/* ========== Writer
 */

/* ========== Set
 */

/* ========== Printer
 */

/* ========== Reader
 */

/* ========== Generator
 */

/* PLG 2005-12-08
 * should be protected
 * this is supposed to be SAFE
 * these_actualParameters is supposed to have one and only one (string) element
 * success: this is correctly expanded as the name of a registered list identifier 
 *          <this_expandedArgument> is set to the list value of this list identifier
 * failure: these_actualParameters expansion as a registered list identifier failed 
 *          error message is printed
 */
_PUBLIC_ _VIRTUAL_ boolean ListValFunctionCall::single_call ()
{
  // logDEBUG_in("single_call to listval");
  // logDEBUG_actualParameters();
  if (IS_SAFE ())
    {
      boolean
	lCorrect = pk_true;
      ref2ArgumentList
	argumentList_res;
      if (HAS_DYNAMIC_PARAMETER ())
	if (!get_identifier_expand_singleton_ (&this_CString_varName))	/*(fatal)error message is printed, fatal is set */
	  return pk_false;
      if (this_readingContext->getIf_expandedList_idVal_ (this_CString_varName, &lCorrect, &argumentList_res))
	{
	  /* DEBUG
	     if ( argumentList_res == NIL_ArgumentList )
	     logDEBUG_in("single_call getIf_expandedList_idVal_ OK empty, identifier is ", this_CString_varName);
	     else
	     logDEBUG_in("single_call getIf_expandedList_idVal_ OK NOT empty, identifier is ", this_CString_varName);
	     DEBUG */
	  this_expandedArgument = argumentList_res;
	  return pk_true;
	}
      // logDEBUG_in("single_call getIf_expandedList_idVal_ FAILED, identifier is ", this_CString_varName);
      if (lCorrect)
	{
	  this_expandedArgument = NIL_ArgumentList;
	  fatal_missingIdentifier ("list", this_CString_varName);
	}
    }
  return pk_false;
}

/* ========== Grapher
 */

/* ========== Builder
 */

/* 2004-10-14
 * creates a new :listval function call 
 * this <readingContext> current character is a not space character following the function name
 *                       or this <readingContext> current line contains the function name
                             not followed by not space and is completed
 * success: current character is a parameter list opening mark followed by actual parameters
                     followed by a parameter list closing mark
 *          this <readingContext> cursor is set after function call closing mark
 *          <correct> remains unchanged
 * failure: set <correct> to false
 *          error message is printed
 */
_PUBLIC_ ListValFunctionCall::ListValFunctionCall (ref2Context readingContext, ref2Argument actualParameter, boolean * correct):ListFunctionCall (readingContext, listvalWORD,
		  actualParameter)
{
  //  readingContext->log_ASDEBUG("ListValFunctionCall::ListValFunctionCall simple");
  if (!set_stringIdentifierArg (actualParameter, &this_CString_varName))	/*(fatal)error message is printed, fatal is set */
    (*correct) = pk_false;
}

/* 2004-10-14
 * creates a new iterated :listval function call 
 * this <readingContext> current character is a not space character following the function name
 *                       or this <readingContext> current line contains the function name
                             not followed by not space and is completed
 * success: current character is a parameter list opening mark followed by actual parameters
                     followed by a parameter list closing mark
 *          this <readingContext> cursor is set after function call closing mark
 *          <correct> remains unchanged
 * failure: set <correct> to false
 *          error message is printed
 * PLG check if parameter is a singleton !!!!!
 */
_PUBLIC_ ListValFunctionCall::ListValFunctionCall (ref2IteratorContext readingContext, ref2Argument actualParameter, boolean * correct):ListFunctionCall (readingContext, listvalWORD,
		  actualParameter)
{
  //  ((ref2Context)readingContext)->log_ASDEBUG("ListValFunctionCall::ListValFunctionCall iterated");
  if (!set_stringIdentifierArg (actualParameter, &this_CString_varName))	/*(fatal)error message is printed, fatal is set */
    (*correct) = pk_false;
}
