#define LOG_DEPATTR_LN() LOGFILE()->put_dependenceAttribute_ln(this_dependenceNature, this_hasHighDependenceLevel)

_PUBLIC_
/* ========== Attributes
 */
/* ========== Printer
 */
  _VIRTUAL_ void
MetaAncestor::print_ActualHeader (ref2Lexical printingContext, ref2IntePrinter outBuffer, int depth)
{
  if (this_argument_name != NIL_Argument)
    if (this_isVar)
      {
	this_argument_name->print_actualFormula (printingContext, outBuffer, depth, pk_false);
	outBuffer->space ();
      }
    else if (this_isFile)
      {
	outBuffer->put_fileTAG ();
	this_argument_name->print_actualFormula (printingContext, outBuffer, depth, pk_false);
	outBuffer->put_fileTAG ();
	outBuffer->space ();
      }
    else
      {
	outBuffer->put_externTAG ();
	this_argument_name->print_actualFormula (printingContext, outBuffer, depth, pk_false);
	outBuffer->put_externTAG ();
      }
  outBuffer->put_dependenceAttribute_ln (this_dependenceNature, this_hasHighDependenceLevel);
}

_VIRTUAL_ void
MetaAncestor::print_header (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  if (this_argument_name == NIL_Argument)
    {
      outBuffer->line ();
      return;
    }
  if (this_isVar)
    {
      this_argument_name->print_varNameFormula (printingContext, outBuffer);
      outBuffer->space ();
    }
  else if (this_isFile)
    {
      this_argument_name->print_fileNameFormula (printingContext, outBuffer);
      outBuffer->space ();
    }
  else
    {
      this_argument_name->print_externNameFormula (printingContext, outBuffer);
      outBuffer->space ();
    }
  outBuffer->put_dependenceAttribute_ln (this_dependenceNature, this_hasHighDependenceLevel);
}

/* ========== Log
 */
_VIRTUAL_ void
MetaAncestor::logDebug_header (int level)
{
  if (this_argument_name == NIL_Argument)
    {
      log_spn_str_ln (level, "header name is missing");
    }
  else
    {
      if (this_isVar)
	{
	  log_spn_str_ln (level, "this is a variable ancestor");
	}
      else if (this_isFile)
	{
	  log_spn_str_ln (level, "this is a file ancestor");
	}
      else
	{
	  log_spn_str_ln (level, "this is a host ancestor");
	}
      log_subTitle_ln (level, " referenced name is");
      this_argument_name->logExtendedDebug_formula_ln (level + 1);
      LOG_DEPATTR_LN ();
    }
}

/* ========== Grapher
 */

/* ========== Generator
 */

/* generates a ancestor singleton list from this
 * <callingContext> is not NIL (not checked)
 * success: generated ancestor is returned in <ancestorList_res>
 *              <ancestorList_res> is not empty
 * failure: this is not a correct ancestor generator
 *               error message is printed
 */
_VIRTUAL_ boolean
MetaAncestor::build_ancestors (ref2Context callingContext, ref2AncestorList * ancestorList_res)
{
  // fprintf(stderr, "DEBUG MetaAncestor::build_ancestors \n");
  if (IS_SAFE ())
    {
      char *name;
      if (this_argument_name->getIf_CString_cast_expand_ (&name))
	{
	  ref2NodeElement theIdentNode;
	  theIdentNode = (callingContext->get_contextTree ())->get_nodeReference (name, this_isVar, this_isFile);
	  theIdentNode->setReferredTo ();
	  (*ancestorList_res) = new AncestorList (theIdentNode, this_dependenceNature, this_hasHighDependenceLevel, NIL_LineList, NIL_AncestorList);
	  return pk_true;
	}
    }
  return pk_false;
}

/* ========== Reader
 */

/* ========== Builder
 */
/* 
 * Empty ancestor list creation
 */
MetaAncestor::MetaAncestor (ref2Argument argumentName, boolean isVar, boolean isFile, int dependenceNature, boolean dependenceLevel, ref2ArgumentList ancestorAction):GenericAncestor
  (ancestorAction)
{
  this_dependenceNature = dependenceNature;
  this_argument_name = argumentName;
  this_isVar = isVar;
  this_isFile = isFile;
  this_hasHighDependenceLevel = dependenceLevel;
}
