/* TODO 
 */

_PUBLIC_ _VIRTUAL_ const char *
MetaFileNode::myClassName ()
{
  return "MetaFileNode";
}

/* ========== Attributes
 */

/* ========== Debugger
 */
_PROTECTED_ _VIRTUAL_ void
MetaFileNode::logDebug_metaCategory (int level)
{
  if (this_isExecutable)
    log_spn_str_ln (level, "this is an executable file");
  else if (this_isWrite)
    log_spn_str_ln (level, "this is a writable file");
  else
    log_spn_str_ln (level, "this is a standard file");
}

/* ========== Log
 */

/* ========== Set
 */

/* ========== Printer
 */

_PROTECTED_ _VIRTUAL_ void
MetaFileNode::print_name (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  this_name->print_fileNameFormula (printingContext, outBuffer);
}

_PROTECTED_ _VIRTUAL_ void
MetaFileNode::print_genericAttribute (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  if (this_isWrite)
    {
      outBuffer->space ();
      printingContext->out_fileWriteContext_sp (outBuffer, this_isExecutable, this_breakCharList, this_continuationMark);
    }
  outBuffer->line ();
}

/* ========== Reader
 */

/* 2005-04-04
 * creates and returns a new object descriptor which name generator is <nameArgument>
 * success: cursor starts [Direct_attribute] [fileSpace*] [NODE_BODY] '}' [fileSpace*] [Character_but_Space]
 *          or cursor starts [NODE_BODY] '}' [fileSpace*] [Character_but_Space]
 *          where
 *          cursor is moved to final [Character_but_Space]
 * failure: cursor starts [Character*] '}' [fileSpace*] [Character_but_Space], 
 *            an error occured in [Character*], '{' '}' are well balanced in [Character*]
 *                cursor is moved to final [Character_but_Space]
 *          cursor starts [Character*] [fileSpace*] [EOF], 
 *            '{' '}' are well balanced in [Character*]
 *                cursor is moved to final [EOF]
 *          error message is printed
 * PLG USED IN FREE POSITION: checked 2007-04-17 read_metaFile_fSpStar_
 */
_PUBLIC_ _VIRTUAL_ boolean MetaFileNode::read_metaBody_fSpStar_nSp ()
{
  // this_readingContext->log_ASDEBUG("entering MetaFileNode::read_metaBody_fSpStar_nSp");
  // fprintf(stderr, "DEBUG MetaFileNode::read_metaBody_fSpStar_\n");
  if ((this_readingContext->get_lexicalContext ())->stepOpt_fileDefinitionMode_fSpStar_nSp (&this_isWrite, &this_isExecutable))
    {
      /* FILE = PREFIX . <commandChar>'exec'[fileSpace*] # [Character_but_Space][Any*][EOF]
       *             <this_isWrite> is set TRUE
       *             <isExec> is set TRUE
       *          FILE = PREFIX . <commandChar>'write'[fileSpace*] # [Character_but_Space][Any*][EOF]
       *             <this_isWrite> is set TRUE
       *             <isExec> is set FALSE
       *          FILE = PREFIX .# [Character_but_Space_but_<commandChar>][Any*][EOF]
       *             <this_isWrite> is set FALSE
       *             <isExec> remain unchanged
       */
      boolean
	lCorrect = pk_true;
      if (this_isWrite)
	this_isFormatted = this_readingContext->readIf_splittingAttributes_fSpStar_nSp (&lCorrect, &this_breakCharList, &this_continuationMark);
      else
	this_isFormatted = pk_false;
      thisHas_conditionalBuilding = pk_false;
      if (lCorrect)
	{
	  if (readOpt_MetaBuilder_eol_ ())
	    {
	      return pk_true;
	    }
	  return pk_false;
	}
      return pk_false;
    }
  /* FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Any*][EOF]
   *             [Identifier] is neither 'exec' nor 'write'
   *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [EOF]
   *             [Identifier] is either 'exec' or 'write'
   *          FILE = PREFIX . ... [EOF], reading failed
   *          error message is printed
   */
  return pk_false;
}

/* ========== Generator
 */

_PRIVATE_ boolean MetaFileNode::build_FileDecl (ref2DynamicContext callingContext, char *name, ref2ArgumentList comments)
{
  ref2FileNode
    curFileNode;

  // logDEBUG_in("build_FileDecl");
  if ((callingContext->get_contextTree ())->getIf_fileDeclaration (callingContext, name, &curFileNode))
    {
      if (build_body (callingContext, curFileNode, comments))
	{
	  closeNodeConstruction (curFileNode);
	  return pk_true;
	}
    }
  return pk_false;
}

/* ========= Direct file
 * <callingContext> is not NIL (not checked)
 */
_PRIVATE_ boolean MetaFileNode::build_DirectFileDecl (ref2DynamicContext callingContext, char *name, ref2ArgumentList comments)
{
  ref2DirectFileNode
    curDirectFileNode;

  // logDEBUG_in("build_DirectFileDecl ++++++++++++++++++++++++ ");
  if (this_isFormatted)
    {
      ref2FormattedFileNode
	curFormattedFileNode;
      if ((callingContext->get_contextTree ())->getIf_formattedFileDeclaration (callingContext, name, this_isExecutable,
										this_breakCharList, this_continuationMark, &curFormattedFileNode))
	curDirectFileNode = (ref2DirectFileNode) curFormattedFileNode;
      else
	return pk_false;
    }
  else if (!((callingContext->get_contextTree ())->getIf_directFileDeclaration (callingContext, name, this_isExecutable, &curDirectFileNode)))
    return pk_false;
  if (build_body (callingContext, curDirectFileNode, comments))
    {
      closeNodeConstruction (curDirectFileNode);
      return pk_true;
    }
  return pk_false;
}


/* ========= Generic
 */

/* builds a node from this
 * <callingContext> is not NIL (not checked)
 * parameterValues has been assigned to formal parameters
 * remains callingContext unchanged
 * failure: this is not a correct node generator
 *               error message is printed
 */
_PROTECTED_ _VIRTUAL_ boolean MetaFileNode::build_elementInnerDecl (ref2DynamicContext callingContext, char *name, ref2ArgumentList comments)
{
  // logDEBUG_in("build_elementInnerDecl");
  if (this_isExecutable || this_isWrite)
    {
      return build_DirectFileDecl (callingContext, name, comments);
    }
  return build_FileDecl (callingContext, name, comments);
}

/* ========== Builder
 */
/* 2004-12-30
 * creates and returns a new object descriptor which name generator is <nameArgument>
 * success: cursor starts [Direct_attribute] [fileSpace*] [NODE_BODY] '}' [fileSpace*] [Character_but_Space]
 *          or cursor starts [NODE_BODY] '}' [fileSpace*] [Character_but_Space]
 *          where
 *          cursor is moved to final character [fileSpace*] [Character_but_Space]
 * failure: cursor starts [Character*] '}' [fileSpace*] [Character_but_Space], 
 *            an error occured in [Character*], '{' '}' are well balanced in [Character*]
 *                cursor is moved to final [Character_but_Space]
 *          cursor starts [Character*] [fileSpace*] [EOF], 
 *            '{' '}' are well balanced in [Character*]
 *                cursor is moved to final [EOF]
 *          error message is printed
 *          <correct> is set to false
 * PLG USED IN FREE POSITION: checked 2007-04-17 MetaFileNode::MetaFileNode
 */
_PUBLIC_ MetaFileNode::MetaFileNode (ref2DynamicContext readingContext, ref2ArgumentList comments, ref2Argument nameArgument):MetaNodeElement (readingContext, comments,
		 nameArgument)
{
}
