/* ================================== */
_PUBLIC_ _VIRTUAL_ const char *
MetaIdentifier::myClassName ()
{
  return "MetaIdentifier";
}

/* ========== Attributes
 */

/* returns this char * name
 */
_PUBLIC_ ref2Argument MetaIdentifier::get_metaName ()
{
  return this_metaName;
}

/* returns this char * name
 */
_PUBLIC_ ref2MetaContext MetaIdentifier::get_ownerContext ()
{
  return this_ownerContext;
}

_PUBLIC_ _VIRTUAL_ boolean MetaIdentifier::is_isomorphic (char *str_name)
{
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean MetaIdentifier::is_isomorphic (ref2MetaArgument metaIdent)
{
  if (this_metaName != NIL_Argument)
    return this_metaName->is_isomorphic (metaIdent);
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean MetaIdentifier::is_isomorphic (ref2CommandArgument commandIdent)
{
  if (this_metaName != NIL_Argument)
    return this_metaName->is_isomorphic (commandIdent);
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean MetaIdentifier::is_isomorphic (ref2Identifier ident_arg)
{
  if (ident_arg == NIL_Identifier)
    return pk_false;
  return ident_arg->is_innerIsomorphic (this);
}

_PUBLIC_ _VIRTUAL_ boolean MetaIdentifier::is_isomorphic (ref2MetaIdentifier ident_arg)
{
  if (ident_arg == NIL_Identifier)
    return pk_false;
  if (this_ownerContext == ident_arg->get_ownerContext ())
    return this_metaName->is_isomorphic (ident_arg->get_metaName ());
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean MetaIdentifier::is_innerIsomorphic (ref2Identifier ident_arg)
{
  return pk_false;
}

/* ident_arg is not NIL (not checked)
 */
_PUBLIC_ _VIRTUAL_ boolean MetaIdentifier::is_innerIsomorphic (ref2MetaIdentifier ident_arg)
{
  return is_isomorphic (ident_arg);
}

/* ========== Log
 */
_PROTECTED_ _VIRTUAL_ void
MetaIdentifier::log_name_sp ()
{
  this_metaName->log_formula_ (pk_false);
  LOG_SP ();
}

/* ========== Writer
 */

_PROTECTED_ void
MetaIdentifier::print_metaName_sp (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  this_metaName->print_varNameValue (printingContext, outBuffer);
  outBuffer->space ();
}

/* prints this name separated by spaces
 */
void
MetaIdentifier::print_typedMetaName_sp (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  outBuffer->put_type_sp (HAS_LIST_TYPE ());
  print_metaName_sp (printingContext, outBuffer);
}

/* prints this actual value with CString tags
 */
_VIRTUAL_ void
MetaIdentifier::print_actualFormula (ref2Lexical printingContext, ref2IntePrinter outBuffer, int depth, boolean inAList)
{
  if (this_argumentValue != NIL_Argument)
    this_argumentValue->print_actualFormula (printingContext, outBuffer, depth, inAList);
  else
    print_metaName_sp (printingContext, outBuffer);
}

/* prints this actual value 
 */
_VIRTUAL_ void
MetaIdentifier::print_formula (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  print_metaName_sp (printingContext, outBuffer);
}

/* ========== Log
 */
/* prints this actual value with CString tags
 */
_PUBLIC_ _VIRTUAL_ void
MetaIdentifier::logExtendedDebug_formula_ln (int level)
{
  if (IS_SAFE ())
    {
      logDebug_formulaHead_ln (level);
      print_metaName_sp (LOGMARKS (), LOGFILE ());
      logDebug_expandedFormula_ln (level);
    }
  else
    log_spn_str_ln (level, "this is ## in error ##");
}

/* ========== Generator
 */
/* ========== Builder
 */

/* creates and returns a parameter identifier named <aName>
 * if isAListMetaIdentifier this type is string list else it is string
 */
_PUBLIC_ MetaIdentifier::MetaIdentifier (ref2MetaContext _ownerContext, ref2Argument _metaName, boolean isAListIdentifier, ref2Argument formula):Identifier (NIL_String, isAListIdentifier,
	    formula)
{
  this_metaName = _metaName;
  this_ownerContext = _ownerContext;
}
