/* TODO 
 */

_PUBLIC_ _VIRTUAL_ const char *
MetaNodeElement::myClassName ()
{
  return "MetaNodeElement";
}

/* ========== Attributes
 */

/* ========== Debugger
 */
_PROTECTED_ _VIRTUAL_ void
MetaNodeElement::logDebug_metaCategory (int level)
{
}

_PRIVATE_ void
MetaNodeElement::logDebug_prelude_ln (int level)
{
  if (this_metaPrelude == NIL_ArgumentList)
    log_NILComponent_ln (level, "prelude");
  else
    {
      log_subTitle_ln (level, "these prelude lines are");
      this_metaPrelude->logExtendedDebug_formula_ln (level + 1);
    }
}

_PRIVATE_ void
MetaNodeElement::logDebug_AncestorList (int level)
{
  if (these_genericAncestors == NIL_GenericAncestorList)
    log_NILComponent_ln (level, "ancestor list");
  else
    {
      log_subTitle_ln (level, "these ancestors are");
      these_genericAncestors->logExtendedDebug_formula_ln (level + 1);
    }
}

_PRIVATE_ void
MetaNodeElement::logDebug_default_ln (int level)
{
  if (this_defaultMetaAction == NIL_ArgumentList)
    log_NILComponent_ln (level, "default action");
  else
    {
      log_subTitle_ln (level, "these default lines are");
      this_defaultMetaAction->logExtendedDebug_formula_ln (level + 1);
    }
}

_PROTECTED_ _VIRTUAL_ void
MetaNodeElement::logDebug_body (int level)
{
  logDebug_prelude_ln (level);
  logDebug_AncestorList (level);
  logDebug_default_ln (level);
}

/* ========== Log
 */

_PROTECTED_ void
MetaNodeElement::closeNodeConstruction (ref2NodeElement aNode)
{
  if (aNode == NIL_NodeElement)
    {
      /* appends  'eol'';''spc''--:''spc' <aNode name>'spc''empty node''eol' */
      LOG_LN_COMMENTITEM_STR_SP_STR_LN (aNode->get_name (), "empty node");
      return;
    }
  /*  if ( thisOutBuffer != NIL_IntePrinter ) {
     aNode->print(thisOutBuffer, pk_true);
     thisOutBuffer->line(); } */
  if (ISDEBUG ())
    {
      /* if ( thisOutBuffer == NIL_IntePrinter ) */
      if (ISLDEBUG ())
	{
	  ((ref2Element) aNode)->log_ln_INFO_ref__ln ("generation of ");
	  aNode->print (LOGMARKS (), LOGFILE (), pk_true);
	  LOG_LN ();
	  return;
	}
      /* appends  'eol'';''spc''--:' 'spc''generation of''spc' <aNode name>'eol' */
      LOG_LN_COMMENTITEM_STR_SP_STR_LN ("generation of", aNode->get_name ());
    }
}

/* ========== Set
 */

/* ========== Printer
 */

_PROTECTED_ _VIRTUAL_ void
MetaNodeElement::print_name (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  // logDEBUG_in("print_name");
}

_PROTECTED_ _VIRTUAL_ void
MetaNodeElement::print_genericAttribute (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  // logDEBUG_in("print_genericAttribute");
}

_VIRTUAL_ void
MetaNodeElement::print_genericHeader (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  if (this_name == NIL_Argument)
    {
      outBuffer->line ();
      return;
    }
  print_name (printingContext, outBuffer);
  print_genericAttribute (printingContext, outBuffer);
}

_PROTECTED_ _VIRTUAL_ void
MetaNodeElement::print_genericValue (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  if (this_metaPrelude != NIL_ArgumentList)
    {
      outBuffer->put_ln_preludeOpening_ln ();
      this_metaPrelude->line_formula (printingContext, outBuffer);
    }
  if (these_genericAncestors != NIL_GenericAncestorList)
    {
      these_genericAncestors->print_formula (printingContext, outBuffer);
    }
  if (this_defaultMetaAction != NIL_ArgumentList)
    {
      outBuffer->put_ln_defaultOpening_ln ();
      this_defaultMetaAction->line_formula (printingContext, outBuffer);
    }
}

/* ========== Reader
 */

/* 2008_07-02
 * reads and sets this body content
 * success: FILE = PREFIX.[_NODE_ACTION]#'}'[Any*][EOF]
 *          where [_NODE_ACTION] ::= opt{[_PRELUDE]} [_ANCESTOR*] opt{[_DEFAULT]}
 * failure: some error occurred during component reading
 *          error message is printed
 *          cursor is moved to  errored position
 */
_PROTECTED_ boolean MetaNodeElement::readOpt_MetaBuilder_eol_ ()
{
  // this_readingContext->log_ASDEBUG("MetaNodeElement::readOpt_MetaBuilder_eol_");
  if (!this_readingContext->readOpt_genericNodePrelude_eol_ (&this_metaPrelude))
    return pk_false;
  if (!this_readingContext->readOpt_genericAncestorList_eol_ (&these_genericAncestors))
    return pk_false;
  return this_readingContext->readOpt_genericNodeDefault_eol_ (&this_defaultMetaAction);
}

/* 2005-04-04
 * creates and returns a new object descriptor which name generator is <nameArgument>
 * success: cursor starts [Direct_attribute] [fileSpace*] [NODE_ACTION] '}' [fileSpace*] [Character_but_Space]
 *          or cursor starts [NODE_ACTION] '}' [fileSpace*] [Character_but_Space]
 *          where
 *          cursor is moved to final [Character_but_Space]
 * failure: cursor starts [Character*] '}' [fileSpace*] [Character_but_Space], 
 *            an error occured in [Character*], '{' '}' are well balanced in [Character*]
 *                cursor is moved to final [Character_but_Space]
 *          cursor starts [Character*] [fileSpace*] [EOF], 
 *            '{' '}' are well balanced in [Character*]
 *                cursor is moved to final [EOF]
 *          error message is printed
 * PLG USED IN FREE POSITION: checked 2007-04-17 read_metaFile_fSpStar_
 */
_PUBLIC_ _VIRTUAL_ boolean MetaNodeElement::read_metaBody_fSpStar_nSp ()
{
  return pk_true;
}

/* ========== Generator
 */


/* build actual curNode body; curNode::this_buildingData is not NIL;
 * must be done before all node consultations
 * <callingContext> is not NIL (not checked)
 */
_PROTECTED_ boolean MetaNodeElement::build_body (ref2DynamicContext callingContext, ref2NodeElement curNode, ref2ArgumentList comments)
{
  // logDEBUG_in("build_body(ref2Context, ref2NodeElement, ref2ArgumentList)");
  ref2LineList
    preludeLineList = NIL_LineList;
  ref2AncestorList
    ancestorList = NIL_AncestorList;
  ref2LineList
    defaultLineList = NIL_LineList;

  curNode->setComments (comments);
  /* prelude */
  if (this_metaPrelude != NIL_ArgumentList)
    if (!this_metaPrelude->getIf_lineList_cast_flatExpand_ (&preludeLineList))
      {
	curNode->set_fatal ();
	return pk_false;
      }
  /* ancestors */
  if (these_genericAncestors != NIL_GenericAncestorList)
    if (!(these_genericAncestors->build_ancestorList (callingContext, &ancestorList)))
      {
	curNode->set_fatal ();
	return pk_false;
      }
  /* <ancestorList> may be empty */
  /* default */
  if (this_defaultMetaAction != NIL_ArgumentList)
    if (!this_defaultMetaAction->getIf_lineList_cast_flatExpand_ (&defaultLineList))
      {
	curNode->set_fatal ();
	return pk_false;
      }
  return curNode->set_builder (preludeLineList, ancestorList, defaultLineList, thisHas_conditionalBuilding);
}

/* ========= Generic
 */

/* builds a node from this
 * <callingContext> is not NIL (not checked)
 * parameterValues has been assigned to formal parameters
 * remains callingContext unchanged
 * failure: this is not a correct node generator
 *               error message is printed
 */
_PROTECTED_ _VIRTUAL_ boolean MetaNodeElement::build_elementInnerDecl (ref2DynamicContext callingContext, char *name, ref2ArgumentList comments)
{
  // logDEBUG_in("build_elementInnerDecl, name is", name);
  return pk_false;
}

/* ========== Builder
 */
/* 2004-12-30
 * creates and returns a new object descriptor which name generator is <nameArgument>
 * success: cursor starts [Direct_attribute] [fileSpace*] [NODE_ACTION] '}' [fileSpace*] [Character_but_Space]
 *          or cursor starts [NODE_ACTION] '}' [fileSpace*] [Character_but_Space]
 *          where
 *          cursor is moved to final character [fileSpace*] [Character_but_Space]
 * failure: cursor starts [Character*] '}' [fileSpace*] [Character_but_Space], 
 *            an error occured in [Character*], '{' '}' are well balanced in [Character*]
 *                cursor is moved to final [Character_but_Space]
 *          cursor starts [Character*] [fileSpace*] [EOF], 
 *            '{' '}' are well balanced in [Character*]
 *                cursor is moved to final [EOF]
 *          error message is printed
 *          <correct> is set to false
 * PLG USED IN FREE POSITION: checked 2007-04-17 MetaNodeElement::MetaNodeElement
 */
_PROTECTED_ MetaNodeElement::MetaNodeElement (ref2DynamicContext readingContext, ref2ArgumentList comments, ref2Argument nameArgument):MetaElement (readingContext, comments,
	     nameArgument)
{
  // this_readingContext->log_ASDEBUG("MetaNodeElement::MetaNodeElement");
  thisHas_conditionalBuilding = pk_false;
  this_metaPrelude = NIL_ArgumentList;
  these_genericAncestors = NIL_GenericAncestorList;
  postludeAction = NIL_ArgumentList;
  this_defaultMetaAction = NIL_ArgumentList;
}
