/* TODO 
 */

_PUBLIC_ _VIRTUAL_ const char *
MetaVariableNode::myClassName ()
{
  return "MetaVariableNode";
}

/* ========== Attributes
 */

/* ========== Debugger
 */
_PROTECTED_ _VIRTUAL_ void
MetaVariableNode::logDebug_metaCategory (int level)
{
  if (this_isExecutable)
    log_spn_str_ln (level, "this is an executable variable");
  else if (this_isBuildable)
    log_spn_str_ln (level, "this is a standard variable");
  else
    log_spn_str_ln (level, "this is datation variable");
}

/* ========== Log
 */

/* ========== Set
 */

/* ========== Printer
 */

_PROTECTED_ _VIRTUAL_ void
MetaVariableNode::print_name (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  this_name->print_varNameFormula (printingContext, outBuffer);
  outBuffer->space ();
}

_PROTECTED_ _VIRTUAL_ void
MetaVariableNode::print_genericAttribute (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  printingContext->out_varAttributes_ln (outBuffer, this_isExecutable, this_isBuildable, pk_false);
}

/* ========== Reader
 */

/* 2005-04-04
 * creates and returns a new object descriptor which name generator is <nameArgument>
 * success: cursor starts [Direct_attribute] [fileSpace*] [NODE_BODY] '}' [fileSpace*] [Character_but_Space]
 *          or cursor starts [NODE_BODY] '}' [fileSpace*] [Character_but_Space]
 *          where
 *          cursor is moved to final [Character_but_Space]
 * failure: cursor starts [Character*] '}' [fileSpace*] [Character_but_Space], 
 *            an error occured in [Character*], '{' '}' are well balanced in [Character*]
 *                cursor is moved to final [Character_but_Space]
 *          cursor starts [Character*] [fileSpace*] [EOF], 
 *            '{' '}' are well balanced in [Character*]
 *                cursor is moved to final [EOF]
 *          error message is printed
 * PLG USED IN FREE POSITION: checked 2007-04-17 read_metaVar_fSpStar_
 */
_PUBLIC_ _VIRTUAL_ boolean MetaVariableNode::read_metaBody_fSpStar_nSp ()
{
  // this_readingContext->log_ASDEBUG("entering DEBUG MetaVariableNode::read_metaBody_fSpStar_nSp");
  if ((this_readingContext->get_lexicalContext ())->
      stepOpt_varDefinitionMode_fSpStar_nSp (&this_isBuildable, &this_isExecutable, &thisHas_conditionalBuilding))
    {
      /* FILE = PREFIX . opt{<commandChar>[execWORD][White*]}['/'][fileSpace*] # [Character_but_Space][Any*][EOF]
       *              (isBuildable,isCond,isExec) =  (pk_true,true,isExec), isExec is pk_true iff [execWORD] is present
       *          FILE = PREFIX . <commandChar>[execWORD][fileSpace*] # [Character_but_Space][Any*][EOF]
       *                  if [fileSpace*] is empty  opt{[Character_but_Space][Any*]} does not start with an IdentCharacter
       *                  if [fileSpace*] has no [eol] occurrence,   opt{[Character_but_Space][Any*]} does not start with '/'
       *             (isBuildable,isCond,isExec) =  (pk_true,false,true)
       *          FILE = PREFIX .# [Any*][EOF], first [Any] not in {':', '/', '~'}
       *             (isBuildable,isCond,isExec) =  (pk_true,false,false)
       *          FILE = PREFIX . '~'[fileSpace*] # [Character_but_Space][Any*][EOF]
       *             (isBuildable,isCond,isExec) = (pk_false,false,false)
       */
      return readOpt_MetaBuilder_eol_ ();
    }
  /* FILE = PREFIX . opt{<commandChar>[execWORD][White*]}['/'][fileSpace*] # [EOF]
   *          FILE = PREFIX . <commandChar>[execWORD][fileSpace*] # [EOF]
   *          FILE = PREFIX . '~'[fileSpace*] # [EOF]
   *          FILE = PREFIX . <commandChar>[execWORD]opt{[lineSpaces]}...# [EOF], reading failed
   *                (isBuildable,isCond,isExec) =  (pk_true,true,false)
   *          FILE = PREFIX . <commandChar>[execWORD][White*]['/']opt{[lineSpaces]}... # [EOF], reading failed
   *                (isBuildable,isExec,isCond) =  (pk_true,true,true)
   *          FILE = PREFIX .# <commandChar>opt{[eol][Any*]}[EOF]
   *            or = PREFIX .# <commandChar>[execWORD][Identifier][Character*]opt{[eol][Any*]}[EOF]
   *            or = PREFIX .# <commandChar>[Character+]opt{[eol][Any*]}[EOF], [execWORD] is not a prefix of [Character+]
   *            or = PREFIX . ... # [EOF], reading failed
   *                (isBuildable,isExec,isCond) remain unchanged
   *          error message is printed
   */
  return pk_false;
}

/* ========== Generator
 */

/* builds a node from this
 * <callingContext> is not NIL (not checked)
 * parameterValues has been assigned to formal parameters
 * remains callingContext unchanged
 * failure: this is not a correct node generator
 *               error message is printed
 */
_PROTECTED_ _VIRTUAL_ boolean MetaVariableNode::build_elementInnerDecl (ref2DynamicContext callingContext, char *name, ref2ArgumentList comments)
{
  // openDEBUG_in("build_elementInnerDecl, name is", name);
  ref2VariableNode
    curVariableNode;

  if ((callingContext->get_contextTree ())->getIf_variableDeclaration (callingContext, name, this_isExecutable, &curVariableNode))
    {
      if (build_body (callingContext, curVariableNode, comments))
	{
	  if (this_isExecutable)
	    curVariableNode->set_executable ();
	  else if (this_isBuildable)
	    {
	      curVariableNode->set_buildable ();
	    }
	  closeNodeConstruction (curVariableNode);
	  // closeDEBUG_in("build_elementInnerDecl");
	  return pk_true;
	}
    }
  // closeDEBUG_in("build_elementInnerDecl");
  return pk_false;
}

/* ========== Builder
 */
/* 2004-12-30
 * creates and returns a new object descriptor which name generator is <nameArgument>
 * success: cursor starts [Direct_attribute] [fileSpace*] [NODE_BODY] '}' [fileSpace*] [Character_but_Space]
 *          or cursor starts [NODE_BODY] '}' [fileSpace*] [Character_but_Space]
 *          where
 *          cursor is moved to final character [fileSpace*] [Character_but_Space]
 * failure: cursor starts [Character*] '}' [fileSpace*] [Character_but_Space], 
 *            an error occured in [Character*], '{' '}' are well balanced in [Character*]
 *                cursor is moved to final [Character_but_Space]
 *          cursor starts [Character*] [fileSpace*] [EOF], 
 *            '{' '}' are well balanced in [Character*]
 *                cursor is moved to final [EOF]
 *          error message is printed
 *          <correct> is set to false
 * PLG USED IN FREE POSITION: checked 2007-04-17 MetaVariableNode::MetaVariableNode
 */
_PUBLIC_ MetaVariableNode::MetaVariableNode (ref2DynamicContext readingContext, ref2ArgumentList comments, ref2Argument nameArgument):MetaNodeElement (readingContext, comments,
		 nameArgument)
{
  //  readingContext->log_ASDEBUG("MetaVariableNode::MetaVariableNode");
}
