#define LOG_LN_INFOSTAT_LN(_NAME, _II_, _JJ_) LOGFILE()->put_ln_INFO__statLine(_NAME, _II_, _JJ_)
#define LOG_LN_INFOGLOBALSTAT_LN(_NAME, _TT, _SS, _II, _JJ) LOGFILE()->put_ln_INFO__statGlobLines(_NAME, _TT, _SS, _II, _JJ)
_PUBLIC_ int
NodeManager::getStringHash (char *aString)
{
  int i, index, maxi, step, length = strlen (aString);
  int hashi = length;
  if (length <= 4)
    for (i = 0; i < length; i = i + 1)
      hashi = hashi + (unsigned) (aString[i]);
  else
    {
      if (length <= 19)
	{
	  maxi = 5;
	  if (length <= 8)
	    {
	      if (length == 6)
		step = 5;
	      else
		step = 3;
	    }
	  else
	    {
	      if (length <= 12)
		step = 7;
	      else
		step = 11;
	    }
	}
      else
	{
	  maxi = 7;
	  if (length <= 31)
	    step = 17;
	  else
	    step = 29;
	}
      index = step / 4;
      for (i = 0; i <= maxi; i = i + 1)
	{
	  hashi = hashi + (unsigned) (aString[index]);
	  index = index + step;
	  if (index >= length)
	    index = index - length;
	}
    }
  hashi = (hashi % size);
  return hashi;
}

/* PLG 2006-01-17
 * <pt2Element> is supposed to be not nil
 */
void
NodeManager::register_ (ref2Element pt2Element, int index)
{
  // fprintf(stderr, "DEBUG NodeManager:register:_ elt adr %i, name %s, index %i\n", (int)pt2Element, pt2Element->get_name(), index);
  ref2ElementList listHead = table[index];

  if (listHead == NIL_ElementList)
    table[index] = new ElementList (pt2Element);
  else
    listHead->append (pt2Element);
}

/* PLG 2006-01-17
 * <pt2Element> is supposed to be not nil
 */
void
NodeManager::register_ (ref2Element pt2Element, char *name)
{
  register_ (pt2Element, getStringHash (name));
}

void
NodeManager::replace_ (ref2Element prevElt, ref2Element newElt, int index)
{
  // fprintf(stderr, "DEBUG NodeManager::replace_ index is %i, prevElt adr is %i, newElt adr is %i\n", index, prevElt, newElt);
  (table[index])->replace (prevElt, newElt);
}

/* PLG 2006-01-17
 * search for an existing node named name 
 * returns in index its table entry index
 * if node is not found returns false
 * if node is found 
 *       returns this node in refFoundElt
 *       returns pk_true
 */
boolean
NodeManager::find_ (char *name, int *index, ref2Element * refFoundElt)
{
  // fprintf(stderr, "DEBUG NodeManager::find_ name is %s\n", name);
  ref2ElementList theElementList;
  *index = getStringHash (name);
  theElementList = table[*index];
  if (theElementList == NIL_ElementList)
    return pk_false;
  return theElementList->find (name, refFoundElt);
}

void
NodeManager::print (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  int i;

  for (i = 0; i < size; i++)
    if (table[i] != NIL_ElementList)
      (table[i])->print (printingContext, outBuffer);
}

void
NodeManager::logUnreferred ()
{
  int i;

  for (i = 0; i < size; i++)
    {
      if (table[i] != NIL_ElementList)
	(table[i])->logUnreferred ();
    }
}

void
NodeManager::logStatistics (const char *name, boolean allStat, int objectNumber)
{
  int i, count, total = 0;
  int smallest = objectNumber;
  int greatest = 0;

  if (allStat)
    LOG_LN_ (1);
  for (i = 0; i < size; i++)
    {
      if (table[i] == NIL_ElementList)
	count = 0;
      else
	count = (table[i])->size ();
      if (allStat)
	LOG_LN_INFOSTAT_LN (name, i, count);
      if (count < smallest)
	smallest = count;
      if (count > greatest)
	greatest = count;
      total = total + count;
    }
  if (allStat)
    LOG_LN_ (1);
  LOG_LN_INFOGLOBALSTAT_LN (name, total, size, smallest, greatest);
}

/* object, file other tables initialization
 */
NodeManager::NodeManager (int aSize)
{
  int i;
  size = aSize;
  table = new ref2ElementList[size];
  for (i = 0; i < size; i++)
    table[i] = NIL_ElementList;
}
