
/* ========== Attributes
 */

_PUBLIC_ _VIRTUAL_ const char *
StringValFunctionCall::myClassName ()
{
  return "StringValFunctionCall";
}

_PUBLIC_ _VIRTUAL_ boolean StringValFunctionCall::is_isomorphic (ref2ArgumentFunctionCall arg_funcCall)
{
  if ((ref2ArgumentFunctionCall) this == arg_funcCall)
    return pk_true;
  if (arg_funcCall != NIL_ArgumentFunctionCall)
    {
      return arg_funcCall->is_isomorphic (this);
    }
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean StringValFunctionCall::is_isomorphic (ref2StringValFunctionCall arg_funcCall)
{
  if (this == arg_funcCall)
    return pk_true;
  return have_isomorphicParameters (arg_funcCall);
}

/* ========== Log
 */

/* ========== Writer
 */

/* ========== Set
 */

/* ========== Printer
 */

/* ========== Reader
 */

/* ========== Generator
 */

/* PLG 2005-12-07
 * should be protected
 * this is supposed to be SAFE
 * these_actualParameters is supposed to have one and only one (string) element
 * success: this is correctly expanded as the name of a registered string identifier 
 *          <this_expandedArgument> is set to the string value of this string identifier 
 * failure: these_actualParameters expansion as a registered string identifier failed 
 *          error message is printed
 */
_PUBLIC_ _VIRTUAL_ boolean StringValFunctionCall::single_call ()
{
  // logDEBUG_in("ENTER single_call() to function stringval");
  // logDEBUG_actualParameters();
  if (IS_SAFE ())
    {
      boolean
	lCorrect = pk_true;
      ref2StringArgument
	stringArgument;
      if (HAS_DYNAMIC_PARAMETER ())
	if (!get_identifier_expand_singleton_ (&this_CString_varName))
	  {			/*(fatal)error message is printed, fatal is set */
	    return pk_false;
	  }
      if (this_readingContext->getIf_expandedString_idVal_ (this_CString_varName, &lCorrect, &stringArgument))
	{
	  this_expandedArgument = stringArgument;
	  if (stringArgument == NIL_Argument)
	    this_CString_expanded = NIL_String;
	  else
	    this_CString_expanded = this_expandedArgument->get_CString ();
	  return pk_true;
	}
      if (lCorrect)
	{
	  this_expandedArgument = NIL_Argument;
	  this_CString_expanded = NIL_String;
	  fatal_missingIdentifier ("string", this_CString_varName);
	}
    }
  return pk_false;
}

/* ========== Grapher
 */

/* ========== Builder
 */

/* 2004-10-14
 * creates a new :stringval function call 
 * this <readingContext> current character is a not space character following the function name
 *                       or this <readingContext> current line contains the function name
                             not followed by not space and is completed
 * success: current character is a parameter list opening mark followed by actual parameters
                     followed by a parameter list closing mark
 *          this <readingContext> cursor is set after function call closing mark
 *          <correct> remains unchanged
 * failure: set <correct> to false
 *          error message is printed
 */
_PUBLIC_ StringValFunctionCall::StringValFunctionCall (ref2Context readingContext, ref2Argument actualParameter, boolean * correct):StringFunctionCall (readingContext, stringvalWORD,
		    actualParameter)
{
  //  readingContext->log_ASDEBUG("StringValFunctionCall::StringValFunctionCall simple");
  if (!(set_stringIdentifierArg (actualParameter, &this_CString_varName)))	/*(fatal)error message is printed, fatal is set */
    (*correct) = pk_false;
}

/* 2004-10-14
 * creates a new iterated :stringval function call 
 * this <readingContext> current character is a not space character following the function name
 *                       or this <readingContext> current line contains the function name
                             not followed by not space and is completed
 * success: current character is a parameter list opening mark followed by actual parameters
                     followed by a parameter list closing mark
 *          this <readingContext> cursor is set after function call closing mark
 *          <correct> remains unchanged
 * failure: set <correct> to false
 *          error message is printed
 */
/* PLG TODO ADD bollean * correct as parameter
 */
_PUBLIC_ StringValFunctionCall::StringValFunctionCall (ref2IteratorContext readingContext, ref2Argument actualParameter, boolean * correct):StringFunctionCall (readingContext, stringvalWORD,
		    actualParameter)
{
  //  ((ref2Context)readingContext)->log_ASDEBUG("StringValFunctionCall::StringValFunctionCall iterated");
  if (!set_stringIdentifierArg (actualParameter, &this_CString_varName))	/*(fatal)error message is printed, fatal is set */
    (*correct) = pk_false;
}
