_PUBLIC_ _VIRTUAL_ const char *
UserListFunctionCall::myClassName ()
{
  return "UserListFunctionCall";
}

/* ========== Attributes
 */

_PUBLIC_ ref2UserListFunctionElement UserListFunctionCall::get_linkedFunction ()
{
  return this_linkedFunction;
}

_PUBLIC_ _VIRTUAL_ boolean UserListFunctionCall::is_isomorphic (ref2ArgumentFunctionCall arg_funcCall)
{
  if ((ref2ArgumentFunctionCall) this == arg_funcCall)
    return pk_true;
  if (arg_funcCall != NIL_ArgumentFunctionCall)
    {
      return arg_funcCall->is_isomorphic (this);
    }
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean UserListFunctionCall::is_isomorphic (ref2UserListFunctionCall arg_funcCall)
{
  if (this == arg_funcCall)
    return pk_true;
  if (arg_funcCall == NIL_UserListFunctionCall)
    return pk_false;
  if (this_linkedFunction == arg_funcCall->get_linkedFunction ())
    return have_isomorphicParameters (arg_funcCall->get_actualParameters ());
  return pk_false;
}

/* ========== Writer
 */

/* ========== Set
 */

/* ========== Printer
 */

/* ========== Reader
 */

/* ========== Generator
 */

/* ========== Grapher
 */

/* ========== Builder
 */

/* PLG 2005-10-13
 * should be protected
 * this is supposed to be SAFE (not checked)
 * this_linkedFunction is not NIL
 * actual argument list and formal argument list fit
 * success: these_actualParameters are correctly expanded
 *          function call is correctly processed
 *          the result of this_linkedFunction call is assigned to this_expandedArgument
 * failure: these_actualParameters expansion failed or function call failed
 *          error message is printed
 */
_VIRTUAL_ boolean
UserListFunctionCall::single_call ()
{
  // logDEBUG_in("ENTER single_call call to", this_functionName);
  // logDEBUG_actualParameters();
  ref2ArgumentList argumentList;
  if (this_linkedFunction->list_call (these_actualParameters, &argumentList))
    {
      this_expandedArgument = argumentList;
      return pk_true;
    }
  return pk_false;
}

/* 2004-11-23
 * creates a call to a user defined list function 
 */
UserListFunctionCall::UserListFunctionCall (ref2Context readingContext, char *name, ref2UserListFunctionElement aFunction, ref2ArgumentList actualParameters, boolean * correct):ListFunctionCall (readingContext, name,
		  actualParameters)
{
  // logDEBUG_in("UserListFunctionCall(ref2Context, char *, ref2UserListFunctionElement, ref2ArgumentList, boolean *) ");
  // logDEBUG_in("UserListFunctionCall INIT IS ListFunctionCall(ref2Context, char *, ref2ArgumentList) ");
  this_linkedFunction = aFunction;
}

/* 2004-10-14
 * creates an iterated call to a user defined string function 
 * this <readingContext> current character is a not space character following the function name
 *                       or this <readingContext> current line contains the function name
 *                       not followed by not space and is completed
 * success: current character is a parameter list opening mark followed by actual parameters
 *             followed by a parameter list closing mark
 *          this <readingContext> cursor is set after function call closing mark
 */
UserListFunctionCall::UserListFunctionCall (ref2IteratorContext readingContext, char *name,
					    ref2UserListFunctionElement aFunction, ref2ArgumentList actualParameters, boolean * correct):
ListFunctionCall (readingContext, name, actualParameters)
{
  // logDEBUG_in("UserListFunctionCall(ref2IteratorContext, char *, ref2UserListFunctionElement, ref2ArgumentList, boolean *) ");
  // logDEBUG_in("UserListFunctionCall INIT IS ListFunctionCall(ref2IteratorContext, char *, ref2ArgumentList) ");
  this_linkedFunction = aFunction;
}
