#define IS_EMPTY() ( this_genericArgument == NIL_Argument )
#define IS_STATIC() ( IS_EMPTY() || (this_genericArgument->is_static()) )

_PUBLIC_ _VIRTUAL_ const char *
UserListFunctionElement::myClassName ()
{
  return "UserListFunctionElement";
}

/* ========== Attributes
 */

_PUBLIC_ _VIRTUAL_ boolean UserListFunctionElement::isUserListFunctionElement ()
{
  return pk_true;
}

/* ========== Writer
 */

/* prints object standard header: "{ <NAME>" or "{ <TYPE> <NAME>"
 */
_VIRTUAL_ void
UserListFunctionElement::print_type_sp (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  printingContext->out_listType_sp (outBuffer);
}

_VIRTUAL_ void
UserListFunctionElement::print_declBody (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  outBuffer->line ();
  if (IS_EMPTY ())
    outBuffer->print ("## Empty list ##");
  else
    this_genericArgument->Cprint_formula (printingContext, outBuffer, pk_false);
}

/* ========== Log
 */

/* detailss in <outBuffer> file this context and local declarations
 * <outBuffer> is not NIL_IntePrinter
 */
_VIRTUAL_ void
UserListFunctionElement::logDebug_declBody (int level)
{
  if (IS_EMPTY ())
    log_NILComponent_ln (level, "list generator");
  else
    {
      log_subTitle_ln (level, "this list generator is");
      this_genericArgument->logExtendedDebug_formula_ln (level + 1);
    }
}

/* ========== Set
 */

/* ========== Printer
 */

/* ========== Reader
 */

/* 2004-11-24
 * reads body of a function declaration
 * success: cursor starts .[list_ARGUMENT] [fileSpace*]#'}:'
 *          cursor is moved to '}'
 * failure: an error occurred
 *          cursor is moved to errored position
 *          error message is printed
 */
_VIRTUAL_ boolean
UserListFunctionElement::read_declBody_fSpStar_nSp ()
{
  // logDEBUG_in("read_declBody_fSpStar_nSp");
  return this_innerContext->read_list_fSpStar_nSp (&this_genericArgument);
}

/* ========== Generator
 */

/* expands actual parameter values, assign them to formal parameters and call this function
 * success: returns in <res> a new allocated ArgumentList
 * failure: arguments do not fit or some expansion failed
 *          error message is printed
 */
boolean
UserListFunctionElement::list_call (ref2ArgumentList parameterValues, ref2ArgumentList * argumentList_res)
{
  // logDEBUG_in("list_call call to", this_name);
  if (IS_STATIC ())
    {
      (*argumentList_res) = (ref2ArgumentList) this_genericArgument;
      return pk_true;
    }
  if ((parameterValues == NIL_ArgumentList) || parameterListLink_expand_ (parameterValues))
    {
      return this_genericArgument->getIf_listExpand_ (argumentList_res);
    }
  return pk_false;
}

/* ========== Builder
 */
/* 2005-02-01 syntax
 * creates and returns a new list function descriptor named <name>
 * <embeddingContext> is not NIL
 * <embeddingContext> is the context in which this declaration occurs
 * <comments> are comments associated with this declaration
 * <innerContext> is the new internal context
 * success: cursor starts .[list_ARGUMENT_fSp+*]#'}:'
 *          [list_ARGUMENT] is read in <innerContext>
 *          <correct> remains unchanged
 *          cursor is moved to  '}:'
 * failure: an error occurs
 *          error message is printed
 *          <correct> is set to false
 */
UserListFunctionElement::UserListFunctionElement (ref2Context embeddingContext, char *name, ref2DynamicContext innerContext, ref2ArgumentList comments):ArgumentFunctionElement (embeddingContext, name, innerContext,
			 comments)
{
}
