#define IS_EMPTY() ( this_genericArgument == NIL_Argument )
#define IS_STATIC() ( IS_EMPTY() || (this_genericArgument->is_static()) )

_PUBLIC_ _VIRTUAL_ const char *
UserStringFunctionElement::myClassName ()
{
  return "UserStringFunctionElement";
}

/* ========== Attributes
 */

_PUBLIC_ _VIRTUAL_ boolean UserStringFunctionElement::isUserStringFunctionElement ()
{
  return pk_true;
}

/* ========== Writer
 */

/* prints object standard header: "{ <NAME>" or "{ <TYPE> <NAME>"
 */
_PUBLIC_ _VIRTUAL_ void
UserStringFunctionElement::print_type_sp (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  printingContext->out_stringType_sp (outBuffer);
}

_PUBLIC_ _VIRTUAL_ void
UserStringFunctionElement::print_declBody (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  outBuffer->line ();
  if (IS_EMPTY ())
    outBuffer->print ("## ERRORED ##");
  else
    this_genericArgument->Cprint_formula (printingContext, outBuffer, pk_false);
}

/* ========== Log
 */

/* detailss in <outBuffer> file this context and local declarations
 * <outBuffer> is not NIL_IntePrinter
 */
_PUBLIC_ _VIRTUAL_ void
UserStringFunctionElement::logDebug_declBody (int level)
{
  if (IS_EMPTY ())
    log_spn_str_ln (level, "this argument is not defined");
  else
    {
      log_subTitle_ln (level, "this argument is");
      this_genericArgument->logExtendedDebug_formula_ln (level + 1);
    }
}

/* ========== Set
 */

/* ========== Printer
 */

/* ========== Reader
 */

/* 2004-11-24
 * reads body of a function declaration
 * success: cursor starts .[string_ARGUMENT] [fileSpace*]#'}:'
 *          cursor is moved to '}'
 * failure: an error occurred
 *          cursor is moved to errored position
 *          error message is printed
 */
_VIRTUAL_ boolean
UserStringFunctionElement::read_declBody_fSpStar_nSp ()
{
  // this_innerContext->log_ASDEBUG("UserStringFunctionElement::read_declBody_fSpStar_nSp");
  return this_innerContext->read_string_fSpStar_nSp (&this_genericArgument);
}

/* ========== Generator
 */

/* expands actual parameter values, assign them to formal parameters and call this function
 * success: returns in <res> a new allocated Argument
 * failure: arguments do not fit or string generation failed 
 *               error message is printed
 */
boolean
UserStringFunctionElement::CString_call (ref2ArgumentList parameterValues, char **CString_res)
{
  // logDEBUG_in("CString_call name is ", this_name);
  if (IS_EMPTY ())
    {
      (*CString_res) = NIL_String;
      return pk_true;
    }
  if (IS_STATIC ())
    {
      (*CString_res) = this_genericArgument->get_CString ();
      return pk_true;
    }
  if ((parameterValues == NIL_ArgumentList) || parameterListLink_expand_ (parameterValues))
    {
      return this_genericArgument->getIf_CString_cast_expand_ (CString_res);
    }
  return pk_false;
}

/* ========== Builder
 */
/* 2005-02-01
 * creates and returns a new string function descriptor named <name>
 * <embeddingContext> is not NIL
 * <embeddingContext> is the context in which this declaration occurs
 * <comments> are comments associated with this declaration
 * <innerContext> is the new internal context
 * success: cursor starts .[string_ARGUMENT] [fileSpace*] #'}:'
 *          [string_ARGUMENT] is read in <innerContext>
 *          <correct> remains unchanged
 *          cursor is moved to '}:'
 * failure: an error occurs
 *          error message is printed
 *          <correct> is set to false
 */
UserStringFunctionElement::UserStringFunctionElement (ref2Context embeddingContext, char *name, ref2DynamicContext innerContext, ref2ArgumentList comments):ArgumentFunctionElement (embeddingContext, name, innerContext,
			 comments)
{
  // fprintf(stderr, "DEBUG new UserStringFunctionElement, innerContext parameter is %i, this_innerContext is %i,\n", (int)innerContext, (int)this_innerContext );
}
