#define SET_ALLFILEPRESENT() allFiles_arePresent = 1
#define SET_SOMEFILEMISSING() allFiles_arePresent = 0
#define SET_MAYSOMEFILEMISSING() allFiles_arePresent = -1

#define ARE_ALLFILEPRESENT() ( allFiles_arePresent == 1 )
#define IS_SOMEFILEMISSING() ( allFiles_arePresent == 0 )
#define MAY_SOMEFILEMISSING() ( allFiles_arePresent == -1 )

#define SET_EXECUTED() this_buildingRequired = pk_false; SET_PROCESSED()
#define IS_TOBEBUILT() this_buildingRequired
#define IS_TOBEEXECUTED() IS_TOBEBUILT()

#define SET_PROCESSED_FOR(fileNode) SET_PROCESSED(); made = fileNode
#define IS_PROCESSED_FOR(fileNode) ( (IS_PROCESSED()) && (made == fileNode) )

#define HAS_IMPLICITTAG() ( (this_buildingData != NIL_BuildingData) && (this_buildingData->is_defaultActivated()) )
#define HAS_DEFAULTACTION() ( this_buildingData->has_defaultAction() )
#define DO_INNER_(_ACTIVEDEP_) ( this_buildingData->do_innerConstructive(this_declarationContext, _ACTIVEDEP_) )
#define GENERATE_DEFAULT(fileToPrint) ( this_buildingData->generateDefault(fileToPrint) )
#define GENERATE_MAIN(curBuiltFile, fileToPrint) ( this_buildingData->generate(curBuiltFile, fileToPrint) )
#define EXECUTE_DEFAULT() ( this_buildingData->executeDefault() )
#define EXECUTE_MAIN(curExecutedNode) ( this_buildingData->execute(curExecutedNode) )


_PUBLIC_ _VIRTUAL_ const char *
VariableNode::myClassName ()
{
  return "VariableNode";
}

/* ==========  ==========  global actions
 */

/* ==========  ==========  Attributes
 */
/* set this to be built
 */
_PUBLIC_ void
VariableNode::set_buildable ()
{
  this_isBuildable = pk_true;
}

/* set this to be executed
 */
_PUBLIC_ void
VariableNode::set_executable ()
{
  this_isBuildable = pk_true;
  this_isExecutable = pk_true;
}

/* ==========  ==========  Writer
 */
_PRIVATE_ _VIRTUAL_ void
VariableNode::print_attributes_ln (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  printingContext->out_varAttributes_ln (outBuffer, this_isExecutable, this_isBuildable, HAS_IMPLICITTAG ());
}

/* ==========  ========== Reader
 */

/* 2005-01-21
 * success: FILE = PREFIX. opt{[execTag_fSpStar]}[_NODE_BODY_fSpStar]#'}' [Any*][eof]
 * failure: cursor is moved to errored character
 *          sets this node errored
 *          error message is printed
 */
_PUBLIC_ boolean VariableNode::read_dataDecl_fSpStar_nSp (ref2ArgumentList comments, boolean isBuildable, boolean isExecutable, boolean isCond)
{
  // fprintf(stderr, "DEBUG VariableNode::read_dataDecl_fSpStar_nSp\n");
  this_isBuildable = isBuildable;
  this_isExecutable = isExecutable;
  return NodeElement::read_dataDecl_fSpStar_nSp (comments, isCond, "declared variable");
}

/* ==========  ==========  Grapher
 */
/* ========== Actions for not NIL building data */

/* ========== Actions for not empty ancestor set */

/* PLG 2006-01-18
 * should be private 
 * this is supposed to be safe, not locked
 * this is defined (=>this_buildingData is not NIL 
 * this ancestor list is not empty
 * this has not been previously registered
 * <comingFrom> is the most inner node preceded by this
 * success: this_date, <updatedDate> are assigned the youngest updated date of its ancestors
 *          this is set to be built
 *          this is registered
 * failure: some of these ancestors is in error 
 *              <cycleRoot> remains unchanged
 *          this participates to a cycle
 *              <cycleRoot> is set to this cycle root
 *          set this in error
 *          this_date remains unchanged
 * this_stepIndex is set to the_stepIndex
 */
_PRIVATE_ boolean VariableNode::_visitMess_executable_ancestor_toBeBuilt (ref2NodeElement comingFrom, ref2NodeElement * cycleRoot)
{
  // fprintf(stderr, "DEBUG VariableNode::_visitMess_executable_ancestor_toBeBuilt, name is %s\n", this_name);
  time_t
    updatedDate;
  levelInfo_comment_ref_date_ln ();
  if (IS_UPDATED ())
    {
      set_toBeBuilt ();
      register_constructiveNode ();
      return pk_true;
    }
  if (_visit_standard_toBeBuilt (this, comingFrom, &updatedDate, cycleRoot))
    {
      SET_DATE (updatedDate);
      register_constructiveNode ();
      return pk_true;
    }
  return pk_false;
}

/* ========== Actions when ancestor set may be empty */

/* PLG 2008-06-13
 * this is supposed to be safe, unlocked
 *         this_isDefined is pk_true (=> this building data is not NIL)
 * success: these ancestors are safe, 
 *          1-IS_SOMEFILEMISSING
 *          2-MAY_SOMEFILEMISSING and this has some missing ancestor file or some variable that has_missingAncestorFile()
 *              IS_SOMEFILEMISSING becomes pk_true
 * failure: 1-these ancestors are safe, 
 *              1-1-ARE_ALLFILEPRESENT
 *              1-2-MAY_SOMEFILEMISSING and all ancestor files are present, and none of variable ancestors has_missingAncestorFile()
 *                    ARE_ALLFILEPRESENT becomesd pk_true
 *          some of these ancestors is in error, this is cycle free
 *               <cycleRoot> remains unchanged
 *               this is set in error 
 *          this participates to a cycle
 *               <cycleRoot> is set to the root of this cycle
 *               this is set in error 
 * this_stepIndex remains unchanged
 * tbis is locked remains unchanged
 */
_PRIVATE_ boolean VariableNode::_has_missingAncestorFile (ref2NodeElement comingFrom, boolean * correct, ref2NodeElement * cycleRoot)
{
  if (IS_SOMEFILEMISSING ())
    {
      levelInfo_comment_ref_sp__ln ("refers to some  missing file");
      return pk_true;
    }
  if (ARE_ALLFILEPRESENT ())
    {
      levelInfo_comment_ref_sp__ln ("all referred to files are present");
      return pk_false;
    }
  /* this is defined (=>this_buildingData is not NIL */
  if (_innerExplorationToDo_ln (cycleRoot))
    {
      boolean
	lCorrect = pk_true;
      if (_visit_missingAncestorFile (comingFrom, &lCorrect, cycleRoot))
	{
	  levelInfo_comment_ref_sp__ln ("refers to some  missing file");
	  SET_SOMEFILEMISSING ();
	  return pk_true;
	}
      if (lCorrect)
	{
	  levelInfo_comment_ref_sp__ln ("all referred to files are present");
	  SET_ALLFILEPRESENT ();
	  return pk_false;
	}
      (*correct) = pk_false;
      return pk_false;
    }
  if (IS_SAFE ())
    {
      /* this is ancestor free */
      levelInfo_comment_ref_sp__ln ("is ancestor free");
      SET_ALLFILEPRESENT ();
      return pk_false;
    }
  (*correct) = pk_false;
  return pk_false;
}

/* PLG 2005-12-29
 * this is supposed to be safe, executable, this may be locked
 * this_isDefined is pk_true (=>this_buildingData not NIL ) 
 * this has not been previously registered
 * <contextTime> is the time of the most inner file which building can be decided when looking at this
 * <comingFrom> is the node immediately preceded by this
 * set this creator as this
 * success: all (ancestor) referred to nodes are properly defined 
 *          this has some missing file ancestor, or some dependence date inversion 
 *                     wrt to creation date and dependence modalities
 *              this_date, <updatedDate> are assigned FUTURE
 *              this is set to be built
 *              this is registered
 *          all file ancestors are present, all files are upto date 
 *                     wrt to creation date and dependence modalities
 *              this_date, <updatedDate> are assigned the youngest updated date of its ancestors
 *          <cycleRoot> remains unchanged
 *          this constructor is assigned this
 * failure: this completes a cycle
 *             error message is printed
 *             if cycle has more than one node
 *                <cycleRoot> is set to cycle root
 *             if cycle has only one node
 *                <cycleRoot> remains unchanged
 *             this is set in error
 *          some (ancestor) referred to node is not properly defined 
 *               <cycleRoot> remains unchanged
 *          this_date remains unchanged
 *          this is set in error 
 * this_stepIndex is set to the_stepIndex
 */
_PRIVATE_
  boolean VariableNode::_visitMessIf_executable_ (time_t contextTime, ref2NodeElement comingFrom,
						  time_t * updatedDate, boolean * isToBeBuilt, ref2NodeElement * cycleRoot)
{
  /* this is not in error, does not belong to a cycle and is defined with not empty building data */
  levelInfo_comment_ref_date_ln ();
  (*updatedDate) = GET_DATE ();
  if (_innerExplorationToDo_ln (cycleRoot))
    {
      if (reset_ancestor_constructive (GET_FUTURE (), isToBeBuilt))
	return pk_true;
      /* this_stepIndex is smaller than the_stepIndex */
      if (_visit_standardUpdate (this, contextTime, comingFrom, updatedDate, isToBeBuilt, cycleRoot))
	{
	  SET_DATE (*updatedDate);
	  if (*isToBeBuilt)
	    register_constructiveNode ();
	  return pk_true;
	}
      return pk_false;
    }
  if (IS_SAFE ())
    {
      if (reset_ancestorFree_constructive (GET_FUTURE (), isToBeBuilt))
	return pk_true;
      /* this_stepIndex is smaller than the_stepIndex */
      set_actualCreator (this);
      return pk_true;
    }
  return pk_false;
}

/* PLG 2006-01-09
 * <comingFrom> is a node that (transitively) depends on this
 * <creator> is a constructive node (executable variable or direct file) that constructively depends on this
                 constructively means without never building occurrence
 * this_isDefined is pk_true (=>this_buildingData not NIL )
 * this has not been previously registered
 * success: this is not in a cyclic dependence, all referred to nodes are properly defined 
 *                <cycleRoot> remains unchanged
 *                this is registered
 * failure: some referred to node is not properly defined or some missing file does not have definition
 *          a cyclic dependence including this is found, this is not the cycle root
 *                sets <cycleRoot> to cycle root
 *          no cyclic dependence includes this, or this is the cycle root
 *                <cycleRoot> remains unchanged
 * this_stepIndex is set to the_stepIndex
 */
_PRIVATE_ boolean VariableNode::_visitMessIf_executable_toBeBuilt (ref2NodeElement comingFrom, ref2NodeElement * cycleRoot)
{
  // fprintf(stderr, "DEBUG VariableNode::_visitMessIf_executable_toBeBuilt, name is %s\n", this_name);
  /* this is defined (=>this_buildingData is not NIL */
  if (_innerExplorationToDo_ln (cycleRoot))
    {
      return _visitMess_executable_ancestor_toBeBuilt (comingFrom, cycleRoot);
    }
  if (IS_SAFE ())
    {
      /* this is ancestor free */
      levelInfo_comment_ref_date_ln ();
      set_toBeBuilt ();
      register_constructiveNode ();
      return pk_true;
    }
  return pk_false;
}

/* PLG 2006-01-06
 * this is supposed to be safe, defined
 * this is defined (=> this Building data is not NIL) 
 * this may have been previoudly visited
 * <creator> is the most inner constructive node that precedes this, <creator> is not NIL
 * <comingFrom> is the most inner node preceded by this
 * success: this is set as visited
 *          this variable has some missing file ancestor
 *              this_date, <updatedDate> are assigned FUTURE
 *          all file ancestor are present
 *              this_date, <updatedDate> are assigned the youngest updated date of its ancestors
 *          this is set to be built
 * failure: some of these ancestors is in error 
 *              <cycleRoot> remains unchanged
 *          this participates to a cycle
 *              <cycleRoot> is set to this cycle root
 *          set this in error
 * this_date remains unchanged
 * this_stepIndex is set to the_stepIndex
 */
_PRIVATE_
  boolean VariableNode::_visitIf_executable_recursiveEverUpdate (ref2NodeElement comingFrom, time_t * updatedDate, ref2NodeElement * cycleRoot)
{
  boolean
    hasYoungerAncestor = pk_false;
  if (_visitIf_recursiveEverUpdate (this, comingFrom, updatedDate, &hasYoungerAncestor, cycleRoot))
    {
      if (hasYoungerAncestor)
	SET_DATE (*updatedDate);
      if (!IS_REGISTERED ())
	register_constructiveNode ();
      return pk_true;
    }
  if (IS_SAFE ())
    {
      if (!IS_REGISTERED ())
	{
	  set_toBeBuilt ();
	  register_constructiveNode ();
	}
      return pk_true;
    }
  return pk_false;
}

/* ========== Entry points, this may not be defined 
*/

/* PLG 2006-01-18
 * this node analysis is required by a passive presence inquiring dependence
 * this searches for missing file ignoring dpendence and node modality
 * <comingFrom> is the most inner node preceded by this
 * success: this is safe, not in a cyclic dependence, all referred to nodes are properly defined 
 *             some file ancestor is missing or some variable ancestor has_missingAncestorFile()
 *          this node, <correct>, <cycleRoot> remain unchanged
 * failure: this is safe, defined, not in a cyclic dependence, all referred to nodes are properly defined 
 *          and all file ancestors are present in host
 *             this node, <correct>, <cycleRoot> remain unchanged
 *          some referred to node is not properly defined or some missing file does not have definition
 *             a cyclic dependence including this is found, this is not the cycle root
 *                sets <cycleRoot> to cycle root
 *             no cyclic dependence includes this, or this is the cycle root
 *                <cycleRoot> remains unchanged
 *          <correct> is set to false
 */
_PUBLIC_ _VIRTUAL_ boolean VariableNode::has_missingAncestorFile (ref2NodeElement comingFrom, boolean * correct, ref2NodeElement * cycleRoot)
{
  // fprintf(stderr, "DEBUG VariableNode::has_missingAncestorFile, name is %s\n", this_name);
  if (IS_SAFE ())
    {
      if (this_isDefined)
	{
	  return _has_missingAncestorFile (comingFrom, correct, cycleRoot);
	}
      error_missingIdentifier ("variable", get_name ());
    }
  else
    levelInfo_comment_ancestor_unsafe_ln ();
  (*correct) = pk_false;
  return pk_false;
}


/* PLG 2006-01-18
 * this node analysis is required by a presence inquiring dependence following an active link
 * <creator> is the most inner constructive node that precedes this, <creator> is not NIL
 * <comingFrom> is the most inner node preceded by this
 * this_stepIndex is set to the_stepIndex
 * success: this is safe, not in a cyclic dependence, all referred to nodes are properly defined 
 *          1- all ancestor files are present and none of the ancestor variables has_missingAncestorFile()
 *             <isMissing>, <cycleRoot> remain unchanged
 *          2- some ancestor file is missing or some ancestor variable has_missingAncestorFile()
 *             <isMissing> is set to pk_true
 *             this is buildable
 *                this date is set to FUTURE
 *                this is set to be built 
 *                this is executable: this is registered as a building root
 *             this is not buildable never definition modality)
 *                this date remains unchanged
 *          all ancestor files are present
 *             <isMissing> remains unchanged
 * failure: this is not safe or some referred to node is not properly defined or some missing file does not have definition
 *          a cyclic dependence including this is found, this is not the cycle root
 *                sets <cycleRoot> to cycle root
 *          no cyclic dependence includes this, or this is the cycle root
 *                <cycleRoot> remains unchanged
 *          <isMissing> may be set to pk_true
 */
_PUBLIC_
  _VIRTUAL_ boolean VariableNode::set_missingUpdate (ref2NodeElement creator, ref2NodeElement comingFrom,
						     boolean * isMissing, ref2NodeElement * cycleRoot)
{
  // fprintf(stderr, "DEBUG VariableNode::set_missingUpdate, name is %s\n", this_name);
  if (IS_SAFE ())
    {
      if (this_isDefined)
	{
	  boolean
	    lCorrect = pk_true;
	  if (_has_missingAncestorFile (comingFrom, &lCorrect, cycleRoot))
	    {
	      /* this has ancestors, this is not locked */
	      (*isMissing) = pk_true;
	      if (this_isExecutable)
		{
		  if (IS_REGISTERED ())
		    {
		      levelInfo_comment_ref_date_ln ();
		      return pk_true;
		    }
		  return _visitMess_executable_ancestor_toBeBuilt (comingFrom, cycleRoot);
		}
	      if (this_isBuildable)
		{
		  time_t
		    updatedDate;
		  levelInfo_comment_ref_date_ln ();
		  if (reset_toBeBuilt (creator))
		    return pk_true;
		  if (_visit_standard_toBeBuilt (creator, comingFrom, &updatedDate, cycleRoot))
		    {
		      SET_DATE (updatedDate);
		      return pk_true;
		    }
		  return pk_false;
		}
	      levelInfo_comment_ref_date_ln ();
	      return pk_true;
	    }
	  return lCorrect;
	}
      error_missingIdentifier ("variable", get_name ());
    }
  else
    levelInfo_comment_ancestor_unsafe_ln ();
  return pk_false;
}

/* PLG 2006-01-09
 * assumes this_buildingData not NIL when this is defined and safe
 * <context_time> is the time of the file which building can be decided when looking at this
 * <comingFrom> is the node immediately preceded by this
 * success: this is safe, defined, not in a cyclic dependence, all referred to nodes are properly defined 
 *          1 this_stepIndex is not smaller than the_stepIndex
 *             this_date is assigned to <updatedDate>
 *          2 this_stepIndex is smaller than the_stepIndex, this updated date is computed wrt dependence modality
 *             2-0 a reference YY to an ancestor XX can be 
 *                 never or standard modality: XX is updated with intrinsic modality
 *                     XX updated date is set
 *                     YY updated date is XX updated date
 *                 ever or recursive ever modality: XX is updated with intrinsic modality
 *                     XX updated date is set
 *                     YY dependence updated date is FUTURE
 *                 missing modality: XX is not updated
 *                     XX updated date is not set
 *                     XX is a missing file or a variable referring to some missing file
 *                        YY dependence updated date is FUTURE
 *                     other
 *                        YY dependence updated date is OLDEST
 *             this_date, <updatedDate> are assigned the youngest YY updated date
 *             some YY updated date is FUTURE
 *                 this is set to be built
 *          <cycleRoot> remains unchanged
 * failure: this is absent in host, this is not defined or
 *          some referred to node is not properly defined or some missing file does not have definition
 *          a cyclic dependence including this is found, this is not the cycle root
 *                sets <cycleRoot> to cycle root
 *          no cyclic dependence includes this, or this is the cycle root
 *                <cycleRoot> remains unchanged
 *          set this in error
 *          this_date remains unchanged
 *          <updatedDate> remains unchanged
 */
_PUBLIC_
  _VIRTUAL_ boolean VariableNode::set_intrinsicUpdate (time_t contextTime, ref2NodeElement comingFrom,
						       time_t * updatedDate, ref2NodeElement * cycleRoot)
{
  // fprintf(stderr, "DEBUG VariableNode::set_intrinsicUpdate, name is %s\n", this_name);
  if (IS_SAFE ())
    {
      if (this_isDefined)
	{
	  levelInfo_comment_ref_date_ln ();
	  (*updatedDate) = GET_DATE ();
	  if (_innerExplorationToDo_ln (cycleRoot))
	    {
	      if (IS_UPDATED ())
		{
		  (*updatedDate) = GET_DATE ();
		  return pk_true;
		}
	      if (_visit_intrinsicUpdate (contextTime, comingFrom, updatedDate, cycleRoot))
		{
		  SET_DATE (*updatedDate);
		  if (this_isBuildable)
		    {
		      if (IS_FUTURE ())
			set_toBeBuilt ();
		    }
		  return pk_true;
		}
	      return pk_false;
	    }
	  return set_nullCreator (updatedDate);
	}
      error_missingIdentifier ("variable", get_name ());
    }
  else
    levelInfo_comment_ancestor_unsafe_ln ();
  return pk_false;
}

/* PLG 2006-01-09
 * this variable node dependence analysis is applied for a standard dependence
 * Preparation to generation step:
 *          <creator> is the most inner constructive node
 *               which some dependence recursively refers to this, <creator> is not NIL
 * Time dependence analysis:
 *          <context_time> is the time of the most inner file that (recursively) depends on this variable
 * Cycle detection: 
 *          <comingFrom> is the node which some dependence immediately refers to this
 * success: this is safe, defined and
 *          1-this has an empty ancestor list
 *          2-this has a not empty ancestor list, this does not complete a cyclic dependence, 
 *          3-this has some missing file ancestor, or some dependence date inversion 
 *                   wrt to creation date and dependence modalities
 *              this is executable
 *                 this_date, <updatedDate> are assigned FUTURE
 *                 this is set to be built
 *                 this is registered
 *              this is buildable
 *                 this_date, <updatedDate> are assigned FUTURE
 *                 this is set to be built, this constructor is set to <creator>
 *              this is not buildable
 *          all file ancestors are present, all files are upto date wrt to creation date and dependence modalities
 *              this_date, <updatedDate> are assigned the youngest updated date of its ancestors
 *          <cycleRoot> remains unchanged
 *          this_stepIndex is set to the_stepIndex
 *          this constructor is assigned <creator>
 * failure: some referred to node is not properly defined or some missing file does not have definition
 *          a cyclic dependence including this is completed, this is not the cycle root
 *                <cycleRoot> is set to this cycle root
 *          no cyclic dependence includes this, or this is the cycle root
 *                <cycleRoot> remains unchanged
 */
_PUBLIC_
  _VIRTUAL_ boolean VariableNode::set_standardUpdate (ref2NodeElement creator, time_t contextTime, ref2NodeElement comingFrom,
						      time_t * updatedDate, boolean * isToBeBuilt, ref2NodeElement * cycleRoot)
{
  // fprintf(stderr, "DEBUG VariableNode::set_standardUpdate, name is %s\n", this_name);
  if (IS_SAFE ())
    {
      if (this_isDefined)
	{
	  if (this_isExecutable)
	    {
	      (*updatedDate) = GET_DATE ();
	      if (IS_REGISTERED ())
		{
		  levelInfo_comment_ref_date_ln ();
		  (*isToBeBuilt) = pk_true;
		  return pk_true;
		}
	      return _visitMessIf_executable_ (contextTime, comingFrom, updatedDate, isToBeBuilt, cycleRoot);
	    }
	  levelInfo_comment_ref_date_ln ();
	  if (this_isBuildable)
	    {
	      (*updatedDate) = GET_DATE ();
	      if (_innerExplorationToDo_ln (cycleRoot))
		{
		  if (reset_buildable (creator, updatedDate, isToBeBuilt))
		    return pk_true;
		  if (_visit_standardUpdate (creator, contextTime, comingFrom, updatedDate, isToBeBuilt, cycleRoot))
		    {
		      SET_DATE (*updatedDate);
		      return pk_true;
		    }
		  return pk_false;
		}
	      if (IS_SAFE ())
		{
		  if (reset_buildable (creator, updatedDate, isToBeBuilt))
		    return pk_true;
		  set_actualCreator (creator);
		  return pk_true;
		}
	      return pk_false;
	    }
	  (*updatedDate) = GET_DATE ();
	  if (_innerExplorationToDo_ln (cycleRoot))
	    {
	      if (IS_UPDATED ())
		return pk_true;
	      if (_visit_intrinsicUpdate (contextTime, comingFrom, updatedDate, cycleRoot))
		{
		  SET_DATE (*updatedDate);
		  return pk_true;
		}
	    }
	  return IS_SAFE ();
	}
      error_missingIdentifier ("variable", get_name ());
    }
  else
    levelInfo_comment_ancestor_unsafe_ln ();
  return pk_false;
}

/* PLG 2006-01-09
 * <creator> is a constructive node (executable variable or direct file) that constructively depends on this
 *                 constructively means without never building occurrence
 *            <creator> is not NIL
 * <comingFrom> is a node that (transitively) depends on this
 * assumes this_buildingData not NIL when this is defined and safe
 * sets this updated
 * success: this is not in a cyclic dependence, all referred to nodes are properly defined 
 *                <cycleRoot> remains unchanged
 * failure: some referred to node is not properly defined or some missing file does not have definition
 *          a cyclic dependence including this is found, this is not the cycle root
 *                sets <cycleRoot> to cycle root
 *          no cyclic dependence includes this, or this is the cycle root
 *                <cycleRoot> remains unchanged
 */
_PUBLIC_ _VIRTUAL_ boolean VariableNode::set_everUpdate (ref2NodeElement creator, ref2NodeElement comingFrom, ref2NodeElement * cycleRoot)
{
  // fprintf(stderr, "DEBUG VariableNode::set_everUpdate, name is %s\n", this_name);
  if (IS_SAFE ())
    {
      if (this_isDefined)
	{
	  if (this_isExecutable)
	    {
	      if (IS_REGISTERED ())
		{
		  levelInfo_comment_ref_date_ln ();
		  return pk_true;
		}
	      return _visitMessIf_executable_toBeBuilt (comingFrom, cycleRoot);
	    }
	  if (this_isBuildable)
	    {
	      time_t
		updatedDate;
	      levelInfo_comment_ref_date_ln ();
	      /* this is defined (=>this_buildingData is not NIL OK */
	      if (_innerExplorationToDo_ln (cycleRoot))
		{
		  if (reset_toBeBuilt (creator))
		    return pk_true;
		  if (_visit_standard_toBeBuilt (creator, comingFrom, &updatedDate, cycleRoot))
		    {
		      SET_DATE (updatedDate);
		      return pk_true;
		    }
		  return pk_false;
		}
	      if (IS_SAFE ())
		{
		  /* this is ancestor free */
		  set_toBeBuilt (creator);
		  return pk_true;
		}
	      return pk_false;
	    }
	  levelInfo_comment_ref_date_ln ();
	  return pk_true;
	}
      error_missingIdentifier ("variable", get_name ());
    }
  else
    levelInfo_comment_ancestor_unsafe_ln ();
  return pk_false;
}

/* 
 * <comingFrom> is a node that (transitively) depends on this
 * <creator> is a constructive node (executable variable or direct file) that constructively depends on this
 *                constructively means without never building occurrence
 *                <creator> is not NIL
 * <recursive> is pk_true if building is required for this and recursively its ancestors
 * assumes this_buildingData not NIL when this is defined and safe
 * set stated to pk_true
 * success: this is not in a cyclic dependence, all referred to nodes are properly defined 
 *                <cycleRoot> remains unchanged
 * failure: some referred to node is not properly defined or some missing file does not have definition
 *          a cyclic dependence including this is found, this is not the cycle root
 *                sets <cycleRoot> to cycle root
 *          no cyclic dependence includes this, or this is the cycle root
 *                <cycleRoot> remains unchanged
 */
_PUBLIC_
  _VIRTUAL_ boolean VariableNode::set_recursiveEverUpdate (ref2NodeElement creator, ref2NodeElement comingFrom,
							   time_t * updatedDate, boolean * isToBeBuilt, ref2NodeElement * cycleRoot)
{
  // fprintf(stderr, "DEBUG VariableNode::set_recursiveEverUpdate coming from %s, creator is %s\n", comingFrom->get_name(), creator->get_name());
  if (IS_SAFE ())
    {
      if (this_isDefined)
	{
	  levelInfo_comment_ref_date_ln ();
	  if (this_isExecutable)
	    {
	      //      fprintf(stderr, "    ----    DEBUG VariableNode::set_recursiveEverUpdate, %s is executable \n", this_name);
	      return _visitIf_executable_recursiveEverUpdate (comingFrom, updatedDate, cycleRoot);
	    }
	  if (this_isBuildable)
	    {
	      //      fprintf(stderr, "    ----    DEBUG VariableNode::set_recursiveEverUpdate, %s is buildable \n", this_name);
	      boolean
		hasYoungerAncestor = pk_false;
	      if (_visitIf_recursiveEverUpdate (creator, comingFrom, updatedDate, &hasYoungerAncestor, cycleRoot))
		{
		  if (hasYoungerAncestor)
		    SET_DATE (*updatedDate);
		  return pk_true;
		}
	      if (IS_SAFE ())
		{
		  if (!reset_toBeBuilt (creator))
		    set_toBeBuilt (creator);
		  return pk_true;
		}
	      return pk_false;
	    }
	  // fprintf(stderr, "    ----    DEBUG VariableNode::set_recursiveEverUpdate, %s is not buildable \n", this_name);
	  (*updatedDate) = GET_DATE ();
	  if (_innerExplorationToDo_ln (cycleRoot))
	    {
	      if (IS_UPDATED ())
		return pk_true;
	      if (_visit_intrinsicUpdate (GET_FUTURE (), comingFrom, updatedDate, cycleRoot))
		{
		  SET_DATE (*updatedDate);
		  return pk_true;
		}
	    }
	  return IS_SAFE ();
	}
      /* this has been already set and force does not require new checking */
      error_missingIdentifier ("variable", get_name ());
    }
  else
    levelInfo_comment_ancestor_unsafe_ln ();
  return pk_false;
}

/* assumes this_buildingData not NIL when this is defined and safe
 * this is a variable
 *
 * <force>: 0 this node is to be built if this recursively depends of some newer node
 * <force>: 1 this node is to be built whatever are its ancestor ages
 * <force>: 2 this node and recursively its ancestors have be built whatever are its ancestor ages
 *             this recursivity ends on never dependence
 * assumes objects and missing files being either in error or defined 
 * set this stated to pk_true
 * success: no cyclic dependence
 *          complete the well ordered list of files to do
 * failure: if a cyclic dependence is found
 *          set this in error
 */
_PUBLIC_ _VIRTUAL_ boolean VariableNode::set_rootUpdate (ref2MKFFileNode comingFrom, int force)
{
  // fprintf(stderr, "DEBUG VariableNode::set_rootUpdate, name is %s\n", this_name);
  if (IS_SAFE ())
    {
      if (this_isDefined)
	{
	  if (this_isExecutable)
	    {
	      ref2NodeElement
		cycleRoot = NIL_NodeElement;
	      boolean
		isToBeBuilt = pk_false;
	      time_t
		updatedDate;
	      this_isUsed = pk_true;
	      levelInfo_objectCategory_sp ("VARIABLE ROOT");
	      if (force > 1)
		{
		  levelInfo_comment_ref_date_ln ();
		  return _visitIf_executable_recursiveEverUpdate ((ref2NodeElement) comingFrom, &updatedDate, &cycleRoot);
		}
	      if (IS_REGISTERED ())
		{
		  levelInfo_comment_ref_date_ln ();
		  return pk_true;
		}
	      if (force == 1)
		return _visitMessIf_executable_toBeBuilt ((ref2NodeElement) comingFrom, &cycleRoot);
	      return _visitMessIf_executable_ (GET_FUTURE (), (ref2NodeElement) comingFrom, &updatedDate, &isToBeBuilt, &cycleRoot);
	    }
	  error_constructiveVariable (get_name ());
	}
      else
	error_missingIdentifier ("constructive variable", get_name ());
    }
  else
    levelInfo_comment_ancestor_unsafe_ln ();
  return pk_false;
}

/* ========== Generator
 */

/* PLG 2005-08-26
 * assumes this safe, defined and this_buildingData not NIL 
 * this is a safe, executable variable
 * executes its main commands line by line
 */
_PRIVATE_ boolean VariableNode::__execute_main ()
{
  // fprintf(stderr, "DEBUG VariableNode::__execute_main this_name is <%s>\n", this_name);
  SET_EXECUTED ();		/* this_buildingRequired is set to pk_false; this_date is set to NOW */
  verboseAnnounce ("exec variable node");
  if (mainToGenerate ())
    {
      if (EXECUTE_MAIN (this))
	return pk_true;
      error_line_reference ("main execution failed");
      return pk_false;
    }
  return pk_true;
}

/* PLG 2005-08-26
 * assumes this safe, defined and this_buildingData not NIL 
 * this is a safe, executable variable
 * executes its default commands line by line
 */
_PRIVATE_ boolean VariableNode::__execute_default ()
{
  // fprintf(stderr, "DEBUG VariableNode::__execute_default this_name is <%s>\n", this_name);
  if (HAS_DEFAULTACTION ())
    {
      levelInfo_DefaultGeneration  (pk_true, "already done");
      if (EXECUTE_DEFAULT ())
	return pk_true;
      error_line_reference ("default execution failed");
      return pk_false;
    }
  return pk_true;
}

/* PLG 2005-08-26
 * assumes this safe, defined and this_buildingData not NIL 
 * this is a safe, executable variable
 * if this is the first execution attempt in current file generator, executes its main action
 * if this has been executed in the current generator, executes its default actions
 */
_PRIVATE_ boolean VariableNode::__execute ()
{
  // fprintf(stderr, "DEBUG VariableNode::__execute_default this_name is <%s>\n", this_name);
  if (IS_TOBEEXECUTED ())
    return __execute_main ();
  return __execute_default ();
}

/* 2005-08-26
 * assumes this defined and this_buildingData not NIL when this is safe
 * this method is called when this is a never modality ancestor of a constructive node 
 * success: this safe and
 *              this is executable, this execution is required and correctly done
 *              this is executable, this execution is no more required 
 *              this is not executable, this construction is required 
 *                 a warning is printed
 * failure: this is in error
 *          or this execution is required and
 *                this is executable and execution failed
 *                or this is not executable
 */
_PUBLIC_ _VIRTUAL_ boolean VariableNode::nested_requiredConstructive ()
{
  // fprintf(stderr, "DEBUG VariableNode::nested_requiredConstructive this_name is <%s>\n", this_name);
  if (IS_SAFE ())
    {
      if (this_isExecutable)
	{
	  if (IS_TOBEEXECUTED ())	/* this_buildingRequired is pk_true */
	    return __execute_main ();
	  return pk_true;
	}
      if (IS_TOBEBUILT ())
	{			/* this_buildingRequired is pk_true */
	  levelInfo_shouldBeDone ();
	}
      return pk_true;
    }
  else
    OUPS_name ("unsafe variable node", this_name);
  return pk_false;
}

/* 
 * assumes this defined and this_buildingData not NIL when this is safe
 * <curExecutedNode> is the nearest executable object that depends on this
 * executes commands line by line
 * success: this safe and
 *            this is executable
 *              this execution is required and correctly done
 *              this execution is no more required, this default is correctly executed
 *            this is not executable
 *              this construction is required and execution is correctly done
 *              this has yet been executed for <curExecutedNode>, this default is correctly executed
 * failure: this is in error
 *          or this execution is required and
 *                this is executable and execution failed
 *                or this is not executable
 */
_PUBLIC_ _VIRTUAL_ boolean VariableNode::execute (ref2NodeElement curExecutedNode)
{
  // fprintf(stderr, "DEBUG VariableNode::execute this_name is <%s>\n", this_name);
  if (IS_SAFE ())
    {
      if (this_isExecutable)
	return __execute ();
      /* PRE: this_stepIndex is not smaller than the_stepIndex TODO check */
      if (has_creator ())
	{			/* this_creator is not NIL */
	  if ((IS_PROCESSED_FOR (curExecutedNode)))
	    return __execute_default ();
	  SET_PROCESSED_FOR (curExecutedNode);	/* this_date is assigned NOW and made is assigned curExecutedNode */
	  if (mainToGenerate ())
	    {
	      if (EXECUTE_MAIN (curExecutedNode))
		return pk_true;
	      error_line_reference ("main execution failed");
	      return pk_false;
	    }
	  return pk_true;
	}
      else
	return pk_true;
    }
  else
    OUPS_name ("unsafe variable node", this_name);
  return pk_false;
}


/* 
 * assumes this defined and this_buildingData not NIL when this is safe
 * <curBuiltFile> is the nearest direct file that depends on this
 * success: this safe and
 *            this is executable
 *              this execution is required and correctly done
 *              this execution is no more required, this default is correctly executed
 *            this is not executable
 *              this construction is required and construction is correctly done
 *              this has yet been built in <curBuiltFile>, this default is built
 * failure: this is not safe or building failed
 */
_PUBLIC_ _VIRTUAL_ boolean VariableNode::generate (ref2NodeElement curBuiltFile, ref2Buffer fileToPrint)
{
  // fprintf(stderr, "DEBUG VariableNode::generate this_name is <%s>\n", this_name);
  if (IS_SAFE ())
    {
      if (this_isExecutable)
	return __execute ();
      /* PRE: this_stepIndex is not smaller than the_stepIndex TODO check */
      if (has_creator ())
	{			/* this_creator is not NIL */
	  if ((IS_PROCESSED_FOR (curBuiltFile)))
	    {			/* this_date is NOW and made is curBuiltFile */
	      if (HAS_DEFAULTACTION ())
		{
		  levelInfo_DefaultGeneration  (pk_true, "already done");
		  GENERATE_DEFAULT (fileToPrint);
		}
	      return pk_true;
	    }
	  SET_PROCESSED_FOR (curBuiltFile);	/* this_date is assigned NOW and made is assigned curBuiltFile */
	  if (mainToGenerate ())
	    {
	      if (GENERATE_MAIN (curBuiltFile, fileToPrint))
		return pk_true;
	      error_line_reference ("main execution failed");
	      return pk_false;
	    }
	  return pk_true;
	}
      else
	return pk_true;
    }
  else
    OUPS_name ("unsafe variable node", this_name);
  return pk_false;
}

/* 
 * success: this is safe
 *          this is executable
 *               this is executed
 *          this is not executable
 *               these ancestors are processed
 * failure: this is not safe
 *          or this is safe, this has to be built, this does not have constructor
 */
_PUBLIC_ _VIRTUAL_ boolean VariableNode::do_innerConstructive (boolean activeDependence)
{
  // fprintf(stderr, "DEBUG VariableNode::do_innerConstructive this_name is <%s>\n", this_name);
  if (IS_SAFE ())
    {
      if (this_isExecutable)
	{
	  if (IS_TOBEEXECUTED ())
	    return __execute_main ();
	  return pk_true;
	}
      if (IS_TOBEBUILT ())	/* this_buildingRequired is pk_true */
	return DO_INNER_ (activeDependence);
      return pk_true;
    }
  return pk_false;
}

/*
 * assumes this defined and this_buildingData not NIL when this is safe
 * root generation of an executable variable
 *     
 */
_PUBLIC_ _VIRTUAL_ boolean VariableNode::root_generate ()
{
  // fprintf(stderr, "DEBUG VariableNode::root_generate this_name is <%s>\n", this_name);
  if (IS_SAFE ())
    {
      if (this_isExecutable)
	return __execute ();
      OUPS_name ("illegal VariableNode::root_generate, executable expected", this_name);
    }
  else
    OUPS_name ("unsafe variable node", this_name);
  return pk_false;
}

/* ========== Builder
 */

/* ==========  Reference to not defined node
 */

/* PLG 2005-09-07
 * creates and returns a new forward reference to a variable descriptor named <name> 
 * NODE::sets this_isDefined to false
 * NODE::sets initial date as the universal OLDEST date (GENESIA)
 * sets this context as the static context
 */
_PUBLIC_ VariableNode::VariableNode (int hashi, char *name):NodeElement (name)
{
  // fprintf(stderr, "DEBUG VariableNode::VariableNode 2, name is %s\n", name);
  this_isUsed = pk_false;
  this_isBuildable = pk_false;
  SET_MAYSOMEFILEMISSING ();
}

/* ==========  Declaration in readingContext
 */

/* PLG 2005-09-07
 * <readingContext> is not NIL (not checked)
 * creates and returns a new variable declaration descriptor named <name>, this_buildingData is not NIL
 * NODE::sets this declared in <readingContext>
 * NODE::sets initial date as the universal OLDEST date (GENESIA)
 * register this variable
 */
_PUBLIC_ VariableNode::VariableNode (ref2Context readingContext, int hashi, char *name):
NodeElement (readingContext, name)
{
  // fprintf(stderr, "DEBUG VariableNode::VariableNode 1, name is %s\n", name);
  set_defined ();		/* this_buildingData is not NIL  */
  this_isUsed = pk_false;
  this_isBuildable = pk_false;
  SET_MAYSOMEFILEMISSING ();
}
