/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

#ifndef __io_g__
#define __io_g__

/** return the current line number in input file  */
EXTERN int /*io_g*/get_lineCount( void );

EXTERN void /*io_g*/DEBUG_lineScale( char* prefix );

EXTERN void /*io_g*/DEBUG_string( char* prefix1 ,char* prefix2 ,char* str_name ,char* str_val );

EXTERN void /*io_g*/exitERR( const char* mess );

EXTERN void /*io_g*/exitOn_memoryAllocationErr( void );

EXTERN void /*io_g*/exitERR_line( const char* mess );

EXTERN void /*io_g*/warningCommentLost( void );

/** 
 * input: FPIN = [Character*][eol]~[Character*][EOF]
 * output: FPIN  = [Character*][eol]#~[Character*][EOF]
  */
EXTERN void /*io_g*/register_logicalEol( void );

/** FPIN = PREFIX # STRING ~ [Character*][EOF] is used to comment actions;
         it means that PREFIX (previously to the action) followed by STRING(dureing the action) has been read in FPIN;
         thus '~' denotes the "current position",
         at the end of an action # is the current position before the action execution
     <parameter> denotes the value of a char or char * parameter
     '['']' are brackeks
     { STR } denotes that STR is optional
    DIRECTIVE = '#' LOGICALLINE
    a LOGICALSTRING is a sequence of characters in which the sequence '\'[eol] does not occur
    a LOGICALLINE is a LOGICALSTRING not terminated by '\', and followed by [eol]
    BLANKS = {[Blank*]'\'[eol]}* [Blank*]
 */
EXTERN void /*io_g*/char_backward( char ch );

/** returns the next logical character
 *  FPIN = [Character*]#{'\'[eol]}*[Char1]~[Character*][EOF]
 *  [Char1] is neither '\' followed by [eol] nor [eol] preceded by '\'
  */
EXTERN char /*io_g*/get_logicalChar( void );

/** 
 * reads new characters in fpin until an eol or a non space character is reached
 * global input: FPIN = PREFIX ~ [Character*][EOF]
 * parameter: NONE
 * success: FPIN = PREFIX # [SPACE_but_eol]+ ~ [Character*] [EOF], where
 *           first character in [Character*] [EOF] is eol or a non space character
 * failure: FPIN = PREFIX # ~ [Character*] [EOF], where
 *           first character in [Character*] [EOF] is eol or a non space character
 *          exit on reading errors
  */
EXTERN boolean /*io_g*/skip_logicalSpaces_but_eol( void );

/** 
 * reads spaces (including '\n' in fpin until a non space character is reached
 * global input: FPIN = PREFIX ~ [Character*][EOF]
 * parameter: NONE
 * success: FPIN = PREFIX # [SPACE_but_eol]+ ~ [Character*] [EOF], where
 *           first character in [Character*] [EOF] is eol or a non space character
 * failure: FPIN = PREFIX # ~ [Character*] [EOF], where
 *           first character in [Character*] [EOF] is eol or a non space character
 *          exit on reading errors
  */
EXTERN boolean /*io_g*/skip_logicalSpaces( void );

/** if <ch> is the first non read character in FPIN, getc it
 * global input: FPIN = PREFIX ~ [Character*][EOF]
 * parameter: <ch> is not EOF
 * success: FPIN = PREFIX # <ch> ~ [Character*][EOF]
 * failure: FPIN = PREFIX #~ {[Character_but_<ch>][Character*]}[EOF]
  */
EXTERN boolean /*io_g*/getc_if_logicalNext_char_is( char ch );

/** test if <prefix> is the prefix of non read character in FPIN
 * global input: FPIN = PREFIX ~ [Character*][EOF]
 * parameter: <prefix>
 *
 * success: FPIN = PREFIX #~ <prefix> [Character*][EOF]
 * failure: FPIN = PREFIX #~ [EOF]
 * failure: FPIN = PREFIX #~ [Character_0][Character*][EOF], [Character_0] is not <prefix>
  */
EXTERN boolean /*io_g*/logicalNext_string_is( char* prefix );

/** skip spaces including '\n', after a '\n' occurrence. line count is incremented for this occurrence and the following ones
 * FPIN = [Character*][eol]~[Character*][EOF]
 * completed: 
 *          if <testDirective> is false FPIN  = [Character*][eol]#~[Character*][EOF]
 *          if <testDirective> is true 
 *                  FPIN  = [Character*][eol] # { SPACES DIRECTIVE }* SPACES ~ {[Char1][Character*]}[EOF]
 *          [Char1] is not a Blank, not '\' preceding [eol], not [eol] following '\',  not '#' following Spaces
 * return true (false) if a directive occurs (does not occur)
 * 
  */
EXTERN boolean /*io_g*/skip_spacesAndDirectives_inNewLogiLine( boolean testDirective );

/** 
 * reads new characters in fpin until [eol] is reached
 * global input: FPIN = PREFIX '/' '/' ~ [Character*][EOF]
 * success: FPIN = PREFIX '/' '/' # STRING [eol] ~ [Character*] [EOF], '*' '/' does not occur in STRING
 * failure: FPIN = PREFIX '/' '/' # STRING [EOF]~, [eol] does not occur in STRING
  */
EXTERN void /*io_g*/skip_C_lineComment_completion( void );

/** 
 * reads new characters in fpin until the sequence '*' '/' is reached
 * global input: FPIN = PREFIX '/' '*' ~ [Character*][EOF]
 * success: FPIN = PREFIX '/' '*' # STRING '*' '/' ~ [Character*] [EOF], '*' '/' does not occur in STRING
 * failure: FPIN = PREFIX '/' '*' # STRING [EOF]~, '*' '/' does not occur in STRING
  */
EXTERN void /*io_g*/skip_C_fullComment_completion( void );

/** 
 * FPIN = [Character*]['/']~[Character*][EOF]
 * success: FPIN = [Character*]['/'] # ['*'][Character*]['*''/'] ~ [Character*][EOF]
 *          FPIN = [Character*]['/'] # ['/'][Character_but_eol*][eol] ~ [Character*][EOF]
 * failure: FPIN = [Character*]['/'] #~ [Character*][EOF]
  */
EXTERN boolean /*io_g*/skipIf_comment_completion( void );

/** 
 * reads new characters in fpin until a non space character is reached
 * global input: FPIN = PREFIX ~ [Character*][EOF]
 * parameter <testDirective>: if true check preprocessor lines
 * success: FPIN = PREFIX # [SPACE]+ ~ [Character*] [EOF], where
 *           SPACE can be a space character, a comment or a [eol]
 *          [Character*] [EOF] does not start with a SPACE
 * failure: FPIN = PREFIX # ~ [Character*] [EOF], where
 *          [Character*] [EOF] does not start with a SPACE or a COMMENT
  */
EXTERN boolean /*io_g*/skipIf_comments_and_spaces( boolean testDirective );

/** 
 * reads characters in fpin until '"' is reached
 * global input: FPIN = PREFIX '"'~ [Character*][EOF]
 * in expression "[eol] does not occur in STRING" the sequence  '\\'[eol] may occur
 * success: FPIN = PREFIX '"' # STRING '"' ~ [Character*] [EOF], '"', '\' and [eol] do not occur in STRING
 * failure: FPIN = PREFIX '"' # STRING  [EOF]~, '"' and [eol] do not occur in STRING
 * failure: FPIN = PREFIX  '"' # STRING ~ [eol] [Character*] [EOF], '"' and [eol] do not occur in STRING
  */
EXTERN void /*io_g*/skip_C_string_completion( void );

/** 
 * reads new characters in fpin until the ''' is reached
 * global input: FPIN = PREFIX '''~ [Character*][EOF]
 * in expression "[eol] does not occur in STRING" the sequence  '\\'[eol] may occur
 * success: FPIN = PREFIX ''' # STRING ''' ~ [Character*] [EOF], ''' and [eol] do not occur in STRING
 * failure: FPIN = PREFIX ''' # STRING  [EOF]~, ''' and [eol] do not occur in STRING
 * failure: FPIN = PREFIX  ''' # STRING ~ [eol] [Character*] [EOF], ''' and [eol] do not occur in STRING
  */
EXTERN void /*io_g*/skip_C_characterConstant_completion( void );

/** 
 * parameter  <testDirective>: if true check preprocessor lines
  */
EXTERN void /*io_g*/skipTo_endOfUnit( boolean testDirective );

/** reach '{' or ';' first occurrence at level 0
 * parameter  <testDirective>: if true check preprocessor lines
 * skip inner nesting such as strings, comments, C blocks,...
 * return true if '{' is the last read character
 * return false if ';' or EOF is reached
 * exit on inner syntactic error
  */
EXTERN boolean /*io_g*/reach_blockStart( boolean testDirective );

/** INPUT:  FPIN = PREFIX ~ [Character*] EOF
 *  OUTPUT: FPIN = PREFIX # INNER ']' ~ EOF where INNER is a well balanced (wrt '('-')' '['-']' '{'-'}' Character, String Comments  bracketing) sequence of Characters
  */
EXTERN void /*io_g*/skip_squareBracketInner( void );

/** INPUT:  FPIN = PREFIX ~ [Character*] EOF
 *  OUTPUT: FPIN = PREFIX # INNER ')' ~ EOF where INNER is a well balanced (wrt '('-')' '['-']' '{'-'}' Character, String Comments  bracketing) sequence of Characters
  */
EXTERN void /*io_g*/skip_parenthesisInner( void );

/** INPUT:  FPIN = PREFIX ~ [Character*] EOF
 *  OUTPUT: FPIN = PREFIX # INNER '}' ~ EOF where INNER is a well balanced (wrt '('-')' '['-']' '{'-'}' Character, String Comments  bracketing) sequence of Characters
  */
EXTERN void /*io_g*/skip_braceInner( void );

EXTERN int /*io_g*/get_comment( char cmt_str []);

/** in:  <curr_char> is an identifier header char
 *       FPIN = PREFIX <curr_char> ~ [Character*][EOF]
 *       <res_index> is an integer that satisfaies -1 <= <res_index> < sizeof(res_str)
 *       <res_str> is an array large enough to contain an identifier after <res_index> position
 *       if  <res_index> > 0, <res_str>[<res_index>] == '\0'
 *  out: FPIN = PREFIX <curr_char> # IDENT ~ [Character*][EOF] 
 *             the first character in [Character*][EOF] is not an identifier character
 *       <curr_char>IDENT is stored in <res_str>[(res_index+1)..(res_index+strlen(IDENT))]
 *       <res_str>[res_index+strlen(IDENT)+1] == '\0'
 * returns <res_index>+strlen(<curr_char>IDENT)
  */
EXTERN int /*io_g*/get_identifier_completion( char curr_char ,char res_str [],int res_index );

EXTERN void /*io_g*/check_inputFile( char* filePath );

EXTERN void /*io_g*/init_reading( void );

EXTERN void /*io_g*/open_inputFile( char* filePath );

EXTERN void /*io_g*/close_inputFile( void );

EXTERN void /*io_g*/put_space( void );

EXTERN void /*io_g*/put_char( char CC );

EXTERN void /*io_g*/put_eol( void );

EXTERN void /*io_g*/put_abstractProtoEnd( void );

EXTERN void /*io_g*/put_string( const char* str );

EXTERN void /*io_g*/put_publicAccess( void );

EXTERN void /*io_g*/put_protectedAccess( void );

EXTERN void /*io_g*/put_privateAccess( void );

EXTERN void /*io_g*/put_comment( const char* str );

EXTERN void /*io_g*/put_comment_eol( const char* str );

EXTERN void /*io_g*/put_filePrelude( void );

EXTERN void /*io_g*/put_filePostlude( void );

EXTERN void /*io_g*/put_forced_comment_eol( const char* orAnd_str );

EXTERN void /*io_g*/put_headingCommentMissing( void );

EXTERN void /*io_g*/put_forced_functionComment( void );

EXTERN void /*io_g*/open_outputFile( const char* filePath );

EXTERN void /*io_g*/close_outputFile( void );

EXTERN void /*io_g*/remove_file( char* filePath );


#endif /*__io_g__*/
