/* C keywords */

/* C storage-class-specifiers: at most one among the following at the beginning of a declaration */
#define C_extern "extern "
#define substitute_C_extern "_EXTERN_ "
#define C_static "static "
#define substitute_C_static "_STATIC_ "
#define C_auto "auto " /* not in an external declaration */
#define C_register "register " /* for an object && not in an external declaration */
#define C_typedef "typedef " /* for convenience only */

/* C type-qualifiers: 0, 1, 2, 3 among the following */
#define C_const "const "
#define C_volatile "volatile "
#define C_restrict "restrict "


/* C type-specifiers: mandatory in the declaration specifiers in each declaration */
/* C_type_specifiers are 
"void " "char " "short " "int " "long " "float " "double " "signed " "unsigned "
"_Bool" 
"_Complex " "_Imaginary " may not be required 
struct-or-union-specifier enum-specifier 
typedef-name 
*/

/* function specifier is "inline" */

/* struct union */


/* C++ keywords */
/* C++ inheritance qualifier applies to all methods until next scope qualifier */
#define Cpp_public "public:"
#define substitute_Cpp_public "_PUBLIC_"
#define Cpp_protected "protected:"
#define substitute_Cpp_protected "_PROTECTED_"
#define Cpp_private "private:"
#define substitute_Cpp_private "_PRIVATE_"

/* C++ scope qualifier applies to all methods until next scope qualifier */
#define Cpp_static "static "

/* C++ virtual qualifier local to a method */
#define Cpp_virtual "virtual "
#define substitute_Cpp_virtual "_VIRTUAL_ "
#define Cpp_inline "inline "
#define substitute_Cpp_inline "_INLINE_ "

/* C++ inheritance initialisation 
 * syntax is : foo(...)
 */

/* a space is the standard white-space character or
is one of a locale-specific set of characters for which isalnum is false. The standard
white-space characters are the following: space (' '), form feed ('\f'), new-line
('\n'), carriage return ('\r'), horizontal tab ('\t'), and vertical tab ('\v'). In the
"C" locale, isspace returns true only for the standard white-space characters.

/* C++ key words
storage class specifier
        shared with C: auto register  static extern  
        specific     thread_local mutable  
function specifier
        inline 
	virtual explicit  
simple type specifier
        char wchar_t boolean  short int long signed unsigned float double void
linkage specification
        extern ?
cvqualifier
        const volatile
class key
        class struct union 
base specifier
        virtual
access specifier
        private 
        protected 
	public 

enum    

template 

There are another 30 reserved words that were not in C, are therefore new to C++, and here they are:

asm  ?
namespace ?

operator            typename
      friend           this             using
     
*/
