/* PLG DOING 
 * readExpand_lineList_nl NIL REF TODO
 */

/* ==========  ==========  ==========  ========== TITLE: lexical context
 */
/* ==========  ==========  ==========  ========== TITLE: lexical context printing
 */

/* ==========  ==========  ==========  ========== TITLE: lexical context reading
 */

_PUBLIC_ ref2Lexical Context::get_lexicalContext ()	/* DONE */
{
  return this_lexicalContext;
}

/* ==========  ==========  ==========  ========== TITLE: lexical context END
 */

/* appends  'eol'';''spc''--:''spc''LOADED''spc' */
#define LOG_LN_COMMENTLOADED_SP() LOG_LN_COMMENTITEM_STR_SP("inner context previously loaded");
/* appends  'eol'';''spc''--:''spc''LOAD''spc' */
#define LOG_LN_COMMENTLOAD_SP() LOG_LN_COMMENTITEM_STR_SP("inner context LOAD");
/* appends  'eol'';''spc''--:''spc' 'LOAD DONE, back to' 'spc' */
#define LOG_LN_COMMENTLOADdone_SP() LOG_LN_COMMENTITEM_STR_SP("inner context done, back to");
#define THIS_FILENAME() this_MKFFileContext->get_fileName()

/* ==========  ==========  ==========  ========== TITLE: these attributes
 */
_PUBLIC_ _VIRTUAL_ const char *
Context::myClassName ()
{
  return "Context";
}

/* returns in parameters these corresponding attributes
 */
_PUBLIC_ void
Context::get_attributes (ref2IntePrinter * outBuffer, ref2MKFFileNode * staticContext, ref2ContextTree * contextTree, ref2Lexical * lexicalContext)
{
  (*outBuffer) = this_outBuffer;
  (*staticContext) = this_MKFFileContext;
  (*contextTree) = this_contextTree;
  (*lexicalContext) = this_lexicalContext;
}

/* 2004-09-20
 * returns this associated make file
 */
_PUBLIC_ ref2MKFFileNode Context::getMKFFile ()
{
  return this_MKFFileContext;
}


_PUBLIC_ void
Context::reset_ownerFile (ref2MKFFileNode aMKFFile)
{
  this_MKFFileContext = aMKFFile;
}


/* 2004-09-20
 * returns this associated make file
 */
_PUBLIC_ int
Context::get_ownerNumber ()
{
  if (this_MKFFileContext == NIL_MKFFileNode)
    return -1;
  return this_MKFFileContext->get_number ();
}

/* ========== Declaration registration
 */

/* Register a file object in the list of file to be directly built
 */
_PUBLIC_ ref2ContextTree Context::get_contextTree ()
{
  return this_contextTree;
}

/* PLG 2007-02-05
 * search for an existing node named <name> 
 * success: a node named <name> is found in this local context, 
 *          a node named <name> is found recursively in one of these nesting contexts
 *              an accelerator to found declaration is set in this local context
 *          <correct> remains unchanged
 *          returns this node in <refFoundElement>, <refFoundElement> is not NIL
 * failure: this context does not contain node named <name>
 *              <refFoundElement> may be changed
 *          a cyclic context nesting is met
 *              WARNING is printed
 *              <refFoundElement> remains unchanged
 */
_PUBLIC_ boolean Context::find_element_ (char *name, ref2Element * foundElement)
{
  if (this_contextTree == NIL_ContextTree)
    return pk_false;
  return this_contextTree->find_element_ (name, foundElement);
}

/* ==========  ==========  ==========  ========== TITLE: PRINTING
 */


_PUBLIC_ void
Context::print_fileNameValue_sp (ref2Lexical printingContext, ref2IntePrinter outBuffer)
{
  if (this_MKFFileContext != NIL_Element)
    this_MKFFileContext->print_nameValue_sp (printingContext, outBuffer);
}

_PRIVATE_ void
Context::print_contextTree (ref2IntePrinter outBuffer)
{
  if (this_contextTree != NIL_ContextTree)
    this_contextTree->print (this_lexicalContext, outBuffer);
}

_PUBLIC_ _VIRTUAL_ void
Context::print (ref2IntePrinter outBuffer)
{
  print_contextTree (outBuffer);
}



/* ==========  ==========  ==========  ========== TITLE: PRINTING in LOG
 */
/* ==========  ==========  ==========  ========== TITLE: INFO
 */
/* ==========  ==========  ==========  ========== TITLE: LEVEL INFO
 */

_PUBLIC_ void
Context::debugAnnounce (const char *text)
{
  if (ISDEBUG ())
    {
      if (ISLDEBUG ())
	this_MKFFileContext->log_ln_INFO_ref__ln (text);
      else
	LOG_LN_COMMENTITEM_STR_LN (text);	/* appends  'eol'';''spc''--:''spc'<text>'eol' */
      this_MKFFileContext->log_fullReference_ln ();
    }
}

_PRIVATE_ void
Context::print_fileNameValue_ln_lst (ref2IntePrinter outBuffer, ref2CStringList nameLst)
{
  // log_ASDEBUG("Context::print_fileNameValue_ln_lst");
  while (nameLst != NIL_CStringList)
    {
      // log_ASDEBUG("Context::print_fileNameValue_ln_lst in while");
      outBuffer->put_fileNameValue_ln (nameLst->content ());
      nameLst = nameLst->next ();
    }
  // log_ASDEBUG("Context::print_fileNameValue_ln_lst end");
}

_PRIVATE_ void
Context::debugInfo_backToContext ()
{
  if (ISDEBUG ())
    {
      LOG_LN_COMMENTLOADdone_SP ();	/* appends  'eol'';''spc''--:''spc' 'LOAD DONE, back to' 'spc' */
      LOG_STR_LN (THIS_FILENAME ());
    }
}

_PUBLIC_ void
Context::levelInfo_loadedAnnounce_ln ()
{
  if (ISLVERBOSE ())
    {
      LOG_LN_COMMENTLOADED_SP ();
      if (ISDEBUG ())
	{
	  this_MKFFileContext->log_fullReference_ln ();
	}
      else
	this_MKFFileContext->log_outerName_ln ();
    }
}


_PRIVATE_ void
Context::levelInfo_loadAnnounce_ln ()
{
  if (this_MKFFileContext == NIL_Element)
    {
      if (ISLVERBOSE ())
	{
	  LOG_LN_COMMENTLOAD_SP ();
	  LOG_STR_LN ("empty file descriptor");
	}
      return;
    }
  if (ISLVERBOSE ())
    {
      LOG_LN_COMMENTLOAD_SP ();
      if (ISDEBUG ())
	{
	  this_MKFFileContext->log_fullReference_ln ();
	}
      else
	{
	  this_MKFFileContext->log_outerName_ln ();
	}
      LOG_TAB (3);
    }
}

/* ==========  ==========  ==========  ========== TITLE: LEVEL INFO OR PRINTING
 */

/* PLG 2008-06-04
 * if class attribute <this_outBuffer> is NIL_IntePrinter and log status is less than LDEBUG
 *   nothing is done
 *   otherwise prints file lexical marks in TARGET
 * if class attribute <this_outBuffer> is not NIL_IntePrinter TARGET is <this_outBuffer>
 * if class attribute <this_outBuffer> is NIL_IntePrinter TARGET is <the_logBuffer>
 * PRE: TARGET is not NIL; TARGET = STRING
 * POST: TARGET = STRING '$$' L R C S 'eol'
 */
_PRIVATE_ void
Context::printORlevelInfo_lexicalContext_ln ()
{
  if (this_outBuffer == NIL_IntePrinter)
    {
      if (ISLDEBUG ())
	this_lexicalContext->out_lexicalContext_ln (LOGFILE ());
    }				// appends  L R C S  'eol'
  else
    this_lexicalContext->out_lexicalContext_ln (this_outBuffer);	// appends  L R C S  'eol'
}

/* anElement cannot be NIL
 */
_PUBLIC_ void
Context::printORlevelInfo_declCompletion (ref2Element anElement)
{
  if (this_outBuffer == NIL_IntePrinter)
    {
      if (ISLDEBUG ())
	anElement->print (LOGMARKS (), LOGFILE (), pk_true);
    }
  else
    anElement->print (this_lexicalContext, this_outBuffer, pk_true);
}

/* anElement cannot be NIL
 */
_PUBLIC_ void
Context::printORlevelInfo_decl_ln (ref2Element anElement, const char *mess)
{
  if (this_outBuffer == NIL_IntePrinter)
    {
      if (ISDEBUG ())
	{
	  if (ISLDEBUG ())
	    {
	      anElement->log_ln_INFO_ref__ln (mess);
	      anElement->print (LOGMARKS (), LOGFILE (), pk_true);
	    }
	  else
	    {
	      /* appends  'eol'';''spc''--:''spc'<mess>'spc' <anElement name>'eol' */
	      LOG_LN_COMMENTITEM_STR_SP_STR_LN (mess, anElement->get_name ());
	    }
	}
    }
  else
    {
      fprintf (stderr, "PLG DEBUG Context::printORlevelInfo_decl_ln this_outBuffer NOT NIL_IntePrinter \n");
      anElement->print (this_lexicalContext, this_outBuffer, pk_true);
      if (ISDEBUG ())
	{
	  /* appends  'eol'';''spc''--:''spc'<mess>'spc' <anElement name>'eol' */
	  LOG_LN_COMMENTITEM_STR_SP_STR_LN (mess, anElement->get_name ());
	}
    }
}

/* ========= =========  READ COMMAND 1-0: announce printORlevelInfo_declOpening_boot, printORlevelInfo_declClosing_boot
 */
/* PLG 2008-06-04
 * PRE: <outBuffer> is not NIL_IntePrinter; 
 *      <outBuffer> == STRING
 * POST:<outBuffer> == STRING 'eol' '{' 'spc' '$$' L R C S 'eol' {<comments> 'eol'} C 'boot' 'eol'
 *      where  L, R, C, S are respectively current opening, closing, command, string marks
 */
_PRIVATE_ void
Context::print_ln_bootOpening_ln (ref2IntePrinter outBuffer, ref2ArgumentList comments)
{
  this_lexicalContext->out_ln_declOpening_sp (outBuffer);	// appends 'eol' '{' 'spc'
  if (comments != NIL_ArgumentList)
    comments->print_commentList (this_lexicalContext, outBuffer, pk_true);
  // appends <comments> actual value:'eol'';' STR_1 'eol' ... ';' STR_m 'eol'
  this_lexicalContext->out_bootDeclHeader_ln (outBuffer);	// appends C 'boot' 'eol'
}

/* PLG 2008-06-04
 * PRE: <the_logBuffer> is not NIL; 
 * COND1: class attribute <this_outBuffer> is NIL_IntePrinter and log status is less than DEBUG
 *   nothing is done, 
 *   returns false
 * COND2: class attribute <this_outBuffer> is NIL_IntePrinter and log status is DEBUG
 *     PRE: <the_logBuffer> = STRING
 *     POST: <the_logBuffer> = STRING 'boot action' 'eol'
 *   returns pk_true
 * COND3: class attribute <this_outBuffer> is NIL_IntePrinter and log status is LDEBUG
 *     PRE: <the_logBuffer> = STRING, <this_lexicalContext command mark> is C
 *     POST: <the_logBuffer> = STRING  'eol'  C'boot' 'eol'
 *   returns pk_true
 * COND4: class attribute <this_outBuffer> is not NIL_IntePrinter 
 *     PRE: <this_outBuffer> = STRING, <this_lexicalContext command mark> is C
 *     POST: <this_outBuffer> = STRING 'eol' '{' 'spc' '$$' L R C S 'eol' {<comments> 'eol'} C 'boot' 'eol'
 *           <the_logBuffer> as in COND2
 *   returns pk_true
 */
_PRIVATE_ boolean Context::printORlevelInfo_declOpening_boot (ref2ArgumentList comments)
{
  if (this_outBuffer == NIL_IntePrinter)
    {
      if (ISDEBUG ())
	{
	  if (ISLDEBUG ())
	    print_ln_bootOpening_ln (LOGFILE (), comments);
	  else
	    print_ln_bootOpening_ln (LOGFILE (), NIL_ArgumentList);
	  return pk_true;
	}
      return pk_false;
    }
  print_ln_bootOpening_ln (this_outBuffer, comments);
  // appends 'eol' '{' 'spc' '$$' L R C S 'eol' {<comments> 'eol'} C 'boot' 'eol'
  if (ISDEBUG ())
    {
      /* appends  'eol'';''spc''--:''spc' 'boot action' 'eol' */
      LOG_LN_COMMENTITEM_STR_LN ("boot action");
    }
  return pk_true;
}

/* PLG 2008-06-04
 * PRE: <the_logBuffer> is not NIL; 
 * COND1: class attribute <this_outBuffer> is NIL_IntePrinter and log status is less than LDEBUG
 *   nothing is done, 
 *   returns false
 * COND2: class attribute <this_outBuffer> is NIL_IntePrinter and log status is LDEBUG
 *     PRE: <the_logBuffer> = STRING
 *     POST: <the_logBuffer> = STRING 'eol' '}' 'eol'
 *   returns pk_true
 * COND3: class attribute <this_outBuffer> is not NIL_IntePrinter 
 *     PRE: <this_outBuffer> = STRING, 
 *     POST: <this_outBuffer> = STRING 'eol' '}' 'eol'
 *           <the_logBuffer> as in COND2
 *   returns pk_true
 */
_PRIVATE_ void
Context::printORlevelInfo_declClosing_boot (ref2LineList command_lines)
{
  if (this_outBuffer == NIL_IntePrinter)
    {
      if (ISDEBUG ())
	{
	  if (command_lines != NIL_LineList)
	    command_lines->generate (LOGFILE ());
	  LOGFILE ()->put_ln_declClosing_ln ();
	}
    }				/* appends 'eol' '}' 'eol' */
  else
    {
      if (command_lines != NIL_LineList)
	command_lines->generate (this_outBuffer);
      this_outBuffer->put_ln_declClosing_ln ();
    }				/* appends 'eol' '}' 'eol' */
}


/* ========= =========  READ COMMAND 2-0: announce printORlevelInfo_declOpening_context, printORlevelInfo_declClosing_context_backTab
 */
/* PLG 2008-06-04
 * PRE: <outBuffer> is not NIL_IntePrinter; 
 *      <outBuffer> == STRING
 * POST:<outBuffer> == STRING 'eol' '{' 'spc' '$$' L R C S 'eol' {<comments> 'eol'} C 'context' 'spc'
 *      where  L, R, C, S are respectively current opening, closing, command, string marks
 */
_PRIVATE_ void
Context::print_ln_declOpening_context_spTab (ref2IntePrinter outBuffer, ref2ArgumentList comments)
{
  this_lexicalContext->out_ln_declOpening_sp (outBuffer);	// appends 'eol' '{' 'spc'
  if (comments != NIL_ArgumentList)
    comments->print_commentList (this_lexicalContext, outBuffer, pk_true);
  // appends <comments> actual value:'eol'';' STR_1 'eol' ... ';' STR_m 'eol'
  this_lexicalContext->out_contextDeclHeader_spTab (outBuffer);	// appends C 'context' 'eol'
}

_PRIVATE_ boolean Context::printORlevelInfo_declOpening_context_spTab (ref2ArgumentList comments)
{
  if (this_outBuffer == NIL_IntePrinter)
    {
      if (ISDEBUG ())
	{
	  if (ISLDEBUG ())
	    print_ln_declOpening_context_spTab (LOGFILE (), comments);
	  else
	    print_ln_declOpening_context_spTab (LOGFILE (), NIL_ArgumentList);
	  /* appends 'eol' '{' 'spc' '$$' L R C S 'eol' {<comments> 'eol'} C 'context' 'spc' */
	  return pk_true;
	}
      return pk_false;
    }
  print_ln_declOpening_context_spTab (this_outBuffer, comments);
  /* appends 'eol' '{' 'spc' '$$' L R C S 'eol' {<comments> 'eol'} C 'context' 'spc' */
  if (ISDEBUG ())
    /* appends  'eol'';''spc''--:''spc' 'inner context' 'eol' */
    LOG_LN_COMMENTITEM_STR_LN ("inner context");
  return pk_false;
}

/* PLG 2007-03-20
 * prints in target context mark followed file <comments>
 * if class attribute <this_outBuffer> is not NIL_IntePrinter target file is this_outBuffer
 * if class attribute <this_outBuffer> is NIL_IntePrinter target file is the_logBuffer
 *       in this case printing occurs if log status is debug level
 */
_PRIVATE_ void
Context::printORlevelInfo_declClosing_context_backTab (ref2CStringList nameLst)
{
  // log_ASDEBUG("Context::printORlevelInfo_declClosing_context_backTab");
  if (this_outBuffer == NIL_IntePrinter)
    {
      if (ISDEBUG ())
	{
	  print_fileNameValue_ln_lst (LOGFILE (), nameLst);
	  LOGFILE ()->put_ln_declClosing_lnBackTab ();
	}
    }
  else
    {
      print_fileNameValue_ln_lst (this_outBuffer, nameLst);
      this_outBuffer->put_ln_declClosing_lnBackTab ();
    }
}

/* ========= =========  READ COMMAND 3-0: announce printORlevelInfo_declOpening_elementFunctionCall, printORlevelInfo_declClosing_elementFunctionCall
 */
/* PLG 2008-06-04
 * PRE: <outBuffer> is not NIL_IntePrinter; 
 *      <outBuffer> == STRING
 * POST:<outBuffer> == STRING 'eol' '{' 'spc' '$$' L R C S 'eol' {<comments> 'eol'} 
 *      where  L, R, C, S are respectively current opening, closing, command, string marks
 */
_PRIVATE_ void
Context::print_ln_declOpening_elementFunctionCall_sp (ref2IntePrinter outBuffer, ref2ArgumentList comments)
{
  // log_ASDEBUG("Context::print_ln_declOpening_elementFunctionCall_sp");
  this_lexicalContext->out_ln_setComment_declOpening_sp (outBuffer);	// appends 'eol' '{' 'spc'
  this_lexicalContext->out_lexicalContext_sp (outBuffer);	// appends  L R C S  'eol'
  if (comments != NIL_ArgumentList)
    comments->print_commentList (this_lexicalContext, outBuffer, pk_true);
}

_PRIVATE_ boolean Context::printORlevelInfo_declOpening_elementFunctionCall (ref2ArgumentList comments, const char *functionName)
{
  // log_ASDEBUG("Context::printORlevelInfo_declOpening_elementFunctionCall");
  if (this_outBuffer == NIL_IntePrinter)
    {
      if (ISDEBUG ())
	{
	  if (ISLDEBUG ())
	    {
	      print_ln_declOpening_elementFunctionCall_sp (LOGFILE (), comments);
	      return pk_true;
	    }
	  LOG_LN_COMMENTITEM_STR_SP_STR_LN ("call to element function", functionName);
	}
      return pk_false;
    }
  print_ln_declOpening_elementFunctionCall_sp (this_outBuffer, comments);	/* TODO print call or result ??? */
  /* appends 'eol' '{' 'spc' '$$' L R C S 'eol' {<comments> 'eol'} */
  if (ISDEBUG ())
    {
      LOG_LN_COMMENTITEM_STR_SP_STR_LN ("call to element function", functionName);
    }
  return pk_true;
}

/* PLG 2007-03-20
 * prints in target context mark followed file <comments>
 * if class attribute <this_outBuffer> is not NIL_IntePrinter target file is this_outBuffer
 * if class attribute <this_outBuffer> is NIL_IntePrinter target file is the_logBuffer
 *       in this case printing occurs if log status is debug level
 */
_PRIVATE_ void
Context::printORlevelInfo_declClosing_elementFunctionCall (ref2ElementFunctionCall pt2NodeCall)
{
  // log_ASDEBUG("Context::printORlevelInfo_declClosing_elementFunctionCall");
  if (this_outBuffer == NIL_IntePrinter)
    {
      if (ISLDEBUG ())
	{
	  pt2NodeCall->print_formula (this_lexicalContext, LOGFILE ());
	  (LOGFILE ())->put_ln_declClosing_ln_unsetComment ();
	}
    }
  else
    {
      pt2NodeCall->print_formula (this_lexicalContext, this_outBuffer);
      this_outBuffer->put_ln_declClosing_ln_unsetComment ();
    }
  // log_ASDEBUG("Context::printORlevelInfo_declClosing_elementFunctionCall DONE");
}

/* ========= =========  READ COMMAND 4-0: announce printORlevelInfo_declOpening_context_spTab, printORlevelInfo_declClosing_context_backTab
 */

_PUBLIC_ void
Context::printORlevelInfo_node_functionCallReading (const char *functionName, ref2FunctionCall action, ref2ArgumentList comments)
{
  ref2IntePrinter outBuffer;
  if (this_outBuffer == NIL_IntePrinter)
    {				/* PLG reset level info */
      if (ISLDEBUG ())
	{
	  outBuffer = LOGFILE ();
	  LOG_LN_INFO_STR_SP_STR_LN ("node", "generator call");
	}
      else
	return;
    }
  else
    outBuffer = this_outBuffer;
  /* appends 'eol' ';' '{' 'spc' '$$' L R C S 'eol' {<comments> 'eol'} */
  print_ln_declOpening_elementFunctionCall_sp (outBuffer, comments);
  action->print_formula (this_lexicalContext, outBuffer);
  outBuffer->put_ln_declClosing_ln_unsetComment ();
}

/* ========= =========  READ COMMAND 4-0: announce 
 */




_PUBLIC_ void
Context::printORlevelInfo_functionCallReading (ref2Lexical printingContext, ref2FunctionCall action, const char *generatedType)
{
  if (this_outBuffer == NIL_IntePrinter)
    {
      if (ISLDEBUG ())
	{
	  (LOGFILE ())->put_ln_setComment_declOpening_sp ();
	  LOG_LN_INFO_STR_SP_STR_LN (generatedType, "generator call reading");
	  action->print_formula (LOGMARKS (), LOGFILE ());
	  (LOGFILE ())->put_ln_declClosing_ln_unsetComment ();
	}
    }
  else
    {
      this_outBuffer->put_ln_setComment_declOpening_sp ();
      action->print_formula (printingContext, this_outBuffer);
      this_outBuffer->put_ln_declClosing_ln_unsetComment ();
    }
}

_PUBLIC_ void
Context::printORlevelInfo_functionCallReading (ref2FunctionCall action, const char *generatedType)
{
  printORlevelInfo_functionCallReading (this_lexicalContext, action, generatedType);
}

/* PLG HERE Context -> Soundness */
/* ==========  ==========  ==========  ========== TITLE: ERROR
 */

/* this is set to fatal or error as indicated by this lexical context
 */
_PROTECTED_ void
Context::set_errored ()
{
  if (this_lexicalContext->is_fatal ())
    set_fatal ();
  else
    set_error ();
}

_PROTECTED_ void
Context::error_newLineExpected ()
{
  this_lexicalContext->ASFatal_expected ("new line");
  set_error ();
}

_PROTECTED_ void
Context::error_ARGList_expected ()
{
  this_lexicalContext->ASFatal_expected ("list of arguments between ( and )");
  set_error ();
}

_PROTECTED_ void
Context::error_type_functionCall_ (const char *functionName)
{
  LOG_LN_ERRO_STR_SP ("call to ");
  LOG_STR_SP_STR_LN (functionName, "function: unexpected type");
  set_error ();
}

_PROTECTED_ void
Context::error_stringTypeMatching_ (const char *identifierName)
{
  LOG_LN_ERRO_STR_SP ("assignment to ");
  LOG_STR_SP_STR_LN (identifierName, "expected type is string");
  set_error ();
}

_PROTECTED_ void
Context::error_NIL_argument_ (const char *identifierName)
{
  LOG_LN_ERRO_STR_SP ("assignment to ");
  LOG_STR_SP_STR_LN (identifierName, "expected value is not defined");
  set_error ();
}

/* ==========  ==========  ==========  ========== TITLE: FATAL
 */

_PROTECTED_ void
Context::ASFatal_expected (const char *mess)
{
  this_lexicalContext->ASFatal_expected (mess);
}

_PROTECTED_ void
Context::ASFatal_unexpected (const char *mess)
{
  this_lexicalContext->ASFatal_unexpected (mess);
}

_PROTECTED_ void
Context::ASFatal_unexpected (boolean printMess, const char *mess)
{
  this_lexicalContext->ASFatal_unexpected (printMess, mess);
}

_PROTECTED_ void
Context::ASFatal_missingDecl (boolean printMess, const char *category, const char *CString_name)
{
  this_lexicalContext->ASFatal_missingDecl (printMess, category, CString_name);
}

_PRIVATE_ void
Context::ASFatal_expansion (const char *mess)
{
  this_lexicalContext->ASFatal_expansion (mess);
}

_PUBLIC_ void
Context::ASFatal_doubleDecl (const char *CString_name)
{
  this_lexicalContext->ASFatal_doubleDecl (CString_name);
}

/* ==========  ==========  ==========  ========== TITLE: DEBUG
 */

_PUBLIC_ int
Context::get_contextNumber ()
{
  return this_contextNumber;
}

_PUBLIC_ void
Context::logDEBUG_contextNumber ()
{
  LOG_LN_DEBU_STR_SP ("This context number is");
  LOG_INT_LN (this_contextNumber);
}

_PRIVATE_ void
Context::logDEBUG_contextLinking (int ancestorNumber)
{
  logDEBUG_in ("creator");
  LOG_LN_DEBU_STR_SP ("This context numbered");
  LOG_INT_SP (this_contextNumber);
  LOG_STR_SP ("is linked to the context numbered");
  LOG_INT_LN (ancestorNumber);
}

_PUBLIC_ void
Context::logDebug_class_ln (const char *mess)
{
  LOG_LN_DEBU_STR_SP (mess);
  LOG_STR_LN (myClassName ());
}

void
Context::log_ASDEBUG (const char *mess)
{
  if (this_lexicalContext != NIL_Lexical)
    this_lexicalContext->log_ASDEBUG (mess);
}

_PROTECTED_ void
Context::logDEBUG_emptyFormula_ln (const char *mess, const char *category)
{
  LOG_LN_DEBU_STR_SP (mess);
  LOG_STR_SP_STR_LN ("empty", category);
}

/* ==========  ==========  ==========  ========== TITLE: SPECIFIC ACTIONS
 */

/* ========== Declaration linking
 */

/* PLG 2007-02-05
 * search for a string identifier declaration named <CString_name>
 * search root is current_fileContextTree
 * required: not empty <CString_name> (not checked)
 * success: a global identifier with expected type is found
 *          returns its actual value in <stringArgument_res>
 *          <correct> remains unchanged
 * failure: <CString_name> has not been found in this context
 *             <correct> remains unchanged
 *          <CString_name> has been found but has unexpected type, or a cyclic search has been met
 *             (fatal) error message is printed
 *             <correct> is set to false
 *          <stringArgument_res> remains unchanged
 */
_PUBLIC_ _VIRTUAL_ boolean Context::getIf_expandedString_idVal_ (char *CString_name, boolean * correct, ref2StringArgument * stringArgument_res)
{
  ref2ArgumentElement
    argumentElement;

  // logDEBUG_in("getIf_expandedString_idVal_ name is", CString_name);
  if (current_fileContextTree->find_argumentElement_in_ (CString_name, correct, &argumentElement))
    {
      boolean
	isFatal;
      if (argumentElement->get_expandedString (stringArgument_res, &isFatal))
	return pk_true;
      /* fatal error; message has been printed */
      (*correct) = pk_false;
    }
  /* correct false: fatal error (CString_name found, not a string argument) */
  return pk_false;
}

/* PLG 2007-02-05
 * search for a list identifier declaration named <CString_name> 
 * search root is current_fileContextTree
 * required: not empty <CString_name>
 * success: a global identifier with expected type is found
 *          returns its actual value in <argumentList_res>
 *             <isFatal> remains unchanged
 * failure: <CString_name> has not been found in this context
 *             <correct> remains unchanged
 *          <CString_name> has been found but has unexpected type, or a cyclic search has been met
 *             (fatal)error message is printed
 *             <correct> is set to false
 *          <argumentList_res> remains unchanged
 */
_VIRTUAL_ boolean
Context::getIf_expandedList_idVal_ (char *CString_name, boolean * correct, ref2ArgumentList * argumentList_res)
{
  ref2ArgumentElement argumentElement;
  // logDEBUG_in("getIf_expandedList_idVal_, name is", CString_name);
  if (current_fileContextTree->find_argumentElement_in_ (CString_name, correct, &argumentElement))
    {
      boolean isFatal;
      if (argumentElement->get_expandedList (argumentList_res, &isFatal))
	return pk_true;
      /* fatal error; message has been printed */
      (*correct) = pk_false;
    }
  /* correct false: fatal error (CString_name found, not a list argument) */
  return pk_false;
}

/* PLG PLG 2007-02-05
 * search for a string element declaration named <CString_name>, <CString_name> is not NIL_String, not checked
 * success: a global identifier with expected type is found
 *          returns its expanded value in <argument_res>; 
 *             <correct> remains unchanged
 * failure: <CString_name> has not been found in this context
 *             <correct> remains unchanged
 *          <CString_name> has been found but has unexpected type, or a cyclic search has been met
 *             error message is printed
 *             <correct> is set to false
 *          <argument_res> remains unchanged
 */
_PUBLIC_ _VIRTUAL_ boolean Context::getIf_string_id_ (char *CString_name, boolean * correct, ref2Argument * argument_res)
{
  // logDEBUG_in("getIf_string_id_ name is", CString_name);
  ref2ArgumentElement
    argumentElement;
  if (this_contextTree->find_argumentElement_in_ (CString_name, correct, &argumentElement))
    {
      ref2StringArgument
	stringArgument_res;
      boolean
	isFatal;
      if (argumentElement->get_expandedString (&stringArgument_res, &isFatal))
	{
	  (*argument_res) = (ref2Argument) stringArgument_res;
	  return pk_true;
	}
      /* fatal error; message has been printed */
      set_fatal ();
      (*correct) = pk_false;
    }
  /* correct false: fatal error (CString_name found, not a string id argument) */
  return pk_false;
}

_PRIVATE_ boolean Context::get_string_id_ (char *CString_name, ref2Argument * argument_res)
{
  // logDEBUG_in("get_string_id_ name is", CString_name);
  boolean
    lCorrect = pk_true;
  if (getIf_string_id_ (CString_name, &lCorrect, argument_res))
    return pk_true;
  if (lCorrect)
    ASFatal_missingDecl (lCorrect, "string identifier", CString_name);
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean Context::getIf_string_id_ (ref2MetaArgument id_name, boolean * correct, ref2Argument * argument_res)
{
  // logDEBUG_in("getIf_string_id_ name is MetaArg");
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean Context::getIf_string_id_ (ref2CommandArgument id_name, boolean * correct, ref2Argument * argument_res)
{
  // logDEBUG_in("getIf_string_id_ name is MetaArg");
  return pk_false;
}

/* PLG 2007-02-05
 * search for a list element declaration named <CString_name>, <CString_name> is not NIL_String, not checked
 * success: a global identifier with expected type is found
 *          returns its expanded value in <argument_res>; 
 *             <correct> remains unchanged
 * failure: <CString_name> has not been found in this context
 *             <correct> remains unchanged
 *          <CString_name> has been found but has unexpected type, or a cyclic search has been met
 *             error message is printed
 *             <correct> is set to false
 *          <argument_res> remains unchanged
 */
_VIRTUAL_ boolean
Context::getIf_list_id_ (char *CString_name, boolean * correct, ref2Argument * argument_res)
{
  ref2ArgumentElement argumentElement;
  if (this_contextTree->find_argumentElement_in_ (CString_name, correct, &argumentElement))
    {
      ref2ArgumentList argumentList_res;
      boolean isFatal;
      if (argumentElement->get_expandedList (&argumentList_res, &isFatal))
	{
	  (*argument_res) = (ref2Argument) argumentList_res;
	  return pk_true;
	}
      /* fatal error; message has been printed */
      (*correct) = pk_false;
    }
  /* correct false: fatal error (CString_name found, not a list id argument) */
  return pk_false;
}

_VIRTUAL_ boolean
Context::getIf_list_id_ (ref2MetaArgument id_name, boolean * correct, ref2Argument * argument_res)
{
  return pk_false;
}

_VIRTUAL_ boolean
Context::getIf_list_id_ (ref2CommandArgument id_name, boolean * correct, ref2Argument * argument_res)
{
  return pk_false;
}

/* PLG 2007-02-05
 * search for a string or list element declaration named <CString_name>, <CString_name> is not NIL_String, not checked
 * success: a global argument identifier is found
 *          returns found identifier expanded value in <argument_res>; this actual value is a 
 *          (static, string) StringArgument or a static (list) ArgumentList
 *             <correct> remains unchanged
 * failure: <CString_name> has not been found in this context
 *             <correct> remains unchanged
 *          <CString_name> has been found but has unexpected type, or a cyclic search has been met
 *              error message is printed
 *             <correct> is set to false
 *          <argument_res> remains unchanged
 */
_PUBLIC_ _VIRTUAL_ boolean Context::getIf_argument_id_ (char *CString_name, boolean * correct, ref2Argument * argument_res)
{
  ref2ArgumentElement
    argumentElement;
  if (this_contextTree->find_argumentElement_in_ (CString_name, correct, &argumentElement))
    {
      if (argumentElement->get_expanded (argument_res))
	return pk_true;
      /* fatal error; message has been printed */
      set_fatal ();
      (*correct) = pk_false;
    }
  /* correct false: fatal error (CString_name found, not an id argument) */
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean Context::getIf_argument_id_ (ref2MetaArgument id_name, boolean * correct, ref2Argument * argument_res)
{
  return pk_false;
}

_PUBLIC_ _VIRTUAL_ boolean Context::getIf_argument_id_ (ref2CommandArgument id_name, boolean * correct, ref2Argument * argument_res)
{
  return pk_false;
}

/* failure: error message is printed
 */
_PRIVATE_
  boolean Context::getExpandedIfStatic (ref2ArgumentFunctionCall functionCall, boolean isList, ref2Argument * argument_res, boolean isIterated)
{
  if (isIterated)
    {
      (*argument_res) = new CommandArgument (isList, functionCall, pk_true);
      return pk_true;
    }
  if (functionCall->is_static ())
    return functionCall->get_expanded (argument_res);
  (*argument_res) = new CommandArgument (isList, functionCall, pk_false);
  return pk_true;
}

_PUBLIC_ boolean Context::appendNew_staticStringElement (ref2ArgumentList comments, char *CString_name, ref2Argument formula)
{
  // log_ASDEBUG("Context::appendNew_staticStringElement 000-1");
  ref2StringArgument
    stringRes;
  if (formula->getIf_stringExpand_ (&stringRes))
    return this_contextTree->appendNew_staticArgumentElement (comments, pk_true, CString_name, (ref2Argument) stringRes);
  ASFatal_expansion ("string");
  return pk_false;
}

_PUBLIC_ boolean Context::appendNew_localStringElement (ref2ArgumentList comments, char *CString_name, ref2Argument formula)
{
  // log_ASDEBUG("Context::appendNew_localStringElement 0001-1");
  if (this_contextTree->check_localDeclAbsence (CString_name))
    {
      ref2StringArgument
	stringRes;
      if (formula->getIf_stringExpand_ (&stringRes))
	return this_contextTree->appendNew_fileArgumentElement (comments, pk_true, CString_name, (ref2Argument) stringRes);
      ASFatal_expansion ("string");
      return pk_false;
    }
  else
    ASFatal_doubleDecl (CString_name);
  return pk_false;
}

_PUBLIC_ boolean Context::appendNew_staticListElement (ref2ArgumentList comments, char *CString_name, ref2Argument formula)
{
  // log_ASDEBUG("Context::appendNew_staticListElement 000-2");
  ref2ArgumentList
    listRes;
  if (formula == NIL_Argument)
    return this_contextTree->appendNew_staticArgumentElement (comments, pk_false, CString_name, NIL_Argument);
  if (formula->getIf_flatten_listExpand_ (&listRes))
    return this_contextTree->appendNew_staticArgumentElement (comments, pk_false, CString_name, (ref2Argument) listRes);
  ASFatal_expansion ("list");
  return pk_false;
}

_PUBLIC_ boolean Context::appendNew_localListElement (ref2ArgumentList comments, char *CString_name, ref2Argument formula)
{
  // log_ASDEBUG("Context::appendNew_localListElement 0001-2");
  if (this_contextTree->check_localDeclAbsence (CString_name))
    {
      ref2ArgumentList
	listRes;
      if (formula == NIL_Argument)
	return this_contextTree->appendNew_fileArgumentElement (comments, pk_false, CString_name, NIL_Argument);
      if (formula->getIf_flatten_listExpand_ (&listRes))
	return this_contextTree->appendNew_fileArgumentElement (comments, pk_false, CString_name, (ref2Argument) listRes);
      ASFatal_expansion ("list");
      return pk_false;
    }
  else
    ASFatal_doubleDecl (CString_name);
  return pk_false;
}

boolean
Context::cast_argument2Ident (ref2Argument _arg, char **CString_name)
{
  if (_arg->getIf_CString_cast_expand_ (CString_name))
    if (this_lexicalContext->isString_userIdentifier (*CString_name))
      return pk_true;
  ASFatal_expected ("user identifier");
  return pk_false;
}

/* ================================================================================ */
/*
 * this_nestingContext not NIL (not checked)
 * success: <name> is a static list identifier
 *              a new iterator is assigned to <iterator>
 *              its value is the expanded value of the static identifier
 * failure: <name> has not been found or <name> does not have list type
 *     <name> is found, but is not a string list element
 *          or a cyclic search has been met
 *          error message is printed
 *          <isFatal> is set to pk_true
 *     <name> is not found
 *          <isFatal> remains unchanged
 */
_VIRTUAL_ boolean
Context::build_iteratorRefTo_ (char *name, ref2Iterator * iterator, boolean * isFatal)
{
  ref2ArgumentList argRes;
  boolean lCorrect = pk_true;;
  if (getIf_expandedList_idVal_ (name, &lCorrect, &argRes))
    {
      (*iterator) = new Iterator (name, argRes);
      return pk_true;
    }
  if (lCorrect)
    fatal_missingIdentifier ("list variable refered to by iterator", name);
  return pk_false;
}

/* PLG 2007-02-07
 * search for an element declaration named <CString_name> in this_MKFFileContext context
 * success: returns found declaration in <foundElement> 
 * failure: CString_name is not an element in this_MKFFileContext context, or a cyclic search has been met
 *          (fatal) error message is printed
 */
_PRIVATE_ boolean Context::find_function (char *CString_name, ref2Element * foundElement)
{
  if (find_element_ (CString_name, foundElement))	/* never errored */
    return pk_true;
  ASFatal_missingDecl (pk_true, "function", CString_name);
  return pk_false;
}

_PROTECTED_ boolean Context::find_userListFunctionElement (char *CString_name, ref2UserListFunctionElement * function_res)
{
  ref2Element
    foundElement;
  if (find_function (CString_name, &foundElement))
    {
      if (foundElement->isUserListFunctionElement ())
	{
	  *function_res = (ref2UserListFunctionElement) foundElement;
	  return pk_true;
	}
      fatal_named_typeConflict_ln (CString_name, "list function");
    }
  return pk_false;
}

/* PLG 2005-12-12, 2007-02-07
 * search for an argument function declaration named <CString_name> in this_MKFFileContext context
 * success: returns found declaration in <foundElement> 
 * failure: CString_name is not found or
 *          CString_name is found, but is not an argument function in this_MKFFileContext context
 *           or a cyclic search has been met
 *          (fatal)error message is printed
 *     
 */

_PROTECTED_ boolean Context::find_argumentFunctionElement (char *CString_name, ref2FunctionElement * function_res, boolean * isList)
{
  ref2Element
    foundElement;
  if (find_function (CString_name, &foundElement))
    {
      if (foundElement->isUserStringFunctionElement ())
	{
	  (*function_res) = (ref2FunctionElement) foundElement;
	  (*isList) = pk_false;
	  return pk_true;
	}
      else if (foundElement->isUserListFunctionElement ())
	{
	  *function_res = (ref2FunctionElement) foundElement;
	  (*isList) = pk_true;
	  return pk_true;
	}
      fatal_named_typeConflict_ln (CString_name, "string or list function");
    }
  return pk_false;
}

_PUBLIC_
/* PLG 2005-12-12
 * search for an ancestor function declaration named <CString_name> in this_MKFFileContext context
 * success: returns found declaration in <foundElement> 
 * failure: 
 *     CString_name is found, but is not an ancestor function in this_MKFFileContext context
 *          or a cyclic search has been met
 *          error message is printed
 *          <isFatal> is set to pk_true
 *     CString_name is not found
 *          <isFatal> remains unchanged
 */
  boolean Context::find_ancestorFunctionElement (char *CString_name, ref2AncestorFunctionElement * function_res)
{
  ref2Element
    foundElement;
  if (find_function (CString_name, &foundElement))
    {
      if (foundElement->isAncestorFunctionElement ())
	{
	  *function_res = (ref2AncestorFunctionElement) foundElement;
	  return pk_true;
	}
      fatal_named_typeConflict_ln (CString_name, "ancestor function");
    }
  return pk_false;
}

/* PLG 2005-12-12
 * search for a node function declaration named <CString_name> in this_MKFFileContext context
 * success: returns found declaration in <foundElement> 
 * failure: CString_name is not found or
 *     CString_name is found, but is not a node function in this_MKFFileContext context
 *          or a cyclic search has been met
 *          error message is printed
 */
boolean
Context::find_elementFunctionElement (char *CString_name, ref2ElementFunctionElement * function_res)
{
  ref2Element foundElement;
  // log_ASDEBUG("entering Context::find_elementFunctionElement");
  if (find_function (CString_name, &foundElement))
    {
      if (foundElement->isElementFunctionElement ())
	{
	  *function_res = (ref2ElementFunctionElement) foundElement;
	  return pk_true;
	}
      fatal_named_typeConflict_ln (CString_name, "node function");
    }
  else
    ASFatal_missingDecl (pk_true, "node function", CString_name);
  return pk_false;
}

/* ==========  ==========  ==========  ========== TITLE: READING
 */

/* PLG 2009-07-01 OK
 * associates a buffer to file
 * open file fileName 
 * ASSUMES IS_COMPLETED() => this_fileAnalyzer not NIL, open and safe
 * success: FILE = PREFIX . [fileWhite*]# [Any*][EOF]
 * failure: file cannot be open, or error occurred during initial reading
 *             this is set in error
 *             error message has been printed
 */
_PUBLIC_ boolean Context::fileOpen_fWhStar_ (const char *CString_fileName, boolean * isEof)
{
  // logDEBUG_in("Context::fileOpen_fWhStar_");
  // log_ASDEBUG("line is");
  levelInfo_loadAnnounce_ln ();
  if (this_lexicalContext->fileOpen_fWhStar_ (CString_fileName, isEof))
    return pk_true;
  set_fatal ();
  return pk_false;
}

_PUBLIC_ void
Context::closeFileReading ()
{
  lVerboseBackTabulation ();
  if (this_outBuffer != NIL_IntePrinter)
    {
      this_outBuffer->close ();
      delete this_outBuffer;
    }
  this_lexicalContext->closeFileReading ();
}

/* PLG 2009-07-01 OK
 * associates a buffer to stdin
 * ASSUMES IS_COMPLETED() => this_fileAnalyzer not NIL, open and safe
 * success: FILE = . [fileWhite*]# [Any*][eol][^][eol]
 * failure: file cannot be open, or error occurred during initial reading
 *             this is set in error
 *             error message has been printed
 */
_PUBLIC_ boolean Context::stdinOpen_fWhStar_ (char *stdinName, boolean * isEof)
{
  boolean
    lCorrect = pk_true;
  ref2IntePrinter
    outBuffer = new IntePrinter (0, 511, &lCorrect);
  if (lCorrect)
    {
      outBuffer->line ("Reading from stdin; end reading is a line beginning with '^' followed by carriage return");
      if (this_lexicalContext->stdinOpen_fWhStar_ (stdinName, isEof))
	{
	  levelInfo_loadAnnounce_ln ();
	  outBuffer->close ();
	  delete
	    outBuffer;
	  return pk_true;
	}
      outBuffer->line ("Opening stdin failed");
      outBuffer->close ();
      delete
	outBuffer;
    }
  set_fatal ();
  return pk_false;
}

/* ============================== Elementary readings
 */
/* ==================== Elementary steppings
 */

/* ==========----------==========---------- Argument reading 
*/
/* ==========----------========== read string argument
 */

/* ========= ========= ========= =========  ========= ========= READ ARGUMENT
 */
/* ========= ========= ========= READ ARGUMENT 0: parenthesized
 */
/* PLG 2009-09-28
 * success: FILE = PREFIX . [closed_ARGUMENT_LIST][White*] # [Character_but_Space][Any*][EOF]
 *          FILE = PREFIX . [closed_ARGUMENT_LIST] opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
 *          <isEol> is set according to  # position
 * failure: FILE = PREFIX .# [Character_but_Space_but_'('][Any*][EOF] 
 *
 *          FILE = PREFIX . '(' [fileSpace*][ERROR_ARGUMENT_LIST]... # [EOF], reading failed
 *
 *          WELLBALANCED is [Any_but_'}:'_but_'}']* that is well balanced wrt to '(', ')'
 *          FILE = PREFIX . '(' [fileSpace*][ERROR_ARGUMENT_LIST][Character_but_'}:'_but_'}']*  # '}:'[Any*][EOF]
 *            or   PREFIX . '(' [fileSpace*][ERROR_ARGUMENT_LIST][Character_but_'}:'_but_'}']*  # '}'[Any*][EOF]
 *             [Character_but_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>> 
 *          FILE = PREFIX . '(' [fileSpace*][ERROR_ARGUMENT_LIST]WELLBALANCED ')'opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
 *            or   PREFIX . '(' [fileSpace*][ERROR_ARGUMENT_LIST]WELLBALANCED ')'[White*] # [Character_but_Space][Any*][EOF]
 *          error message is printed
 *          <argumentList_res> is assigned NIL
 */
_PUBLIC_ boolean Context::ASRequire_O_freeARGList_C_spStar_ (ref2ArgumentList * argumentList_res, boolean * isEol)
/* PLG 2007-02-07: TODO for each errored argument, set it as empty (list or string) */
{
  // logDEBUG_in("ASRequire_O_freeARGList_C_spStar_");
  // log_ASDEBUG("line is");
  /* FILE = PREFIX . [Character_but_Space][Any*][EOF] */
  if (this_lexicalContext->req_listO_fSpStar_nSp ())
    {
      /* FILE = PREFIX . '(' [fileSpace*] # [Character_but_Space][Any*][EOF] */
      if (starRead_ARGList_fSpStar_nSp (argumentList_res))
	/* FILE = PREFIX . '(' [fileSpace*] opt{[ARGUMENT_LIST][fileSpace*]} # [Character_but_Space][Any*][EOF] */
	return this_lexicalContext->req_listC_spStar_ (isEol);	/* success: FILE = PREFIX . [closed_ARGUMENT_LIST][White*] # [Character_but_Space][Any*][EOF]
								 *          FILE = PREFIX . [closed_ARGUMENT_LIST] opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
								 * failure: FILE = PREFIX . '(' [fileSpace*] opt{[ARGUMENT_LIST][fileSpace*]} ... # [EOF], reading or recovering failed
								 *
								 *          WELLBALANCED is [Any_but_'}:'_but_'}']*  that is well balanced wrt to '(', ')'
								 *          FILE = PREFIX . '(' [fileSpace*] opt{[ARGUMENT_LIST][fileSpace*]} [Character_but_'}:'_but_'}']*  # '}:'[Any*][EOF]
								 *            or   PREFIX . '(' [fileSpace*] opt{[ARGUMENT_LIST][fileSpace*]} [Character_but_'}:'_but_'}']*  # '}'[Any*][EOF]
								 *             [Character_but_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>> 
								 *          FILE = PREFIX . '(' [fileSpace*] opt{[ARGUMENT_LIST][fileSpace*]} WELLBALANCED ')'[White*] # [Character_but_Space][Any*][EOF]
								 *            or   PREFIX . '(' [fileSpace*] opt{[ARGUMENT_LIST][fileSpace*]} WELLBALANCED ')'opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
								 *          error message is printed
								 * <isEol> is set according to  # position
								 */
      /* FILE = PREFIX . '(' [fileSpace*][ERROR_ARGUMENT_LIST] # [Any*][EOF] */
      if (this_lexicalContext->recover_second_spStar_ (isEol));
      /* FILE = PREFIX . '(' [fileSpace*][ERROR_ARGUMENT_LIST] ... # [EOF], reading failed
       * FILE = PREFIX . '(' [fileSpace*][ERROR_ARGUMENT_LIST] WELLBALANCED opt{'('[Any_but_'}:'_but_'}']*} # [EOF], 
       *              [Any_but_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>>
       * WELLBALANCED is [Character_but_'}:'_but_'}']* that is well balanced wrt to '(', ')'
       * 
       * FILE = PREFIX . '(' [fileSpace*][ERROR_ARGUMENT_LIST] [Character_but_'}:'_but_'}']*  # '}:'[Any*][EOF]
       *   or   PREFIX . '(' [fileSpace*][ERROR_ARGUMENT_LIST] [Character_but_'}:'_but_'}']*  # '}'[Any*][EOF]
       *             [Character_but_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>> 
       * FILE = PREFIX . '(' [fileSpace*][ERROR_ARGUMENT_LIST] WELLBALANCED ')'[White*] # [Character_but_Space][Any*][EOF]
       *   or   PREFIX . '(' [fileSpace*][ERROR_ARGUMENT_LIST] WELLBALANCED ')'opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
       * info or error message is printed; 
       * <isEol> is set according to # position  */
      return pk_false;
    }
  (*argumentList_res) = NIL_ArgumentList;
  /*  FILE = PREFIX . ... # [EOF], reading failed
   *   or   PREFIX . '(' [fileSpace*] # [EOF]
   * FILE = PREFIX .# [Character_but_Space_but_'('][Any*][EOF] 
   * error message is printed */
  return pk_false;
}

/*
 * failure: error message is printed
 *          <argumentList_res> is assigned NIL
 */
_PRIVATE_ boolean Context::ASRequire_O_freeARGList_C_spStar_eol_ (ref2ArgumentList * argumentList_res)
/* PLG 2007-02-07: TODO for each errored argument, set it as empty (list or string) */
{
  boolean
    isEol;
  if (ASRequire_O_freeARGList_C_spStar_ (argumentList_res, &isEol))
    {
      /* FILE = PREFIX . [closed_ARGUMENT_LIST] [White*] # [Character_but_Space][Any*][EOF]
       * FILE = PREFIX . [closed_ARGUMENT_LIST] opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
       * <isEol> is set according to  # position
       */
      if (isEol)
	/* FILE = PREFIX . [closed_ARGUMENT_LIST] opt{[lineSpaces]} # opt{[eol][Any*]}[EOF] */
	return this_lexicalContext->load_nl ();
      /* FILE = PREFIX . [closed_ARGUMENT_LIST] [White*] # [Character_but_Space][Any*][EOF] */
      error_newLineExpected ();
    }
  /* failure: error message is printed */
  return pk_false;
}

/* PLG 2009-10-05 REF TODO
 * success: [closed_ARGUMENT_LIST] = '(' [fileSpace*][ARGUMENT_fSpStar]* ')'
 *          FILE = PREFIX . [closed_ARGUMENT_LIST][fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 * failure: FILE = PREFIX .# [Character_but_Space_but_'('][Any*][EOF]
 *               <correct> remains unchanged
 *
 *          WELLBALANCED is [Any_but_'}:'_but_'}']* in which '(', ')' are well balanced
 *          UNRECOVERED is [Any_but_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>>
 *
 *          FILE = PREFIX . '(' ... # [EOF], reading failed
 *            or   PREFIX . '(' ERROR_ARGUMENT_LIST opt{'('UNRECOVERED} # [EOF]
 *               error message is printed
 *               <correct> is set FALSE
 *
 *          FILE = PREFIX . '(' ERROR_closed_ARGUMENT_LIST UNRECOVERED  # '}:'[Any*][EOF]
 *            or   PREFIX . '(' ERROR_closed_ARGUMENT_LIST UNRECOVERED  # '}'[Any*][EOF]
 *            or   PREFIX . '(' ERROR_closed_ARGUMENT_LIST WELLBALANCED ')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *               error message is printed
 *               <correct> is set FALSE
 *
 *          <argumentList_res> is set NIL
 * 
 * <isEof> is set according to # position
 */
_PUBLIC_ boolean Context::AsGetIf_O_freeARGList_C_fSpStar_ (boolean * correct, ref2ArgumentList * argumentList_res, boolean * isEof)
/* PLG 2007-02-07: TODO for each errored argument, set it as empty (list or string) */
{
  // logDEBUG_in("AsGetIf_O_freeARGList_C_fSpStar_ ================================");
  // log_ASDEBUG("line is");
  if (this_lexicalContext->stepIf_listO_fSpStar_nSp (correct))
    {
      /* FILE = PREFIX . '(' [fileSpace*] # [Character_but_Space][Any*][EOF] */
      if (starRead_ARGList_fSpStar_nSp (argumentList_res))
	{
	  /* FILE = PREFIX . '(' [fileSpace*][ARGUMENT_fSpStar]* # [Character_but_Space][Any*][EOF] */
	  if (this_lexicalContext->req_listC_fSpStar_ (isEof))
	    /* FILE = PREFIX . '(' [fileSpace*][ARGUMENT_fSpStar]* ')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
	     * <isEof> is set according to # position */
	    return pk_true;
	  /* WELLBALANCED is [Any_but_'}:'_but_'}']* in which '(', ')' are well balanced
	   *          FILE = PREFIX . '(' [fileSpace*][ARGUMENT_fSpStar]* ... [EOF], reading failed
	   *          FILE = PREFIX . '(' [fileSpace*][ARGUMENT_fSpStar]* WELLBALANCED opt{'('[Any_'}:'_but_'}']*} # [EOF], 
	   *             [Any_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>>
	   *          FILE = PREFIX . '(' [fileSpace*][ARGUMENT_fSpStar]* [Any_but_'}:'_but_'}']*  # '}:'[Any*][EOF]
	   *            or   PREFIX . '(' [fileSpace*][ARGUMENT_fSpStar]* [Any_but_'}:'_but_'}']*  # '}'[Any*][EOF]
	   *             [Any_but_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>> 
	   *          FILE = PREFIX . '(' [fileSpace*][ARGUMENT_fSpStar]* WELLBALANCED ')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
	   *          error message is printed
	   * <isEof> is set according to # position
	   */
	  (*correct) = pk_false;
	  (*argumentList_res) = NIL_ArgumentList;
	  return pk_false;
	}
      /* req_listC_fSpStar_:
       * success: FILE = PREFIX . '(' [fileSpace*][ARGUMENT_fSpStar]* ')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
       * failure: 
       */
      if (this_lexicalContext->recover_second_fSpStar_ (isEof));
      /* FILE = PREFIX . '(' ... # [EOF], reading failed
       * FILE = PREFIX . '(' WELLBALANCED opt{'('[Any_'}:'_but_'}']*} # [EOF]
       *       [Any_but_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>> 
       *
       * WELLBALANCED is [Any_but_'}:'_but_'}']* that is well balanced wrt to '(', ')'
       * FILE = PREFIX . '(' [Any_but_'}:'_but_'}']*  # '}:'[Any*][EOF]
       *   or   PREFIX . '(' [Any_but_'}:'_but_'}']*  # '}'[Any*][EOF]
       *       [Any_but_'}:'_but_'}']* does not match <<WELLBALANCED')'[Any*]>> 
       * FILE = PREFIX . '(' WELLBALANCED ')'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
       * info or error message is printed
       * <isEof> is set according to  # position */
      (*correct) = pk_false;
      (*argumentList_res) = NIL_ArgumentList;
      return pk_false;
    }
  /* failure: FILE = PREFIX .# [Character_but_Space_but_'('][Any*][EOF]
   *            <correct> remains unchanged
   *          FILE = PREFIX . '('[fileSpace*] # [EOF]
   *            <correct> is set FALSE
   *          FILE = PREFIX ... # [EOF], reading failed
   *          or file is closed
   *            error message is printed
   *            <correct> is set FALSE
   *            this is set  ERRORCOMPLETED or ERRORCLOSED */
  (*argumentList_res) = NIL_ArgumentList;
  return pk_false;
}

_PRIVATE_ boolean Context::check_parameterMatching (ref2Identifier anIdentifier, ref2Argument anArgument)
{
  // openDEBUG_in("check_typeMatching");
  // log_ASDEBUG("line is");
  if (anArgument == NIL_Argument)
    return pk_true;
  if (anIdentifier->has_string_type ())
    return anArgument->has_string_type ();
  if (anIdentifier->has_list_type ())
    return anArgument->has_list_type ();
  return pk_false;
}

_PRIVATE_ boolean Context::check_stringParameterMatching (const char *destination, ref2ArgumentList anArgumentList, ref2Argument * anArgument)
{
  // openDEBUG_in("check_stringParameterMatching");
  if (anArgumentList == NIL_ArgumentList)
    {
      error_NIL_argument_ (destination);
      return pk_false;
    }
  if (anArgumentList->is_singleton ())
    {
      (*anArgument) = anArgumentList->content ();
      if ((*anArgument) == NIL_Argument)
	{
	  error_NIL_argument_ (destination);
	  return pk_false;
	}
      if ((*anArgument)->has_string_type ())
	return pk_true;
    }
  error_stringTypeMatching_ (destination);
  return pk_false;
}

/* UNUSED: REQUIRED TO POLYMORPHISM MATCHING
 */
_PRIVATE_ boolean Context::check_parameterListMatching (ref2IdentifierList formalParameterList, ref2ArgumentList argumentList)
{
  // openDEBUG_in("check_parameterMatching");
  // log_ASDEBUG("line is");
  while (formalParameterList != NIL_IdentifierList)
    {
      if (argumentList == NIL_ArgumentList)
	return pk_false;
      if (!check_parameterMatching (formalParameterList->content (), argumentList->content ()))
	return pk_false;
      formalParameterList = formalParameterList->next ();
      argumentList = argumentList->next ();
    }
  return argumentList == NIL_ArgumentList;
}

_PRIVATE_ boolean Context::guarantee_parameterListMatching (char *functionName, ref2IdentifierList formalParameterList, ref2ArgumentList argumentList)
{
  // openDEBUG_in("check_parameterMatching");
  // log_ASDEBUG("line is");
  while (formalParameterList != NIL_IdentifierList)
    {
      if (argumentList == NIL_ArgumentList)
	{
	  error_type_functionCall_ (functionName);
	  return pk_false;
	}
      if (!check_parameterMatching (formalParameterList->content (), argumentList->content ()))
	return pk_false;
      formalParameterList = formalParameterList->next ();
      argumentList = argumentList->next ();
    }
  return argumentList == NIL_ArgumentList;
}

/* ========= ========= ========= READ ARGUMENT 1: CREATE ARGUMENT FUNCTION CALL
 */
_PROTECTED_ _VIRTUAL_ boolean Context::new_StringFunctionCall (ref2ArgumentList actualParameters, ref2StringFunctionCall * functionCall)
{
  boolean
    lCorrect = pk_true;
  (*functionCall) = new StringFunctionCall (this, actualParameters, &lCorrect);
  return lCorrect;
}


_PROTECTED_ boolean Context::create_stringFunctionCall (ref2ArgumentList actualParameters, ref2StringFunctionCall * functionCall)
{
  if (new_StringFunctionCall (actualParameters, functionCall))
    {
      printORlevelInfo_functionCallReading (*functionCall, "string");
      return pk_true;
    }
  (*functionCall) = NIL_StringFunctionCall;
  return pk_false;
}

_PROTECTED_ _VIRTUAL_ boolean Context::new_StringValFunctionCall (ref2Argument actualParameter, ref2StringValFunctionCall * functionCall)
{
  boolean
    lCorrect = pk_true;
  (*functionCall) = new StringValFunctionCall (this, actualParameter, &lCorrect);
  return lCorrect;
}

_PROTECTED_ boolean Context::create_stringValFunctionCall (ref2ArgumentList actualParameters, ref2StringFunctionCall * functionCall)
{
  ref2Argument
    actualParameter;
  if (check_stringParameterMatching ("argument of stringVal function", actualParameters, &actualParameter))
    {
      ref2StringValFunctionCall
	lfunctionCall;
      if (new_StringValFunctionCall (actualParameter, &lfunctionCall))
	{
	  (*functionCall) = lfunctionCall;
	  printORlevelInfo_functionCallReading (lfunctionCall, "stringVal");
	  return pk_true;
	}
    }
  (*functionCall) = NIL_StringFunctionCall;
  return pk_false;
}

_PROTECTED_ _VIRTUAL_ boolean Context::new_HostValFunctionCall (ref2Argument actualParameter, ref2HostValFunctionCall * functionCall)
{
  boolean
    lCorrect = pk_true;
  (*functionCall) = new HostValFunctionCall (this, actualParameter, &lCorrect);
  return lCorrect;
}

_PROTECTED_ boolean Context::create_hostValFunctionCall (ref2ArgumentList actualParameters, ref2StringFunctionCall * functionCall)
{
  ref2Argument
    actualParameter;
  if (check_stringParameterMatching ("argument of hostVal function", actualParameters, &actualParameter))
    {
      ref2HostValFunctionCall
	lfunctionCall;
      if (new_HostValFunctionCall (actualParameter, &lfunctionCall))
	{
	  (*functionCall) = lfunctionCall;
	  printORlevelInfo_functionCallReading (lfunctionCall, "hostVal");
	  return pk_true;
	}
    }
  (*functionCall) = NIL_StringFunctionCall;
  return pk_false;
}

_PROTECTED_
  _VIRTUAL_ boolean Context::new_UserStringFunctionCall (char *functionName, ref2UserStringFunctionElement linkedFunction,
							 ref2ArgumentList actualParameters, ref2UserStringFunctionCall * functionCall)
{
  boolean
    lCorrect = pk_true;
  (*functionCall) = new UserStringFunctionCall (this, functionName, linkedFunction, actualParameters, &lCorrect);
  return lCorrect;
}

_PROTECTED_
  boolean Context::create_userStringFunctionCall (char *functionName, ref2UserStringFunctionElement linkedFunction, ref2Context readingContext,
						  ref2ArgumentList actualParameters, ref2StringFunctionCall * functionCall)
{
  if (readingContext->guarantee_parameterListMatching (functionName, linkedFunction->getFormalParameters (), actualParameters))
    {
      ref2UserStringFunctionCall
	lfunctionCall;
      if (new_UserStringFunctionCall (functionName, linkedFunction, actualParameters, &lfunctionCall))
	{
	  (*functionCall) = lfunctionCall;
	  printORlevelInfo_functionCallReading (lfunctionCall, functionName);
	  return pk_true;
	}
    }
  (*functionCall) = NIL_StringFunctionCall;
  return pk_false;
}

_PROTECTED_ _VIRTUAL_ boolean Context::new_ListFunctionCall (ref2ArgumentList actualParameters, ref2ListFunctionCall * functionCall)
{
  boolean
    lCorrect = pk_true;
  (*functionCall) = new ListFunctionCall (this, actualParameters, &lCorrect);
  return lCorrect;
}

_PROTECTED_ boolean Context::create_listFunctionCall (ref2ArgumentList actualParameters, ref2ListFunctionCall * functionCall)
{
  if (new_ListFunctionCall (actualParameters, functionCall))
    {
      printORlevelInfo_functionCallReading (*functionCall, "list");
      return pk_true;
    }
  return pk_false;
}

_PROTECTED_ _VIRTUAL_ boolean Context::new_ListValFunctionCall (ref2Argument actualParameters, ref2ListValFunctionCall * functionCall)
{
  // logDEBUG_in("new_UserListFunctionCall");
  boolean
    lCorrect = pk_true;
  (*functionCall) = new ListValFunctionCall (this, actualParameters, &lCorrect);
  return lCorrect;
}

_PROTECTED_ boolean Context::create_listValFunctionCall (ref2ArgumentList actualParameters, ref2ListFunctionCall * functionCall)
{
  ref2Argument
    actualParameter;
  if (check_stringParameterMatching ("argument of listVal function", actualParameters, &actualParameter))
    {
      ref2ListValFunctionCall
	lfunctionCall;
      if (new_ListValFunctionCall (actualParameter, &lfunctionCall))
	{
	  (*functionCall) = lfunctionCall;
	  printORlevelInfo_functionCallReading (lfunctionCall, "listVal");
	  return pk_true;
	}
    }
  (*functionCall) = NIL_ListFunctionCall;
  return pk_false;
}

_PROTECTED_
  _VIRTUAL_ boolean Context::new_UserListFunctionCall (char *functionName, ref2UserListFunctionElement linkedFunction,
						       ref2ArgumentList actualParameters, ref2UserListFunctionCall * functionCall)
{
  boolean
    lCorrect = pk_true;
  (*functionCall) = new UserListFunctionCall (this, functionName, linkedFunction, actualParameters, &lCorrect);
  return lCorrect;
}

_PROTECTED_
  boolean Context::create_userListFunctionCall (char *functionName, ref2UserListFunctionElement linkedFunction, ref2Context readingContext,
						ref2ArgumentList actualParameters, ref2ListFunctionCall * functionCall)
{
  if (readingContext->guarantee_parameterListMatching (functionName, linkedFunction->getFormalParameters (), actualParameters))
    {
      ref2UserListFunctionCall
	lfunctionCall;
      if (new_UserListFunctionCall (functionName, linkedFunction, actualParameters, &lfunctionCall))
	{
	  (*functionCall) = lfunctionCall;
	  printORlevelInfo_functionCallReading (lfunctionCall, functionName);
	  return pk_true;
	}
    }
  (*functionCall) = NIL_ListFunctionCall;
  return pk_false;
}

_PROTECTED_
  boolean Context::findCreate_userListFunctionCall (char *functionName, ref2Context readingContext,
						    ref2ArgumentList actualParameters, ref2ListFunctionCall * functionCall)
{
  ref2Element
    foundElement;
  if (find_function (functionName, &foundElement))
    {
      if (foundElement->isUserListFunctionElement ())
	{
	  return create_userListFunctionCall (functionName, (ref2UserListFunctionElement) foundElement, readingContext, actualParameters,
					      functionCall);
	}
      fatal_named_typeConflict_ln (functionName, "list function");
    }
  (*functionCall) = NIL_ListFunctionCall;
  return pk_false;
}

/* 2004-12-27
 * success: <commandCode> is stringCODE, stringvalCODE, hostvalCODE, listCODE, or listvalCODE
 *          returns a function call to 'string' 'stringval' 'hostval' 'list' 'listval'
 * failure: <commandCode> does not belong to stringCODE, stringvalCODE, hostvalCODE, listCODE, listvalCODE 
 *          returns NIL
 * <isEol> is set according to finla cursor position
 */
_PROTECTED_
  boolean Context::create_stdArgumentFunctionCall (boolean isIterated, int commandCode, ref2ArgumentList actualParameters,
						   ref2Argument * argument_res, boolean * isList)
{
  // logDEBUG_in("create_stdArgumentFunctionCall");
  switch (commandCode)
    {
    case stringCODE:
      {
	ref2StringFunctionCall
	  functionCall;
	(*isList) = pk_false;
	if (create_stringFunctionCall (actualParameters, &functionCall))
	  return getExpandedIfStatic (functionCall, pk_false, argument_res, isIterated);
	set_fatal ();
	(*argument_res) = NIL_Argument;
	return pk_false;
      }
    case stringvalCODE:
      {
	ref2StringFunctionCall
	  functionCall;
	(*isList) = pk_false;
	if (create_stringValFunctionCall (actualParameters, &functionCall))
	  return getExpandedIfStatic (functionCall, pk_false, argument_res, isIterated);
	set_fatal ();
	(*argument_res) = NIL_Argument;
	return pk_false;
      }
    case hostvalCODE:
      {
	ref2StringFunctionCall
	  functionCall;
	(*isList) = pk_false;
	if (create_hostValFunctionCall (actualParameters, &functionCall))
	  return getExpandedIfStatic (functionCall, pk_false, argument_res, isIterated);
	set_fatal ();
	(*argument_res) = NIL_Argument;
	return pk_false;
      }
    case listCODE:
      {
	ref2ListFunctionCall
	  functionCall;
	(*isList) = pk_true;
	if (create_listFunctionCall (actualParameters, &functionCall))
	  return getExpandedIfStatic (functionCall, pk_true, argument_res, isIterated);
	set_fatal ();
	(*argument_res) = NIL_Argument;
	return pk_false;
      }
    case listvalCODE:
      {
	ref2ListFunctionCall
	  functionCall;
	(*isList) = pk_true;
	if (create_listValFunctionCall (actualParameters, &functionCall))
	  return getExpandedIfStatic (functionCall, pk_true, argument_res, isIterated);
	set_fatal ();
	(*argument_res) = NIL_Argument;
	return pk_false;
      }
    default:
      this_lexicalContext->ASFatal_named_typeConflict_ln ("argument function");
    }
  (*argument_res) = NIL_Argument;
  return pk_false;
}

/* 2007-02-07
 * string call is not iterated 
 * success: <commandCode> is stringCODE, stringvalCODE, hostvalCODE or userCODE
 *          [closed_ARGUMENT_LIST] = '(' [fileSpace*][ARGUMENT_fSpStar]* ')'
 *          FILE = PREFIX . [closed_ARGUMENT_LIST][lineSpaces][Character_but_Space][Any*][EOF]
 *             <isEol> is set to false
 *          FILE = PREFIX . [closed_ARGUMENT_LIST][lineSpaces][eol][Any*][EOF]
 *             <isEol> is set to pk_true
 *          cursor is moved to final [Character_but_Space]
 *          <correct> remains unchanged
 *          returns a function call to 'string' 'stringval' 'hostval' or to a user defined string function
 * failure: fatal: <commandCode> does not belong to stringCODE, stringvalCODE, hostvalCODE or userCODE
 *          inaccurate function call is read
 *             error message is printed
 *          <correct> is set to false
 *          cursor is moved to errored position
 *          returns NIL
 * <isEol> is set according to final cursor position
 */
/* PLG 2008-06-06 functionName added, done in occurrences*/
_PRIVATE_
  boolean Context::read_string_call_argList_spStar_ (int commandCode, char *functionName, ref2StringFunctionCall * functionCall, boolean * isEol,
						     ref2Argument * argument_res)
{
  // log_ASDEBUG("Context::read_string_call_argList_spStar_");
  ref2ArgumentList
    actualParameters;
  ref2Context
    readingContext = new DynamicContext ((ref2Context) this);	/* to avoid parameter inner call being iterated */
  if (readingContext->ASRequire_O_freeARGList_C_spStar_ (&actualParameters, isEol))
    {
      if (commandCode == userCODE)
	{
	  ref2Element
	    foundElement;
	  if (find_function (functionName, &foundElement))
	    {
	      if (foundElement->isUserStringFunctionElement ())
		{
		  if (create_userStringFunctionCall
		      (functionName, (ref2UserStringFunctionElement) foundElement, readingContext, actualParameters, functionCall))
		    return getExpandedIfStatic (*functionCall, pk_false, argument_res, pk_false);
		  return pk_false;
		}
	      this_lexicalContext->ASFatal_named_typeConflict_ln (functionName, "string function");
	    }
	  ASFatal_missingDecl (pk_false, functionName, "string function");
	  (*functionCall) = NIL_StringFunctionCall;
	  return pk_false;
	}
      switch (commandCode)
	{
	case stringCODE:
	  if (create_stringFunctionCall (actualParameters, functionCall))
	    return getExpandedIfStatic (*functionCall, pk_false, argument_res, pk_false);	/* OK */
	  return pk_false;
	case stringvalCODE:
	  if (create_stringValFunctionCall (actualParameters, functionCall))
	    return getExpandedIfStatic (*functionCall, pk_false, argument_res, pk_false);	/* OK */
	  return pk_false;
	case hostvalCODE:
	  if (create_hostValFunctionCall (actualParameters, functionCall))
	    return getExpandedIfStatic (*functionCall, pk_false, argument_res, pk_false);	/* OK */
	  return pk_false;
	default:
	  this_lexicalContext->ASFatal_named_typeConflict_ln ("string function");
	}
    }
  (*functionCall) = NIL_StringFunctionCall;
  return pk_false;
}

/* 2007-02-07
 * string call is not iterated 
 * success: <commandCode> is stringCODE, stringvalCODE, hostvalCODE or userCODE
 *          [closed_ARGUMENT_LIST] = '(' [fileSpace*][ARGUMENT_fSpStar]* ')'
 *          FILE = PREFIX . [closed_ARGUMENT_LIST][fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
 *          <correct> remains unchanged
 *          returns a function call to 'string' 'stringval' 'hostval' or to a user defined string function
 * failure: fatal: <commandCode> does not belong to stringCODE, stringvalCODE, hostvalCODE or userCODE
 *          inaccurate function call is read
 *             error message is printed
 *          <correct> is set to false
 *          cursor is moved to errored position
 *          returns NIL
 * <isEol> is set according to finla cursor position
 */
/* PLG 2008-06-06 functionName added, done in occurrences*/
_PROTECTED_
  boolean Context::read_string_call_argList_fSpStar_ (int commandCode, char *functionName, ref2StringFunctionCall * functionCall, boolean * isEof,
						      ref2Argument * argument_res)
{
  // log_ASDEBUG("Context::read_string_call_argList_fSpStar_");
  boolean
    isEol;
  if (read_string_call_argList_spStar_ (commandCode, functionName, functionCall, &isEol, argument_res))
    {
      if (isEol)
	return this_lexicalContext->step_nl_fSpStar_ (isEof);	/* success: FILE = PREFIX . [Character*][eol] [fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
								 *             if [EOF] is reached, <isEof> is set TRUE and this is set COMPLETED
								 * failure: FILE = PREFIX . [Character*] # [EOF]
								 *             this is set XXXCOMPLETED
								 *             <isEof> is set TRUE
								 *          error message is printed, this is set ERRORXXX */
      return pk_true;
    }
  set_fatal ();
  return pk_false;
}

/* 2004-12-01
 * reads a new allocated named string argument 
 * success: cursor starts [Identifier] [fileSpace*_nSp] 
 *          cursor is moved to end of [fileSpace*_nSp]
 *          returns in <res> a new argument containing a new m'allocated copy of this identifier
 *          <correct> remains unchanged
 *          FILE current atom is set to empty
 * failure: returns NIL_Argument in <res> 
 *          reference to missing identifier declaration is read
 *              error message is printed
 *              <correct> is set to false
 *          cursor starts [Identifier] [fileSpace*] [EOF]
 *              error message is printed
 *              <correct> is set to false
 *          next character does not begin an identifier reference
 *              current character,  <correct> remain unchanged
 */
_VIRTUAL_ boolean
Context::idVal_readIf_stringIdentifier_fSpStar_nSp (boolean * correct, ref2Argument * argument_res)
{
  // log_ASDEBUG("Context::idVal_readIf_stringIdentifier_fSpStar_nSp");
  // logDEBUG_in("idVal_readIf_stringIdentifier_fSpStar_nSp");
  char *CString_name;
  if (readIf_varIdentification_fSpStar_nSp (correct, &CString_name))
    {
      /* CString_name is a (not empty) user identifier */
      if (get_string_id_ (CString_name, argument_res))
	return pk_true;
      (*correct) = pk_false;
    }
  (*argument_res) = NIL_Argument;
  return pk_false;
}

/* 2004-12-29
 * reads from FILE and returns in <argument_res> a new allocated string argument
 * expand static string
 * success: cursor starts [string_ARGUMENT] [fileSpace*] [Character_but_Space]
 *             where 
 *                [string_ARGUMENT] ::= <this_stringTag> [Character*] <this_stringTag> 
 *                [string_ARGUMENT] ::= <this_stringTag> [parameterized_string] <this_stringTag> 
 *                [string_ARGUMENT] ::= [Identifier]
 *                		  where  [Identifier] type is string
 *                [string_ARGUMENT] ::= [StringFunction_CALL]
 *          cursor is moved to final [Character_but_Space]
 *          <argument_res> is set to a new Argument containing the read [string_ARGUMENT]
 * failure: inaccurate string, identifier or function call is read
 *          or a correct string or identifier is read but reading does not terminate on not space not comment char
 *          next character does not begin a string value, an identifier or a string function call
 *          <argument_res> remains unchanged
 *          error message is printed
 * USED IN ArgumentElement::
 * USED IN Context::
 * USED IN UserStringFunctionElement::
 * PLG verifier si en utilisation erreur ne provoque pas core dump
 * PLG USED IN FREE POSITION: checked 2007-04-17
 */
_PUBLIC_ boolean Context::read_string_fSpStar_nSp (ref2Argument * argument_res)
{
  // logDEBUG_in("read_string_fSpStar_nSp");
  int
    commandCode;
  boolean
    lCorrect = pk_true;
  char *
    functionName;
  if (this_lexicalContext->stepIf_stringCallHead_fSpStar_nSp (&commandCode, &functionName))
    {
      ref2StringFunctionCall
	functionCall;
      boolean
	isEof = pk_false;
      if (read_string_call_argList_fSpStar_ (commandCode, functionName, &functionCall, &isEof, argument_res))
	{
	  if (isEof)
	    {
	      this_lexicalContext->ASFatal_eof ();
	      return pk_false;
	    }
	  return pk_true;
	}
      /* failure: error message is printed */
      set_fatal ();
      return pk_false;
    }
  if (commandCode == errorCODE)
    {
      set_fatal ();
      return pk_false;
    }
  if (idVal_readIf_stringIdentifier_fSpStar_nSp (&lCorrect, argument_res))
    return pk_true;
  if (lCorrect)
    {
      char *
	strRes;
      boolean
	isEof = pk_false;
      if (this_lexicalContext->stepIf_stringConstant_fSpStar_ (&lCorrect, &strRes, &isEof))
	{
	  if (isEof)
	    {
	      this_lexicalContext->ASFatal_eof ();
	      return pk_false;
	    }
	  /* <this_stringChar> does not occur in [Character*] 
	   *          FILE = PREFIX . <this_stringChar>[Character*]<this_stringChar>[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
	   *          <isEof> is set according to final position
	   *          a new fresh copy of [Character*] is returned in <strRes>
	   *          <lCorrect> remains unchanged
	   */
	  (*argument_res) = new StringArgument (strRes);
	  return pk_true;
	}
      if (lCorrect)
	{
	  /* FILE = PREFIX .# opt{[Any_but_<this_stringChar>][Any*]}[EOF], isEof is set TRUE if [EOF] is reached */
	  ASFatal_expected ("string argument");
	  return pk_false;
	}
      /* FILE = PREFIX . <this_stringChar> # [Character*]opt{[eol][Any*]}[EOF] , <this_stringChar> does not occur in [Character*]
       * FILE = PREFIX . <this_stringChar>[Character*]<this_stringChar> opt{[lineSpaces]} ... [EOF], reading failed
       * FILE = PREFIX . <this_stringChar>[Character*]<this_stringChar>[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF], some memory error occurred
       * <isEof> is set TRUE if [EOF] is reached
       * error message is printed */
      set_fatal ();
    }
  return pk_false;
}


/* ========= ========= ========= READ ARGUMENT 2: read_list_fSpStar_nSp
 */
/* PLG 2007-04-18, PLG 2007-06-25, PLG 2009-09-09 REF TODO
 *   it is the list of formal parameters to which actual parameters have to be associated
 * success: FILE = PREFIX . [ARGUMENT_fSpStar]* # [Character_but_Space][Any*][EOF], [Character_but_Space][Any*][EOF] is not prefixed by an [ARGUMENT]
 *          <argumentList_res> is assigned the list of linked values
 *          <correct> remains unchanged
 * failure: syntax or linking error 
 *             <correct> is set to false
 *             error message is printed
 *          <argumentList_res> is assigned NIL
 */
_PRIVATE_ boolean Context::starRead_ARGList_fSpStar_nSp (ref2ArgumentList * argumentList_res)
{
  // openDEBUG_in("starRead_ARGList_fSpStar_nSp");
  // log_ASDEBUG("line is");
  boolean
    lCorrect = pk_true;
  ref2Argument
    current_arg;
  if (readIf_argument_fSpStar_nSp (&lCorrect, &current_arg))
    {
      // logDEBUG_in("starRead_ARGList_fSpStar_nSp first argument read");
      ref2ArgumentList
	tailArgList;
      if (starRead_ARGList_fSpStar_nSp (&tailArgList))
	{
	  (*argumentList_res) = new ArgumentList (current_arg, tailArgList);
	  // closeDEBUG_in("starRead_ARGList_fSpStar_nSp SUCCESS");
	  return pk_true;
	}
      // closeDEBUG_in("starRead_ARGList_fSpStar_nSp FAILURE");
      (*argumentList_res) = NIL_ArgumentList;
      return pk_false;
    }
  (*argumentList_res) = NIL_ArgumentList;
  // closeDEBUG_in("starRead_ARGList_fSpStar_nSp", lCorrect);
  return lCorrect;
}

/* ========= ========= ========= READ ARGUMENT: read_list_fSpStar_nSp
 */
_PRIVATE_
  boolean Context::findCreate_userArgumentFunctionCall (char *functionName, ref2Context readingContext,
							ref2ArgumentList actualParameters, ref2Argument * argument_res, boolean * isList)
{
  ref2FunctionElement
    linkedFunction;
  if (find_argumentFunctionElement (functionName, &linkedFunction, isList))
    {
      /* on correct pk_true after calling next functions: cursor starts not space; expected #'}:' */
      if (*isList)
	{
	  ref2ListFunctionCall
	    functionCall;
	  if (create_userListFunctionCall
	      (functionName, (ref2UserListFunctionElement) linkedFunction, readingContext, actualParameters, &functionCall))
	    {
	      return getExpandedIfStatic (functionCall, pk_true, argument_res, pk_false);	/* OK */
	    }
	}
      else
	{
	  ref2StringFunctionCall
	    functionCall;
	  if (create_userStringFunctionCall
	      (functionName, (ref2UserStringFunctionElement) linkedFunction, readingContext, actualParameters, &functionCall))
	    {
	      return getExpandedIfStatic (functionCall, pk_false, argument_res, pk_false);	/* OK */
	    }
	}
    }
  (*argument_res) = NIL_Argument;
  return pk_false;
}

_PRIVATE_ boolean Context::read_arg_fSpStar_nSp (ref2Identifier currentIdentifier, ref2Argument * current_arg)
{
  // openDEBUG_in("read_arg_fSpStar_nSp");
  // log_ASDEBUG("line is");
  if (currentIdentifier->has_string_type ())
    return read_string_fSpStar_nSp (current_arg);
  if (currentIdentifier->has_list_type ())
    return read_list_fSpStar_nSp (current_arg);
  return pk_false;
}

/* 2005-03-22 
 * <formalParameterList> is not empty (not checked) 
 *   it is the list of formal parameters to which actual parameters have to be associated
 * success: cursor starts [ARGUMENT+] [fileSpace*] ')' [lineSpaces]
 *          cursor is moved to end of [lineSpaces]
 *          returns in <argumentList_res> the list of linked values
 *                 links context variable, parameter and function declarations in read strings
 * failure: syntax or linking error 
 *          error message is printed
 *          from syntax error
 *              cursor starts [Any*] ')' [lineSpaces], '{', '}', '(', ')' are well balanced in [Any*] 
 *                 cursor is moved to end of [lineSpaces]
 *              cursor starts [Any*] '}' , '{', '}', '(', ')' are well balanced in [Any*] 
 *                 cursor is moved to '}' 
 *              cursor starts [Any*] [EOF] , there are more opening than closing tags in [Any*] 
 *                 cursor is moved to [EOF]
 *          returns in <argumentList_res> NIL_ArgumentList
 *          recover argument list closing
 */
_PRIVATE_ boolean Context::plusRead_ARGList_fSpStar_nSp (ref2IdentifierList formalParameterList, ref2ArgumentList * argumentList_res)
{
  // openDEBUG_in("plusRead_ARGList_fSpStar_nSp 0");
  // log_ASDEBUG("line is");
  ref2Argument
    current_arg;
  ref2Identifier
    currentIdentifier = (ref2Identifier) (formalParameterList->content ());
  if (read_arg_fSpStar_nSp (currentIdentifier, &current_arg))
    {
      ref2ArgumentList
	tailArgList;
      formalParameterList = formalParameterList->next ();
      if (formalParameterList == NIL_IdentifierList)
	{
	  (*argumentList_res) = new ArgumentList (current_arg);
	  // closeDEBUG_in("plusRead_ARGList_fSpStar_nSp 0: on NIL cdr");
	  return pk_true;
	}
      if (plusRead_ARGList_fSpStar_nSp (formalParameterList, &tailArgList))
	{			/*failure: recover argument list closing */
	  (*argumentList_res) = new ArgumentList (current_arg, tailArgList);
	  // closeDEBUG_in("plusRead_ARGList_fSpStar_nSp 0: on not NIL cdr");
	  return pk_true;
	}
    }
  return pk_false;
}

_PRIVATE_ boolean Context::new_iteratorContext_nSp (ref2IteratorContext * iteratorContext_res)
{
  // logDEBUG_in("new_iteratorContext_nSp");
  (*iteratorContext_res) = new IteratorContext (this);
  if ((*iteratorContext_res)->read_dynamicContext_fSpStar_nSp ())
    return pk_true;
  (*iteratorContext_res)->set_fatal ();
  return pk_false;
}

_PRIVATE_ boolean Context::read_list_inNewIteratorContext_spStar_ (ref2Argument * argument_res, boolean * isEol)
{
  // log_ASDEBUG("entering Context::read_list_inNewIteratorContext_spStar_");
  ref2IteratorContext
    innerContext;
  if (new_iteratorContext_nSp (&innerContext))
    {
      int
	commandCode;
      char *
	functionName;
      if (this_lexicalContext->stepIf_argumentCallHead_fSpStar_nSp (&commandCode, &functionName))
	{
	  /* <commandCode> in  { userCODE, stringCODE, stringvalCODE, hostvalCODE, iterateCODE, listCODE, listvalCODE } */
	  return innerContext->read_list_iteratedCall_argList_spStar_ (commandCode, functionName, argument_res, isEol);
	}
    }
  set_fatal ();
  return pk_false;
}

/* 2004-12-27
 * success: FILE = PREFIX . [ListFunction_CALL] [fileSpace*] # [Character_but_Space][Any*][EOF]
 *          where 
 *             [ListFunction_CALL] ::= <commandChar> 'list' [fileSpace*] [ARGUMENT_LIST]
 *             [ListFunction_CALL] ::= <commandChar> [userIdentifier] [fileSpace*] [ARGUMENT_LIST]
 *             		       where [userIdentifier] denotes a list function
 *          <correct> remains unchanged
 *          <argument_res> is set to a new command argument containing the function call
 * failure: 1- FILE = PREFIX .# [Character*] [eoX], [Character*] [eoX] does not start with [ListFunction_CALL] 
 *              <correct> remain unchanged
 *          2-FILE = PREFIX . [ListFunction_CALL] [fileSpace*] # [EOF]
 *            or inaccurate function call is read
 *             error message is printed
 *              <correct> is set to false
 */
_PRIVATE_ boolean Context::readIf_list_CALL_fSpStar_ (boolean * correct, ref2Argument * argument_res, boolean * isEof)
{
  int
    commandCode;
  char *
    functionName;
  // log_ASDEBUG("entering Context::readIf_list_CALL_fSpStar_");
  if (this_lexicalContext->stepIf_listCallHead_fSpStar_nSp (&commandCode, &functionName))
    {
      /* commandCode in userCODE , iterateCODE, listCODE, listvalCODE */
      boolean
	isEol;
      if (commandCode == iterateCODE)
	{
	  if (read_list_inNewIteratorContext_spStar_ (argument_res, &isEol))
	    {
	      if (isEol)
		{
		  if (this_lexicalContext->step_nl_fSpStar_ (isEof))
		    /* success: FILE = PREFIX . [Character*][eol] [fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
		     *             if [EOF] is reached, <isEof> is set TRUE and this is set COMPLETED */
		    return pk_true;
		  /* failure: FILE = PREFIX . [Character*] # [EOF]
		   *             this is set XXXCOMPLETED
		   *             <isEof> is set TRUE
		   *          error message is printed, this is set ERRORXXX */
		  (*correct) = pk_false;
		  return pk_false;
		}
	      return pk_true;
	    }
	  (*correct) = pk_false;
	  return pk_false;
	}
      else
	{
	  ref2ListFunctionCall
	    functionCall;
	  ref2ArgumentList
	    actualParameters;
	  boolean
	    isList;
	  ref2Context
	    readingContext = new DynamicContext ((ref2Context) this);	/* to avoid parameter inner call being iterated */
	  if (readingContext->ASRequire_O_freeARGList_C_spStar_ (&actualParameters, &isEol))
	    {
	      if (isEol)
		if (!this_lexicalContext->step_nl_fSpStar_ (isEof))
		  {
		    (*correct) = pk_false;
		    return pk_false;
		  }
	      if (commandCode == userCODE)
		{
		  ref2Element
		    foundElement;
		  if (find_function (functionName, &foundElement))
		    {
		      if (foundElement->isUserListFunctionElement ())
			{
			  if (create_userListFunctionCall
			      (functionName, (ref2UserListFunctionElement) foundElement, readingContext, actualParameters, &functionCall))
			    return getExpandedIfStatic (functionCall, pk_true, argument_res, pk_false);
			  (*correct) = pk_false;
			  return pk_false;
			}
		      fatal_named_typeConflict_ln (functionName, "list function");
		    }
		  (*correct) = pk_false;
		  return pk_false;
		}
	      if (create_stdArgumentFunctionCall (pk_false, commandCode, actualParameters, argument_res, &isList))
		{
		  if (isList)
		    return pk_true;
		  ASFatal_unexpected (pk_true, "list function");
		}
	    }
	}
      set_fatal ();
      (*correct) = pk_false;
      return pk_false;
    }
  if (commandCode == errorCODE)
    (*correct) = pk_false;
  return pk_false;
}

/* 2004-12-01
 * reads a new allocated named list argument 
 * success: cursor starts [Identifier] [fileSpace*_nSp] 
 *          cursor is moved to end of [fileSpace*_nSp]
 *          returns in <res> a new argument containing a new m'allocated copy of this identifier
 *          <correct> remains unchanged
 *          FILE current atom is set to empty
 * failure: returns NIL_Argument in <res> 
 *          reference to missing identifier declaration is read
 *              error message is printed
 *              <correct> is set to false
 *          cursor starts [Identifier] [fileSpace*] [EOF]
 *              error message is printed
 *              <correct> is set to false
 *          next character does not begin an identifier reference
 *              current character,  <correct> remain unchanged
 */
_PROTECTED_ _VIRTUAL_ boolean Context::idVal_readIf_listIdentifier_fSpStar_ (boolean * correct, ref2Argument * argument_res, boolean * isEof)
{
  // log_ASDEBUG("Context::idVal_readIf_listIdentifier_fSpStar_");
  char *
    CString_name;
  if (readIf_varIdentification_fSpStar_nSp (correct, &CString_name))
    {
      /* CString_name is a (not empty) user identifier */
      boolean
	lCorrect = pk_true;
      if (getIf_list_id_ (CString_name, &lCorrect, argument_res))
	return pk_true;
      ASFatal_missingDecl (lCorrect, "list identifier", CString_name);
      (*correct) = pk_false;
    }
  (*argument_res) = NIL_Argument;
  return pk_false;
}

/* 2004-12-29
 * reads from FILE and returns in <argument_res> a new allocated list argument
 * expand static string elements
 * success: FILE = PREFIX . [list_ARGUMENT] [fileSpace*] # [Character_but_Space][Any*][EOF]
 *             where 
 *                [list_ARGUMENT] ::= [Identifier]
 *                		  where  [Identifier] type is list
 *                [list_ARGUMENT] ::= [ITERATOR] [fileSpace*] [StringFunction_CALL]
 *                [list_ARGUMENT] ::= [ListFunction_CALL]
 *                [list_ARGUMENT] ::= [ARGUMENT_LIST] 
 *          <argument_res> is set to a new Argument containing the read [list_ARGUMENT]
 * failure: 1- FILE = PREFIX .# [Character*] [eoX], [Character*] [eoX] does not start with [list_ARGUMENT] 
 *              <correct> remain unchanged
 *          2-FILE = PREFIX . [list_ARGUMENT] [fileSpace*] # [EOF]
 *          3- other reading errors
 *             error message is printed
 *          <argument_res> is assigned NIL
 */
_PUBLIC_ boolean Context::read_list_fSpStar_ (ref2Argument * argument_res, boolean * isEof)
{
  // log_ASDEBUG("entering Context::read_list_fSpStar_");
  boolean
    lCorrect = pk_true;
  if (readIf_list_CALL_fSpStar_ (&lCorrect, argument_res, isEof))
    return pk_true;
  if (lCorrect)
    {
      if (idVal_readIf_listIdentifier_fSpStar_ (&lCorrect, argument_res, isEof))
	return pk_true;
      if (lCorrect)
	{
	  ref2ArgumentList
	    argumentList_res;
	  if (AsGetIf_O_freeARGList_C_fSpStar_ (&lCorrect, &argumentList_res, isEof))
	    {
	      (*argument_res) = (ref2Argument) argumentList_res;
	      return pk_true;
	    }
	  if (lCorrect)
	    this_lexicalContext->ASFatal_list_argument (pk_true);
	  (*argument_res) = NIL_Argument;
	  return pk_false;
	}
      this_lexicalContext->ASFatal_list_argument (pk_true);
    }
  (*argument_res) = NIL_Argument;
  return pk_false;
}

_PUBLIC_ boolean Context::read_list_fSpStar_nSp (ref2Argument * argument_res)
{
  // log_ASDEBUG("entering Context::read_list_fSpStar_nSp");
  boolean
    isEof = pk_false;
  if (read_list_fSpStar_ (argument_res, &isEof))
    {
      if (isEof)
	{
	  this_lexicalContext->ASFatal_eof ();
	  return pk_false;
	}
      return pk_true;
    }
  return pk_false;
}

/* ========= ========= ========= READ ARGUMENT 3: readIf_argument_fSpStar_nSp
 */

/* 2004-12-27
 * success: cursor starts [ArgumentFunction_CALL] [lineSpaces]
 *          where 
 *             [ArgumentFunction_CALL] ::= [StringFunction_CALL] + [ListFunction_CALL]
 *             [StringFunction_CALL] ::= <commandChar> 'string' [fileSpace*] [ARGUMENT_LIST]
 *             [StringFunction_CALL] ::= <commandChar> [userIdentifier] [fileSpace*] [ARGUMENT_LIST]
 *             		       where [userIdentifier] denotes a string function,
 *                                     actual argument types and formal argument types must fit
 *             [ListFunction_CALL] ::= [ITERATOR_fSp] [StringFunction_CALL]
 *             [ListFunction_CALL] ::= <commandChar> 'list' [fileSpace*] [ARGUMENT_LIST]
 *             [ListFunction_CALL] ::= <commandChar> [userIdentifier] [fileSpace*] [ARGUMENT_LIST]
 *             		       where [userIdentifier] denotes a list function
 *          cursor is moved to end of [lineSpaces]
 *          <correct> remains unchanged
 *          <argument_res> is set to a new command argument containing the function call
 *          <isEol> si set according to new cursor position
 * failure: inaccurate function call is read
 *             error message is printed
 *             <correct> is set to false
 *          next character does not begin a string or list function call
 *             cursor, <correct> remain unchanged
 *          <argument_res> remains unchanged
 *          returns false 
 */
_PROTECTED_ boolean Context::readIf_argument_call_argList_spStar_ (boolean * correct, ref2Argument * argument_res, boolean * isEol, boolean * isList)
{
  int
    commandCode;
  char *
    functionName;
  // log_ASDEBUG("Context::readIf_argument_call_argList_spStar_");
  if (this_lexicalContext->stepIf_argumentCallHead_fSpStar_nSp (&commandCode, &functionName))
    {
      /* commandCode belongs to userCODE, iterateCODE, stringCODE, stringvalCODE, hostvalCODE, listCODE, listvalCODE */
      if (commandCode == iterateCODE)
	{
	  (*isList) = pk_true;
	  if (read_list_inNewIteratorContext_spStar_ (argument_res, isEol))
	    return pk_true;
	  (*correct) = pk_false;
	  return pk_false;
	}
      else
	{
	  ref2ArgumentList
	    actualParameters;
	  ref2Context
	    readingContext = new DynamicContext ((ref2Context) this);	/* to avoid parameter inner call being iterated */
	  if (readingContext->ASRequire_O_freeARGList_C_spStar_ (&actualParameters, isEol))
	    {
	      if (commandCode == userCODE)
		return findCreate_userArgumentFunctionCall (functionName, readingContext, actualParameters, argument_res, isList);
	      return create_stdArgumentFunctionCall (pk_false, commandCode, actualParameters, argument_res, isList);
	    }
	  (*correct) = pk_false;
	  return pk_false;
	}
    }
  if (commandCode == errorCODE)
    (*correct) = pk_false;
  /* else commandCode is notACommandCODE */
  return pk_false;
}

/* 2004-12-01
 * reads a new allocated named argument 
 * success: cursor starts [Identifier] [fileSpace*_nSp] 
 *          cursor is moved to end of [fileSpace*_nSp]
 *          returns in <res> a new argument containing a new m'allocated copy of this identifier
 *          <correct> remains unchanged
 *          FILE current atom is set to empty
 * failure: returns NIL_Argument in <res> 
 *          reference to missing identifier declaration is read
 *              error message is printed
 *              <correct> is set to false
 *          cursor starts [Identifier] [fileSpace*] [EOF]
 *              error message is printed
 *              <correct> is set to false
 *          next character does not begin an identifier reference
 *              current character,  <correct> remain unchanged
 */
_VIRTUAL_ boolean
Context::idVal_readIf_argumentIdentifier_fSpStar_nSp (boolean * correct, ref2Argument * argument_res)
{
  // log_ASDEBUG("Context::idVal_readIf_argumentIdentifier_fSpStar_nSp");
  char *CString_name;
  if (readIf_varIdentification_fSpStar_nSp (correct, &CString_name))
    {
      /* CString_name is a (not empty) user identifier */
      boolean lCorrect = pk_true;
      if (getIf_argument_id_ (CString_name, &lCorrect, argument_res))
	return pk_true;
      ASFatal_missingDecl (lCorrect, "argument identifier", CString_name);
      (*correct) = pk_false;
    }
  (*argument_res) = NIL_Argument;
  return pk_false;
}

/* 2004-11-30
 * reads from FILE and returns in <argument_res> a new allocated argument
 * success: next character begins 
 *             a correct stringConstant <"stringConstant">
 *                 returns in <argument_res> a new stringArgument containing this stringConstant
 *             a correct global variable identifier <Arg>
 *                 returns in <argument_res> a new namedArgument containing this linked and value expanded variable
 *             a string function call
 *                 returns in <argument_res> a new argument containing this linked and value expanded function call
 *          terminates after next not space character following a newly read argument
 * failure: inaccurate string, identifier or function call is read
 *          or a correct string or identifier is read but reading does not terminate on not space not comment char
 *          next character does not begin a string value, an identifier or a correct string function call
 *             current character remains unchanged
 *          error message is printed
 * USED IN Context::
 * PLG verifier si en utilisation erreur ne provoque pas core dump
 */
_PRIVATE_ boolean Context::readIf_argument_fSpStar_ (boolean * correct, ref2Argument * argument_res, boolean * isEof)
{
  // logDEBUG_in("readIf_argument_fSpStar_nSp");
  // log_ASDEBUG("line is");
  boolean
    lCorrect = pk_true;
  boolean
    isEol;
  boolean
    isList;
  if (readIf_argument_call_argList_spStar_ (&lCorrect, argument_res, &isEol, &isList))
    {
      if (isEol)
	{
	  if (this_lexicalContext->step_nl_fSpStar_ (isEof))
	    /* FILE = PREFIX . [Character*][eol] [fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
	     *             if [EOF] is reached, <isEof> is set TRUE and this is set COMPLETED */
	    return pk_true;
	  /* FILE = PREFIX .# [EOF]
	   *          this is set XXXCOMPLETED
	   *          <isEof> is set TRUE
	   *          error message is printed, this is set ERRORXXX */
	  (*correct) = pk_false;
	  return pk_false;
	}
      return pk_true;
    }
  if (lCorrect)
    {
      char *
	strRes;
      if (this_lexicalContext->stepIf_stringConstant_fSpStar_ (&lCorrect, &strRes, isEof))
	{
	  /* <this_stringChar> does not occur in [Character*] 
	   *          FILE = PREFIX . <this_stringChar>[Character*]<this_stringChar>[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
	   *          <isEof> is set according to final position
	   *          a new fresh copy of [Character*] is returned in <strRes>
	   *          <correct> remains unchanged
	   */
	  (*argument_res) = new StringArgument (strRes);
	  return pk_true;
	}
      /* FILE = PREFIX .# opt{[Any_but_<this_stringChar>][Any*]}[EOF]
       *              <correct>, <isEof>, <strRes> remain unchanged
       *          FILE = PREFIX . <this_stringChar> # [Any*][eol], <this_stringChar> does not occur in [Any*]
       *              error message is printed
       *              <correct> is set FALSE
       *          FILE = PREFIX . <this_stringChar>[Character*]<this_stringChar> opt{[lineSpaces]} ... [EOF], reading failed
       *              error message is printed
       *              <correct> is set FALSE
       *          FILE = PREFIX . <this_stringChar>[Character*]<this_stringChar>[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF], some memory error occurred
       *              error message is printed
       *              <correct> is set FALSE */
      if (lCorrect)
	{
	  /* FILE = PREFIX .# opt{[Any_but_<this_stringChar>][Any*]}[EOF], isEof is set TRUE if [EOF] is reached */
	  if (idVal_readIf_argumentIdentifier_fSpStar_nSp (&lCorrect, argument_res))
	    return pk_true;
	  if (lCorrect)
	    {
	      ref2ArgumentList
		argumentList_res;
	      if (AsGetIf_O_freeARGList_C_fSpStar_ (correct, &argumentList_res, isEof))
		{
		  (*argument_res) = (ref2Argument) argumentList_res;
		  return pk_true;
		}
	      (*argument_res) = NIL_Argument;
	      return pk_false;
	    }
	  (*correct) = pk_false;
	  (*argument_res) = NIL_Argument;
	  return pk_false;
	}
      /* FILE = PREFIX . <this_stringChar> # [Character*]opt{[eol][Any*]}[EOF] , <this_stringChar> does not occur in [Character*]
       * FILE = PREFIX . <this_stringChar>[Character*]<this_stringChar> opt{[lineSpaces]} ... [EOF], reading failed
       * FILE = PREFIX . <this_stringChar>[Character*]<this_stringChar>[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF], some memory error occurred
       * <isEof> is set TRUE if [EOF] is reached
       * error message is printed */
      (*correct) = pk_false;
      (*argument_res) = NIL_Argument;
      return pk_false;
    }
  (*correct) = pk_false;
  (*argument_res) = NIL_Argument;
  return pk_false;
}

_PRIVATE_ boolean Context::readIf_argument_fSpStar_nSp (boolean * correct, ref2Argument * argument_res)
{
  boolean
    isEof = pk_false;
  if (readIf_argument_fSpStar_ (correct, argument_res, &isEof))
    {
      if (isEof)
	{
	  this_lexicalContext->ASFatal_eof ();
	  (*correct) = pk_false;
	  return pk_false;
	}
      return pk_true;
    }
  return pk_false;
}

/* ========= ========= ========= READ ARGUMENT 4: Identifier
 */

/* PLG 2008-06-06 functionName added */
_PROTECTED_ boolean Context::readIf_varIdentCommand_spStar_ (boolean * correct, ref2Argument * argument_res, boolean * isEol)
{
  int
    identifierCode;
  char *
    functionName;
  if (this_lexicalContext->stepIf_varIdentCommandHead_fSpStar_nSp (&identifierCode, &functionName))
    {
      /*FILE = PREFIX . '$:'[Identifier] [fileSpace*] # [Character_but_Space][Any*][EOF]
       *             [Identifier] is in { 'string',  'stringval', 'hostval'} or is not a reserved word
       *                <identifierCode> is set according to Identifier
       */
      ref2StringFunctionCall
	functionCall;
      if (read_string_call_argList_spStar_ (identifierCode, functionName, &functionCall, isEol, argument_res))
	return pk_true;
    }
  else if (identifierCode == notACommandCODE)
    /* FILE = PREFIX . [Character_but_Space_but_'$:'][Any*][EOF] */
    return pk_false;
  /* FILE = PREFIX . ... # [EOF], reading failed
   * FILE = PREFIX . '$:'[Identifier] [fileSpace*] # [EOF]
   * FILE = PREFIX . '$:' # opt{[Any_but_IdentHeaderCharacter][Any*]}[EOF]
   * FILE = PREFIX . '$:'[Identifier] [fileSpace*] # [Character_but_Space][Any*][EOF]
   *           [Identifier] is a reserved word not in { 'string',  'stringval', 'hostval'}
   * an error message is printed
   */
  (*correct) = pk_false;
  set_fatal ();
  return pk_false;
}

_PRIVATE_ boolean Context::stepOpt_referenceTailIdentifier_spStar_ (ref2Argument ident_argValue, ref2ArgumentList * argumentList_res, boolean * isEol)
{
  /* cursor starts [ReferenceHeaded_ident] [Character*] [eoX] or [Character*] [eoX] */
  boolean
    lCorrect = pk_true;
  ref2ArgumentList
    tailList;
  if (stepIf_referenceHeadedIdentifier_spStar_ (&lCorrect, &tailList, isEol))
    {
      (*argumentList_res) = new ArgumentList (ident_argValue, tailList);
      return pk_true;
    }
  if (lCorrect)
    {
      (*argumentList_res) = new ArgumentList (ident_argValue);
      return pk_true;
    }
  return pk_false;
}

_PRIVATE_ boolean Context::stepOpt_referenceTailIdentifier_spStar_ (char *string_headSubName, ref2ArgumentList * argumentList_res, boolean * isEol)
{
  /* cursor starts [ReferenceHeaded_ident] [Character*] [eoX] or [Character*] [eoX] */
  boolean
    lCorrect = pk_true;
  ref2ArgumentList
    tailList;
  if (stepIf_referenceHeadedIdentifier_spStar_ (&lCorrect, &tailList, isEol))
    {
      (*argumentList_res) = new ArgumentList (string_headSubName, tailList);
      return pk_true;
    }
  if (lCorrect)
    {
      (*argumentList_res) = new ArgumentList (string_headSubName);
      return pk_true;
    }
  return pk_false;
}

/* 
 * success: FILE = PREFIX . '$('
 */
_PROTECTED_ boolean Context::stepIf_referenceHeadedIdentifier_fSpStar_nSp (boolean * correct, ref2ArgumentList * argumentList_res)
{
  // log_ASDEBUG("Context::stepIf_referenceHeadedIdentifier_fSpStar_nSp");
  /* cursor starts [ReferenceHeaded_ident] [Character*] [eoX] or [Character*] [eoX] */

  boolean
    isEol = pk_false;
  if (this_lexicalContext->stepIf_referenceHead_spStar_ (&isEol))
    {
      /* success: BUFFER = PREFIX . [referenceTAG] <this_openingChar> [White*] # [Character_but_Space][Any*]
       *             <isEol> is set to false
       *          BUFFER = PREFIX . [referenceTAG] <this_openingChar> [Space*]#
       *             <isEol> is set to pk_true
       * failure: BUFFER = PREFIX .#[Any*], [referenceTAG]<this_openingChar> is not a prefix in [Any*]
       *             <isEol> is set to false
       *          BUFFER = PREFIX .#[eol],
       *             <isEol> is set to pk_true */
      if (step_referenceBodyHeadedIdentifier_spStar_ (argumentList_res, &isEol))
	{
	  if (isEol)
	    {
	      if (this_lexicalContext->req_nl_fSpStar_nSp ())	/* success: FILE = PREFIX . [Character*][eol][fileSpace*] #[Character_but_Space][Any*][EOF]
								 * failure: FILE = PREFIX . [Character*]opt{[eol][fileSpace*]}#[EOF] */
		return pk_true;
	      (*correct) = pk_false;
	      return pk_false;
	    }
	  return pk_true;
	}
      (*correct) = pk_false;
      return pk_false;
    }
  if (isEol)
    if (!this_lexicalContext->req_nl_fSpStar_nSp ())	/* success: FILE = PREFIX . [Character*][eol][fileSpace*] #[Character_but_Space][Any*][EOF]
							 * failure: FILE = PREFIX . [Character*]opt{[eol][fileSpace*]}#[EOF] */
      (*correct) = pk_false;
  return pk_false;
}

/* PLG 2005-03-17
 * success: cursor starts [ReferenceHeaded_ident] [eoX]
 *             cursor is moved to [eoX]
 *          cursor starts [ReferenceHeaded_ident] [Character] [eoX]
 *                [Character] is not an [Identcharacter]
 *             cursor is moved to [Character]
 *          cursor starts [ReferenceHeaded_ident] [Character] [Character] [Any]
 *                first character is not an [Identcharacter]
 *                first [Character] is not [referenceTAG] or second character is not <leftChar> 
 *             cursor is moved to first [Character]
 *          where
 *             [ReferenceHeaded_ident] ::= [identReference] { [] + [Identifier] + [Parameterized_ident] }
 *             [identReference] ::= [referenceTAG] <leftChar> [White*] [Identifier] [White*] <rightChar>
 *             [Parameterized_ident] ::= { [] + [Identifier] } [ReferenceHeaded_ident]
 *          <correct> remains unchanged
 *          <argumentList_res> is set to a new ArgumetList containing [ReferenceHeaded_ident]  components
 *          <isEol> is set according to final cursor position
 * failure: cursor starts [referenceTAG] <leftChar>, a context or syntax error occurred
 *             error message is printed
 *             cursor is moved to errored position
 *             <correct> is set to false
 *             <argumentList_res> remains unchanged
 *          cursor does not start [referenceTAG] <leftChar>
 *             <argumentList_res>, <correct>, <isEol> remain unchanged
 * USED IN recursively
 */
_PRIVATE_ boolean Context::step_referenceBodyHeadedIdentifier_spStar_ (ref2ArgumentList * argumentList_res, boolean * isEol)
{
  // log_ASDEBUG("Context::step_referenceBodyHeadedIdentifier_spStar_");
  char *
    parameterName;
  boolean
    isSpaced;
  if (this_lexicalContext->req_referenceTail_C_spStar_ (&parameterName, &isSpaced, isEol))
    {
      /* FILE = PREFIX . [Identifier][White*]<rightChar>[White*] # [Character_but_Space][Any*][EOF]
       *   or   PREFIX . [Identifier][White*]<rightChar> opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
       *                     [Identifier] is not a reserved word
       *             <isEol> is set according to final cursor position
       *             <isSpaced> is set according to [Any] that immediately follows <rightChar> (TRUE if [Any] is [eoX]
       *             <parameterName> is loaded with a new m'allocated copy of [Identifier] */
      ref2Argument
	ident_argValue;
      /* name is a (not empty) user identifier name */
      if (get_string_id_ (parameterName, &ident_argValue))
	{
	  if (isSpaced)
	    {
	      (*argumentList_res) = new ArgumentList (ident_argValue);
	      return pk_true;
	    }
	  else
	    {
	      ref2ArgumentList
		tailList;
	      char *
		string_subName;
	      boolean
		lCorrect = pk_true;
	      if (this_lexicalContext->stepIf_userIdentifier_spStar_ (&lCorrect, &string_subName, &isSpaced, isEol))
		{
		  if (isSpaced)
		    {
		      /* FILE = PREFIX . [Identifier]opt{[lineSpaces]} # opt{[eol][Any*]}[EOF], 
		       *              <isEol> is set TRUE
		       * FILE = PREFIX . [Identifier][White+] # [Character_but_Space][Any*][EOF]
		       *              <isEol> is set FALSE
		       */
		      (*argumentList_res) = new ArgumentList (ident_argValue, new ArgumentList (string_subName));
		      return pk_true;
		    }
		  /* FILE = PREFIX . [Identifier] # [Character_but_Space_but_IdentCharacter][Any*][EOF]
		   *              <isEol> is set FALSE */
		  if (stepOpt_referenceTailIdentifier_spStar_ (string_subName, &tailList, isEol))
		    {
		      (*argumentList_res) = new ArgumentList (ident_argValue, tailList);
		      return pk_true;
		    }
		  return pk_false;
		}
	      /* [Identifier] is a reserved word in
	       *      FILE = PREFIX . [Identifier] opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
	       *        or   PREFIX . [Identifier] [White*] # [Character_but_Space][Any*][EOF]
	       *              <correct> is set FALSE
	       *              <isEol> is set according to final position
	       *              error message is printed
	       *          FILE = PREFIX . ... # [Any*][EOF], reading failed
	       *              <correct> is set FALSE
	       *          <name>  remains unchanged
	       * <isEol> is set according to final cursor position*/
	      if (lCorrect)
		/* FILE = PREFIX .# opt{[Any_but_IdentCharacter][Any*]}[EOF]
		 *      <isEol> is set according to final position
		 */
		return stepOpt_referenceTailIdentifier_spStar_ (ident_argValue, argumentList_res, isEol);
	      /* [Identifier] is a reserved word in
	       *      FILE = PREFIX . [Identifier] opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
	       *        or   PREFIX . [Identifier] [White*] # [Character_but_Space][Any*][EOF]
	       *              <correct> is set FALSE
	       *              <isEol> is set according to final position
	       *              error message is printed
	       *          FILE = PREFIX . ... # [Any*][EOF], reading failed
	       *              <correct> is set FALSE
	       *          <name>  remains unchanged
	       * <isEol> is set according to final cursor position */
	      return pk_false;
	    }
	  return pk_false;
	}
      return pk_false;
    }
  /*  failure req_referenceTail_C_spStar_: 
   *          syntax is correct, [Identifier] is a reserved word 
   *          FILE = PREFIX . [Identifier] [White*] # [Any_but_Space_but_<rightChar>][Any*][EOF]
   *             <parameterName> is loaded with a new m'allocated copy of [Identifier]
   *          FILE = PREFIX .# SUFFIX, SUFFIX does not start with [referenceTAG] <leftChar>
   *             <parameterName> remains unchanged
   *          FILE = PREFIX . ... # [Any*][EOF], reading failed
   *          error message is printed
   *          <isEol> is set according to final cursor position */
  return pk_false;
}

/* 
 * success: FILE = PREFIX . '$('
 */
_PROTECTED_ boolean Context::stepIf_referenceHeadedIdentifier_spStar_ (boolean * correct, ref2ArgumentList * argumentList_res, boolean * isEol)
{
  // log_ASDEBUG("Context::stepIf_referenceHeadedIdentifier_spStar_");
  if (this_lexicalContext->stepIf_referenceHead_spStar_ (isEol))
    {
      if (step_referenceBodyHeadedIdentifier_spStar_ (argumentList_res, isEol))
	return pk_true;
      (*correct) = pk_false;
    }
  return pk_false;
}

/* 2005-02-28
 * reads in FILE a generic variable identification
 * success: current character starts [VAR_IDENTIFICATION] [lineSpaces]
 *            where 
 *              [VAR_IDENTIFICATION] ::= [Identifier]
 *              [VAR_IDENTIFICATION] ::= [parameterized_string] 
 *                            [parameterized_string] evaluation result is an Identifier
 *              [VAR_IDENTIFICATION] ::= '$:' [StringFunction_CALL]
 *                            [StringFunction_CALL] evaluation result is an Identifier
 *          cursor is moved to final character in [lineSpaces]
 *          FILE current atom is set to empty
 *          <correct> remains unchanged
 *          returns in <CString_name> a new m'allocated copy of [VAR_IDENTIFICATION]
 * failure: 'FILE' starts an inaccurate [VAR_IDENTIFICATION]
 *              <correct> is set to false
 *              error message is printed
 *          'FILE' does not start a [VAR_IDENTIFICATION]
 *              <correct> remains unchanged
 */
_PRIVATE_ boolean Context::readIf_varIdentification_spStar_ (boolean * correct, char **CString_name, boolean * isEol)
{
  // log_ASDEBUG("Context::readIf_varIdentification_spStar_");
  boolean
    lCorrect = pk_true;
  ref2Argument
    argument_res;
  if (readIf_varIdentCommand_spStar_ (&lCorrect, &argument_res, isEol))
    {
      if (cast_argument2Ident (argument_res, CString_name))
	return pk_true;
      (*correct) = pk_false;
      return pk_false;
    }
  if (lCorrect)
    {
      ref2ArgumentList
	listRes;
      boolean
	isSpaced;
      if (this_lexicalContext->stepIf_userIdentifier_spStar_ (&lCorrect, CString_name, &isSpaced, isEol))
	{
	  if (isSpaced)
	    {
	      /* FILE = PREFIX . [Identifier]opt{[lineSpaces]} # opt{[eol][Any*]}[EOF], 
	       *              <isEol> is set TRUE
	       *          FILE = PREFIX . [Identifier][White+] # [Character_but_Space][Any*][EOF]
	       *              <isEol> is set FALSE */
	      return pk_true;
	    }
	  /* FILE = PREFIX . [Identifier] # [Character_but_Space_but_IdentCharacter][Any*][EOF]
	   *              <isSpaced> is set FALSE
	   *              <isEol> is set FALSE
	   *          [Identifier] is returned in <name> */
	  if (stepIf_referenceHeadedIdentifier_spStar_ (&lCorrect, &listRes, isEol))
	    {
	      listRes = new ArgumentList (*CString_name, listRes);
	      if (cast_argument2Ident (listRes, CString_name))
		return pk_true;
	      (*correct) = pk_false;
	      return pk_false;
	    }
	  if (lCorrect)
	    return pk_true;
	  (*correct) = pk_false;
	  return pk_false;
	}
      if (lCorrect)
	{			/* FILE = PREFIX .# opt{[Any_but_IdentCharacter][Any*]}[EOF]
				 *             <isEol> is set according to final position */
	  if (stepIf_referenceHeadedIdentifier_spStar_ (correct, &listRes, isEol))
	    {
	      if (cast_argument2Ident (listRes, CString_name))
		return pk_true;
	    }
	  else
	    return pk_false;
	}
      /* [Identifier] is a reserved word in
       *          FILE = PREFIX . [Identifier] opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
       *                or   PREFIX . [Identifier] [White*] # [Character_but_Space][Any*][EOF]
       *              <correct> is set FALSE
       *              <isEol> is set according to final position
       *              error message is printed
       *          FILE = PREFIX . ... # [Any*][EOF], reading failed
       *              <correct> is set FALSE
       *          <name>  remains unchanged
       * <isEol> is set according to final cursor position */
      (*correct) = pk_false;
      return pk_false;
    }
  (*correct) = pk_false;
  return pk_false;
}

/* PLG 2008-06-06 functionName added
 * failure: correct false: error message is printed
 */
_PROTECTED_ boolean Context::readIf_extIdentCommand_spStar_ (boolean * correct, ref2Argument * argument_res, boolean * isEol)
{
  // log_ASDEBUG("Context::readIf_extIdentCommand_spStar_");
  int
    commandCode;
  char *
    functionName;
  if (this_lexicalContext->stepIf_extIdentCommandHead_fSpStar_nSp (&commandCode, &functionName))
    {
      ref2StringFunctionCall
	functionCall;
      if (read_string_call_argList_spStar_ (commandCode, functionName, &functionCall, isEol, argument_res))
	return pk_true;
      /* not lCorrect: error message is printed */ }
  else if (commandCode == notACommandCODE)
    return pk_false;
  (*correct) = pk_false;
  set_fatal ();
  return pk_false;
}

/* 2004-11-22
 * reads in this_lexicalContext a generic extern identification
 * success: cursor starts [EXTERN_IDENTIFICATION] [lineSpaces]
 *            where
 *            [EXTERN_IDENTIFICATION] ::= '~' [Character+] '~'
 *            		'~' does not occur in [Character+] 
 *            		<commandChar> does not start [Character+]
 *            [EXTERN_IDENTIFICATION] ::= '~' [parameterized_string] '~'
 *            		'~' does not occur in [parameterized_string]
 *            		<commandChar> does not start [Character*]
 *            [EXTERN_IDENTIFICATION] ::= '~' [StringFunction_CALL] [lineSpaces]'~'
 *            		'~' does not occur in [StringFunction_CALL]
 *          cursor is moved to terminal position of [lineSpaces]
 *          returns the node name in <CString_name> (new m'allocated)
 * failure: 'this_lexicalContext' cursor starts a not correct [EXTERN_IDENTIFICATION], or 
 *              error message is printed
 *          'this_lexicalContext' current character is not '~' 
 */
_PRIVATE_ boolean Context::readIf_externIdentifier_spStar_ (boolean * correct, char **CString_name, boolean * isEol)
{
  // log_ASDEBUG("Context::readIf_externIdentifier_spStar_");
  boolean
    lCorrect = pk_true;
  ref2Argument
    argument_res;
  if (readIf_extIdentCommand_spStar_ (&lCorrect, &argument_res, isEol))
    return argument_res->getIf_CString_cast_expand_ (CString_name);
  if (lCorrect)
    {
      if (this_lexicalContext->stepIf_externIdentifier_spStar_ (&lCorrect, CString_name, isEol))
	/* FILE = PREFIX . '~'[Character*]'~'opt{[lineSpaces]} # opt{[eol][Any*]}[EOF] 
	 *          FILE = PREFIX . '~'[Character*]'~'[White*]#[Character_but_Space][Character+] [NULL_char] 
	 *          a new fresh copy of [Character*] is returned in <CString_name>
	 *          <lCorrect> remains unchanged, <isEol> is set  */
	return pk_true;
      if (lCorrect)
	/* PREFIX .# opt{[Character_but_'~'][Character*]}opt{[eol][Any*]}[EOF], isEol> is set */
	return pk_false;
      /* FILE = PREFIX . '~''~' opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
       *   or   PREFIX . '~''~'[White*] # [Character_but_Space][Any+][EOF]
       * some memory error occurred
       *               FILE = PREFIX . '~'[Character*]'~' opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
       *                 or   PREFIX . '~'[Character*]'~'[White*] # [Character_but_Space][Character*] opt{[eol][Any*]}[EOF]
       * FILE = PREFIX . '~' # [Character*]opt{[eol][Any*]}[EOF], '~' does not occur in [Character*]
       * error message is printed, <isEol> is set */
      (*correct) = pk_false;
      return pk_false;
    }
  (*correct) = pk_false;
  return pk_false;
}

/* 2005-02-28
 */
_PUBLIC_ boolean Context::readIf_varIdentification_fSpStar_nSp (boolean * correct, char **CString_name)
{
  // log_ASDEBUG("Context::readIf_varIdentification_fSpStar_nSp");
  boolean
    isEol;
  boolean
    lCorrect = pk_true;
  if (readIf_varIdentification_spStar_ (&lCorrect, CString_name, &isEol))
    {				/* _fSpStar_nSp */
      if (isEol)
	{
	  if (this_lexicalContext->req_nl_fSpStar_nSp ())	/* success: FILE = PREFIX . [Character*][eol][fileSpace*] #[Character_but_Space][Any*][EOF]
								 * failure: FILE = PREFIX . [Character*]opt{[eol][fileSpace*]}#[EOF] */
	    return pk_true;
	  (*correct) = pk_false;
	  return pk_false;
	}
      return pk_true;
    }
  if (lCorrect)
    return pk_false;
  (*correct) = pk_false;
  return pk_false;
}

/* PLG 2008-06-06 functionName added */
_PROTECTED_ boolean Context::readIf_fileIdentCommand_spStar_ (boolean * correct, ref2Argument * argument_res, boolean * isEol)
{
  int
    commandCode;
  char *
    functionName;
  if (this_lexicalContext->stepIf_fileIdentCommandHead_fSpStar_nSp (&commandCode, &functionName))
    {
      ref2StringFunctionCall
	functionCall;
      if (read_string_call_argList_spStar_ (commandCode, functionName, &functionCall, isEol, argument_res))
	return pk_true;
    }
  else if (commandCode == notACommandCODE)
    return pk_false;
  set_fatal ();
  (*correct) = pk_false;
  return pk_false;
}

/* 2005-02-28
 * reads in this_lexicalContext a generic file identification
 * success: cursor starts [FILE_IDENTIFICATION] [lineSpaces]
 *            where
 *            [FILE_IDENTIFICATION] ::= '!' [Character+] '!'
 *            		'!' does not occur in [Character+] 
 *            		<commandChar> does not start [Character+]
 *            [FILE_IDENTIFICATION] ::= '!' [parameterized_string] '!'
 *            		'!' does not occur in [parameterized_string]
 *            		<commandChar> does not start [Character*]
 *            [FILE_IDENTIFICATION] ::= '!' [StringFunction_CALL] [lineSpaces]'!'
 *            		'!' does not occur in [StringFunction_CALL]
 *          cursor is moved to final character in [lineSpaces]
 *          <correct> remains unchanged
 *          returns the node name in <CString_name> (new m'allocated)
 * failure: 'this_lexicalContext' cursor starts a not correct [FILE_IDENTIFICATION],
 *              <correct> is set to false
 *              error message is printed
 *          'this_lexicalContext' current character is not '!' 
 *              <correct> remains unchanged
 */
_PRIVATE_ boolean Context::readIf_fileIdentifier_spStar_ (boolean * correct, char **CString_name, boolean * isEol)
{
  boolean
    lCorrect = pk_true;
  ref2Argument
    argument_res;
  if (readIf_fileIdentCommand_spStar_ (&lCorrect, &argument_res, isEol))
    return argument_res->getIf_CString_cast_expand_ (CString_name);
  if (lCorrect)
    {
      if (this_lexicalContext->stepIf_fileIdentifier_spStar_ (&lCorrect, CString_name, isEol))
	/* FILE = PREFIX . '!'[Character*]'!'opt{[lineSpaces]} # opt{[eol][Any*]}[EOF] 
	 *          FILE = PREFIX . '!'[Character*]'!'[White*]#[Character_but_Space][Character+] [NULL_char] 
	 *          a new fresh copy of [Character*] is returned in <CString_name>
	 *          <lCorrect> remains unchanged, <isEol> is set  */
	return pk_true;
      if (lCorrect)
	/* PREFIX .# opt{[Character_but_'!'][Character*]}opt{[eol][Any*]}[EOF], <isEol> is set */
	return pk_false;
      /* FILE = PREFIX . '!''!' opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
       *   or   PREFIX . '!''!'[White*] # [Character_but_Space][Any+][EOF]
       * some memory error occurred
       *               FILE = PREFIX . '!'[Character*]'!' opt{[lineSpaces]} # opt{[eol][Any*]}[EOF]
       *                 or   PREFIX . '!'[Character*]'!'[White*] # [Character_but_Space][Character*] opt{[eol][Any*]}[EOF]
       * FILE = PREFIX . '!' # [Character*]opt{[eol][Any*]}[EOF], '!' does not occur in [Character*]
       * error message is printed, <isEol> is set */
      (*correct) = pk_false;
      return pk_false;
    }
  (*correct) = pk_false;
  return pk_false;
}

/* 2004-11-22 PLG 2007-02-14 CHECK STRANGE
 * reads in this_lexicalContext a file identification list
 * success: FILE = PREFIX . [FILE_IDENTIFICATIONs_fSp*]#[Character_but_Space][Any*][EOF]
 *                 [Character_but_Space] does not start a [FILE_IDENTIFICATIONs]
 *              [FILE_IDENTIFICATIONs] ::= [FILE_IDENTIFICATION]
 *              [FILE_IDENTIFICATIONs] ::= [_ARGUMENT]
 *             returns in <str_nameLst> the list of read names
 *          FILE = PREFIX .#[Character_but_Space][Any*][EOF]
 *                 [Character_but_Space] does not start a [FILE_IDENTIFICATIONs]
 *             returns in <str_nameLst> the empty list 
 * failure: 'this_lexicalContext' cursor starts a not correct [FILE_IDENTIFICATIONs]
 *          or 'this_lexicalContext' cursor starts [FILE_IDENTIFICATIONs] [fileSpace*] [EOF] 
 *                  error message is printed
 *                  <str_nameLst> may be changed
 */
_PRIVATE_ boolean Context::read_fileIdentifierList_fSpStar_nSp (ref2CStringList * str_nameLst)
{
  boolean
    isEol;
  boolean
    lCorrect = pk_true;
  char *
    CString_currentName;
  ref2CStringList
    tail_nameLst;

  // log_ASDEBUG("entering Context::read_fileIdentifierList_fSpStar_nSp");

  if (readIf_fileIdentifier_spStar_ (&lCorrect, &CString_currentName, &isEol))
    {
      if (isEol)
	if (!this_lexicalContext->req_nl_fSpStar_nSp ())	/* success: FILE = PREFIX . [Character*][eol][fileSpace*] #[Character_but_Space][Any*][EOF]
								 * failure: FILE = PREFIX . [Character*]opt{[eol][fileSpace*]}#[EOF] */
	  return pk_false;
      if (read_fileIdentifierList_fSpStar_nSp (&tail_nameLst))
	{
	  (*str_nameLst) = new CStringList (CString_currentName, tail_nameLst);
	  return pk_true;
	}
      return pk_false;
    }
  if (lCorrect)
    {
      ref2Argument
	argument_res;
      if (readIf_argument_fSpStar_nSp (&lCorrect, &argument_res))
	{
	  if (argument_res->getIf_CStringList_cast_flatExpand_ (str_nameLst))
	    {
	      if (read_fileIdentifierList_fSpStar_nSp (&tail_nameLst))
		{
		  if (tail_nameLst != NIL_CStringList)
		    (*str_nameLst)->append (tail_nameLst);
		  return pk_true;
		}
	    }
	  return pk_false;
	}
      if (lCorrect)
	{
	  (*str_nameLst) = NIL_CStringList;
	  return pk_true;
	}
    }
  return pk_false;
}

/* 2005-02-28
 * reads a generic node name beginning at current position
 * success: cursor starts [NODE_IDENTIFICATION] [lineSpaces]
 *          where
 *            [NODE_IDENTIFICATION] ::= [EXTERN_Identifier]
 *               [EXTERN_IDENTIFICATION] ::= '~' [Character+] '~' 
 *               [EXTERN_IDENTIFICATION] ::= '~' [Parameterized_string] '~' 
 *               [EXTERN_IDENTIFICATION] ::= '~' [StringFunction_CALL] 
 *               set <isVar> to pk_false, <isFile> to false 
 *            [NODE_IDENTIFICATION] ::= [FILE_IDENTIFICATION]
 *               [FILE_IDENTIFICATION] ::= '!' [Character+] '!' 
 *               [FILE_IDENTIFICATION] ::= '!' [Parameterized_string] '!'
 *               [FILE_IDENTIFICATONI] ::= '!' [StringFunction_CALL]
 *               set <isVar> to pk_false, <isFile> to pk_true 
 *            [NODE_IDENTIFICATION] ::= [VAR_IDENTIFICATION]
 *               [VAR_IDENTIFICATION] ::= [Identifier]
 *               [VAR_IDENTIFICATION] ::= [Parameterized_ident] 
 *               [VAR_IDENTIFICATION] ::= [referenceTAG] [StringFunction_CALL]
 *               set <isVar> to pk_true
 *          all references are static references. actual name is computed and returned in <CString_name>
 *          cursor is moved to end of [lineSpaces]
 *          returns the node name in <CString_name> (unsafe)
 * failure: on context or syntax error 
 *             error message is printed
 *             cursor is moved to errored position
 *             <correct> is set to false
 *             <CString_name> remains unchanged
 *          cursor does not start an identification
 *             <correct>, <CString_name> remain unchanged
 */
_PRIVATE_ boolean Context::read_nodeIdentifier_spStar_ (char **CString_name, boolean * isVar, boolean * isFile, boolean * isEol)
{
  boolean
    lCorrect = pk_true;
  // log_ASDEBUG("Context::read_nodeIdentifier_spStar_");

  if (readIf_externIdentifier_spStar_ (&lCorrect, CString_name, isEol))
    {
      (*isVar) = pk_false;
      (*isFile) = pk_false;
      return pk_true;
    }
  if (lCorrect)
    {
      if (readIf_fileIdentifier_spStar_ (&lCorrect, CString_name, isEol))
	{
	  (*isVar) = pk_false;
	  (*isFile) = pk_true;
	  return pk_true;
	}
      if (lCorrect)
	{
	  if (readIf_varIdentification_spStar_ (&lCorrect, CString_name, isEol))
	    {
	      (*isVar) = pk_true;
	      return pk_true;
	    }
	  if (lCorrect)
	    ASFatal_expected ("node identifier");
	}
    }
  return pk_false;
}

/* ========= ========= ========= READ ARGUMENT 5: readExpand_lineList_nl
 */

/* --------- --------- --------- READ ARGUMENT 5: readExpand_lineList_nl
 */
/* 2004-11-15
 * reads and returns a list of actual string lines starting at cursor position and terminated with
 *     close tag as line first character
 * success: cursor starts [_line*] '}'
 *          <lineList_res> is assigned [_line*]
 *          cursor is moved to '}' line starting
 * failure: cursor starts [_line*] [Character*] [EOF]
 *          error message is printed
 *          <lineList_res> is assigned NIL
 * PLG SOURCE OF CONSTRAINTS ON SPACE READING readExpand_lineList_nl
 */
_PRIVATE_ boolean Context::readExpand_lineList_nl (ref2LineList * lineList_res)
{
  // log_ASDEBUG("Context::readExpand_lineList_nl");
  ref2ArgumentList
    argumentList;
  if (starRead_ARGList_fSpStar_nSp (&argumentList))
    {
      /* FILE = PREFIX . [ARGUMENT_fSpStar]* # [Character_but_Space][Any*][EOF], [Character_but_Space][Any*][EOF] is not prefixed by an [ARGUMENT] */
      if (this_lexicalContext->is_actionClosing ())
	{
	  /* FILE = PREFIX .[ARGUMENT_fSpStar]*  # '}'[Any*][EOF], [eol] terminates PREFIX [ARGUMENT_fSpStar]* */
	  if (argumentList == NIL_ArgumentList)
	    {
	      (*lineList_res) = NIL_LineList;
	      return pk_true;
	    }
	  return argumentList->getIf_lineList_cast_flatExpand_ (lineList_res);
	}
    }
  (*lineList_res) = NIL_LineList;
  return pk_false;
}

/* ========= ========= ========= =========  ========= ========= READ COMMAND
 */
/* --------- --------- --------- ---------  READ COMMAND 1: readExec_boot_fSpStar_nSp
 */
/* 2005-01-31, PLG 2007-06-20 (syntax)
 * reads and execute command lines
 * success:    FILE = PREFIX'{'[fileSpace*] opt{[SyntaxAdaptor_fSpPlus]} [commandChar]'boot' [lineSpaces][eol][_ACTION_eol]*#'}' [Any*][eoX] 
 *          [__ACTION] are executed in host after reading achievement
 *          cursor is moved to final [eoX]
 *          [_ACTION_eol*] are executed in host after reading achievement
 * failure: syntax or execution error
 *          error message is printed
 *          cursor is moved to recovered position
 * PLG TO DO "delete command_lines" does not work
 */
/* ==> 2-5 */
_PRIVATE_ boolean Context::readExec_boot_fSpStar_nSp (ref2ArgumentList comments)
{
  // log_ASDEBUG("Context::readExec_boot_fSpStar_nSp");
  ref2LineList
    command_lines;
  boolean
    printClosing = printORlevelInfo_declOpening_boot (comments);
  // appends 'eol' '{' 'spc' '$$' L R C S 'eol' {<comments> 'eol'} C 'boot' 'eol'
  if (readExpand_lineList_nl (&command_lines))
    {				/* terminates on '}' */
      if (printClosing)
	printORlevelInfo_declClosing_boot (command_lines);	/* appends  'eol' '}' 'eol' */
      if (command_lines == NIL_LineList)
	return pk_true;
      if (command_lines->execute ())
	{
	  delete
	    command_lines;
	  return pk_true;
	}
      delete
	command_lines;
      return pk_false;
    }
  return pk_false;
}

/* ========= ========= ========= =========  READ COMMAND 2: readLoad_contextFileList_fSpStar_nSp
 */
/* 2005-06-20 syntax
 * reads a list of context files possibly preceded by spaces
 * success: in other (syntax adaptaded) 
 *             FILE = PREFIX'{'[fileSpace*] opt{[SyntaxAdaptor_fSpPlus]} [commandChar]'context'[fileSpace*] . [FILE_IDENTIFICATION_fSpStar]* #'}' [Any*][eoX] 
 *          registers context files
 * failure: syntax or conflict error
 *          error message is printed
 *          cursor is moved to recovered position
 */
/* ==> 2-6 */
_PRIVATE_ boolean Context::readLoad_contextFileList_fSpStar_nSp (ref2MKFFileNode loader, ref2ArgumentList comments)
{
  /* cursor starts [FILE_Identifier_fSp*] '}' + [FILE_IDENTIFICATION_fSp*] '}' */
  // fprintf(stderr,"readLoad_contextFileList_fSpStar_nSp in %s, line %d\n",__FILE__,__LINE__);
  ref2CStringList
    nameLst;
  /* PLG could be enhanced with iteration allowing */
  boolean
    printClosing = printORlevelInfo_declOpening_context_spTab (comments);
  if (read_fileIdentifierList_fSpStar_nSp (&nameLst))
    {
      // fprintf(stderr,"readLoad_contextFileList_fSpStar_nSp in %s, line %d\n",__FILE__,__LINE__);
      if (printClosing)
	printORlevelInfo_declClosing_context_backTab (nameLst);
      // fprintf(stderr,"readLoad_contextFileList_fSpStar_nSp in %s, line %d\n",__FILE__,__LINE__);
      return load_contextList (loader, nameLst);
    }
  return pk_false;
}

/* ========= ========= ========= =========  READ COMMAND 3: 
 */
/* ========= =========  READ COMMAND 3-0: announce printORlevelInfo_declOpening_context_spTab, printORlevelInfo_declClosing_context_backTab
 */
/* ----- READ FUNCTION CALL NODE 1: 
 */
_PROTECTED_
  _VIRTUAL_ boolean Context::new_elementFunctionCall (char *functionName, ref2ArgumentList comments, ref2ElementFunctionElement linkedFunction,
						      ref2ArgumentList actualParameters, ref2ElementFunctionCall * functionCall)
{
  boolean
    lCorrect = pk_true;
  (*functionCall) = new ElementFunctionCall (this, functionName, comments, linkedFunction, actualParameters, &lCorrect);
  return lCorrect;
}

_PRIVATE_
  boolean Context::create_elementFunctionCall (char *functionName, ref2ArgumentList comments, ref2ElementFunctionElement linkedFunction,
					       ref2Context readingContext, ref2ArgumentList actualParameters, ref2ElementFunctionCall * functionCall)
{
  // log_ASDEBUG("entering Context::create_elementFunctionCall");
  // fprintf(stderr,"         functionName is <<%s>>", functionName);
  if (readingContext->guarantee_parameterListMatching (functionName, linkedFunction->getFormalParameters (), actualParameters))
    {
      if (new_elementFunctionCall (functionName, comments, linkedFunction, actualParameters, functionCall))
	{
	  printORlevelInfo_functionCallReading (*functionCall, functionName);
	  return pk_true;
	}
    }
  (*functionCall) = NIL_ElementFunctionCall;
  return pk_false;
}

_PUBLIC_
  boolean Context::read_elementFunctionCall_argList_fSpStar_ (ref2ArgumentList comments, char *functionName, ref2ElementFunctionCall * functionCall,
							      boolean * isEof)
{
  // openDEBUG_in("read_elementFunctionCall_argList_fSpStar_ 1, this function name is", functionName);
  // log_ASDEBUG("entering Context::read_elementFunctionCall_argList_fSpStar_");
  boolean
    lCorrect = pk_true;
  ref2ArgumentList
    actualParameters;
  boolean
    printClosing = printORlevelInfo_declOpening_elementFunctionCall (comments, functionName);
  ref2Context
    readingContext = new DynamicContext ((ref2Context) this);	/* to avoid parameter inner call being iterated */
  if (readingContext->AsGetIf_O_freeARGList_C_fSpStar_ (&lCorrect, &actualParameters, isEof))
    {
      ref2ElementFunctionElement
	linkedFunction;
      if (find_elementFunctionElement (functionName, &linkedFunction))
	{
	  if (create_elementFunctionCall (functionName, comments, linkedFunction, readingContext, actualParameters, functionCall))
	    {
	      if (printClosing)
		printORlevelInfo_declClosing_elementFunctionCall (*functionCall);
	      return pk_true;
	    }
	}
    }
  // closeDEBUG_in("read_elementFunctionCall_argList_fSpStar_ 1 FAILED, this function name is", functionName);
  (*functionCall) = NIL_ElementFunctionCall;
  return pk_false;
}

/* ===== READ FUNCTION CALL ANCESTOR 1: read_ancestorFunctionCall_argList_spStar_eol_ =====
 */
/* ===== READ FUNCTION CALL ANCESTOR 1-1: new_ancestorFunctionCall =====
 */
_PROTECTED_
  _VIRTUAL_ boolean Context::new_AncestorFunctionCall (char *functionName, ref2AncestorFunctionElement linkedFunction,
						       ref2ArgumentList actualParameters, ref2AncestorFunctionCall * functionCall)
{
  boolean
    lCorrect = pk_true;
  (*functionCall) = new AncestorFunctionCall (this, functionName, linkedFunction, actualParameters, &lCorrect);
  return lCorrect;
}

/* ----- READ FUNCTION CALL ANCESTOR 1: read_ancestorFunctionCall_argList_spStar_eol_ -----
 */
_PRIVATE_
  boolean Context::create_ancestorFunctionCall (char *functionName, ref2AncestorFunctionElement linkedFunction, ref2Context readingContext,
						ref2ArgumentList actualParameters, ref2AncestorFunctionCall * functionCall)
{
  if (readingContext->guarantee_parameterListMatching (functionName, linkedFunction->getFormalParameters (), actualParameters))
    {
      if (new_AncestorFunctionCall (functionName, linkedFunction, actualParameters, functionCall))
	{
	  printORlevelInfo_functionCallReading (*functionCall, functionName);
	  return pk_true;
	}
    }
  (*functionCall) = NIL_AncestorFunctionCall;
  return pk_false;
}

/* 2005-03-22 
 * reads in this_lexicalContext, an argument list that must fit <formalParameterList>
 * success: FILE = PREFIX . '(' [INNER_ARG] ')' [lineSpaces] # [eol][Any*][EOF]
 *             <isEol> is et to pk_true
 *          FILE = PREFIX . '(' innerArgument ')' [lineSpaces] # [Character_but_Space][Any*][EOF]
 *             <isEol> is et to false
 *          [INNER_ARG] = [fileSpace*]
 *             <formalParameterList> is empty
 *          [INNER_ARG] = [fileSpace*] list_fSp{[_ARGUMENT]} 
 *             <formalParameterList> has as many elements as list_fSp{[_ARGUMENT]}
 *          returns in <argumentList_res> the list of linked values
 *               links context variable, parameter and function declarations used in list_fSp{[_ARGUMENT]}
 * failure: syntax or context error
 *          error message is printed
 *          from syntax error
 *              cursor starts [Any*] ')' [lineSpaces], '{', '}', '(', ')' are well balanced in [Any*] 
 *                 cursor is moved to end of [lineSpaces]
 *              cursor starts [Any*] '}' , '{', '}', '(', ')' are well balanced in [Any*] 
 *                 cursor is moved to '}' 
 *              cursor starts [Any*] [EOF] , there are more opening than closing tags in [Any*] 
 *                 cursor is moved to [EOF]
 * FunctionCall Entry Point
 */
_PUBLIC_ boolean Context::read_ancestorFunctionCall_argList_spStar_eol_ (char *functionName, ref2AncestorFunctionCall * functionCall)
{
  // logDEBUG_in("read_ancestorFunctionCall_argList_spStar_eol_, this function name is", functionName);
  // log_ASDEBUG("Context::read_ancestorFunctionCall_argList_spStar_eol_ 1");
  ref2Context
    readingContext = new DynamicContext ((ref2Context) this);	/* to avoid parameter inner call being iterated */
  ref2ArgumentList
    actualParameters;
  if (readingContext->ASRequire_O_freeARGList_C_spStar_eol_ (&actualParameters))
    {
      ref2AncestorFunctionElement
	linkedFunction;
      if (find_ancestorFunctionElement (functionName, &linkedFunction))
	return create_ancestorFunctionCall (functionName, linkedFunction, readingContext, actualParameters, functionCall);
    }
  (*functionCall) = NIL_AncestorFunctionCall;
  return pk_false;
}

/* 2005-04-01
 * success: cursor starts [ITERATOR_fSp] [ANCESTOR_CALL] [lineSpaces_eol] [Any+]
 *          or cursor starts [ANCESTOR_CALL] [lineSpaces_eol] [Any+]
 *            cursor is moved to first position in [Any+]
 *            <function_res> is assigned the not empty function call built from [ITERATOR_fSp] [ANCESTOR_CALL] or [ANCESTOR_CALL] 
 * failure: cursor does not start an [ITERATOR_fSp] or an [ANCESTOR_CALL] 
 *            cursor, <correct>, <function_res> remain unchanged
 *          a syntax error occured
 *            cursor is moved to errored position
 *            <correct> is set to false
 *            error message is printed
 */
_PRIVATE_ boolean Context::read_ancestorList_inNewIteratorContext_eol_ (ref2AncestorFunctionCall * functionCall)
{
  // log_ASDEBUG("Context::read_ancestorList_inNewIteratorContext_eol_");
  ref2IteratorContext
    innerContext;
  if (new_iteratorContext_nSp (&innerContext))
    {
      char *
	functionName;
      if (this_lexicalContext->req_userElementaryCallHead_fSpStar_nSp (&functionName))
	{
	  /* FILE = PREFIX . <commandChar> [Identifier][fileSpace*] # [Character_but_Space][Any*][EOF]
	   *                 [Identifier] is not a reserved word
	   *                 first character in [fileSpace*][Character_but_Space] is not an [IdentCharacter]
	   *                 [Identifier] is assigned to <>functionName */
	  return innerContext->read_ancestorFunctionCall_argList_spStar_eol_ (functionName, functionCall);
	}
      /* req_userElementaryCallHead_fSpStar_nSp failure: 
       * FILE = PREFIX .# [Any_but_<commandChar>][Any*][EOF]
       * FILE = PREFIX . <commandChar>[Identifier] [fileSpace*] # opt{[Any_but_Space][Any*]}[EOF]
       *             [Identifier] is a reserved word
       * FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [EOF]
       *             [Identifier] is not a reserved word
       * FILE = PREFIX . <commandChar> # opt{[Any_but_IdentHeaderCharacter][Any*]}[EOF]
       * reading failed
       * an error message is printed */
    }
  return pk_false;
}

/* 2005-04-01
 * success: cursor starts [ITERATOR_fSp] [ANCESTOR_CALL] [lineSpaces_eol] [Any+]
 *          or cursor starts [ANCESTOR_CALL] [lineSpaces_eol] [Any+]
 *            cursor is moved to first position in [Any+]
 *            <function_res> is assigned the not empty function call built from [ITERATOR_fSp] [ANCESTOR_CALL] or [ANCESTOR_CALL] 
 * failure: cursor does not start an [ITERATOR_fSp] or an [ANCESTOR_CALL] 
 *            cursor, <correct>, <function_res> remain unchanged
 *          a syntax error occured
 *            cursor is moved to errored position
 *            <correct> is set to false
 *            error message is printed
 */
_PROTECTED_ boolean Context::readIf_ancestorCall_eol_ (boolean * correct, ref2AncestorFunctionCall * functionCall)
{
  boolean
    inIteration;
  boolean
    lCorrect = pk_true;
  char *
    functionName;
  // log_ASDEBUG("Context::readIf_ancestorCall_eol_");
  if (this_lexicalContext->stepIf_userCallHeader_fSpStar_nSp (&lCorrect, &inIteration, &functionName))
    {
      /* success: FILE = PREFIX . <commandChar> 'iterate' [fileSpace*] # [Character_but_Space][Any*][EOF]
       *                 first character in [fileSpace*][Character_but_Space] is not an [IdentCharacter]
       *             <inIteration> is pk_true
       *          FILE = PREFIX . <commandChar> [Identifier][fileSpace*] # [Character_but_Space][Any*][EOF]
       *                 [Identifier] is not a reserved word
       *                 first character in [fileSpace*][Character_but_Space] is not an [IdentCharacter]
       *             <inIteration> is false
       */
      if (inIteration)
	{
	  if (read_ancestorList_inNewIteratorContext_eol_ (functionCall))
	    {
	      return pk_true;
	    }
	}
      else
	{
	  if (read_ancestorFunctionCall_argList_spStar_eol_ (functionName, functionCall))
	    return pk_true;
	}
      (*correct) = pk_false;
      return pk_false;
    }
  if (lCorrect)
    return pk_false;
  (*correct) = pk_false;
  return pk_false;
}

/* ===== READ FUNCTION CALL NODE 1-1: new_elementFunctionCall =====
 */
/* ==================== context
 */

/* PLG 2007-05-24, PLG 2007-06-20, 2009-07-08, PLG-2009-09-07
 *          [Comment_eol_fWhStar]::[commentTAG][Character*][eol][fileWhite*]
 * success: FILE = PREFIX . [Comment_eol_fWhStar]*# opt{[Character_butSpace][Any*]} [EOF]
 *             <isEof> is set
 *             the sequence of comments in [Comment_eol_fWhStar]* is assigned to <comments>
 * failure: some syntactic error occurred
 *             error messages have been printed
 */
_PRIVATE_ boolean Context::starRead_comment_fWhStar_ (ref2ArgumentList * comments, boolean * isEof)
{
  char *
    commentCharSeq;
  boolean
    lCorrect = pk_true;
  // logDEBUG_in("starRead_comment_fWhStar_");
  /* PREFIX . [Comment_eol_fWhStar]* opt{[Character_butSpace][Any*]} [EOF] */
  if (this_lexicalContext->stepIf_comment_fWhStar_ (&lCorrect, &commentCharSeq, isEof))
    {				/* PLG 2009-08-25 */
      /* FILE = PREFIX . [commentTAG][Character*][eol][fileWhite*] # opt{[Character_but_White*][Any*]}[EOF]
       *          FILE = PREFIX . [commentTAG][Character*] # [EOF]
       *             [Character*] between [commentTAG] and [eol] (or EOF) are assigned to <commentCharSeq>
       *             if [EOF] is reached, <isEof> is set TRUE and this is set COMPLETED
       *             <correct> remains unchanged */
      ref2Argument
	aComment_arg = new StringArgument (commentCharSeq);
      ref2ArgumentList
	argumentListTail = NIL_ArgumentList;
      if (starRead_comment_fWhStar_ (&argumentListTail, isEof))
	{
	  /* FILE = PREFIX . [Comment_eol_fWhStar]+# opt{[Character_butSpace][Any*]} [EOF] */
	  (*comments) = new ArgumentList (aComment_arg, argumentListTail);
	  return pk_true;
	}
      /* error message has been printed */
      return pk_false;
    }
  /* FILE = PREFIX .# opt{[Any_but_commentTAG][Any*]}[EOF]
   *             <correct>, <commentCharSeq> remain unchanged
   *          some syntactic error occurred
   *             <correct> is set FALSE, this is set completed
   */
  (*comments) = NIL_ArgumentList;
  return lCorrect;
}


/* 2005-03-09, PLG-2007-05-24 , PLG-2007-06-05, PLG-2009-09-07
 * current character is a [Character_but_Space] 
 * success: FILE = PREFIX . '{' [fileSpace*] # [Character_but_Space][Any*][EOF]
 *            <correct> remains unchanged
 *            <commentLineList> is set to the list of [Comment_string] encountered in [fileSpace*]
 * failure: FILE = PREFIX .#[Character_but_'{'][Any*][EOF]
 *             <correct> remains unchanged
 *          FILE = PREFIX . '{' [fileSpace*] # [EOF]
 *             error message is printed
 *             <correct> is set to false
 *          FILE = PREFIX . '{' ... # [EOF], reading failed
 *             error message has been printed
 *             <correct> is set to false
 */
_PROTECTED_ boolean Context::readIf_declOpening_fSpStar_nSp (boolean * correct, ref2ArgumentList * commentLineList)
{
  boolean
    lCorrect = pk_true;
  /* FILE = PREFIX . [Any*][EOF] */
  if (this_lexicalContext->stepIf_declOpening_fWhStar_nWh (&lCorrect))
    {
      /* FILE = PREFIX . '{' [fileWhite*]# [Character_but_White][Any*][EOF] */
      boolean
	isEof = pk_false;
      if (starRead_comment_fWhStar_ (commentLineList, &isEof))
	{
	  /* FILE = PREFIX . '{' [fileSpace*] # opt{[Character_but_Space][Any*]} [EOF] */
	  if (isEof)
	    {
	      this_lexicalContext->ASFatal_eof ();
	      (*correct) = pk_false;
	      return pk_false;
	    }
	  /* FILE = PREFIX . '{' [fileSpace*] # opt{[Character_but_Space][Any*]} [EOF] */
	  return pk_true;
	}
      (*correct) = pk_false;
      return pk_false;
    }
  /* FILE = PREFIX .# opt{[Any_but_'{'][Any*]}[EOF]
   *             <correct> remain unchanged, 
   * FILE = PREFIX . '{' [fileWhite*] # [EOF]
   *             <correct> is set false
   *             this is set ERRORCOMPLETED
   * some error occurred
   *             <correct> is set false
   *             this is set ERRORCOMPLETED
   */
  if (lCorrect)
    return pk_false;
  (*correct) = pk_false;
  return pk_false;
}

/* 2005-01-21, PLG 2007-06-05, PLG 2008_07-03, PLG 2009-07-08
 * reads contextual syntax marks
 * success:  FILE = PREFIX . '$$'[_SyntaxAdaptation][fileSpace+] # opt{[Character_but_Space][Any*]}[EOF]
 *            or   PREFIX . '$$'[_SyntaxAdaptation] # [EOF]
 *            with [_SyntaxAdaptation] = [leftCharacter][rightCharacter]opt{[commandCharacter]opt{[stringCharacter]}}
 *                                        <leftChar>, <rightChar>, <commandChar>, <stringChar> conflict free
 *                   <newLexical> is set TRUE
 *                   a new Lexical is pushed and assigned to <new_lexicalContext>
 *                          <its_openingChar>, <its_closingChar>, <its_commandChar>, <its_stringChar> are respectively assigned
 *                               <leftChar>, <rightChar>, <commandChar>, <stringChar> (or previous alue when tag is missing)
 *          FILE = PREFIX . '$$'[fileSpace+] # [Character_but_Space][Any*][EOF],
 *            or   PREFIX . '$$'[fileSpace*] # [EOF]
 *            or   PREFIX .# [eol][fileSpace*]opt{[Character_but_Space][Any*]}[EOF]
 *            or   PREFIX .# opt{[Character_but_'$$'][Any*]}[EOF]
 *                   <newLexical>, <new_lexicalContext> remain unchanged
 *          if [EOF] is reached, <isEof> is set TRUE and this is set COMPLETED
 * failure: FILE = PREFIX . '$$'[_SyntaxAdaptation][fileSpace+] # opt{[Character_but_Space][Any*]}[EOF]
 *            or   PREFIX . '$$'[_SyntaxAdaptation] # [EOF]
 *                  some marks in [_SyntaxAdaptation] are in conflict
 *          FILE = PREFIX . '$$'opt{[leftCharacter]} # [EOF]
 *                <isEof> is set TRUE and this is set COMPLETED
 *          FILE = PREFIX . '$$'opt{[leftCharacter]}[fileSpace+] # opt{[Character_but_Space][Any*]}[EOF]
 *                if [EOF] is reached, <isEof> is set TRUE and this is set COMPLETED
 *          FILE = PREFIX . '$$'opt{[leftCharacter]opt{[rightCharacter]opt{[commandCharacter]}}} # [reservedCharacter][Any*][EOF]
 *                error message is printed
 *          FILE = PREFIX . '$$'[leftCharacter][rightCharacter][commandCharacter][stringCharacter] # [Character_but_Space][Any*][EOF]
 *          <new_lexicalContext>, <newLexical> remain unchanged
 *          FILE = PREFIX . ... [EOF], reading failed
 *          error message is printed
 */

_PROTECTED_ boolean Context::readOpt_lexical_fSpStar_ (boolean * newLexical, boolean * isEof)
{
  return this_lexicalContext->stepOpt_lexical_fSpStar_ (newLexical, &this_lexicalContext, isEof);
}

/* ==================== argument
 */


/* ==================== ancestor
 */

/* 2004-12-24
 * success: cursor starts [NODE_IDENTIFICATION] [lineSpaces]
 * failure: cursor starts inaccurate term
 *          cursor is moved to errored position in file
 *          <correct> is set to false
 *          error messag is printed
 */
_PRIVATE_ boolean Context::read_nodeRef_nl (ref2NodeElement * theIdentNode, int *dependenceNature, boolean * highDependenceLevel)
{
  char *
    CString_name;
  boolean
    isvar,
    isFile;
  boolean
    isEol;

  if (read_nodeIdentifier_spStar_ (&CString_name, &isvar, &isFile, &isEol))
    {				/* _spStar_ */
      /*current character immediately after the atom */
      (*theIdentNode) = this_contextTree->get_nodeReference (CString_name, isvar, isFile);
      (*theIdentNode)->setReferredTo ();
      return this_lexicalContext->stepOpt_antecedenceModality_eol_ (dependenceNature, highDependenceLevel);
      /* success: FILE = PREFIX . opt{ '~'opt{[lineSpaces]} }[eol] # [Any*][EOF] 
       *              <dependenceNature> is set to newerBuildCODE
       *              <highDependenceLevel> is set  FALSE if '~' is present, TRUE otherwise
       *          FILE = PREFIX . '!'opt{[White*]'*'}opt{[lineSpaces]}[eol] # [Any*][EOF]
       *              <dependenceNature> is set to everBuildCODE
       *              <highDependenceLevel> is set TRUE if '*' is present, FALSE otherwise
       *          FILE = PREFIX . '-'opt{[White*]'~'}opt{[lineSpaces]}[eol] # [Any*][EOF]
       *              <dependenceNature> is set to missingBuildCODE
       *              <highDependenceLevel> is set FALSE if '~' is present, TRUE otherwise
       * failure: none of the above case occurs 
       *             error message is printed 
       */
    }
  return pk_false;
}

/* 2005-01-03
 * reads and appends this ancestor and its following ancestors 
 * success: cursor starts [ANCESTOR_HEADER] [lineSpaces_eol] [_ACTION_eol*] [ANCESTOR*] [NOT_ANCESTOR]
 *             where 
 *                [ANCESTOR] ::= '}?' [fileSpace*] [ANCESTOR_HEADER] [lineSpaces_eol] [_ACTION_eol*]
 *                [ANCESTOR_HEADER] ::= [NODE_Identifier] { [White*] [Antecedence_attribute] + [] }
 *                [Antecedence_attribute] ::= [neverTAG] + [everTAG] [White*] <recursiveTAG>
 *                [NOT_ANCESTOR] ::= [Character*], '}?' is not a prefix of [Character*], [NOT_ANCESTOR] follows [eol]
 *             cursor is moved to head of [NOT_ANCESTOR]
 *             returns in <ancestorList_res> the list of ancestors that has been read
 * failure: cursor starts inaccurate term
 *          cursor is moved to errored position in file
 */
_PRIVATE_ boolean Context::read_nodeRef__ancestorList_nl (ref2AncestorList * ancestorList_res)
{
  ref2NodeElement
    referredToNode;
  int
    dependenceNature;
  boolean
    dependenceLevel;
  if (read_nodeRef_nl (&referredToNode, &dependenceNature, &dependenceLevel))
    {
      /* referredToNode is supposed not NIL */
      ref2LineList
	ancestorAction;
      if (readExpand_lineList_nl (&ancestorAction))
	{
	  ref2AncestorList
	    ancestorListTail_res;
	  if (readOpt_ancestorList_eol_ (&ancestorListTail_res))
	    {
	      (*ancestorList_res) = new AncestorList (referredToNode, dependenceNature, dependenceLevel, ancestorAction, ancestorListTail_res);
	      return pk_true;
	    }
	}
    }
  (*ancestorList_res) = NIL_AncestorList;
  return pk_false;
}

/* PLG 2008_07-02
 * reads and appends this ancestor and its following ancestors 
 * success: FILE = PREFIX . [_ANCESTOR*]#'}'[Any*][EOF]
 *             where 
 *                [ANCESTOR] ::= <ANCESTOR_mark> [fileSpace*] [ANCESTOR_HEADER] [lineSpaces_eol] [_ACTION_eol*]
 *                         <ANCESTOR_mark> ::= '}?'
 *                    [_ANCESTOR_HEADER] ::= [NODE_IDENTIFICATION] [White*] [Antecedence_attribute]
 *                    [_ANCESTOR_HEADER] ::= [NODE_IDENTIFICATION]
 *                    [_ANCESTOR_HEADER] ::= [ITERATOR_fSp] [ANCESTOR_CALL]  
 *                    [_ANCESTOR_HEADER] ::= [ANCESTOR_CALL]  
 *                    [Antecedence_attribute] ::= [neverTAG] + [everTAG] [White*] <recursiveTAG>
 *                <ANCESTOR_mark> is not a prefix of '}'[Any*][EOF]
 * failure: cursor starts inaccurate term
 */
_PUBLIC_ boolean Context::readOpt_ancestorList_eol_ (ref2AncestorList * ancestorList_res)
{
  // log_ASDEBUG("Context::readOpt_ancestorList_eol_");
  boolean
    lCorrect = pk_true;
  if (this_lexicalContext->stepIf_ancestorMark_fSpStar_nSp (&lCorrect))
    {
      /* FILE = PREFIX . '}?'[fileSpace*] # [Character_but_Space][Any*][EOF] */
      ref2AncestorFunctionCall
	ancestorFunctionCall;
      if (readIf_ancestorCall_eol_ (&lCorrect, &ancestorFunctionCall))
	{
	  if (ancestorFunctionCall->call (this, ancestorList_res))
	    {
	      /* ancestorList_res may be NIL; it may have several dependences each provided with post ancestor actions */
	      ref2LineList
		ancestorAction;
	      if (readExpand_lineList_nl (&ancestorAction))
		{
		  ref2AncestorList
		    ancestorListTail_res;
		  if ((*ancestorList_res) == NIL_AncestorList)
		    /* ancestor actions are lost when reference set is empty */
		    return readOpt_ancestorList_eol_ (ancestorList_res);
		  if (ancestorAction != NIL_LineList)
		    (*ancestorList_res)->append_ancestorActions (ancestorAction);
		  if (readOpt_ancestorList_eol_ (&ancestorListTail_res))
		    {
		      if (ancestorListTail_res != NIL_AncestorList)
			(*ancestorList_res)->append (ancestorListTail_res);
		      return pk_true;
		    }
		}
	    }
	  (*ancestorList_res) = NIL_AncestorList;
	  return pk_false;
	}
      return read_nodeRef__ancestorList_nl (ancestorList_res);
    }
  /* FILE = PREFIX .# [Any_but_'}?'][Any*][EOF]
   *            <correct> remains unchanged
   * FILE = PREFIX . '}?'[fileSpace*] # [EOF]
   * or FILE = PREFIX . ... [EOF], reading failed
   *            error message is printed
   *            <correct> is set FALSE
   *            this is set  ERRORCOMPLETED or ERRORCLOSED
   */
  (*ancestorList_res) = NIL_AncestorList;
  return lCorrect;
}

/* ==================== node
 */

/* 2004-11-25
 * reads file declaration attributes
 * success: FILE = PREFIX . '(' [fileSpace*] [StringConstant] [fileSpace*] [SingleCharString] [fileSpace*] ')' [fileSpace*] # [Character_but_Space][Any*][EOF]
 *             <breakCharList> value is set to [StringConstant] occurrence
 *             <continuationMark> value has a single <Character>; it is set to [SingleCharString] 
 * failure: FILE = PREFIX .# [Character_but_Space][Any*][EOF], [Character_but_Space] is not '(' 
 *             <correct> remains unchanged
 *          FILE = PREFIX . '(' [fileSpace*] [StringConstant] [fileSpace*] [SingleCharString] [fileSpace*] ')' [fileSpace*] # [EOF]
 *          or reading failed
 *             <correct> is set to false
 *             error message is printed
 *          
 */
_PUBLIC_ boolean Context::readIf_splittingAttributes_fSpStar_nSp (boolean * correct, char **breakCharList, char *continuationMark)
{
  return this_lexicalContext->stepIf_splittingAttributes_fSpStar_nSp (correct, breakCharList, continuationMark);
}


/* 2005-01-31 syntax
 * reads a list of context files possibly preceded by spaces
 * success: all files in <nameLst> have been previously loaded or are successfully loaded
 *          registers context files
 * failure: error message is printed
 */
/* ==> 2-6 */
_PRIVATE_ boolean Context::load_contextList (ref2MKFFileNode loader, ref2CStringList nameLst)
{
  // fprintf(stderr,"load_contextList in %s, line %d\n",__FILE__,__LINE__);
  boolean
    lCorrect = pk_true;
  boolean
    newFile = pk_false;
  boolean
    isMissing = pk_false;
  char *
    curFile_name;
  ref2MKFFileNode
    curMKFFile;
  // logDEBUG_in("load_contextList, X=================================X");
  while (nameLst != NIL_CStringList)
    {
      // fprintf(stderr,"load_contextList in %s, line %d\n",__FILE__,__LINE__);
      curFile_name = nameLst->content ();
      // fprintf(stderr,"load_contextList in %s, line %d\n",__FILE__,__LINE__);
      nameLst = nameLst->next ();
      // fprintf(stderr,"load_contextList in %s, line %d\n",__FILE__,__LINE__);
      // fprintf(stderr,"     name file is %s\n",curFile_name);
      if (this_contextTree->getIf_mkfFileOccurrence (this, curFile_name, &curMKFFile, &isMissing))
	{
	  if (!isMissing)
	    {
	      // fprintf(stderr,"load_contextList in %s, line %d\n",__FILE__,__LINE__);
	      if (!(curMKFFile->loadIf_innerFileContext (this_contextTree, loader, &newFile)))
		lCorrect = pk_false;
	      if (newFile)
		{
		  // fprintf(stderr,"load_contextList in %s, line %d\n",__FILE__,__LINE__);
		  debugInfo_backToContext ();
		  newFile = pk_false;
		}
	      // fprintf(stderr,"load_contextList in %s, line %d\n",__FILE__,__LINE__);
	      /* else curMKFFile is in error; error message has been printed */
	    }
	}
      else
	/* curFile_name not found; error message has been printed */
	lCorrect = pk_false;
    }
  // fprintf(stderr,"load_contextList in %s, line %d\n",__FILE__,__LINE__);
  return lCorrect;
}

/* ===== READ COMMAND 11: read_nodeEquation_fSpStar_nSp =====
 */
/* ==================== node body
 */

/* PLG 2008_07-02
 * reads and sets this_metaPrelude, these_genericAncestors and this_defaultMetaAction contents
 * success: FILE = PREFIX . opt{[_PRELUDE]}#'}'[Any*][EOF]
 *          where
 *             [PRELUDE] ::= '{' [lineSpaces_eol] [_line*], none of the [_line*] begins with '}'
 * failure: some error occurred during component reading
 *          error message is printed
 */
_PUBLIC_ boolean Context::readOpt_nodePrelude_eol_ (ref2LineList * prelude)
{
  // log_ASDEBUG("Context::readOpt_nodePrelude_eol_");

  boolean
    lCorrect = pk_true;
  if (this_lexicalContext->stepIf_bodyPreludeO_spStar_eol_ (&lCorrect))
    /* FILE = PREFIX . '{' opt{[lineSpaces]}[eol] # [Any*][EOF], <correct> remains unchanged */
    return readExpand_lineList_nl (prelude);
  /* FILE = PREFIX .# [Any_but_'{'][Any*][EOF]
   *             <correct> remains unchanged
   *          FILE = PREFIX . '{' [White*] # [Character_but_Space][Any*] 
   *          or FILE = PREFIX . '{' opt{[lineSpaces]} # [EOF]
   *          or FILE = PREFIX . ... [EOF], reading failed
   *             <lCorrect> is set FALSE
   *             error message is printed
   *             this is set ERRORREADY or ERRORCOMPLETED */
  (*prelude) = NIL_LineList;
  return lCorrect;
}

/* PLG 2008_07-02
 * reads and sets this_metaPrelude, these_genericAncestors and this_defaultMetaAction contents
 * success: FILE = PREFIX . opt{[_DEFAULT]}#'}'[Any*][EOF]
 *          where
 *             [DEFAULT] ::= <DEFAULT_mark> [lineSpaces_eol] [_line*], none of the [_line*] begins with '}'
 *                  <DEFAULT_mark> ::= '}/'
 * failure: some error occurred during component reading
 *          error message is printed
 */
_PUBLIC_ boolean Context::readOpt_nodeDefault_eol_ (ref2LineList * default_res)
{
  // log_ASDEBUG("Context::readOpt_nodeDefault_eol_");

  boolean
    lCorrect = pk_true;
  if (this_lexicalContext->stepIf_defaultOpeningLine_eol_ (&lCorrect))
    /* FILE = PREFIX . '}/'opt{[lineSpaces]}[eol] # [Any*][EOF] */
    return readExpand_lineList_nl (default_res);
  /* FILE = PREFIX .# [Character_but_Space][Any*], '}/' is not a prefix of [Character_but_Space][Any*]
   *             <correct> remains unchanged
   *          FILE = PREFIX . '}/' [White*] # [Character_but_Space][Any*] 
   *          or FILE = PREFIX . '}/' opt{[lineSpaces]} # [EOF]
   *          or FILE = PREFIX . ... [EOF], reading failed
   *             <correct> is set FALSE
   *             error message is printed
   *            this is set  ERRORCOMPLETED or ERRORCLOSED */
  (*default_res) = NIL_LineList;
  return lCorrect;
}

/* 2004-11-22
 * reads a node name beginning at current position
 * success: FILE = PREFIX . [NODE_IDENTIFICATION] [fileSpace*]#[Character_but_Space][Any*][EOF]
 *          where
 *            [NODE_XX] ::= [VAR_XX]
 *                 set <isVar> to pk_true
 *            [NODE_XX] ::= [FILE_XX]
 *                 set <isVar> to pk_false, <isFile> to pk_true 
 *            [NODE_XX] ::= [EXTERN_XX]
 *                 set <isVar> to pk_false, <isFile> to false 
 *          returns the node name in <CString_name> (unsafe)
 * failure: on syntax error
 *             error message is printed
 *             cursor is moved to errored position
 *             <CString_name> remains unchanged
 */
/* ===== READ COMMAND 11-1: read_nodeIdentifier_fSpStar_nSp =====
 */
_PRIVATE_ boolean Context::read_nodeIdentifier_fSpStar_nSp (char **CString_name, boolean * isvar, boolean * isFile)
{
  boolean
    isEol;
  if (read_nodeIdentifier_spStar_ (CString_name, isvar, isFile, &isEol))
    {
      if (isEol)
	return this_lexicalContext->req_nl_fSpStar_nSp ();	/* success: FILE = PREFIX . [Character*][eol][fileSpace*] #[Character_but_Space][Any*][EOF]
								 * failure: FILE = PREFIX . [Character*]opt{[eol][fileSpace*]}#[EOF] */
      return pk_true;
    }
  return pk_false;
}

/* ===== READ COMMAND 11-2: read_VarDecl_fSpStar_nSp =====
 */
/* 2005-01-21
 * success: <CString_name> is a variable name that is not yet defined and
 *             FILE = PREFIX[VAR_IDENTIFICATION_fSpStar] . opt{[execTag_fSpStar]} [_NODE_BODY_fSpStar]#'}'[Any*][EOF]
 *          cursor is moved to [eoX]
 * failure: syntax error
 *             cursor is moved to errored character
 *          double declaration
 *             cursor remains unchanged
 *          sets this node errored
 *          error message is printed
 */
/* ==> 1-2 */
_PRIVATE_ boolean Context::read_VarDecl_fSpStar_nSp (char *CString_name, ref2ArgumentList comments)
{
  // log_ASDEBUG("Context::read_VarDecl_fSpStar_nSp");
  boolean
    isBuildable,
    isExec,
    isCond;
  if (this_lexicalContext->stepOpt_varDefinitionMode_fSpStar_nSp (&isBuildable, &isExec, &isCond))
    {
      /* FILE = PREFIX . opt{<commandChar>[execWORD][White*]}['/'][fileSpace*] # [Character_but_Space][Any*][EOF]
       *              (isBuildable,isCond,isExec) = (pk_true,true,isExec), isExec is pk_true iff [execWORD] is present
       *          FILE = PREFIX . <commandChar>[execWORD][fileSpace*] # [Character_but_Space][Any*][EOF]
       *                  if [fileSpace*] is empty  opt{[Character_but_Space][Any*]} does not start with an IdentCharacter
       *                  if [fileSpace*] has no [eol] occurrence,   opt{[Character_but_Space][Any*]} does not start with '/'
       *             (isBuildable,isCond,isExec) = (pk_true,false,true)
       *          FILE = PREFIX .# [Any*][EOF], first [Any] not in {':', '/', '~'}
       *             (isBuildable,isCond,isExec) = (pk_true,false,false)
       *          FILE = PREFIX . '~'[fileSpace*] # [Character_but_Space][Any*][EOF]
       *             (isBuildable,isCond,isExec) = (pk_false,false,false)
       */
      ref2VariableNode
	curVariableNode;
      if (this_contextTree->getIf_variableDeclaration (this, CString_name, isExec, &curVariableNode))
	{
	  if (curVariableNode->read_dataDecl_fSpStar_nSp (comments, isBuildable, isExec, isCond))
	    {
	      printORlevelInfo_declCompletion (curVariableNode);
	      return pk_true;
	    }
	  return pk_false;
	}
      return pk_false;
    }
  /* FILE = PREFIX . opt{<commandChar>[execWORD][White*]}['/'][fileSpace*] # [EOF]
   *          FILE = PREFIX . <commandChar>[execWORD][fileSpace*] # [EOF]
   *          FILE = PREFIX . '~'[fileSpace*] # [EOF]
   *          FILE = PREFIX . <commandChar>[execWORD]opt{[lineSpaces]} ... # [EOF], reading failed
   *                (isBuildable,isCond,isExec) = (pk_true,true,false)
   *          FILE = PREFIX . <commandChar>[execWORD][White*]['/']opt{[lineSpaces]} ... # [EOF], reading failed
   *                (isBuildable,isExec,isCond) = (pk_true,true,true)
   *          FILE = PREFIX .# <commandChar>opt{[eol][Any*]}[EOF]
   *            or = PREFIX .# <commandChar>[execWORD][Identifier][Character*]opt{[eol][Any*]}[EOF]
   *            or = PREFIX .# <commandChar>[Character+]opt{[eol][Any*]}[EOF], [execWORD] is not a prefix of [Character+]
   *            or = PREFIX . ... # [EOF], reading failed
   *                (isBuildable,isExec,isCond) remain unchanged
   *          error message is printed
   */
  return pk_false;
}

/* ===== READ COMMAND 11-3: read_FileDecl_fSpStar_ =====
 */
/* 2005-01-21
 * success: <CString_name> is a simple file name that is not yet defined and
 *             cursor starts [_NODE_BODY] '}'[lineSpaces][eoX]
 *          <CString_name> is a direct file name that is not yet defined and
 *             cursor starts [Direct_attribute_fSp] [_NODE_BODY] '}'[lineSpaces][eoX]
 *          cursor is moved to [eoX]
 * failure: syntax error
 *             cursor is moved to errored character
 *          double declaration
 *             cursor remains unchanged
 *          sets this node errored
 *          error message is printed
 */
/* ==> 1-3 */

_PRIVATE_
  boolean Context::read_FormatFileNode_fSpStar_ (char *CString_name,
						 boolean exec_or_build, char *breakCharList, char continuationChar, ref2ArgumentList comments)
{
  ref2FormattedFileNode
    curFormattedFileNode;
  // log_ASDEBUG("Context::read_FormatFileNode_fSpStar_");
  if (this_contextTree->getIf_formattedFileDeclaration (this, CString_name, exec_or_build, breakCharList, continuationChar, &curFormattedFileNode))
    if (curFormattedFileNode->read_dataDecl_fSpStar_nSp (comments, pk_false, "formatted file"))
      {
	printORlevelInfo_declCompletion (curFormattedFileNode);
	return pk_true;
      }
  return pk_false;
}

_PRIVATE_ boolean Context::read_DirectFileNode_fSpStar_ (char *CString_name, boolean exec_or_build, ref2ArgumentList comments)
{
  ref2DirectFileNode
    curDirectFileNode;
  if (this_contextTree->getIf_directFileDeclaration (this, CString_name, exec_or_build, &curDirectFileNode))
    if (curDirectFileNode->read_dataDecl_fSpStar_nSp (comments, pk_false, "to be written file"))
      {
	printORlevelInfo_declCompletion (curDirectFileNode);
	return pk_true;
      }
  return pk_false;
}

_PRIVATE_ boolean Context::read_FileNode_fSpStar_ (char *CString_name, ref2ArgumentList comments)
{
  ref2FileNode
    curFileNode;
  if (this_contextTree->getIf_fileDeclaration (this, CString_name, &curFileNode))
    {
      if (curFileNode->read_dataDecl_fSpStar_nSp (comments, pk_false, "built file"))
	{
	  printORlevelInfo_declCompletion (curFileNode);
	  return pk_true;
	}
    }
  return pk_false;
}

/* ----- READ COMMAND 11-3: read_FileDecl_fSpStar_ -----
 */
_PRIVATE_ boolean Context::read_FileDecl_fSpStar_ (char *CString_name, ref2ArgumentList comments)
{
  boolean
    isWrite,
    isExec;
  // log_ASDEBUG("Context::read_FileDecl_fSpStar_");
  if (this_lexicalContext->stepOpt_fileDefinitionMode_fSpStar_nSp (&isWrite, &isExec))
    {
      /* FILE = PREFIX . <commandChar>'exec'[fileSpace*] # [Character_but_Space][Any*][EOF]
       *             <isWrite> is set TRUE
       *             <isExec> is set TRUE
       *          FILE = PREFIX . <commandChar>'write'[fileSpace*] # [Character_but_Space][Any*][EOF]
       *             <isWrite> is set TRUE
       *             <isExec> is set FALSE
       *          FILE = PREFIX .# [Character_but_Space_but_<commandChar>][Any*][EOF]
       *             <isWrite> is set FALSE
       *             <isExec> remain unchanged
       */
      if (isWrite)
	{
	  boolean
	    lCorrect = pk_true;
	  char *
	    breakCharList;
	  char
	    continuationChar;
	  if (this_lexicalContext->stepIf_splittingAttributes_fSpStar_nSp (&lCorrect, &breakCharList, &continuationChar))
	    return read_FormatFileNode_fSpStar_ (CString_name, isExec, breakCharList, continuationChar, comments);
	  if (lCorrect)
	    return read_DirectFileNode_fSpStar_ (CString_name, isExec, comments);
	  return pk_false;
	}
      return read_FileNode_fSpStar_ (CString_name, comments);
    }
  /* FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [Any*][EOF]
   *             [Identifier] is neither 'exec' nor 'write'
   *          FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [EOF]
   *             [Identifier] is either 'exec' or 'write'
   *          FILE = PREFIX . ... [EOF], reading failed
   *          error message is printed
   */
  return pk_false;
}

/* ===== READ COMMAND 11-4: read_ExternDecl_fSpStar_ =====
 */
/* 2005-01-21
 * reads empty declaration content
 * success: <CString_name> is an extern name that is not yet defined and 
 *          cursor starts '}' [lineSpaces][eoX]
 *          cursor is moved to [eoX]
 * failure: syntax error
 *             cursor is moved to errored character
 *          double declaration
 *             cursor remains unchanged
 *          sets this node errored
 *          error message is printed
 */
/* ==> 1-1 */
_PRIVATE_ boolean Context::read_ExternDecl_fSpStar_ (char *CString_name, ref2ArgumentList comments)
{
  ref2ExternNode
    curExternNode;
  if (this_contextTree->getIf_externDeclaration (this, CString_name, &curExternNode))
    {
      if (curExternNode->read_dataDecl_fSpStar_nSp (comments))
	{
	  printORlevelInfo_declCompletion (curExternNode);
	  return pk_true;
	}
    }
  return pk_false;
}

/* ----- READ COMMAND 11: read_nodeEquation_fSpStar_nSp -----
 */
/* 2005-01-31, PLG 2007-06-20 (syntax)
 * success: FILE = PREFIX'{'[fileSpace*] opt{[SyntaxAdaptor_fSpPlus]} . [_NODE_EQUATION_fSpStar]#'}'[Any*][EOF]
 *          FILE = PREFIX'{'[fileSpace*] opt{[SyntaxAdaptor_fSpPlus]} . opt{[ITERATOR_fSpStar]} [NODE_CALL_fSpStar]#'}'[Any*][EOF]
 *                 [_NODE_EQUATION] ::= [EXTERN_Identifier]
 *                 [_NODE_EQUATION] ::= [FILE_IDENTIFICATION_fSpStar] opt{[Direct_attribute_fSpStar]} [FILE_NODE_BODY]
 *                 [_NODE_EQUATION] ::= [VAR_IDENTIFICATION_fSpStar] opt{[execTag_fSpStar]} [VAR_NODE_BODY] 
 * failure: error message is printed
 */
_PRIVATE_ boolean Context::read_nodeEquation_fSpStar_nSp (ref2ArgumentList comments)
{
  char *
    CString_name;
  boolean
    isvar,
    isFile;

  // log_ASDEBUG("Context::read_nodeEquation_fSpStar_nSp");
  if (read_nodeIdentifier_fSpStar_nSp (&CString_name, &isvar, &isFile))
    {
      if (isvar)
	/*  FILE = PREFIX . [VAR_IDENTIFICATION_fSpStar]#opt{[execTAG_fSpStar]} [VAR_NODE_BODY_fSpStar] '}' [Any*][EOF] */
	return read_VarDecl_fSpStar_nSp (CString_name, comments);
      if (isFile)
	/* FILE = PREFIX . [FILE_IDENTIFICATION_fSpStar]#opt{[Direct_attribute_fSpStar]} [FILE_NODE_BODY_fSpStar] '}' [Any*][EOF] */
	return read_FileDecl_fSpStar_ (CString_name, comments);
      /*  FILE = PREFIX . [EXTERN_Identifier_fSpStar]#'}' [Any*][EOF] */
      return read_ExternDecl_fSpStar_ (CString_name, comments);
    }
  return pk_false;
}

/* ===== READ COMMAND 12: read argument Equation_fSpStar_nSp =====
 */
/* 2004-11-22
 * reads in this_lexicalContext a variable name
 * success: current character starts [Identifier] [fileSpace*] [Character_but_Space]
 *            where [Identifier] is a ANSI C identifier
 *          returns in <CString_name> a new m'allocated copy of [Identifier]
 *          cursor is file moved to [Character_but_Space] following [Identifier]
 *          this_lexicalContext current atom is set to empty
 * failure: 'this_lexicalContext' cursor starts [Identifier] [fileSpace*] [EOF] or
 *          'this_lexicalContext' current character is not an [IdentHeaderCharacter] ::= [Letter] + '_'
 *                  error message is printed
 */
_PRIVATE_ boolean Context::read_varIdentification_fSpStar_nSp (char **CString_name)
{
  boolean
    lCorrect = pk_true;
  // log_ASDEBUG("Context::read_varIdentification_fSpStar_nSp");
  if (readIf_varIdentification_fSpStar_nSp (&lCorrect, CString_name))
    {
      return pk_true;
    }
  if (lCorrect)
    ASFatal_expected ("node variable identifier");
  return pk_false;
}

/* ===== READ COMMAND 12-2: read local ListEquation_fSpStar_nSp =====
 */

/* ----- READ COMMAND 12: read argument Equation_fSpStar_nSp -----
 */
/* 2005-01-10, PLG 2007-06-20(syntax)
 * Reads a string declaration
 * success: FILE = PREFIX'{'[fileSpace*] [commandChar]'string'[fileSpace*] . [_STRING_DEFINITION] #'}'[Any*][EOF]
 * failure: syntax or context errors occurred
 *          error messages is printed
 *          cursor is moved to errored position
 */
_PRIVATE_ boolean Context::read_stringEquation_fSpStar_nSp (ref2ArgumentList comments)
{
  // log_ASDEBUG("Context::read_stringEquation_fSpStar_nSp");
  boolean
    isGlobal;
  if (this_lexicalContext->stepOpt_scope_fSpStar_nSp (&isGlobal))
    {
      /* FILE = PREFIX . <commandChar>'static'[fileSpace*] # [Character_but_Space][Any*][EOF]
       *             first character in [fileSpace*][Character_but_Space] is not an [IdentCharacter]
       *             <isGlobal> is set TRUE
       *          FILE = PREFIX .# opt{[Any_but_<commandChar>][Any*]}[EOF]
       *             <isGlobal> is set FALSE */
      char *
	CString_name;
      if (read_varIdentification_fSpStar_nSp (&CString_name))
	{
	  ref2Argument
	    formula;
	  if (read_string_fSpStar_nSp (&formula))
	    {
	      // log_ASDEBUG("Context::read_stringEquation_fSpStar_nSp read_string_fSpStar_nSp DONE");
	      if (isGlobal)
		return appendNew_staticStringElement (comments, CString_name, formula);
	      return appendNew_localStringElement (comments, CString_name, formula);
	    }
	}
      return pk_false;
    }
  /* FILE = PREFIX .# <commandChar>[Identifier][fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
   *             [Identifier] is not  'static'
   * or FILE = PREFIX . <commandChar>'static'[fileSpace*] # [EOF]
   * or FILE = PREFIX . <commandChar> # [Any_but_IdentCharacter][Any*][EOF]
   * or FILE = PREFIX . ... [EOF], reading failed
   * or file is closed
   * error message is printed
   */
  return pk_false;
}

/* 2005-01-10, PLG 2007-06-20(syntax)
 * Reads a list of node declarations
 * success: FILE = PREFIX'{'[fileSpace*] [commandChar]'list' [fileSpace*] . [_LIST_DEFINITION] #'}'[Any*][EOF]
 * failure: syntax or context errors occurred
 *          error messages is printed
 *          cursor is moved to errored position
 */
_PRIVATE_ boolean Context::read_listEquation_fSpStar_nSp (ref2ArgumentList comments)
{
  // log_ASDEBUG("Context::read_listEquation_fSpStar_nSp");
  boolean
    isGlobal;
  char *
    CString_name;
  if (this_lexicalContext->stepOpt_scope_fSpStar_nSp (&isGlobal))
    {
      /* FILE = PREFIX . <commandChar>'static'[fileSpace*] # [Character_but_Space][Any*][EOF]
       *             first character in [fileSpace*][Character_but_Space] is not an [IdentCharacter]
       *             <isGlobal> is set TRUE
       *          FILE = PREFIX .# opt{[Any_but_<commandChar>][Any*]}[EOF]
       *             <isGlobal> is set FALSE */
      if (read_varIdentification_fSpStar_nSp (&CString_name))
	{
	  ref2Argument
	    formula;
	  if (read_list_fSpStar_nSp (&formula))
	    {
	      if (isGlobal)
		return appendNew_staticListElement (comments, CString_name, formula);
	      return appendNew_localListElement (comments, CString_name, formula);
	    }
	}
      return pk_false;
    }
  /* FILE = PREFIX .# <commandChar>[Identifier][fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
   *             [Identifier] is not  'static'
   * or FILE = PREFIX . <commandChar>'static'[fileSpace*] # [EOF]
   * or FILE = PREFIX . <commandChar> # [Any_but_IdentCharacter][Any*][EOF]
   * or FILE = PREFIX . ... [EOF], reading failed
   * or file is closed
   * error message is printed
   */
  return pk_false;
}


/* ===== READ COMMAND 16: read_functionDecl_C_fSpStar_ =====
 */
/* 2004-12-22, 2007-02-06, 2008-09-12
 * success: PREFIX1 = PREFIX '{' [fileSpace*] opt{[SyntaxAdaptor_fSpPlus]} <this_commandChar>'define' 
 *          SUFFIX = opt{[Character_but_Space][Character*]}[eoX] 
 *          FILE = PREFIX1 . [_FUNCTION_DECLARATION_fSpStar] '}:' [fileSpace*] # SUFFIX
 *          [_FUNCTION_DECLARATION_fSpStar] = [XTYPE_DECL_MARK_fSp] [FUNCTION_PROFILE_fSpStar] [XTYPE_FUNCTION_BODY_fSp]
 *
 *          [FUNCTION_PROFILE] ::= [FUNCTION_Identifier_fSpStar] [TypedIdentifier_LIST]; 
 *             [XTYPE_DECL_MARK] = <this_commandChar>'string'[fileSpace*] => [XTYPE_FUNCTION_BODY_fSp] = [string_ARGUMENT_fSp+*]
 *             [XTYPE_DECL_MARK] = <this_commandChar>'list'[fileSpace*]   => [XTYPE_FUNCTION_BODY_fSp] = [list_ARGUMENT_fSp+*]
 *             [XTYPE_DECL_MARK] = <this_commandChar>'ancestor'[fileSpace*] => [XTYPE_FUNCTION_BODY_fSp] = [_ANCESTOR*]
 *             [XTYPE_DECL_MARK] = <this_commandChar>'node'[fileSpace*] => [XTYPE_FUNCTION_BODY_fSp] = [inner_NODE_GENERATOR_fSp+]
 *             [XTYPE_DECL_MARK] = <this_commandChar>'context'[fileSpace*] => [XTYPE_FUNCTION_BODY_fSp] = [inner_NODE_GENERATOR_fSp+]
 *             [XTYPE_DECL_MARK] =  => [XTYPE_FUNCTION_BODY_fSp] = [inner_NODE_GENERATOR_fSp+]
 *            <eof> is set according to file termination status
 *
 * failure: FILE = PREFIX'{'[fileSpace*]<this_commandChar>'define'[fileSpace*] . [Any1*] '}:'[fileSpace*][Character_but_Space][Character*][EOF]
 *            syntax error is recovered, <eof> is set to false
 *          FILE = PREFIX'{'[fileSpace*]<this_commandChar>'define'[fileSpace*] . [Any*][EOF]
 *            syntax error cannot be recovered, <eof> is set to pk_true, file is closed
 *          error message is printed
 * 2004-12-22 */
_PRIVATE_ boolean Context::read_functionDecl_C_fSpStar_ (ref2ArgumentList comments, boolean inNewLexical, boolean * isEof)
{
  // log_ASDEBUG("entering Context::read_functionDecl_C_fSpStar_");
  int
    commandCode;
  /* FILE = PREFIX1 .# [XTYPE_DECL_MARK_fSp] [FUNCTION_PROFILE_fSpStar] [XTYPE_FUNCTION_BODY_fSp] '}:' [fileSpace*] SUFFIX */
  if (this_lexicalContext->stepOpt_functionType_fSpStar_nSp (&commandCode))
    {
      /* FILE = PREFIX . <commandChar>[functionType][fileSpace*] # [Character_but_Space][Any*][EOF]
       *              [functionType] belongs to {'ancestor', 'context', 'list', 'node' , 'string'}
       *              <funcTypeCode> is assigned the code associated with [functionType]
       *          FILE = PREFIX .# opt{[Any_but_<commandChar>][Any*]}[EOF]
       *              <funcTypeCode> is assigned nodeCODE */
      char *
	functionName;
      /* FILE = PREFIX1 . [XTYPE_DECL_MARK_fSp] # [FUNCTION_PROFILE_fSpStar] [XTYPE_FUNCTION_BODY_fSp] '}:' [fileSpace*] SUFFIX */
      if (this_lexicalContext->req_userIdentifier_fSpStar_nSp (&functionName))
	{
	  /* [Identifier] is not a reserved word
	   *          FILE = PREFIX . [Identifier][fileSpace+] # [Character_but_Space][Any*][EOF]
	   *          FILE = PREFIX . [Identifier] # [Character_but_Space_but_IdentCharacter][Any*][EOF]
	   *          <functionName> is loaded with a new m'allocated copy of [Identifier] */
	  ref2DynamicContext
	    parameterContext = new DynamicContext (this);
	  if (parameterContext->read_dynamicContext_fSpStar_nSp ())
	    {
	      /* FILE = PREFIX1 . [XTYPE_DECL_MARK_fSp] [FUNCTION_PROFILE_fSp] # [XTYPE_FUNCTION_BODY_fSp] '}:' [fileSpace*] SUFFIX */
	      ref2FunctionElement
		declaredFunction;
	      switch (commandCode)
		{
		case stringCODE:
		  {		/* FUNCPREFIX = <this_commandChar>'string'[fileSpace+][IDENTIFIER] */
		    /* FUNCBODY = [string_ARGUMENT_fSp+*] */
		    declaredFunction = new UserStringFunctionElement (this, functionName, parameterContext, comments);
		    break;
		  }
		case listCODE:
		  {		/* FUNCPREFIX = <this_commandChar>'list'[fileSpace+][IDENTIFIER] */
		    /* FUNCBODY = [list_ARGUMENT_fSp+*] */
		    declaredFunction = new UserListFunctionElement (this, functionName, parameterContext, comments);
		    break;
		  }
		case ancestorCODE:
		  {		/* FUNCPREFIX = <this_commandChar>'ancestor'[fileSpace+][IDENTIFIER] */
		    /* FUNCBODY = [_ANCESTOR*] */
		    declaredFunction = new AncestorFunctionElement (this, functionName, parameterContext, comments);
		    break;
		  }
		case nodeCODE:
		  {		/* FUNCPREFIX = <this_commandChar>'node'[fileSpace+][IDENTIFIER] */
		    /* FUNCBODY = [inner_NODE_GENERATOR_fSp+] */
		    declaredFunction = new ElementFunctionElement (this, functionName, new MetaContext (parameterContext), comments);
		    break;
		  }
		case contextCODE:
		  {		/* FUNCPREFIX = <this_commandChar>'context'[fileSpace+][IDENTIFIER] */
		    /* FUNCBODY = [inner_NODE_GENERATOR_fSp+] */
		    declaredFunction = new ElementFunctionElement (this, functionName, new MetaContext (parameterContext), comments);
		    break;
		  }
		default:
		  {
		    /* commandCode belongs to iterateCODE, userCODE */
		    this_lexicalContext->logERR_ln_LineColumn_ln__ln ("SYSTEM ERROR: unexpected function type in declaration");
		    if (inNewLexical)
		      this_lexicalContext = this_lexicalContext->pop ();
		    if (this_lexicalContext->recover_funcDecl_fSpStar_ (isEof));
		    return pk_false;
		  }
		}
	      /* FILE = PREFIX1 . [XTYPE_DECL_MARK_fSp] [FUNCTION_PROFILE_fSp] # [XTYPE_FUNCTION_BODY_fSp] '}:' [fileSpace*] SUFFIX */
	      if (declaredFunction->read_functionBody_fSpStar_nSp ())
		{
		  /* FILE = PREFIX1 . [_FUNCTION_DECLARATION_fSpStar] # '}:' [fileSpace*] SUFFIX */
		  if (this_contextTree->check_localDeclAbsence (functionName))
		    {
		      this_contextTree->register_element_ (declaredFunction);
		      if (inNewLexical)
			this_lexicalContext = this_lexicalContext->pop ();
		      if (this_lexicalContext->req_funcDeclClosing_fSpStar_ (isEof))
			/* FILE = PREFIX . '}:'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
			 *             if [EOF] is reached, <isEof> is set TRUE and this is set COMPLETED */
			return pk_true;
		      /* FILE = PREFIX . [Any_but_but_'}:']+  # '}:'[Any*][EOF]
		       *             if [EOF] is reached, <isEof> is set TRUE and this is set ERRORCOMPLETED
		       *             if [EOF] is not reached, <isEof> remains unchanged, and this is set ERRORREADY
		       *          FILE = PREFIX . [Any_but_'}:']*  # [EOF]
		       *             <isEof> is set TRUE and this is set ERRORCOMPLETED
		       */
		      declaredFunction->set_error ();
		      return pk_false;
		    }
		  ASFatal_doubleDecl (functionName);
		}
	      else
		{
		  if (inNewLexical)
		    this_lexicalContext = this_lexicalContext->pop ();
		  /* req_funcDeclClosing_fSpStar_ 
		   * success: FILE = PREFIX . '}:'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
		   *             if [EOF] is reached, <isEof> is set TRUE and this is set COMPLETED
		   * failure: FILE = PREFIX . [Any_but_but_'}:']+  # '}:'[Any*][EOF]
		   *             if [EOF] is reached, <isEof> is set TRUE and this is set ERRORCOMPLETED
		   *             if [EOF] is not reached, <isEof> remains unchanged, and this is set ERRORREADY
		   *          FILE = PREFIX . [Any_but_'}:']*  # [EOF]
		   *             <isEof> is set TRUE and this is set ERRORCOMPLETED
		   *          message is printed */
		  if (this_lexicalContext->recover_funcDecl_fSpStar_ (isEof));
		  return pk_false;
		}
	    }
	}
      /*  failure req_userIdentifier_fSpStar_nSp: 
       * FILE = PREFIX . [Identifier][fileSpace*] # [EOF]
       *                <CString_name> is loaded with a new m'allocated copy of [Identifier]
       *          FILE = PREFIX . [Identifier][fileSpace+] # [Any*][EOF]
       *                 [Identifier] is a reserved word
       *          FILE = PREFIX .# [Any_but_IdentCharacter][Any*][EOF]
       *          FILE = PREFIX . ... # [Any*][EOF], reading failed
       *          error message is printed */
    }
  /* failure stepOpt_functionType_fSpStar_nSp
   * FILE = PREFIX . <commandChar>[functionType][fileSpace*] # [EOF]
   *               this is set ERRORCOMPLETED 
   * FILE = PREFIX . <commandChar>[functionType] ...  # [EOF], reading failed
   *        this is set ERRORCOMPLETED 
   * FILE = PREFIX . <commandChar>[Identifier] # [Character*][fileSpace*] # opt{[Character_but_Space][Any*]}[EOF], 
   *                      [Identifier] does not belong to {'ancestor', 'context', 'list', 'node' , 'string'}
   *               this is set ERRORREADY
   * FILE = PREFIX . <commandChar> # [Any*][EOF], first [Any] in [Any*] is not an IdentCharacter
   *               this is set ERRORREADY
   * FILE = PREFIX . ... # [EOF], reading failed
   *               this is set ERRORREADY
   *  error message is printed;
   */
  if (inNewLexical)
    this_lexicalContext = this_lexicalContext->pop ();
  if (this_lexicalContext->recover_funcDecl_fSpStar_ (isEof));
  return pk_false;
}


/* ===== READ COMMAND 17: readCall_iterateElementDecl_fSpStar_nSp =====
 */
/* 2005-01-10, PLG 2007-06-20(syntax)
 * Reads an iterated command
 * success: FILE = PREFIX'{'[fileSpace*]<commandChar>'iterate'[fileSpace*] . [Iterator_LIST] [_ELEMENT_GENERATOR] #'}'[Any*][EOF] PLG currently NODE_CALL
 *             ( user defined command, 'static', 'string', 'list' ) can be iterated
 * failure: syntax or context errors occurred
 *          error messages is printed
 *          cursor is moved to errored position
 */
_PROTECTED_ boolean Context::read_elementList_inNewIteratorContext_fSpStar_nSp (ref2ArgumentList comments, ref2ElementFunctionCall * functionCall)
{
  // log_ASDEBUG("Context::read_elementList_inNewIteratorContext_fSpStar_nSp");
  ref2IteratorContext
    innerContext;
  if (new_iteratorContext_nSp (&innerContext))
    {
      char *
	functionName;
      if (this_lexicalContext->req_userElementaryCallHead_fSpStar_nSp (&functionName))
	{
	  boolean
	    isEof = pk_false;
	  /* FILE = PREFIX . <commandChar> [Identifier][fileSpace*] # [Character_but_Space][Any*][EOF]
	   *                 [Identifier] is not a reserved word
	   *                 first character in [fileSpace*][Character_but_Space] is not an [IdentCharacter]
	   *                 [Identifier] is assigned to <>functionName */
	  if (innerContext->read_elementFunctionCall_argList_fSpStar_ (comments, functionName, functionCall, &isEof))
	    {
	      printORlevelInfo_node_functionCallReading (functionName, (ref2FunctionCall) (*functionCall), comments);
	      return pk_true;
	    }
	  return pk_false;
	}
      /* req_userElementaryCallHead_fSpStar_nSp failure: 
       * FILE = PREFIX .# [Any_but_<commandChar>][Any*][EOF]
       * FILE = PREFIX . <commandChar>[Identifier] [fileSpace*] # opt{[Any_but_Space][Any*]}[EOF]
       *             [Identifier] is a reserved word
       * FILE = PREFIX . <commandChar>[Identifier][fileSpace*] # [EOF]
       *             [Identifier] is not a reserved word
       * FILE = PREFIX . <commandChar> # opt{[Any_but_IdentHeaderCharacter][Any*]}[EOF]
       * reading failed
       * an error message is printed */
    }
  return pk_false;
}

/* 2005-01-10, PLG 2007-06-20(syntax)
 * Reads an iterated command
 * success: FILE = PREFIX'{'[fileSpace*]<commandChar>'iterate'[fileSpace*] . [Iterator_LIST] [_ELEMENT_GENERATOR] #'}'[Any*][EOF] PLG currently NODE_CALL
 *             ( user defined command, 'static', 'string', 'list' ) can be iterated
 * failure: syntax or context errors occurred
 *          error messages is printed
 *          cursor is moved to errored position
 */
_PRIVATE_ boolean Context::readCall_iterateElementDecl_fSpStar_nSp (ref2ArgumentList comments)
{
  // log_ASDEBUG("Context::readCall_iterateElementDecl_fSpStar_nSp");
  ref2ElementFunctionCall
    pt2NodeCall;
  if (read_elementList_inNewIteratorContext_fSpStar_nSp (comments, &pt2NodeCall))
    return (pt2NodeCall->call (this, NIL_FunctionElement));
  return pk_false;
}


/* 2005-01-07, PLG 2007-06-20 (syntax)
 * Reads a declaration
 * <loader> is the context associated with MKFFileNode in which this file loading is processed
 * success: PREFIX1 = PREFIX '{' [fileSpace*] opt{[SyntaxAdaptor_fSpPlus]}
 *          SUFFIX = opt{[Character_but_Space][Character*]}[eoX] 
 *             FILE = PREFIX1
 *             FILE = PREFIX1 . <this_commandChar>'define' [_FUNCTION_DECLARATION_fSpStar] '}:' [fileSpace*] # SUFFIX
 *             FILE = PREFIX1 . [_ELEMENT_DECLARATION_fSpStar] '}' [fileSpace*] # SUFFIX
 *          [Comment_string] lines extracted from '{' [fileSpace*]  are registered in these_commentLines
 *                        of corresponding declaration
 * failure: syntax or context errors occurred
 *          error messages are printed
 * cursor is moved to end of file
 */
// NESTING close_read_eof::read_command_C_fSpStar_
_PRIVATE_ boolean Context::read_command_C_fSpStar_ (ref2MKFFileNode loader, ref2ArgumentList comments, boolean inNewLexical, boolean * isEof)
{
  // fprintf(stderr,"read_command_C_fSpStar_ in %s, line %d\n",__FILE__,__LINE__);
  int
    commandCode;
  char *
    functionName;
  boolean
    lCorrect;
  if (this_lexicalContext->stepIf_commandHead_fSpStar_nlORnSp (&commandCode, &functionName))
    {				/* new line if commandCode is bootCODE */
      /* commandCode belongs to defineCODE, userCODE, contextCODE, bootCODE, stringCODE, listCODE, iterateCODE, globalCODE */
      // fprintf(stderr,"read_command_C_fSpStar_ in %s, line %d\n",__FILE__,__LINE__);
      if (commandCode == defineCODE)
	return read_functionDecl_C_fSpStar_ (comments, inNewLexical, isEof);
      switch (commandCode)
	{
	case bootCODE:		/* [commandChar] 'boot' [lineSpaces] has been read */
	  lCorrect = readExec_boot_fSpStar_nSp (comments);	/* READ COMMAND 1 */
	  break;
	case contextCODE:	/* [commandChar] 'context' [fileSpace*] has been read */
	  // fprintf(stderr,"read_command_C_fSpStar_:contextCODE in %s, line %d\n",__FILE__,__LINE__);
	  lCorrect = readLoad_contextFileList_fSpStar_nSp (loader, comments);	/* READ COMMAND 4 */
	  // fprintf(stderr,"read_command_C_fSpStar_ in %s, line %d\n",__FILE__,__LINE__);
	  break;
	case userCODE:
	  {
	    ref2ElementFunctionCall
	      functionCall;
	    if (read_elementFunctionCall_argList_fSpStar_ (comments, functionName, &functionCall, isEof))
	      lCorrect = (functionCall->call (this, NIL_FunctionElement));
	    else
	      lCorrect = pk_false;
	    break;
	  }
	case iterateCODE:	/* 3 [commandChar] 'iterate' [fileSpace*] has been read */
	  lCorrect = readCall_iterateElementDecl_fSpStar_nSp (comments);	/* READ COMMAND 7 */
	  break;
	case stringCODE:
	  lCorrect = read_stringEquation_fSpStar_nSp (comments);
	  break;
	case listCODE:
	  lCorrect = read_listEquation_fSpStar_nSp (comments);
	  break;
	case globalCODE:
	  ASFatal_unexpected ("Command code in Context::read_command_C_fSpStar_ static not implemented");
	  lCorrect = pk_false;
	  break;
	default:
	  ASFatal_unexpected ("Command code in Context::read_command_C_fSpStar_");
	  lCorrect = pk_false;
	}
      if (inNewLexical)
	this_lexicalContext = this_lexicalContext->pop ();
      if (lCorrect)
	return this_lexicalContext->req_declClosing_fSpStar_ (isEof);
      /* req_declClosing_fSpStar_ success: FILE = PREFIX . '}'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF], '}' is not followed by ':'
       *             if [EOF] is reached, <isEof> is set TRUE and this is set COMPLETED */
      /* req_declClosing_fSpStar_ failure: FILE = PREFIX . [Any_but_'}'_but_'}:']+  # '}:'[Any*][EOF]
       *             if [EOF] is reached, <isEof> is set TRUE and this is set ERRORCOMPLETED
       *             if [EOF] is not reached, <isEof> remains unchanged, and this is set ERRORREADY
       *          FILE = PREFIX . [Any_but_'}'_but_'}:']+ '}'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
       *             if [EOF] is reached, <isEof> is set TRUE and this is set ERRORCOMPLETED
       *             if [EOF] is not reached, <isEof> remains unchanged, and this is set ERRORREADY
       *          FILE = PREFIX . [Any_but_'}'_but_'}:']*  # [EOF]
       *             <isEof> is set TRUE and this is set ERRORCOMPLETED */
      if (this_lexicalContext->recover_main_fSpStar_ (isEof));
      return pk_false;
    }				/* READ COMMAND 2 */
  /* commandCode belongs to errorCODE or notACommandCODE */
  // fprintf(stderr,"read_command_C_fSpStar_ in %s, line %d\n",__FILE__,__LINE__);
  if (commandCode == notACommandCODE)
    {
      if (read_nodeEquation_fSpStar_nSp (comments))
	{
	  if (inNewLexical)
	    this_lexicalContext = this_lexicalContext->pop ();
	  return this_lexicalContext->req_declClosing_fSpStar_ (isEof);
	  /* success: FILE = PREFIX . '}'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF], '}' is not followed by ':'
	   *             if [EOF] is reached, <isEof> is set TRUE and this is set COMPLETED */
	  /* failure: FILE = PREFIX . [Any_but_'}'_but_'}:']+  # '}:'[Any*][EOF]
	   *             if [EOF] is reached, <isEof> is set TRUE and this is set ERRORCOMPLETED
	   *             if [EOF] is not reached, <isEof> remains unchanged, and this is set ERRORREADY
	   *          FILE = PREFIX . [Any_but_'}'_but_'}:']+ '}'[fileSpace*] # opt{[Character_but_Space][Any*]}[EOF]
	   *             if [EOF] is reached, <isEof> is set TRUE and this is set ERRORCOMPLETED
	   *             if [EOF] is not reached, <isEof> remains unchanged, and this is set ERRORREADY
	   *          FILE = PREFIX . [Any_but_'}'_but_'}:']*  # [EOF]
	   *             <isEof> is set TRUE and this is set ERRORCOMPLETED */
	}
    }
  if (inNewLexical)
    this_lexicalContext = this_lexicalContext->pop ();
  if (this_lexicalContext->recover_main_fSpStar_ (isEof));
  return pk_false;
}

/* 2005-01-07
 * Reads a list of declarations
 * <loader> is the context associated with MKFFileNode in which this file loading is processed
 * success: FILE = PREFIX . [ELEMENT_fSpStar]*[Any_but_'{']*[EOF] 
 *             where 
 *                [ELEMENT] ::= '{' [fileSpace*] opt{[SyntaxAdaptor_fSpPlus]} <this_commandChar>'define' [_FUNCTION_DECLARATION_fSpStar] '}:' 
 *                [ELEMENT] ::= '{' [fileSpace*] opt{[SyntaxAdaptor_fSpPlus]} [_ELEMENT_DECLARATION_fSpStar] '}' 
 *          [Comment_string] lines extracted from '{' [fileSpace*]  are registered in these_commentLines
 *                        of corresponding declaration
 * failure: syntax or context errors occurred
 *          error messages are printed
 * cursor is moved to end of file
 */
_PRIVATE_ boolean Context::starRead_element_fSpStar_eof (ref2MKFFileNode loader)
{
  ref2ArgumentList
    comments = NIL_ArgumentList;;
  boolean
    lCorrect = pk_true, fullyCorrect = pk_true;
  boolean
    inNewLexical = pk_false;
  boolean
    isEof = pk_false;

  while (!isEof)
    {				/* open, not completed */
      // fprintf(stderr,"starRead_element_fSpStar_eof in %s, line %d\n",__FILE__,__LINE__);
      /* FILE = PREFIX . [ELEMENT*] # [Character_but_Space][Any*][EOF], some ELEMENT may be in error */
      if (readIf_declOpening_fSpStar_nSp (&lCorrect, &comments))
	{			/* 2009-09-07 OK */
	  // fprintf(stderr,"starRead_element_fSpStar_eof in %s, line %d\n",__FILE__,__LINE__);
	  /* FILE = PREFIX . [ELEMENT*]'{'[fileSpace*] # [Character_but_Space][Any*][EOF] */
	  if (readOpt_lexical_fSpStar_ (&inNewLexical, &isEof))
	    {
	      // fprintf(stderr,"starRead_element_fSpStar_eof in %s, line %d\n",__FILE__,__LINE__);
	      /* FILE = PREFIX . [ELEMENT*]'{'[fileSpace*] opt{[SyntaxAdaptor_fSpPlus]} # opt{[Character_but_Space][Any*]}[EOF] */
	      if (isEof)
		{
		  this_lexicalContext->ASFatal_eof ();
		  return pk_false;
		}
	      // fprintf(stderr,"starRead_element_fSpStar_eof in %s, line %d\n",__FILE__,__LINE__);
	      if (read_command_C_fSpStar_ (loader, comments, inNewLexical, &isEof))
		{
		  // fprintf(stderr,"starRead_element_fSpStar_eof in %s, line %d\n",__FILE__,__LINE__);
		  if (isEof)
		    return fullyCorrect;
		}
	      else
		{		/* should be [EOF] or recovered */
		  // fprintf(stderr,"starRead_element_fSpStar_eof in %s, line %d\n",__FILE__,__LINE__);
		  if (isEof)
		    return pk_false;
		  // fprintf(stderr,"starRead_element_fSpStar_eof in %s, line %d\n",__FILE__,__LINE__);
		  fullyCorrect = pk_false;
		}
	      inNewLexical = pk_false;
	    }
	  else
	    {
	      // fprintf(stderr,"starRead_element_fSpStar_eof in %s, line %d\n",__FILE__,__LINE__);
	      if (isEof)
		return pk_false;
	      if (!(this_lexicalContext->recover_main_fSpStar_ (&isEof)))
		return pk_false;
	      fullyCorrect = pk_false;
	    }
	}
      else
	{
	  // fprintf(stderr,"starRead_element_fSpStar_eof in %s, line %d\n",__FILE__,__LINE__);
	  if (!lCorrect)
	    /* FILE = PREFIX . [ELEMENT*] '{' [fileSpace*] # [EOF]
	     * FILE = PREFIX . [ELEMENT*] '{' ... # [EOF], reading failed
	     * error message has been printed
	     */
	    return pk_false;
	  /* FILE = PREFIX . [ELEMENT*] # [Character_but_'{'][Any*][EOF] */
	  if (!(this_lexicalContext->reachOpt_declOpening (&lCorrect)))
	    /* lCorrect TT: FILE = PREFIX . [ELEMENT*][Any_but_'{']*#[EOF] 
	       lCorrect FF: some error occured, error mesages have been printed  */
	    return lCorrect && fullyCorrect;
	}
      /* FILE = PREFIX . [ELEMENT*][Any_but_'{']*#'{' [Any*][EOF] */
    }				/* end while */
  return fullyCorrect;
}

/* 2005-01-10, PLG 2007-06-04 OK, PLG 2009-07-07
 * ENTRY POINT from MKFFileNode loading
 * Reads this file which expected content is a list of declarations
 * success: 
 *      FILE = [fileWhite*] . {[Comment_string] [eol][fileWhite*]}* opt{[SyntaxAdaptor_fSpStar]}[ELEMENT_fSpStar]*[EOF]#
 * failure: FILE = [fileWhite*] . [Any+][EOF]#, [Any+][EOF] in error
 *          error messages have been printed
 *          this is set in error
 */
/* PLG 2009-08-25 */
_PUBLIC_ boolean Context::close_read_eof (ref2ArgumentList * commentLines)
{
  // log_ASDEBUG("entering Context::close_read_eof");
  /* FILE = [fileWhite*] .#{[Comment_string][eol][fileWhite*]}* opt{[SyntaxAdaptor_fSpPlus]}[ELEMENT_fSpStar]*[EOF] */
  boolean
    isEof = pk_false;
  if (starRead_comment_fWhStar_ (commentLines, &isEof))
    {
      /* FILE = [fileWhite*] . {[Comment_string] [eol][fileWhite*]}* # opt{[SyntaxAdaptor_fSpPlus]}[ELEMENT_fSpStar]* [EOF] */
      ref2ContextTree
	caller = set_currentFileContextTree (this_contextTree);
      boolean
	inNewLexical = pk_false;
      if (readOpt_lexical_fSpStar_ (&inNewLexical, &isEof))
	{
	  /* FILE = [fileWhite*] . {[Comment_string] [eol][fileWhite*]}* opt{[SyntaxAdaptor_fSpPlus]} # [ELEMENT_fSpStar]* [EOF] */
	  printORlevelInfo_lexicalContext_ln ();	// log or  appends '$$' L R C S 'eol'to <this_outBuffer> 
	  if (starRead_element_fSpStar_eof (this_MKFFileContext))
	    {
	      /* FILE = [fileWhite*] . {[Comment_string] [eol][fileWhite*]}* opt{[SyntaxAdaptor_fSpPlus]} [ELEMENT_fSpStar]* # [EOF] */
	      if (inNewLexical)
		this_lexicalContext = this_lexicalContext->pop ();
	      caller = set_currentFileContextTree (caller);
	      closeFileReading ();
	      return pk_true;
	    }
	  /* syntax or context errors occurred, error messages have been printed */
	  if (inNewLexical)
	    this_lexicalContext = this_lexicalContext->pop ();
	}
      /* some syntactic error occurred, error messages have been printed */
      caller = set_currentFileContextTree (caller);
      closeFileReading ();
      return pk_false;
    }
  /* some syntactic error occurred, error messages have been printed */
  closeFileReading ();
  return pk_false;
}

/* ==========  ==========  ==========  ========== TITLE: BUILDER
 */
/* creates and returns a new inner context 
   with all attributes being the same as in <aContext>
 */
Context::Context (ref2Context embeddingContext):Soundness ()
{
  this_contextNumber = the_contextNumber;
  the_contextNumber = the_contextNumber + 1;
  // logDEBUG_contextLinking(embeddingContext->get_contextNumber());
  embeddingContext->get_attributes (&this_outBuffer, &this_MKFFileContext, &this_contextTree, &this_lexicalContext);
}

/* creates and returns a new static root context associated to <aMKFFile> 
 * each ref2MKFFileNode has its own Context
 * this is static
 */
Context::Context (ref2MKFFileNode aMKFFile):Soundness ()
{
  this_contextNumber = the_contextNumber;
  the_contextNumber = the_contextNumber + 1;
  // logDEBUG_contextLinking(0);
  this_MKFFileContext = aMKFFile;
  this_contextTree = new ContextTree (this);
  this_outBuffer = NIL_IntePrinter;
  this_lexicalContext = new Lexical ();
}

/*
 *
 * Static Elements
 *
 */
int
  Context::the_contextNumber;
ref2Context
  Context::the_staticContext;
ref2ContextTree
  Context::current_fileContextTree;

/** creates and returns a new static context used to errored and static declarations (the_staticContext)
 * this does not have reader
 * this scope is static
 * this outBuffer is the logBuffer
 */
Context::Context (ref2Lexical stdLexicalContext, ref2ContextTree rootContextTree):Soundness ()
{
  this_contextNumber = the_contextNumber;
  the_contextNumber = the_contextNumber + 1;
  // logDEBUG_contextLinking(-1);
  this_MKFFileContext = NIL_MKFFileNode;
  this_contextTree = rootContextTree;
  // this_outBuffer = LOGFILE();
  this_outBuffer = NIL_IntePrinter;
  this_lexicalContext = stdLexicalContext;
}

_STATIC_ ref2ContextTree
Context::set_currentFileContextTree (ref2ContextTree _contextTree)
{
  ref2ContextTree previousHighest = current_fileContextTree;
  current_fileContextTree = _contextTree;
  return previousHighest;
}

_STATIC_ ref2ContextTree
Context::setStatic ()
{
  the_contextNumber = 0;
  Lexical::setStatic ();
  ContextTree::setStatic (23, 23, 19, 7);
  the_staticContext = new Context (Lexical::the_staticLexical, ContextTree::the_staticContextTree);
  (ContextTree::the_staticContextTree)->linkToContext (the_staticContext);
  current_fileContextTree = NIL_ContextTree;
  return ContextTree::the_staticContextTree;
}
