/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

private:

/**
   It suspends the name setting for the built clocks during the current operation.
   The setting clock name operation is expensive for big programs. 
   It is done using a mark called NO_NAME_FOR_OBJ, global attribute defined in CompilerAttributes.h file.
   It is applied to each clock of a list (l).
 */
void /*exclusiveClocks::*/suspendNameSetting( ptlinsth l );

/**
   It updates the matrix (triangular) by setting the representative formula of each element.
 */
void /*exclusiveClocks::*/triangularMatrixFinalize( void );

/**
  It marks the clock vh1 and vh2
  - as exclusive when bexclusive : 
       - the matrix matrix[i][j] is set to null clock (i, j are the index of vh1/vh2 for the matrix calculus).
       - matrix DoneMatrix[i][j] is set to pk_true.	
  - as not exclusive otherwise: the matrix DoneMatrix[i][j] is set to pk_true.
 */
void /*exclusiveClocks::*/setExclusiveInfo( ptinsth vh1 ,ptinsth vh2 ,boolean bexclusive );

/**
   The clocks vh1 and vh2 are marked as exclusive (setExclusiveInfo()).
   The property is propagated using the hierarchy: all clock H in tree(vh1) and K in tree(vh2) are exclusive.
 */
void /*exclusiveClocks::*/exclusiveForEachClockSubTrees( ptinsth vh1 ,ptinsth vh2 );

/**
   The clocks vh1 and vh2 are marked as not exclusive (setExclusiveInfo()).
   The property is propagated using the hierarchy: all clock H in tree(vh1) and K in tree(vh2) are not exclusive.
 */
void /*exclusiveClocks::*/notExclusiveForEachClockSubTrees( ptinsth vh1 ,ptinsth vh2 );

/**
   Assumed: lh is a list of clocks, sister of vh.
   For vh=[c] and [d] an element of lh undersampling of the same clock, all clock H in tree([c]) and K in tree([d]) cannot be exclusive,
   by definition of the hierarchy. It calls notExclusiveForEachClockSubTrees(ptinsth , ptinsth )for each pair.
 */
void /*exclusiveClocks::*/notExclusiveForEachClockSubTrees( ptinsth vh ,ptlinsth lh );

/**
   Assumed: lh is the list of the clocks under vh in the hierarchy.
   For a clock k of lh, k and vh are, by definition of the hierarchy, not exclusive.
 */
void /*exclusiveClocks::*/notExclusiveForSubTree( ptinsth vh ,ptlinsth lh );

/**
   It travels the clock hierarchy to extract some obvious exclusive informations, such that:
    - For [c] and [not c], all clock H in tree([c]) and K in tree([not c]) are exclusive.  It calls exclusiveForEachClockSubTrees().
    - For [c] and [d], all clock H in tree([c]) and K in tree([d]) are not exclusive.  It calls  notExclusiveForEachClockSubTrees().
 */
void /*exclusiveClocks::*/extractHierarchyInfo( ptlinsth lh );

/**
   The elements of the matrix are first initialized by the "undefined" clock.
   Then, the hierarchy is exploited, see extractHierarchyInfo().
 */
void /*exclusiveClocks::*/lowerBoundOpInitialize( void );

/**
   It computes the lower bounds of each pair of selected clocks. Only 1/2 matrix is used.
   It exploits the known information set in extractHierarchyInfo().
 */
void /*exclusiveClocks::*/lowerBoundOp( void );

/**
   It adds (selects)
   - all elements of ls when m=UNDEFINED_MARK
   - the elements marked with m otherwise
   in a table used for matrix calculus, a table of indexes is also used.
 */
void /*exclusiveClocks::*/clockListProcessing( ptlinsth ls ,typeMark m );

/**
   It selects the clocks of the list (lh) for a matrix calculus.
   It builds the \e table attribute member. 
   The matrix will be produced using the size of this table.
 */
void /*exclusiveClocks::*/selectClocks( typeMark m );

/**
   It creates the matrix from the size of the table (see selectClocks()).
 */
void /*exclusiveClocks::*/makeMatrix( void );

/**
   It assigns to each clock its exclusive clocks. It is set as an attribute, this attribute is a predefined one called EXCLUSIVE_CLOCKS.
   It is defined in the file $GraphVM_export/CompilerAttributes.h.
 */
void /*exclusiveClocks::*/setAttribute( void );

/**
  Initializing the calculus:
  - It creates a matrix taking account of the number of selected clocks (makeMatrix()),
 */
void /*exclusiveClocks::*/initCalculus( void );

/**
   Finalizing the calculus:
   - it applies the clock calculus (IGraphClockCalculus()),
   - it updates the matrix (triangularMatrixFinalize()).
 */
void /*exclusiveClocks::*/finalCalculus( void );

/**
   It computes the lower bound for each pair of selected clocks (selectClocks()). It uses the hierarchy to avoid 
   to compute all the cases.
   It is composed of 
   - an initial step (initCalculus()),
   - the specific computation (lowerBoundOp()),
   - a final step (finalCalculus())
 */
void /*exclusiveClocks::*/lowerBoundPairOfClocksCalculus( void );


